const p = require('../config/db');
const faqController = require('../controllers/faqController');
const reviewController = require('../controllers/reviewsController');
const commentController = require('../controllers/commentController');
const now = new Date().toISOString().slice(0, 19).replace('T', ' ');
const specializationController = require('../controllers/specializationController');

const userController = require('../controllers/userController');
const cheerio = require('cheerio');



class IndividualCourse {
static async IndividualCourseFilter(feature,
      active,
      toc,
      coursetype,
      modifieddate,
      addeddate,
      modifieduser,
      wordcount,
      expression) {

      // Initialize the base query
      let baseQuery = `SELECT * FROM individualcourse WHERE 1=1`; // 1=1 is a placeholder to simplify appending conditions
      let values = []; // This will hold the actual values for the query parameters

      if (feature && feature !== '') {
         baseQuery += ` AND feature IS NOT NULL AND feature != '' AND feature = $${values.length + 1}`;
         values.push(feature);
      }

      if (active && active !== '') {
         baseQuery += ` AND active IS NOT NULL AND active != '' AND active = $${values.length + 1}`;
         values.push(active);
      }

      if (toc && toc !== '') {
         baseQuery += ` AND toc IS NOT NULL AND toc != '' AND toc = $${values.length + 1}`;
         values.push(toc);
      }

      if (coursetype && coursetype !== '') {
         baseQuery += ` AND categorie IS NOT NULL AND categorie != '' AND categorie = $${values.length + 1}`;
         values.push(coursetype);
      }

      if (modifieddate && modifieddate !== '') {
         baseQuery += ` AND last_modified IS NOT NULL AND date(last_modified) = $${values.length + 1}`;
         values.push(modifieddate); // Assuming last_modified is provided in a valid date format
      }

      if (addeddate && addeddate !== '') {
         baseQuery += ` AND added_date IS NOT NULL AND date(added_date) = $${values.length + 1}`;
         values.push(addeddate);
      }

      if (modifieduser && modifieduser !== '') {
         baseQuery += ` AND last_modified_user IS NOT NULL AND last_modified_user != '' AND last_modified_user = $${values.length + 1}`;
         values.push(modifieduser);
      }

      // if (wordcount && wordcount !== '') {
      //    baseQuery += ` AND wordcount IS NOT NULL AND wordcount != '' AND wordcount = $${values.length + 1}`;
      //    values.push(wordcount);
      // }

      // Execute the query with the dynamically built SQL and values
      let c = (await p.query(baseQuery, values)).rows;


    

      return c;
   }
   static async addIndividualCourse(
      course,
      courseDescription,
      detailcourseDescription,
      whyCourse,
      whoPursueCourse,
      WhenToDoCourse,
      keyHighCourse,
      eligibility,
      skills,
      other,
      feature,
      active,
      toc,
      admission,
      year,
      month,
      fee,

      title,
      seoDescription,
      logo,
      mode,
      categorie,
      added_by,
      question,
      answers,
      urlname,

      toch1,
      toch2,
      toch3,
      toch4,
      toch5,
      Role
   ) {
      console.log(urlname);
      const escapeAndFormatArray = (arr) => `{${arr.map(el => '"' + el.replace(/"/g, '\\"').replace(/'/g, "''") + '"').join(',')}}`;
console.log(Role);

      try {
        if(Role=='Add')
        {
             const query = `
         INSERT INTO individualcourse (
           courename, coursedescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
           eligibility, skills, other, feature, active, toc, admission, noofyear, noofmonth, fee, title, seodescription, image,
           mode, categorie, added_by, urlname, toch1, toch2, toch3, toch4, toch5,Role
         ) VALUES (
           $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21, $22, $23, $24, $25, $26, $27, $28, $29,$30
         ) RETURNING id`;

         const values = [
            course, courseDescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
            eligibility, skills, other, feature, active, toc, admission, year, month, fee, title, seoDescription, logo,
            mode, categorie, added_by, urlname,
            escapeAndFormatArray(toch1), escapeAndFormatArray(toch2), escapeAndFormatArray(toch3), escapeAndFormatArray(toch4), escapeAndFormatArray(toch5),Role
         ];


         const result = await p.query(query, values);
         const Id = result.rows[0].id;


          let yy=`INSERT INTO public.courseactivity(
             superuserid, content, role,courseid)
             VALUES ($1,$2,$3,$4)`;
           let zz =[added_by,detailcourseDescription,"Add",Id];

           let pp=await p.query(yy,zz);


         await faqController.addIndividalCourseFaq(Id, question, answers, added_by);
        }
        else
        {
            
            
            console.log(urlname);
            console.log("THis is My Urlname");
            
            let a="delete  from prevewindividualcourse where urlname=$1";
            
            let b=[urlname];
            let data=await p.query(a,b);
        
            
             const query = `
         INSERT INTO prevewindividualcourse (
           courename, coursedescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
           eligibility, skills, other, feature, active, toc, admission, noofyear, noofmonth, fee, title, seodescription, image,
           mode, categorie, added_by, urlname, toch1, toch2, toch3, toch4, toch5,Role
         ) VALUES (
           $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21, $22, $23, $24, $25, $26, $27, $28, $29,$30
         ) RETURNING id`;

         const values = [
            course, courseDescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
            eligibility, skills, other, feature, active, toc, admission, year, month, fee, title, seoDescription, logo,
            mode, categorie, added_by, urlname,
            escapeAndFormatArray(toch1), escapeAndFormatArray(toch2), escapeAndFormatArray(toch3), escapeAndFormatArray(toch4), escapeAndFormatArray(toch5),Role
         ];


         const result = await p.query(query, values);
         const Id = result.rows[0].id;


         


        //  await faqController.addIndividalCourseFaq(Id, question, answers, added_by);
        }

         return {
            Status: true
         };
      } catch (error) {
         console.error('Error inserting course:', error);
         return {
            Status: false,
            Error: error.message
         };
      }
   }

   static async getCourseByUrlName1(Url) {
     let a = (await p.query(`select  * from individualcourse where urlname=${Url}`)).rows;


console.log("Bhai Shabd");
      return a;

   }
   static async getCourseByName1(name) {


      let a = await p.query("SELECT   COUNT(*) AS total,  t1.id, t2.courename,  t2.toch1,t2.toch2,t2.toch3,t2.toch4,t2.coursedescription , t2.detailCourseDescription, t2.whyCourse, t2.whoPursueCourse,t2.WhenToDoCourse, t2.keyHighCourse, t2.eligibility,t2.skills,t2.other,t2.admission,   t2.fee,         t2.noofyear, t2.noofmonth,     t2.fee,t2.image,t2.feature AS Type, t2.categorie,t2.added_date,t2.last_modified      FROM university t1 JOIN course t2 ON t1.id::text = any(t2.universityid)  WHERE t2.courename='" + name + "'	  GROUP BY    t1.id, t2.courename,t2.coursedescription,t2.noofyear, t2.noofmonth,t2.fee,t2.image,t2.feature,t2.categorie,t2.added_date,t2.last_modified,t2.detailCourseDescription, t2.whyCourse, t2.whoPursueCourse,     t2.WhenToDoCourse, t2.keyHighCourse, t2.eligibility,     t2.skills,t2.other,t2.admission,t2.toch1,t2.toch2,t2.toch3,t2.toch4 LIMIT 1")

      return a.rows;

   }

   static async FilterIndividualCourse(column, value) {
      if (value == '') {
         let a = await p.query("select * from individualcourse");

         return a.rows;
      }
      else if (column == "added_date" || column == "last_modified") {
         let b = await p.query("SELECT * FROM individualcourse WHERE DATE(" + column + ") = '" + value + "'");

         return b.rows;

      }
      else {
         let a = await p.query("select * from individualcourse where " + column + "='" + value + "'");

         return a.rows;
      }
   }

   static async getTotal() {
      let a = await p.query("select count(*) as total from course");

      return a.rows;
   }




   static async UpdateIndividualCourse(
      id, course, courseDescription, detailcourseDescription,
      whyCourse,
      whoPursueCourse,
      WhenToDoCourse,
      keyHighCourse,
      eligibility,
      skills, other,
      feature,
      active,
      toc,
      admission, year, month, fee, title, seoDescription, image, mode, categorie, add, quesiton, answer, urlname

      ,

      TOCH1,
      TOCH2,
      TOCH3,
      TOCH4,
      TOCH5,
      modified_by,
      Role

   ) {

   if(Role=="Add")
   {
    let x = (await p.query("select * from individualcourse where id='" + id + "'")).rows;
      let y = {};
      let previouscontent = '';
      let newcontent = '';
      let differentcontent = [];
      let prev = [];





      x.forEach((n, index) => {
         if (!(n.detailcoursedescription === detailcourseDescription)) {



            const prev1 = cheerio.load(n.detailcoursedescription);
            previouscontent = prev1.text().trim();


            const new1 = cheerio.load(detailcourseDescription);
            newcontent = new1.text().trim();
            console.log("This is New Content:");

            newcontent.split(" ").forEach(e => {
               if (!previouscontent.split(" ").includes(e)) {
                  differentcontent.push(e);

               }
            })

            previouscontent.split(" ").forEach(e => {
               if (!newcontent.split(" ").includes(e)) {
                  prev.push(e);

               }
            })


         }
      });

      console.log(differentcontent.join(' '));

      // x.forEach((n, index) => {

      //    let k = Object.keys(n);









      //    if (!(n.courename === course)) {
      //       y.courename = course;
      //       y.previouscourename = n.courename;
      //    }
      //    if (!(n.coursedescription === courseDescription)) {
      //       y.coursedescription = courseDescription;
      //       y.previouscoursedescription = n.coursedescription;

      //    }
      //    if (!(n.noofyear === year)) {
      //       y.noofyear = year;
      //       y.previousnoofyear = n.noofyear;
      //    }
      //    if (!(n.noofmonth === month)) {
      //       y.noofmonth = month;
      //       y.previousnoofmonth = n.noofmonth;

      //    }
      //    if (!(n.fee === fee)) {
      //       y.fee = fee;
      //       y.previousfee = n.fee;

      //    }
      //    if (!(n.title === title)) {
      //       y.title = title;
      //       y.previoustitle = n.title;

      //    }
      //    if (!(n.seodescription === seoDescription)) {
      //       y.seodescription = seoDescription;
      //       y.previousseodescription = n.seodescription;

      //    }

      //    if (!(n.image === image)) {
      //       y.image = image;
      //       y.previousimage = n.image;

      //    }

      //    if (!(n.mode === mode)) {
      //       y.mode = mode;
      //       y.previousmode = n.mode;

      //    }

      //    if (!(n.feature === feature)) {
      //       y.feature = feature;
      //       y.previousfeature = n.feature;

      //    }

      //    if (!(n.categorie === categorie)) {
      //       y.categorie = categorie;
      //       y.previouscategorie = n.categorie;

      //    }

      //    if (!(n.detailcoursedescription === detailcourseDescription)) {
      //       y.detailcoursedescription = detailcourseDescription;
      //       y.previousdetailcoursedescription = n.detailcoursedescription;


      //    }

      //    if (!(n.active === active)) {
      //       y.active = active;
      //       y.previousactive = n.active;

      //    }
      //    if (!(n.toc === toc)) {
      //       y.toc = toc;
      //       y.previoustoc = n.toc;

      //    }
      //    if (!(n.urlname === urlname)) {
      //       y.urlname = urlname;
      //       y.previousurlname = n.urlname;


      //    }

      //    // if (!(JSON.stringify(n.toch2) === JSON.stringify(TOCH2))) {
      //    //     y.toch2 = TOCH2;
      //    //     y.previoustoch2 = n.toch2;

      //    // }

      //    // if (!(JSON.stringify(n.toch3) === JSON.stringify(TOCH3))) {
      //    //     y.toch3 = TOCH3;
      //    //     y.previoustoch3 = n.toch3;

      //    // }

      //    // if (!(JSON.stringify(n.toch4) === JSON.stringify(TOCH4))) {
      //    //     y.toch4 = TOCH4;
      //    //     y.previoustoch4 = n.toch4;

      //    // }

      // });

      console.log(modified_by);
      console.log(id);


      let yy = `INSERT INTO public.courseactivity(
         superuserid, differentcontent, role,courseid,
         previouscontent,previouscontentlength,newcontentlength
         )
         VALUES ($1,$2,$3,$4,$5,$6,$7)`;
      let zz = [modified_by, differentcontent.join(' '), "Update", id, prev.join(' '), prev.length, differentcontent.length];

      let pp = await p.query(yy, zz);


      let query = `
    UPDATE individualcourse 
    SET  courename=$1, 
    coursedescription=$2, 
    noofyear=$3, 
    noofmonth=$4, 
    fee=$5, 
    title=$6, 
    seodescription=$7, 
    image=$8, 
    mode=$9, 
    feature=$10, 
    categorie=$11 
 ,
 last_modified=$12, 
 detailcoursedescription=$13, 
 whycourse=$14, 
 whopursuecourse=$15, 
 whentodocourse=$16, 
 keyhighcourse=$17, 
 eligibility=$18, 
 skills=$19, 
 other=$20,
  admission=$21, 
  active=$22, 
  toc=$23, 
  last_modified_user=$24, 
  urlname=$25, 
  toch1=$26, 
  toch2=$27, 
  toch3=$28, 
  toch4=$29,
  toch5=$30
    WHERE id = $31
`;

      let values = [




         course,
         courseDescription,
         year,

         month,
         fee,
         title,
         seoDescription,
         image,
         mode,
         feature,
         categorie,

         now,
         detailcourseDescription,
         whyCourse,
         whoPursueCourse,
         "ASdasdasd",
         keyHighCourse,
         eligibility,
         skills,
         other,
         admission,
         active,
         toc,
         add,
         urlname,
         TOCH1,
         TOCH2,
         TOCH3,
         TOCH4,
         TOCH5,
         id
      ];

      await p.query(query, values);





      // let q = `{${question.join(',')}}`;
      // let ans = `{${answers.join(',')}}`;



      let b = await faqController.UpdateIndividualCourseFaqById(id, quesiton, answer, add);


   }


else
{
    console.log(urlname);
            console.log("THis is My Urlname");
            
            let a="delete  from prevewindividualcourse where urlname=$1";
            
            let b=[urlname];
            let data=await p.query(a,b);
        
            
             const query = `
         INSERT INTO prevewindividualcourse (
           courename, coursedescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
           eligibility, skills, other, feature, active, toc, admission, noofyear, noofmonth, fee, title, seodescription, image,
           mode, categorie, added_by, urlname, toch1, toch2, toch3, toch4, toch5,Role
         ) VALUES (
           $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20, $21, $22, $23, $24, $25, $26, $27, $28, $29,$30
         ) RETURNING id`;

         const values = [
            course, courseDescription, detailcourseDescription, whyCourse, whoPursueCourse, WhenToDoCourse, keyHighCourse,
            eligibility, skills, other, feature, active, toc, admission, year, month, fee, title, seoDescription, logo,
            mode, categorie, added_by, urlname,
            escapeAndFormatArray(toch1), escapeAndFormatArray(toch2), escapeAndFormatArray(toch3), escapeAndFormatArray(toch4), escapeAndFormatArray(toch5),Role
         ];


}


      return {
         Status: true
      }


   }



   static async getIndividualCourse() {
      let a = await p.query("select (select email from superuser where superuser.id::text=individualcourse.added_by),* from individualcourse where Role='Add'");
      

      return a.rows;

   }
   static async getSingleCourseByNam(name) {
      if (name == '') {
         let a = await p.query("select * from course");

         return a.rows;
      }
      else {
         let a = await p.query("select * from course where courename='" + name + "'");

         return a.rows;
      }


   }
   static async getUniversityByCourseName(name) {
      let a = await p.query("select t1.uname,t1.nip ,t1.websiteurl from university t1 join course t2 on t1.id=t2.universityid where courename='" + name + "'");

      return a.rows;



   }
   static async getCourseByUniversityId(Id) {

      return (await p.query("select * from course where universityid='" + Id + "'")).rows;
   }
   static async getCourseByType(name) {
      let a = await p.query("SELECT  COUNT(*) AS total,t1.urlname ,t1.id,t1.courename AS course,t1.noofmonth AS month,t1.noofyear AS year FROM course t1 INNER JOIN course t2 ON t1.courename = t2.courename  WHERE t1.categorie = '" + name + "' GROUP BY  t1.courename,t1.noofmonth,t1.noofyear,t1.id");
    // let a='';
console.log("This is Name");
console.log(name);

      return a.rows;
   }
   static async getSingleIndividualCourseById(id) {
      let a = (await p.query("select * from individualcourse where id='" + id + "'")).rows;

      return a;

   }
   static async getCourseByName(name) {


      let a = await p.query("SELECT   COUNT(*) AS total,  t1.id, t2.courename,  t2.coursedescription , t2.detailCourseDescription, t2.whyCourse, t2.whoPursueCourse,     t2.WhenToDoCourse, t2.keyHighCourse, t2.eligibility,                  t2.skills,      t2.other,t2.admission,   t2.fee,         t2.noofyear, t2.noofmonth,     t2.fee,t2.image,t2.feature AS Type, t2.categorie,t2.added_date,t2.last_modified      FROM university t1 JOIN course t2 ON t1.id = t2.universityid  WHERE t2.urlname='" + name + "'	  GROUP BY    t1.id, t2.courename,t2.coursedescription,t2.noofyear, t2.noofmonth,t2.fee,t2.image,t2.feature,t2.categorie,t2.added_date,t2.last_modified,t2.detailCourseDescription, t2.whyCourse, t2.whoPursueCourse,     t2.WhenToDoCourse, t2.keyHighCourse, t2.eligibility,     t2.skills,t2.other,t2.admission LIMIT 1")

      return a.rows;

   }
   static async getSpecializationByCourseName(name) {
      let a = await p.query("select t1.specialization from specialization t1 join course t2 on t1.courseid=t2.id where t2.courename='" + name + "'");

      return a.rows;

   }


   static async deletCoursebyUniversityid(d1) {

      let a = await p.query("select * from course where universityid='" + d1 + "'");



      if (a.rows.length > 0) {
         a.rows.forEach(async (en) => {
            console.log(en.id);

            let e = await userController.deleteUserBycourseId(en.id);
            await specializationController.deleteSpecializationByCouresId(en.id);
            let b = await reviewController.deleteCourseReviewBycourseId(en.id);
            let c = await commentController.deleteCourseCommentBycourseId(en.id);
            let d = await faqController.deleteCoursefaqBycourseId(en.id);

         }
         )
      }







      let f = await p.query("delete from course where universityid='" + d1 + "'");


      return { Status: true };














   }
   static async deleteIndividualCourse(d1, superuserid) {
      let a = await p.query("select * from individualcourse where id='" + d1 + "'");


      console.log("Memon");


      a.rows.forEach(async (en) => {



         console.log("Individual Course id");
         console.log(en.id)
 await specializationController.deleteSpecializationByCouresId(en.id);

         let d = await faqController.deleteCoursefaqBycourseId(en.id);

         let b = await reviewController.deleteCourseReviewBycourseId(en.id);

        

         let c = await commentController.deleteCourseCommentBycourseId(en.id);
         // let e = await userController.deleteUserBycourseId(en.id);



      }
      );


      //   let yy=`INSERT INTO public.courseactivity(
      //      superuserid, content, role,courseid)
      //      VALUES ($1,$2,$3,$4)`;
      //    let zz =[superuserid,'{}',"Delete",d1];

      //    let pp=await p.query(yy,zz);
      
       let yy=`INSERT INTO public.courseactivity(
           superuserid, content, role,courseid)
           VALUES ($1,$2,$3,$4)`;
         let zz =[superuserid,'{}',"Delete",d1];

         let pp=await p.query(yy,zz);

      let f = await p.query("delete from individualcourse where id='" + d1 + "'");


      return { Status: true };



   }


}
module.exports = IndividualCourse;