const p = require('../config/db');
const faqController = require('../controllers/faqController');
const commentController = require('../controllers/commentController');
const reviewController = require('../controllers/reviewsController');
const now = new Date().toISOString().slice(0, 19).replace('T', ' ');

const cheerio = require('cheerio');
class Blog {
   
   static async BlogFilter(feature,
    active,
    toc,
    tag,
    addeduser,
    modifieddate
  ) {

    // Initialize the base query
    let baseQuery = `SELECT * FROM blog WHERE 1=1`; // 1=1 is a placeholder to simplify appending conditions
    let values = []; // This will hold the actual values for the query parameters

    // Now construct the WHERE clause dynamically
    if (feature && feature !== '') {
      baseQuery += ` AND feature IS NOT NULL AND feature != '' AND feature = $${values.length + 1}`;
      values.push(feature);
    }

    if (active && active !== '') {
      baseQuery += ` AND active IS NOT NULL AND active != '' AND active = $${values.length + 1}`;
      values.push(active);
    }

    if (toc && toc !== '') {
      baseQuery += ` AND toc IS NOT NULL AND toc != '' AND toc = $${values.length + 1}`;
      values.push(toc);
    }

    if (tag && tag !== '') {
      baseQuery += ` AND tag IS NOT NULL AND tag != '' AND tag like $${values.length + 1}`;
      values.push(tag);
    }

    if (modifieddate && modifieddate !== '') {
      baseQuery += ` AND last_modified IS NOT NULL AND date(last_modified) = $${values.length + 1}`;
      values.push(modifieddate); // Assuming last_modified is provided in a valid date format
    }



    if (addeduser && addeduser !== '') {
      baseQuery += ` AND added_by IS NOT NULL AND added_by != '' AND added_by = $${values.length + 1}`;
      values.push(addeduser);
    }

    // if (wordcount && wordcount !== '') {
    //    baseQuery += ` AND wordcount IS NOT NULL AND wordcount != '' AND wordcount = $${values.length + 1}`;
    //    values.push(wordcount);
    // }

    // Execute the query with the dynamically built SQL and values
    let c = (await p.query(baseQuery, values)).rows;




    return c;
  }
    static async addBlog(pageName, seoTitle, seoDescription, tag, status, topic, logo, content, added_by, questions, answers, feature, toc, active, urlname, TOCH1, TOCH2, TOCH3, TOCH4, TOCH5, layout,Role) {



   if(Role=="Add")
   {
           const insertBlogQuery = `
        INSERT INTO blog(pagename, seotitle, seodescription, tag, status, topic, image, content, added_by, feature, toc, active, urlname,TOCH1,TOCH2,TOCH3,TOCH4,TOCH5,layout)
        VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14,$15,$16,$17,$18,$19)
        RETURNING id
    `;
    const blogValues = [pageName, seoTitle, seoDescription, tag, status, topic, logo, content, added_by, feature, toc, active, urlname,
      TOCH1, TOCH2, TOCH3, TOCH4, TOCH5, layout

    ];

    let result = await p.query(insertBlogQuery, blogValues);
    if(result.rows.length>0)
    {
         let Id = result.rows[0].id;

   
 let yy = `INSERT INTO public.blogactivity(
      superuserid, differentcontent, role,blogid)
      VALUES ($1,$2,$3,$4)`;
    let zz = [added_by, content, "Add", Id];
    let pp = await p.query(yy, zz);
    
    
    const insertBlogFaqQuery = `
        INSERT INTO blogfaqs(question, answer, blogid)
        VALUES ($1, $2, $3)
    `;
    const blogquestion = [questions, answers, Id];

    const c = await p.query(insertBlogFaqQuery, blogquestion);

    }
   }
   else
   {
           const insertBlogQuery = `
        INSERT INTO previewblog(pagename, seotitle, seodescription, tag, status, topic, image, content, added_by, feature, toc, active, urlname,TOCH1,TOCH2,TOCH3,TOCH4,TOCH5,layout)
        VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14,$15,$16,$17,$18,$19)
        RETURNING id
    `;
    const blogValues = [pageName, seoTitle, seoDescription, tag, status, topic, logo, content, added_by, feature, toc, active, urlname,
      TOCH1, TOCH2, TOCH3, TOCH4, TOCH5, layout

    ];

    let result = await p.query(insertBlogQuery, blogValues);
  
   }

    return {
      Status: true
    };
  }
   
 static async getBlog23() {

    let a = await p.query("SELECT (SELECT email FROM superuser WHERE superuser.id::text = previewblog.added_by),* FROM previewblog ORDER BY added_Date DESC");
    return a.rows

  }


 static async getBlog() {

    let a = await p.query("select t1.*,t2.username,t2.name ,t2.id as authorid,t2.profile from blog t1  join superuser t2 on t2.id::text=t1.added_by order by t1.added_Date desc");
    return a.rows

  }


  static async FilterBlog(column, value) {
    if (value == '') {
      let a = await p.query("select * from blog");
      return a.rows;
    }
    else if (column == 'last_modified') {
      console.log(value);

      let a = await p.query("SELECT * FROM blog WHERE DATE(" + column + ") = '" + value + "' ");

      // let a=await p.query("SELECT * FROM blog WHERE DATE("+column+") = '2024-04-01' ");
      return a.rows;

    }
    else {
      let a = await p.query("select * from blog where " + column + "='" + value + "' ");

      return a.rows;

    }

  }
  static async getSingleBlogByName(name) {

    if (name == '') {
      let a = await p.query("select * from blog");

      return a.rows
    }
    else {
      let a = await p.query("select * from blog where pagename='" + name + "'");

      return a.rows
    }
  }


  static async deleteBlog(id,superuser) {
    let a = await faqController.deleteBlogFaqByblogId(id);
    let b = await reviewController.deleteBlogReviewByblogId(id);
    let c = await commentController.deleteBlogCommentByblogId(id);
    
      let yy = `INSERT INTO public.blogactivity(
      superuserid, content, role,blogid)
      VALUES ($1,$2,$3,$4)`;
  let zz = [superuser, '{}', "Delete", id];

  let pp = await p.query(yy, zz);

    let d = await p.query("delete from blog where id='" + id + "'");


    return { Status: true };


  }

 static async getParticularBlog(Id) {









    let a ="select t1.pagename, t1.urlname,t1.seotitle,t1.seodescription,t1.toc,t1.toch1,t1.toch2,t1.toch3,t1.toch4,t1.active,t1.feature,t1.added_date ,t1.tag,t1.layout,t1.status,t1.topic,t1.image,t1.content,t2.question,t2.answer from blog t1 left join blogfaqs t2 on t2.blogid=t1.id where t1.id=$1";
    let b=[Id];
    let c=await p.query(a,b);
    
    
    
    
    
    

    return c.rows;
    

  }

  static async getParticularBlog1(Id) {

    let a = (await p.query("select t1.id,t1.pagename, t1.seotitle,t1.seodescription,t1.toc,t1.toch1,t1.toch2,t1.toch3,t1.toch4,t1.active,t1.feature,t1.added_date ,t1.categorie,t1.tag,t1.status,t1.topic,t1.image,t1.content,t2.question,t2.answer from blog t1 join blogfaqs t2 on t2.blogid=t1.id where t1.urlname='" + Id + "'")).rows;

    return a;

  }



  static async UpdateBlog(id,
    pageName,
    seoTitle,
    seoDescription,

    tag,
    status,
    topic,
    content,
    questions,
    answers, add,
    TOC1,
    TOC2,
    TOC3,
    TOC4,
    TOC5,
    layout,
    image,
    Role,
    urlname
  ) {
      
      if(Role=='Add')
      {
    let x = (await p.query("select * from blog where id='" + id + "'")).rows;
    let previouscontent = '';
    let newcontent = '';
    let differentcontent = [];
    let prev = [];


    x.forEach((n, index) => {
   
      if (!(n.content == content)) {

        


        const prev1 = cheerio.load(n.content);
        previouscontent = prev1.text().trim();
      


        const new1 = cheerio.load(content);
        newcontent = new1.text().trim();
      

        newcontent.split(" ").forEach(e => {
          if (!previouscontent.split(" ").includes(e)) {
            differentcontent.push(e);

          }
        })

        previouscontent.split(" ").forEach(e => {
          if (!newcontent.split(" ").includes(e)) {
            prev.push(e);

          }
        })


      }
    });

    
console.log("This is urlname");
console.log(urlname);


    let yy = `INSERT INTO public.blogactivity(
            superuserid, differentcontent, role, blogid,
            previouscontent,previouscontentlength,newcontentlength
        ) VALUES ($1, $2, $3, $4,$5,$6,$7)`;
    let zz = [add, differentcontent.join(' '), "Update", id, prev.join(' '), prev.length, differentcontent.length];
    await p.query(yy, zz);

    let querys = `
        UPDATE public.blog 
        SET pagename = $1,
            seotitle = $2,
            seodescription = $3,
          
            tag = $4,
            status = $5,
            topic = $6,
            content = $7,
            
            last_modified = $8,
            TOCH1=$9,
          TOCH2=$10,
          TOCH3=$11,
          TOCH4=$12,
          TOCH5=$13,
          layout=$14,
          image=$15,
          urlname=$16
        WHERE id = $17
      `;

    let values = [
      pageName,
      seoTitle,
      seoDescription,

      tag,
      status,
      topic,
      content,

      now,

      TOC1,
      TOC2,
      TOC3,
      TOC4,
      TOC5,
      layout,
      image,
      urlname,
      id
    ];
    
    await p.query(querys,values);

   


    let q = questions;
    let ans = answers;


    let b = await p.query("UPDATE public.blogfaqs SET question='" + q + "', answer='" + ans + "', added_by='" + add + "', last_modified='" + now + "' WHERE blogid='"+id+"'");

      }
//      else
//      {
       


     
//     let query = `
//     insert into blog(pagename,
//       seotitle ,
//       seodescription ,
    
//       tag ,
//       status,
//       topic ,
//       content ,
//       added_by ,
//       last_modified,
//       TOCH1,
//     TOCH2,
//     TOCH3,
//     TOCH4,
//     TOCH5,
//     layout,
//     image)
//     values(  $1,
//       $2,
//       $3,
    
//       $4,
//       $5,
//       $6,
//       $7,
//       $8,
//       $9,
//       $10,
//     $11,
//     $12,
//     $13,
//     $14,
//     $15,
//     $16
 
// )`;

//     let values = [
//       pageName,
//       seoTitle,
//       seoDescription,

//       tag,
//       status,
//       topic,
//       content,
//       add,
//       now,
     
//       TOC1,
//       TOC2,
//       TOC3,
//       TOC4,
//       TOC5,
//       layout,
//       image
//     ];

//     await p.query(query, values);


//      }



    return { Status: true };


  }


  static async getTotal() {
    let a = await p.query("select count(*) as total from blog");

    return a.rows;
  }
  static async getBlogByNameUsingLike(name) {
    if (name !== '') {
      const query = `
      SELECT 
          t1.id, 
          t1.pagename AS name,
          t1.image AS image,
          t1.added_date,
          t2.username AS added_by
      FROM 
          blog t1 
      JOIN  
          superuser t2 
      ON 
          t1.added_by = t2.id::text 
      WHERE 
          t1.pagename LIKE $1
  `;

      const values = [`%${name}%`];
      let a = await p.query(query, values);
      return a.rows;
    }
    else {
      return [];
    }
  }

}
module.exports = Blog;