const p = require('../config/db');
const faqController = require('../controllers/faqController');
const reviewController = require('../controllers/reviewsController');
const commentController = require('../controllers/commentController');
const now = new Date().toISOString().slice(0, 19).replace('T', ' ');
const specializationController = require('../controllers/specializationController');

const userController = require('../controllers/userController');

const cheerio = require('cheerio');

class Course {
    static async CourseFilter(feature,
      active,
      toc,
      coursetype,
      modifieddate,
      addeddate,
      modifieduser,
      wordcount,
      expression) {

      // Initialize the base query
      let baseQuery = `SELECT * FROM course WHERE 1=1`; // 1=1 is a placeholder to simplify appending conditions
      let values = []; // This will hold the actual values for the query parameters

      // Now construct the WHERE clause dynamically
      if (feature && feature !== '') {
         baseQuery += ` AND feature IS NOT NULL AND feature != '' AND feature = $${values.length + 1}`;
         values.push(feature);
      }

      if (active && active !== '') {
         baseQuery += ` AND active IS NOT NULL AND active != '' AND active = $${values.length + 1}`;
         values.push(active);
      }

      if (toc && toc !== '') {
         baseQuery += ` AND toc IS NOT NULL AND toc != '' AND toc = $${values.length + 1}`;
         values.push(toc);
      }

      if (coursetype && coursetype !== '') {
         baseQuery += ` AND categorie IS NOT NULL AND categorie != '' AND categorie = $${values.length + 1}`;
         values.push(coursetype);
      }

      if (modifieddate && modifieddate !== '') {
         baseQuery += ` AND last_modified IS NOT NULL AND date(last_modified) = $${values.length + 1}`;
         values.push(modifieddate); // Assuming last_modified is provided in a valid date format
      }

      if (addeddate && addeddate !== '') {
         baseQuery += ` AND added_date IS NOT NULL AND date(added_date) = $${values.length + 1}`;
         values.push(addeddate);
      }

      if (modifieduser && modifieduser !== '') {
         baseQuery += ` AND last_modified_user IS NOT NULL AND last_modified_user != '' AND last_modified_user = $${values.length + 1}`;
         values.push(modifieduser);
      }

      // if (wordcount && wordcount !== '') {
      //    baseQuery += ` AND wordcount IS NOT NULL AND wordcount != '' AND wordcount = $${values.length + 1}`;
      //    values.push(wordcount);
      // }

      // Execute the query with the dynamically built SQL and values
      let c = (await p.query(baseQuery, values)).rows;


    

      return c;
   }
static async getCourseByName2(name)
   {
      await p.query('begin');
      let a=` SELECT * 
            FROM course 
            WHERE courename ILIKE '%' || $1 || '%' 
            AND courename IS NOT NULL 
            AND courename <> ''1`;
      let b=[name];
      let c=await p.query(a,b);
      await p.query('commit');

      return c.rows;
      
   }
   static async addCourse(
      course,
      courseDescription,
      detailcourseDescription,
      whyCourse,
      whoPursueCourse,
      WhenToDoCourse,
      keyHighCourse,
      eligibility,
      skills,
      other,
      feature,
      active,
      toc,
      admission,
      year,
      month,
      fee,
      university,
      title,
      seoDescription,
      logo,
      mode,
      categorie,
      added_by,
      question,
      answers,
      urlname,
      toch1,
      toch2,
      toch3,
      toch4,
      toch5
   ) {
      console.log(urlname);

      try {
         const query = `
              INSERT INTO course (
                  courename,
                  coursedescription,
                  detailcourseDescription,
                  whyCourse,
                  whoPursueCourse,
                  WhenToDoCourse,
                  keyHighCourse,
                  eligibility,
                  skills,
                  other,
                  feature,
                  active,
                  toc,
                  admission,
                  noofyear,
                  noofmonth,
                  fee,
                  universityId,
                  title,
                  seodescription,
                  image,
                  mode,
                  categorie,
                  added_by,
                  urlname,
                  toch1,
                  toch2,
                  toch3,
                  toch4,
                  toch5
              ) VALUES (
                  $1, $2, $3, $4, $5, $6, $7, $8, $9, $10,
                  $11, $12, $13, $14, $15, $16, $17, $18, $19,
                  $20, $21, $22, $23, $24, $25,$26,$27,$28,$29,$30
              ) RETURNING id`;

         const values = [
            course,
            courseDescription,
            detailcourseDescription,
            whyCourse,
            whoPursueCourse,
            WhenToDoCourse,
            keyHighCourse,
            eligibility,
            skills,
            other,
            feature,
            active,
            toc,
            admission,
            year,
            month,
            fee,
            university,
            title,
            seoDescription,
            logo,
            mode,
            categorie,
            added_by,
            urlname,
            toch1,
            toch2,
            toch3,
            toch4,
            toch5
         ];

         const result = await p.query(query, values);
         const Id = result.rows[0].id;

 let yy = `INSERT INTO public.universitycourseactivity(
            superuserid, content, role,unicourseid)
            VALUES ($1,$2,$3,$4)`;
         let zz = [added_by, detailcourseDescription, "Add", Id];

         let pp = await p.query(yy, zz);




         await faqController.addCourseFaq(Id, question, answers, added_by);

         return {
            Status: true
         };
      } catch (error) {
         console.error('Error inserting course:', error);
         return {
            Status: false,
            Error: error.message
         };
      }
   }

 static async getCourseByName2(name)
   {
      let a=`select * from course where courename=$1`;
      let b=[name];
      let c=await p.query(a,b);

      return c.rows;
      
   }
   static async FilterCourse(column, value) {
      if (value == '') {
         let a = await p.query("select * from course");

         return a.rows;
      }
      else if (column == "added_date" || column == "last_modified") {
         let b = await p.query("SELECT * FROM course WHERE DATE(" + column + ") = '" + value + "'");

         return b.rows;

      }
      else {
         let a = await p.query("select * from course where " + column + "='" + value + "'");

         return a.rows;
      }
   }
   static async CourseForAbout(column, value, comp) {

      let a = await p.query(`select t1.courename,
      (select name from courseduration where id=t1.noofmonth::integer) as duration,t1.detailcoursedescription as about  ,t1.feature,t1.active,t1.toc,t1.categorie,t1.id,t1.urlname,t1.added_date, 
       (select username from superuser where id=last_modified_user::integer ) as modified_by,
       t2.username as added_by	
       from course t1 join superuser t2 on t2.id=t1.added_by::integer
       `);
      let arr = [];

      a.rows.forEach((n) => {


         const plainText = n.about.replace(/<[^>]*>/g, '');


         const words = plainText.split(/\s+/);


         const filteredWords = words.filter(word => word.trim() !== '');



         if (comp.trim() === "Less") {



            console.log(column);
            console.log(value);
            console.log(comp);

            if (filteredWords.length < parseInt(value)) {
               console.log("Wor");

               let obj = {
                  "courename": n.courename,
                  "duration": n.duration,
                  "feature": n.feature,
                  "active": n.active,
                  "toc": n.toc,
                  "categorie": n.categorie,

                  "last_modified": n.modified_by,
                  "added_date": n.added_date,
                  "added_by": n.added_by,
                  "urlname": n.urlname,
                  "id": n.id,

               }
               arr.push(obj);

            }
         }
         else if (comp.trim() == "Greater") {
            if (filteredWords.length > parseInt(value)) {
               let obj = {
                  "courname": n.courename,
                  "duration": n.duration,
                  "feature": n.feature,
                  "approvedby": n.active,
                  "toc": n.toc,
                  "categorie": n.categorie,

                  "last_modified": n.modified_by,
                  "added_date": n.added_date,
                  "added_by": n.added_by,
                  "urlname": n.urlname,
                  "id": n.id,

               }
               arr.push(obj);
            }
         }

         else if (comp == '' || value == '') {

            let obj = {
               "courname": n.courename,
               "duration": n.duration,
               "feature": n.feature,
               "approvedby": n.active,
               "toc": n.toc,
               "categorie": n.categorie,

               "last_modified": n.modified_by,
               "added_date": n.added_date,
               "added_by": n.added_by,
               "urlname": n.urlname,
               "id": n.id,

            }
            arr.push(obj);

         }




      })




      return arr;
   }

   static async getTotal() {
      let a = await p.query("select count(*) as total from course");

      return a.rows;
   }

  static async UpdateCourse(
      id, course, courseDescription, detailcourseDescription,
      whyCourse,
      whoPursueCourse,
      WhenToDoCourse,
      keyHighCourse,
      eligibility,
      skills, other,
      feature,
      active,
      toc,
      admission, year, month, fee, university, title, seoDescription, image, mode, categorie, add, quesiton, answer, urlname

      ,

      TOCH1,
      TOCH2,
      TOCH3,
      TOCH4,
      TOCH5,
      modified_by

   ) {

      let x = (await p.query("select * from course where id='" + id + "'")).rows;
      let y = {};

      let previouscontent = '';
      let newcontent = '';
      let differentcontent = [];
      let prev = [];




      x.forEach((n, index) => {
         if (!(n.detailcoursedescription === detailcourseDescription)) {



            const prev1 = cheerio.load(n.detailcoursedescription);
            previouscontent = prev1.text().trim();


            const new1 = cheerio.load(detailcourseDescription);
            newcontent = new1.text().trim();
            console.log("This is New Content:");

            newcontent.split(" ").forEach(e => {
               if (!previouscontent.split(" ").includes(e)) {
                  differentcontent.push(e);

               }
            })

            previouscontent.split(" ").forEach(e => {
               if (!newcontent.split(" ").includes(e)) {
                  prev.push(e);

               }
            })


         }
      });
      // x.forEach((n, index) => {

      //    let k = Object.keys(n);









      //    if (!(n.courename === course)) {
      //       y.courename = course;
      //       y.previouscourename = n.courename;
      //    }
      //    if (!(n.coursedescription === courseDescription)) {
      //       y.coursedescription = courseDescription;
      //       y.previouscoursedescription = n.coursedescription;

      //    }
      //    if (!(n.noofyear === year)) {
      //       y.noofyear = year;
      //       y.previousnoofyear = n.noofyear;
      //    }
      //    if (!(n.noofmonth === month)) {
      //       y.noofmonth = month;
      //       y.previousnoofmonth = n.noofmonth;

      //    }
      //    if (!(n.fee === fee)) {
      //       y.fee = fee;
      //       y.previousfee = n.fee;

      //    }
      //    if (!(n.title === title)) {
      //       y.title = title;
      //       y.previoustitle = n.title;

      //    }
      //    if (!(n.seodescription === seoDescription)) {
      //       y.seodescription = seoDescription;
      //       y.previousseodescription = n.seodescription;

      //    }

      //    if (!(n.image === image)) {
      //       y.image = image;
      //       y.previousimage = n.image;

      //    }

      //    if (!(n.mode === mode)) {
      //       y.mode = mode;
      //       y.previousmode = n.mode;

      //    }

      //    if (!(n.feature === feature)) {
      //       y.feature = feature;
      //       y.previousfeature = n.feature;

      //    }

      //    if (!(n.categorie === categorie)) {
      //       y.categorie = categorie;
      //       y.previouscategorie = n.categorie;

      //    }
      //    if (!(n.universityid == university)) {
      //       y.universityid = university;
      //       y.previousuniversityid = n.universityid;

      //    }
      //    if (!(n.detailcoursedescription === detailcourseDescription)) {
      //       y.detailcoursedescription = detailcourseDescription;
      //       y.previousdetailcoursedescription = n.detailcoursedescription;


      //    }

      //    if (!(n.active === active)) {
      //       y.active = active;
      //       y.previousactive = n.active;

      //    }
      //    if (!(n.toc === toc)) {
      //       y.toc = toc;
      //       y.previoustoc = n.toc;

      //    }
      //    if (!(n.urlname === urlname)) {
      //       y.urlname = urlname;
      //       y.previousurlname = n.urlname;


      //    }


      // });
      // console.log(y);

      let yy = `INSERT INTO public.universitycourseactivity(
         superuserid, differentcontent, role,unicourseid,
         previouscontent,previouscontentlength,newcontentlength
         )
         VALUES ($1,$2,$3,$4,$5,$6,$7)`;
      let zz = [modified_by, differentcontent.join(' '), "Update", id, prev.join(' '), prev.length, differentcontent.length];

      let pp = await p.query(yy, zz);

      let query = `
      UPDATE course 
      SET  courename=$1, 
      coursedescription=$2, 
      noofyear=$3, 
      noofmonth=$4, 
      fee=$5, 
      title=$6, 
      seodescription=$7, 
      image=$8, 
      mode=$9, 
      feature=$10, 
      categorie=$11 
   , universityid=$12, 
   last_modified=$13, 
   detailcoursedescription=$14, 
   whycourse=$15, 
   whopursuecourse=$16, 
   whentodocourse=$17, 
   keyhighcourse=$18, 
   eligibility=$19, 
   skills=$20, 
   other=$21,
    admission=$22, 
    active=$23, 
    toc=$24, 
    last_modified_user=$25, 
    urlname=$26, 
    toch1=$27, 
    toch2=$28, 
    toch3=$29, 
    toch4=$30
    ,toch5=$31
      WHERE id = $32
  `;

      let values = [




         course,
         courseDescription,
         year,

         month,
         fee,
         title,
         seoDescription,
         image,
         mode,
         feature,
         categorie,
         university,
         now,
         detailcourseDescription,
         whyCourse,
         whoPursueCourse,
         "ASdasdasd",
         keyHighCourse,
         eligibility,
         skills,
         other,
         admission,
         active,
         toc,
         modified_by,
         urlname,

         TOCH1,
         TOCH2,
         TOCH3,
         TOCH4,
         TOCH5,
         id
      ];

      await p.query(query, values);





      // let q = `{${question.join(',')}}`;
      // let ans = `{${answers.join(',')}}`;



      let b = await faqController.UpdateCourseFaqById(id, quesiton, answer, modified_by);





      return {
         Status: true
      }


   }


   static async getCourse() {
      let a = await p.query(`
      select t1.courename,
     (select name from courseduration where id=t1.noofmonth::integer) as duration  ,t1.feature,t1.active,t1.toc,t1.categorie,t1.id,t1.urlname,t1.added_date, 
      (select username from superuser where id=last_modified_user::integer ) as modified_by,
      t2.username as added_by	
      from course t1 join superuser t2 on t2.id=t1.added_by::integer;
      `);

      return a.rows;

   }
   static async getSingleCourseByNam(name) {
      if (name == '') {
         let a = await p.query("select * from course");

         return a.rows;
      }
      else {
         let a = await p.query("select * from course where courename='" + name + "'");

         return a.rows;
      }


   }
   static async getUniversityByCourseName(name) {
      let a = await p.query("select t2.courename as courename,t1.uname,t1.nip ,t1.websiteurl from university t1 join course t2 on t1.id::text=any(t2.universityid) where courename='" + name + "'");

      return a.rows;



   }
   
   static async getCourseByUniversityId1(Id) {

//  
      return (await p.query("select * from course where '" + Id + "'=any (universityid)")).rows;
      
   }
   static async getCourseByUniversityId() {

//  where '" + Id + "'=any (universityid)
      return (await p.query("select * from course")).rows;
   }
   static async getCourseByType() {
      let a = await p.query("SELECT  t1.urlname,t1.categorie ,t1.id,t1.courename AS course,t1.noofmonth AS month FROM individualcourse t1 INNER JOIN individualcourse t2 ON t1.courename = t2.courename where t1.Role='Add'");
      
      

      return a.rows;
   }
   static async getSingleCourseById(id) {
      let a = (await p.query("select * from course where id='" + id + "'")).rows;

      const combinedArray = [];

      for (const item of a) {
         const uniIds = item.universityid;

         for (let i = 0; i < uniIds.length; i++) {


            let b = await p.query("select id, uname from university where id='" + uniIds[i] + "'");
            b.rows.forEach((z) => {
               console.log(z.id);
               console.log(z.uname);

               combinedArray.push({ label: z.uname, value: z.id });
            });
         }
      }

      return {
         Course: a,
         AppearUniversity: combinedArray
      };
   }

   static async getCourseByName() {


// let a=`SELECT   COUNT(*) AS total,courename as course,mode,urlname,toch1,toch2,id,toch3,toch4,toch5,coursedescription , detailCourseDescription,noofyear as year,noofmonth as month,fee,image,feature AS Type, categorie,added_date,last_modified   FROM  individualcourse   where Role='Add'	  GROUP BY   mode, course,coursedescription,year,month,fee,image,feature,categorie,added_date,last_modified,detailCourseDescription,urlname,id,toch1,toch2,toch3,toch4,toch5`;


let a=`select courename AS course, mode, urlname, toch1, toch2, id, toch3, toch4, toch5, coursedescription, detailCourseDescription, noofyear AS year, noofmonth AS month, fee, image, feature AS Type, categorie, added_date, last_modified
FROM individualcourse
WHERE Role = $1`;
let b=["Add"]

      let c = await p.query(a,b);
      

      console.log("final");
      
     
      
      

      return c.rows;

   }



   static async getCourseByName1() {


console.log("I am Copy of Ypour")
let a=`SELECT   COUNT(*) AS total,courename,mode,urlname,toch1,toch2,id,toch3,toch4,toch5,coursedescription , detailCourseDescription,noofyear,noofmonth,fee,image,feature AS Type, categorie,added_date,last_modified   FROM  prevewindividualcourse   where Role='Watch' 	  GROUP BY   mode,courename,coursedescription,noofyear,noofmonth,fee,image,feature,categorie,added_date,last_modified,detailCourseDescription,urlname,id,toch1,toch2,toch3,toch4,toch5`;

      let c = await p.query(a);


      return c.rows;
      


   }
   static async getSpecializationByCourseName() {
      let a = await p.query("select t2.courename,t2.urlname,t1.specialization from specialization t1 join individualcourse t2 on t1.courseid=t2.id");

      return a.rows;

   }
   
   static async getCourseByUrlName(Url) {
    try {
        // Use parameterized queries to prevent SQL injection
        let a = (await p.query('SELECT * FROM individualcourse WHERE urlname=$1', [Url])).rows;
        console.log(Url);
        console.log("Ahmed");
        console.log(a);
        
        return a;
    } catch (error) {
        console.error("Error executing query", error);
        throw error; // Propagate the error so it can be handled by the caller
    }
}



//   static async deletCoursebyUniversityid(d1) {

//       let a = await p.query("select * from course where universityid='" + d1 + "'");



//       if (a.rows.length > 0) {
//          a.rows.forEach(async (en) => {
//             console.log(en.id);

//             let e = await userController.deleteUserBycourseId(en.id);
//             await specializationController.deleteSpecializationByCouresId(en.id);
//             let b = await reviewController.deleteCourseReviewBycourseId(en.id);
//             let c = await commentController.deleteCourseCommentBycourseId(en.id);
//             let d = await faqController.deleteCoursefaqBycourseId(en.id);

//          }
//          )
//       }







//       let f = await p.query("delete from course where universityid='" + d1 + "'");


//       return { Status: true };














//   }


 static async deletCoursebyUniversityid(d1) {

      await p.query('begin');
      let a = await p.query("select * from course where '" + d1 + "'=any (universityid)");
      if (a.rows.length > 0) {
         a.rows.forEach(async (en) => {


            if (en.universityid.length >= 1) {
               console.log("Length is 1");

              
               let b = await reviewController.deleteCourseReviewBycourseId(en.id);
               let c = await commentController.deleteCourseCommentBycourseId(en.id);
               let d = await faqController.deleteCoursefaqBycourseId(en.id);

               let f = await p.query("delete from course where '" + d1 + "'=any (universityid)");
            }
            else {
               let a = await p.query(`UPDATE course
                  SET universityid = array_remove(universityid, 1)
                  WHERE array_length(universityid, 1) > 1
                    AND ${d1} = ANY(universityid)`);

            }

         }
         )
      }
      else {

      }
      await p.query('commit');
      return { Status: true };

   }

   static async deleteCourse(d1, superuserid) {
      let a = await p.query("select * from course where id='" + d1 + "'");



      a.rows.forEach(async (en) => {




         let d = await faqController.deleteCoursefaqBycourseId(en.id);

         let b = await reviewController.deleteCourseReviewBycourseId(en.id);

         await specializationController.deleteSpecializationByCouresId(en.id);


         let c = await commentController.deleteCourseCommentBycourseId(en.id);
         let e = await userController.deleteUserBycourseId(en.id);

         



      }
      );

let ff=await p.query("delete from acdemicspecialization where courseid='"+d1+"'");

    let yy = `INSERT INTO public.universitycourseactivity(
         superuserid, content, role,unicourseid)
         VALUES ($1,$2,$3,$4)`;
      let zz = [superuserid, '{}', "Delete", d1];

      let pp = await p.query(yy, zz);

      let f = await p.query("delete from course where id='" + d1 + "'");


      return { Status: true };



   }
   static async getCourseByNameUsingLike(name) {

      if (name.trim() !== '') {
         const query = `
            SELECT 
                t1.id, 
                t1.courename AS name,
                t1.image AS image,
                t1.added_date,
                t2.username AS added_by
            FROM 
                course t1 
            JOIN  
                superuser t2 
            ON 
                t1.added_by = t2.id::text 
            WHERE 
                t1.courename LIKE $1
        `;

         const values = [`%${name}%`];
         let a = await p.query(query, values);
         return a.rows;
      }
      else {
         return [];

      }
   }


}
module.exports = Course;