const p = require('../config/db');
const faqController = require('../controllers/faqController');
const commentController = require('../controllers/commentController');
const authorController = require('../controllers/authorController');
const reviewController = require('../controllers/reviewsController');
const courseController = require('../controllers/courseController');
const now = new Date().toISOString().slice(0, 19).replace('T', ' ');

const cheerio = require('cheerio');
class University {
    
    
    
      static async getUniversityByState(name, state) {
        await p.query('begin');
        let a = `select imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university where state=$2`;
        let b = [name, state];
        let c = await p.query(a, b);
        await p.query('commit');
        return c.rows;

    }
    static async getUniversityByType(name, unitype) {
        await p.query('begin');
        let a = `select imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university where universitytype=$2`;
        let b = [name, unitype];
        let c = await p.query(a, b);
        await p.query('commit');
        return c.rows;
    }
    
     static async getUniversityByZone(name, unitype) {
        await p.query('begin');
        let a = `select imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university where zone=$2`;
        let b = [name, unitype];
        let c = await p.query(a, b);
        await p.query('commit');
        return c.rows;
    }
    
    static async getUniversityByName1(name, unitype) {
        
        await p.query('begin');
        let a = `select imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university where uname=$2`;
        let b = [name, unitype];
        let c = await p.query(a, b);
        await p.query('commit');
        return c.rows;
    }
    
     static async getUniversityByName(name)
    {
        
      await  p.query('begin');
        
        console.log(name);
        
         let a = `
        SELECT * 
        FROM university 
        WHERE uname ILIKE '%' || $1 || '%' 
        AND uname IS NOT NULL 
        AND uname <> '';
    `;
        let b=[name];
        let c=await p.query(a,b);
      await  p.query('commit');
        
        return c.rows;
        
    }
  
    static async addUniversity(name, Established, about, fact, emi, admission, nip, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city, logoUrl, imageUrl, videoUrl, fbLink, twitterLink, linkedin, instagram, smode, added, question, answer, feature, toc, active, urlname, seotitle,
        seodescription,
        toccontent,
        toch1,
        toch2,

        toch3,
        toch4,
        toch5,
        prospectus,
        Role
    ) {
        try {
         if(Role=='Add')
         {
                const query = `
                INSERT INTO university (
                    uname,
                     Established, 
                     about, 
                     fact, 
                     emi, 
                     admission, 
                     nip, 
                     officeMailId, 
                     approvedBy,
                      courseType,
                    stream,
                     studyMode, 
                     UniversityType, 
                     WebsiteUrl, 
                     state,
                      city,
                       logoUrl, 
                       imageUrl, 
                       videoUrl,
                    fbLink, 
                    twitterLink, 
                    linkedin, 
                    instagram, 
                    smode, 
                    added_by, 
                    feature, 
                    active, 
                    toc,
                     urlname,
                    seotitle ,
                       seodescription ,
                       
                     toccontent,
                        toch1,
                       toch2,
                           toch3 ,
                       toch4,
                         toch5,
                         prospectus
                ) VALUES (
                    $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20,
                    $21, $22, $23, $24, $25, $26, $27, $28,$29,$30, $31, $32, $33, $34, $35, $36,$37,$38
                ) RETURNING id`;

            const values = [
                name,
                Established,
                about,
                fact,
                emi,
                admission,
                nip,
                officeMailId,
                approvedBy,
                courseType,
                stream,
                studyMode,
                UniversityType,
                WebsiteUrl,
                state,
                city,
                logoUrl,
                imageUrl,
                videoUrl,
                fbLink,
                twitterLink,
                linkedin,
                instagram,
                smode,
                added,
                feature,
                active,
                toc,
                urlname,

                seotitle,
                seodescription,
                `{1,2}`,
                toch1,
                toch2,
                toch3,
                toch4,
                toch5,
                prospectus
            ];

            const result = await p.query(query, values);
            const id = result.rows[0].id;

            let yy = `INSERT INTO public.universityactivity(
                superuserid, differentcontent, role,universityId)
                VALUES ($1,$2,$3,$4)`;
            if(added!=0)
            {
            let zz = [added, about, "Add", id];
            let pp = await p.query(yy, zz);
                
            }



            await faqController.addUniversityFaq(id, question, answer, added);
         }
         else
         {
                const query = `
                INSERT INTO previewuniversity (
                    uname,
                     Established, 
                     about, 
                     fact, 
                     emi, 
                     admission, 
                     nip, 
                     officeMailId, 
                     approvedBy,
                      courseType,
                    stream,
                     studyMode, 
                     UniversityType, 
                     WebsiteUrl, 
                     state,
                      city,
                       logoUrl, 
                       imageUrl, 
                       videoUrl,
                    fbLink, 
                    twitterLink, 
                    linkedin, 
                    instagram, 
                    smode, 
                    added_by, 
                    feature, 
                    active, 
                    toc,
                     urlname,
                    seotitle ,
                       seodescription ,
                       
                     toccontent,
                        toch1,
                       toch2,
                           toch3 ,
                       toch4,
                         toch5,
                         prospectus
                ) VALUES (
                    $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17, $18, $19, $20,
                    $21, $22, $23, $24, $25, $26, $27, $28,$29,$30, $31, $32, $33, $34, $35, $36,$37,$38
                ) RETURNING id`;

            const values = [
                name,
                Established,
                about,
                fact,
                emi,
                admission,
                nip,
                officeMailId,
                approvedBy,
                courseType,
                stream,
                studyMode,
                UniversityType,
                WebsiteUrl,
                state,
                city,
                logoUrl,
                imageUrl,
                videoUrl,
                fbLink,
                twitterLink,
                linkedin,
                instagram,
                smode,
                added,
                feature,
                active,
                toc,
                urlname,

                seotitle,
                seodescription,
                `{1,2}`,
                toch1,
                toch2,
                toch3,
                toch4,
                toch5,
                prospectus
            ];

            const result = await p.query(query, values);
            const id = result.rows[0].id;

         }

            return {
                Status: true
            };
        } catch (error) {
            console.error('Error inserting university:', error);
            return {
                Status: false,
                Error: error.message
            };
        }
    }




    static async getTotal() {
        let a = await p.query("select count(*) as total from university");

        return a.rows;
    }

 static async UpdateUniversity(
        Id, Name, Established, about, fact, emi, admission, nip, officeMailId, approvedBy, courseType, stream, studyMode,
        UniversityType, WebsiteUrl, state, city, logo, image, video, fbLink, twitterLink, linkedin, instagram, smode, add,
        quesiton, answer, feature, toc, active, urlname, seotitle, seodescription, TOCcontent, TOCH1, TOCH2, TOCH3, TOCH4,
        TOCH5, modified_by,
        Role
    ) {
        if(Role=="Add")
        {
        let x = (await p.query("select * from university where id=$1", [Id])).rows;
        let y = {};
        let previouscontent = '';
        let newcontent = '';
        let differentcontent = [];
        let prev = [];

        x.forEach((n, index) => {
            if (!(n.about === about)) {


                const prev1 = cheerio.load(n.about);
                previouscontent = prev1.text().trim();
                // console.log("This is Previous Content:");
                // console.log(previouscontent);


                const new1 = cheerio.load(about);
                newcontent = new1.text().trim();
                // console.log("This is New Content:");
                // console.log(newcontent);

                previouscontent.split(" ").forEach(e => {
                    if (!newcontent.split(" ").includes(e)) {
                        prev.push(e);

                    }
                })

                newcontent.split(" ").forEach(e => {
                    if (!previouscontent.split(" ").includes(e)) {
                        differentcontent.push(e);

                    }
                })


            }
        });

        console.log(differentcontent.join(' '));

        console.log(prev.join(' '));
        console.log(differentcontent.length);
        console.log(prev.length);



        let yy = `INSERT INTO public.universityactivity(
            superuserid, differentcontent, role, universityId,
            previouscontent,previouscontentlength,newcontentlength
        ) VALUES ($1, $2, $3, $4,$5,$6,$7)`;
        let zz = [modified_by, differentcontent.join(' '), "Update", Id, prev.join(' '), prev.length, differentcontent.length];
        await p.query(yy, zz);

        console.log("THis is Id");
        console.log(modified_by);
        let escapeHtmlString = (str) => {
            if (typeof str === 'string') {
                return str.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/'/g, "\\'");
            }
            return str;
        };

        let formatArrayLiteral = (arr) => {
            return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
        };

        let query = `
        UPDATE university 
        SET uname=$1, established=$2, officemailid=$3, approvedby=$4, coursetype=$5, stream=$6, studymode=$7, universitytype=$8, 
            websiteurl=$9, state=$10, city=$11, logourl=$12, imageurl=$13, videourl=$14, fblink=$15, twitterlink=$16, linkedin=$17, 
            instagram=$18, toc=$19, smode=$20, feature=$21, last_modified=$22, nip=$23, about=$24, fact=$25, emi=$26, 
            admission=$27, active=$28, urlname=$29, seotitle=$30, seodescription=$31, toch1=$32, toch2=$33, toch3=$34, toch4=$35, 
            toch5=$36, last_modified_by=$37 WHERE id=$38`;

        let values = [
            Name, Established, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city,
            logo, formatArrayLiteral(image), '{}', fbLink, twitterLink, linkedin, instagram, toc, smode, feature, new Date(),
            nip, about, fact, emi, admission, active, urlname, seotitle, seodescription, formatArrayLiteral(TOCH1),
            formatArrayLiteral(TOCH2), formatArrayLiteral(TOCH3), formatArrayLiteral(TOCH4), formatArrayLiteral(TOCH5),
            modified_by, Id
        ];

        await p.query(query, values);
        await faqController.UpdateUniversityFaqByUniversityId(Id, `{${quesiton.join(',')}}`, `{${answer.join(',')}}`, add);

        }
        else
        {
            
             let escapeHtmlString = (str) => {
            if (typeof str === 'string') {
                return str.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/'/g, "\\'");
            }
            return str;
        };
            
              let formatArrayLiteral = (arr) => {
            return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
        };
        
        let zz=await p.query("delete from previewuniversity where urlname='"+urlname+"'");
        

               let query1 = `
        insert into previewuniversity( uname, established, officemailid, approvedby, coursetype, stream, studymode, universitytype, 
            websiteurl, state, city, logourl, imageurl, videourl, fblink, twitterlink, linkedin, 
            instagram, toc, smode, feature, added_by, last_modified, nip, about, fact, emi, 
            admission, active, urlname, seotitle, seodescription, toch1, toch2, toch3, toch4,toch5 ) values($1,$2,$3,$4,$5,$6,$7,$8, $9,$10, $11,$12,$13,$14, $15,$16,$17,$18,$19,$20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$30,$31,$32,$33,$34,$35,$36,$37)  
       `;

        let values = [
            Name, Established, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city,
            logo, formatArrayLiteral(image), '{}', fbLink, twitterLink, linkedin, instagram, toc, smode, feature, add, new Date(),
            nip, about, fact, emi, admission, active, urlname, seotitle, seodescription, formatArrayLiteral(TOCH1),
            formatArrayLiteral(TOCH2), formatArrayLiteral(TOCH3), formatArrayLiteral(TOCH4), formatArrayLiteral(TOCH5)
            
        ];

        await p.query(query1, values);

            const id = result.rows[0].id;
        }
        
        

        return { Status: true };
    }
    //  static async UpdateUniversity(

    //     Id, Name, Established, about, fact, emi, admission, nip, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city, logo, image, video, fbLink, twitterLink, linkedin, instagram, smode, add, quesiton, answer, feature, toc,
    //     active,
    //     urlname,
    //     seotitle,
    //     seodescription,
    //     TOCcontent,
    //     TOCH1,
    //     TOCH2,

    //     TOCH3,
    //     TOCH4,
    //     TOCH5,
    //     modified_by


    // ) {
    //     let x = (await p.query("select * from university where id='" + Id + "'")).rows;
    //     let y = {};
    //     x.forEach((n, index) => {
    //         let k = Object.keys(n);
    //         if (!(n.uname === Name)) {
    //             y.uname = Name;
    //             y.previousuname = n.uname;
    //         }
    //         if (!(n.established === Established)) {
    //             y.established = Established;
    //             y.previousestablished = n.established;
    //         }
    //         if (!(n.about === about)) {
    //             y.about = about;
    //             y.previousabout = n.about;
    //         }
    //         if (!(n.officemailid === officeMailId)) {
    //             y.officemailid = officeMailId;
    //             y.previousofficemailid = n.officemailid;

    //         }
    //         if (!(n.approvedby === approvedBy)) {
    //             y.approvedby = approvedBy;
    //             y.previousapprovedby = n.approvedby;

    //         }
    //         if (!(n.coursetype === courseType)) {
    //             y.coursetype = courseType;
    //             y.previouscoursetype = n.coursetype;

    //         }
    //         if (!(n.stream === stream)) {
    //             y.stream = stream;
    //             y.previousstream = n.stream;

    //         }

    //         if (!(n.studymode === studyMode)) {
    //             y.studyMode = studyMode;
    //             y.previousstudymode = n.studymode;

    //         }

    //         if (!(n.universitytype === UniversityType)) {
    //             y.universitytype = UniversityType;
    //             y.previousuniversitytype = n.universitytype;

    //         }

    //         if (!(n.websiteurl === WebsiteUrl)) {
    //             y.websiteurl = WebsiteUrl;
    //             y.previouswebsiteurl = n.websiteurl;

    //         }

    //         if (!(n.state === state)) {
    //             y.state = state;
    //             y.previousstate = n.state;

    //         }
    //         if (!(n.city === city)) {
    //             y.city = city;
    //             y.previouscity = n.city;

    //         }
    //         if (!(n.logourl === logo)) {
    //             y.logourl = logo;
    //             y.previouslogourl = n.logourl;


    //         }
    //         if (!(JSON.stringify(n.imageurl) === JSON.stringify(image))) {
    //             y.imageurl = image;
    //             y.previousimageurl = n.imgArray;

    //         }
    //         if (!(JSON.stringify(n.videourl) === JSON.stringify(video))) {
    //             y.videourl = video;
    //             y.previousvideourl = n.videourl;

    //         }
    //         if (!(n.fblink === fbLink)) {
    //             y.fblink = fbLink;
    //             y.previousfblink = n.fblink;

    //         }
    //         if (!(n.twitterlink === twitterLink)) {
    //             y.twitterlink = twitterLink;
    //             y.previoustwitterlink = n.twitterlink;

    //         }
    //         if (!(n.linkedin === linkedin)) {
    //             y.linkedin = linkedin;
    //             y.previouslinkedin = n.linkedin;


    //         }
    //         if (!(n.instagram === instagram)) {
    //             y.instagram = instagram;
    //             y.previousinstagram = n.instagram;

    //         }
    //         if (!(n.toc === toc)) {
    //             y.toc = toc;
    //             y.previoustoc = n.toc;

    //         }

    //         if (!(n.smode === smode)) {
    //             y.smode = smode;
    //             y.previoussmode = n.smode;

    //         }

    //         if (!(n.feature === feature)) {
    //             y.feature = feature;
    //             y.previousfeature = n.feature;

    //         }

    //         if (!(n.nip === nip)) {
    //             y.nip = nip;
    //             y.previousnip = n.nip;

    //         }

    //         if (!(n.active === active)) {
    //             y.active = active;
    //             y.previousactive = n.active;

    //         }

    //         if (!(n.urlname === urlname)) {
    //             y.urlname = urlname;
    //             y.previousurlname = n.urlname;

    //         }

    //         if (!(n.seotitle === seotitle)) {
    //             y.seotitle = seotitle;
    //             y.previousseotitle = n.seotitle;

    //         }

    //         if (!(n.seodescription === seodescription)) {
    //             y.seodescription = seodescription;
    //             y.previousseodescription = n.seodescription;

    //         }

    //         if (!(JSON.stringify(n.toch2) === JSON.stringify(TOCH2))) {
    //             y.toch2 = TOCH2;
    //             y.previoustoch2 = n.toch2;

    //         }

    //         if (!(JSON.stringify(n.toch3) === JSON.stringify(TOCH3))) {
    //             y.toch3 = TOCH3;
    //             y.previoustoch3 = n.toch3;

    //         }

    //         if (!(JSON.stringify(n.toch4) === JSON.stringify(TOCH4))) {
    //             y.toch4 = TOCH4;
    //             y.previoustoch4 = n.toch4;

    //         }

    //     });
    //     console.log(y);
    //     let yy = `INSERT INTO public.universityactivity(
    //         superuserid, content, role,universityId)
    //         VALUES ($1,$2,$3,$4)`;
    //     let zz = [modified_by, y, "Update", Id];

    //     let pp = await p.query(yy, zz);


    //     let escapeHtmlString = (str) => {
    //         if (typeof str === 'string') {
    //             return str.replace(/\\/g, '\\\\').replace(/"/g, '\\"').replace(/'/g, "\\'");
    //         }
    //         return str;
    //     };

    //     let formatArrayLiteral = (arr) => {
    //         return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
    //     };



 
    // let query = `
    //     UPDATE university 
    //     SET uname=$1, 
    //     established=$2, 
    //     officemailid=$3, 
    //     approvedby=$4, 
    //     coursetype=$5, 
    //     stream=$6, 
    //     studymode=$7, 
    //     universitytype=$8, 
    //     websiteurl=$9, 
    //     state=$10, 
    //     city=$11, 
    //     logourl=$12, 
    //     imageurl=$13, 
    //     videourl=$14, 
    //     fblink=$15, 
    //     twitterlink=$16, 
    //     linkedin=$17, 
    //     instagram=$18,
    //     toc=$19, 
    //     smode=$20, 
    //     feature=$21, 
    //     added_by=$22, 
    //     last_modified=$23, 
    //     nip=$24, 
    //     about=$25, 
    //     fact=$26, 
    //     emi=$27, 
    //     admission=$28, 
    //     active=$29, 
    //     urlname=$30, 
    //     seotitle=$31, 
    //     seodescription=$32, 
      
    //     toch1=$33, 
    //     toch2=$34, 
    //     toch3=$35, 
    //     toch4=$36, 
    //     toch5=$37,
    //     last_modified_by=$38
    //     WHERE id = $39
    // `;

    //     let values = [
    //         Name,
    //         Established,
    //         officeMailId,
    //         approvedBy,
    //         courseType,
    //         stream,
    //         studyMode,
    //         UniversityType,
    //         WebsiteUrl,
    //         state,
    //         city,
    //         logo,
    //         formatArrayLiteral(image),
    //         '{}',
    //         fbLink,
    //         twitterLink,
    //         linkedin,
    //         instagram,
    //         toc,
    //         smode,
    //         feature,
    //         add,
    //         now,
    //         nip,
    //         about,
    //         fact,
    //         emi,
    //         admission,
    //         active,
    //         urlname,
    //         seotitle,
    //         seodescription,
            
    //         formatArrayLiteral(TOCH1),
    //         formatArrayLiteral(TOCH2),
    //         formatArrayLiteral(TOCH3),
    //         formatArrayLiteral(TOCH4),
    //         formatArrayLiteral(TOCH5),
    //         modified_by,
    //         Id
    //     ];

    //     await p.query(query, values);
    //     await faqController.UpdateUniversityFaqByUniversityId(Id, `{${quesiton.join(',')}}`, `{${answer.join(',')}}`, add);

    //     return {
    //         Status: true
    //     }

    // }

// static async getUniversityByStudyMode(Name) {
//         await p.query('begin');
//         let a = `select zone as zonenumber,state as statenumber,universitytype as universitytypenumber,imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university;`
//         let b = [Name];
//         let c = await p.query(a, b);
//         await p.query('commit');

//         return c.rows;

//     }

static async getUniversityByStudyMode(Name) {
        await p.query('begin');
        let a = `select zone as zonenumber,state as statenumber,universitytype as universitytypenumber,imageurl,(select name from approved where id::text=approvedby) as approvedby,(select name from state where id::text=state) as state,(select name from city where id::text=city) as city,uname,logourl,(select name from studymode where name=$1 ) as mode,(select name from universitytype where id::text=universitytype ) as unitype,(select name from zone where id::text=zone) as zone,established from university;`
        let b = [Name];
        let c = await p.query(a, b);
        await p.query('commit');

        return c.rows;

    }
    static async getUniversity() {
        let a = await p.query(`select id,uname from university `);



        return a.rows;
    }

    static async getUniversity1() {
        let a = await p.query(`select t1.id,t1.uname,
        t1.established,
        t1.officemailid,
        (select name from approved where id=t1.approvedby::integer) as approvedby
,
	
      (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
      (select name from stream where id=t1.stream::integer) as stream,
      (select name from studymode where id=t1.studymode::integer) as studymode,  
      
      (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
     (select name from state where id=t1.state::integer) as state,
     (select name from city where id=t1.city::integer) as city,
        t1.logourl,
        t1.active,
        t1.toc,
        t1.feature,
        t1.urlname,
        t1.added_date,
        t2.username as added_by,
        (select username from superuser where id=last_modified_by::integer ) as modified_by
        from university t1 join  superuser t2 on t1.added_by=t2.id`);



        return a.rows;
    }

 static async getRequestUniversity() {
        let a = await p.query(`select t1.id,t1.uname,
            t1.established,
            t1.officemailid,
            (select name from approved where id=t1.approvedby::integer) as approvedby
    ,
        
          (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
          (select name from stream where id=t1.stream::integer) as stream,
          (select name from studymode where id=t1.studymode::integer) as studymode,  
          
          (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
         (select name from state where id=t1.state::integer) as state,
         (select name from city where id=t1.city::integer) as city,
            t1.logourl,
            t1.active,
            t1.toc,
            t1.feature,
            t1.urlname,
            t1.added_date,
            t1.added_by,
            t1.last_modified_by as modified_by
            from university t1 join  coursetype t2 on t1.coursetype::int=t2.id
            where t1.added_by=0
            `);



        return a.rows;
    }
    static async getSingleUniversity(name) {
        if (name == '') {
            let a = await p.query("select * from university");

            return a.rows;
        }
        else {
            let a = await p.query("select * from university where uname='" + name + "'");

            return a.rows;
        }


    }
    static async UniversityFilter(column, value) {





        console.log(column);
        console.log(value);




        if (value == '') {
            console.log("First");
            let a = await p.query(`select t1.id,t1.uname,
            t1.established,
            t1.officemailid,
        
            (select name from approved where id=t1.approvedby::integer) as approvedby
    ,
        
          (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
          (select name from stream where id=t1.stream::integer) as stream,
          (select name from studymode where id=t1.studymode::integer) as studymode,  
          
          (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
         (select name from state where id=t1.state::integer) as state,
         (select name from city where id=t1.city::integer) as city,
            t1.logourl,
            t1.active,
            t1.toc,
            t1.feature,
            t1.urlname,
            t1.added_date,
            t2.username as added_by,
            (select username from superuser where id=last_modified_by::integer ) as modified_by
            from university t1 join  superuser t2 on t1.added_by=t2.id`);





            return a.rows;
        }
        else if (column == 'about') {
            console.log("Second");

            ["S.No", "uname", "established", "officemailid", "approvedby", "stream", "coursetype",
                "studymode",
                "universitytype",
                "logourl",
                "state",
                "city",
                "feature",
                "active",
                "toc",
                "urlname",

                , "id"

            ];
            let a = await p.query(`select t1.id,t1.uname,
            t1.established,
            t1.officemailid,
            t1.about,
            (select name from approved where id=t1.approvedby::integer) as approvedby
    ,
        
          (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
          (select name from stream where id=t1.stream::integer) as stream,
          (select name from studymode where id=t1.studymode::integer) as studymode,  
          
          (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
         (select name from state where id=t1.state::integer) as state,
         (select name from city where id=t1.city::integer) as city,
            t1.logourl,
            t1.active,
            t1.toc,
            t1.feature,
            t1.urlname,
            t1.added_date,
            t2.username as added_by,
            (select username from superuser where id=last_modified_by::integer ) as modified_by
            from university t1 join  superuser t2 on t1.added_by=t2.id`);



            let arr = [];

            a.rows.forEach((n) => {


                const plainText = n.about.replace(/<[^>]*>/g, '');


                const words = plainText.split(/\s+/);


                const filteredWords = words.filter(word => word.trim() !== '');

                if (parseInt(value) == 25) {
                    if (filteredWords.length < 25) {
                        let obj = {
                            "uname": n.uname,
                            "established": n.established,
                            "officemailid": n.officemailid,
                            "approvedby": n.approvedby,
                            "stream": n.stream,
                            "coursetype": n.coursetype,

                            "studymode": n.studymode,
                            "universitytype": n.universitytype,
                            "logourl": n.logourl,
                            "state": n.state,
                            "city": n.city,
                            "feature": n.feature,
                            "active": n.active,
                            "toc": n.toc,
                            "urlname": n.urlname,

                            "id": n.id

                        }
                        arr.push(obj);

                    }
                }
                else if (parseInt(value) == 50) {
                    if (filteredWords.length > 50) {
                        let obj = {
                            "uname": n.uname,
                            "established": n.established,
                            "officemailid": n.officemailid,
                            "approvedby": n.approvedby,
                            "stream": n.stream,
                            "coursetype": n.coursetype,

                            "studymode": n.studymode,
                            "universitytype": n.universitytype,
                            "logourl": n.logourl,
                            "state": n.state,
                            "city": n.city,
                            "feature": n.feature,
                            "active": n.active,
                            "toc": n.toc,
                            "urlname": n.urlname,

                            "id": n.id

                        }
                        arr.push(obj);
                    }
                }




            })




            return arr;


        }
        else {
            let userquery = `select t1.id,t1.uname,
            t1.established,
            t1.officemailid,
            (select name from approved where id=t1.approvedby::integer) as approvedby
    ,
        
          (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
          (select name from stream where id=t1.stream::integer) as stream,
          (select name from studymode where id=t1.studymode::integer) as studymode,  
          
          (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
         (select name from state where id=t1.state::integer) as state,
         (select name from city where id=t1.city::integer) as city,
            t1.logourl,
            t1.active,
            t1.toc,
            t1.feature,
            t1.urlname,
            t1.added_date,
            t2.username as added_by,
            (select username from superuser where id=last_modified_by::integer ) as modified_by
            from university t1 join  superuser t2 on t1.added_by=t2.id where  t1.${column}='${value}'::text`;
            let a = await p.query(userquery);
            return a.rows;
        }


    }
    static async UniversityForAbout(column, value, comp) {
        ["S.No", "uname", "established", "officemailid", "approvedby", "stream", "coursetype",
            "studymode",
            "universitytype",
            "logourl",
            "state",
            "city",
            "feature",
            "active",
            "toc",
            "urlname",

            , "id"

        ];
        let a = await p.query(`select t1.id,t1.uname,
    t1.established,
    t1.officemailid,
    t1.about,
    (select name from approved where id=t1.approvedby::integer) as approvedby,
  (select name from coursetype where id=t1.coursetype::integer) as coursetype  ,
  (select name from stream where id=t1.stream::integer) as stream,
  (select name from studymode where id=t1.studymode::integer) as studymode,  
  (select name from universitytype where id=t1.universitytype::integer) as universitytype  ,
 (select name from state where id=t1.state::integer) as state,
 (select name from city where id=t1.city::integer) as city,
    t1.logourl,
    t1.active,
    t1.toc,
    t1.feature,
    t1.urlname,
    t1.added_date,
    t2.username as added_by,
    (select username from superuser where id=last_modified_by::integer ) as modified_by
    from university t1 join  superuser t2 on t1.added_by=t2.id`);
        let arr = [];

        if (value == '' || comp == '') {
            a.rows.forEach((n) => {
                const plainText = n.about.replace(/<[^>]*>/g, '');
                const words = plainText.split(/\s+/);
                const filteredWords = words.filter(word => word.trim() !== '');




                let obj = {
                    "uname": n.uname,
                    "established": n.established,
                    "officemailid": n.officemailid,
                    "approvedby": n.approvedby,
                    "stream": n.stream,
                    "coursetype": n.coursetype,

                    "studymode": n.studymode,
                    "universitytype": n.universitytype,
                    "logourl": n.logourl,
                    "state": n.state,
                    "city": n.city,
                    "feature": n.feature,
                    "active": n.active,
                    "toc": n.toc,
                    "urlname": n.urlname,

                    "id": n.id

                }
                arr.push(obj);

            }
            );






        }
        else {
            a.rows.forEach((n) => {


                const plainText = n.about.replace(/<[^>]*>/g, '');


                const words = plainText.split(/\s+/);


                const filteredWords = words.filter(word => word.trim() !== '');

                console.log(value);
                console.log(comp);

                if (comp.trim() === "Less") {



                    if (filteredWords.length < parseInt(value)) {
                        console.log("Wor");

                        let obj = {
                            "uname": n.uname,
                            "established": n.established,
                            "officemailid": n.officemailid,
                            "approvedby": n.approvedby,
                            "stream": n.stream,
                            "coursetype": n.coursetype,

                            "studymode": n.studymode,
                            "universitytype": n.universitytype,
                            "logourl": n.logourl,
                            "state": n.state,
                            "city": n.city,
                            "feature": n.feature,
                            "active": n.active,
                            "toc": n.toc,
                            "urlname": n.urlname,

                            "id": n.id

                        }
                        arr.push(obj);

                    }
                }
                else if (comp.trim() == "Greater") {
                    if (filteredWords.length > parseInt(value)) {
                        let obj = {
                            "uname": n.uname,
                            "established": n.established,
                            "officemailid": n.officemailid,
                            "approvedby": n.approvedby,
                            "stream": n.stream,
                            "coursetype": n.coursetype,

                            "studymode": n.studymode,
                            "universitytype": n.universitytype,
                            "logourl": n.logourl,
                            "state": n.state,
                            "city": n.city,
                            "feature": n.feature,
                            "active": n.active,
                            "toc": n.toc,
                            "urlname": n.urlname,

                            "id": n.id

                        }
                        arr.push(obj);
                    }
                }
                else if (comp == '' || value == '') {
                    let obj = {
                        "uname": n.uname,
                        "established": n.established,
                        "officemailid": n.officemailid,
                        "approvedby": n.approvedby,
                        "stream": n.stream,
                        "coursetype": n.coursetype,

                        "studymode": n.studymode,
                        "universitytype": n.universitytype,
                        "logourl": n.logourl,
                        "state": n.state,
                        "city": n.city,
                        "feature": n.feature,
                        "active": n.active,
                        "toc": n.toc,
                        "urlname": n.urlname,

                        "id": n.id

                    }
                    arr.push(obj);
                }




            })
        }




        return arr;
    }

    static async getUniversityByTotalCourse() {
        let a = await p.query(`SELECT COUNT(*) as total,t1.courename as course, t2.uname, t2.logourl, t2.id, t2.urlname 
        FROM course t1 
       RIGHT JOIN university t2 ON t2.id::text = ANY(t1.universityid)
        GROUP BY t2.uname, t2.logourl, t2.id, t2.urlname,t1.courename`);




        return a.rows;

    }
    
    static async getSpecializationByCourse() {
        let a = await p.query("select t1.id,t1.courseid,t1.specialization from acdemicspecialization t1 join course t2 on t2.id=t1.courseid ");
        
        
        

        return a.rows;

    }
    

    static async getUniversityByCourseSpecialization() {
        let a = await p.query("SELECT count(*) as total,t3.id as spId, t1.uname, t1.urlname,t1.coursetype,t1.id FROM university t1 JOIN course t2 ON t1.id::text=any(t2.universityid) JOIN acdemicspecialization t3 ON t3.courseid=t2.id  GROUP BY t1.uname,t1.urlname,t3.id ,t1.id,t1.coursetype");

        return a.rows;

    }



    static async deleteUniversity(id, superuserId) {

        console.log()
        let a = await reviewController.deleteUniversityReviewByuniversityId(id);
        let b = await commentController.deleteUniversityCommentByuniversityId(id);
        let c = await faqController.deleteUniversityfaqByuniversityId(id);

        console.log("Uni", id);


        let d = await courseController.deletCoursebyUniversityid(id);


        let yy = `INSERT INTO public.universityactivity(
            superuserid, content, role,universityId)
            VALUES ($1,$2,$3,$4)`;
        let zz = [superuserId, '{}', "Delete", id];

        let pp = await p.query(yy, zz);


        let e = await p.query("delete from university where id='" + id + "'");





        return { Status: true };



    }
    
   

    static async getUniversitySpecialization() {
        let a = await p.query("select id,feature as Specializaion from university");


        return a.rows;

    }

    static async getUniversityBySpecializatioName(specialization) {
        let a = await p.query("select t1.uname,t1.established,t1.officemailid,t1.approvedby,t1.coursetype,t1.stream,t1.studymode,t1.universitytype,t1.websiteurl,t1.state,t1.city,t1.logourl,t1.imageurl,t1.videourl,t1.fblink,t1.twitterlink,t1.linkedin,t1.instagram,t1.toc,t1.smode,t1.feature,t2.rating from university t1 join universityreview t2 on t1.id=t2.universityid where feature='" + specialization + "'");

        return a.rows;



    }
    
    
    
    

    static async ParticularUniversity() {
        let a = await p.query("select * from university  ");
        

let universitydata=a.rows;
let authorData='';
let universityreview='';
let universityfaq='';
let universitycourse='';





     authorData = await authorController.getPrimaryDetail();
      universityreview =await reviewController.getUniversityReviewByUniversityId();
       universityfaq = await faqController.getUniversityFaqByUniversityId();
       universitycourse = await courseController.getCourseByUniversityId();
       
      

     
     
     
       


return {
    university:universitydata,
    author:authorData,
    review:universityreview,
    faq:universityfaq,
    course:universitycourse
    
}



    }
    static async ParticularUniversity2() {
        let a = await p.query("select * from previewuniversity  ");
        

let universitydata=a.rows;
let authorData='';
let universityreview='';
let universityfaq='';
let universitycourse='';





     authorData = await authorController.getPrimaryDetail2();
      universityreview =await reviewController.getUniversityReviewByUniversityId();
       universityfaq = await faqController.getUniversityFaqByUniversityId();
       universitycourse = await courseController.getCourseByUniversityId();
       
      

     
     
     
    


return {
    university:universitydata,
    author:authorData,
    review:universityreview,
    faq:universityfaq,
    course:universitycourse
    
}



    }
    static async ParticularUniversity1(id) {
        let a = await p.query("select * from university  where id='" + id + "'");

        return a.rows;

    }
    static async getUniversityByNameUsingLike(name) {
        await p.query('begin');
        
        if (name !== '') {
            const query = `
            SELECT 
                t1.id, 
                t1.uname AS uname,
                t1.logourl AS logourl,
                t1.urlname as urlname,
                t1.added_date,
                t2.username AS added_by
            FROM 
                university t1 
            JOIN  
                superuser t2 
            ON 
                t1.added_by = t2.id 
            WHERE 
                t1.uname LIKE $1
        `;

            const values = [`%${name}%`];
            let a = await p.query(query, values);
            return a.rows;
        }
        else
        {
            return [];
            
        }
        await p.query('commit');

    }

}

module.exports = University;
