
const express=require('express');
const cors = require('cors');
const fs = require('fs');
const path = require('path');
const cookieParser = require("cookie-parser");

const mongoose=require('mongoose');
const expressesion=require('express-session');
const session = require("express-session");

const p=require('./config/db.js');
const compression = require('compression');

const cluster = require('cluster');
const os = require('os');
const numCPUs = os.cpus().length;

const client=require('./config/redius.js');




const RedisStore = require('connect-redis').default;




const app=express();
app.use(express.urlencoded({
    extended:false
}));







const { SitemapStream, streamToPromise } = require('sitemap');

const { Readable } = require('stream');


const { createWriteStream } = require('fs');

const blogController = require('./controllers/blogController');
const courseController = require('./controllers/courseController');
const universityController = require('./controllers/universityController');
const jobController = require('./controllers/JobController');
async function generateSitemap() {
  try {
   
const blogurl=await blogController.getBlog();
const courseurl=await courseController.getCourseByName();
const universityurl=await universityController.getUniversityByTotalCourse();
const joburl=(await p.query("select id from job")).rows;

   const auth=(await p.query("select name from  superuser")).rows;
   
   
   const links = [
  { url: '/', changefreq: 'daily', priority: 1.0 },
  { url: '/about', changefreq: 'monthly', priority: 0.8 },
  { url: '/contact', changefreq: 'monthly', priority: 0.7 },
  { url: '/media', changefreq: 'monthly', priority: 0.7 },
 
   { url: '/sitemap', changefreq: 'monthly', priority: 0.5 },
  { url: '/experts', changefreq: 'monthly', priority: 0.8 },
 
  { url: '/Dashboard', changefreq: 'weekly', priority: 0.6 },
  { url: '/blog', changefreq: 'weekly', priority: 0.7 },
  { url: '/list-yourself', changefreq: 'monthly', priority: 0.8 },

  { url: '/Video-Conselling', changefreq: 'monthly', priority: 0.6 },
  { url: '/Verify-University', changefreq: 'monthly', priority: 0.7 },
  { url: '/checklist', changefreq: 'monthly', priority: 0.6 },
  
 
  { url: '/Career', changefreq: 'monthly', priority: 0.8 },
 
];
   
    
    blogurl.forEach(blog => {
      links.push({ url: `/blog/${blog.urlname}`, changefreq: 'weekly', priority: 0.7 });
    });
    
     courseurl.forEach(blog => {
      links.push({ url: `/courses/${blog.urlname}`, changefreq: 'weekly', priority: 0.7 });
    });
     universityurl.forEach(blog => {
      links.push({ url: `/universities/${blog.urlname}`, changefreq: 'weekly', priority: 0.8 });
    });
    
    
     auth.forEach(blog => {
      links.push({ url: `/Author/${blog.name}`, changefreq: 'monthly', priority: 0.7 });
    });
     joburl.forEach(blog => {
      links.push({ url: `/Job-Detail/${blog.id}`, changefreq: 'monthly', priority: 0.7 });
    });
    

    // Generate the sitemap
    const stream = new SitemapStream({ hostname: 'https://imts.ac.in' });
    const sitemapPath = '../IMTS1/sitemap.xml'; // Adjust path based on your React deployment structure

    const readableLinks = Readable.from(links.map(link => link));
    const data = await streamToPromise(readableLinks.pipe(stream));

    createWriteStream(sitemapPath).write(data.toString());
    console.log('Sitemap generated at:', sitemapPath);
  } catch (error) {
    console.error('Error generating sitemap:', error);
  }
}




const corsOptions = {
origin: ['https://imts.ac.in','https://student.imtsonline.in','http://localhost:5173','http://localhost:3000','http://localhost:5174'],
  credentials: true,
};

app.use(cors(corsOptions));
app.use(express.json());


app.use(compression());

  
  
  
  
  
const allowOnlyImtsonline = (req, res, next) => {
    const allowedDomain = 'imts.ac.in';
    const origin = req.headers.origin || req.headers.referer;

    if (origin) {
        const domain = new URL(origin).hostname;
        if (domain.endsWith(allowedDomain)) {
            return next(); 
        }
    }


    res.status(403).send('Access forbidden: domain not allowed');
};
// app.use(allowOnlyImtsonline);
app.use(express.json({ limit: '1000000mb' }));
// app.use((req, res, next) => {
//   const startHrTime = process.hrtime();
//   res.on('finish', () => {
//     const elapsedHrTime = process.hrtime(startHrTime);
//     const elapsedTimeInMs = elapsedHrTime[0] * 1000 + elapsedHrTime[1] / 1e6;
//     console.log(`${req.method} ${req.url} [${res.statusCode}] - ${elapsedTimeInMs} ms`);
//   });
//   next();
// });
app.use('/backend/Backup', express.static(path.join(__dirname, 'Backup')))
const backupDir = path.join(__dirname, 'Backup');
const { exec } = require('child_process');
const cron = require('node-cron');
const backupDatabase =async() => {

   const dbName = 'imtsac_educationdunia';
const dbPass = 'Website119$';
const dbHost = 'localhost';
const dbUser = 'imtsac_ibrahimmemon';
const dbPort = '5432';

 const date = new Date();
    const currentDate = `${date.getFullYear()}-${date.getMonth() + 1}-${date.getDate()}`;
    const backupFilePath = path.join(__dirname, 'Backup', `${dbName}-${currentDate}.sql`);



    exec(`pg_dump -h ${dbHost} -U ${dbUser} -p ${dbPort} -F p -b -v -f  ${backupFilePath} ${dbName}`, { env: { PGPASSWORD: dbPass } }, (error, stdout, stderr) => {
    
        if (error) {
            console.error(`exec error: ${error}`);
            return;
        }
        if (stderr) {
            console.error(`stderr: ${stderr}`);
            return;
        }
        console.log(`Created a backup of ${dbName} at ${date.toLocaleString()} successfully: ${stdout}`);
    });
    
    
    const fpath = `${dbName}-${currentDate}.sql`;
    
    
    const a=`insert into backup(filepath,mode) values($1,$2)`;
    const b=[fpath,'Auto'];
    const c=await p.query(a,b);
    
    

};
app.get("/backend/Mannual-Backup",async(req,res)=>
{
    backupDatabase();
    res.json({
        Status:true
    });
})
app.get("/backend/get-Backup",async(req,res)=>
{
    let a=await p.query("select * from backup");
    res.send(a.rows);
    
})
const deleteOldBackups = () => {
    fs.readdir(backupDir, (err, files) => {
        if (err) throw err;

        files.forEach(file => {
            const filePath = path.join(__dirname, 'Backup', file);
            fs.stat(filePath, (err, stat) => {
                if (err) throw err;

                const now = new Date().getTime();
                const endTime = new Date(stat.mtime).getTime() + 7 * 24 * 60 * 60 * 1000;

                if (now > endTime) {
                    fs.unlink(filePath, err => {
                        if (err) throw err;
                        console.log(`Deleted old backup: ${file}`);
                    });
                }
            });
        });
    });
};
const RestoreOldBackups = () => {
    fs.readdir(backupDir, (err, files) => {
        if (err) throw err;

        files.forEach(file => {
            const filePath = path.join(__dirname, 'Backup', file);
            fs.stat(filePath, (err, stat) => {
                if (err) throw err;

               
                    fs.unlink(filePath, err => {
                        if (err) throw err;
                        console.log(`Deleted old backup: ${file}`);
                    });
                
            });
        });
    });
};
const deleteAllData = async () => {
  try {

    const tablesRes = await p.query(
      `SELECT table_name 
       FROM information_schema.tables 
       WHERE table_schema='public'`
    );
    const tableNames = tablesRes.rows.map(row => row.table_name);

    for (const tableName of tableNames) {
      await p.query(`TRUNCATE TABLE ${tableName} CASCADE`);
    }

   
  } catch (error) {
    console.error('Error deleting data:', error);
  }
};
app.post('/backend/Recover-Database1', async (req, res) => {
    
    
    const {Id}=req.body;
    
    
    
    const dbName = 'imtsac_educationdunia';
const dbPass = 'Website119$';
const dbHost = 'localhost';
const dbUser = 'imtsac_ibrahimmemon';
const dbPort = '5432';


//     const dbName = 'imtsac_imtsonline';
// const dbPass = 'Website119$$';
// const dbHost = 'localhost';
// const dbUser = 'imtsac_imtsonline_user';
// const dbPort = '5432';




const a=await p.query("select * from backup where id='"+Id+"'");
let b=await a.rows[0].filepath;


// let b='imtsac_educationdunia-2024-9-19.sql';








  const backupDir1 = path.join(__dirname, `Backup/${b}`);
  if (!fs.existsSync(backupDir1)) {
    return res.status(404).send('SQL file not found');
  }

  await deleteAllData();



  const restoreCommand = `/usr/bin/psql -h ${dbHost} -U ${dbUser} -d ${dbName} -f ${backupDir1}`;


  exec(restoreCommand, { env: { PGPASSWORD: dbPass } }, (error, stdout, stderr) => {
    if (error) {
      console.error(`Error restoring database: ${error.message}`);
      return res.status(500).send('Error restoring database');
    }
    if (stderr) {
      console.error(`psql stderr: ${stderr}`);
    }
    console.log('Database restored successfully');



  });

res.send("Database restored successfully");
});
app.get('/backend/Restorebackup', (req, res) => {
   RestoreOldBackups();
   
   res.send(
       {
           Status:true
       })

});

cron.schedule('0 0 * * *',async () => {
    backupDatabase();
    generateSitemap();
    
    deleteOldBackups();
    console.log('Scheduled backup and cleanup completed');
});
app.use('/backend/images', express.static(path.join(__dirname, 'assets')));
app.use((err, req, res, next) => {
    console.error(err.stack);
    res.status(500).send('Server Error');
});
app.get("/backend/Test",async(req,res)=>
{
  
    generateSitemap();
    res.send("dfsdfsdf");
    
})
app.set('view-engine','ejs');


  
  
  app.post('/backend/set-value', async (req, res) => {
  const value = req.body.value1;
console.log(value);

  try {
    // Check if value is valid
    if (typeof value !== 'string') {
      return res.status(400).send('Invalid value type');
    }

    await client.set('myKey', value);
    res.send('Value saved to Redis');
  } catch (err) {
    console.error('Error saving to Redis:', err);
    return res.status(500).send('Error saving to Redis');
  }
});


// Route to get value from Redis
app.get('/backend/get-value',async (req, res) => {

let a=await client.get('myKey');
let b='';
if(a)
{
    b='B is Correct';
}
else
{
    b='B is inCorrect';
}
res.send(b+a);


});
if (cluster.isMaster) {
  console.log(`Master process ${process.pid} is running`);

  for (let i = 0; i < numCPUs; i++) {
    cluster.fork();
  }

  cluster.on('exit', (worker, code, signal) => {
    console.log(`Worker process ${worker.process.pid} died. Restarting...`);
    cluster.fork();
  });
} 
else {
    
   
  
  
  app.use(session({
      store: new RedisStore({ client: client }),
      
      
  secret: '&@#$%^&*()_+',
  resave: false,
  saveUninitialized: true,
  cookie: {
    expires: 60 * 60 * 24 * 30,
    secure:false
  },
 
}));

app.use(cookieParser());

app.use("/backend/",require('./router/routers'));
const PORT=7008;
app.listen(PORT,()=>
{


console.log("fsdfsdf");

});


 

}

// app.use(session({
     
      
      
//   secret: '&@#$%^&*()_+',
//   resave: false,
//   saveUninitialized: true,
//   cookie: {
//     expires: 60 * 60 * 24 * 30,
//     secure:false
//   },
 
// }));

// app.use(cookieParser());

// app.use("/backend/",require('./router/routers'));
// const PORT=7008;
// app.listen(PORT,()=>
// {


// console.log("fsdfsdf");

// });










