require('dotenv').config();
const express = require("express");
const multer = require('multer');
const path = require('path');
const fs = require('fs');
const router = express.Router();
const jwt = require('jsonwebtoken');
exports.router = router;
const QualificationController=require('../controllers/QualificationController');
const DesignationController = require("../controllers/DesignationController");
const ZoneController = require('../controllers/ZoneController');
const AcdemicSpecialization = require('../controllers/AcdemicSpecialization');
const ExpertController=require('../controllers/ExpertController');
const AboutController = require('../controllers/AboutController');
const UniversityListeningBenefit = require('../controllers/UniversityListeningBenefit');
const EstablishController = require('../controllers/EstablishController');
const MarqueeController = require('../controllers/MarqueeController');
const client=require('../config/redius.js');
const redisClient=require('../config/redius.js');

const UniversityListeningStep=require('../controllers/UniversityListeningStep');
const HeaderController = require('../controllers/HeaderController');
const CTAController = require('../controllers/CTAController');
const MoreResourceController = require('../controllers/MoreResourceController');

const JobResponse = require('../controllers/JobResponseController');
const JobModeController = require('../controllers/JobModeController');
const XLSX = require('xlsx');
const JobTypeController = require('../controllers/JobTypeController');
const JobReferenceController = require('../controllers/jobReferenceConroller');
const ContactUsController = require('../controllers/ContactController');

const OneStepSolution = require('../controllers/OneStepSolution');
const MediaController = require('../controllers/MediaController');
const JobController = require('../controllers/JobController');

const courseTypeController = require('../controllers/courseTypeController');
const courseDurationController = require('../controllers/coursedurationController');
const collegetypeController = require('../controllers/collegetypeController');
const bannerController = require('../controllers/bannerController');
const studyModeController = require('../controllers/studymodeController');
const courseModeController = require('../controllers/courseModeController');

const universitytypeController = require('../controllers/universityTypeController');
const approvedController = require('../controllers/approvedController');
const stateController = require('../controllers/stateController');
const streamController = require('../controllers/streamController');
const cityController = require('../controllers/cityController');

// const bcrypt = require('bcrypt');
// const saltRounds = 10;
// const { encrypt, decrypt } = require('../controllers/cryptoController');
const authorController = require("../controllers/authorController");
const useractivityController = require("../controllers/useractivityController");
const UserActivityController = require("../controllers/useractivityController");
const IndividualCourseController = require("../controllers/IndividualCourseController");
const countryController = require("../controllers/countryController");

const bookController = require("../controllers/bookController");
const staffController = require("../controllers/staffController");
const footerController = require("../controllers/footerController");
const dashboardController = require("../controllers/DashboardController");


const subjectController = require("../controllers/subjectController");
const superuserController = require("../controllers/superuserController");
const alumniController = require('../controllers/alumniController');

const SuperUserController = require("../controllers/superuserController");

const userController = require('../controllers/userController');

const universityController = require('../controllers/universityController');
const blogController = require('../controllers/blogController');
const courseController = require('../controllers/courseController');
const newsController = require('../controllers/newsController');
const faqController = require('../controllers/faqController');
const commentController = require('../controllers/commentController');
const reviewController = require('../controllers/reviewsController');
const specializationController = require('../controllers/specializationController');
const LeadController = require("../controllers/leadController");

const p = require('../config/db');
const { log } = require('console');
const session = require('express-session');

const crypto = require('crypto');


const secretKey = crypto.randomBytes(64).toString('hex');
const SECRET_KEY = "f4fcee7048275cfea27c8d6f28b7be087d6c1f57dd376f7fbcdbda7f";
const TOKEN_EXPIRATION = '24h'; 
console.log(secretKey);


router.post("/Add-University-Review", async (req, res) => {
    client.del("getuniversityreviewapi");
  try {
    const add = req.session.username;
    const { rating, detail, user, university } = req.body;

    const r = await p.query("SELECT * FROM users WHERE email=$1", [user]);

    if (r.rows.length > 0) {
      const promises = r.rows.map(async (p) => {
        return await reviewController.addUniversityReview(rating, detail, p.id, university, add);
      });

      const results = await Promise.all(promises);
      res.send({
        Status: true
      }); // Send the response after all promises are resolved
    } else {
      res.json({ Status: false });
    }
  } catch (error) {
    console.error("Error:", error);
    res.status(500).json({ error: "Internal Server Error" });
  }










  // if (!requireLogin) {
  //   let add = "admin";

  //   const { rating, detail, user, university } = req.body;

  //   const a = await reviewController.addUniversityReview(rating, detail, user, university, add);



  //   res.send(a);
  // }
  // else {
  //   let add = "admin";

  //   const { rating, detail, user, university } = req.body;


  //   let r = (await p.query("select * from users where email='" + user + "'")).rows;

  //   if (r.length > 0) {
  //     r.forEach(async (p) => {
  //       const a = await reviewController.addUniversityReview(rating, detail, p.id, university, add);
  //       res.send(a);
  //     })

  //   }
  //   else {
  //     res.json(
  //       {
  //         Status: false
  //       }
  //     );
  //   }






  // }





});


const requireLogin1 = (req, res, next) => {
  if (req.session.superusername) {

    next();
  } else {

    res.json(
      {
        Status: false
      }
    );

  }
};
router.get("/get-University-Course-Activity", async (req, res) => {
  let a = await useractivityController.getUniversityCourseActivity();

  res.send(a);

})
router.get("/get-Blog-Activity", async (req, res) => {
  let a = await useractivityController.getBlogActivity();

  res.send(a);

})
router.post("/Update-University-Review", async (req, res) => {
    client.del("getuniversityreviewapi");
  let add = "admin";

  const { id, rating, detail, user, university } = req.body;

  const a = await reviewController.UpdateUniversityReview(rating, detail, user, university, add, id);



  // res.send(a);
  res.json(
    {
      Status: req.body

    }
  );





});

router.post("/get-Single-Course-By-Id", async (req, res) => {
  const { Id } = req.body;
  let a = await courseController.getSingleCourseById(Id);

  res.send(a);

})


router.post("/get-Single-Individual-Course-By-Id", async (req, res) => {
  const { Id } = req.body;
  let a = await IndividualCourseController.getSingleIndividualCourseById(Id);

  res.send(a);

})

router.post("/get-Single-Course-Faq-By-Course-Id", async (req, res) => {
  const { Id } = req.body;

  let a = (await faqController.getCourseFaqByCourseId(Id));

  res.send(a);

})


router.post("/get-Single-Individual-Course-Faq-By-Course-Id", async (req, res) => {
  const { Id } = req.body;

  let a = (await faqController.getSingleCourseIndividualFaqByCId(Id)).rows;

  res.send(a);

})


router.get("/get-University-Review", async (req, res) => {

let response=[];
let b=await client.get("getuniversityreviewapi");
if(b)
{
    response=b;
}
else
{  
    let a = await reviewController.getUniversityReview();
    response=a;
    await client.set("getuniversityreviewapi",JSON.stringify(a),'EX',3600*24);
}


  res.send(response);


});

router.post("/Add-Blog-Reviews", async (req, res) => {
    client.del("getblogreviewapi");
    
  let add = req.session.username;

  const { rating, detail, user, topic } = req.body;

  let a = await reviewController.addBlogReview(rating, detail, user, topic, add);


  res.send(a);



});



router.get("/get-Blog-Review", async (req, res) => {
    let response=[];
    let b=await client.get("getblogreviewapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await reviewController.getBlogReview();
        await client.set("getblogreviewapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }



  res.send(response);
  




});


router.get("/get-University-By-Total-Course", async (req, res) => {
  let a = await universityController.getUniversityByTotalCourse();

  res.send(a);

})
router.get("/get-University-By-Course-Specialization", async (req, res) => {
  let a = await universityController.getUniversityByCourseSpecialization(req.query.name);

  res.send(a);

});

router.get("/get-University-By-Specialization-Name", async (req, res) => {

  let a = await universityController.getUniversityBySpecializatioName(req.query.name);

  res.send(a);


})


router.get("/get-University-Specialization", async (req, res) => {
  let a = await universityController.getUniversitySpecialization();
  res.send(a);


})
router.get("/get-Course-By-Type", async (req, res) => {
  let a = await courseController.getCourseByType(req.query.name)
  res.send(a);




});


router.get("/get-Course-By-Name", async (req, res) => {


  let a = await courseController.getCourseByName(req.query.name)
  res.send(a);




});

router.post("/get-Course-By-Url", async (req, res) => {
  let a = await courseController.getCourseByUrlName(req.body.Id);

  res.send(a);

})
router.post("/get-Course-By-Url1", async (req, res) => {
  let a = await IndividualCourseController.getCourseByUrlName(req.body.Id);

  res.send(a);

})
router.get("/get-Course-By-Name1", async (req, res) => {


  let a = await IndividualCourseController.getCourseByName1(req.query.name)
  res.send(a);




});

router.post("/get-University-Faq-By-University-Id", async (req, res) => {
  let a = await faqController.getUniversityFaqByUniversityId(req.body.Id);

  res.send(a);

});
router.post("/get-University-Faq-By-University-Id1", async (req, res) => {
  let a = await faqController.getUniversityFaqByUniversityId1(req.body.Id);

  res.send(a);

});
router.post("/get-Review-By-University-Id", async (req, res) => {
  let a = await reviewController.getUniversityReviewByUniversityId(req.body.Id);

  res.send(a);

})
router.post("/get-Course-By-University-Id1", async (req, res) => {
  const { Id } = req.body;

  let a = await courseController.getCourseByUniversityId(Id);

  res.send(a);



})

router.get("/get-Course-Review", async (req, res) => {
    let response=[];
    let b=await client.get("getcoursereviewapi");
    if(b)
    {
        response=b;
    }
    else
    {
         let a = await reviewController.getCourseReview();

        response=a;
        await client.set("getcoursereviewapi",JSON.stringify(a),'EX',3600*24);
    }
 

  res.send(response);

})



router.post("/Add-Subject", async (req, res) => {
    client.del("getsubjectapi");
  const { course, semsterOrYear,
    noOfSemsterOrYear, specialization, questions, answers } = req.body;


  const s = `{${questions.join(',')}}`;
  const c = `{${answers.join(',')}}`;
  let added_by = req.session.superusername;


  let a = await subjectController.Add(course, semsterOrYear,
    noOfSemsterOrYear, specialization, s, c, added_by);


  res.send(a);

});


router.get("/get-Subject-By-Course-Name", async (req, res) => {
  let a = await subjectController.getSubjectByCourseName(req.query.name);

  res.send(a);
})


router.get("/get-Subject", async (req, res) => {
    let response=[];
    let b=await client.get("getsubjectapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await subjectController.getSubject();
        await client.set("getsubjectapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

});

router.get("/delete-Subject", async (req, res) => {
    
    client.del("getsubjectapi");
  let a = await subjectController.deleteSubject(req.query.Id);

  return a;

});

router.post("/Add-Book", async (req, res) => {
 client.del("getbookapi");
  const { university, course, title, url } = req.body;
  let added_by = req.session.superusername;
  let a = await bookController.Add(university, course, title, url, added_by);


  res.send(a);

});


router.get("/get-Book", async (req, res) => {
    
    
    let response=[];
    let a=await client.get("getbookapi");
    if(a)
    {
        response=a;
    }
    else
    {
        
  let a = await bookController.getBook();
  await client.set("getbookapi",JSON.stringify(a),'EX',3600*24);
  
  response=a;
    }



  res.send(response);

});




router.get("/delete-Book", async (req, res) => {
    client.del("getbookapi");
  let a = await bookController.deleteBook(req.query.Id);


  res.send(a);

})

router.post("/get-Subject-By-Specialization-Id", async (req, res) => {
  let a = await subjectController.getSubjectBySpecializationId(req.body.Id);

  res.send(a);

})
router.post("/Add-Specialization", async (req, res) => {
    client.del("getspecializationapi");
  const {
    course,
    specialization,
    specializationcode,
  } = req.body;
  let added_by = req.session.superusername;

  let a = await specializationController.Add(
    course,
    specialization,
    specializationcode,
    added_by);


  res.send(a);

})




router.get("/get-Specialization", async (req, res) => {
    let response=[];
    let b=await client.get("getspecializationapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await specializationController.getSpecialization();
        await client.set("getspecializationapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

})
router.get("/delete-Specialization", async (req, res) => {
 
 client.del("getacademicspecializationapi");
 
  let a = await specializationController.deleteSpecialization(req.query.Id, req.session.superusername);

  res.send(a);


});

router.get("/get-Specialization-By-Course-Id", async (req, res) => {
  let a = await specializationController.getSpecializationByCourseId(req.query.Id);
  res.send(a);

})


router.get("/Particular-Specialization", async (req, res) => {
  let a = await specializationController.getParticualrSpecialization(req.query.Id);

  res.send(a);

});


router.post("/Update-Specialization", async (req, res) => {
    client.del("getacademicspecializationapi");
  const { Id, 
    course,
    specialization,
    specializationcode,
   
  } = req.body;



  let a = await specializationController.UpdateSpecialization(Id,
    course,
    specialization,
    specializationcode,
   
    req.session.superusername
  );


  res.send(a);

})


router.post("/Particular-Subject-By-Id", async (req, res) => {
  const { Id } = req.body;
  let a = await subjectController.getParticularSubjectById(Id);

  res.send(a);

})

router.post("/Update-Subject", async (req, res) => {
    client.del("getsubjectapi");
  const { id,
    course,
    specialization,

    questions,
    answers } = req.body;

  let s = `{${questions.join(',')}}`;
  let c = `{${answers.join(',')}}`;

  let a = await subjectController.UpdateSubjectById(id,
    course,
    specialization,

    s,
    c);


  res.send(a);

})

router.get("/Particular-Blog", async (req, res) => {
    
    console.log(req.query.Id);
    
  let a = await blogController.getParticularBlog(req.query.Id);

  res.send(a);

});
router.get("/Particular-Blog1", async (req, res) => {
  let a = await blogController.getParticularBlog1(req.query.Id);

  res.send(a);

});
router.post("/Update-Blog", async (req, res) => {
client.del("getblogapi");
    client.del("gethomepageapi");

  let add = req.session.superusername;

 let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };

  const { id,
    pageName,
    seoTitle,
    seoDescription,
   
    tag,
    status,
    topic,
    content,
    questions,
    answers,
    TOC1,
    TOC2,
    TOC3,
    TOC4,
    TOC5,
    layout,
    image,
    Role,
    urlname

  } = req.body;



let z=`{${TOC3.join(',')}}`

  console.log("This is Role");
  console.log(Role);






  let a = await blogController.UpdateBlog(id,
    pageName,
    seoTitle,
    seoDescription,
   
    tag,
    status,
    topic,
    content,
    `{${questions.join(',')}}`,
    `{${answers.join(',')}}`,
    add,
    formatArrayLiteral(TOC1),

    formatArrayLiteral(TOC2),
    formatArrayLiteral(TOC3),

    formatArrayLiteral(TOC4),
        formatArrayLiteral(TOC5),
    layout,
    image,
    Role,
    urlname
  );



  res.send(a);


});


router.get("/get-Total-University", async (req, res) => {
  let a = await universityController.getTotal();

  res.send(a);
})

router.get("/get-Total-Course", async (req, res) => {
  let a = await courseController.getTotal();

  res.send(a);
})
router.get("/get-Total-Specialization", async (req, res) => {
  let a = await specializationController.getTotal();

  res.send(a);
})

router.get("/get-Total-Subject", async (req, res) => {
  let a = await subjectController.getTotal();

  res.send(a);
});

router.get("/get-Total-Book", async (req, res) => {
  let a = await bookController.getTotal();

  res.send(a);
});

router.get("/get-Total-Users", async (req, res) => {
  let a = await userController.getTotal();

  res.send(a);
});

router.get("/get-Total-Blog", async (req, res) => {
  let a = await blogController.getTotal();

  res.send(a);
});

router.get("/get-Total-University-Faq", async (req, res) => {
  let a = await faqController.getTotal();

  res.send(a);
});

router.get("/get-Total-University-Review", async (req, res) => {
  let a = await reviewController.getTotal();

  res.send(a);
})

router.get("/get-Total-University-Comment", async (req, res) => {
  let a = await commentController.getTotal();

  res.send(a);
});


router.get("/get-University-By-Name", async (req, res) => {
  let a = await universityController.getSingleUniversity(req.query.name);

  res.send(a);

})

router.get("/get-Single-Course-By-Name", async (req, res) => {
  let a = await courseController.getSingleCourseByNam(req.query.name);

  res.send(a);

});




router.get("/get-Single-Specialization-By-Name", async (req, res) => {
  let a = await specializationController.getSingleSpecializationByName(req.query.name);

  res.send(a);

});


router.get("/get-Single-Book-By-Name", async (req, res) => {
  let a = await bookController.getSingleBookByName(req.query.name);

  res.send(a);

});


router.get("/get-Single-Blog-By-Name", async (req, res) => {
  let a = await blogController.getSingleBlogByName(req.query.name);

  res.send(a);

});




router.get("/get-Single-User-By-Username", async (req, res) => {
  let a = await userController.getSingleUserByName(req.query.name);

  res.send(a);

});








router.post("/Particular-Book-By-Id", async (req, res) => {
  let a = await bookController.getParticularBookById(req.body.Id);


  res.send(a);

});

router.post("/Update-Book", async (req, res) => {
    client.del("getbookapi");
  const { id, subject, specialization, title, url } = req.body;


  let a = await bookController.UpdateBook(id, subject, specialization, title, url);


  res.send(a);

})

router.post("/Add-Course-Reviews", async (req, res) => {

client.del("getcoursereviewapi");
  let add = req.session.username;

  const { rating, detail, user, course } = req.body;

  let a = await reviewController.addCourseReview(rating, detail, user, course, add);

  res.send(a);


});









router.post("/Add-University-Comment", async (req, res) => {
    client.del("getuniversitycommentapi");
  const added_by = req.session.username;

  const { title, detail, university, username } = req.body;


  let a = await commentController.addUniversityComment(title, detail, university, username, added_by);


  res.send(a);




});


router.post("/Add-Course-Comment", async (req, res) => {
  const added_by = req.session.username;

client.del("getcoursecommentapi");

  const { title, detail, course, username } = req.body;


  let a = await commentController.addCourseComment(title, detail, course, username, added_by);


  res.send(a);




});



router.post("/Add-Blog-Comment", async (req, res) => {
    client.del("getblogcommentapi");
  const added_by = req.session.username;

  const { title, detail, topic, username } = req.body;


  let a = await commentController.addBlogComment(title, detail, topic, username, added_by);


  res.send(a);




});

router.get("/get-Blog-Comments", async (req, res) => {
    
    let response=[];
    let b=await client.get("getblogcommentapi");
    
    if(b)
    {
        response=b;
    }
    else
    {
        let r = await commentController.getBlogComments();
        response=r;
        await client.set("getblogcommentapi",JSON.stringify(r),'EX',3600*24);

    }
    
  
  res.send(response);

})


router.get("/get-University-Comments", async (req, res) => {
    let response=[];
    let b=await client.get("getuniversitycommentapi");
    if(b)
    {
        response=b;
    }
    else
    {
          const r = await commentController.getUniversityComments();
        await client.set("getuniversitycommentapi",JSON.stringify(r),'EX',3600*24);
        response=r;
    }





  res.send(response);




});

router.get("/get-Course-Comments", async (req, res) => {
    
    let response=[];
    
    let b=await client.get("getcoursecommentapi");
    
    if(b)
    {
        response=b;
    }
    else
    {
          const r = await commentController.getCourseComment();
          await client.set("getcoursecommentapi",JSON.stringify(r),'EX',3600*24);
          response=r;
    }
    
  res.send(response);

})
const storage = multer.diskStorage({
  destination: (req, file, cb) => {
    cb(null, 'assets/');
  },
  filename: (req, file, cb) => {
    cb(null, `${file.originalname}`);
  }
});

const upload = multer({ storage: storage });



router.post("/Save-Images", upload.array("image", 10), async (req, res) => {
    console.log("Memion");
    
  res.json(
    {
      Status: true
    }
  );

})


router.get("/Test", async (req, res) => {
  let a = [];

  // let b=`{${a.join()}}`;
  let b = `{${a.join()}}`
  res.send(a);

})


router.post("/Add-University", async (req, res) => {
client.del("getuniversityapi");
client.del("getsecondarydataapi");
client.del("gethomepageapi");
  const { Name, Established, about,
    fact,
    emi,
    admission, nip, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city, image, logo, video, fbLink, twitterLink, linkedin, instagram, smode, quesition, answer, feature, toc,
    active, urlname
    , TOCcontent,
    TOCH1, TOCH2, TOCH3, TOCH4, TOCH5,
    seotitle, seodescription,
    prospectus,
    Role

  } = req.body;


  let add = req.session.superusername;
  console.log("This is Added By");
  
console.log(req.session.superusername);

  if (add === null) {
    add = "LocalUser"
  }






  let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };

  let r = await universityController.addUniversity(
    Name,
    Established,
    about,
    fact,
    emi,
    admission,
    nip,
    officeMailId,
    approvedBy,
    courseType,
    stream,
    studyMode,
    UniversityType,
    WebsiteUrl,
    state,
    city,
    logo,
    image,
    video,
    fbLink,
    twitterLink,
    linkedin,
    instagram,
    smode,
    add,
    `{${quesition.join(',')}}`,  // Ensure questions are formatted properly
    `{${answer.join(',')}}`,     // Ensure answers are formatted properly
    feature,
    toc,
    active,
    urlname.trim(),
    seotitle,
    seodescription,
    formatArrayLiteral(TOCcontent),
    formatArrayLiteral(TOCH1),
    formatArrayLiteral(TOCH2),
    formatArrayLiteral(TOCH3),
    formatArrayLiteral(TOCH4),
    formatArrayLiteral(TOCH5),
    prospectus,
    Role
  );


  res.send(r);





})
router.post("/Update-University", async (req, res) => {

client.del("getuniversityapi");
client.del("getsecondarydataapi");
client.del("gethomepageapi");
  let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };
  const { Id, Name, Established, about,
    fact,
    emi,
    admission, nip, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city, image, logo, video, fbLink, twitterLink, linkedin, instagram, smode, quesiton, answer, feature, toc,
    active, urlname
    , TOCcontent,
    TOCH1, TOCH2, TOCH3, TOCH4, TOCH5,
    seotitle, seodescription,
    Role

  } = req.body;



  let add = req.session.superusername;
  let r = await universityController.UpdateUniversity(Id, Name, Established, about, fact, emi, admission, nip, officeMailId, approvedBy, courseType, stream, studyMode, UniversityType, WebsiteUrl, state, city, logo, image, `{}`, fbLink, twitterLink, linkedin, instagram, smode, add, quesiton, answer, feature, toc,
    active,
    urlname,
    seotitle,
    seodescription,
    TOCcontent,
    TOCH1,
    TOCH2,
    TOCH3,
    TOCH4,
    TOCH5,
    req.session.superusername,
    Role
  );
  res.send(r);






})


router.get("/delete-University", async (req, res) => {
    client.del("getuniversityapi");
    client.del("getsecondarydataapi");
client.del("gethomepageapi");
  const { Id } = req.query;

  let a = await universityController.deleteUniversity(Id, req.session.superusername);

  res.send(a);


});

router.get("/delete-Individual-Course", async (req, res) => {
    client.del("getindividualcourseapi");
        client.del("gethomepageapi");

  const { Id } = req.query;

  let a = await IndividualCourseController.deleteIndividualCourse(Id, req.session.superusername);



  res.send(a);


});






router.get("/delete-Course", async (req, res) => {
    client.del("getcourseapi");
        client.del("gethomepageapi");

  const { Id } = req.query;

  let a = await courseController.deleteCourse(Id, req.session.superusername);



  res.send(a);


});


router.get("/delete-User", async (req, res) => {
    client.del("getuserapi");
  const { Id } = req.query;

  let a = await userController.deleteUser(Id);

  res.send(a);




});
router.get("/delete-Blog", async (req, res) => {
    client.del("getblogapi");
        client.del("gethomepageapi");

  const { Id } = req.query;

  let a = await blogController.deleteBlog(Id,req.session.superusername);

  res.send(a);

});

router.get("/delete-Course-Faq", async (req, res) => {
    client.del("getcoursefaqapi");
  const { Id } = req.query;

  let a = await faqController.deleteCourseFaq(Id);

  res.send(a);

})



router.get("/delete-Blog-Faq", async (req, res) => {
    client.del("getblogfaqapi");
        client.del("gethomepageapi");

  const { Id } = req.query;

  let a = await faqController.deleteBlogeFaq(Id);

  res.send(a);

})


router.get("/delete-University-Faq", async (req, res) => {
    client.del("getuniversityfaqapi");
  const { Id } = req.query;

  let a = await faqController.deleteUniversityFaq(Id);

  res.send(a);

})



router.get("/delete-University-Comment", async (req, res) => {
    client.del("getuniversitycommentapi");
  const { Id } = req.query;

  let a = await commentController.deleteUniversityComment(Id);

  res.send(a);

})



router.get("/delete-Course-Comment", async (req, res) => {
    client.del("getcoursecommentapi");
    
  const { Id } = req.query;

  let a = await commentController.deleteCourseComment(Id);

  res.send(a);

});

router.get("/delete-Blog-Comment", async (req, res) => {
    client.del("getblogcommentapi");
  const { Id } = req.query;

  let a = await commentController.deleteBlogComment(Id);

  res.send(a);

});


router.get("/delete-Blog-Reviews", async (req, res) => {
    client.del("getblogreviewapi");
  const { Id } = req.query;

  let a = await reviewController.deleteBlogReview(Id);

  res.send(a);

});

router.get("/delete-University-Reviews", async (req, res) => {
    client.del("getuniversityreviewapi");
  const { Id } = req.query;

  let a = await reviewController.deleteUniversityReview(Id);

  res.send(a);

});

router.post("/get-Single-University", async (req, res) => {
  const { Id } = req.body;


  let a = await universityController.ParticularUniversity(Id);


  res.send(a);

});

router.post("/get-Single-University1", async (req, res) => {
  const { Id } = req.body;


  let a = await universityController.ParticularUniversity1(Id);


  res.send(a);

});

router.post("/get-Single-University-Review", async (req, res) => {
  const { Id } = req.body;

  let a = await reviewController.getSingleUniversityReview(Id);

  res.send(a);


})


router.post("/get-Single-Course-Review", async (req, res) => {
  const { Id } = req.body;

  let a = await reviewController.getSingleCourseReview(Id);

  res.send(a);


});


router.post("/get-Single-University-Comment", async (req, res) => {
  const { Id } = req.body;

  let a = await commentController.getSingleUniversityComment(Id);



  res.send(a);


});


router.post("/Update-Course-Reviews", async (req, res) => {
client.del("getcoursereviewapi");
  let add = "admin";

  const { id, rating, detail, user, course } = req.body;
  let a = await reviewController.UpdateCourseReview(rating, detail, user, course, add, id);

  res.send(a);



});

router.post("/get-Single-User", async (req, res) => {

  const { Id } = req.body;


  let a = await userController.getSingleUser(Id);


  res.send(a);




})

router.post("/Update-User", async (req, res) => {
    client.del("getuserapi");
  let add = "admin";
  const { id, Name, email, phone, city, state, country, gender, password
  } = req.body;



  let a = await userController.UpdateUser(
    Name,
    email,
    phone,
    city,
    state,
    country,
    gender,
    password,
    id, add

  );


  res.send(a);




})


router.post("/get-Single-Course-Faq", async (req, res) => {
  const { Id } = req.body;
  let a = await faqController.getSingleCourseFaq(Id);


  res.send(a);

});


router.post("/get-Single-University-Faq", async (req, res) => {
  const { Id } = req.body;
  let a = await faqController.getUniversityFaqByUniversityId(Id);


  res.send(a);

});


router.post("/get-Single-Blog-Faq", async (req, res) => {
  const { Id } = req.body;
  let a = await faqController.getSingleBlogFaq(Id);


  res.send(a);

});


router.post("/Update-Blog-Faq", async (req, res) => {
  let add = "admin"
  client.del("getblogfaqapi");
      client.del("gethomepageapi");

  const { id, topic, questions, answers } = req.body;
  const qa = `{${questions.join(',')}}`;
  const ans = `{${answers.join(',')}}`;


  let r = await faqController.UpdateBlogFaq(topic, qa, ans, add, id);

  res.send(r);



})


router.post("/Update-University-Faq", async (req, res) => {
    client.del("getuniversityfaqapi");
  let add = "admin"
  const { id, university, questions, answers } = req.body;
  const qa = `{${questions.join(',')}}`;
  const ans = `{${answers.join(',')}}`;


  let r = await faqController.UpdateUniversityFaq(university, qa, ans, add, id);

  res.send(r);



})


router.post("/Update-Course-Faq", async (req, res) => {
    client.del("getcoursefaqapi");
  let add = "admin"
  const { id, course, questions, answers } = req.body;
  const qa = `{${questions.join(',')}}`;
  const ans = `{${answers.join(',')}}`;


  let r = await faqController.UpdateCourseFaq(course, qa, ans, add, id);

  res.send(r);



})
router.post("/Update-University-Comment", async (req, res) => {
client.del("getuniversitycommentapi");
  let add = "admin";

  const { id, title, detail, university, username } = req.body;
  let a = await commentController.UpdateUniversityComment(title, detail, university, username, add, id);

  res.send(a);



});

router.post("/Update-Course-Comment", async (req, res) => {

  let add = "admin";
  client.del("getcoursecommentapi");
  

  const { id, title, detail, course, username } = req.body;
  let a = await commentController.UpdateCourseComment(title, detail, username, course, add, id);

  res.send(a);



});



router.get("/get-Secondary-Data", async (req, res) => {
  

let response=[];
let b=await client.get("getsecondarydataapi");
if(b)
{
    response=b;
}
else
{
      let a = await universityController.getUniversityByStudyMode('Online');
    await client.set("getsecondarydataapi",JSON.stringify(a),'EX',24*3600);
    response=a;
}


let r={
    universitylist:JSON.parse(b)
};
  res.send(r);
  

})
router.post("/get-Single-Course-Comment", async (req, res) => {
  const { Id } = req.body;

  let a = await commentController.getSingleCourseComment(Id);

  res.send(a);

})

router.get("/delete-Course-Reviews", async (req, res) => {
    client.del("getcoursereviewapi");
  const { Id } = req.query;

  let a = await reviewController.deleteCourseReview(Id);

  res.send(a);

});


router.post("/Add-Course", async (req, res) => {
    client.del("getcourseapi");
        client.del("gethomepageapi");

  let add = req.session.superusername;
  const { course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills,
    other,
    feature,
    active,
    toc,

    admission
    , year, month, fee, university, title, seoDescription, logo, mode, categorie, questions, answers

    , urlname,
    TOCH1,
    TOCH2,
    TOCH3,
    TOCH4,
    TOCH5

  } = req.body;





  let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };


  let r = await courseController.addCourse(course, courseDescription,
    detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills, other,
    feature,
    active,
    toc,
    admission, year, month, fee, `{${university.join(',')}}`, title, seoDescription, logo, mode, categorie, add, `{${questions.join(',')}}`, `{${answers.join(',')}}`, urlname

    ,


    formatArrayLiteral(TOCH1),
    formatArrayLiteral(TOCH2),
    formatArrayLiteral(TOCH3),
    formatArrayLiteral(TOCH4),
    formatArrayLiteral(TOCH5)
  );









  res.send(r);

})



router.post("/Add-Individual-Course", async (req, res) => {
    client.del("getindividualcourseapi");
        client.del("gethomepageapi");

  let add = req.session.superusername;
  const { course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills,
    other,
    feature,
    active,
    toc,

    admission
    , year, month, fee, title, seoDescription, logo, mode, categorie, questions, answers

    , urlname, TOCH1, TOCH2,
    TOCH3,
    TOCH4,
    TOCH5,Role

  } = req.body;




  console.log(req.body);






  let r = await IndividualCourseController.addIndividualCourse(course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills, other,
    feature,
    active,
    toc,
    admission, year, month, fee, title, seoDescription, logo, mode, categorie, add, `{${questions.join(',')}}`, `{${answers.join(',')}}`, urlname

    ,

    TOCH1,
    TOCH2,
    TOCH3,
    TOCH4,
    TOCH5,
    Role
  );

  res.send(r);










})






router.post("/Course-Filter", async (req, res) => {
  let a = await courseController.FilterCourse(req.body.column, req.body.value);

  res.send(a);




});


router.post("/Individual-Course-Filter", async (req, res) => {
  let a = await IndividualCourseController.FilterIndividualCourse(req.body.column, req.body.value);

  res.send(a);




});


router.post("/Blog-Filter", async (req, res) => {
  let a = await blogController.FilterBlog(req.body.column, req.body.value);


  res.send(a);

});


router.get("/get-University-By-Course-Name", async (req, res) => {
  let a = await courseController.getUniversityByCourseName(req.query.name);


  res.send(a);



})




router.get("/get-Specialization-By-Course-Name", async (req, res) => {
  let a = await courseController.getSpecializationByCourseName(req.query.name);


  res.send(a);



});

router.get("/get-Book-By-Specialization", async (req, res) => {
  let a = await bookController.getBookBySpecializationByCourseName(req.query.name);


  res.send(a);

})







router.post("/Update-Individual-Course", async (req, res) => {
        client.del("gethomepageapi");

    client.del("getindividualcourseapi");
  let add = req.session.superusername;
  
  let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };
  const { id, course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills,
    other,
    feature,
    active,
    toc,

    admission
    , year, month, fee, title, seoDescription, image, mode, categorie, questions, answers

    , urlname, TOCH1, TOCH2,
    TOCH3,
    TOCH4,
    TOCH5,
    Role

  } = req.body;






  let r = await IndividualCourseController.UpdateIndividualCourse(id, course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills, other,
    feature,
    active,
    toc,
    admission, year, month, fee, title, seoDescription, image, mode, categorie, req.session.supername, `{${questions.join(',')}}`, `{${answers.join(',')}}`, urlname

    ,

    formatArrayLiteral(TOCH1),
    formatArrayLiteral(TOCH2),
    formatArrayLiteral(TOCH3),
    formatArrayLiteral(TOCH4),
    formatArrayLiteral(TOCH5),

    req.session.superusername,
    Role
  );










  res.send(r);










})












router.post("/Update-Course", async (req, res) => {
    
    
    client.del("getcourseapi");
        client.del("gethomepageapi");

  let add = "admin";
  const { id, course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills,
    other,
    feature,
    active,
    toc,

    admission
    , year, month, fee, university, title, seoDescription, image, mode, categorie, questions, answers

    , urlname,
    TOCH1, TOCH2,
    TOCH3,
    TOCH4,
    TOCH5

  } = req.body;


 

  let r = await courseController.UpdateCourse(id, course, courseDescription, detailcourseDescription,
    whyCourse,
    whoPursueCourse,
    WhenToDoCourse,
    keyHighCourse,
    eligibility,
    skills, other,
    feature,
    active,
    toc,
    admission, year, month, fee, `{${university.join(',')}}`, title, seoDescription, image, mode, categorie, req.session.supername, `{${questions.join(',')}}`, `{${answers.join(',')}}`, urlname

    ,

    `{${TOCH1.join(',')}}`,
    `{${TOCH2.join(',')}}`,
    `{${TOCH3.join(',')}}`,
    `{${TOCH4.join(',')}}`,
    `{${TOCH5.join(',')}}`,
    req.session.superusername
  );

  res.send(r);

})


router.post("/Add-Blog", async (req, res) => {
client.del("getblogapi");
    client.del("gethomepageapi");

  let add = req.session.superusername;
  const { pageName, seoTitle, seoDescription, tags, status, topic, image, content, question, answers, feature, toc, active,
    layout


    , urlname,
    TOCH1,
    TOCH2,
    TOCH3,
    TOCH4,
    TOCH5,
    Role
  } = req.body;



  let escapeHtmlString = (str) => {
    if (typeof str === 'string') {
      return str.replace(/"/g, '\\"');
    }
    return str;
  };

  let formatArrayLiteral = (arr) => {
    return `{${arr.map(item => `"${escapeHtmlString(item)}"`).join(',')}}`;
  };



  let b = await blogController.addBlog(pageName, seoTitle, seoDescription, tags, status, topic, image, 
  content, add, `{${question.join(',')}}`, `{${answers.join(',')}}`, feature, toc, active,

    urlname,
    formatArrayLiteral(TOCH1),
    formatArrayLiteral(TOCH2),
    formatArrayLiteral(TOCH3),
    formatArrayLiteral(TOCH4),
    formatArrayLiteral(TOCH5),

    layout,
    Role
  );


  res.send(b);


}
)

router.get("/get-University", async (req, res) => {


let response=[];
let b=await client.get("getuniversityapi");

if(b)
{
    response=b;
    
}
else
{
  let r = await universityController.getUniversity();
  await client.set("getuniversityapi",JSON.stringify(r),'EX', 3600);
  response=r;
  
      
}



    res.send(response);
    
});

router.get("/get-University1", async (req, res) => {

  let r = await universityController.getUniversity1();



  res.send(r)
});
router.get("/get-Request-University", async (req, res) => {
  let a = await universityController.getRequestUniversity();
  res.send(a);
})
router.get("/get-Blog", async (req, res) => {
    let response=[];
    let b=await client.get("getblogapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let r = await blogController.getBlog();
        response=r;
        await client.set("getblogapi",JSON.stringify(r),'EX',3600*24);
    }
  


  res.send(response);
  

})


router.get("/get-Course", async (req, res) => {
    
    
    let response=[];
    let a=await client.get("getcourseapi");
    if(a)
    {
        response=a;
    }
    else
    {
         let r = await courseController.getCourse();
         await client.set("getcourseapi",JSON.stringify(r),'EX',3600*24);
         
         response=r;
    }
 

  res.send(response);
  

});


router.get("/get-Individual-Course", async (req, res) => {
    
    let response=[];
    let b=await client.get("getindividualcourseapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let r = await IndividualCourseController.getIndividualCourse();
        response=r;
        await client.set("getindividualcourseapi",JSON.stringify(r),'EX',3600*24);
    }


  res.send(response);

});

const requireLogin = (req, res, next) => {
  if (req.session.username) {

    next();
  } else {

    res.json(
      {
        Status: false
      }
    );

  }
};



router.post("/User-Login", async (req, res) => {
  const { email, password } = req.body;


  let a = await userController.Login(email, password);




  if (a.Status) {
    req.session.username = email;
    req.session.fname = a.name;

    res.json(
      {
        Status: true
      }
    );


  }
  else {
    res.json(
      {
        Status: false
      }
    )

  }



})





router.get('/dashboard', requireLogin, async (req, res) => {
  res.json(
    {
      Status: true,
      username: req.session.username,
      fname: req.session.fname
    }
  );
});

router.post('/logout', (req, res) => {
  const usernameToDestroy = req.session.username; // Get the username from the session
  if (usernameToDestroy) {
    const sessionStore = req.sessionStore;
    sessionStore.all((err, sessions) => {
      if (err) {
        console.error('Error fetching sessions:', err);
        res.status(500).send('Error fetching sessions');
        return;
      }

      let sessionDestroyed = false;
      for (const sessionId in sessions) {
        const sessionData = sessions[sessionId];
        if (sessionData && sessionData.username === usernameToDestroy) {
          sessionStore.destroy(sessionId, (err) => {
            if (err) {
              console.error('Error destroying session:', err);
              res.status(500).send('Error destroying session');
            } else {
              sessionDestroyed = true;
              res.send(`Session for ${usernameToDestroy} destroyed`);
            }
          });
          break; // Exit loop after destroying the session
        }
      }

      if (!sessionDestroyed) {
        res.send(`Session for ${usernameToDestroy} not found`);
      }
    });
  } else {
    res.status(400).send('No username found in session');
  }
});










// router.post('/logout', (req, res) => {

//   req.session.destroy((err) => {
//     if (err) {
//       console.error(err);
//       res.status(500).send('Internal Server Error');
//     } else {
//       res.send('Your Successfully Logout');
//     }
//   });
// });


router.get("/get-User-Detail", async (req, res) => {
  let a = await userController.getUserDetail(req.query.email);


  res.send(a);

})
router.post("/Add-User", async (req, res) => {

client.del("getuserapi");
  let add = req.session.superusername;












  const { Name, email, phone, city, dob, state, country, gender, password, role } = req.body;

  req.session.username = email;
  req.session.fname = Name;


  // const salt = await bcrypt.genSalt(saltRounds);
  // const hashedPassword = await bcrypt.hash(password, salt);


  const hashedPassword = password;

  if (role === undefined) {
    const r = await userController.addUser(Name, email, phone, city, dob, state, country, gender, hashedPassword, add);


    res.json({
      Status: true,
      username: req.session.username
    });

  }
  else {

    let courseId = 0;

    let rr = (await p.query("select id from course where courename='" + state + "' limit 1")).rows;
    rr.forEach((d) => {
      courseId = d.id;

    });
    const r = await userController.addUser(Name, email, phone, city, dob, courseId, country, gender, hashedPassword, add);


    res.json({
      Status: true,
      username: req.session.username
    });
  }

});

router.get("/get-User", async (req, res) => {
    let response=[];
    let b=await client.get("getuserapi");
    if(b)
    {
        response=b;
    }
    else
    {
          const r = await userController.getUser();
        await client.set("getuserapi",JSON.stringify(r),'EX',3600*24);
        response=r;
    }


  res.send(response);

});

router.post("/Add-News", upload.single("logoUrl"), async (req, res) => {

  let add = "admin";

  const { title, description, logo } = req.body;

  const r = await newsController.addNews(title, description, logo, add);



  res.send(r);

});

router.get("/get-News", async (req, res) => {
  const r = await newsController.getNews();

  res.send(r);

});

router.post("/Add-Course-Faq", async (req, res) => {

client.del("getcoursefaqapi");
  const { course, questions, answers } = req.body;


  const add = req.session.superusername;

  const q = `{${questions.join(',')}}`;
  const a = `{${answers.join(',')}}`;

  const r = await faqController.addCourseFaq(course, q, a, add);


  res.send(r);

});



router.post("/Add-University-Faq", async (req, res) => {

client.del("getuniversityfaqapi");
  const { university, questions, answers } = req.body;


  const add = req.session.superusername;

  const q = `{${questions.join(',')}}`;
  const a = `{${answers.join(',')}}`;

  const r = await faqController.addUniversityFaq(university, q, a, add);


  res.send(r);






});

router.post("/Add-Blog-Faq", async (req, res) => {

client.del("getblogfaqapi");
    client.del("gethomepageapi");


  const { topic, questions, answers } = req.body;


  const add = req.session.superusername;

  const q = `{${questions.join(',')}}`;
  const a = `{${answers.join(',')}}`;

  const r = await faqController.addBlogFaq(topic, q, a, add);


  res.send(r);



});

router.get("/get-Blog-Faq", async (req, res) => {
    
    
    let response=[];
    let b=await client.get("getblogfaqapi");
    if(b)
    {
        response=b;
    }
    else
    {
  let r = await faqController.getBlogFaq();
  await client.set("getblogfaqapi",JSON.stringify(r),'EX',3600*24);
  response=r;
    }
    
  res.send(response);

})


router.get("/get-Course-Faq", async (req, res) => {
    
    let response=[];
    
    let b=await client.get("getcoursefaqapi");
    if(b)
    {
        response=b;
    }
    else
    {
         const r = await faqController.getCourseFaq();
        response=r;
        
        await client.set("getcoursefaqapi",JSON.stringify(r),'EX',3600*24);
    }
 


  res.send(response);

});
router.post("/University-Filter", async (req, res) => {
  
  let a = await universityController.UniversityFilter(req.body.column, req.body.value);


  res.send(a);


});


router.post("/get-University-About", async (req, res) => {
  let a = await universityController.UniversityForAbout(req.body.column, req.body.comp, req.body.value);

  res.send(a);


})


router.post("/get-Course-About", async (req, res) => {
  let a = await courseController.CourseForAbout(req.body.column, req.body.comp, req.body.value);

  res.send(a);


})

router.post("/Add-Leads", async (req, res) => {
     client.del("getleadapi");
  const { id,
    fname,
    email,
    phone,
    course,
    city,
    message } = req.body;
  let a = await LeadController.Add(id,
    fname,
    email,
    phone,
    course,
    city,
    message);


  res.send(a);

})

router.get("/get-Leads", async (req, res) => {
    let response=[];
    let b=await client.get("getleadapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await LeadController.getLeads();
        response=a;
        await client.set("getleadapi",JSON.stringify(a),'EX',3600*24);
    }


  res.send(response);

});
router.get("/delete-Lead", async (req, res) => {
    client.del("getleadapi");
    
  let a = await LeadController.deleteLead(req.query.Id);


  res.send(a);

})
router.post("/Filter-Lead", async (req, res) => {
  const { column, value } = req.body;
  let a = await LeadController.FilterLead(column, value);


  res.send(a);

})

router.get("/get-University-Faq", async (req, res) => {
    let response=[];
    let b=await client.get("getuniversityfaqapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let r = await faqController.getUniversityFaq();
        await client.set("getuniversityfaqapi",JSON.stringify(r),'EX',3600*24);
        response=r;
    }


  res.send(response);

})

router.post("/Add-Super-User", async (req, res) => {
        client.del("gethomepageapi");

    client.del("getsuperuserapi");
  const { Name,
    email,
    username,
    password,
    designation,
    specialization,
    about,
    gender,
    fb,
    linkd,
    profile,
    permission,
    access,
    active
  } = req.body;
  let add = req.session.superusername;


  let r = await superuserController.addSuperUser(Name,
    email,
    username,
    password,
    designation,
    specialization,
    about,
    gender,
    fb,
    linkd,
    profile,
    permission,
    access,
    add,
    active

  );





  res.send(r);


})


router.post("/Update-Super-User", async (req, res) => {
        client.del("gethomepageapi");
    client.del("getsuperuserapi");

  const { Id, name,
    email,
    username,
    password,
    designation,
    specialization,
    about,
    gender,
    fb,
    linkd,

    permission,
    access,
    profile,
    active

  } = req.body;
  let add = req.session.superusername;

  console.log(req.body);




  let a = await superuserController.UpdateSuperUser(Id, name,
    email,
    username,
    password,
    designation,
    specialization,
    about,
    gender,
    fb,
    linkd,

    permission,
    access,
    add,
    profile,
    active
  );



  res.send(a);


})



router.post("/Particular-Alumni", async (req, res) => {
  let a = await alumniController.getSingleAlumni(req.body.Id);

  res.send(a);

});


router.post("/Update-Alumni", async (req, res) => {
    client.del("gethomepageapi");

client.del("getalumniapi");

  let a = await alumniController.UpdateAlumni(req.body.Id, req.body.name, req.body.Image);

  res.send(a);


})


router.get("/delete-Staff", async (req, res) => {
        client.del("getstaffapi");
            client.del("gethomepageapi");

  let a = await staffController.deleteStaff(req.query.Id);

  res.send(a);

});

router.post("/Particular-Staff", async (req, res) => {
  let a = await staffController.ParticularStaff(req.body.Id);

  res.send(a);
});


router.post("/Update-Staff", async (req, res) => {
    client.del("gethomepageapi");

    client.del("getstaffapi");
  const { Id,

    name,
    q,

    exp,

    d,
    image,
    rating
  } = req.body;





  let a = await staffController.UpdateStaff(Id,

    name,
    q,

    exp,

    d,
    req.session.superusername,
    image,
    rating
  );


  res.send(a);


})
router.get("/get-Super-Users", async (req, res) => {
 

let response=[];
let b=await client.get("getsuperuserapi");

if(b)
{
    response=b;
}
else
{
    
    let a = await superuserController.getSuperUser();
     await client.set("getsuperuserapi",JSON.stringify(a),'EX',3600*24);
     response=a;
     
}
 
res.send(response);


})


router.get("/delete-Super-User", async (req, res) => {
    
   client.del("getsuperuserapi");
       client.del("gethomepageapi");

   let a = await superuserController.deleteSuperUser(req.query.Id);
   res.send(a);

});


router.post("/get-Particular-Super-User", async (req, res) => {
  let a = await superuserController.ParticularSuperUser(req.body.Id);


  res.send(a);

})
const verifyToken = (req, res, next) => {
  const token = req.headers['authorization'];

  if (!token) {
    return res.status(403).json({ message: 'Token required' });
  }

  jwt.verify(token, SECRET_KEY, (err, decoded) => {
    if (err) {
        console.log("Invalid Token11");
      return res.status(401).json({ message: 'Invalid token' });
    }
    req.user = decoded;  
    next();
  });
};


// router.get('/super-user-dashboard', verifyToken, async (req, res) => {
//   try {
//     const userId = req.user.id;
//     console.log("I am for Logout");
//     console.log(userId);
    
//     req.session.superusername=req.user.id;
    
// console.log(req.user.id);
// console.log("This is Users")

//   let p=await  redisClient.get(`permissions:${userId}`)

//       res.send(JSON.parse(p));
    
//   } catch (error) {
//     console.error('Dashboard error:', error);
//     res.status(500).json({ message: 'Server error' });
//   }
// });

// router.post("/Super-User-Login", async (req, res) => {
//   const { username, password } = req.body;

//   try {
//     let userData = await superuserController.Login(username, password);

//     if (userData.Status) {
//   req.session.superuser=userData.UserId;
   
   
//       const token = jwt.sign(
//         {
//           id: userData.UserId,
//           name: userData.Name,
//           roles: userData.Roles, 
//         },
//         SECRET_KEY,
//         { expiresIn: TOKEN_EXPIRATION }
//       );
   

//      req.session.superusername=userData.UserId;
     
//      console.log("This is Superuser Id");
     
//      console.log(req.session.superusername);
     
//      let zz=await redisClient.get(`permissions:${userData.UserId}`)
//      if(!zz)
//      {
//           redisClient.set(
//         `permissions:${userData.UserId}`,
//      JSON.stringify(
//           {
//             Name:userData.Name,
//             Status:true,
//           Profile:userData.Profile,
//             UserId: userData.UserId,
//           University: userData.University,
//           Course: userData.Course,
//           Blog: userData.Blog,
//           Specialization: userData.Specialization,
//           Users: userData.Users,
//           Student: userData.Student,
//           Subject: userData.Subject,
//           Book: userData.Book,
//           Review: userData.Review,
//           Comment: userData.Comment,
//           Faq: userData.Faq,
//           Lead: userData.Lead,
//           Menu: userData.Menu,
//           Header: userData.Header,
//           CTA: userData.CTA,
//           IndividualCourse: userData.IndividualCourse,
//           AcademicSpecialization: userData.AcademicSpecialization,
//           AutoBackup: userData.AutoBackup,
//           UniversityRequest: userData.UniversityRequest,
//           SocialMedia: userData.SocialMedia,
//           HomeFaq: userData.HomeFaq,
//           Job: userData.Job,
//           JobResponse: userData.JobResponse,
//           OneStep: userData.OneStep,
//           Banner: userData.Banner,
//           Add: userData.Add,
//           Edit: userData.Edit,
//           View: userData.View,
//           UserActivity: userData.UserActivity,
//           Staff: userData.Staff,
//           Alumni: userData.Alumni,
//           Footer: userData.Footer,
//           Delete: userData.Delete,
//           Export: userData.Export
//         }),
//         'EX', 3600*24 
//       );
 
//      }
    
   
//       res.json({
//         Status: true,
//         token: token
//       });
//     } else {
//       res.json({ Status: false, message: 'Invalid credentials' });
//     }
//   } catch (error) {
//     console.error('Login error:', error);
//     res.status(500).json({ Status: false, message: 'Server error' });
//   }
// });

router.post("/Super-User-Login", async (req, res) => {
  const { username, password } = req.body;


  let a = await superuserController.Login(username, password);


  



  if (a.Status) {
    req.session.superusername = a.UserId;
    req.session.supername = a.Name;
    req.session.Profile = a.Profile,

      req.session.University = a.University;
    req.session.Course = a.Course;
    req.session.Blog = a.Blog;

    req.session.Specialization = a.Specialization;
    req.session.Users = a.Users;
    req.session.Student = a.Student;
    req.session.Subject = a.Subject;
    req.session.Book = a.Book;
    req.session.Review = a.Review;
    req.session.Comment = a.Comment;
    req.session.Faq = a.Faq;
    req.session.Lead = a.Lead;
    req.session.Menu = a.Menu;

    req.session.Header = a.Header;
    req.session.CTA = a.CTA;
    req.session.IndividualCourse = a.IndividualCourse;
    req.session.AcdemicSpecialization = a.AcademicSpecialization;
    req.session.AutoBackup = a.AutoBackup;
    req.session.UniversityRequest = a.UniversityRequest;
    req.session.SocialMedia = a.SocialMedia;
    req.session.HomeFaq = a.HomeFaq;
    req.session.Job = a.Job;
    req.session.JobResponse = a.JobResponse;
    req.session.OneStep = a.OneStep;
    req.session.Banner = a.Banner;



    req.session.Add = a.Add;
    req.session.Edit = a.Edit;
    req.session.View = a.View;
    req.session.UserActivity = a.UserActivity;
    req.session.Staff = a.Staff;
    req.session.Alumni = a.Alumni;
    req.session.Footer = a.Footer;
    req.session.Delelte = a.Delete;
    req.session.Export = a.Export;







    res.json(
      {
        Status: true
      }
    );


  }
  else {
    res.json(
      {
        Status: false
      }
    )

  }



});
router.get('/super-user-dashboard', requireLogin1, async (req, res) => {
  res.json(
    {

      Status: true,
      UserId: req.session.superusername,
      Name: req.session.supername,
      Profile: req.session.Profile,

      University: req.session.University,
      Course: req.session.Course,
      Blog: req.session.Blog,
      Menu: req.session.Menu,

      Specialization: req.session.Specialization,
      Users: req.session.Users,
      Student: req.session.Student,
      Subject: req.session.Subject,
      Book: req.session.Book,
      Review: req.session.Review,
      Comment: req.session.Comment,
      Faq: req.session.Faq,
      Lead: req.session.Lead,
      Add: req.session.Add,
      Edit: req.session.Edit,
      View: req.session.View,
      UserActivity: req.session.UserActivity,
      Staff: req.session.Staff,
      Alumni: req.session.Alumni,
      Footer: req.session.Footer,
      Delete: req.session.Delelte,
      Export: req.session.Export,
      Header: req.session.Header,
      CTA: req.session.CTA,
      IndividualCourse: req.session.IndividualCourse,
      AcademicSpecialization: req.session.AcdemicSpecialization,
      AutoBackup: req.session.AutoBackup,
      UniversityRequest: req.session.UniversityRequest,
      SocialMedia: req.session.SocialMedia,
      HomeFaq: req.session.HomeFaq,
      Job: req.session.Job,
      JobResponse: req.session.JobResponse,
      OneStep: req.session.OneStep,
      Banner: req.session.Banner = req.session.Banner



    }
  );
});



router.get("/delete-Alumni", async (req, res) => {
    client.del("getalumniapi");
        client.del("gethomepageapi");

  let a = await alumniController.deleteAlumni(req.query.Id);

  res.send(a);
});


router.get("/delete-Footer", async (req, res) => {
    client.del("getfooterapi");
  let a = await footerController.deleteFooter(req.query.Id);

  res.send(a);

})
router.post('/admin-logout', async (req, res) => {
let pp=await p.query("update prevuserlogs set status='Logout' where username='"+req.session.superusername+"'");
console.log(session.userloginId);
// delete session.userloginId;
  let xx = `INSERT INTO public.userlogs(
    username, status)
   VALUES ($1,$2)`;
  let yy = [req.session.superusername, "Logout"];
  let zz = await p.query(xx, yy);
  console.log("dfsdf");

  delete req.session.superuserprofile;
  delete req.session.superusername;
  delete req.session.superuserpermission;
  delete req.session.superuseraccess;
  delete req.session.supername;



  req.session.destroy((err) => {
    if (err) {
      console.error('Error destroying session:', err);
      res.status(500).send('Error destroying session');
    } else {
      res.json(
        {
          Status: true
        }
      )
    }
  });
});



router.post("/Add-api-Staff", async (req, res) => {
    client.del("getstaffapi");
    client.del("gethomepageapi");

  let r = await staffController.addStaff(req.body.name, req.body.exp, req.body.q, req.body.logo, req.session.superusername, req.body.d,req.body.rating);

  res.send(r);


})

router.get("/get-Staff", async (req, res) => {
    let response=[];
    let b=await client.get("getstaffapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await staffController.getStaff();
        await client.set("getstaffapi",JSON.stringify(a),'EX',3600*24);
        response=a;
        
    }



  res.send(response);

})

router.post("/Add-Alumni", async (req, res) => {
    
    client.del("getalumniapi");
        client.del("gethomepageapi");

  let a = await alumniController.addAlumni(req.body.name, req.body.Image, req.session.superusername);

  res.send(a);


});

router.get("/get-Alumni", async (req, res) => {
    
    let response=[];
    
    let b=await client.get("getalumniapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await alumniController.getAlumni();
        await client.set("getalumniapi",JSON.stringify(a),'EX',3600*24);
        response=a;
        
    }
  
  res.send(response);

});


router.post("/Add-Footer", async (req, res) => {

client.del("getfooterapi");
  const { work, t, distancemba,
    ugcourse,
    bestcollege,
    aboutwebsite,
    playstore,
    appstore,
    facebook,
    twitter,
    instagram,
    linkedin,
    youtube,

    contactus,
    qr,
    tagline,
    tollno,
    Reserved



  } = req.body;

  let a = await footerController.addFooter(work, t, distancemba,
    ugcourse,
    bestcollege,
    aboutwebsite,
    playstore,
    appstore,
    facebook,
    twitter,
    instagram,
    linkedin,
    youtube,

    contactus,
    qr,
    req.session.superusername,
    tagline,
    tollno,
    Reserved
  );


  


  res.send(a);




});


router.get("/get-Footer", async (req, res) => {
    let response=[];
    let b=await client.get("getfooterapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await footerController.getFooter();
          response=a;
        await client.set("getfooterapi",JSON.stringify(a),'EX',3600*24);
    }


  res.send(response);




});
router.get("/get-Total-Dashboard-Detail", async (req, res) => {
  let a = await dashboardController.getTotalData();

  res.send(a);

})
router.get("/get-Footer1", async (req, res) => {
  let a = await footerController.getFooter();


  res.send(a);





});
router.post("/get-Author", async (req, res) => {
  let a = await authorController.getPrimaryDetail(req.body.Id);

  res.send(a);

});
router.post("/get-Author1", async (req, res) => {
  let a = await authorController.getPrimaryDetail1(req.body.Id);

  res.send(a);

});
router.get("/get-University-Activity", async (req, res) => {

  let response=await useractivityController.getUniversityActivity();
//   let b=await client.get("getuniversityactivityapi");
//   if(b)
//   {
//       response=b;
//   }
//   else
//   {
//         let a = await useractivityController.getUniversityActivity();
//       await client.set("getuniversityactivityapi",JSON.stringify(a),'EX',3600*24);
//       response=a;
//   }

  res.send(response);

});

router.get("/get-Course-Activity", async (req, res) => {
  let a = await useractivityController.getCourseActivity();

  res.send(a);

})


router.get("/get-Specialization-Activity", async (req, res) => {
  let a = await useractivityController.getSpecializationActivity();

  res.send(a);

})

router.post("/get-Author-Full-Detail", async (req, res) => {
  let a = await authorController.getAuthorFullDetail(req.body.Id);
  res.send(a);

})

router.post("/get-Particular-Footer", async (req, res) => {
  let a = await footerController.getSingleFooter(req.body.Id);

  res.send(a);

});


router.post("/Update-Footer", async (req, res) => {
    client.del("getfooterapi");
  let {
    Id,
    distancemba,
    ugcourse,
    bestcollege,
    work,
    aboutwebsite,
    playstore,
    appstore,
    facebook,
    twitter,
    instagram,
    linkedin,
    youtube,
    qr,
    contactus,
    trust,
    tagline,
    tollno,
    Reserved


  } = req.body;








  let a = await footerController.UpdateFooter(
    Id,
    distancemba,
    ugcourse,
    bestcollege,
    work,
    trust,
    aboutwebsite,
    playstore,
    appstore,
    facebook,
    twitter,
    instagram,
    linkedin,
    youtube,
    contactus,
    qr,
    req.session.superusername,
    tagline,
    tollno,
    Reserved
  );

  res.send(a);
})


router.post("/Add-Country", async (req, res) => {
    client.del("getcountryapi");
    
  const { name, status } = req.body;


  let a = await countryController.addCountry(name, status, req.session.superusername);

  res.send(a);


});

router.get("/get-Country", async (req, res) => {
    
    let response=[];
    let b=await client.get("getcountryapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await countryController.getCountry();
        response=a;
      await client.set("getcountryapi",JSON.stringify(a),'EX',3600*24);
      
    }
  

  res.send(a);

});

router.post("/get-Particular-Country", async (req, res) => {
  let a = await countryController.getParticularCountry(req.body.Id);

  res.send(a);

});

router.post("/Update-Country", async (req, res) => {
    client.del("getcountryapi");
  const { Id, name, status } = req.body;

  let a = await countryController.UpdateCountry(Id, name, status, req.session.superusername);

  res.send(a);


})

router.get("/delete-Country", async (req, res) => {
    client.del("getcountryapi");
  let a = await countryController.deleteCountry(req.query.Id);
  res.send(a);

});


router.post("/Add-State", async (req, res) => {
    client.del("getstateapi");
  const { name, country } = req.body;





  let a = await stateController.addState(name, country, req.session.superusername);

  res.send(a);



});

router.get("/get-State", async (req, res) => {
let response=[];
let b=await client.get("getstateapi");
if(b)
{
    response=b;
}
else
{
      let a = await stateController.getState();
    await client.set("getstateapi",JSON.stringify(a),'EX',3600*24);
    response=a;
}


  res.send(response);

});

router.post("/get-Single-State", async (req, res) => {
  let a = await stateController.ParticularState(req.body.Id);

  res.send(a);

})

router.post("/Update-State", async (req, res) => {
    client.del("getstateapi");
  const { Id, name, country } = req.body;

  let a = await stateController.UpdateState(Id, name, country, req.session.superusername);

  res.send(a);


})



router.get("/delete-State", async (req, res) => {
    client.del("getstateapi");
  let a = await stateController.deleteState(req.query.Id);
  res.send(a);

});




router.post("/Add-City", async (req, res) => {
    client.del("getcityapi");
    
  const { name, state } = req.body;

  let a = await cityController.addCity(name, state, req.session.superusername);

  res.send(a);

});

router.get("/get-City", async (req, res) => {
    
    let response=[];
    let b=await client.get("getcityapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await cityController.getCity();
        await client.set("getcityapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

});


router.post("/get-Single-City", async (req, res) => {
  let a = await cityController.getSingleCity(req.body.Id);

  res.send(a);

});
router.post("/Update-City", async (req, res) => {
    client.del("getcityapi");
    
  const { Id, name, state } = req.body;

  let a = await cityController.UpdateCity(Id, name, state, req.session.superusername);

  res.send(a);



})

router.get("/delete-City", async (req, res) => {
    client.del("getcityapi");
    
  let a = await cityController.deleteCity(req.query.Id);

  res.send(a);

});
router.post("/Add-Stream", async (req, res) => {

client.del("getstreamapi");
  const { name, status, streammenu } = req.body;



  let a = await streamController.addStream(name, status, streammenu, req.session.superusername);

  res.send(a);



});
router.get("/get-Stream", async (req, res) => {
    let response=[];
    let b=await client.get("getstreamapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await streamController.getStream();
        await client.set("getstreamapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

});
router.post("/get-Single-Stream", async (req, res) => {
  let a = await streamController.getSingleStream(req.body.Id);

  res.send(a);

});

router.post("/Update-Stream", async (req, res) => {
client.del("getstreamapi");
  const { Id, name, status, streammenu } = req.body;

  let a = await streamController.UpdateStream(Id, name, status, streammenu, req.session.superusername);

  res.send(a);

})
router.get("/delete-Stream", async (req, res) => {
    client.del("getstreamapi");
  let a = await streamController.deleteStream(req.query.Id);

  res.send(a);

});

router.post("/Add-Approved", async (req, res) => {
    client.del("getapprovedapi");
  const { name, status } = req.body;

  let a = await approvedController.addApproved(name, status, req.session.superusername);

  res.send(a);

});

router.get("/get-Approved", async (req, res) => {
    
    let response=[];
    
    let b=await client.get("getapprovedapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await approvedController.getApproved();
        await client.set("getapprovedapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }
  
  res.send(response);

});

router.post("/get-Single-Approved", async (req, res) => {
  let a = await approvedController.getSingleApproved(req.body.Id);
  res.send(a);

});

router.post("/Update-Approved", async (req, res) => {
    client.del("getapprovedapi");
  const { Id, name, status } = req.body;
  let a = await approvedController.UpdateApproved(Id, name, status, req.session.superusername);
  res.send(a);

})

router.get("/delete-Approved", async (req, res) => {
  let a = await approvedController.deleteApproved(req.query.Id);
  res.send(a);

});

router.post("/Add-Course-Type", async (req, res) => {
    client.del("getcoursetypeapi");
    
  const { name, status } = req.body;

  let a = await courseTypeController.addCourseType(name, status, req.session.superusername);

  res.send(a);

});

router.get("/get-Course-Type", async (req, res) => {
    let response=[];
    let b=await client.get("getcoursetypeapi");
    if(b)
    {
        response=b;
    }
    else
    {
  let a = await courseTypeController.getCourseType();        
        response=a;
        await client.set("getcoursetypeapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});
router.post("/get-Single-Course-Type", async (req, res) => {
  let a = await courseTypeController.getSingleCourseType(req.body.Id);

  res.send(a);


});

router.post("/Update-Course-Type", async (req, res) => {
    client.del("getcoursetypeapi");
  const { Id, name, status } = req.body;
  let a = await courseTypeController.UpdateCourseType(Id, name, status, req.session.superusername);
  res.send(a);

})


router.get("/delete-CourseType", async (req, res) => {
  let a = await courseTypeController.deleteCourseType(req.query.Id);

  res.send(a);


});


router.post("/Add-Course-Duration", async (req, res) => {
    client.del("getcoursedurationapi");
    
  const { name, status } = req.body;

  let a = await courseDurationController.addCourseDuration(name, status, req.session.superusername);

  res.send(a);

});

router.get("/get-Course-Duration", async (req, res) => {
    let response=[];
    let b=await client.get("getcoursedurationapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await courseDurationController.getCourseDuration();
        response=a;
        await client.set("getcoursedurationapi",JSON.stringify(a),'EX',3600*24);
    }
  
  res.send(response);


});
router.post("/get-Single-Course-Duration", async (req, res) => {
  let a = await courseDurationController.getSingleCourseDuration(req.body.Id);
  res.send(a);

});

router.post("/Update-Course-Duration", async (req, res) => {
    client.del("getcoursedurationapi");
    
  const { Id, name, status } = req.body;


  let a = await courseDurationController.UpdateCourseDuration(Id, name, status, req.session.superusername);

  res.send(a);

})
router.get("/delete-Course-Type", async (req, res) => {
    client.del("getcoursetypeapi");
  let a = await courseDurationController.deleteCourseDuration(req.query.Id);

  res.send(a);

});

router.post("/Add-University-Type", async (req, res) => {
    client.del("getuniversitytypeapi");
  const { name, status } = req.body;

  let a = await universitytypeController.addUniversityType(name, status, req.session.superusername);

  res.send(a);


});

router.get("/get-University-Type", async (req, res) => {
    let response=[];
    let b=await client.get("getuniversitytypeapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await universitytypeController.getUniversityType();
        response=a;
        await client.set("getuniversitytypeapi",JSON.stringify(a),'EX',3600*24);
        
    }
  res.send(response);

});
router.post("/get-Single-University-Type", async (req, res) => {
  let a = await universitytypeController.getSingleUniversityType(req.body.Id);

  res.send(a);

});

router.post("/Update-University-Type", async (req, res) => {
    client.del("getuniversitytypeapi");
  const { Id, name, status } = req.body;

  let a = await universitytypeController.UpdateUniversityType(Id, name, status, req.session.superusername);

  res.send(a);

})

router.get("/delete-University-Type", async (req, res) => {
    client.del("getuniversitytypeapi");
  let b = await universitytypeController.deleteUniversityType(req.query.Id);

  res.send(b);

});

router.post("/Add-College-Type", async (req, res) => {
    client.del("getcollegetypeapi");
    
  const { name, status } = req.body;

  let a = await collegetypeController.addCollegeType(name, status, req.session.superusername);

  res.send(a);

});

router.get("/get-College-Type", async (req, res) => {
    let response=[];
    
    let b=await client.get("getcollegetypeapi");
    if(b)
    {
        response=b;
    }
    else
    {
        
  let a = await collegetypeController.getCollegeType();
  await client.set("getcollegetypeapi",JSON.stringify(a),'EX',3600*24);
  response=a;
    }


  res.send(response);

});

router.post("/get-Single-College-Type", async (req, res) => {
  let a = await collegetypeController.getSingleCollegeType(req.body.Id);
  res.send(a);

});

router.post("/Update-College-Type", async (req, res) => {
     client.del("getcollegetypeapi");
  const { Id, name, status } = req.body;
  let a = await collegetypeController.UpdateCollegeType(Id, name, status, req.session.superusername);

  res.send(a);



});




router.get("/delete-College-Type", async (req, res) => {
     client.del("getcollegetypeapi");
  let a = await collegetypeController.deleteCollegeType(req.query.Id);

  res.send(a);

});
router.post("/get-City-By-State", async (req, res) => {
  let a = await cityController.getCityByState(req.body.Id);
  res.send(a);
});


router.post("/Add-Banner", async (req, res) => {
    client.del("getbannerapi");
    client.del("gethomepageapi");


  const { name, Image } = req.body;

  let a = await bannerController.addBanner(name, Image, req.session.superusername);

  res.send(a);

});

router.get("/get-Banner", async (req, res) => {
    
    let response=[];
    
    let b=await client.get("getbannerapi");
    if(b)
    {
        response=b;
        console.log("I am Banner Redis");
    }
    else
    {
         let a = await bannerController.getBanner();
         await client.set("getbannerapi",JSON.stringify(a),'EX',3600*24);
         response=a;
    }
 
  res.send(response);

});

router.get("/delete-Banner", async (req, res) => {
    client.del("getbannerapi");
        client.del("gethomepageapi");

  let a = await bannerController.deleteBanner(req.query.Id);
  res.send(a)

});
router.post("/Particular-Banner", async (req, res) => {
  let a = await bannerController.ParticularBanner(req.body.Id);
  res.send(a)
});

router.post("/Update-Banner", async (req, res) => {
    client.del("getbannerapi");
        client.del("gethomepageapi");

  const { Id, name, Image } = req.body;
  const modified_by = req.session.superusername;

  let a = await bannerController.UpdateBanner(Id, name, Image, modified_by);
  res.send(a);

})

router.post("/Add-Study-Mode", async (req, res) => {
    client.del("getstudymodeapi");
  const { name, status } = req.body;
  let a = await studyModeController.addStudyMode(name, status, req.session.superusername);
  res.send(a);

});

router.get("/get-Study-Mode", async (req, res) => {
    let response=[];
    let b=await client.get("getstudymodeapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await studyModeController.getStudyMode();
        await client.set("getstudymodeapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }
  
  res.send(response);
  


});

router.get("/delete-Study-Mode", async (req, res) => {
    client.del("getstudymodeapi");
  let a = await studyModeController.deleteStudyMode(req.query.Id);

  res.send(a);

});

router.post("/get-Single-Study-Mode", async (req, res) => {
  let a = await studyModeController.SingleStudyMode(req.body.Id);
  res.send(a);

})
router.post("/Update-Study-Mode", async (req, res) => {
    client.del("getstudymodeapi");
  const { Id, name, status } = req.body;
  let a = await studyModeController.UpdateStudyMode(Id, name, status, req.session.superusername);

  res.send(a);



});




router.post("/Add-Course-Mode", async (req, res) => {
    client.del("getcoursemodeapi");
  const { name, status } = req.body;
  let a = await courseModeController.addCourseMode(name, status, req.session.superusername);
  res.send(a);

});

router.get("/get-Course-Mode", async (req, res) => {
    let response=[];
    let b=await client.get("getcoursemodeapi");
    if(b)
    {
        response=b;
    }
    else
    {
        let a = await courseModeController.getCourseMode();
        response=a;
        await client.set("getcoursemodeapi",JSON.stringify(a),'EX',3600*24);
    }
    
  
  res.send(response);


});

router.get("/delete-Course-Mode", async (req, res) => {
    client.del("getcoursemodeapi");
  let a = await courseModeController.deleteCourseMode(req.query.Id);

  res.send(a);

});

router.post("/get-Single-Course-Mode", async (req, res) => {
  let a = await courseModeController.SingleCourseMode(req.body.Id);
  res.send(a);

})
router.post("/Update-Course-Mode", async (req, res) => {
    client.del("getcoursemodeapi");
  const { Id, name, status } = req.body;
  let a = await courseModeController.UpdateCourseMode(Id, name, status, req.session.superusername);

  res.send(a);



});

router.post("/Add-One-Step", async (req, res) => {
    client.del("getonestepsolutionapi");
        client.del("gethomepageapi");

  const { Silder, steps, icons } = req.body;

  let a = await OneStepSolution.addoneStep(Silder, steps, icons, req.session.superusername);

  res.send(a);


});

router.get("/get-One-Step-Solution", async (req, res) => {
    let response=[];
    let b=await client.get("getonestepsolutionapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await OneStepSolution.getOneStep();
        response=a;
        await client.set("getonestepsolutionapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});
router.get("/delete-One-Step-Solution", async (req, res) => {
    client.del("getonestepsolutionapi");
        client.del("gethomepageapi");

  let a = await OneStepSolution.deleteOneStep(req.query.Id);
  res.send(a);

});

router.post("/get-Sinlge-One-Step-Solution", async (req, res) => {
  let a = await OneStepSolution.getSingleOneStep(req.body.Id);
  res.send(a);

});

router.post("/Update-One-Step-Solution", async (req, res) => {
    client.del("getonestepsolutionapi");
        client.del("gethomepageapi");

  const { Id, Silder, steps, icons } = req.body;
  let a = await OneStepSolution.UpdateOneStep(Id, Silder, steps, icons, req.session.superusername);
  res.send(a);
});

router.post("/Add-Media", async (req, res) => {
    client.del("getmediaapi");
        client.del("gethomepageapi");

  const { name, Image } = req.body;

  let a = await MediaController.addMedia(name, Image, req.session.superusername);

  res.send(a);

});

router.get("/get-Media", async (req, res) => {
    let response=[];
    let b=await client.get("getmediaapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await MediaController.getMedia();
        await client.set("getmediaapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

});

router.get("/delete-Media", async (req, res) => {
    client.del("getmediaapi");
        client.del("gethomepageapi");

  let a = await MediaController.deleteMedia(req.query.Id);
  res.send(a);

});


router.post("/get-Particular-Media", async (req, res) => {
  let a = await MediaController.getSingleMedia(req.body.Id);
  res.send(a);

});

router.post("/Update-Media", async (req, res) => {
    client.del("getmediaapi");
        client.del("gethomepageapi");

  const { Id, name, Image } = req.body;

  let a = await MediaController.UpdateMedia(Id, name, Image, req.session.superusername);

  res.send(a);

});

router.post("/Add-Job-Type", async (req, res) => {
    client.del("getjobtyeapi");
  const { name, status } = req.body;

  let a = await JobTypeController.addJobType(name, status, req.session.superusername);
  res.send(a);

});
router.get("/get-Job-Type", async (req, res) => {
    let response=[];
    let b=await client.get("getjobtyeapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await JobTypeController.getJobType();
        response=a;
        await client.set("getjobtyeapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});

router.get("/delete-Job-Type", async (req, res) => {
    client.del("getjobtyeapi");
  let a = await JobTypeController.deleteJobType(req.query.Id);
  res.send(a);

});

router.post("/get-Single-Job-Type", async (req, res) => {
  let a = await JobTypeController.getSingleJobType(req.body.Id);
  res.send(a);

});

router.post("/Update-Job-Type", async (req, res) => {
    client.del("getjobtyeapi");
  const { Id, name, status } = req.body;
  let a = await JobTypeController.UpdateJobType(Id, name, status, req.session.superusername);
  res.send(a);

})


router.post("/Add-Job-Reference", async (req, res) => {
    client.del("getjobreferenceapi");
  const { name, status } = req.body;

  let a = await JobReferenceController.addJobReference(name, status, req.session.superusername);
  res.send(a);

});

router.get("/get-Job-Reference", async (req, res) => {
    let response=[];
    let b=await client.get("getjobreferenceapi");
    if(b)
    {
        response=b;
    }
    else
    {
        
          let a = await JobReferenceController.getJobReference();
        response=a;
        await client.set("getjobreferenceapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});

router.get("/delete-Job-Reference", async (req, res) => {
    client.del("getjobreferenceapi");
  let a = await JobReferenceController.deleteJobReference(req.query.Id);
  res.send(a);

});
router.post("/get-Single-Job-Reference", async (req, res) => {
  let a = await JobReferenceController.getSingleJobTypeReference(req.body.Id);
  res.send(a);

});

router.post("/Update-Job-Reference", async (req, res) => {
    client.del("getjobreferenceapi");
  const { Id, name, status } = req.body;
  let a = await JobReferenceController.UpdateJobReference(Id, name, status, req.session.superusername);
  res.send(a);

})
router.post("/Add-Job", async (req, res) => {
    client.del("getjobapi");
    client.del("getsecondarydataapi");
  const { jobtype, jobmode, name, location, responsibility } = req.body;

  let a = await JobController.addJob(jobtype, jobmode, name, location, responsibility, req.session.superusername);

  res.send(a);

});

router.get("/get-Job", async (req, res) => {
    let response=[];
    let b=await client.get("getjobapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await JobController.getJob();
        response=a;
        await client.set("getjobapi",JSON.stringify(a),'EX',3600*24);
    }


  res.send(response);
  

});
router.post("/get-Job-By-Type", async (req, res) => {
  let a = await JobController.getJobByType(req.body.Id);



  res.send(a);

});


router.get("/delete-Job", async (req, res) => {
    client.del("getjobapi");
    client.del("getsecondarydataapi");
    
  let a = await JobController.deleteJob(req.query.Id);
  res.send(a);

});
router.post("/get-Single-Job", async (req, res) => {
  let a = await JobController.getSingleJob(req.body.Id);
  res.send(a);

});

router.post("/get-Single-Job1", async (req, res) => {
  let a = await JobController.getSingleJob1(req.body.Id);
  res.send(a);

});

router.post("/Update-Job", async (req, res) => {
    client.del("getjobapi");
  const { Id, jobtype, jobmode, name, location, responsibility } = req.body;

  let a = await JobController.UpdateJob(Id, jobtype, jobmode, name, location, responsibility, req.session.superusername);
  res.send(a);

})

router.post("/Add-Job-Response", async (req, res) => {
    client.del("getjobresponseapi");
  const {
    jobtype,
    fname,
    email,
    phone,
    reference,
    resume,
    experience,
    handledUG,
    hqualification,
    currentctc,
    yearsexp
  } = req.body;

  try {
    // Construct the URL correctly
    const resumeUrl = `${req.protocol}://${req.get('host')}/backend/images/${resume}`;

    let result = await JobResponse.addJobResponse(
      jobtype,
      fname,
      email,
      phone,
      reference,
      resumeUrl,
      experience,
      handledUG,
      hqualification,
      currentctc,
      yearsexp,
      req.session.superusername
    );

    res.send(result);
  } catch (error) {
    console.error("Error adding job response:", error);
    res.status(500).send({ error: "An error occurred while adding the job response" });
  }
});


router.get("/get-Job-Response", async (req, res) => {
    let response=[];
    let b=await client.get("getjobresponseapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await JobResponse.getJobResponse();
          response=a;
        await client.set("getjobresponseapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});

router.post("/Add-Job-Mode", async (req, res) => {
    client.del("getjobmodeapi");
  const { name, status } = req.body;

  let a = await JobModeController.addJobMode(name, status, req.session.superusername);

  res.send(a);

});
router.get("/get-Job-Mode", async (req, res) => {
    let response=[];
    let b=await client.get("getjobmodeapi");
    if(b)
    {
        response=b;
    }
    else
    {
        
          let a = await JobModeController.getJobMode();
        response=a;
        await client.set("getjobmodeapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);
  

});

router.get("/delete-Job-Mode", async (req, res) => {
    client.del("getjobmodeapi");
  let a = await JobModeController.deleteJobMode(req.query.Id);
  res.send(a);

})
router.post("/get-Job-By-Mode", async (req, res) => {
  let a = await JobController.getJobByMode(req.body.Id);
  res.send(a);

});


router.post("/get-University-By-Name-Using-Like", async (req, res) => {
  const { name } = req.body;

  let a = await universityController.getUniversityByNameUsingLike(name);
  res.send(a);

})
router.post("/get-Course-By-Name-Using-Like", async (req, res) => {
  const { name } = req.body;

  let a = await courseController.getCourseByNameUsingLike(name);
  res.send(a);

})
router.post("/get-Blog-By-Name-Using-Like", async (req, res) => {
  const { name } = req.body;

  let a = await blogController.getBlogByNameUsingLike(name);
  res.send(a);

})

router.post("/get-Blog-Faq-By-Blog-Id", async (req, res) => {
  let a = await faqController.getBlogfaqByBlogId(req.body.Id);
  res.send(a);

});

router.post("/Add-Header", async (req, res) => {
    client.del("getheaderapi");
  const { name, Image } = req.body;

  let a = await HeaderController.addHeader(name, Image, req.session.superusername);

  res.send(a);

});
router.get("/get-Test",async(req,res)=>
{
    res.send("Test");
})
router.get("/get-Course-Page", async (req, res) => {
    try {
        let cacheKey = "getcoursepageapi";
        
        
        
        let cachedData = await client.get(cacheKey);

        if (cachedData) {
            console.log("Serving from Redis cache");
             res.send(cachedData);
        }

      
       else
       {
            const [coursepage, courseauthor] = await Promise.all([
            courseController.getCourseByName(),
            authorController.getCourseAuthor(),
        ]);

        const result = { coursepage, courseauthor };

     
        await client.set(cacheKey, JSON.stringify(result), 'EX', 3600 * 24);

       res.send(result);
       }
    } catch (error) {
        console.error("Error fetching course page data:", error);
        return res.status(500).send({ error: "Failed to fetch course page data" });
    }
});
// router.get("/get-Course-Page",async(req,res)=>
// {
//      try {
        
//         let z=[];
      
   
//         let a=await client.get("getcoursepageapi");
//         if(a)
//         {
//           z=a;
//         console.log("I am Course Redis");
           
           
//         }
//         else
//         {
          
//             const [
            
          
//             coursepage,
//             courseauthor,
          
//         ] = await Promise.all([
            
//             courseController.getCourseByName(),
//             authorController.getCourseAuthor(),
//         ]);

//         const result = {
           
//             courseauthor,
//             coursepage,
          
//         };
//         z=result;
        
//         await client.set("getcoursepageapi",JSON.stringify(result), 'EX', 3600*24);
        
        
//         }
        

//         res.send(z);
//     } catch (error) {
//         console.error("Error fetching home page data:", error);
//         res.status(500).send({ error: "Failed to fetch home page data" });
//     }
// })
router.get("/get-Home-Page", async (req, res) => {
    try {
        
        let z=[];
      
        let a=await client.get("gethomepageapi");
        if(a)
        {
           z=a;
           console.log("I am Redis");
           
           
        }
        else
        {
            const [
            banner,
            course,
            onestop,
            expert,
            university,
            news,
            testimonial,
            blogs,
            blogfaqs,
            blogauthor,
            universitypage,
            coursepage,
            courseauthor,
            coursespecialization,
            coursebook,
            coursesubject,
            marquee
        ] = await Promise.all([
            bannerController.getBanner(),
              
            courseController.getCourseByType(),
            OneStepSolution.getOneStep(),
            staffController.getStaff(),
            universityController.getUniversityByTotalCourse(),
            MediaController.getMedia(),
            alumniController.getAlumni(),
            blogController.getBlog(),
            faqController.getBlogFaq(),
            authorController.getBlogAuthor(),
            universityController.ParticularUniversity(),
            courseController.getCourseByName(),
            authorController.getCourseAuthor(),
             courseController.getSpecializationByCourseName(),
              bookController.getBookBySpecializationByCourseName(),
               subjectController.getSubjectByCourseName(),
               MarqueeController.getLatestMarquee()



            

        ]);

        const result = {
            coursespecialization,
            coursesubject,
            coursebook,
            
            universitypage,
            courseauthor,
            coursepage,
            banner,
            course,
            onestop,
            expert,
            university,
            news,
            testimonial,
            blogs,
            blogfaqs,
            blogauthor,
            marquee
        };
        z=result;
        
        await client.set("gethomepageapi",JSON.stringify(result), 'EX', 3600*24);
        
        
        }
        

        res.send(z);
    } catch (error) {
        console.error("Error fetching home page data:", error);
        res.status(500).send({ error: "Failed to fetch home page data" });
    }
});
router.get("/get-Home-Page1", async (req, res) => {
    
    console.log("I am Route Two");
    
    try {
        
        const [
            banner,
            course,
            onestop,
            expert,
            university,
            news,
            testimonial,
            blogs,
            blogfaqs,
            blogauthor,
            universitypage,
            coursepage,
            courseauthor,
            coursespecialization,
            coursebook,
            coursesubject,
            marquee
        ] = await Promise.all([
            bannerController.getBanner(),
              
            courseController.getCourseByType(),
            OneStepSolution.getOneStep(),
            staffController.getStaff(),
            universityController.getUniversityByTotalCourse(),
            MediaController.getMedia(),
            alumniController.getAlumni(),
            blogController.getBlog23(),
            faqController.getBlogFaq(),
            authorController.getBlogAuthor1(),
            universityController.ParticularUniversity2(),
            courseController.getCourseByName1(),
            authorController.getCoursePreviewAuthor(),
             courseController.getSpecializationByCourseName(),
              bookController.getBookBySpecializationByCourseName(),
               subjectController.getSubjectByCourseName(),
               MarqueeController.getLatestMarquee()



            

        ]);

        const result = {
            coursespecialization,
            coursesubject,
            coursebook,
            
            universitypage,
            courseauthor,
            coursepage,
            banner,
            course,
            onestop,
            expert,
            university,
            news,
            testimonial,
            blogs,
            blogfaqs,
            blogauthor,
            marquee
        };

        res.send(result);
    } catch (error) {
        console.error("Error fetching home page data:", error);
        res.status(500).send({ error: "Failed to fetch home page data" });
    }
});

router.get("/get-Header", async (req, res) => {
    let response=[];
    let b=await client.get("getheaderapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await HeaderController.getHeader();
        response=a;
        await client.set("getheaderapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});

router.get("/get-Latest-Header", async (req, res) => {
  let a = await HeaderController.getLatestHeader();
  res.send(a);

});
router.get("/delete-Header", async (req, res) => {
    client.del("getheaderapi");
  let a = await HeaderController.deleteHeader(req.query.Id);
  res.send(a);

});
router.post("/get-University-Study-Mode", async (req, res) => {


  let a = await universityController.getUniversityByStudyMode(req.body.Name);

  res.send(a);

})
router.post("/get-University-By-State", async (req, res) => {
  let a = await universityController.getUniversityByState(req.body.Name, req.body.state);
  res.send(a);

})

router.post("/get-University-By-University-Type", async (req, res) => {
  let a = await universityController.getUniversityByType(req.body.Name, req.body.state);
  res.send(a);

})
router.post("/get-Particular-Header", async (req, res) => {
  let a = await HeaderController.getParticularHeader(req.body.Id);

  res.send(a);


});




router.post("/Update-Header", async (req, res) => {
    client.del("getheaderapi");
  const { Id, name, Image } = req.body;



  let a = await HeaderController.UpdateHeader(Id, name, Image, req.session.superusername);
  res.send(a);
});

router.post("/Add-CTA", async (req, res) => {
    client.del("getctaapi");
    
  const { name } = req.body;

  let a = await CTAController.addCTA(name, req.session.superusername);
  res.send(a);

});

router.get("/get-CTA", async (req, res) => {
    let response=[];
    let b=await client.get("getctaapi");
    if(b)
    {
        response=b;
    }
    else
    {

  let a = await CTAController.getCTA();        
        response=a;
        
        await client.set("getctaapi",JSON.stringify(a),'EX',3600*24);
        
    }

  res.send(response);

})

router.post("/get-University-By-Name", async (req, res) => {
  let a = await universityController.getUniversityByName(req.body.Name);
  res.send(a);

});
router.post("/get-Course-By-Name2", async (req, res) => {
  let a = await courseController.getCourseByName2(req.body.Name);
  res.send(a);

})


router.post("/Add-More-Resource", async (req, res) => {
    client.del("getmoreresourceapi");
  let { button1,
    button2,
    button3,
    button4,
    button5,
    button6,
    newNumber,
    timing } = req.body;

  const added_by = req.session.superusername;

  let a = await MoreResourceController.addMoreResource(button1,
    button2,
    button3,
    button4,
    button5,
    button6,
    newNumber,
    timing,
    added_by);

  res.send(a);
});

router.get("/get-More-Resource", async (req, res) => {
    let response=[];
    let b=await client.get("getmoreresourceapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await MoreResourceController.getMoreResource();
        await client.set("getmoreresourceapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }

  res.send(response);

});

router.get("/delete-More-Resource", async (req, res) => {
    client.del("getmoreresourceapi");
  let { Id } = req.query;
  let a = await MoreResourceController.deleteMoreResource(Id);
  res.send(a);

});

router.post("/Update-More-Resource", async (req, res) => {
    client.del("getmoreresourceapi");
  let { Id } = req.body;
  let a = await MoreResourceController.getSingleMoreResource(Id);
  res.send(a);

});

router.post("/Update-More-Resourceses", async (req, res) => {
  let {
    Id,
    button1,
    button2,
    button3,
    button4,
    button5,
    button6,
    newNumber,
    timing
  } = req.body;
  let modified_by = req.session.superusername;


  let a = await MoreResourceController.UpdateResource(Id,
    button1,
    button2,
    button3,
    button4,
    button5,
    button6,
    newNumber,
    timing,
    modified_by
  );
  res.send(a);

})

router.post("/Add-Zone", async (req, res) => {
    client.del("getzoneapi");
  const { name, status } = req.body;


  let a = await ZoneController.addZone(name, status, req.session.superusername);

  res.send(a);


});



router.get("/get-Zone", async (req, res) => {
    let response=[];
    let b=await client.get("getzoneapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await ZoneController.getZone();
        response=a;
        await client.set("getzoneapi",JSON.stringify(a),'EX',3600*24);
    }


  res.send(response);

});

router.post("/get-Particular-Zone", async (req, res) => {
  let a = await ZoneController.getParticularZone(req.body.Id);

  res.send(a);

});

router.post("/Update-Zone", async (req, res) => {
    client.del("getzoneapi");
  const { Id, name, status } = req.body;

  let a = await ZoneController.UpdateZone(Id, name, status, req.session.superusername);

  res.send(a);


})

router.get("/delete-Zone", async (req, res) => {
    client.del("getzoneapi");
  let a = await ZoneController.deleteZone(req.query.Id);
  res.send(a);

});


router.post("/Add-Acdemic-Specialization", async (req, res) => {


  client.del("getacademicspecializationapi");
  

  const { university,
    course,
    specialization,
    specializationcode,
    examfee,
    registrationfee,
    coursefee } = req.body;
  let added_by = req.session.superusername;

  let a = await AcdemicSpecialization.Add(university,
    course,
    specialization,
    specializationcode,
    examfee,
    registrationfee,
    coursefee, added_by);


  res.send(a);

})


router.get("/get-Academic-Specialization", async (req, res) => {
    
    let response=[];
    let b=await client.get("getacademicspecializationapi");
    if(b)
    {
        response=b;
    }
    else
    {
  let a = await AcdemicSpecialization.getSpecialization();
  await client.set("getacademicspecializationapi",JSON.stringify(a),'EX',3600*24);
  response=a;
  
    }



  res.send(response);
  

})


router.post("/Add-Faq", async (req, res) => {


  const { questions, answers } = req.body;





  const add = req.session.superusername;

  const q = `{${questions.join(',')}}`;
  const a = `{${answers.join(',')}}`;

  const r = await faqController.addFaq(q, a, add);


  res.send(r);

});

router.get("/get-Faq", async (req, res) => {
  let a = await faqController.getFaq();
  res.send(a);

})
router.post("/get-Single-Faq", async (req, res) => {
  let a = await faqController.getSingleFaq(req.body.Id);
  res.send(a);

})
router.post("/Update-Faq", async (req, res) => {
  let add = req.session.superusername;

  const { id, questions, answers } = req.body;
  const q = `{${questions.map(item => `"${item}"`).join(',')}}`;
  const a = `{${answers.map(item => `"${item}"`).join(',')}}`;
  let r = await faqController.UpdateFaq(q, a, add, id);
  res.send(r);
});
router.get("/delete-Faq", async (req, res) => {
  let a = await faqController.deleteFaq(req.query.Id);
  res.send(a);

})

router.post("/Add-Expert-Page",async(req,res)=>
{
  
client.del("getexpertpageapi");
    
  let {  qualityassurancecell,
    qualitycellimage,
    training,
    trainingimage,
    qualityassuranceteam,
    qualityteamimage,
    aimqualityassurance}=req.body;
    let added_by=req.session.superusername;


    let a=await ExpertController.addExpert(qualityassurancecell,
    qualitycellimage,
    training,
    trainingimage,
    qualityassuranceteam,
    qualityteamimage,
    aimqualityassurance,
  added_by);

  res.send(a);

})

router.get("/get-Expert-Page",async(req,res)=>
{
    let response=[];
    let b=await client.get("getexpertpageapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a=await ExpertController.getExpert();
       response=a;
       await client.set("getexpertpageapi",JSON.stringify(a),'EX',3600*24);
    }
    

  res.send(response);

})

router.get("/get-Latest-Expert-Page",async(req,res)=>
{
  let a=await ExpertController.getLatestExpert();
  res.send(a);

})
router.get("/delete-Expert-Page",async(req,res)=>
{
    client.del("getexpertpageapi");
    
  let a=await ExpertController.deleteExpert(req.query.Id);
  res.send(a);

});
router.get("/Particular-Expert-Page",async(req,res)=>
{
   
  let a=await ExpertController.getSingleExpertPage(req.query.Id);
  res.send(a);

})


router.post("/Add-About-Page", async (req, res) => {
    client.del("getaboutapi");
    
  const { heading, description, about,moreabout } = req.body;
  const added_by = req.session.superusername;


  let a = await AboutController.addAbout(heading, description, about,moreabout, added_by);

  res.send(a);



});

router.get("/get-About-Page", async (req, res) => {
    
  let response=[];
  let b=await client.get("getaboutapi");
  if(b)
  {
      response=b;
  }
  else
  {
      let a = await AboutController.getAbout();
      
      await client.set("getaboutapi",JSON.stringify(a),'EX',3600*24);
      response=a
}
res.send(response);

});

router.get("/get-Latest-About-Page", async (req, res) => {
  let a = await AboutController.getLatestAbout();
  res.send(a);

});
router.get("/delete-About-Page", async (req, res) => {
  let a = await AboutController.deleteAbout(req.query.Id);
  res.send(a);

});
router.get("/Particular-About-Page", async (req, res) => {
  

  let a = await AboutController.getSingleAbout(req.query.Id);
  res.send(a);

})
router.post("/Update-About-Page", async (req, res) => {
    client.del("getaboutapi");
    
  const { Id, heading, description, content,moreabout } = req.body;
  const added_by = req.session.superusername;


  let a = await AboutController.UpdateAboutPage(Id, heading, description, content,moreabout, added_by);

  res.send(a);
});


router.post("/Add-Contact-Us", async (req, res) => {
    client.del("getcontactusapi");
  const { email, contactnumber, officeaddress } = req.body;
  const added_by = req.session.superusername;

  const a = await ContactUsController.addContactUs(email, contactnumber, officeaddress, added_by);

  res.send(a);
});

router.get("/get-Contact-Us", async (req, res) => {
    let response=[];
    
    let b=await client.get("getcontactusapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await ContactUsController.getContactUs();
        response=a;
        await client.set("getcontactusapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);

});
router.get("/delete-Contact-Us", async (req, res) => {
client.del("getcontactusapi")
  let a = await ContactUsController.deleteContactUs(req.query.Id);
  res.send(a);

});
router.post("/get-Single-Contact-Us", async (req, res) => {
  let a = await ContactUsController.getParticularContactUs(req.body.Id);
  res.send(a);

});

router.post("/Update-Contact-Us", async (req, res) => {
    client.del("getcontactusapi")
  const { Id, email, contactnumber, officeaddress } = req.body;
  const added_by = req.session.superusername;
  let a = await ContactUsController.UpdateContactUs(Id, email, contactnumber, officeaddress, added_by);
  res.send(a);

})
router.post("/Update-Expert-Page", async (req, res) => {
    client.del("getexpertpageapi");
    
  const { Id,
    qualityassurancecell,
    qualitycellimage,
    training,
    trainingimage,
    qualityassuranceteam,
    qualityteamimage,
    aimqualityassurance } = req.body;
  let added_by = req.session.superusername;
  let a = await ExpertController.UpdateExpertPage(Id,
    qualityassurancecell,
    qualitycellimage,
    training,
    trainingimage,
    qualityassuranceteam,
    qualityteamimage,
    aimqualityassurance,
    added_by);


  res.send(a);

});
router.get("/get-Contact-Us-Latest",async(req,res)=>
{
  let a=await ContactUsController.getLatestRecord();
  res.send(a);

})
router.get("/get-Latest-Media", async (req, res) => {
  let a = await MediaController.getLatestMedia();

  res.send(a);

});

router.post("/Add-University-Listening-Step",async(req,res)=>
{
    client.del("getuniversitylisteningapi");
    
  const {step1,step2,step3,step4}=req.body;
  let added_by=req.session.superusername;

  let a=await UniversityListeningStep.addUniversityListeningStep(step1,step2,step3,step4,added_by);
  res.send(a);

})

router.get("/get-University-Listening-Page",async(req,res)=>
{
    let response=[];
    let b=await client.get("getuniversitylisteningapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a=await UniversityListeningStep.getUniversityListeningPage();
        await client.set("getuniversitylisteningapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }

  res.send(response);

});

router.get("/get-University-Listening-Latest-Page",async(req,res)=>
{
  let a=await UniversityListeningStep.getUniversityListeningLatestStep();
  res.send(a);
  
})


router.post("/Add-University-Listening-Benefit", async (req, res) => {
     client.del("getuniversitylisteningbenefitapi");
  const { step1, step2, step3, step4 } = req.body;
  let added_by = req.session.superusername;

  let a = await UniversityListeningBenefit.addUniversityListeningbenefit(step1, step2, step3, step4, added_by);
  res.send(a);

})

router.get("/get-University-Listening-Benefit", async (req, res) => {
    let response=[];
    let b=await client.get("getuniversitylisteningbenefitapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await UniversityListeningBenefit.getUniversityListeningBenefit();
        await client.set("getuniversitylisteningbenefitapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }

  res.send(response);

});
router.get("/delete-University-Listening-Benefit",async(req,res)=>
{
    client.del("getuniversitylisteningbenefitapi");
  const {Id}=req.query;
  

  let a=await UniversityListeningBenefit.deleteUniversityListeningBenefit(Id);
  res.send(a);
})
router.post("/get-Single-University-Listening-Benefit", async (req, res) => {
  const { Id } = req.body;
  let a = await UniversityListeningBenefit.getSingleUniversityListeningBenefit(Id);
  res.send(a);

});

router.post("/Update-University-Listening-Benefit", async (req, res) => {
 
 client.del("getuniversitylisteningbenefitapi");
  const { id, step1, step2, step3, step4 } = req.body;
  const added_by = req.session.superusername;

  let a = await UniversityListeningBenefit.UpdateUniversityListeningBenefit(id, step1, step2, step3, step4, added_by);
  res.send(a);

})

router.get("/get-Latest-University-Listening-Benefit", async (req, res) => {
  let a = await UniversityListeningBenefit.getUniversityListeningLatestBenefit();
  res.send(a);

});

router.post("/Add-Designation",async(req,res)=>
{
    client.del("getdesignationapi");
    
  const {name,status}=req.body;
  let added_by=req.session.superusername;
  let a=await DesignationController.addDesignation(name,status,added_by);
  res.send(a);

});

router.get("/get-Designation",async(req,res)=>
{
    let response=[];
    let b=await client.get("getdesignationapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a=await DesignationController.getDesignation();
        response=a;
        await client.set("getdesignationapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);
});
router.get("/delete-Designation",async(req,res)=>
{
    client.del("getdesignationapi");
    
  const {Id}=req.query;
  let a=await DesignationController.deleteDesignation(Id);
  res.send(a);
  
})

router.post("/Add-Qualification",async(req,res)=>
  {
            client.del("getqualificationapi");
    const {name,status}=req.body;
    let added_by=req.session.superusername;
    let a=await QualificationController.addQualification(name,status,added_by);
    res.send(a);
  
  });
  
  router.get("/delete-CTA",async(req,res)=>
{
    client.del("getctaapi");
    
  const {Id}=req.query;
  let a=await CTAController.deleteCTA(Id);

  res.send(a);
  
})
  
  router.get("/get-Qualification",async(req,res)=>
  {
      let response=[];
      let b=await client.get("getqualificationapi");
      if(b)
      {
          response=b;
      }
      else
      {
              let a=await QualificationController.getQualification();
          response=a;
          await client.set("getqualificationapi",JSON.stringify(a),'EX',3600*24);
      }

    res.send(response);
  });
  router.get("/delete-Qualification",async(req,res)=>
  {
      client.del("getqualificationapi");
    const {Id}=req.query;
    let a=await QualificationController.deleteQualification(Id);
    res.send(a);
    
  })
  
router.post("/Add-Establish-In", async (req, res) => {
    client.del("getestablishapi");
  const { name, status } = req.body;
  let added_by = req.session.superusername;
  let a = await EstablishController.addestablish(name, status, added_by);
  res.send(a);

});

router.get("/get-Establish", async (req, res) => {
    let response=[];
    let b=await client.get("getestablishapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await EstablishController.getEstablish();
        response=a;
        await client.set("getestablishapi",JSON.stringify(a),'EX',3600*24);
    }

  res.send(response);
  
});
router.get("/delete-Establish", async (req, res) => {
    client.del("getestablishapi");
  const { Id } = req.query;
  let a = await EstablishController.deleteEstablish(Id);
  res.send(a);

})


router.post("/get-Single-University-Listening-Step",async(req,res)=>
{
  const {Id}=req.body;

  let a=await UniversityListeningStep.getSingleUniversityListeningStep(Id);
  res.send(a);

})

router.post("/Update-University-Listening-Step", async (req, res) => {
        client.del("getuniversitylisteningapi");
  const { Id,step1, step2, step3, step4 } = req.body;
  let added_by = req.session.superusername;

  let a = await UniversityListeningStep.UpdateUniversityListeningStep(Id,step1, step2, step3, step4, added_by);
  res.send(a);

})

router.get("/delete-University-Listening-Step",async(req,res)=>
{
    client.del("getuniversitylisteningapi");
  const {Id}=req.query;
  let a=await UniversityListeningStep.deleteUniversityListeningStep(Id);
  res.send(a);
  
})

router.post("/Add-Marquee", async (req, res) => {
    client.del("getmarqueeapi");
        client.del("gethomepageapi");

  const { name, status } = req.body;


  let a = await MarqueeController.addMarquee(name, status, req.session.superusername);

  res.send(a);


});



router.get("/get-Marquee", async (req, res) => {
    let response=[];
    let b=await client.get("getmarqueeapi");
    if(b)
    {
        response=b;
    }
    else
    {
          let a = await MarqueeController.getMarquee();
        await client.set("getmarqueeapi",JSON.stringify(a),'EX',3600*24);
        response=a;
    }


  res.send(response);

});

router.post("/get-Particular-Marquee", async (req, res) => {
  let a = await MarqueeController.getParticularMarquee(req.body.Id);

  res.send(a);

});

router.post("/Update-Marquee", async (req, res) => {
    client.del("getmarqueeapi");
        client.del("gethomepageapi");

  const { Id, name, status } = req.body;

  let a = await MarqueeController.UpdateMarquee(Id, name, status, req.session.superusername);

  res.send(a);


})

router.get("/delete-Marquee", async (req, res) => {
    client.del("getmarqueeapi");
        client.del("gethomepageapi");

  let a = await MarqueeController.deleteMarquee(req.query.Id);
  res.send(a);

});


router.post("/get-University-Activiy-By-User", async (req, res) => {



  let a = await UserActivityController.getUniversityActivityByUser(req.body.column, req.body.value);

  res.send(a);

})

router.post("/get-University-Course-Activiy-By-User", async (req, res) => {
 
 

  let a = await UserActivityController.getUniversityCourseActivityByUser(req.body.column, req.body.value);

  res.send(a);

})


router.post("/get-Blog-Activiy-By-User", async (req, res) => {
 

  let a = await UserActivityController.getBlogActivityByUser(req.body.column,req.body.value);

  res.send(a);

})
router.post("/get-Course-Activiy-By-User", async (req, res) => {
 


  let a = await UserActivityController.getCourseActivityByUser(req.body.column,req.body.value);

  res.send(a);

})


router.post("/get-University-Activiy-Between-Date", async (req, res) => {


  let a = await UserActivityController.getUniversityActivityBetweenDates(req.body.startdate, req.body.endate);
  res.send(a);

});

router.post("/get-University-Course-Activiy-Between-Date", async (req, res) => {
  console.log(req.body);
  let a = await UserActivityController.getUniversityCourseActivityBetweenDates(req.body.startdate, req.body.endate);
  res.send(a);
});

router.post("/get-Blog-Activiy-Between-Date", async (req, res) => {
  console.log(req.body);
  let a = await UserActivityController.getBlogActivityBetweenDates(req.body.startdate, req.body.endate);
  res.send(a);
});
router.post("/get-Course-Activiy-By-Between-Date", async (req, res) => {
  console.log(req.body);

  let a = await UserActivityController.getCourseActivityBetweenDates(req.body.startdate, req.body.endate);
  res.send(a);
});
router.post("/get-All-Activiy", async (req, res) => {
  console.log(req.body);

  const a = await UserActivityController.getAllActivity();
  res.send(a);


});

router.get("/get-User-Api", async (req, res) => {
  let a = await SuperUserController.getAllUsers();
  res.send(a);

})
router.get("/get-Users-Logs",async(req,res)=>
{
  let a=await SuperUserController.getUserLogs();
  res.send(a.rows);

})
router.post("/get-User-Activity-By-Filter", async (req, res) => {
  const { type, author, startdate, enddate } = req.body;


  let a = await UserActivityController.getDataByFilter(type, author, startdate, enddate);

  res.send(a);


});



router.post("/get-Course-By-Filter", async (req, res) => {
  const { feature,
    active,
    toc,
    coursetype,
    modifieddate,
    addeddate,
    modifieduser,
    wordcount,
    expression } = req.body;


  console.log(req.body);
  let a = '';
  const { getapiName } = req.body;

  if (req.body.getapiName == "/get-Individual-Course") {
    a = await IndividualCourseController.IndividualCourseFilter(feature,
      active,
      toc,
      coursetype,
      modifieddate,
      addeddate,
      modifieduser,
      wordcount,
      expression);

  }
  else if (getapiName == "/get-Course") {
    a = await courseController.CourseFilter(feature,
      active,
      toc,
      coursetype,
      modifieddate,
      addeddate,
      modifieduser,
      wordcount,
      expression);

  }
  res.send(a);



});

router.post("/get-Blog-By-Filter", async (req, res) => {
  console.log(req.body);
  const { feature,
    active,
    toc,
    tag,
    addeduser,
    modifieddate } = req.body;

  let a = await blogController.BlogFilter(feature,
    active,
    toc,
    tag,
    addeduser,
    modifieddate);
  res.send(a);


})

module.exports = router;
