const p = require('../config/db');
const faqController = require('../controllers/faqController');
const commentController = require('../controllers/commentController');
const reviewController = require('../controllers/reviewsController');
const now = new Date().toISOString().slice(0, 19).replace('T', ' ');


class Blog {
   
   
    static async addBlog(pageName, seoTitle, seoDescription, tag, status, topic, logo, content, added_by, questions, answers, feature, toc, active, urlname, TOCH1, TOCH2, TOCH3, TOCH4, TOCH5, layout) {
    console.log(urlname);

    const insertBlogQuery = `
        INSERT INTO blog(pagename, seotitle, seodescription, tag, status, topic, image, content, added_by, feature, toc, active, urlname,TOCH1,TOCH2,TOCH3,TOCH4,TOCH5,layout)
        VALUES ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14,$15,$16,$17,$18,$19)
        RETURNING id
    `;
    const blogValues = [pageName, seoTitle, seoDescription, tag, status, topic, logo, content, added_by, feature, toc, active, urlname,
      TOCH1, TOCH2, TOCH3, TOCH4, TOCH5, layout

    ];

    let result = await p.query(insertBlogQuery, blogValues);
    if(result.rows.length>0)
    {
         let Id = result.rows[0].id;

   

    const insertBlogFaqQuery = `
        INSERT INTO blogfaq(question, answer, blogid)
        VALUES ($1, $2, $3)
    `;
    const blogquestion = [questions, answers, Id];

    const c = await p.query(insertBlogFaqQuery, blogquestion);

    }

   

    return {
      Status: true
    };
  }
   
  static async getBlog() {
    let a = await p.query("SELECT * FROM blog ORDER BY last_modified DESC");

    return a.rows
  }



  static async FilterBlog(column, value) {
    if (value == '') {
      let a = await p.query("select * from blog");
      return a.rows;
    }
    else if (column == 'last_modified') {
      console.log(value);

      let a = await p.query("SELECT * FROM blog WHERE DATE(" + column + ") = '" + value + "' ");

      // let a=await p.query("SELECT * FROM blog WHERE DATE("+column+") = '2024-04-01' ");
      return a.rows;

    }
    else {
      let a = await p.query("select * from blog where " + column + "='" + value + "' ");

      return a.rows;

    }

  }
  static async getSingleBlogByName(name) {

    if (name == '') {
      let a = await p.query("select * from blog");

      return a.rows
    }
    else {
      let a = await p.query("select * from blog where pagename='" + name + "'");

      return a.rows
    }
  }


  static async deleteBlog(id) {
    let a = await faqController.deleteBlogFaqByblogId(id);
    let b = await reviewController.deleteBlogReviewByblogId(id);
    let c = await commentController.deleteBlogCommentByblogId(id);

    let d = await p.query("delete from blog where id='" + id + "'");


    return { Status: true };


  }

 static async getParticularBlog(Id) {









    let a = (await p.query("select t1.pagename, t1.seotitle,t1.seodescription,t1.toc,t1.toch1,t1.toch2,t1.toch3,t1.toch4,t1.active,t1.feature,t1.added_date ,t1.tag,t1.layout,t1.status,t1.topic,t1.image,t1.content,t2.question,t2.answer from blog t1 join blogfaq t2 on t2.blogid=t1.id where t1.id='" + Id + "'")).rows;

    return a;

  }

  static async getParticularBlog1(Id) {

    let a = (await p.query("select t1.id,t1.pagename, t1.seotitle,t1.seodescription,t1.toc,t1.toch1,t1.toch2,t1.toch3,t1.toch4,t1.active,t1.feature,t1.added_date ,t1.categorie,t1.tag,t1.status,t1.topic,t1.image,t1.content,t2.question,t2.answer from blog t1 join blogfaq t2 on t2.blogid=t1.id where t1.urlname='" + Id + "'")).rows;

    return a;

  }



  static async UpdateBlog(id,
    pageName,
    seoTitle,
    seoDescription,

    tag,
    status,
    topic,
    content,
    questions,
    answers, add,
    TOC1,
    TOC2,
    TOC3,
    TOC4,
    TOC5,
    layout
  ) {

    let query = `
  UPDATE public.blog 
  SET pagename = $1,
      seotitle = $2,
      seodescription = $3,
    
      tag = $4,
      status = $5,
      topic = $6,
      content = $7,
      added_by = $8,
      last_modified = $9,
      TOCH1=$11,
    TOCH2=$12,
    TOCH3=$13,
    TOCH4=$14,
    TOCH5=$15,
    layout=$16
  WHERE id = $10
`;

    let values = [
      pageName,
      seoTitle,
      seoDescription,

      tag,
      status,
      topic,
      content,
      add,
      now,
      id,
      TOC1,
      TOC2,
      TOC3,
      TOC4,
      TOC5,
      layout
    ];

    await p.query(query, values);

    let q = questions;
    let ans = answers;


    let b = await p.query("UPDATE public.blogfaq SET question='" + q + "', answer='" + ans + "', added_by='" + add + "', last_modified='" + now + "' WHERE blogid='" + id + "'");



    return { Status: true };


  }


  static async getTotal() {
    let a = await p.query("select count(*) as total from blog");

    return a.rows;
  }
  static async getBlogByNameUsingLike(name) {
    if (name !== '') {
      const query = `
      SELECT 
          t1.id, 
          t1.pagename AS name,
          t1.image AS image,
          t1.added_date,
          t2.username AS added_by
      FROM 
          blog t1 
      JOIN  
          superuser t2 
      ON 
          t1.added_by = t2.id::text 
      WHERE 
          t1.pagename LIKE $1
  `;

      const values = [`%${name}%`];
      let a = await p.query(query, values);
      return a.rows;
    }
    else {
      return [];
    }
  }

}
module.exports = Blog;