--
-- PostgreSQL database dump
--

-- Dumped from database version 10.23
-- Dumped by pg_dump version 10.23

-- Started on 2024-08-04 00:00:00 UTC

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

--
-- TOC entry 1 (class 3079 OID 13283)
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- TOC entry 3915 (class 0 OID 0)
-- Dependencies: 1
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 305 (class 1259 OID 17245)
-- Name: aboutpage; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.aboutpage (
    id integer NOT NULL,
    heading text,
    description text,
    content text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone,
    moreabout text
);


ALTER TABLE public.aboutpage OWNER TO imtsac;

--
-- TOC entry 304 (class 1259 OID 17243)
-- Name: aboutpage_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.aboutpage_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.aboutpage_id_seq OWNER TO imtsac;

--
-- TOC entry 3917 (class 0 OID 0)
-- Dependencies: 304
-- Name: aboutpage_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: imtsac
--

ALTER SEQUENCE public.aboutpage_id_seq OWNED BY public.aboutpage.id;


--
-- TOC entry 197 (class 1259 OID 16409)
-- Name: acdemicspecialization_id; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.acdemicspecialization_id
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.acdemicspecialization_id OWNER TO imtsac;

--
-- TOC entry 252 (class 1259 OID 16574)
-- Name: acdemicspecialization; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.acdemicspecialization (
    id integer DEFAULT nextval('public.acdemicspecialization_id'::regclass) NOT NULL,
    universityid integer,
    courseid integer,
    specialization text,
    specializationcode text,
    coursefee text,
    examfee text,
    registrationfee text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.acdemicspecialization OWNER TO imtsac;

--
-- TOC entry 198 (class 1259 OID 16413)
-- Name: alumni_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.alumni_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.alumni_id_seq OWNER TO imtsac;

--
-- TOC entry 256 (class 1259 OID 16644)
-- Name: alumni; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.alumni (
    id integer DEFAULT nextval('public.alumni_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.alumni OWNER TO imtsac;

--
-- TOC entry 199 (class 1259 OID 16415)
-- Name: approved_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.approved_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.approved_id_seq OWNER TO imtsac;

--
-- TOC entry 257 (class 1259 OID 16654)
-- Name: approved; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.approved (
    id integer DEFAULT nextval('public.approved_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.approved OWNER TO imtsac;

--
-- TOC entry 200 (class 1259 OID 16417)
-- Name: backup_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.backup_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.backup_id_seq OWNER TO imtsac;

--
-- TOC entry 258 (class 1259 OID 16664)
-- Name: backup; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.backup (
    id integer DEFAULT nextval('public.backup_id_seq'::regclass) NOT NULL,
    filepath text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    mode text
);


ALTER TABLE public.backup OWNER TO imtsac;

--
-- TOC entry 259 (class 1259 OID 16674)
-- Name: banner; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.banner (
    id integer DEFAULT nextval('public.alumni_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.banner OWNER TO imtsac;

--
-- TOC entry 201 (class 1259 OID 16419)
-- Name: blog_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.blog_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.blog_id_seq OWNER TO imtsac;

--
-- TOC entry 255 (class 1259 OID 16634)
-- Name: blog; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.blog (
    id integer DEFAULT nextval('public.blog_id_seq'::regclass) NOT NULL,
    pagename text,
    seotitle text,
    seodescription text,
    tag text,
    status text,
    topic text,
    image text,
    content text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    feature text,
    toc text,
    active text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    layout text
);


ALTER TABLE public.blog OWNER TO imtsac;

--
-- TOC entry 202 (class 1259 OID 16421)
-- Name: blogcomment_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.blogcomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.blogcomment_id_seq OWNER TO imtsac;

--
-- TOC entry 261 (class 1259 OID 16714)
-- Name: blogcomment; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.blogcomment (
    id integer DEFAULT nextval('public.blogcomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    blogid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogcomment OWNER TO imtsac;

--
-- TOC entry 203 (class 1259 OID 16423)
-- Name: blogfaq_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.blogfaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.blogfaq_id_seq OWNER TO imtsac;

--
-- TOC entry 262 (class 1259 OID 16734)
-- Name: blogfaq; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.blogfaq (
    id integer DEFAULT nextval('public.blogfaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    blogid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogfaq OWNER TO imtsac;

--
-- TOC entry 204 (class 1259 OID 16425)
-- Name: blogreview_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.blogreview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.blogreview_id_seq OWNER TO imtsac;

--
-- TOC entry 263 (class 1259 OID 16749)
-- Name: blogreview; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.blogreview (
    id integer DEFAULT nextval('public.blogreview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    userid integer,
    blogid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogreview OWNER TO imtsac;

--
-- TOC entry 205 (class 1259 OID 16427)
-- Name: book_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.book_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.book_id_seq OWNER TO imtsac;

--
-- TOC entry 254 (class 1259 OID 16614)
-- Name: book; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.book (
    id integer DEFAULT nextval('public.book_id_seq'::regclass) NOT NULL,
    specialization integer,
    subject integer,
    title text,
    url text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.book OWNER TO imtsac;

--
-- TOC entry 206 (class 1259 OID 16429)
-- Name: city_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.city_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.city_id_seq OWNER TO imtsac;

--
-- TOC entry 264 (class 1259 OID 16770)
-- Name: city; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.city (
    id integer DEFAULT nextval('public.city_id_seq'::regclass) NOT NULL,
    name text,
    state text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.city OWNER TO imtsac;

--
-- TOC entry 207 (class 1259 OID 16431)
-- Name: collegetype_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.collegetype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.collegetype_id_seq OWNER TO imtsac;

--
-- TOC entry 265 (class 1259 OID 16780)
-- Name: collegetype; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.collegetype (
    id integer DEFAULT nextval('public.collegetype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.collegetype OWNER TO imtsac;

--
-- TOC entry 307 (class 1259 OID 17257)
-- Name: contactus; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.contactus (
    id integer NOT NULL,
    email text,
    contactnumber text,
    officeaddress text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.contactus OWNER TO imtsac;

--
-- TOC entry 306 (class 1259 OID 17255)
-- Name: contactus_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.contactus_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.contactus_id_seq OWNER TO imtsac;

--
-- TOC entry 3943 (class 0 OID 0)
-- Dependencies: 306
-- Name: contactus_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: imtsac
--

ALTER SEQUENCE public.contactus_id_seq OWNED BY public.contactus.id;


--
-- TOC entry 208 (class 1259 OID 16433)
-- Name: country_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.country_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.country_id_seq OWNER TO imtsac;

--
-- TOC entry 266 (class 1259 OID 16790)
-- Name: country; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.country (
    id integer DEFAULT nextval('public.country_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.country OWNER TO imtsac;

--
-- TOC entry 209 (class 1259 OID 16435)
-- Name: course_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.course_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.course_id_seq OWNER TO imtsac;

--
-- TOC entry 249 (class 1259 OID 16524)
-- Name: course; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.course (
    id integer DEFAULT nextval('public.course_id_seq'::regclass) NOT NULL,
    courename text,
    coursedescription text,
    noofyear text,
    noofmonth text,
    fee text,
    title text,
    seodescription text,
    image text,
    mode text,
    feature text,
    categorie text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    detailcoursedescription text,
    whycourse text,
    whopursuecourse text,
    whentodocourse text,
    keyhighcourse text,
    eligibility text,
    skills text,
    other text,
    admission text,
    active text,
    toc text,
    last_modified_user text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    universityid text[],
    toch5 text[]
);


ALTER TABLE public.course OWNER TO imtsac;

--
-- TOC entry 210 (class 1259 OID 16437)
-- Name: courseactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.courseactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.courseactivity_id_seq OWNER TO imtsac;

--
-- TOC entry 267 (class 1259 OID 16800)
-- Name: courseactivity; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.courseactivity (
    id integer DEFAULT nextval('public.courseactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    courseid integer,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text
);


ALTER TABLE public.courseactivity OWNER TO imtsac;

--
-- TOC entry 211 (class 1259 OID 16439)
-- Name: coursecomment_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.coursecomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.coursecomment_id_seq OWNER TO imtsac;

--
-- TOC entry 268 (class 1259 OID 16810)
-- Name: coursecomment; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.coursecomment (
    id integer DEFAULT nextval('public.coursecomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    courseid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursecomment OWNER TO imtsac;

--
-- TOC entry 212 (class 1259 OID 16441)
-- Name: courseduration_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.courseduration_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.courseduration_id_seq OWNER TO imtsac;

--
-- TOC entry 269 (class 1259 OID 16830)
-- Name: courseduration; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.courseduration (
    id integer DEFAULT nextval('public.courseduration_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.courseduration OWNER TO imtsac;

--
-- TOC entry 213 (class 1259 OID 16443)
-- Name: coursefaq_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.coursefaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.coursefaq_id_seq OWNER TO imtsac;

--
-- TOC entry 270 (class 1259 OID 16840)
-- Name: coursefaq; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.coursefaq (
    id integer DEFAULT nextval('public.coursefaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    courseid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursefaq OWNER TO imtsac;

--
-- TOC entry 214 (class 1259 OID 16445)
-- Name: coursemode_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.coursemode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.coursemode_id_seq OWNER TO imtsac;

--
-- TOC entry 271 (class 1259 OID 16855)
-- Name: coursemode; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.coursemode (
    id integer DEFAULT nextval('public.coursemode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.coursemode OWNER TO imtsac;

--
-- TOC entry 215 (class 1259 OID 16447)
-- Name: coursereview_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.coursereview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.coursereview_id_seq OWNER TO imtsac;

--
-- TOC entry 272 (class 1259 OID 16865)
-- Name: coursereview; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.coursereview (
    id integer DEFAULT nextval('public.coursereview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    userid integer,
    courseid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursereview OWNER TO imtsac;

--
-- TOC entry 216 (class 1259 OID 16449)
-- Name: coursetype_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.coursetype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.coursetype_id_seq OWNER TO imtsac;

--
-- TOC entry 273 (class 1259 OID 16885)
-- Name: coursetype; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.coursetype (
    id integer DEFAULT nextval('public.coursetype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.coursetype OWNER TO imtsac;

--
-- TOC entry 274 (class 1259 OID 16898)
-- Name: cta_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.cta_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.cta_id_seq OWNER TO imtsac;

--
-- TOC entry 275 (class 1259 OID 16900)
-- Name: cta; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.cta (
    id integer DEFAULT nextval('public.cta_id_seq'::regclass) NOT NULL,
    title text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text
);


ALTER TABLE public.cta OWNER TO imtsac;

--
-- TOC entry 217 (class 1259 OID 16451)
-- Name: cta_id_seq_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.cta_id_seq_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.cta_id_seq_seq OWNER TO imtsac;

--
-- TOC entry 303 (class 1259 OID 17230)
-- Name: expertpage; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.expertpage (
    id integer NOT NULL,
    qualityassurancecell text,
    qualitycellimage text,
    training text,
    trainingimage text,
    qualityassuranceteam text,
    qualityteamimage text,
    aimqualityassurance text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.expertpage OWNER TO imtsac;

--
-- TOC entry 302 (class 1259 OID 17228)
-- Name: expertpage_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.expertpage_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.expertpage_id_seq OWNER TO imtsac;

--
-- TOC entry 3967 (class 0 OID 0)
-- Dependencies: 302
-- Name: expertpage_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: imtsac
--

ALTER SEQUENCE public.expertpage_id_seq OWNED BY public.expertpage.id;


--
-- TOC entry 218 (class 1259 OID 16453)
-- Name: faq_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.faq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.faq_id_seq OWNER TO imtsac;

--
-- TOC entry 276 (class 1259 OID 16910)
-- Name: faq; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.faq (
    id integer DEFAULT nextval('public.faq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.faq OWNER TO imtsac;

--
-- TOC entry 219 (class 1259 OID 16456)
-- Name: footer_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.footer_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.footer_id_seq OWNER TO imtsac;

--
-- TOC entry 277 (class 1259 OID 16920)
-- Name: footer; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.footer (
    id integer DEFAULT nextval('public.footer_id_seq'::regclass) NOT NULL,
    work text,
    trust text,
    distancemba text,
    ugcourse text,
    bestcollege text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    aboutwebsite text,
    playstore text,
    appstore text,
    facebook text,
    twitter text,
    instagram text,
    linkedin text,
    youtube text,
    contactus text,
    qr text,
    tagline text,
    tollno text,
    reserved text
);


ALTER TABLE public.footer OWNER TO imtsac;

--
-- TOC entry 220 (class 1259 OID 16458)
-- Name: header_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.header_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.header_id_seq OWNER TO imtsac;

--
-- TOC entry 278 (class 1259 OID 16930)
-- Name: header; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.header (
    id integer DEFAULT nextval('public.header_id_seq'::regclass) NOT NULL,
    title text,
    logo text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.header OWNER TO imtsac;

--
-- TOC entry 221 (class 1259 OID 16460)
-- Name: individualcourse_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.individualcourse_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.individualcourse_id_seq OWNER TO imtsac;

--
-- TOC entry 250 (class 1259 OID 16545)
-- Name: individualcourse; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.individualcourse (
    courename text,
    coursedescription text,
    noofyear text,
    noofmonth text,
    fee text,
    title text,
    seodescription text,
    image text,
    mode text,
    feature text,
    categorie text,
    added_date timestamp without time zone,
    added_by text,
    last_modified timestamp without time zone,
    detailcoursedescription text,
    whycourse text,
    whopursuecourse text,
    whentodocourse text,
    keyhighcourse text,
    eligibility text,
    skills text,
    other text,
    admission text,
    active text,
    toc text,
    last_modified_user text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    id integer DEFAULT nextval('public.individualcourse_id_seq'::regclass) NOT NULL,
    toch5 text[]
);


ALTER TABLE public.individualcourse OWNER TO imtsac;

--
-- TOC entry 222 (class 1259 OID 16462)
-- Name: individualcoursefaq_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.individualcoursefaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.individualcoursefaq_id_seq OWNER TO imtsac;

--
-- TOC entry 279 (class 1259 OID 16940)
-- Name: individualcoursefaq; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.individualcoursefaq (
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone,
    courseid integer,
    last_modified timestamp without time zone,
    id integer DEFAULT nextval('public.individualcoursefaq_id_seq'::regclass) NOT NULL
);


ALTER TABLE public.individualcoursefaq OWNER TO imtsac;

--
-- TOC entry 223 (class 1259 OID 16464)
-- Name: job_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.job_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.job_id_seq OWNER TO imtsac;

--
-- TOC entry 280 (class 1259 OID 16949)
-- Name: job; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.job (
    id integer DEFAULT nextval('public.job_id_seq'::regclass) NOT NULL,
    jobtype text,
    jobmode text,
    name text,
    location text,
    responsilibity text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.job OWNER TO imtsac;

--
-- TOC entry 224 (class 1259 OID 16466)
-- Name: jobmode_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.jobmode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.jobmode_id_seq OWNER TO imtsac;

--
-- TOC entry 281 (class 1259 OID 16960)
-- Name: jobmode; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.jobmode (
    id integer DEFAULT nextval('public.jobmode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobmode OWNER TO imtsac;

--
-- TOC entry 225 (class 1259 OID 16468)
-- Name: jobreference_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.jobreference_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.jobreference_id_seq OWNER TO imtsac;

--
-- TOC entry 282 (class 1259 OID 16970)
-- Name: jobreference; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.jobreference (
    id integer DEFAULT nextval('public.jobreference_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobreference OWNER TO imtsac;

--
-- TOC entry 226 (class 1259 OID 16470)
-- Name: jobresponse_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.jobresponse_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.jobresponse_id_seq OWNER TO imtsac;

--
-- TOC entry 283 (class 1259 OID 16980)
-- Name: jobresponse; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.jobresponse (
    id integer DEFAULT nextval('public.jobresponse_id_seq'::regclass) NOT NULL,
    jobtype text,
    name text,
    email text,
    reference text,
    resume text,
    experienceed text,
    isugpg text,
    hqualifuication text,
    ctc text,
    expereience text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modifed_date timestamp without time zone,
    phone text
);


ALTER TABLE public.jobresponse OWNER TO imtsac;

--
-- TOC entry 227 (class 1259 OID 16472)
-- Name: jobtype_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.jobtype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.jobtype_id_seq OWNER TO imtsac;

--
-- TOC entry 284 (class 1259 OID 16990)
-- Name: jobtype; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.jobtype (
    id integer DEFAULT nextval('public.jobtype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobtype OWNER TO imtsac;

--
-- TOC entry 228 (class 1259 OID 16474)
-- Name: lead_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.lead_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.lead_id_seq OWNER TO imtsac;

--
-- TOC entry 285 (class 1259 OID 17000)
-- Name: lead; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.lead (
    id integer DEFAULT nextval('public.lead_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    phone text,
    courseid integer,
    universityid integer,
    city text,
    message text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.lead OWNER TO imtsac;

--
-- TOC entry 229 (class 1259 OID 16476)
-- Name: media_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.media_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.media_id_seq OWNER TO imtsac;

--
-- TOC entry 286 (class 1259 OID 17020)
-- Name: media; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.media (
    id integer DEFAULT nextval('public.media_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.media OWNER TO imtsac;

--
-- TOC entry 230 (class 1259 OID 16478)
-- Name: moreresource_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.moreresource_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.moreresource_id_seq OWNER TO imtsac;

--
-- TOC entry 287 (class 1259 OID 17030)
-- Name: moreresource; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.moreresource (
    id integer DEFAULT nextval('public.moreresource_id_seq'::regclass) NOT NULL,
    button1 text,
    button2 text,
    button3 text,
    button4 text,
    button5 text,
    button6 text,
    newstudent text,
    visitus text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.moreresource OWNER TO imtsac;

--
-- TOC entry 231 (class 1259 OID 16480)
-- Name: news_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.news_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.news_id_seq OWNER TO imtsac;

--
-- TOC entry 288 (class 1259 OID 17040)
-- Name: news; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.news (
    id integer DEFAULT nextval('public.news_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    image text,
    added_by text,
    last_modified date,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.news OWNER TO imtsac;

--
-- TOC entry 232 (class 1259 OID 16482)
-- Name: onestep_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.onestep_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.onestep_id_seq OWNER TO imtsac;

--
-- TOC entry 289 (class 1259 OID 17050)
-- Name: onestep; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.onestep (
    id integer DEFAULT nextval('public.onestep_id_seq'::regclass) NOT NULL,
    slider text[],
    steps text[],
    icon text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modifid_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.onestep OWNER TO imtsac;

--
-- TOC entry 233 (class 1259 OID 16484)
-- Name: specialization_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.specialization_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.specialization_id_seq OWNER TO imtsac;

--
-- TOC entry 251 (class 1259 OID 16554)
-- Name: specialization; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.specialization (
    id integer DEFAULT nextval('public.specialization_id_seq'::regclass) NOT NULL,
    courseid integer,
    specialization text,
    specializationcode text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.specialization OWNER TO imtsac;

--
-- TOC entry 234 (class 1259 OID 16486)
-- Name: specializationactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.specializationactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.specializationactivity_id_seq OWNER TO imtsac;

--
-- TOC entry 290 (class 1259 OID 17060)
-- Name: specializationactivity; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.specializationactivity (
    id integer DEFAULT nextval('public.specializationactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    spid integer,
    role text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.specializationactivity OWNER TO imtsac;

--
-- TOC entry 235 (class 1259 OID 16488)
-- Name: staff_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.staff_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.staff_id_seq OWNER TO imtsac;

--
-- TOC entry 291 (class 1259 OID 17070)
-- Name: staff; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.staff (
    id integer DEFAULT nextval('public.staff_id_seq'::regclass) NOT NULL,
    name text,
    expert text,
    experience text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    designation text
);


ALTER TABLE public.staff OWNER TO imtsac;

--
-- TOC entry 236 (class 1259 OID 16490)
-- Name: state_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.state_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.state_id_seq OWNER TO imtsac;

--
-- TOC entry 292 (class 1259 OID 17080)
-- Name: state; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.state (
    id integer DEFAULT nextval('public.state_id_seq'::regclass) NOT NULL,
    name text,
    country text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.state OWNER TO imtsac;

--
-- TOC entry 237 (class 1259 OID 16492)
-- Name: stream_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.stream_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stream_id_seq OWNER TO imtsac;

--
-- TOC entry 293 (class 1259 OID 17090)
-- Name: stream; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.stream (
    id integer DEFAULT nextval('public.stream_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    streammenu text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.stream OWNER TO imtsac;

--
-- TOC entry 238 (class 1259 OID 16494)
-- Name: studymode_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.studymode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.studymode_id_seq OWNER TO imtsac;

--
-- TOC entry 294 (class 1259 OID 17100)
-- Name: studymode; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.studymode (
    id integer DEFAULT nextval('public.studymode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.studymode OWNER TO imtsac;

--
-- TOC entry 239 (class 1259 OID 16496)
-- Name: subject_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.subject_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.subject_id_seq OWNER TO imtsac;

--
-- TOC entry 253 (class 1259 OID 16594)
-- Name: subject; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.subject (
    id integer DEFAULT nextval('public.subject_id_seq'::regclass) NOT NULL,
    course integer,
    specialization integer,
    subject text[],
    subjectcode text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    semsteroryear text,
    noofsemsteroryear text
);


ALTER TABLE public.subject OWNER TO imtsac;

--
-- TOC entry 240 (class 1259 OID 16498)
-- Name: superuser_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.superuser_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.superuser_id_seq OWNER TO imtsac;

--
-- TOC entry 295 (class 1259 OID 17110)
-- Name: superuser; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.superuser (
    id integer DEFAULT nextval('public.superuser_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    username text,
    password text,
    designation text,
    specialization text,
    about text,
    gender text,
    profile text,
    fb text,
    linkedin text,
    permission text[],
    access text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    modified_by text
);


ALTER TABLE public.superuser OWNER TO imtsac;

--
-- TOC entry 196 (class 1259 OID 16394)
-- Name: university_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.university_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.university_id_seq OWNER TO imtsac;

--
-- TOC entry 248 (class 1259 OID 16514)
-- Name: university; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.university (
    id integer DEFAULT nextval('public.university_id_seq'::regclass) NOT NULL,
    uname character varying(150),
    established character varying(200),
    officemailid character varying(300),
    approvedby character varying(200),
    coursetype character varying(300),
    stream character varying(500),
    studymode character varying(300),
    universitytype character varying(300),
    websiteurl character varying(200),
    state character varying(340),
    city character varying(400),
    logourl character varying(400),
    imageurl character varying[],
    videourl character varying[],
    fblink character varying(240),
    twitterlink character varying(500),
    linkedin character varying(500),
    instagram character varying(500),
    toc character varying(300),
    smode character varying(400),
    feature character varying(300),
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    nip text,
    about text,
    fact text,
    emi text,
    admission text,
    active text,
    urlname text,
    seotitle text,
    seodescription text,
    toccontent text[],
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    prospectus text,
    last_modified_by text,
    added_by integer,
    zone text
);


ALTER TABLE public.university OWNER TO imtsac;

--
-- TOC entry 241 (class 1259 OID 16500)
-- Name: universityactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universityactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universityactivity_id_seq OWNER TO imtsac;

--
-- TOC entry 296 (class 1259 OID 17120)
-- Name: universityactivity; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universityactivity (
    id integer DEFAULT nextval('public.universityactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    modified_date timestamp without time zone,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text,
    universityid text
);


ALTER TABLE public.universityactivity OWNER TO imtsac;

--
-- TOC entry 242 (class 1259 OID 16502)
-- Name: universitycomment_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universitycomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universitycomment_id_seq OWNER TO imtsac;

--
-- TOC entry 297 (class 1259 OID 17136)
-- Name: universitycomment; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universitycomment (
    id integer DEFAULT nextval('public.universitycomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    universityid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.universitycomment OWNER TO imtsac;

--
-- TOC entry 243 (class 1259 OID 16504)
-- Name: universityfaq_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universityfaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universityfaq_id_seq OWNER TO imtsac;

--
-- TOC entry 298 (class 1259 OID 17156)
-- Name: universityfaq; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universityfaq (
    id integer DEFAULT nextval('public.universityfaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    universityid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.universityfaq OWNER TO imtsac;

--
-- TOC entry 309 (class 1259 OID 17280)
-- Name: universitylisteningstep; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universitylisteningstep (
    id integer NOT NULL,
    step1 text,
    step2 text,
    step3 text,
    step4 text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_date timestamp without time zone,
    last_modified_by text
);


ALTER TABLE public.universitylisteningstep OWNER TO imtsac;

--
-- TOC entry 308 (class 1259 OID 17278)
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universitylisteningstep_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universitylisteningstep_id_seq OWNER TO imtsac;

--
-- TOC entry 4024 (class 0 OID 0)
-- Dependencies: 308
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: imtsac
--

ALTER SEQUENCE public.universitylisteningstep_id_seq OWNED BY public.universitylisteningstep.id;


--
-- TOC entry 244 (class 1259 OID 16506)
-- Name: universityreview_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universityreview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universityreview_id_seq OWNER TO imtsac;

--
-- TOC entry 299 (class 1259 OID 17171)
-- Name: universityreview; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universityreview (
    id integer DEFAULT nextval('public.universityreview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    universityid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.universityreview OWNER TO imtsac;

--
-- TOC entry 245 (class 1259 OID 16508)
-- Name: universitytype_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.universitytype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.universitytype_id_seq OWNER TO imtsac;

--
-- TOC entry 300 (class 1259 OID 17191)
-- Name: universitytype; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.universitytype (
    id integer DEFAULT nextval('public.universitytype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.universitytype OWNER TO imtsac;

--
-- TOC entry 246 (class 1259 OID 16510)
-- Name: users_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.users_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.users_id_seq OWNER TO imtsac;

--
-- TOC entry 260 (class 1259 OID 16699)
-- Name: users; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.users (
    id integer DEFAULT nextval('public.users_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    phone text,
    city text,
    country text,
    gender text,
    password text,
    added_by text,
    last_modified date,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    courseid integer,
    dob text
);


ALTER TABLE public.users OWNER TO imtsac;

--
-- TOC entry 247 (class 1259 OID 16512)
-- Name: zone_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac
--

CREATE SEQUENCE public.zone_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.zone_id_seq OWNER TO imtsac;

--
-- TOC entry 301 (class 1259 OID 17201)
-- Name: zone; Type: TABLE; Schema: public; Owner: imtsac
--

CREATE TABLE public.zone (
    id integer DEFAULT nextval('public.zone_id_seq'::regclass) NOT NULL,
    name text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone,
    status text
);


ALTER TABLE public.zone OWNER TO imtsac;

--
-- TOC entry 3527 (class 2604 OID 17248)
-- Name: aboutpage id; Type: DEFAULT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.aboutpage ALTER COLUMN id SET DEFAULT nextval('public.aboutpage_id_seq'::regclass);


--
-- TOC entry 3529 (class 2604 OID 17260)
-- Name: contactus id; Type: DEFAULT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.contactus ALTER COLUMN id SET DEFAULT nextval('public.contactus_id_seq'::regclass);


--
-- TOC entry 3525 (class 2604 OID 17233)
-- Name: expertpage id; Type: DEFAULT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.expertpage ALTER COLUMN id SET DEFAULT nextval('public.expertpage_id_seq'::regclass);


--
-- TOC entry 3531 (class 2604 OID 17283)
-- Name: universitylisteningstep id; Type: DEFAULT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitylisteningstep ALTER COLUMN id SET DEFAULT nextval('public.universitylisteningstep_id_seq'::regclass);


--
-- TOC entry 3903 (class 0 OID 17245)
-- Dependencies: 305
-- Data for Name: aboutpage; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.aboutpage (id, heading, description, content, added_by, added_date, last_modified_by, last_modified_date, moreabout) FROM stdin;
6	About Us		<div class="elementor-element elementor-element-c413a9a elementor-widget elementor-widget-heading" data-id="c413a9a" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box; text-align: center;"><span style="box-sizing: border-box; color: rgb(255, 102, 0);">WHO WE ARE</span></div></div><div class="elementor-element elementor-element-be9b7ae elementor-widget elementor-widget-heading" data-id="be9b7ae" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Offers The Highest Quality Online Learning And Distance Learning Courses.</h2></div></div><div class="elementor-element elementor-element-484fbd7 elementor-widget elementor-widget-text-editor" data-id="484fbd7" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box;"><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS institute is an educational institute with highly qualified, adept teachers and more than 350 Employee. IMTS Institute aims to provide quality education to all its students, no matter what their location. Primarily geared toward career-oriented students, IMTS Institute strives to make its students reach the pinnacle of their success with its quality education.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS Education is the process of facilitating learning, or the acquisition of knowledge, skills, values, beliefs, and habits. Educational methods include storytelling, discussion, teaching, training, and directed research. Education frequently takes place under the guidance of educators, but learners may also educate themselves.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Core belief of IMTS is that every student should get accurate information and assistance before they choose that would become a stepping-stone towards their bright future.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;"><strong style="box-sizing: border-box; font-weight: 600;">Knowledge and guidance with IMTS institute</strong></p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Career education and leadership play an essential role in the curriculum that supports: student’s interests, strengths, and aspirations. With multiple career options available in the market, it gives students a tough time in selecting the right course for themselves that would help them nurture in the right direction. In the majority of the cases, either student ends up opting for a course that does not align with their plans or take up a job that varies completely from the path they had pursued.</p></div></div>	1	2024-07-30 10:42:58.57088	\N	\N	<section class="elementor-section elementor-top-section elementor-element elementor-element-7319234 elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="7319234" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-top-column elementor-element elementor-element-fb8b4d9" data-id="fb8b4d9" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-afb88c1 elementor-widget elementor-widget-heading" data-id="afb88c1" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-xl" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Institute Assisted 25000+ Students to Achieve their Professional Goals after the Covid-19 Epidemic</h2></div></div></div></div></div></section><section class="elementor-section elementor-top-section elementor-element elementor-element-ff64faa elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="ff64faa" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-top-column elementor-element elementor-element-8f98539" data-id="8f98539" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-d69e989 elementor-widget elementor-widget-text-editor" data-id="d69e989" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h3 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 16px !important;">The New Wave</h3><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">It is critical to recognize the relevance of technology in education, even if you are neither a student nor an educator. While many individuals prefer traditional teaching techniques, the opportunities when technology is introduced into the classroom are limitless. For one thing, education has become much more accessible, with a wider range of learning styles and degree alternatives.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">It can undoubtedly assist educators in tracking individual progress and devising novel instructional plans. Students who learn through technology, on the other hand, can develop a set of skills that will aid them in their future employment. Teachers should evaluate why students want rather than need technology in the classroom to get the most out of these tools.</p><h2 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important;">IMTS to the Rescue</h2><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Due to the unpredictable nature of the Covid-19 pandemic, schools were obliged to halt physical education classes in order to combat the virus. As a result, many students could not obtain the education they desired. IMTS’s contemporary teaching methods proved to be a big success.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">The educational institution aimed to give high-quality education to all of its pupils, regardless of their geographic location, with over 350 career counsellors and highly-skilled, qualified teachers. IMTS Institute, primarily focused on career-oriented students, aims to help them achieve the peak of their accomplishment through superior education.</p><h2 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important;">Online learning</h2><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Learning from home or modern communication paradigms has tremendously facilitated online learning. Individuals can attend lectures via distance education even if the lecturer is on another continent. During the global pandemic of 2020, when schools were compelled to close and fully transition to distance learning, this teaching style became incredibly crucial. Even before that, online courses were popular because they provided knowledge to those who wanted to grow in their careers but didn’t have the time or money to do so.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">When it comes to the formation of critical thinking, the role of technology in education is especially clear. Different educational techniques enable pupils to express themselves in unique ways, resulting in various solutions. They approach information seriously in this process, considering each accessible piece of data to arrive at the intended result.</p><h3 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 16px !important;">Technology’s Potential in Education</h3><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">As you can see, technology plays a huge role in education, and its influence is rising. However, it is critical to properly incorporate technology in education because many old teaching methods should be preserved. Furthermore, the computer is not appropriate for all situations, nor is studying with it always more efficient. As a result, teachers must balance future-ready education and traditional offline instruction.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">In the uncertain times of Covid-19, IMTS has achieved its objective of educating 25000 students, and it has made it a slogan to ensure that students receive quality education through modern means. They will be up to date on the latest technologies and will be able to ensure that their education is of maximum practical use in the real world.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;"><section class="elementor-section elementor-inner-section elementor-element elementor-element-fbceeba elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="fbceeba" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-inner-column elementor-element elementor-element-1fbed1e" data-id="1fbed1e" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-7c9a633 elementor-widget elementor-widget-heading" data-id="7c9a633" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box; text-align: center;"><span class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; color: rgb(255, 102, 0);">TESTIMONIAL</span></div></div><div class="elementor-element elementor-element-0da93ad elementor-widget elementor-widget-heading" data-id="0da93ad" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Institute Delivers World-Class Education With A 99% Pass Rate: 40% Alumni Working Abroad</h2></div></div></div></div></div></section><section class="elementor-section elementor-inner-section elementor-element elementor-element-c1a2896 elementor-section-full_width elementor-section-height-default elementor-section-height-default" data-id="c1a2896" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-inner-column elementor-element elementor-element-6789b75" data-id="6789b75" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-2f0690c elementor-widget elementor-widget-text-editor" data-id="2f0690c" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">For the past 17 years, around 50k students have been satisfied with the assistance and services provided by IMTS. The mentors are highly skilled in their fields and work. They have been leading MNC’s such as IBM, HCL, Google, BSF, Government Indian Army, BSF, CISF, SBI ETC. Jobs and others .For students to improve their professional and personal abilities, IMTS Institute provides the best possible support to students. 99% of students Get their diplomas on schedule.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">The IMTS institution has benefited over 50,000 students. They offer excellent career counseling in which specialists advise students on the breadth of each topic. This allows students to live a stress-free life after passing their Class 12 exams. They can determine which topics are best based on a student’s abilities. It is an ideal environment for those who desire to advance and achieve in their chosen area.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Strong reputation among Indian students</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS Institute is a prestigious institute. It has already established a strong reputation among Indian students, and it is now accepting international students as well. It helps students to fly in the sky of boundless knowledge. IMTS provides course after 12th information as well as assistance to students with projects and assignments.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">To avoid any carelessness on the part of the students, IMTS keeps them up to speed on the newest rules, regulations, and announcements issued by the institutions.</p></div></div></div></div></div></section></p></div></div></div></div></div></section>
\.


--
-- TOC entry 3850 (class 0 OID 16574)
-- Dependencies: 252
-- Data for Name: acdemicspecialization; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.acdemicspecialization (id, universityid, courseid, specialization, specializationcode, coursefee, examfee, registrationfee, added_date, added_by, last_modified) FROM stdin;
\.


--
-- TOC entry 3854 (class 0 OID 16644)
-- Dependencies: 256
-- Data for Name: alumni; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.alumni (id, name, image, added_by, added_date) FROM stdin;
18	download.jpeg	download.jpeg	1	2024-07-29 09:48:10.156318
19	images (1).jpeg	images (1).jpeg	1	2024-07-29 09:48:17.05841
20	images (2).jpeg	images (2).jpeg	1	2024-07-29 09:48:26.530984
21	images (3).jpeg	images (3).jpeg	1	2024-07-29 09:48:33.790345
22	images (4).jpeg	images (4).jpeg	1	2024-07-29 09:48:40.913245
23	images (5).jpeg	images (5).jpeg	1	2024-07-29 09:48:47.633629
24	images (6).jpeg	images (6).jpeg	1	2024-07-29 09:48:55.208164
25	images (7).jpeg	images (7).jpeg	1	2024-07-29 09:49:02.522484
26	images (8).jpeg	images (8).jpeg	1	2024-07-29 09:49:10.91477
27	images.jpeg	images.jpeg	1	2024-07-29 09:49:18.181863
\.


--
-- TOC entry 3855 (class 0 OID 16654)
-- Dependencies: 257
-- Data for Name: approved; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.approved (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	UGC	Active	1	2024-07-26 05:50:28.22642	\N	\N
\.


--
-- TOC entry 3856 (class 0 OID 16664)
-- Dependencies: 258
-- Data for Name: backup; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.backup (id, filepath, added_date, mode) FROM stdin;
1	imtsonline_vidhya_college-2024-7-19.sql	2024-07-19 00:00:00.814235	Auto
2	imtsac_educationdunia-2024-7-20.sql	2024-07-20 00:00:00.775215	Auto
3	imtsac_educationdunia-2024-7-21.sql	2024-07-21 00:00:00.349357	Auto
4	imtsac_educationdunia-2024-7-22.sql	2024-07-22 00:00:00.276621	Auto
5	imtsac_educationdunia-2024-7-23.sql	2024-07-23 00:00:00.970417	Auto
6	imtsac_educationdunia-2024-7-24.sql	2024-07-24 00:00:00.432669	Auto
7	imtsac_educationdunia-2024-7-25.sql	2024-07-25 00:00:00.311874	Auto
8	imtsac_educationdunia-2024-7-26.sql	2024-07-26 00:00:00.258535	Auto
9	imtsac_educationdunia-2024-7-27.sql	2024-07-27 00:00:00.369742	Auto
10	imtsac_educationdunia-2024-7-28.sql	2024-07-28 00:00:00.190199	Auto
11	imtsac_educationdunia-2024-7-29.sql	2024-07-29 00:00:00.199108	Auto
12	imtsac_educationdunia-2024-7-30.sql	2024-07-30 00:00:00.75426	Auto
13	imtsac_educationdunia-2024-7-31.sql	2024-07-31 00:00:00.243921	Auto
14	imtsac_educationdunia-2024-8-1.sql	2024-08-01 00:00:00.191832	Auto
15	imtsac_educationdunia-2024-8-2.sql	2024-08-02 00:00:00.659873	Auto
16	imtsac_educationdunia-2024-8-3.sql	2024-08-03 00:00:00.466356	Auto
17	imtsac_educationdunia-2024-8-4.sql	2024-08-04 00:00:00.275203	Auto
\.


--
-- TOC entry 3857 (class 0 OID 16674)
-- Dependencies: 259
-- Data for Name: banner; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.banner (id, name, image, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
28	Ibrahim	Blue Modern Photo Technology YouTube Banner (2).jpg	1	2024-07-29 09:55:53.910817	\N	\N
\.


--
-- TOC entry 3853 (class 0 OID 16634)
-- Dependencies: 255
-- Data for Name: blog; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.blog (id, pagename, seotitle, seodescription, tag, status, topic, image, content, added_date, added_by, last_modified, feature, toc, active, urlname, toch1, toch2, toch3, toch4, toch5, layout) FROM stdin;
\.


--
-- TOC entry 3859 (class 0 OID 16714)
-- Dependencies: 261
-- Data for Name: blogcomment; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.blogcomment (id, title, description, blogid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3860 (class 0 OID 16734)
-- Dependencies: 262
-- Data for Name: blogfaq; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.blogfaq (id, question, answer, added_by, added_date, blogid, last_modified) FROM stdin;
\.


--
-- TOC entry 3861 (class 0 OID 16749)
-- Dependencies: 263
-- Data for Name: blogreview; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.blogreview (id, rating, detail, userid, blogid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3852 (class 0 OID 16614)
-- Dependencies: 254
-- Data for Name: book; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.book (id, specialization, subject, title, url, added_date, added_by, last_modified) FROM stdin;
\.


--
-- TOC entry 3862 (class 0 OID 16770)
-- Dependencies: 264
-- Data for Name: city; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.city (id, name, state, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Jhansi	1	1	2024-07-26 05:48:16.382408	\N	\N
\.


--
-- TOC entry 3863 (class 0 OID 16780)
-- Dependencies: 265
-- Data for Name: collegetype; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.collegetype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Reguler	Active	1	2024-07-26 05:53:32.442195	\N	\N
\.


--
-- TOC entry 3905 (class 0 OID 17257)
-- Dependencies: 307
-- Data for Name: contactus; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.contactus (id, email, contactnumber, officeaddress, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
2	cvx	vxcv	cxvx	1	2024-07-28 18:46:37.413456	\N	\N
\.


--
-- TOC entry 3864 (class 0 OID 16790)
-- Dependencies: 266
-- Data for Name: country; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.country (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Ibrahim Memon	Active	1	2024-07-18 11:44:05.268494	\N	\N
2	India	Active	1	2024-07-26 05:46:25.814245	\N	\N
\.


--
-- TOC entry 3847 (class 0 OID 16524)
-- Dependencies: 249
-- Data for Name: course; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.course (id, courename, coursedescription, noofyear, noofmonth, fee, title, seodescription, image, mode, feature, categorie, added_date, added_by, last_modified, detailcoursedescription, whycourse, whopursuecourse, whentodocourse, keyhighcourse, eligibility, skills, other, admission, active, toc, last_modified_user, urlname, toch1, toch2, toch3, toch4, universityid, toch5) FROM stdin;
1	MCA	xcsadsFees		1	50000	grefgfg	fgfgfdg	\N	0		pgCourses	2024-07-26 05:59:44.152256	1	\N	<p>Enter Content Herefgfdgfcdf</p>									Active		\N	dsasa-	{}	{}	{}	{}	{1}	{}
2	IIM Courses Online	cvbcv		1	5345			\N	0		ugCourses	2024-07-26 12:37:27.643517	1	\N	Enter Content Here											\N	gdg	{}	{}	{}	{}	{2}	{}
\.


--
-- TOC entry 3865 (class 0 OID 16800)
-- Dependencies: 267
-- Data for Name: courseactivity; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.courseactivity (id, superuserid, content, courseid, added_date, role) FROM stdin;
1	1	{}	1	2024-07-26 05:59:44.155483	Add
2	1	{}	1	2024-07-26 06:31:02.266679	Delete
3	1	{}	1	2024-07-26 06:31:24.172555	Delete
4	1	{}	1	2024-07-26 09:30:48.792657	Delete
5	1	{}	1	2024-07-26 09:31:10.293753	Delete
6	1	{}	1	2024-07-26 09:31:11.123597	Delete
7	1	{}	1	2024-07-26 09:31:11.642682	Delete
8	1	{}	1	2024-07-26 09:31:12.702408	Delete
9	1	{}	1	2024-07-26 09:31:48.817554	Delete
10	1	{}	1	2024-07-26 09:32:10.307856	Delete
11	1	{}	1	2024-07-26 11:15:53.510967	Delete
12	1	{}	1	2024-07-26 11:16:07.599959	Delete
13	1	{}	1	2024-07-26 11:16:28.730142	Delete
14	1	{}	1	2024-07-26 11:16:28.949457	Delete
15	1	{}	1	2024-07-26 11:43:47.308038	Delete
16	1	{}	1	2024-07-26 11:44:09.185356	Delete
17	1	{}	1	2024-07-26 11:44:47.324106	Delete
18	1	{}	1	2024-07-26 11:45:09.19547	Delete
19	1	{}	1	2024-07-26 11:52:49.507211	Delete
20	1	{}	1	2024-07-26 11:53:49.526686	Delete
21	1	{}	1	2024-07-26 12:04:09.322744	Delete
22	1	{}	1	2024-07-26 12:05:09.321823	Delete
23	1	{}	1	2024-07-26 12:07:03.454063	Delete
24	1	{}	1	2024-07-26 12:09:48.245329	Delete
26	1	{}	2	2024-07-26 12:37:27.64592	Add
\.


--
-- TOC entry 3866 (class 0 OID 16810)
-- Dependencies: 268
-- Data for Name: coursecomment; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.coursecomment (id, title, description, courseid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3867 (class 0 OID 16830)
-- Dependencies: 269
-- Data for Name: courseduration; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.courseduration (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	@ Year	Active	1	2024-07-26 05:51:34.627007	\N	\N
\.


--
-- TOC entry 3868 (class 0 OID 16840)
-- Dependencies: 270
-- Data for Name: coursefaq; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.coursefaq (id, question, answer, added_by, added_date, courseid, last_modified) FROM stdin;
2	{}	{}	1	2024-07-26 12:37:27.647581	2	\N
\.


--
-- TOC entry 3869 (class 0 OID 16855)
-- Dependencies: 271
-- Data for Name: coursemode; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.coursemode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 3870 (class 0 OID 16865)
-- Dependencies: 272
-- Data for Name: coursereview; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.coursereview (id, rating, detail, userid, courseid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3871 (class 0 OID 16885)
-- Dependencies: 273
-- Data for Name: coursetype; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.coursetype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	MCA	Active	1	2024-07-26 05:50:44.968336	1	2024-07-25 16:31:19
\.


--
-- TOC entry 3873 (class 0 OID 16900)
-- Dependencies: 275
-- Data for Name: cta; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.cta (id, title, added_date, added_by) FROM stdin;
1	a	2024-07-26 06:14:20.856679	1
2	a	2024-07-26 06:15:11.846517	1
3	CN	2024-07-26 08:55:10.512568	1
4	Consult Now	2024-07-26 08:58:17.699574	1
5	h	2024-07-26 09:29:56.803243	1
6	H	2024-07-26 12:02:45.432159	1
8	IMTS	2024-08-03 15:57:02.265788	1
\.


--
-- TOC entry 3901 (class 0 OID 17230)
-- Dependencies: 303
-- Data for Name: expertpage; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.expertpage (id, qualityassurancecell, qualitycellimage, training, trainingimage, qualityassuranceteam, qualityteamimage, aimqualityassurance, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
3	<p><strong style="font-size: 24px;">Empowering Futures, One Student at a Time</strong></p><p><span style="font-size: 16px;">At IMTS Institute, we specialize in providing comprehensive admission consulting services for students seeking higher education. Our mission is to guide you through the intricate admissions process, helping you make informed decisions that align with your academic and career aspirations.</span><br></p>	career.webp	<p><strong style="font-size: 24px;">Why Choose IMTS Institute?</strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">1. Expertise and Experience</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">With years of experience in the education sector, our team of seasoned consultants possesses in-depth knowledge of admission requirements, application processes, and educational systems worldwide. We stay abreast of the latest trends and changes in the education landscape to offer you the most accurate and up-to-date advice.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">2. Personalized Guidance</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We understand that each student has unique goals and aspirations. Our personalized consulting services are tailored to meet your individual needs. Whether you aim for undergraduate, postgraduate, or professional courses, we provide customized strategies to enhance your application and increase your chances of acceptance.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">3. Comprehensive Services</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">From selecting the right course and university to preparing compelling application essays, IMTS Institute offers a wide range of services, including:</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Course and University Selection</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Based on your interests, academic background, and career goals, we help you choose the best-fit courses and institutions.</span></strong></p></li><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Application Assistance</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Our experts assist you in crafting standout applications, including personal statements, letters of recommendation, and resumes.</span></strong></p></li></ul><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">4. Proven Success</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our track record speaks for itself. IMTS Institute has successfully guided numerous students to prestigious institutions worldwide. We take pride in our students' achievements and are committed to helping you reach their full potential.</span></strong></p><br>	Medium.jpg	<p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;">Our Process</span></strong></p><p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;"><strong style="font-weight:normal;" id="docs-internal-guid-4f0e739b-7fff-d7be-48bb-24a796dba9c5"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 1: Initial Consultation</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We start with an in-depth consultation to understand your academic background, interests, and career goals. This helps us tailor our services to your specific needs.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 2: Strategic Planning</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Based on our initial consultation, we developed a personalized admission strategy. This includes a list of recommended courses and universities, as well as a timeline for completing your application.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 3: Application Development</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our consultants work closely with you to develop a compelling application. We provide feedback on your essays, resumes, and other application materials to ensure they reflect your strengths and aspirations.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 4: Review and Submission</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We conduct a thorough review of your application before submission, ensuring all components are polished and error-free. We also help you navigate the submission process to meet all deadlines.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 5: Post-Application Support</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">After submitting your applications, we continue to support you through interview preparation and provide guidance on accepting offers and preparing for your educational journey.</span></p><br></strong></span></strong></p>		<p>&nbsp;<br></p>	1	2024-07-30 09:46:51.670604	\N	\N
4	<p><strong style="font-size: 24px;">Empowering Futures, One Student at a Time</strong></p><p><span style="font-size: 16px;">At IMTS Institute, we specialize in providing comprehensive admission consulting services for students seeking higher education. Our mission is to guide you through the intricate admissions process, helping you make informed decisions that align with your academic and career aspirations.</span><br></p>	career.webp	<p><strong style="font-size: 24px;">Why Choose IMTS Institute?</strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">1. Expertise and Experience</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">With years of experience in the education sector, our team of seasoned consultants possesses in-depth knowledge of admission requirements, application processes, and educational systems worldwide. We stay abreast of the latest trends and changes in the education landscape to offer you the most accurate and up-to-date advice.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">2. Personalized Guidance</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We understand that each student has unique goals and aspirations. Our personalized consulting services are tailored to meet your individual needs. Whether you aim for undergraduate, postgraduate, or professional courses, we provide customized strategies to enhance your application and increase your chances of acceptance.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">3. Comprehensive Services</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">From selecting the right course and university to preparing compelling application essays, IMTS Institute offers a wide range of services, including:</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Course and University Selection</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Based on your interests, academic background, and career goals, we help you choose the best-fit courses and institutions.</span></strong></p></li><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Application Assistance</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Our experts assist you in crafting standout applications, including personal statements, letters of recommendation, and resumes.</span></strong></p></li></ul><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">4. Proven Success</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our track record speaks for itself. IMTS Institute has successfully guided numerous students to prestigious institutions worldwide. We take pride in our students' achievements and are committed to helping you reach their full potential.</span></strong></p><br>	Medium.jpg	<p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;">Our Process</span></strong></p><p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;"><strong style="font-weight:normal;" id="docs-internal-guid-4f0e739b-7fff-d7be-48bb-24a796dba9c5"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 1: Initial Consultation</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We start with an in-depth consultation to understand your academic background, interests, and career goals. This helps us tailor our services to your specific needs.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 2: Strategic Planning</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Based on our initial consultation, we developed a personalized admission strategy. This includes a list of recommended courses and universities, as well as a timeline for completing your application.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 3: Application Development</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our consultants work closely with you to develop a compelling application. We provide feedback on your essays, resumes, and other application materials to ensure they reflect your strengths and aspirations.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 4: Review and Submission</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We conduct a thorough review of your application before submission, ensuring all components are polished and error-free. We also help you navigate the submission process to meet all deadlines.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 5: Post-Application Support</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">After submitting your applications, we continue to support you through interview preparation and provide guidance on accepting offers and preparing for your educational journey.</span></p><br></strong></span></strong></p>	download (1).jpeg	<p>&nbsp;<br></p>	1	2024-07-30 09:47:58.218784	\N	\N
\.


--
-- TOC entry 3874 (class 0 OID 16910)
-- Dependencies: 276
-- Data for Name: faq; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.faq (id, question, answer, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	{"Q1: What is the admission process at IMTS Institute","What are the eligibility criteria for undergraduate programs","Can I apply for multiple courses simultaneously","What documents are required for the admission process","What types of courses does IMTS Institute offer","Are the courses offered by IMTS Institute recognized","Does IMTS Institute offer online courses"}	{"The admission process at IMTS Institute involves filling out the online application form","submitting the required documents","and paying the application fee. For specific courses","there might be entrance exams or interviews","For undergraduate programs","candidates must have completed their 10+2 education from a recognized board with the required percentage as specified by the course",Yes,"you can apply for multiple courses","but you need to fill out separate application forms and pay the application fee for each course","Required documents include educational certificates","identity proof","passport-sized photographs","and any other documents specified by the course requirements.\nCourses and Programs","IMTS Institute offers a variety of courses","including undergraduate",postgraduate,diploma,"and certificate programs in fields such as management",engineering,"computer applications","and more.",Yes,"all courses offered by IMTS Institute are recognized by relevant educational authorities and are designed to meet industry standards",Yes,"IMTS Institute offers several online courses that provide flexibility and convenience for students who cannot attend on-campus classes"}	1	2024-07-23 12:11:22.349281	\N	\N
\.


--
-- TOC entry 3875 (class 0 OID 16920)
-- Dependencies: 277
-- Data for Name: footer; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.footer (id, work, trust, distancemba, ugcourse, bestcollege, added_by, added_date, aboutwebsite, playstore, appstore, facebook, twitter, instagram, linkedin, youtube, contactus, qr, tagline, tollno, reserved) FROM stdin;
2			<h2 class="widget-title">Distance Courses</h2><div class="textwidget"><p><a href="https://dde.imtsinstitute.com/ba-distance-education/">BA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/bsc-distance-education/">BSC Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/b-com-distance-education-admission/">BCOM Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/bba-management-distance-education/">BBA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/ma-distance-education/">MA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/msc-distance-education/">MSC Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mcom-distance-education/">MCOM Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-distance-education/">MBA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-it-distance-education/" target="_blank" rel="noopener">MBA IT Distance education</a></p><p><a href="https://dde.imtsinstitute.com/mba-human-resource-management-distance-education/">MBA HR Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-hospital-management-distance-education/">MBA Hospital Management</a></p><p><a href="https://dde.imtsinstitute.com/m-sc-in-information-technology-dde/">MSC IT Distance education</a></p></div>	<h2 class="widget-title">Courses</h2><div class="textwidget"><p><a href="https://imtsinstitute.com/ba/">BA Course</a></p><p><a href="https://imtsinstitute.com/bcom/">BCOM Course</a></p><p><a href="https://imtsinstitute.com/bsc/">BSC Course</a></p><p><a href="https://imtsinstitute.com/bba/">BBA Course</a></p><p><a href="https://imtsinstitute.com/bbm/">BBM Course</a></p><p><a href="https://imtsinstitute.com/bca/">BCA Course</a></p><p><a href="https://imtsinstitute.com/mba/">MBA Course</a></p><p><a href="https://imtsinstitute.com/mca/">MCA Course</a></p><p><a href="https://imtsinstitute.com/mcom/">MCom Course</a></p><p><a href="https://imtsinstitute.com/msc/">MSC Course</a></p><p><a href="https://imtsinstitute.com/btech/">BTech Course</a></p><p><a href="https://imtsinstitute.com/bed/">BEd Course</a></p></div>	<h2 class="widget-title">Courses After 12th</h2><div class="textwidget"><p><a href="https://blog.imtsinstitute.com/courses-after-12th/">Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/courses-after-12th-science/">Science Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/diploma-courses-after-10th/">Diploma Courses After 10th</a></p><p><a href="https://blog.imtsinstitute.com/yoga-course-after-12th/">Yoga Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/diploma-courses-after-12th/">Diploma Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/it-course-after-12th/">IT Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/commerce-courses-after-12th/">Commerce Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/career-after-12th/">Career Options After 12th</a></p><p><a href="https://blog.imtsinstitute.com/professional-courses-after-12th/">Professional Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/dual-degree-course-after-12th/">Dual Degree Courses After 12th</a></p></div>	1	2024-07-23 12:29:02.204925													<p><span>All content on this website, including but not limited to text, graphics, logos, images, audio clips, video clips, data compilations, and software, is the property of IMTS Institute and is protected by applicable copyright laws. Unauthorized use, reproduction, modification, distribution, or republication of any content from this website without prior written permission from IMTS Institute is strictly prohibited.</span></p>
\.


--
-- TOC entry 3876 (class 0 OID 16930)
-- Dependencies: 278
-- Data for Name: header; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.header (id, title, logo, added_date, added_by, last_modified_by, last_modified_date) FROM stdin;
8	IMTS	IMTS.png	2024-08-03 15:55:13.612947	1	\N	\N
\.


--
-- TOC entry 3848 (class 0 OID 16545)
-- Dependencies: 250
-- Data for Name: individualcourse; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.individualcourse (courename, coursedescription, noofyear, noofmonth, fee, title, seodescription, image, mode, feature, categorie, added_date, added_by, last_modified, detailcoursedescription, whycourse, whopursuecourse, whentodocourse, keyhighcourse, eligibility, skills, other, admission, active, toc, last_modified_user, urlname, toch1, toch2, toch3, toch4, id, toch5) FROM stdin;
BA Visual Communication	Our BA Visual Communication program equips students with a strong foundation in visual design, communication, and media. Through a blend of theoretical knowledge and practical application, students develop a comprehensive understanding of visual language and its impact on audiences.\n\nThe program covers a wide range of subjects including graphic design, photography, typography, digital media, animation, and visual storytelling. Students will learn to use industry-standard software and tools to create compelling visual content for various platforms.	3	Year	65644	BA Visual Communication: Unleash Your Creative Potential	Discover the power of visual storytelling with our BA Visual Communication program. Learn graphic design, photography, animation, and more. Prepare for a dynamic career in the creative industry.	1599717418_5f59c02a7de93_750_351.jpg	Full Time 	Feature	ugCourses	\N	1	\N	<h2>Introduction</h2><p>The Bachelor of Arts in Visual Communication (BA Visual Communication) is an innovative undergraduate program that blends art, design, and media studies. This course focuses on the creation and interpretation of visual content, encompassing graphic design, photography, video production, animation, and multimedia. It aims to equip students with the creative and technical skills necessary to excel in the dynamic field of visual communication.</p><h3>Course Structure</h3><p>The BA Visual Communication program typically spans three years, divided into six semesters. The curriculum is designed to provide a comprehensive understanding of visual media and communication techniques. Core subjects often include:</p><ul><li><strong>Introduction to Visual Communication</strong>: Fundamentals of visual media and communication theories.</li><li><strong>Graphic Design</strong>: Principles and practices of creating visual content using software tools.</li><li><strong>Photography</strong>: Techniques and art of capturing and editing photographs.</li><li><strong>Video Production</strong>: Basics of shooting, editing, and producing videos.</li><li><strong>Animation</strong>: Principles of creating animations and motion graphics.</li><li><strong>Multimedia Design</strong>: Integration of different media forms for interactive content.</li><li><strong>Advertising and Branding</strong>: Concepts and strategies in visual advertising and brand communication.</li><li><strong>Web Design</strong>: Designing and developing visually appealing websites.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a BA Visual Communication program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li><strong>Portfolio</strong>: Some institutions may require a portfolio showcasing the candidate’s creative work.</li><li><strong>Entrance Exams</strong>: Certain institutions might conduct entrance exams or interviews to assess the candidate's aptitude and creativity.</li></ul><h3>Fee Structure</h3><p>The fee for a BA Visual Communication program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 20,000 to INR 1,00,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3>Career Prospects</h3><p>A BA in Visual Communication opens up diverse career opportunities across various sectors. Graduates can pursue careers in:</p><ul><li><strong>Graphic Design</strong>: Roles in advertising agencies, design studios, and corporate design departments.</li><li><strong>Photography</strong>: Professional photography in fashion, journalism, and events.</li><li><strong>Film and Video Production</strong>: Positions in film studios, television channels, and production houses.</li><li><strong>Animation and VFX</strong>: Careers in animation studios and special effects companies.</li><li><strong>Advertising and Marketing</strong>: Roles in advertising agencies, marketing firms, and brand management.</li><li><strong>Web and Multimedia Design</strong>: Opportunities in web development companies and multimedia agencies.</li><li><strong>Freelancing</strong>: Independent work as graphic designers, photographers, or video producers.</li></ul><h3>Specializations</h3><p>Within the BA Visual Communication program, students may have the option to specialize in areas such as:</p><ul><li><strong>Graphic Design</strong>: Focus on creating visual content for print and digital media.</li><li><strong>Photography</strong>: Specialization in various types of photography such as portrait, landscape, and commercial.</li><li><strong>Film and Video</strong>: Emphasis on filmmaking, editing, and video production techniques.</li><li><strong>Animation</strong>: Advanced studies in 2D and 3D animation and motion graphics.</li><li><strong>Interactive Media</strong>: Designing interactive content for web and mobile applications.</li><li><strong>Advertising</strong>: Concentration on visual strategies for advertising and brand communication.</li></ul>									Active	TOC	\N	BA-Visual-Communication-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>}	{}	3	{}
BA History	Our BA History program provides a comprehensive exploration of human societies and cultures across time. Students will develop a deep understanding of historical events, trends, and patterns. The program emphasizes critical thinking, research, and writing skills, preparing students for a variety of intellectual and professional pursuits.	3	Year	14321	BA History: Uncover the Past, Shape the Future	Immerse yourself in the study of the past with our BA History program. Develop critical thinking, research, and writing skills. Prepare for a rewarding career in academia, law, government, or journalism.	ba-history-blog-1.jpg	Full Time 	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Bachelor of Arts in History (BA History) is a comprehensive undergraduate program that explores the vast chronicles of human civilization. This course delves into the study of historical events, cultures, and societies, providing students with a deep understanding of the past and its impact on the present and future. It aims to develop critical thinking, analytical skills, and a nuanced perspective on historical narratives.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA History program typically spans three years, divided into six semesters. The curriculum is designed to provide a broad overview of world history, along with specialized studies in various historical periods and regions. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Ancient History</strong>: Study of early civilizations and their contributions to human development.</li><li style="text-align: justify;"><strong>Medieval History</strong>: Examination of the Middle Ages, including feudalism, crusades, and cultural transformations.</li><li style="text-align: justify;"><strong>Modern History</strong>: Analysis of the modern era, focusing on revolutions, industrialization, and global conflicts.</li><li style="text-align: justify;"><strong>Indian History</strong>: Comprehensive study of the Indian subcontinent's history, from ancient to modern times.</li><li style="text-align: justify;"><strong>Historiography</strong>: Understanding the methodologies and interpretations in historical writing.</li><li style="text-align: justify;"><strong>World History</strong>: Exploration of global historical events and their interconnectedness.</li><li style="text-align: justify;"><strong>Economic History</strong>: Study of historical economic systems, trade, and commerce.</li><li style="text-align: justify;"><strong>Social and Cultural History</strong>: Examination of societal structures, cultures, and everyday life in different historical periods.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA History program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Subject Requirements</strong>: While not always mandatory, having studied history or related subjects in high school can be beneficial.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA History program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 10,000 to INR 50,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in History opens up diverse career opportunities across various sectors. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Education</strong>: Teaching positions in schools or further studies for collegiate-level teaching.</li><li style="text-align: justify;"><strong>Museums and Archives</strong>: Roles as curators, archivists, and researchers.</li><li style="text-align: justify;"><strong>Historical Research</strong>: Positions in research institutions and think tanks.</li><li style="text-align: justify;"><strong>Civil Services</strong>: Preparation for competitive exams like UPSC, where knowledge of history is advantageous.</li><li style="text-align: justify;"><strong>Journalism and Media</strong>: Roles in writing, editing, and content creation with a historical focus.</li><li style="text-align: justify;"><strong>Heritage and Conservation</strong>: Work in preserving and promoting historical sites and artifacts.</li><li style="text-align: justify;"><strong>Publishing</strong>: Opportunities as authors, editors, or reviewers of historical content.</li></ul>									Active	TOC	\N	BA-History-	{}	{<h2>Introduction</h2>}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>"}	{}	4	{}
BA Fine Arts	Our BA Fine Arts program provides a comprehensive foundation in visual arts. Students will develop a deep understanding of artistic concepts, techniques, and historical contexts. The program emphasizes both technical skill development and critical thinking.	3	Year	6451	BA Fine Arts: Ignite Your Creative Passion	Discover your artistic potential with our BA Fine Arts program. Explore painting, sculpture, drawing, and more. Develop your creative voice and build a strong portfolio.	images (7).jfif	Full Time 	Feature	ugCourses	\N	1	\N	<h2>Introduction</h2><p>The Bachelor of Arts in Fine Arts (BA Fine Arts) is an undergraduate program designed for individuals passionate about artistic expression and creativity. This course focuses on developing skills in various art forms, including painting, sculpture, drawing, and digital arts. It aims to nurture creative talents, enhance technical abilities, and provide a thorough understanding of art history and theory.</p><h3>Course Structure</h3><p>The BA Fine Arts program typically spans three years, divided into six semesters. The curriculum is designed to provide a comprehensive foundation in both traditional and contemporary art practices. Core subjects often include:</p><ul><li><strong>Drawing and Sketching</strong>: Fundamentals of drawing techniques and observational skills.</li><li><strong>Painting</strong>: Exploration of various painting mediums such as oil, acrylic, and watercolor.</li><li><strong>Sculpture</strong>: Techniques and materials used in creating three-dimensional art.</li><li><strong>Art History</strong>: Study of major art movements, artists, and their contributions.</li><li><strong>Digital Arts</strong>: Introduction to digital tools and software for creating art.</li><li><strong>Printmaking</strong>: Techniques of producing art prints using various methods.</li><li><strong>Visual Communication</strong>: Principles of design and visual storytelling.</li><li><strong>Criticism and Aesthetics</strong>: Analysis and evaluation of art from different perspectives.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a BA Fine Arts program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li><strong>Portfolio</strong>: Submission of a portfolio showcasing the candidate’s artistic work is often required.</li><li><strong>Entrance Exams</strong>: Some institutions may conduct entrance exams or interviews to assess the candidate's creative aptitude.</li></ul><h3>Fee Structure</h3><p>The fee for a BA Fine Arts program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 20,000 to INR 1,00,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3>Career Prospects</h3><p>A BA in Fine Arts opens up diverse career opportunities across various creative sectors. Graduates can pursue careers in:</p><ul><li><strong>Professional Artist</strong>: Creating and selling artworks independently or through galleries.</li><li><strong>Art Education</strong>: Teaching art in schools, colleges, or private institutions.</li><li><strong>Graphic Design</strong>: Roles in advertising agencies, design studios, and corporate design departments.</li><li><strong>Illustration</strong>: Work in publishing, animation, and media industries as an illustrator.</li><li><strong>Art Therapy</strong>: Using art as a therapeutic tool to help individuals with emotional or psychological issues.</li><li><strong>Museum and Gallery Management</strong>: Positions in curation, exhibition design, and art administration.</li><li><strong>Photography</strong>: Professional photography for commercial, fashion, or artistic purposes.</li><li><strong>Set and Costume Design</strong>: Roles in theatre, film, and television production.</li></ul><h3>Specializations</h3><p>Within the BA Fine Arts program, students may have the option to specialize in areas such as:</p><ul><li><strong>Painting</strong>: Focus on advanced techniques and styles in various painting mediums.</li><li><strong>Sculpture</strong>: Specialization in creating three-dimensional art forms using different materials.</li><li><strong>Printmaking</strong>: In-depth study of printmaking processes and techniques.</li><li><strong>Digital Arts</strong>: Emphasis on digital media and contemporary art practices.</li><li><strong>Ceramics</strong>: Techniques and artistry involved in working with clay and ceramics.</li><li><strong>Textile Design</strong>: Exploration of artistic techniques applied to fabric and textile creation.</li></ul>									Active	TOC	\N	BA-Fine-Arts-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>}	{}	5	{}
BA Yoga and Naturopathy	Our BA Yoga and Naturopathy program offers a comprehensive education in the principles and practices of yoga and naturopathy. Students will develop a deep understanding of holistic health, wellness, and the interconnectedness of mind, body, and spirit.	3	Year	6344	BA Yoga and Naturopathy: Master Holistic Healing and Wellness	Discover the power of yoga and naturopathy with our BA program. Learn ancient healing techniques and modern wellness practices. Prepare for a fulfilling career in holistic healthcare.	1640543584.jpg	0	Feature	ugCourses	\N	1	\N	<h2>Introduction</h2><p>The Bachelor of Arts in Yoga and Naturopathy (BA Yoga and Naturopathy) is a unique undergraduate program that combines traditional Indian practices of yoga with naturopathy. This course aims to promote holistic health and well-being by integrating physical, mental, and spiritual practices. It is designed for individuals interested in natural healing methods and the ancient science of yoga.</p><h3>Course Structure</h3><p>The BA Yoga and Naturopathy program typically spans three years, divided into six semesters. The curriculum is designed to provide a comprehensive understanding of yoga practices, naturopathic treatments, and holistic health principles. Core subjects often include:</p><ul><li><strong>Introduction to Yoga</strong>: Fundamentals of yoga philosophy, history, and practices.</li><li><strong>Asanas and Pranayama</strong>: Techniques and benefits of various yoga postures and breathing exercises.</li><li><strong>Yoga Therapy</strong>: Application of yoga practices for therapeutic purposes.</li><li><strong>Naturopathy Principles</strong>: Basics of naturopathy and its healing methods.</li><li><strong>Diet and Nutrition</strong>: Role of diet in maintaining health and treating illnesses.</li><li><strong>Anatomy and Physiology</strong>: Understanding the human body's structure and functions.</li><li><strong>Meditation and Mindfulness</strong>: Practices to enhance mental well-being and mindfulness.</li><li><strong>Herbal Medicine</strong>: Use of herbs in naturopathic treatments.</li><li><strong>Hydrotherapy and Massage</strong>: Techniques and benefits of water therapy and therapeutic massage.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a BA Yoga and Naturopathy program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li><strong>Physical Fitness</strong>: Good physical health is essential, as the course involves physical practices.</li><li><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li></ul><h3>Fee Structure</h3><p>The fee for a BA Yoga and Naturopathy program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 15,000 to INR 60,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3>Career Prospects</h3><p>A BA in Yoga and Naturopathy opens up diverse career opportunities in the health and wellness sector. Graduates can pursue careers in:</p><ul><li><strong>Yoga Instructor</strong>: Teaching yoga at fitness centers, yoga studios, schools, and corporate settings.</li><li><strong>Naturopathic Practitioner</strong>: Offering naturopathic treatments and consultations.</li><li><strong>Health and Wellness Coach</strong>: Providing guidance on healthy lifestyle practices and wellness strategies.</li><li><strong>Therapist</strong>: Specializing in yoga therapy, massage therapy, or other naturopathic treatments.</li><li><strong>Research and Academia</strong>: Engaging in research on yoga and naturopathy or teaching at educational institutions.</li><li><strong>Health Retreats and Spas</strong>: Working at wellness centers, health resorts, and spas.</li><li><strong>Corporate Wellness Programs</strong>: Designing and implementing wellness programs for organizations.</li></ul>									Active	TOC	\N	BA-Yoga-and-Naturopathy-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>"}	{}	6	{}
BA Hospitality Management	Our BA Hospitality Management program provides a comprehensive education in the principles and practices of the hospitality industry. Students will develop a strong foundation in hotel management, food and beverage service, event planning, and customer service. The program emphasizes both theoretical knowledge and practical experience.	3	Year	7560	BA Hospitality Management: Launch Your Career in the Thriving Industry	Ignite your passion for the hospitality industry with our BA Hospitality Management degree. Gain practical experience and theoretical knowledge. Prepare for a rewarding career in hotels, resorts, and tourism.\n\n	images (8).jfif	0	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Bachelor of Arts in Hospitality Management (BA Hospitality Management) is an undergraduate program designed to prepare students for dynamic careers in the hospitality and tourism industry. This course provides comprehensive knowledge and skills in managing hotels, restaurants, resorts, event planning, and other hospitality operations. It aims to develop strong managerial, customer service, and leadership abilities essential for success in this vibrant sector.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA Hospitality Management program typically spans three years, divided into six semesters. The curriculum is designed to provide a thorough understanding of hospitality operations, management principles, and customer service excellence. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Introduction to Hospitality Management</strong>: Overview of the hospitality industry and its various sectors.</li><li style="text-align: justify;"><strong>Food and Beverage Management</strong>: Principles of managing food service operations and culinary arts.</li><li style="text-align: justify;"><strong>Hotel Operations Management</strong>: Techniques and strategies for managing hotel operations, including front office, housekeeping, and maintenance.</li><li style="text-align: justify;"><strong>Event Management</strong>: Planning, organizing, and executing events and conferences.</li><li style="text-align: justify;"><strong>Tourism Management</strong>: Understanding the tourism industry, destination management, and travel services.</li><li style="text-align: justify;"><strong>Marketing in Hospitality</strong>: Strategies for marketing hospitality services and building customer relationships.</li><li style="text-align: justify;"><strong>Financial Management</strong>: Basics of financial accounting, budgeting, and cost control in hospitality operations.</li><li style="text-align: justify;"><strong>Human Resource Management</strong>: Techniques for managing and motivating hospitality staff.</li><li style="text-align: justify;"><strong>Customer Service Excellence</strong>: Principles and practices for delivering outstanding customer service.</li><li style="text-align: justify;"><strong>Sustainable Tourism and Hospitality</strong>: Approaches to sustainability and responsible tourism in the hospitality industry.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA Hospitality Management program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li><li style="text-align: justify;"><strong>Communication Skills</strong>: Proficiency in English and strong communication skills are often necessary.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA Hospitality Management program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 30,000 to INR 1,50,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in Hospitality Management opens up diverse career opportunities across various sectors. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Hotel Management</strong>: Roles in hotel operations, front office management, housekeeping, and guest services.</li><li style="text-align: justify;"><strong>Food and Beverage Management</strong>: Positions in restaurants, cafes, catering companies, and food service operations.</li><li style="text-align: justify;"><strong>Event Planning and Management</strong>: Careers in organizing corporate events, weddings, and conferences.</li><li style="text-align: justify;"><strong>Tourism Management</strong>: Roles in travel agencies, tour operators, and destination management organizations.</li><li style="text-align: justify;"><strong>Resort and Spa Management</strong>: Management positions in resorts, spas, and wellness centers.</li><li style="text-align: justify;"><strong>Cruise Line Management</strong>: Opportunities in managing cruise ship operations and services.</li><li style="text-align: justify;"><strong>Hospitality Marketing and Sales</strong>: Positions in marketing, sales, and public relations within the hospitality industry.</li><li style="text-align: justify;"><strong>Human Resource Management</strong>: Roles in recruitment, training, and staff management in hospitality settings.</li><li style="text-align: justify;"><strong>Entrepreneurship</strong>: Starting and managing own hospitality ventures such as hotels, restaurants, or travel agencies.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the BA Hospitality Management program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Hotel and Resort Management</strong>: Advanced study of managing hotel and resort operations.</li><li style="text-align: justify;"><strong>Food and Beverage Management</strong>: Focus on culinary arts, restaurant management, and catering services.</li><li style="text-align: justify;"><strong>Event Management</strong>: Specialization in planning and executing events and conferences.</li><li style="text-align: justify;"><strong>Tourism Management</strong>: In-depth study of tourism industry practices and destination management.</li><li style="text-align: justify;"><strong>Luxury Hospitality Management</strong>: Techniques and strategies for managing luxury hotels and high-end hospitality services.</li><li style="text-align: justify;"><strong>Sustainable Hospitality</strong>: Emphasis on sustainable practices and responsible tourism.</li></ul>									Active	TOC	\N	BA-Hospitality-Management-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>"}	{}	7	{}
BA Home Science	Our BA Home Science program offers a holistic approach to understanding the individual, family, and community. Students develop a strong foundation in various aspects of home science, including food and nutrition, child development, human development, resource management, and textiles.	3	Year	7530	BA Home Science	Discover the science of home and family with our BA Home Science program. Learn nutrition, child development, textiles, and more. Build a fulfilling career in healthcare, education, or community development.	images (9).jfif	Full Time 	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Bachelor of Arts in Home Science (BA Home Science) is an interdisciplinary undergraduate program that focuses on various aspects of home management, family welfare, and human development. This course provides students with knowledge and skills related to managing households, nutrition, child development, textile and fashion, and financial planning. It is designed for individuals interested in improving the quality of life and well-being in family and community settings.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA Home Science program typically spans three years, divided into six semesters. The curriculum is designed to offer a broad understanding of home science principles and practices. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Introduction to Home Science</strong>: Overview of the field and its relevance to daily life.</li><li style="text-align: justify;"><strong>Human Development</strong>: Study of physical, emotional, and social development across the lifespan.</li><li style="text-align: justify;"><strong>Nutrition and Dietetics</strong>: Principles of nutrition, dietary planning, and food safety.</li><li style="text-align: justify;"><strong>Textiles and Clothing</strong>: Exploration of textile fibers, garment construction, and fashion design.</li><li style="text-align: justify;"><strong>Family Resource Management</strong>: Techniques for managing family resources, including budgeting and financial planning.</li><li style="text-align: justify;"><strong>Child Development</strong>: Examination of developmental stages in children and their educational needs.</li><li style="text-align: justify;"><strong>Home Management</strong>: Strategies for managing household operations, including time management and organization.</li><li style="text-align: justify;"><strong>Health and Hygiene</strong>: Principles of maintaining health and hygiene in a home setting.</li><li style="text-align: justify;"><strong>Interior Design</strong>: Basics of designing functional and aesthetically pleasing living spaces.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA Home Science program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Subject Requirements</strong>: Some institutions may prefer candidates who have studied subjects related to home science or science.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may conduct entrance exams or interviews as part of the selection process.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA Home Science program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 15,000 to INR 60,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in Home Science opens up diverse career opportunities across various sectors. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Family and Community Welfare</strong>: Roles in non-profit organizations and government agencies focused on family and community development.</li><li style="text-align: justify;"><strong>Nutrition and Dietetics</strong>: Careers as nutritionists, dietitians, or food service managers.</li><li style="text-align: justify;"><strong>Textile and Fashion Industry</strong>: Opportunities in fashion design, textile manufacturing, and merchandising.</li><li style="text-align: justify;"><strong>Child Development</strong>: Positions as child care workers, early childhood educators, and child development specialists.</li><li style="text-align: justify;"><strong>Home Management</strong>: Roles in managing households, including personal and family finance.</li><li style="text-align: justify;"><strong>Interior Design</strong>: Careers in designing and decorating residential and commercial spaces.</li><li style="text-align: justify;"><strong>Public Health and Hygiene</strong>: Positions in promoting health and hygiene practices in communities.</li><li style="text-align: justify;"><strong>Education</strong>: Teaching positions in schools or colleges specializing in home science and related subjects.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the BA Home Science program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Nutrition and Dietetics</strong>: Focus on advanced nutritional science and diet planning.</li><li style="text-align: justify;"><strong>Textiles and Fashion</strong>: Specialization in textile design, fashion technology, and garment construction.</li><li style="text-align: justify;"><strong>Child Development</strong>: Advanced study of child growth, education, and developmental psychology.</li><li style="text-align: justify;"><strong>Home Management</strong>: Emphasis on efficient household management, financial planning, and resource allocation.</li><li style="text-align: justify;"><strong>Interior Design</strong>: Specialization in designing functional and stylish living and working spaces.</li><li style="text-align: justify;"><strong>Health and Hygiene</strong>: Study of public health practices and home hygiene.</li></ul>									Active	TOC	\N	BA-Home-Science-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>"}	{}	8	{}
BA Hons (Travel and Tourism)	The aim is to create compelling content that accurately reflects the BA Hons (Travel and Tourism) program while optimizing it for search engines. We want to attract potential students by highlighting the dynamic nature of the travel and tourism industry, career opportunities, and the skills developed through the course.	3	Year	5342	Learn Travel and Tourism: Explore the World and Build Your Future	Ignite your passion for travel with our BA Hons in Travel and Tourism. Gain practical experience through internships and industry projects. Prepare for a rewarding career in the global tourism industry.	images (10).jfif	Full Time 	Feature	ugCourses	\N	1	\N	<h2>Introduction</h2><p>The Bachelor of Arts (Honours) in Travel and Tourism (BA Hons Travel and Tourism) is a specialized undergraduate program that focuses on the dynamic and growing field of travel and tourism. This course provides students with a comprehensive understanding of tourism management, travel planning, and the operational aspects of the travel industry. It aims to prepare students for diverse careers in travel agencies, tour operations, hospitality, and destination management.</p><h3>Course Structure</h3><p>The BA Hons Travel and Tourism program typically spans three years, divided into six semesters. The curriculum combines theoretical knowledge with practical skills, offering a holistic view of the travel and tourism industry. Core subjects often include:</p><ul><li><strong>Introduction to Travel and Tourism</strong>: Overview of the tourism industry, its components, and its significance.</li><li><strong>Tourism Management</strong>: Principles and practices of managing tourism operations and services.</li><li><strong>Travel Agency Operations</strong>: Understanding the workings of travel agencies, including booking systems and customer service.</li><li><strong>Tour Planning and Development</strong>: Techniques for designing and developing travel itineraries and packages.</li><li><strong>Destination Management</strong>: Strategies for managing and promoting tourist destinations.</li><li><strong>Hospitality Management</strong>: Basics of hospitality services relevant to the tourism sector.</li><li><strong>Marketing for Tourism</strong>: Strategies and techniques for marketing tourism products and services.</li><li><strong>Sustainable Tourism</strong>: Principles of sustainable practices and eco-friendly tourism.</li><li><strong>Cultural and Heritage Tourism</strong>: Exploration of tourism related to cultural and historical sites.</li><li><strong>Tourism Policy and Planning</strong>: Understanding tourism policies, regulations, and planning processes.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a BA Hons Travel and Tourism program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li><li><strong>Interest in Travel and Tourism</strong>: A genuine interest in the travel and tourism industry can be beneficial.</li></ul><h3>Fee Structure</h3><p>The fee for a BA Hons Travel and Tourism program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 30,000 to INR 1,00,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3>Career Prospects</h3><p>A BA Hons in Travel and Tourism opens up a variety of career opportunities in the travel and tourism sector. Graduates can pursue careers in:</p><ul><li><strong>Travel Agencies</strong>: Roles in travel consultancy, booking management, and customer service.</li><li><strong>Tour Operators</strong>: Positions in organizing and managing tours and travel packages.</li><li><strong>Destination Management</strong>: Careers in promoting and managing tourist destinations and attractions.</li><li><strong>Hospitality Management</strong>: Roles in hotels, resorts, and other hospitality services.</li><li><strong>Event Planning</strong>: Careers in organizing travel-related events, conferences, and exhibitions.</li><li><strong>Tourism Marketing</strong>: Positions in marketing tourism products and services, including digital marketing and public relations.</li><li><strong>Tour Guide</strong>: Providing guided tours and information to tourists at various locations.</li><li><strong>Travel Writing and Journalism</strong>: Opportunities in writing about travel destinations, experiences, and industry trends.</li><li><strong>Corporate Travel Management</strong>: Managing business travel arrangements for corporations and organizations.</li></ul><h3>Specializations</h3><p>Within the BA Hons Travel and Tourism program, students may have the option to specialize in areas such as:</p><ul><li><strong>Tourism Marketing</strong>: Focus on marketing strategies and promotional techniques for tourism.</li><li><strong>Sustainable Tourism</strong>: Specialization in eco-friendly and sustainable tourism practices.</li><li><strong>Event Management</strong>: In-depth study of planning and executing travel-related events and conferences.</li><li><strong>Destination Management</strong>: Advanced techniques in managing and promoting tourist destinations.</li><li><strong>Cultural and Heritage Tourism</strong>: Emphasis on tourism related to cultural and historical heritage.</li><li><strong>Adventure Tourism</strong>: Specialization in tourism related to adventure and outdoor activities.</li></ul>									Active	TOC	\N	BA-Hons-(Travel-and-Tourism)-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>}	{}	9	{}
BA Rural Development	Our BA Rural Development program is designed to equip students with the knowledge and skills necessary to address the complex challenges facing rural India. The program focuses on understanding rural realities, poverty, inequality, and development issues.	3	Year	4521	Learn Rural Development: Empower Rural Communities	Make a difference in rural India with our BA Rural Development degree. Learn about poverty alleviation, agriculture, healthcare, and education. Prepare for a fulfilling career in development.	images (11).jfif	Full Time 	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Bachelor of Arts in Rural Development (BA Rural Development) is an undergraduate program aimed at equipping students with the knowledge and skills needed to address rural challenges and promote sustainable development in rural areas. This course combines principles of sociology, economics, and community development to prepare students for roles in improving the quality of life in rural communities.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA Rural Development program typically spans three years, divided into six semesters. The curriculum is designed to provide a comprehensive understanding of rural development issues and strategies. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Introduction to Rural Development</strong>: Overview of rural development concepts, challenges, and opportunities.</li><li style="text-align: justify;"><strong>Rural Sociology</strong>: Study of social structures, relationships, and issues within rural communities.</li><li style="text-align: justify;"><strong>Rural Economics</strong>: Analysis of economic factors affecting rural areas, including agriculture, industry, and employment.</li><li style="text-align: justify;"><strong>Community Development</strong>: Strategies for promoting social, economic, and environmental well-being in rural communities.</li><li style="text-align: justify;"><strong>Project Management</strong>: Techniques for planning, implementing, and evaluating rural development projects.</li><li style="text-align: justify;"><strong>Rural Health and Education</strong>: Examination of health and educational issues and solutions in rural settings.</li><li style="text-align: justify;"><strong>Agricultural Development</strong>: Study of agricultural practices, innovations, and their impact on rural economies.</li><li style="text-align: justify;"><strong>Poverty Alleviation</strong>: Approaches to reducing poverty and improving living standards in rural areas.</li><li style="text-align: justify;"><strong>Sustainable Development</strong>: Principles of sustainable practices and their application in rural development.</li><li style="text-align: justify;"><strong>Participatory Development</strong>: Methods for involving rural communities in the development process.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA Rural Development program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li><li style="text-align: justify;"><strong>Interest in Rural Issues</strong>: A genuine interest in rural development and community service is beneficial.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA Rural Development program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 15,000 to INR 60,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in Rural Development opens up a range of career opportunities in various sectors focused on rural and community development. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Non-Governmental Organizations (NGOs)</strong>: Working on rural development projects, community outreach, and advocacy.</li><li style="text-align: justify;"><strong>Government Agencies</strong>: Roles in rural development departments, social welfare, and public administration.</li><li style="text-align: justify;"><strong>Community Development</strong>: Positions in planning and implementing community-based development programs.</li><li style="text-align: justify;"><strong>Agricultural Development</strong>: Careers in agricultural extension services, rural cooperatives, and farm management.</li><li style="text-align: justify;"><strong>Public Health</strong>: Roles in improving health services and infrastructure in rural areas.</li><li style="text-align: justify;"><strong>Education</strong>: Teaching positions or roles in educational development programs for rural communities.</li><li style="text-align: justify;"><strong>Social Entrepreneurship</strong>: Starting and managing ventures aimed at addressing rural issues and improving livelihoods.</li><li style="text-align: justify;"><strong>Research and Consultancy</strong>: Engaging in research on rural development issues and providing consultancy services.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the BA Rural Development program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Agricultural Development</strong>: Focus on modern agricultural practices and rural economic development.</li><li style="text-align: justify;"><strong>Community Health</strong>: Specialization in improving health services and outcomes in rural areas.</li><li style="text-align: justify;"><strong>Education and Training</strong>: Emphasis on educational development and vocational training in rural communities.</li><li style="text-align: justify;"><strong>Poverty Reduction</strong>: Advanced study of poverty alleviation strategies and programs.</li><li style="text-align: justify;"><strong>Sustainable Rural Development</strong>: Techniques and practices for promoting environmental sustainability in rural areas.</li><li style="text-align: justify;"><strong>Rural Marketing</strong>: Study of marketing strategies tailored to rural markets and products.</li></ul><h3 style="text-align: justify;">Conclusion</h3><p style="text-align: justify;">The BA Rural Development program is an excellent choice for those passionate about making a positive impact in rural communities. It provides a deep understanding of rural development issues and equips students with practical skills to address these challenges effectively. Whether aiming for a career in NGOs, government, community development, or social entrepreneurship, a BA in Rural Development offers a solid foundation for contributing to sustainable and impactful change in rural areas.</p>									Active	TOC	\N	BA-Rural-Development-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Conclusion</h3>"}	{}	10	{}
BA Tourism Studies	Our BA Tourism Studies program provides a comprehensive education in the theory and practice of the travel and tourism industry. Students will develop a strong understanding of the global tourism market, destination management, tourism planning, and marketing. The program emphasizes both theoretical knowledge and practical application.	3	Year	42132	Hospitality and Tourism Degree: Master the Art of Guest Experience	Master the art of creating unforgettable travel experiences. Our BA Tourism Studies program equips you with the knowledge and skills to succeed in the dynamic travel and tourism sector.	dda795e71b999c62824b6bda7702f2ca.jpeg	Full Time 	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Bachelor of Arts in Tourism Studies (BA Tourism Studies) is an undergraduate program designed to provide students with a comprehensive understanding of the tourism industry. This course combines theoretical knowledge with practical skills, focusing on the various aspects of tourism management, travel planning, and hospitality. It aims to prepare students for diverse careers in the tourism sector, including travel agencies, tour operators, and destination management.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA Tourism Studies program typically spans three years, divided into six semesters. The curriculum is structured to cover a broad range of topics related to tourism and travel. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Introduction to Tourism</strong>: Overview of the tourism industry, its components, and its economic and social impact.</li><li style="text-align: justify;"><strong>Tourism Management</strong>: Principles and practices of managing tourism operations and services.</li><li style="text-align: justify;"><strong>Travel Agency Management</strong>: Understanding the operations and management of travel agencies.</li><li style="text-align: justify;"><strong>Tour Planning and Organization</strong>: Techniques for designing and organizing travel itineraries and packages.</li><li style="text-align: justify;"><strong>Destination Management</strong>: Strategies for managing and promoting tourist destinations.</li><li style="text-align: justify;"><strong>Hospitality Management</strong>: Basics of hospitality services relevant to tourism, including accommodation and food services.</li><li style="text-align: justify;"><strong>Tourism Marketing</strong>: Marketing strategies and techniques specific to the tourism industry.</li><li style="text-align: justify;"><strong>Cultural and Heritage Tourism</strong>: Exploration of tourism related to cultural, historical, and heritage sites.</li><li style="text-align: justify;"><strong>Sustainable Tourism</strong>: Principles of sustainability and responsible tourism practices.</li><li style="text-align: justify;"><strong>Event Management</strong>: Planning and organizing events, conferences, and exhibitions in the tourism sector.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA Tourism Studies program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li><li style="text-align: justify;"><strong>Interest in Tourism</strong>: A genuine interest in travel, tourism, and hospitality can be advantageous.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA Tourism Studies program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 30,000 to INR 1,00,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in Tourism Studies opens up a variety of career opportunities in the tourism and hospitality sector. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Travel Agencies</strong>: Roles in travel consultancy, booking management, and customer service.</li><li style="text-align: justify;"><strong>Tour Operators</strong>: Careers in organizing and managing tours and travel packages.</li><li style="text-align: justify;"><strong>Destination Management</strong>: Positions in managing and promoting tourist destinations and attractions.</li><li style="text-align: justify;"><strong>Hospitality Industry</strong>: Roles in hotels, resorts, and other hospitality services.</li><li style="text-align: justify;"><strong>Event Planning</strong>: Organizing and managing travel-related events, conferences, and exhibitions.</li><li style="text-align: justify;"><strong>Tourism Marketing</strong>: Careers in marketing tourism products and services, including digital marketing and public relations.</li><li style="text-align: justify;"><strong>Tour Guide</strong>: Providing guided tours and information to tourists at various locations.</li><li style="text-align: justify;"><strong>Tourism Research and Development</strong>: Engaging in research on tourism trends, customer preferences, and industry developments.</li><li style="text-align: justify;"><strong>Corporate Travel Management</strong>: Managing business travel arrangements for organizations and corporations.</li></ul>									Active	TOC	\N	BA-Tourism-Studies-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>"}	{}	11	{}
BA Public Relations	Core courses cover topics such as media relations, crisis management, public opinion, corporate communication, and digital PR. Students will have opportunities to gain practical experience through internships, industry projects, and simulated real-world scenarios. The program also focuses on developing strong writing, research, and presentation skills.	3	0	4121	Communication and PR Degree: Shape Public Opinion	Master the art of influencing public opinion with our BA Public Relations program. Learn to build and protect brand reputation. Join a thriving industry with endless opportunities.	1640517954.jpg	0	Feature	ugCourses	\N	1	\N	<h2 style="text-align: justify;">BA Public Relations: An In-Depth Overview</h2><h3 style="text-align: justify;">Introduction</h3><p style="text-align: justify;">The Bachelor of Arts in Public Relations (BA Public Relations) is an undergraduate program designed to provide students with a comprehensive understanding of public relations principles, practices, and strategies. This course prepares students for careers in managing communication between organizations and their target audiences, including media relations, crisis management, and strategic communication.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The BA Public Relations program typically spans three years, divided into six semesters. The curriculum combines theoretical knowledge with practical skills, focusing on various aspects of public relations and communication. Core subjects often include:</p><ul><li style="text-align: justify;"><strong>Introduction to Public Relations</strong>: Overview of public relations, its role, and its importance in various sectors.</li><li style="text-align: justify;"><strong>Media Relations</strong>: Techniques for interacting with media, including press releases, media kits, and media pitching.</li><li style="text-align: justify;"><strong>Crisis Management</strong>: Strategies for handling public relations crises and managing organizational reputation.</li><li style="text-align: justify;"><strong>Strategic Communication</strong>: Planning and implementing communication strategies aligned with organizational goals.</li><li style="text-align: justify;"><strong>Public Relations Ethics and Law</strong>: Examination of ethical considerations and legal issues in public relations.</li><li style="text-align: justify;"><strong>Corporate Communication</strong>: Managing internal and external communication within organizations.</li><li style="text-align: justify;"><strong>Event Management</strong>: Planning, organizing, and managing events and public relations campaigns.</li><li style="text-align: justify;"><strong>Digital and Social Media</strong>: Utilization of digital platforms and social media for public relations and communication.</li><li style="text-align: justify;"><strong>Research Methods in Public Relations</strong>: Techniques for conducting research to support public relations strategies.</li><li style="text-align: justify;"><strong>Campaign Planning and Execution</strong>: Development and implementation of public relations campaigns.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in a BA Public Relations program, candidates must meet certain eligibility requirements, which generally include:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: Successful completion of 10+2 or equivalent examination from a recognized board.</li><li style="text-align: justify;"><strong>Minimum Marks</strong>: A minimum aggregate score, often around 50-60%, depending on the institution.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Some institutions may require candidates to pass entrance exams or undergo interviews.</li><li style="text-align: justify;"><strong>Communication Skills</strong>: Strong written and verbal communication skills are beneficial for success in public relations.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for a BA Public Relations program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 30,000 to INR 1,00,000 in India. Private institutions and universities may charge higher fees compared to government-funded colleges.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">A BA in Public Relations opens up a variety of career opportunities in the field of communication and media. Graduates can pursue careers in:</p><ul><li style="text-align: justify;"><strong>Public Relations Specialist</strong>: Managing communication strategies, media relations, and public image for organizations.</li><li style="text-align: justify;"><strong>Media Relations Manager</strong>: Developing and maintaining relationships with media professionals and managing press coverage.</li><li style="text-align: justify;"><strong>Corporate Communication Manager</strong>: Overseeing internal and external communication within organizations.</li><li style="text-align: justify;"><strong>Crisis Communication Manager</strong>: Handling communication during crises and managing organizational reputation.</li><li style="text-align: justify;"><strong>Event Coordinator</strong>: Planning and executing events, press conferences, and public relations campaigns.</li><li style="text-align: justify;"><strong>Digital PR Specialist</strong>: Utilizing digital platforms and social media to enhance public relations efforts.</li><li style="text-align: justify;"><strong>Content Creator</strong>: Developing content for various media, including blogs, social media, and press releases.</li><li style="text-align: justify;"><strong>Public Affairs Specialist</strong>: Managing relationships with government entities and handling public policy issues.</li><li style="text-align: justify;"><strong>Media Planner</strong>: Developing media strategies and buying media space for advertising and public relations.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the BA Public Relations program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Digital Public Relations</strong>: Focus on using digital and social media platforms for public relations activities.</li><li style="text-align: justify;"><strong>Crisis Management</strong>: Specialization in strategies and techniques for managing communication during crises.</li><li style="text-align: justify;"><strong>Corporate Communication</strong>: Emphasis on managing internal and external communication for organizations.</li><li style="text-align: justify;"><strong>Event Management</strong>: Advanced study of organizing and managing events and public relations campaigns.</li><li style="text-align: justify;"><strong>Media Relations</strong>: Techniques and strategies for effective media interaction and press management.</li><li style="text-align: justify;"><strong>Public Affairs</strong>: Focus on managing relationships with government bodies and handling public policy issues.</li></ul>									Active	TOC	\N	BA-Public-Relations-	{}	{"<h2 style=\\"text-align: justify;\\">BA Public Relations: An In-Depth Overview</h2>"}	{"<h3 style=\\"text-align: justify;\\">Introduction</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>"}	{}	12	{}
MBA in Human Resource Management	Earn your MBA in HR online. Balance work and studies while gaining HR expertise for career advancement.	2	Year	54322	MBA in Human Resource Management: Become an HR Leader	Advance your HR career with our MBA program. Master strategic HR, talent management, and organizational development.	HR-2-1.png	Full Time 	Feature	pgCourses	\N	\N	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The MBA in Human Resource Management (HRM) is a specialized graduate program focused on equipping students with advanced knowledge and skills in managing an organization's human resources. This program is ideal for individuals aiming to pursue careers in HR management, talent acquisition, employee development, and labor relations. The MBA HRM program combines core business principles with specialized HR subjects, preparing graduates to handle various human resource functions effectively.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The MBA HRM program typically spans two years and is divided into four semesters. The curriculum integrates fundamental business courses with specialized HR subjects. Core modules usually include:</p><ul><li style="text-align: justify;"><strong>Human Resource Management</strong>: Principles and practices of managing an organization's human resources, including recruitment, selection, training, and development.</li><li style="text-align: justify;"><strong>Organizational Behavior</strong>: Study of human behavior in organizational settings, focusing on motivation, leadership, team dynamics, and organizational culture.</li><li style="text-align: justify;"><strong>Labor Laws and Industrial Relations</strong>: Understanding labor laws, employee rights, industrial relations, and collective bargaining.</li><li style="text-align: justify;"><strong>Talent Management</strong>: Strategies for attracting, retaining, and developing top talent within an organization.</li><li style="text-align: justify;"><strong>Performance Management</strong>: Techniques for assessing and improving employee performance, including performance appraisal systems and feedback mechanisms.</li><li style="text-align: justify;"><strong>Compensation and Benefits</strong>: Designing and managing employee compensation, benefits, and reward systems.</li><li style="text-align: justify;"><strong>Training and Development</strong>: Planning and implementing training programs to enhance employee skills and performance.</li><li style="text-align: justify;"><strong>Strategic Human Resource Management</strong>: Aligning HR strategies with organizational goals and developing strategic HR initiatives.</li><li style="text-align: justify;"><strong>HR Analytics</strong>: Utilizing data and analytics to make informed HR decisions and measure the effectiveness of HR practices.</li><li style="text-align: justify;"><strong>Change Management</strong>: Managing organizational change, developing change strategies, and overcoming resistance to change.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA HRM program, candidates generally need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in business, psychology, or related fields may be preferred.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in HR or related roles.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA HRM program can vary depending on the institution and location. On average, the annual fee ranges from INR 3,00,000 to INR 15,00,000 in India. Fees can be higher in private institutions and international programs.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA in HRM opens up a wide range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li style="text-align: justify;"><strong>HR Manager</strong>: Overseeing HR functions, managing HR policies, and ensuring compliance with labor laws.</li><li style="text-align: justify;"><strong>Talent Acquisition Specialist</strong>: Managing the recruitment and selection process, identifying and attracting top talent.</li><li style="text-align: justify;"><strong>Training and Development Manager</strong>: Planning and implementing training programs to enhance employee skills and performance.</li><li style="text-align: justify;"><strong>Compensation and Benefits Manager</strong>: Designing and managing employee compensation, benefits, and reward systems.</li><li style="text-align: justify;"><strong>Employee Relations Manager</strong>: Handling employee grievances, managing labor relations, and ensuring a positive work environment.</li><li style="text-align: justify;"><strong>HR Consultant</strong>: Providing HR advisory services to organizations, developing HR strategies, and improving HR practices.</li><li style="text-align: justify;"><strong>HR Business Partner</strong>: Collaborating with business leaders to align HR strategies with organizational goals and support business operations.</li><li style="text-align: justify;"><strong>Performance Management Specialist</strong>: Developing and managing performance appraisal systems and improving employee performance.</li><li style="text-align: justify;"><strong>Organizational Development Manager</strong>: Leading initiatives to improve organizational effectiveness, culture, and employee engagement.</li><li style="text-align: justify;"><strong>HR Analytics Specialist</strong>: Utilizing data and analytics to make informed HR decisions and measure the effectiveness of HR practices.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the MBA HRM program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Talent Management</strong>: Focus on strategies for attracting, retaining, and developing top talent.</li><li style="text-align: justify;"><strong>Labor Relations</strong>: Advanced study of labor laws, employee rights, and industrial relations.</li><li style="text-align: justify;"><strong>Performance Management</strong>: Techniques for assessing and improving employee performance.</li><li style="text-align: justify;"><strong>Compensation and Benefits</strong>: Designing and managing compensation, benefits, and reward systems.</li><li style="text-align: justify;"><strong>Training and Development</strong>: Planning and implementing training programs to enhance employee skills and performance.</li><li style="text-align: justify;"><strong>Strategic HRM</strong>: Aligning HR strategies with organizational goals and developing strategic HR initiatives.</li><li style="text-align: justify;"><strong>HR Analytics</strong>: Utilizing data and analytics to make informed HR decisions and measure the effectiveness of HR practices.</li><li style="text-align: justify;"><strong>Change Management</strong>: Managing organizational change, developing change strategies, and overcoming resistance to change.</li></ul><h3 style="text-align: justify;">Benefits of an MBA in HRM</h3><ul><li style="text-align: justify;"><strong>Advanced HR Skills</strong>: Development of advanced skills in managing human resources, talent acquisition, and employee development.</li><li style="text-align: justify;"><strong>Career Advancement</strong>: Improved prospects for career progression in HR management, talent acquisition, and employee relations roles.</li><li style="text-align: justify;"><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world HR challenges through projects and case studies.</li><li style="text-align: justify;"><strong>Networking Opportunities</strong>: Access to a network of HR professionals, alumni, and industry experts.</li><li style="text-align: justify;"><strong>Strategic Perspective</strong>: Understanding how to align HR strategies with organizational goals and support business operations.</li></ul>									Active	TOC	\N	MBA-in-Human-Resource-Management	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Benefits of an MBA in HRM</h3>"}	{}	20	{}
MBA (Master of Business Administration)	Our MBA program is designed to develop well-rounded business leaders with a strong foundation in core management disciplines. The curriculum focuses on developing strategic thinking, analytical skills, and a global perspective. Through a blend of theoretical knowledge and practical application, students gain the expertise to excel in diverse business roles.	2	Year	65352	MBA Program: Gain Essential Business Skills for Success	Invest in your future with an MBA. Our program offers rigorous coursework, experienced faculty, and valuable networking opportunities. Become a confident and strategic business leader.	1640255976123.png	Full Time 	Feature	pgCourses	\N	\N	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The Master of Business Administration (MBA) is a highly sought-after graduate degree that provides a comprehensive education in business management and administration. MBA programs are designed to equip students with leadership, strategic thinking, and managerial skills necessary to excel in various business environments. The program typically covers core business areas and offers specialized tracks to cater to specific career interests.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">An MBA program usually spans two years, divided into four semesters, though some programs offer accelerated one-year formats. The curriculum generally includes:</p><ul><li style="text-align: justify;"><strong>Core Modules</strong>: Subjects common to all MBA programs, such as Financial Accounting, Marketing Management, Organizational Behavior, Operations Management, Strategic Management, and Human Resource Management.</li><li style="text-align: justify;"><strong>Elective Specializations</strong>: Advanced courses in specific areas of interest, allowing students to tailor their education according to career goals.</li><li style="text-align: justify;"><strong>Capstone Projects and Internships</strong>: Practical experience through real-world projects and internships to apply theoretical knowledge.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA program, candidates typically need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Many programs prefer candidates with work experience, though this varies by program.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs require interviews or personal statements.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA program varies widely depending on the institution and location. On average, the annual fee ranges from INR 2,00,000 to INR 30,00,000 in India and can be higher for international programs.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA opens up diverse career opportunities across various sectors. Graduates can pursue roles in:</p><ul><li style="text-align: justify;"><strong>Management Consulting</strong>: Advising organizations on business strategies and operations.</li><li style="text-align: justify;"><strong>Finance</strong>: Positions in investment banking, financial planning, and analysis.</li><li style="text-align: justify;"><strong>Marketing</strong>: Roles in brand management, digital marketing, and market research.</li><li style="text-align: justify;"><strong>Operations</strong>: Careers in supply chain management, logistics, and operations management.</li><li style="text-align: justify;"><strong>Human Resources</strong>: Roles in talent management, organizational development, and HR strategy.</li><li style="text-align: justify;"><strong>Entrepreneurship</strong>: Starting and managing new business ventures.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Now, let's dive into specific MBA specializations:</p><h3 style="text-align: justify;">1. <strong>MBA PGDM (Post Graduate Diploma in Management)</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: An alternative to traditional MBA programs, offering similar management training but with a different certification.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores may be required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Similar to MBA graduates, including management roles, consulting, and entrepreneurship.</li></ul><h3 style="text-align: justify;">2. <strong>Executive MBA</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Designed for working professionals with significant work experience, focusing on advanced management and leadership skills.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Several years of work experience; often requires a bachelor’s degree.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Leadership roles, senior management, and executive positions.</li></ul><h3 style="text-align: justify;">3. <strong>MBA Dual Specialization</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Allows students to specialize in two areas of business, providing a broader skill set.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Versatile roles in management, consulting, and specialized business fields.</li></ul><h3 style="text-align: justify;">4. <strong>MBA IT (Information Technology)</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on integrating IT with business management, covering topics like IT strategy, management, and systems.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree in any discipline; IT background may be preferred.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: IT management, systems analysis, and technology consulting.</li></ul><h3 style="text-align: justify;">5. <strong>MBA Safety Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in safety protocols, risk management, and compliance in various industries.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in safety or related fields can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Safety manager, risk consultant, and compliance officer.</li></ul><h3 style="text-align: justify;">6. <strong>MBA Finance</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on financial management, investment analysis, and corporate finance.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Financial analyst, investment banker, and finance manager.</li></ul><h3 style="text-align: justify;">7. <strong>MBA Operations</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes managing and optimizing business operations and supply chains.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Operations manager, supply chain analyst, and logistics coordinator.</li></ul><h3 style="text-align: justify;">8. <strong>MBA HRM (Human Resource Management)</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing human resources, including recruitment, training, and organizational development.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: HR manager, recruitment consultant, and organizational development specialist.</li></ul><h3 style="text-align: justify;">9. <strong>MBA Event Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on planning, organizing, and managing events and conferences.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Event manager, conference organizer, and corporate event planner.</li></ul><h3 style="text-align: justify;">10. <strong>MBA Entrepreneurship</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Aims to develop skills for starting and managing new ventures.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrepreneurial background or interest is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Entrepreneur, startup manager, and business consultant.</li></ul><h3 style="text-align: justify;">11. <strong>MBA Airline and Airport Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in the management of airline operations and airport facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in aviation can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Airline manager, airport operations manager, and aviation consultant.</li></ul><h3 style="text-align: justify;">12. <strong>MBA IB (International Business)</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on global business practices, international trade, and cross-cultural management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: International business manager, export manager, and global marketing consultant.</li></ul><h3 style="text-align: justify;">13. <strong>MBA Logistics</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes supply chain management, logistics operations, and distribution strategies.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Logistics manager, supply chain analyst, and operations coordinator.</li></ul><h3 style="text-align: justify;">14. <strong>MBA Marketing</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on marketing strategies, consumer behavior, and brand management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Marketing manager, brand strategist, and market researcher.</li></ul><h3 style="text-align: justify;">15. <strong>MBA Advertising and Sales Promotion</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in advertising strategies and sales promotion techniques.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Advertising manager, sales promotion specialist, and media planner.</li></ul><h3 style="text-align: justify;">16. <strong>MBA Digital Marketing</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on online marketing strategies, social media, and digital analytics.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Digital marketing manager, SEO specialist, and social media manager.</li></ul><h3 style="text-align: justify;">17. <strong>MBA Project Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing projects, including planning, execution, and evaluation.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Project manager, program manager, and project coordinator.</li></ul><h3 style="text-align: justify;">18. <strong>MBA Hospital Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing healthcare facilities and services.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Hospital administrator, healthcare manager, and medical services manager.</li></ul><h3 style="text-align: justify;">19. <strong>MBA Shipping and Port Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing shipping operations and port facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in logistics or maritime studies is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Shipping manager, port operations manager, and maritime consultant.</li></ul><h3 style="text-align: justify;">20. <strong>MBA CRM (Customer Relationship Management)</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing customer relationships and enhancing customer satisfaction.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: CRM manager, customer service director, and client relationship manager.</li></ul><h3 style="text-align: justify;">21. <strong>MBA Clinical Research</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in research methodologies and clinical trials in the healthcare sector.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in life sciences or healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Clinical research manager, research coordinator, and clinical trial analyst.</li></ul><h3 style="text-align: justify;">22. <strong>MBA Disaster Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing disaster response and recovery efforts.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in emergency management is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Disaster response manager, emergency management specialist, and risk assessment analyst.</li></ul><h3 style="text-align: justify;">23. <strong>MBA Pharmaceutical Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing pharmaceutical operations and understanding drug regulations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in pharmacy or life sciences is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Pharmaceutical manager, drug regulatory affairs specialist, and healthcare consultant.</li></ul><h3 style="text-align: justify;">24. <strong>MBA Technology Management</strong></h3><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing technology resources and innovation within organizations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in technology or engineering can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>:</li></ul>									Active	TOC	\N	MBA-(Master-of-Business-Administration)-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">1. <strong>MBA PGDM (Post Graduate Diploma in Management)</strong></h3>","<h3 style=\\"text-align: justify;\\">2. <strong>Executive MBA</strong></h3>","<h3 style=\\"text-align: justify;\\">3. <strong>MBA Dual Specialization</strong></h3>","<h3 style=\\"text-align: justify;\\">4. <strong>MBA IT (Information Technology)</strong></h3>","<h3 style=\\"text-align: justify;\\">5. <strong>MBA Safety Management</strong></h3>","<h3 style=\\"text-align: justify;\\">6. <strong>MBA Finance</strong></h3>","<h3 style=\\"text-align: justify;\\">7. <strong>MBA Operations</strong></h3>","<h3 style=\\"text-align: justify;\\">8. <strong>MBA HRM (Human Resource Management)</strong></h3>","<h3 style=\\"text-align: justify;\\">9. <strong>MBA Event Management</strong></h3>","<h3 style=\\"text-align: justify;\\">10. <strong>MBA Entrepreneurship</strong></h3>","<h3 style=\\"text-align: justify;\\">11. <strong>MBA Airline and Airport Management</strong></h3>","<h3 style=\\"text-align: justify;\\">12. <strong>MBA IB (International Business)</strong></h3>","<h3 style=\\"text-align: justify;\\">13. <strong>MBA Logistics</strong></h3>","<h3 style=\\"text-align: justify;\\">14. <strong>MBA Marketing</strong></h3>","<h3 style=\\"text-align: justify;\\">15. <strong>MBA Advertising and Sales Promotion</strong></h3>","<h3 style=\\"text-align: justify;\\">16. <strong>MBA Digital Marketing</strong></h3>","<h3 style=\\"text-align: justify;\\">17. <strong>MBA Project Management</strong></h3>","<h3 style=\\"text-align: justify;\\">18. <strong>MBA Hospital Management</strong></h3>","<h3 style=\\"text-align: justify;\\">19. <strong>MBA Shipping and Port Management</strong></h3>","<h3 style=\\"text-align: justify;\\">20. <strong>MBA CRM (Customer Relationship Management)</strong></h3>","<h3 style=\\"text-align: justify;\\">21. <strong>MBA Clinical Research</strong></h3>","<h3 style=\\"text-align: justify;\\">22. <strong>MBA Disaster Management</strong></h3>","<h3 style=\\"text-align: justify;\\">23. <strong>MBA Pharmaceutical Management</strong></h3>","<h3 style=\\"text-align: justify;\\">24. <strong>MBA Technology Management</strong></h3>"}	{}	13	{}
MBA PGDM	Acquire in-depth business knowledge and practical skills through our MBA/PGDM program. Prepare for leadership positions across industries. Advance your career and achieve your professional goals.	2	0	65430	MBA/PGDM Program: Gain Essential Business Skills for Success	A diploma program offered by autonomous institutions, regulated by AICTE (All India Council for Technical Education).	70188159.webp	Full Time 	Feature	pgCourses	\N	1	\N	<h2>Introduction</h2><p>The Post Graduate Diploma in Management (PGDM) is a graduate-level program aimed at providing advanced business and management education. While it shares many similarities with an MBA (Master of Business Administration), the PGDM is often offered by autonomous business schools and can have a more flexible curriculum. The program is designed to equip students with comprehensive management skills and prepare them for leadership roles across various industries.</p><h3>Course Structure</h3><p>The PGDM program typically spans two years, divided into four semesters. The curriculum is designed to offer both foundational business knowledge and specialized management skills. Core subjects generally include:</p><ul><li><strong>Management Principles</strong>: Fundamental concepts and practices in business management.</li><li><strong>Financial Management</strong>: Techniques for managing financial resources, budgeting, and investment analysis.</li><li><strong>Marketing Management</strong>: Strategies for market analysis, consumer behavior, and brand management.</li><li><strong>Human Resource Management</strong>: Managing workforce, recruitment, training, and organizational behavior.</li><li><strong>Operations Management</strong>: Principles of production, operations, and supply chain management.</li><li><strong>Strategic Management</strong>: Developing and implementing business strategies to achieve organizational goals.</li><li><strong>Business Ethics and Corporate Governance</strong>: Examination of ethical issues and governance practices in business.</li><li><strong>Entrepreneurship</strong>: Skills and strategies for starting and managing new business ventures.</li><li><strong>International Business</strong>: Understanding global business practices and international market dynamics.</li><li><strong>Business Research Methods</strong>: Techniques for conducting research and analyzing business data.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a PGDM program, candidates generally need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, though this is not always a strict requirement.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, CAT, or equivalent exams.</li><li><strong>Interview and Personal Statement</strong>: Many programs require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for a PGDM program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 3,00,000 to INR 20,00,000 in India. Fees can be higher in private institutions compared to government-funded colleges.</p><h3>Career Prospects</h3><p>An PGDM offers a range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li><strong>Business Manager</strong>: Overseeing operations, managing teams, and driving business growth.</li><li><strong>Financial Analyst</strong>: Analyzing financial data, preparing reports, and making investment recommendations.</li><li><strong>Marketing Manager</strong>: Developing and implementing marketing strategies to promote products and services.</li><li><strong>HR Manager</strong>: Managing human resources functions, including recruitment, training, and employee relations.</li><li><strong>Operations Manager</strong>: Managing production processes, supply chains, and operational efficiency.</li><li><strong>Consultant</strong>: Providing advisory services to organizations on management strategies and business improvements.</li><li><strong>Entrepreneur</strong>: Starting and managing new business ventures.</li><li><strong>Product Manager</strong>: Overseeing the development and management of products and services.</li><li><strong>Project Manager</strong>: Leading and managing projects, ensuring timely completion and alignment with business objectives.</li></ul><h3>Specializations</h3><p>PGDM programs often offer various specializations, allowing students to tailor their education according to their career interests. Some common specializations include:</p><ul><li><strong>Marketing Management</strong>: Advanced study of marketing strategies, consumer behavior, and brand management.</li><li><strong>Finance Management</strong>: Focus on financial planning, investment analysis, and corporate finance.</li><li><strong>Human Resource Management</strong>: Specialization in managing human resources, organizational behavior, and employee development.</li><li><strong>Operations Management</strong>: Emphasis on optimizing production processes, supply chains, and operational efficiency.</li><li><strong>Entrepreneurship</strong>: Skills and strategies for starting and managing new business ventures.</li><li><strong>International Business</strong>: Understanding global business practices, international market dynamics, and cross-cultural management.</li><li><strong>Supply Chain Management</strong>: Managing logistics, procurement, and supply chain operations.</li><li><strong>Digital Marketing</strong>: Utilization of digital platforms and analytics for marketing strategies.</li></ul><h3>Differences Between MBA and PGDM</h3><p>While both MBA and PGDM programs aim to provide management education, there are some key differences:</p><ul><li><strong>Certification</strong>: An MBA is typically awarded by universities and is a degree, whereas a PGDM is a diploma awarded by autonomous institutions.</li><li><strong>Curriculum Flexibility</strong>: PGDM programs often have more flexibility in their curriculum and can adapt to industry trends more rapidly.</li><li><strong>Accreditation</strong>: MBA programs are usually accredited by university bodies, whereas PGDM programs may have different accreditation standards depending on the institution.</li><li><strong>Duration and Structure</strong>: The structure and duration can vary, with some PGDM programs offering more specialized or intensive modules.</li></ul>									Active	TOC	\N	MBA-PGDM-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Differences Between MBA and PGDM</h3>"}	{}	15	{}
Executive MBA (EMBA)	Immerse yourself in a world-class Executive MBA program. Learn from experienced faculty and collaborate with top-tier professionals. Advance your career to the C-suite.		0	7886	Global Executive MBA: Develop a Global Mindset for Business Success	Elevate your career with an Executive MBA. Develop strategic leadership skills, expand your professional network, and gain a global perspective. Designed for busy executives, our EMBA program delivers maximum impact.	0_jQ_qPG6olE0Yn8RW.jpg	Full Time 	Feature	pgCourses	\N	1	\N	<h2>Introduction</h2><p>The Executive MBA (EMBA) is a specialized graduate program designed for experienced professionals and executives seeking to advance their careers. Unlike traditional MBA programs, which are often geared towards recent graduates or those with less work experience, the EMBA caters to individuals with substantial professional experience and leadership roles. The program focuses on advanced management and strategic skills, aiming to enhance participants' effectiveness as leaders and decision-makers.</p><h3>Course Structure</h3><p>The EMBA program is typically structured to accommodate the busy schedules of working professionals. It often spans 18 to 24 months and is divided into modules that may be delivered in a variety of formats, including weekend classes, intensive sessions, and online components. Key elements of the program include:</p><ul><li><strong>Core Modules</strong>: Advanced courses in fundamental business areas, such as Strategic Management, Financial Management, Leadership, Organizational Behavior, and Operations Management.</li><li><strong>Elective Courses</strong>: Specialized courses that allow participants to focus on areas of interest such as Digital Transformation, Global Business, or Innovation Management.</li><li><strong>Capstone Project</strong>: A major project or thesis that integrates learning from the program with real-world business challenges.</li><li><strong>Global Exposure</strong>: Opportunities for international study tours or exchange programs to gain insights into global business practices.</li><li><strong>Networking Opportunities</strong>: Activities and events designed to connect participants with peers, alumni, and industry leaders.</li></ul><h3>Eligibility Criteria</h3><p>To be eligible for an Executive MBA program, candidates typically need:</p><ul><li><strong>Professional Experience</strong>: Significant work experience, often between 5 to 15 years, with a proven track record in managerial or leadership roles.</li><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. Some programs may have additional requirements.</li><li><strong>Entrance Exams</strong>: Some programs may require scores from standardized tests such as the GMAT or GRE, though many EMBA programs do not.</li><li><strong>Interview and Recommendations</strong>: Often, candidates must undergo an interview and provide letters of recommendation from professional contacts.</li></ul><h3>Fee Structure</h3><p>The fee for an Executive MBA program can vary widely depending on the institution and location. On average, the annual fee ranges from INR 5,00,000 to INR 30,00,000 in India, with fees often being higher for top-tier institutions and international programs.</p><h3>Career Prospects</h3><p>An Executive MBA provides a range of career benefits and opportunities. Graduates often pursue roles such as:</p><ul><li><strong>Senior Executive</strong>: Positions such as Chief Executive Officer (CEO), Chief Operating Officer (COO), or Chief Financial Officer (CFO), responsible for strategic decision-making and organizational leadership.</li><li><strong>Consultant</strong>: Providing strategic advice and solutions to businesses on management, operations, and growth.</li><li><strong>Entrepreneur</strong>: Starting and managing new business ventures with enhanced skills and knowledge.</li><li><strong>General Manager</strong>: Overseeing entire business units or operations within an organization.</li><li><strong>Corporate Strategist</strong>: Developing and implementing strategies to drive business growth and competitive advantage.</li><li><strong>Business Development Manager</strong>: Identifying and pursuing new business opportunities and partnerships.</li></ul><h3>Specializations</h3><p>Executive MBA programs often offer various specializations, allowing participants to focus on areas of interest. Common specializations include:</p><ul><li><strong>Leadership and Management</strong>: Advanced strategies for leading teams, managing change, and developing leadership skills.</li><li><strong>Finance and Accounting</strong>: In-depth study of financial management, investment strategies, and corporate finance.</li><li><strong>Marketing and Sales</strong>: Strategies for developing and implementing marketing and sales plans.</li><li><strong>Operations and Supply Chain Management</strong>: Focus on optimizing business operations, supply chains, and logistics.</li><li><strong>Entrepreneurship and Innovation</strong>: Skills and strategies for starting and growing new business ventures.</li><li><strong>Global Business</strong>: Understanding international markets, global strategies, and cross-cultural management.</li><li><strong>Technology Management</strong>: Managing technology projects, innovations, and IT strategies within organizations.</li></ul><h3>Benefits of an Executive MBA</h3><ul><li><strong>Enhanced Leadership Skills</strong>: Development of advanced leadership and management skills applicable to senior roles.</li><li><strong>Networking Opportunities</strong>: Access to a network of experienced professionals, alumni, and industry leaders.</li><li><strong>Career Advancement</strong>: Improved prospects for career progression, higher-level positions, and increased earning potential.</li><li><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world business challenges through projects and case studies.</li><li><strong>Global Perspective</strong>: Exposure to international business practices and global market dynamics.</li></ul>									Active	TOC	\N	Executive-MBA-(EMBA)-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Benefits of an Executive MBA</h3>"}	{}	16	{}
MBA Technology Management	Our MBA Technology Management program is designed to equip professionals with the skills to lead at the intersection of business and technology. The program focuses on developing strategic thinking, innovation, and digital leadership capabilities.	2	Year	45625	Tech MBA: Bridge Business and Technology for Success	Graduates of our MBA Technology Management program are prepared for leadership roles in technology-driven organizations. They can excel in positions like Chief Technology Officer, Product Manager, IT Director, and technology consultant. The program provides a strong foundation for driving innovation and creating value through technology.	MBA-TM.jpg	Full Time 	Feature	pgCourses	\N	1	\N	<h2>Introduction</h2><p>The Master of Business Administration (MBA) in Technology Management is a specialized program designed for professionals interested in managing technology and innovation within organizations. This program combines business management principles with a deep understanding of technology, aiming to equip students with the skills needed to oversee technological projects, drive innovation, and manage technology-driven business strategies.</p><h3>Course Structure</h3><p>The MBA in Technology Management typically spans two years, divided into four semesters. The curriculum integrates core business courses with specialized technology management subjects. Core subjects often include:</p><ul><li><strong>Introduction to Technology Management</strong>: Overview of managing technology in organizations, including technology strategy and implementation.</li><li><strong>Information Systems Management</strong>: Management of information systems and technology infrastructure within organizations.</li><li><strong>Technology Innovation and Entrepreneurship</strong>: Strategies for fostering innovation and starting technology-driven ventures.</li><li><strong>Project Management</strong>: Techniques for planning, executing, and managing technology projects.</li><li><strong>Technology Strategy</strong>: Development and implementation of technology strategies aligned with business goals.</li><li><strong>Data Analytics</strong>: Utilization of data analytics tools and techniques for decision-making and technology management.</li><li><strong>Cybersecurity Management</strong>: Principles and practices of managing cybersecurity and protecting organizational information systems.</li><li><strong>Emerging Technologies</strong>: Study of cutting-edge technologies and their impact on business and industry.</li><li><strong>Technology and Operations Management</strong>: Integration of technology with business operations to enhance efficiency and effectiveness.</li><li><strong>Change Management</strong>: Strategies for managing organizational change and technology adoption.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in an MBA in Technology Management program, candidates generally need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in technology or engineering is often beneficial but not always required.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in technology-related fields.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT or GRE, or equivalent exams.</li><li><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement.</li></ul><h3>Fee Structure</h3><p>The fee for an MBA in Technology Management program varies widely depending on the institution and location. On average, the annual fee ranges from INR 2,00,000 to INR 30,00,000 in India, with private institutions often charging higher fees compared to government-funded colleges.</p><h3>Career Prospects</h3><p>An MBA in Technology Management opens up a range of career opportunities in technology and business management. Graduates can pursue careers in:</p><ul><li><strong>Technology Manager</strong>: Overseeing technology projects and managing technology resources within organizations.</li><li><strong>IT Director</strong>: Leading the IT department and developing strategies for technology integration.</li><li><strong>Chief Technology Officer (CTO)</strong>: Executing technology strategies and driving technological innovation at the executive level.</li><li><strong>Project Manager</strong>: Managing technology-related projects, ensuring successful delivery and alignment with business goals.</li><li><strong>Product Manager</strong>: Overseeing the development and management of technology products and solutions.</li><li><strong>Technology Consultant</strong>: Advising organizations on technology strategies, solutions, and implementation.</li><li><strong>Innovation Manager</strong>: Leading efforts to drive technological innovation and identify new opportunities for technology-driven growth.</li><li><strong>Data Analyst</strong>: Analyzing data to support technology decisions and business strategies.</li><li><strong>Cybersecurity Analyst</strong>: Managing and protecting organizational information systems from security threats.</li></ul><h3>Specializations</h3><p>Within the MBA in Technology Management program, students may have the option to specialize in areas such as:</p><ul><li><strong>Cybersecurity Management</strong>: Focus on managing cybersecurity practices and protecting organizational data.</li><li><strong>Data Analytics</strong>: Specialization in utilizing data analytics tools and techniques for decision-making and technology management.</li><li><strong>Technology Strategy</strong>: Emphasis on developing and implementing technology strategies to align with business objectives.</li><li><strong>Innovation and Entrepreneurship</strong>: Study of strategies for fostering innovation and starting technology-driven businesses.</li><li><strong>Project Management</strong>: Advanced techniques for managing technology projects and ensuring successful execution.</li><li><strong>Emerging Technologies</strong>: Exploration of cutting-edge technologies and their applications in various industries.</li></ul><h3><br></h3>									Active	TOC	\N	MBA-Technology-Management-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specialization</h3>}	{}	14	{}
MBA IT (Information Technology)	Earn your MBA in IT online and advance your career. Our flexible program combines business acumen with IT expertise to prepare you for leadership roles.	2	Year	41321	MBA IT in Business Analytics: Drive Growth with Data	Become a data-driven decision-maker with our MBA IT in Business Analytics. Learn to harness data to optimize operations, improve customer experiences, and gain a competitive edge.	MBA-in-Information-Technology-body-images.jpg	0	Feature	pgCourses	\N	1	\N	<h2>Introduction</h2><p>MBA in Information Technology (MBA IT) is a specialized graduate program designed to bridge the gap between business management and information technology. This program is tailored for individuals who aim to integrate IT solutions with business strategies, manage technology projects, and lead IT-driven initiatives within organizations. The MBA IT program combines core management principles with advanced IT concepts, preparing graduates to excel in technology-driven roles.</p><h3>Course Structure</h3><p>The MBA IT program typically spans two years and is divided into four semesters. The curriculum integrates fundamental business courses with specialized IT subjects. Core modules usually include:</p><ul><li><strong>Management Information Systems (MIS)</strong>: Study of information systems used to manage and process organizational data.</li><li><strong>IT Strategy and Management</strong>: Techniques for aligning IT strategies with business goals and managing technology resources.</li><li><strong>Data Management and Analytics</strong>: Focus on data collection, storage, analysis, and utilization for decision-making.</li><li><strong>Enterprise Resource Planning (ERP)</strong>: Implementation and management of ERP systems to streamline business processes.</li><li><strong>Cybersecurity Management</strong>: Principles and practices for protecting information systems and data from security threats.</li><li><strong>Project Management</strong>: Techniques for managing IT projects, including planning, execution, and risk management.</li><li><strong>Digital Transformation</strong>: Strategies for leveraging technology to drive business transformation and innovation.</li><li><strong>Cloud Computing</strong>: Understanding cloud technologies, services, and their application in business.</li><li><strong>Software Development and Management</strong>: Principles of software development, including design, implementation, and maintenance.</li><li><strong>IT Governance and Compliance</strong>: Ensuring that IT operations comply with regulatory standards and organizational policies.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in an MBA IT program, candidates typically need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in technology or computer science is often preferred but not always required.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in IT or management roles.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for an MBA IT program can vary widely depending on the institution and location. On average, the annual fee ranges from INR 3,00,000 to INR 20,00,000 in India. Fees can be higher in private institutions and international programs.</p><h3>Career Prospects</h3><p>An MBA in IT opens up diverse career opportunities in technology and management. Graduates can pursue roles such as:</p><ul><li><strong>IT Manager</strong>: Overseeing IT operations, managing technology resources, and ensuring alignment with business objectives.</li><li><strong>Chief Information Officer (CIO)</strong>: Leading the IT department, developing IT strategies, and driving digital transformation initiatives.</li><li><strong>IT Consultant</strong>: Advising organizations on IT strategies, solutions, and implementations to improve business performance.</li><li><strong>Project Manager</strong>: Managing IT projects, ensuring successful delivery, and coordinating with stakeholders.</li><li><strong>Business Analyst</strong>: Analyzing business processes and recommending IT solutions to enhance efficiency and effectiveness.</li><li><strong>Data Analyst</strong>: Utilizing data analytics tools and techniques to support decision-making and business strategies.</li><li><strong>Cybersecurity Specialist</strong>: Managing and protecting organizational information systems from security threats and breaches.</li><li><strong>Cloud Solutions Architect</strong>: Designing and implementing cloud-based solutions to meet organizational needs.</li><li><strong>ERP Specialist</strong>: Implementing and managing ERP systems to streamline business processes and operations.</li></ul><h3>Specializations</h3><p>Within the MBA IT program, students may have the option to specialize in areas such as:</p><ul><li><strong>Cybersecurity</strong>: Focus on protecting information systems and data from security threats and breaches.</li><li><strong>Data Science and Analytics</strong>: Advanced study of data analytics techniques and their application in business decision-making.</li><li><strong>Cloud Computing</strong>: Specialization in cloud technologies, services, and their integration into business operations.</li><li><strong>IT Project Management</strong>: Techniques for managing complex IT projects, including planning, execution, and risk management.</li><li><strong>Digital Transformation</strong>: Strategies for leveraging technology to drive business innovation and transformation.</li><li><strong>Software Engineering</strong>: Principles and practices of software development, including design, implementation, and maintenance.</li></ul><h3>Benefits of an MBA IT</h3><ul><li><strong>Enhanced IT and Management Skills</strong>: Development of skills to manage technology resources and integrate IT with business strategies.</li><li><strong>Career Advancement</strong>: Improved prospects for career progression in IT management, consulting, and leadership roles.</li><li><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world technology and business challenges through projects and case studies.</li><li><strong>Networking Opportunities</strong>: Access to a network of professionals, alumni, and industry experts in the IT and business fields.</li><li><strong>Global Perspective</strong>: Understanding global IT trends and practices, and their impact on business operations.</li></ul>									Active	TOC	\N	MBA-IT-(Information-Technology)-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Benefits of an MBA IT</h3>"}	{}	17	{}
MBA in Safety Management	Master industrial safety practices with our MBA program. Develop expertise in hazard identification, risk assessment, and incident investigation.	2	Year	65757	MBA in Safety Management: Become a Safety Leader	Advance your career in safety management with our MBA program. Learn to identify, assess, and mitigate risks to create safer workplaces.	images (12).jfif	Full Time 	Feature	pgCourses	\N	1	\N	<h2>Introduction</h2><p>The MBA in Safety Management is a specialized graduate program designed to equip professionals with the skills needed to manage safety and risk in various organizational environments. This program focuses on developing advanced knowledge in occupational health, safety regulations, and risk management strategies, aimed at ensuring a safe and compliant workplace. The MBA in Safety Management is ideal for individuals seeking leadership roles in safety management, compliance, and risk mitigation.</p><h3>Course Structure</h3><p>The MBA in Safety Management typically spans two years and is divided into four semesters. The curriculum combines core business courses with specialized safety management subjects. Core modules usually include:</p><ul><li><strong>Principles of Safety Management</strong>: Fundamental concepts and practices in managing workplace safety and health.</li><li><strong>Risk Management and Assessment</strong>: Techniques for identifying, analyzing, and managing risks in various organizational settings.</li><li><strong>Occupational Health and Safety Regulations</strong>: Study of regulatory standards, compliance requirements, and best practices in occupational health and safety.</li><li><strong>Emergency Response and Disaster Management</strong>: Strategies and procedures for responding to emergencies and managing disasters.</li><li><strong>Safety Engineering</strong>: Application of engineering principles to design and implement safety systems and controls.</li><li><strong>Environmental Health and Safety</strong>: Understanding environmental regulations, sustainability practices, and their impact on workplace safety.</li><li><strong>Safety Culture and Behavior</strong>: Techniques for fostering a safety-conscious culture and influencing employee behavior.</li><li><strong>Safety Audits and Inspections</strong>: Methods for conducting safety audits, inspections, and ensuring regulatory compliance.</li><li><strong>Accident Investigation and Reporting</strong>: Procedures for investigating accidents, documenting findings, and implementing corrective actions.</li><li><strong>Leadership and Management</strong>: Development of leadership skills and management practices specific to safety and risk management.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in an MBA in Safety Management program, candidates generally need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in engineering, health sciences, or related fields may be preferred.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in safety or risk management roles.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for an MBA in Safety Management program can vary depending on the institution and location. On average, the annual fee ranges from INR 3,00,000 to INR 15,00,000 in India. Fees can be higher in private institutions and international programs.</p><h3>Career Prospects</h3><p>An MBA in Safety Management opens up a range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li><strong>Safety Manager</strong>: Overseeing safety programs, ensuring compliance with regulations, and managing safety resources.</li><li><strong>Risk Manager</strong>: Identifying, assessing, and managing risks to minimize potential impacts on the organization.</li><li><strong>Safety Consultant</strong>: Advising organizations on safety practices, risk management strategies, and compliance with safety regulations.</li><li><strong>Health and Safety Officer</strong>: Ensuring workplace safety, conducting inspections, and implementing health and safety policies.</li><li><strong>Emergency Response Coordinator</strong>: Developing and managing emergency response plans and coordinating disaster response efforts.</li><li><strong>Safety Engineer</strong>: Designing and implementing safety systems and controls to prevent accidents and ensure safe operations.</li><li><strong>Compliance Manager</strong>: Ensuring adherence to safety regulations and industry standards, and managing compliance programs.</li><li><strong>Safety Auditor</strong>: Conducting safety audits, evaluating safety practices, and recommending improvements.</li></ul><h3>Specializations</h3><p>Within the MBA in Safety Management program, students may have the option to specialize in areas such as:</p><ul><li><strong>Industrial Safety</strong>: Focus on safety practices and regulations specific to industrial environments.</li><li><strong>Environmental Safety</strong>: Emphasis on environmental regulations, sustainability practices, and their impact on safety.</li><li><strong>Health and Safety Compliance</strong>: Specialization in compliance with health and safety regulations and standards.</li><li><strong>Emergency Management</strong>: Techniques and strategies for managing emergencies, disasters, and crisis situations.</li><li><strong>Risk Assessment and Mitigation</strong>: Advanced study of risk assessment techniques and strategies for mitigating risks.</li><li><strong>Safety Leadership</strong>: Development of leadership skills and strategies for managing safety teams and fostering a safety culture.</li></ul><h3>Benefits of an MBA in Safety Management</h3><ul><li><strong>Enhanced Safety Skills</strong>: Development of advanced skills in managing workplace safety, risk assessment, and regulatory compliance.</li><li><strong>Career Advancement</strong>: Improved prospects for career progression in safety management, risk management, and compliance roles.</li><li><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world safety challenges through projects and case studies.</li><li><strong>Networking Opportunities</strong>: Access to a network of professionals, alumni, and industry experts in the safety and risk management fields.</li><li><strong>Regulatory Knowledge</strong>: In-depth understanding of safety regulations, standards, and best practices applicable across various industries.</li></ul>									Active	TOC	\N	MBA-in-Safety-Management-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Benefits of an MBA in Safety Management</h3>"}	{}	18	{}
MBA in Finance	MBA in Finance is a specialized graduate program designed to equip students with advanced knowledge and skills in financial management, investment analysis, and financial decision-making. This program is ideal for individuals aiming to pursue careers in finance, banking, investment management, corporate finance, and related fields.	2	Year	34121	MBA in Finance: Master Financial Management and Leadership	Advance your finance career with our online MBA. Learn from industry experts while balancing work and studies.\nAdditional Tips	MBA-Finance.jpg	Full Time 	Feature	pgCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The MBA in Finance is a specialized graduate program designed to equip students with advanced knowledge and skills in financial management, investment analysis, and financial decision-making. This program is ideal for individuals aiming to pursue careers in finance, banking, investment management, corporate finance, and related fields. The MBA in Finance combines core business principles with specialized finance courses, preparing graduates to excel in various finance-related roles.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The MBA in Finance program typically spans two years and is divided into four semesters. The curriculum integrates fundamental business courses with specialized finance subjects. Core modules usually include:</p><ul><li style="text-align: justify;"><strong>Financial Management</strong>: Principles of managing an organization's financial resources, including budgeting, forecasting, and financial planning.</li><li style="text-align: justify;"><strong>Investment Analysis and Portfolio Management</strong>: Techniques for evaluating investment opportunities, managing investment portfolios, and assessing risks and returns.</li><li style="text-align: justify;"><strong>Corporate Finance</strong>: Study of corporate financial decision-making, capital structure, mergers and acquisitions, and corporate governance.</li><li style="text-align: justify;"><strong>Financial Markets and Institutions</strong>: Understanding the functioning of financial markets, instruments, and regulatory frameworks.</li><li style="text-align: justify;"><strong>Accounting for Managers</strong>: Principles of financial and managerial accounting, including financial statement analysis and cost management.</li><li style="text-align: justify;"><strong>Risk Management</strong>: Techniques for identifying, analyzing, and managing financial risks, including market risk, credit risk, and operational risk.</li><li style="text-align: justify;"><strong>International Finance</strong>: Study of global financial markets, exchange rates, international trade, and multinational financial management.</li><li style="text-align: justify;"><strong>Financial Modeling and Valuation</strong>: Building financial models and valuing businesses using various methods such as discounted cash flow (DCF) and comparables analysis.</li><li style="text-align: justify;"><strong>Quantitative Methods for Finance</strong>: Application of quantitative techniques and statistical analysis in finance.</li><li style="text-align: justify;"><strong>Behavioral Finance</strong>: Understanding the psychological factors that influence financial decision-making and market behavior.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA in Finance program, candidates typically need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in business, economics, or related fields may be preferred.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in finance or related roles.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA in Finance program can vary depending on the institution and location. On average, the annual fee ranges from INR 3,00,000 to INR 20,00,000 in India. Fees can be higher in private institutions and international programs.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA in Finance opens up a wide range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li style="text-align: justify;"><strong>Financial Analyst</strong>: Analyzing financial data, preparing reports, and providing investment recommendations.</li><li style="text-align: justify;"><strong>Investment Banker</strong>: Assisting companies in raising capital, mergers and acquisitions, and financial advisory services.</li><li style="text-align: justify;"><strong>Portfolio Manager</strong>: Managing investment portfolios, making investment decisions, and assessing risks and returns.</li><li style="text-align: justify;"><strong>Corporate Finance Manager</strong>: Managing an organization's financial activities, including budgeting, forecasting, and financial planning.</li><li style="text-align: justify;"><strong>Financial Consultant</strong>: Providing financial advisory services to individuals or organizations, including financial planning and wealth management.</li><li style="text-align: justify;"><strong>Risk Manager</strong>: Identifying, analyzing, and managing financial risks to protect an organization’s assets and earnings.</li><li style="text-align: justify;"><strong>Treasury Manager</strong>: Managing an organization’s liquidity, investments, and risk exposure.</li><li style="text-align: justify;"><strong>Credit Analyst</strong>: Assessing the creditworthiness of individuals or organizations and making lending decisions.</li><li style="text-align: justify;"><strong>Financial Controller</strong>: Overseeing financial reporting, accounting, and internal controls within an organization.</li><li style="text-align: justify;"><strong>Chief Financial Officer (CFO)</strong>: Leading the finance department, developing financial strategies, and ensuring financial health of the organization.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the MBA in Finance program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Investment Banking</strong>: Focus on mergers and acquisitions, capital raising, and financial advisory services.</li><li style="text-align: justify;"><strong>Asset Management</strong>: Managing investment portfolios, assessing risks and returns, and developing investment strategies.</li><li style="text-align: justify;"><strong>Corporate Finance</strong>: Advanced study of corporate financial decision-making, capital structure, and corporate governance.</li><li style="text-align: justify;"><strong>Risk Management</strong>: Techniques for identifying, analyzing, and managing financial risks.</li><li style="text-align: justify;"><strong>International Finance</strong>: Understanding global financial markets, exchange rates, and multinational financial management.</li><li style="text-align: justify;"><strong>Quantitative Finance</strong>: Application of quantitative techniques and statistical analysis in financial decision-making.</li><li style="text-align: justify;"><strong>Behavioral Finance</strong>: Study of psychological factors influencing financial decision-making and market behavior.</li></ul><h3 style="text-align: justify;">Benefits of an MBA in Finance</h3><ul><li style="text-align: justify;"><strong>Advanced Financial Skills</strong>: Development of advanced skills in financial analysis, investment management, and corporate finance.</li><li style="text-align: justify;"><strong>Career Advancement</strong>: Improved prospects for career progression in finance, banking, investment management, and related fields.</li><li style="text-align: justify;"><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world financial challenges through projects and case studies.</li><li style="text-align: justify;"><strong>Networking Opportunities</strong>: Access to a network of finance professionals, alumni, and industry experts.</li><li style="text-align: justify;"><strong>Global Perspective</strong>: Understanding global financial markets, international finance practices, and their impact on business operations.</li></ul>									Active	TOC	\N	MBA-in-Finance-	{}	{"<h2 style=\\"text-align: justify;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Benefits of an MBA in Finance</h3>"}	{}	19	{}
MBA in Operations	MBA in Operations is a specialized graduate program designed to equip students with advanced knowledge and skills in managing the production, logistics, and overall operations of organizations. This program is ideal for individuals aiming to pursue careers in operations management, supply chain management, logistics, and related fields.	2	Year	65676	MBA in Operations Management: Master Supply Chain and Logistics	Optimize business operations with our MBA in Operations. Learn supply chain management, process improvement, and data-driven decision-making.	MBA-in-Operations-Management-Body-images.jpg	Full Time 	Feature	pgCourses	\N	\N	\N	<h2>Introduction</h2><p>The MBA in Operations is a specialized graduate program designed to equip students with advanced knowledge and skills in managing the production, logistics, and overall operations of organizations. This program is ideal for individuals aiming to pursue careers in operations management, supply chain management, logistics, and related fields. The MBA Operations program combines core business principles with specialized operations management courses, preparing graduates to optimize processes and enhance organizational efficiency.</p><h3>Course Structure</h3><p>The MBA Operations program typically spans two years and is divided into four semesters. The curriculum integrates fundamental business courses with specialized operations management subjects. Core modules usually include:</p><ul><li><strong>Operations Management</strong>: Principles and practices of managing production processes, quality control, and operations strategy.</li><li><strong>Supply Chain Management</strong>: Study of supply chain design, logistics, inventory management, and supplier relations.</li><li><strong>Project Management</strong>: Techniques for planning, executing, and controlling projects to achieve organizational goals.</li><li><strong>Quality Management</strong>: Principles of quality control, quality assurance, and continuous improvement in operations.</li><li><strong>Production Planning and Control</strong>: Techniques for planning and controlling production activities to optimize efficiency.</li><li><strong>Lean Management</strong>: Application of lean principles to eliminate waste and improve processes.</li><li><strong>Operations Strategy</strong>: Development and implementation of strategies to enhance operational performance.</li><li><strong>Logistics Management</strong>: Managing the flow of goods and services from suppliers to customers.</li><li><strong>Process Optimization</strong>: Techniques for analyzing and improving business processes to increase efficiency and effectiveness.</li><li><strong>Technology in Operations</strong>: Use of technology and information systems to support and improve operations.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in an MBA Operations program, candidates typically need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in engineering, business, or related fields may be preferred.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially in operations or related roles.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for an MBA Operations program can vary depending on the institution and location. On average, the annual fee ranges from INR 3,00,000 to INR 15,00,000 in India. Fees can be higher in private institutions and international programs.</p><h3>Career Prospects</h3><p>An MBA in Operations opens up a wide range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li><strong>Operations Manager</strong>: Overseeing production processes, ensuring efficiency, and managing resources.</li><li><strong>Supply Chain Manager</strong>: Managing supply chain activities, including procurement, logistics, and inventory management.</li><li><strong>Project Manager</strong>: Planning, executing, and controlling projects to achieve organizational goals.</li><li><strong>Quality Manager</strong>: Ensuring product or service quality, implementing quality control processes, and leading continuous improvement initiatives.</li><li><strong>Logistics Manager</strong>: Managing the transportation, storage, and distribution of goods.</li><li><strong>Production Manager</strong>: Overseeing the production process, managing production schedules, and ensuring efficient use of resources.</li><li><strong>Operations Consultant</strong>: Advising organizations on operations strategy, process improvement, and efficiency optimization.</li><li><strong>Process Improvement Manager</strong>: Identifying and implementing process improvements to enhance operational efficiency.</li><li><strong>Inventory Manager</strong>: Managing inventory levels, optimizing stock, and ensuring availability of materials.</li><li><strong>Purchasing Manager</strong>: Overseeing procurement activities, managing supplier relationships, and negotiating contracts.</li></ul><h3>Specializations</h3><p>Within the MBA Operations program, students may have the option to specialize in areas such as:</p><ul><li><strong>Supply Chain Management</strong>: Focus on managing the flow of goods and services, supplier relations, and logistics.</li><li><strong>Project Management</strong>: Advanced study of project planning, execution, and control.</li><li><strong>Quality Management</strong>: Techniques for ensuring product or service quality and implementing continuous improvement initiatives.</li><li><strong>Logistics Management</strong>: Managing the transportation, storage, and distribution of goods.</li><li><strong>Lean Management</strong>: Application of lean principles to eliminate waste and improve processes.</li><li><strong>Process Optimization</strong>: Techniques for analyzing and improving business processes to increase efficiency and effectiveness.</li><li><strong>Technology in Operations</strong>: Use of technology and information systems to support and improve operations.</li></ul><h3>Benefits of an MBA in Operations</h3><ul><li><strong>Advanced Operations Skills</strong>: Development of advanced skills in managing production, logistics, and overall operations.</li><li><strong>Career Advancement</strong>: Improved prospects for career progression in operations management, supply chain management, and related fields.</li><li><strong>Practical Learning</strong>: Application of theoretical knowledge to real-world operations challenges through projects and case studies.</li><li><strong>Networking Opportunities</strong>: Access to a network of operations professionals, alumni, and industry experts.</li><li><strong>Efficiency and Optimization</strong>: Understanding how to optimize processes, reduce costs, and enhance operational efficiency.</li></ul>									Active	TOC	\N	MBA-in-Operations-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Benefits of an MBA in Operations</h3>"}	{}	21	{}
MBA Distance Education	Balance work and study with our distance learning MBA. Gain in-demand management expertise.	2	Year	54323	Online MBA: Flexible Path to Business Success	Become a financial expert with our online MBA. Learn investment, accounting, and financial analysis from anywhere.	images (7).png	Full Time 	Feature	pgCourses	\N	1	\N	<h2 style="text-align: justify;">Introduction</h2><p style="text-align: justify;">The MBA in Distance Education is a flexible graduate program designed for working professionals and individuals who cannot commit to a full-time, on-campus program. This program provides the same rigorous curriculum as traditional MBA programs but allows students to study at their own pace and convenience. The MBA Distance Education program covers a broad range of business principles, preparing graduates for leadership roles in various industries.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">The MBA Distance Education program typically spans two to three years, depending on the institution and the student's pace. The curriculum integrates core business courses with elective specializations. Core modules usually include:</p><ul><li style="text-align: justify;"><strong>Business Management</strong>: Principles of managing an organization, including planning, organizing, leading, and controlling.</li><li style="text-align: justify;"><strong>Financial Management</strong>: Techniques for managing an organization's financial resources, including budgeting, forecasting, and financial analysis.</li><li style="text-align: justify;"><strong>Marketing Management</strong>: Strategies for creating, communicating, and delivering value to customers.</li><li style="text-align: justify;"><strong>Human Resource Management</strong>: Managing an organization's human resources, including recruitment, training, and development.</li><li style="text-align: justify;"><strong>Operations Management</strong>: Managing production processes, quality control, and supply chain management.</li><li style="text-align: justify;"><strong>Strategic Management</strong>: Developing and implementing strategies to achieve organizational goals.</li><li style="text-align: justify;"><strong>Organizational Behavior</strong>: Study of human behavior in organizational settings, focusing on motivation, leadership, and team dynamics.</li><li style="text-align: justify;"><strong>Economics for Managers</strong>: Understanding economic principles and their application to business decision-making.</li><li style="text-align: justify;"><strong>Business Analytics</strong>: Utilizing data and analytical techniques to make informed business decisions.</li><li style="text-align: justify;"><strong>Information Technology Management</strong>: Managing information systems and technology to support business operations.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA Distance Education program, candidates generally need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in business or related fields may be preferred.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially for executive MBA programs.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA Distance Education program can vary depending on the institution and location. On average, the total fee ranges from INR 50,000 to INR 3,00,000 in India. Fees can be higher for international programs or those offered by prestigious institutions.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA in Distance Education opens up a wide range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li style="text-align: justify;"><strong>Business Manager</strong>: Overseeing business operations, managing resources, and ensuring organizational efficiency.</li><li style="text-align: justify;"><strong>Financial Analyst</strong>: Analyzing financial data, preparing reports, and providing investment recommendations.</li><li style="text-align: justify;"><strong>Marketing Manager</strong>: Developing and implementing marketing strategies to promote products or services.</li><li style="text-align: justify;"><strong>HR Manager</strong>: Managing HR functions, including recruitment, training, and employee relations.</li><li style="text-align: justify;"><strong>Operations Manager</strong>: Overseeing production processes, managing logistics, and optimizing operations.</li><li style="text-align: justify;"><strong>Project Manager</strong>: Planning, executing, and controlling projects to achieve organizational goals.</li><li style="text-align: justify;"><strong>Consultant</strong>: Providing advisory services to organizations on various business functions and strategies.</li><li style="text-align: justify;"><strong>Entrepreneur</strong>: Starting and managing a new business venture.</li><li style="text-align: justify;"><strong>Product Manager</strong>: Overseeing the development and marketing of products.</li><li style="text-align: justify;"><strong>Sales Manager</strong>: Leading sales teams, developing sales strategies, and achieving sales targets.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Within the MBA Distance Education program, students may have the option to specialize in areas such as:</p><ul><li style="text-align: justify;"><strong>Finance</strong>: Advanced study of financial management, investment analysis, and corporate finance.</li><li style="text-align: justify;"><strong>Marketing</strong>: Techniques for market research, digital marketing, and brand management.</li><li style="text-align: justify;"><strong>Human Resources</strong>: Strategies for talent management, labor relations, and organizational development.</li><li style="text-align: justify;"><strong>Operations</strong>: Focus on supply chain management, logistics, and process optimization.</li><li style="text-align: justify;"><strong>Information Technology</strong>: Managing information systems and technology to support business operations.</li><li style="text-align: justify;"><strong>International Business</strong>: Understanding global markets, international trade, and cross-cultural management.</li><li style="text-align: justify;"><strong>Entrepreneurship</strong>: Developing skills for starting and managing new business ventures.</li><li style="text-align: justify;"><strong>Healthcare Management</strong>: Managing healthcare organizations, healthcare policy, and healthcare operations.</li><li style="text-align: justify;"><strong>Project Management</strong>: Techniques for planning, executing, and controlling projects.</li></ul><h3 style="text-align: justify;">Benefits of an MBA in Distance Education</h3><ul><li style="text-align: justify;"><strong>Flexibility</strong>: Ability to study at your own pace and schedule, making it ideal for working professionals.</li><li style="text-align: justify;"><strong>Cost-Effective</strong>: Often less expensive than traditional full-time MBA programs.</li><li style="text-align: justify;"><strong>Accessibility</strong>: Opportunity to study from anywhere in the world without relocating.</li><li style="text-align: justify;"><strong>Career Advancement</strong>: Improved prospects for career progression and transition into leadership roles.</li><li style="text-align: justify;"><strong>Diverse Specializations</strong>: Option to specialize in various fields to align with career goals.</li><li style="text-align: justify;"><strong>Networking Opportunities</strong>: Access to a network of peers, alumni, and industry professionals.</li></ul><h3 style="text-align: justify;">Challenges</h3><ul><li style="text-align: justify;"><strong>Self-Discipline</strong>: Requires a high level of self-motivation and discipline to complete coursework independently.</li><li style="text-align: justify;"><strong>Limited Interaction</strong>: Less face-to-face interaction with professors and peers compared to traditional programs.</li><li style="text-align: justify;"><strong>Time Management</strong>: Balancing studies with work and personal commitments can be challenging.</li></ul><h3 style="text-align: justify;">Conclusion</h3><p style="text-align: justify;">The MBA in Distance Education is a comprehensive program designed for individuals seeking to advance their careers while maintaining their current professional and personal commitments. It provides a deep understanding of business principles and specialized knowledge in various fields. With a focus on flexibility, accessibility, and practical application, the MBA Distance Education equips graduates with the skills needed to excel in leadership roles and make a significant impact in their organizations.</p>									Active	TOC	\N	MBA-Distance-Education-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Benefits of an MBA in Distance Education</h3>",<h3>Challenges</h3>,<h3>Conclusion</h3>}	{}	22	{}
Online MBA Dual Specialization	Gain a competitive edge with our online MBA dual specialization program. Master two in-demand business areas and accelerate your career growth.	2	Year	53421	Online MBA Dual Specialization	Combine financial expertise with marketing acumen. Our online MBA dual specialization in finance and marketing prepares you for top management roles.	image.webp	Full Time 	Feature	pgCourses	\N	\N	\N	<h2>Introduction</h2><p>The Online MBA with Dual Specialization is a unique and flexible graduate program designed to provide students with advanced business knowledge and skills in two specific areas of specialization. This program is ideal for working professionals and individuals who seek to broaden their expertise and enhance their career prospects by mastering multiple business disciplines. The online format allows students to study at their convenience, balancing their education with work and personal commitments.</p><h3>Course Structure</h3><p>The Online MBA with Dual Specialization program typically spans two years and is divided into four semesters. The curriculum integrates core business courses with elective courses from the chosen specializations. Core modules usually include:</p><ul><li><strong>Business Management</strong>: Principles of managing an organization, including planning, organizing, leading, and controlling.</li><li><strong>Financial Management</strong>: Techniques for managing an organization's financial resources, including budgeting, forecasting, and financial analysis.</li><li><strong>Marketing Management</strong>: Strategies for creating, communicating, and delivering value to customers.</li><li><strong>Human Resource Management</strong>: Managing an organization's human resources, including recruitment, training, and development.</li><li><strong>Operations Management</strong>: Managing production processes, quality control, and supply chain management.</li><li><strong>Strategic Management</strong>: Developing and implementing strategies to achieve organizational goals.</li><li><strong>Organizational Behavior</strong>: Study of human behavior in organizational settings, focusing on motivation, leadership, and team dynamics.</li><li><strong>Economics for Managers</strong>: Understanding economic principles and their application to business decision-making.</li><li><strong>Business Analytics</strong>: Utilizing data and analytical techniques to make informed business decisions.</li><li><strong>Information Technology Management</strong>: Managing information systems and technology to support business operations.</li></ul><h3>Specializations</h3><p>Students in an Online MBA with Dual Specialization program can choose two areas of specialization. Some common specializations include:</p><ul><li><strong>Finance</strong>: Advanced study of financial management, investment analysis, and corporate finance.</li><li><strong>Marketing</strong>: Techniques for market research, digital marketing, and brand management.</li><li><strong>Human Resources</strong>: Strategies for talent management, labor relations, and organizational development.</li><li><strong>Operations</strong>: Focus on supply chain management, logistics, and process optimization.</li><li><strong>Information Technology</strong>: Managing information systems and technology to support business operations.</li><li><strong>International Business</strong>: Understanding global markets, international trade, and cross-cultural management.</li><li><strong>Entrepreneurship</strong>: Developing skills for starting and managing new business ventures.</li><li><strong>Healthcare Management</strong>: Managing healthcare organizations, healthcare policy, and healthcare operations.</li><li><strong>Project Management</strong>: Techniques for planning, executing, and controlling projects.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in an Online MBA with Dual Specialization program, candidates generally need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution. A background in business or related fields may be preferred.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, especially for executive MBA programs.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams may be required.</li><li><strong>Interview and Personal Statement</strong>: Some programs may require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for an Online MBA with Dual Specialization program can vary depending on the institution and location. On average, the total fee ranges from INR 1,00,000 to INR 5,00,000 in India. Fees can be higher for international programs or those offered by prestigious institutions.</p><h3>Career Prospects</h3><p>An Online MBA with Dual Specialization opens up a wide range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li><strong>Business Manager</strong>: Overseeing business operations, managing resources, and ensuring organizational efficiency.</li><li><strong>Financial Analyst</strong>: Analyzing financial data, preparing reports, and providing investment recommendations.</li><li><strong>Marketing Manager</strong>: Developing and implementing marketing strategies to promote products or services.</li><li><strong>HR Manager</strong>: Managing HR functions, including recruitment, training, and employee relations.</li><li><strong>Operations Manager</strong>: Overseeing production processes, managing logistics, and optimizing operations.</li><li><strong>Project Manager</strong>: Planning, executing, and controlling projects to achieve organizational goals.</li><li><strong>Consultant</strong>: Providing advisory services to organizations on various business functions and strategies.</li><li><strong>Entrepreneur</strong>: Starting and managing a new business venture.</li><li><strong>Product Manager</strong>: Overseeing the development and marketing of products.</li><li><strong>Sales Manager</strong>: Leading sales teams, developing sales strategies, and achieving sales targets.</li></ul><h3>Benefits of an Online MBA with Dual Specialization</h3><ul><li><strong>Flexibility</strong>: Ability to study at your own pace and schedule, making it ideal for working professionals.</li><li><strong>Broad Expertise</strong>: Gaining advanced knowledge and skills in two areas of specialization enhances career prospects and versatility.</li><li><strong>Cost-Effective</strong>: Often less expensive than traditional full-time MBA programs.</li><li><strong>Accessibility</strong>: Opportunity to study from anywhere in the world without relocating.</li><li><strong>Career Advancement</strong>: Improved prospects for career progression and transition into leadership roles.</li><li><strong>Networking Opportunities</strong>: Access to a network of peers, alumni, and industry professionals.</li></ul><h3>Challenges</h3><ul><li><strong>Self-Discipline</strong>: Requires a high level of self-motivation and discipline to complete coursework independently.</li><li><strong>Limited Interaction</strong>: Less face-to-face interaction with professors and peers compared to traditional programs.</li><li><strong>Time Management</strong>: Balancing studies with work and personal commitments can be challenging.</li></ul>									Active	TOC	\N	Online-MBA-Dual-Specialization-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>",<h3>Specializations</h3>,"<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>","<h3>Benefits of an Online MBA with Dual Specialization</h3>",<h3>Challenges</h3>}	{}	23	{}
\.


--
-- TOC entry 3877 (class 0 OID 16940)
-- Dependencies: 279
-- Data for Name: individualcoursefaq; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.individualcoursefaq (question, answer, added_by, added_date, courseid, last_modified, id) FROM stdin;
{}	{}	1	\N	1	\N	1
{}	{}	Ibrahim	\N	2	2024-07-23 10:57:43	2
{}	{}	1	\N	3	\N	3
{}	{}	1	\N	4	\N	4
{}	{}	1	\N	5	\N	5
{}	{}	1	\N	6	\N	6
{}	{}	1	\N	7	\N	7
{}	{}	1	\N	8	\N	8
{}	{}	1	\N	9	\N	9
{}	{}	1	\N	10	\N	10
{}	{}	1	\N	11	\N	11
{}	{}	1	\N	12	\N	12
{}	{}	undefined	\N	13	\N	13
{}	{}	1	\N	14	\N	14
{}	{}	1	\N	15	\N	15
{}	{}	1	\N	16	\N	16
{}	{}	1	\N	17	\N	17
{}	{}	1	\N	18	\N	18
{}	{}	1	\N	19	\N	19
{}	{}	undefined	\N	20	\N	20
{}	{}	undefined	\N	21	\N	21
{}	{}	1	\N	22	\N	22
{}	{}	undefined	\N	23	\N	23
\.


--
-- TOC entry 3878 (class 0 OID 16949)
-- Dependencies: 280
-- Data for Name: job; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.job (id, jobtype, jobmode, name, location, responsilibity, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 3879 (class 0 OID 16960)
-- Dependencies: 281
-- Data for Name: jobmode; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.jobmode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 3880 (class 0 OID 16970)
-- Dependencies: 282
-- Data for Name: jobreference; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.jobreference (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 3881 (class 0 OID 16980)
-- Dependencies: 283
-- Data for Name: jobresponse; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.jobresponse (id, jobtype, name, email, reference, resume, experienceed, isugpg, hqualifuication, ctc, expereience, added_by, added_date, last_modified_by, last_modifed_date, phone) FROM stdin;
\.


--
-- TOC entry 3882 (class 0 OID 16990)
-- Dependencies: 284
-- Data for Name: jobtype; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.jobtype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	dfdsf	Active	1	2024-07-26 05:53:48.821173	\N	\N
\.


--
-- TOC entry 3883 (class 0 OID 17000)
-- Dependencies: 285
-- Data for Name: lead; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.lead (id, name, email, phone, courseid, universityid, city, message, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3884 (class 0 OID 17020)
-- Dependencies: 286
-- Data for Name: media; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.media (id, name, image, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
8	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:53:39.653489	\N	\N
9	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:53:45.899759	\N	\N
10	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:53:48.434337	\N	\N
11	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:53:50.290807	\N	\N
12	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:54:12.996457	\N	\N
13	Ibrahim Memon	1679235462260.jpeg	1	2024-08-02 13:54:51.505484	\N	\N
\.


--
-- TOC entry 3885 (class 0 OID 17030)
-- Dependencies: 287
-- Data for Name: moreresource; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.moreresource (id, button1, button2, button3, button4, button5, button6, newstudent, visitus, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 3886 (class 0 OID 17040)
-- Dependencies: 288
-- Data for Name: news; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.news (id, title, description, image, added_by, last_modified, added_date) FROM stdin;
\.


--
-- TOC entry 3887 (class 0 OID 17050)
-- Dependencies: 289
-- Data for Name: onestep; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.onestep (id, slider, steps, icon, added_by, added_date, last_modifid_by, last_modified_date) FROM stdin;
10	{"Educational Counseling (1).jpg"}	{"<p><span><strong>Educational Counseling</strong>: Offers personalized guidance for students in selecting the right courses and institutions.</span></p>"}	{NULL}	1	2024-07-24 07:37:28.448823	\N	\N
12	{"Educational Counseling.jpg"}	{"<p><span><strong>Admission Support</strong>: Assists with the application and admission process for various educational programs.</span></p>"}	{NULL}	1	2024-07-24 07:37:57.499186	\N	\N
13	{"Educational Counseling (2).jpg"}	{"<p><span><strong>Course Selection</strong>: Helps students choose suitable courses based on their interests and career goals.</span></p>"}	{NULL}	1	2024-07-24 07:38:37.579235	\N	\N
14	{"Educational Counseling (1).jpg"}	{"<p><span><strong>Career Guidance</strong>: Provides advice on career planning and development.</span></p>"}	{NULL}	1	2024-07-24 07:38:57.408522	\N	\N
15	{"Educational Counseling (2).jpg"}	{"<p><span><strong>Information Resources</strong>: Supplies up-to-date information about different educational opportunities and institutions.</span></p>"}	{NULL}	1	2024-07-24 07:39:18.263445	\N	\N
16	{"Educational Counseling (2).jpg"}	{"<p><span><strong>Student Support Services</strong>: Offers ongoing support and resources for students throughout their educational journey.</span></p>"}	{NULL}	1	2024-07-24 07:39:33.960002	\N	\N
\.


--
-- TOC entry 3849 (class 0 OID 16554)
-- Dependencies: 251
-- Data for Name: specialization; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.specialization (id, courseid, specialization, specializationcode, added_date, added_by, last_modified) FROM stdin;
4	4	MANAGEMENT	1234	2024-08-03 15:40:41.350064	1	\N
5	13	HUMAN RESOURCE MANAGEMENT	1234	2024-08-03 15:55:49.289203	1	\N
\.


--
-- TOC entry 3888 (class 0 OID 17060)
-- Dependencies: 290
-- Data for Name: specializationactivity; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.specializationactivity (id, superuserid, content, spid, role, added_date) FROM stdin;
1	1	{}	2	Delete	2024-07-26 06:03:01.151361
2	1	{}	2	Delete	2024-07-26 06:03:08.521373
3	1	{}	2	Delete	2024-07-26 06:03:21.21335
4	1	{}	2	Delete	2024-07-26 06:03:47.242055
5	1	{}	1	Add	2024-07-26 06:07:20.442171
6	1	{}	1	Delete	2024-07-26 11:14:42.823625
7	\N	{}	2	Add	2024-08-03 14:55:53.40213
8	1	{}	2	Delete	2024-08-03 14:56:38.866087
9	1	{}	3	Add	2024-08-03 14:56:58.47403
10	1	{}	3	Delete	2024-08-03 15:37:13.026473
11	1	{}	4	Add	2024-08-03 15:40:41.353215
12	1	{}	5	Add	2024-08-03 15:55:49.291821
\.


--
-- TOC entry 3889 (class 0 OID 17070)
-- Dependencies: 291
-- Data for Name: staff; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.staff (id, name, expert, experience, image, added_by, added_date, last_modified, designation) FROM stdin;
\.


--
-- TOC entry 3890 (class 0 OID 17080)
-- Dependencies: 292
-- Data for Name: state; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.state (id, name, country, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Delhi	2	1	2024-07-26 05:47:48.133137	\N	\N
\.


--
-- TOC entry 3891 (class 0 OID 17090)
-- Dependencies: 293
-- Data for Name: stream; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.stream (id, name, status, streammenu, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Computer Application	Active	Active	1	2024-07-26 05:50:09.976773	\N	\N
\.


--
-- TOC entry 3892 (class 0 OID 17100)
-- Dependencies: 294
-- Data for Name: studymode; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.studymode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Online	Active	1	2024-07-26 05:52:36.804952	\N	\N
\.


--
-- TOC entry 3851 (class 0 OID 16594)
-- Dependencies: 253
-- Data for Name: subject; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.subject (id, course, specialization, subject, subjectcode, added_by, added_date, last_modified, semsteroryear, noofsemsteroryear) FROM stdin;
\.


--
-- TOC entry 3893 (class 0 OID 17110)
-- Dependencies: 295
-- Data for Name: superuser; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.superuser (id, name, email, username, password, designation, specialization, about, gender, profile, fb, linkedin, permission, access, added_by, added_date, last_modified, modified_by) FROM stdin;
1	Ibrahim	ibrahimmemon1709@gmail.com	ibrahimmemon1709@gmail.com	123456789	Developer	Node js PHP Laravel		male	1679235462260.jpeg	https://www.facebook.com/	\N	{All}	{All}	1	2024-07-18 11:32:14.298349	2024-07-30 10:33:22	\N
\.


--
-- TOC entry 3846 (class 0 OID 16514)
-- Dependencies: 248
-- Data for Name: university; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.university (id, uname, established, officemailid, approvedby, coursetype, stream, studymode, universitytype, websiteurl, state, city, logourl, imageurl, videourl, fblink, twitterlink, linkedin, instagram, toc, smode, feature, added_date, last_modified, nip, about, fact, emi, admission, active, urlname, seotitle, seodescription, toccontent, toch1, toch2, toch3, toch4, toch5, prospectus, last_modified_by, added_by, zone) FROM stdin;
\.


--
-- TOC entry 3894 (class 0 OID 17120)
-- Dependencies: 296
-- Data for Name: universityactivity; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universityactivity (id, superuserid, content, modified_date, added_date, role, universityid) FROM stdin;
1	1	{}	\N	2024-07-26 05:57:49.336239	Add	1
2	1	{}	\N	2024-07-26 06:30:17.341605	Delete	1
3	1	{}	\N	2024-07-26 06:30:41.736721	Delete	1
4	1	{}	\N	2024-07-26 06:30:48.162994	Delete	1
5	1	{}	\N	2024-07-26 06:30:49.83669	Delete	1
6	1	{}	\N	2024-07-26 06:30:50.198812	Delete	1
7	1	{}	\N	2024-07-26 06:31:03.455868	Delete	1
8	1	{}	\N	2024-07-26 06:31:05.235123	Delete	1
9	1	{}	\N	2024-07-26 06:31:14.822974	Delete	1
10	1	{}	\N	2024-07-26 06:31:15.520029	Delete	1
11	1	{}	\N	2024-07-26 06:31:15.675063	Delete	1
12	1	{}	\N	2024-07-26 06:31:17.331117	Delete	1
13	1	{}	\N	2024-07-26 09:30:35.412315	Delete	1
14	1	{}	\N	2024-07-26 09:30:57.499808	Delete	1
15	1	{}	\N	2024-07-26 09:30:59.216741	Delete	1
16	1	{}	\N	2024-07-26 09:30:59.381851	Delete	1
17	1	{}	\N	2024-07-26 09:31:35.444098	Delete	1
18	1	{}	\N	2024-07-26 11:13:57.728891	Delete	1
19	1	{}	\N	2024-07-26 11:14:57.728906	Delete	1
20	1	{}	\N	2024-07-26 12:27:54.902079	Delete	1
21	1	{}	\N	2024-07-26 12:37:07.773538	Add	2
22	1	{}	\N	2024-07-26 12:39:28.271609	Delete	2
\.


--
-- TOC entry 3895 (class 0 OID 17136)
-- Dependencies: 297
-- Data for Name: universitycomment; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universitycomment (id, title, description, universityid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3896 (class 0 OID 17156)
-- Dependencies: 298
-- Data for Name: universityfaq; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universityfaq (id, question, answer, added_by, added_date, universityid, last_modified) FROM stdin;
\.


--
-- TOC entry 3907 (class 0 OID 17280)
-- Dependencies: 309
-- Data for Name: universitylisteningstep; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universitylisteningstep (id, step1, step2, step3, step4, added_by, added_date, last_modified_date, last_modified_by) FROM stdin;
\.


--
-- TOC entry 3897 (class 0 OID 17171)
-- Dependencies: 299
-- Data for Name: universityreview; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universityreview (id, rating, detail, universityid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 3898 (class 0 OID 17191)
-- Dependencies: 300
-- Data for Name: universitytype; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.universitytype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Goverment	Active	1	2024-07-26 05:53:10.464118	\N	\N
\.


--
-- TOC entry 3858 (class 0 OID 16699)
-- Dependencies: 260
-- Data for Name: users; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.users (id, name, email, phone, city, country, gender, password, added_by, last_modified, added_date, courseid, dob) FROM stdin;
\.


--
-- TOC entry 3899 (class 0 OID 17201)
-- Dependencies: 301
-- Data for Name: zone; Type: TABLE DATA; Schema: public; Owner: imtsac
--

COPY public.zone (id, name, added_by, added_date, last_modified_by, last_modified_date, status) FROM stdin;
1	fdjshj	1	2024-07-26 05:49:04.699371	\N	\N	Active
\.


--
-- TOC entry 4034 (class 0 OID 0)
-- Dependencies: 304
-- Name: aboutpage_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.aboutpage_id_seq', 6, true);


--
-- TOC entry 4035 (class 0 OID 0)
-- Dependencies: 197
-- Name: acdemicspecialization_id; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.acdemicspecialization_id', 2, true);


--
-- TOC entry 4036 (class 0 OID 0)
-- Dependencies: 198
-- Name: alumni_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.alumni_id_seq', 28, true);


--
-- TOC entry 4037 (class 0 OID 0)
-- Dependencies: 199
-- Name: approved_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.approved_id_seq', 1, true);


--
-- TOC entry 4038 (class 0 OID 0)
-- Dependencies: 200
-- Name: backup_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.backup_id_seq', 17, true);


--
-- TOC entry 4039 (class 0 OID 0)
-- Dependencies: 201
-- Name: blog_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.blog_id_seq', 1, false);


--
-- TOC entry 4040 (class 0 OID 0)
-- Dependencies: 202
-- Name: blogcomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.blogcomment_id_seq', 1, false);


--
-- TOC entry 4041 (class 0 OID 0)
-- Dependencies: 203
-- Name: blogfaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.blogfaq_id_seq', 1, false);


--
-- TOC entry 4042 (class 0 OID 0)
-- Dependencies: 204
-- Name: blogreview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.blogreview_id_seq', 1, false);


--
-- TOC entry 4043 (class 0 OID 0)
-- Dependencies: 205
-- Name: book_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.book_id_seq', 1, false);


--
-- TOC entry 4044 (class 0 OID 0)
-- Dependencies: 206
-- Name: city_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.city_id_seq', 1, true);


--
-- TOC entry 4045 (class 0 OID 0)
-- Dependencies: 207
-- Name: collegetype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.collegetype_id_seq', 1, true);


--
-- TOC entry 4046 (class 0 OID 0)
-- Dependencies: 306
-- Name: contactus_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.contactus_id_seq', 2, true);


--
-- TOC entry 4047 (class 0 OID 0)
-- Dependencies: 208
-- Name: country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.country_id_seq', 2, true);


--
-- TOC entry 4048 (class 0 OID 0)
-- Dependencies: 209
-- Name: course_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.course_id_seq', 2, true);


--
-- TOC entry 4049 (class 0 OID 0)
-- Dependencies: 210
-- Name: courseactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.courseactivity_id_seq', 26, true);


--
-- TOC entry 4050 (class 0 OID 0)
-- Dependencies: 211
-- Name: coursecomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.coursecomment_id_seq', 1, false);


--
-- TOC entry 4051 (class 0 OID 0)
-- Dependencies: 212
-- Name: courseduration_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.courseduration_id_seq', 1, true);


--
-- TOC entry 4052 (class 0 OID 0)
-- Dependencies: 213
-- Name: coursefaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.coursefaq_id_seq', 2, true);


--
-- TOC entry 4053 (class 0 OID 0)
-- Dependencies: 214
-- Name: coursemode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.coursemode_id_seq', 1, false);


--
-- TOC entry 4054 (class 0 OID 0)
-- Dependencies: 215
-- Name: coursereview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.coursereview_id_seq', 1, false);


--
-- TOC entry 4055 (class 0 OID 0)
-- Dependencies: 216
-- Name: coursetype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.coursetype_id_seq', 1, true);


--
-- TOC entry 4056 (class 0 OID 0)
-- Dependencies: 274
-- Name: cta_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.cta_id_seq', 8, true);


--
-- TOC entry 4057 (class 0 OID 0)
-- Dependencies: 217
-- Name: cta_id_seq_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.cta_id_seq_seq', 1, false);


--
-- TOC entry 4058 (class 0 OID 0)
-- Dependencies: 302
-- Name: expertpage_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.expertpage_id_seq', 4, true);


--
-- TOC entry 4059 (class 0 OID 0)
-- Dependencies: 218
-- Name: faq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.faq_id_seq', 1, true);


--
-- TOC entry 4060 (class 0 OID 0)
-- Dependencies: 219
-- Name: footer_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.footer_id_seq', 2, true);


--
-- TOC entry 4061 (class 0 OID 0)
-- Dependencies: 220
-- Name: header_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.header_id_seq', 8, true);


--
-- TOC entry 4062 (class 0 OID 0)
-- Dependencies: 221
-- Name: individualcourse_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.individualcourse_id_seq', 23, true);


--
-- TOC entry 4063 (class 0 OID 0)
-- Dependencies: 222
-- Name: individualcoursefaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.individualcoursefaq_id_seq', 23, true);


--
-- TOC entry 4064 (class 0 OID 0)
-- Dependencies: 223
-- Name: job_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.job_id_seq', 1, false);


--
-- TOC entry 4065 (class 0 OID 0)
-- Dependencies: 224
-- Name: jobmode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.jobmode_id_seq', 1, false);


--
-- TOC entry 4066 (class 0 OID 0)
-- Dependencies: 225
-- Name: jobreference_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.jobreference_id_seq', 1, false);


--
-- TOC entry 4067 (class 0 OID 0)
-- Dependencies: 226
-- Name: jobresponse_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.jobresponse_id_seq', 1, false);


--
-- TOC entry 4068 (class 0 OID 0)
-- Dependencies: 227
-- Name: jobtype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.jobtype_id_seq', 1, true);


--
-- TOC entry 4069 (class 0 OID 0)
-- Dependencies: 228
-- Name: lead_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.lead_id_seq', 1, false);


--
-- TOC entry 4070 (class 0 OID 0)
-- Dependencies: 229
-- Name: media_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.media_id_seq', 13, true);


--
-- TOC entry 4071 (class 0 OID 0)
-- Dependencies: 230
-- Name: moreresource_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.moreresource_id_seq', 1, false);


--
-- TOC entry 4072 (class 0 OID 0)
-- Dependencies: 231
-- Name: news_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.news_id_seq', 1, false);


--
-- TOC entry 4073 (class 0 OID 0)
-- Dependencies: 232
-- Name: onestep_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.onestep_id_seq', 16, true);


--
-- TOC entry 4074 (class 0 OID 0)
-- Dependencies: 233
-- Name: specialization_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.specialization_id_seq', 5, true);


--
-- TOC entry 4075 (class 0 OID 0)
-- Dependencies: 234
-- Name: specializationactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.specializationactivity_id_seq', 12, true);


--
-- TOC entry 4076 (class 0 OID 0)
-- Dependencies: 235
-- Name: staff_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.staff_id_seq', 9, true);


--
-- TOC entry 4077 (class 0 OID 0)
-- Dependencies: 236
-- Name: state_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.state_id_seq', 1, true);


--
-- TOC entry 4078 (class 0 OID 0)
-- Dependencies: 237
-- Name: stream_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.stream_id_seq', 1, true);


--
-- TOC entry 4079 (class 0 OID 0)
-- Dependencies: 238
-- Name: studymode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.studymode_id_seq', 1, true);


--
-- TOC entry 4080 (class 0 OID 0)
-- Dependencies: 239
-- Name: subject_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.subject_id_seq', 1, false);


--
-- TOC entry 4081 (class 0 OID 0)
-- Dependencies: 240
-- Name: superuser_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.superuser_id_seq', 1, true);


--
-- TOC entry 4082 (class 0 OID 0)
-- Dependencies: 196
-- Name: university_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.university_id_seq', 2, true);


--
-- TOC entry 4083 (class 0 OID 0)
-- Dependencies: 241
-- Name: universityactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universityactivity_id_seq', 22, true);


--
-- TOC entry 4084 (class 0 OID 0)
-- Dependencies: 242
-- Name: universitycomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universitycomment_id_seq', 1, false);


--
-- TOC entry 4085 (class 0 OID 0)
-- Dependencies: 243
-- Name: universityfaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universityfaq_id_seq', 2, true);


--
-- TOC entry 4086 (class 0 OID 0)
-- Dependencies: 308
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universitylisteningstep_id_seq', 1, false);


--
-- TOC entry 4087 (class 0 OID 0)
-- Dependencies: 244
-- Name: universityreview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universityreview_id_seq', 1, false);


--
-- TOC entry 4088 (class 0 OID 0)
-- Dependencies: 245
-- Name: universitytype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.universitytype_id_seq', 1, true);


--
-- TOC entry 4089 (class 0 OID 0)
-- Dependencies: 246
-- Name: users_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.users_id_seq', 1, false);


--
-- TOC entry 4090 (class 0 OID 0)
-- Dependencies: 247
-- Name: zone_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac
--

SELECT pg_catalog.setval('public.zone_id_seq', 1, true);


--
-- TOC entry 3642 (class 2606 OID 17254)
-- Name: aboutpage aboutpage_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.aboutpage
    ADD CONSTRAINT aboutpage_pkey PRIMARY KEY (id);


--
-- TOC entry 3542 (class 2606 OID 16583)
-- Name: acdemicspecialization acdemicspecialization_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_pkey PRIMARY KEY (id);


--
-- TOC entry 3550 (class 2606 OID 16653)
-- Name: alumni alumni_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.alumni
    ADD CONSTRAINT alumni_pkey PRIMARY KEY (id);


--
-- TOC entry 3552 (class 2606 OID 16663)
-- Name: approved approved_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.approved
    ADD CONSTRAINT approved_pkey PRIMARY KEY (id);


--
-- TOC entry 3554 (class 2606 OID 16673)
-- Name: backup backup_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.backup
    ADD CONSTRAINT backup_pkey PRIMARY KEY (id);


--
-- TOC entry 3556 (class 2606 OID 16683)
-- Name: banner banner_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.banner
    ADD CONSTRAINT banner_pkey PRIMARY KEY (id);


--
-- TOC entry 3548 (class 2606 OID 16643)
-- Name: blog blog_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blog
    ADD CONSTRAINT blog_pkey PRIMARY KEY (id);


--
-- TOC entry 3560 (class 2606 OID 16723)
-- Name: blogcomment blogcomment_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3562 (class 2606 OID 16743)
-- Name: blogfaq blogfaq_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogfaq
    ADD CONSTRAINT blogfaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3564 (class 2606 OID 16758)
-- Name: blogreview blogreview_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_pkey PRIMARY KEY (id);


--
-- TOC entry 3546 (class 2606 OID 16623)
-- Name: book book_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_pkey PRIMARY KEY (id);


--
-- TOC entry 3566 (class 2606 OID 16779)
-- Name: city city_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.city
    ADD CONSTRAINT city_pkey PRIMARY KEY (id);


--
-- TOC entry 3568 (class 2606 OID 16789)
-- Name: collegetype collegetype_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.collegetype
    ADD CONSTRAINT collegetype_pkey PRIMARY KEY (id);


--
-- TOC entry 3644 (class 2606 OID 17266)
-- Name: contactus contactus_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.contactus
    ADD CONSTRAINT contactus_pkey PRIMARY KEY (id);


--
-- TOC entry 3570 (class 2606 OID 16799)
-- Name: country country_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.country
    ADD CONSTRAINT country_pkey PRIMARY KEY (id);


--
-- TOC entry 3536 (class 2606 OID 16533)
-- Name: course course_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.course
    ADD CONSTRAINT course_pkey PRIMARY KEY (id);


--
-- TOC entry 3572 (class 2606 OID 16809)
-- Name: courseactivity courseactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.courseactivity
    ADD CONSTRAINT courseactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3574 (class 2606 OID 16819)
-- Name: coursecomment coursecomment_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3576 (class 2606 OID 16839)
-- Name: courseduration courseduration_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.courseduration
    ADD CONSTRAINT courseduration_pkey PRIMARY KEY (id);


--
-- TOC entry 3578 (class 2606 OID 16849)
-- Name: coursefaq coursefaq_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursefaq
    ADD CONSTRAINT coursefaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3580 (class 2606 OID 16864)
-- Name: coursemode coursemode_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursemode
    ADD CONSTRAINT coursemode_pkey PRIMARY KEY (id);


--
-- TOC entry 3582 (class 2606 OID 16874)
-- Name: coursereview coursereview_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_pkey PRIMARY KEY (id);


--
-- TOC entry 3584 (class 2606 OID 16894)
-- Name: coursetype coursetype_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursetype
    ADD CONSTRAINT coursetype_pkey PRIMARY KEY (id);


--
-- TOC entry 3586 (class 2606 OID 16909)
-- Name: cta cta_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.cta
    ADD CONSTRAINT cta_pkey PRIMARY KEY (id);


--
-- TOC entry 3640 (class 2606 OID 17239)
-- Name: expertpage expertpage_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.expertpage
    ADD CONSTRAINT expertpage_pkey PRIMARY KEY (id);


--
-- TOC entry 3588 (class 2606 OID 16919)
-- Name: faq faq_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.faq
    ADD CONSTRAINT faq_pkey PRIMARY KEY (id);


--
-- TOC entry 3590 (class 2606 OID 16929)
-- Name: footer footer_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.footer
    ADD CONSTRAINT footer_pkey PRIMARY KEY (id);


--
-- TOC entry 3592 (class 2606 OID 16939)
-- Name: header header_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.header
    ADD CONSTRAINT header_pkey PRIMARY KEY (id);


--
-- TOC entry 3538 (class 2606 OID 16553)
-- Name: individualcourse individualcourse_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.individualcourse
    ADD CONSTRAINT individualcourse_pkey PRIMARY KEY (id);


--
-- TOC entry 3594 (class 2606 OID 16948)
-- Name: individualcoursefaq individualcoursefaq_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.individualcoursefaq
    ADD CONSTRAINT individualcoursefaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3596 (class 2606 OID 16958)
-- Name: job job_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.job
    ADD CONSTRAINT job_pkey PRIMARY KEY (id);


--
-- TOC entry 3598 (class 2606 OID 16969)
-- Name: jobmode jobmode_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.jobmode
    ADD CONSTRAINT jobmode_pkey PRIMARY KEY (id);


--
-- TOC entry 3600 (class 2606 OID 16979)
-- Name: jobreference jobreference_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.jobreference
    ADD CONSTRAINT jobreference_pkey PRIMARY KEY (id);


--
-- TOC entry 3602 (class 2606 OID 16989)
-- Name: jobresponse jobresponse_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.jobresponse
    ADD CONSTRAINT jobresponse_pkey PRIMARY KEY (id);


--
-- TOC entry 3604 (class 2606 OID 16999)
-- Name: jobtype jobtype_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.jobtype
    ADD CONSTRAINT jobtype_pkey PRIMARY KEY (id);


--
-- TOC entry 3606 (class 2606 OID 17009)
-- Name: lead lead_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_pkey PRIMARY KEY (id);


--
-- TOC entry 3608 (class 2606 OID 17029)
-- Name: media media_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.media
    ADD CONSTRAINT media_pkey PRIMARY KEY (id);


--
-- TOC entry 3610 (class 2606 OID 17039)
-- Name: moreresource moreresource_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.moreresource
    ADD CONSTRAINT moreresource_pkey PRIMARY KEY (id);


--
-- TOC entry 3612 (class 2606 OID 17049)
-- Name: news news_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.news
    ADD CONSTRAINT news_pkey PRIMARY KEY (id);


--
-- TOC entry 3614 (class 2606 OID 17059)
-- Name: onestep onestep_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.onestep
    ADD CONSTRAINT onestep_pkey PRIMARY KEY (id);


--
-- TOC entry 3540 (class 2606 OID 16563)
-- Name: specialization specialization_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.specialization
    ADD CONSTRAINT specialization_pkey PRIMARY KEY (id);


--
-- TOC entry 3616 (class 2606 OID 17069)
-- Name: specializationactivity specializationactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.specializationactivity
    ADD CONSTRAINT specializationactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3618 (class 2606 OID 17079)
-- Name: staff staff_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.staff
    ADD CONSTRAINT staff_pkey PRIMARY KEY (id);


--
-- TOC entry 3620 (class 2606 OID 17089)
-- Name: state state_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.state
    ADD CONSTRAINT state_pkey PRIMARY KEY (id);


--
-- TOC entry 3622 (class 2606 OID 17099)
-- Name: stream stream_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.stream
    ADD CONSTRAINT stream_pkey PRIMARY KEY (id);


--
-- TOC entry 3624 (class 2606 OID 17109)
-- Name: studymode studymode_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.studymode
    ADD CONSTRAINT studymode_pkey PRIMARY KEY (id);


--
-- TOC entry 3544 (class 2606 OID 16603)
-- Name: subject subject_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_pkey PRIMARY KEY (id);


--
-- TOC entry 3626 (class 2606 OID 17119)
-- Name: superuser superuser_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.superuser
    ADD CONSTRAINT superuser_pkey PRIMARY KEY (id);


--
-- TOC entry 3534 (class 2606 OID 16523)
-- Name: university university_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.university
    ADD CONSTRAINT university_pkey PRIMARY KEY (id);


--
-- TOC entry 3628 (class 2606 OID 17129)
-- Name: universityactivity universityactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityactivity
    ADD CONSTRAINT universityactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3630 (class 2606 OID 17145)
-- Name: universitycomment universitycomment_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3632 (class 2606 OID 17165)
-- Name: universityfaq universityfaq_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityfaq
    ADD CONSTRAINT universityfaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3646 (class 2606 OID 17289)
-- Name: universitylisteningstep universitylisteningstep_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitylisteningstep
    ADD CONSTRAINT universitylisteningstep_pkey PRIMARY KEY (id);


--
-- TOC entry 3634 (class 2606 OID 17180)
-- Name: universityreview universityreview_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_pkey PRIMARY KEY (id);


--
-- TOC entry 3636 (class 2606 OID 17200)
-- Name: universitytype universitytype_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitytype
    ADD CONSTRAINT universitytype_pkey PRIMARY KEY (id);


--
-- TOC entry 3558 (class 2606 OID 16708)
-- Name: users users_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_pkey PRIMARY KEY (id);


--
-- TOC entry 3638 (class 2606 OID 17210)
-- Name: zone zone_pkey; Type: CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.zone
    ADD CONSTRAINT zone_pkey PRIMARY KEY (id);


--
-- TOC entry 3648 (class 2606 OID 16584)
-- Name: acdemicspecialization acdemicspecialization_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3649 (class 2606 OID 16589)
-- Name: acdemicspecialization acdemicspecialization_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3655 (class 2606 OID 16724)
-- Name: blogcomment blogcomment_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3656 (class 2606 OID 16729)
-- Name: blogcomment blogcomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3657 (class 2606 OID 16744)
-- Name: blogfaq blogfaq_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogfaq
    ADD CONSTRAINT blogfaq_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3658 (class 2606 OID 16759)
-- Name: blogreview blogreview_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3659 (class 2606 OID 16764)
-- Name: blogreview blogreview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3652 (class 2606 OID 16624)
-- Name: book book_specialization_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_specialization_fkey FOREIGN KEY (specialization) REFERENCES public.specialization(id);


--
-- TOC entry 3653 (class 2606 OID 16629)
-- Name: book book_subject_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_subject_fkey FOREIGN KEY (subject) REFERENCES public.subject(id);


--
-- TOC entry 3660 (class 2606 OID 16820)
-- Name: coursecomment coursecomment_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3661 (class 2606 OID 16825)
-- Name: coursecomment coursecomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3662 (class 2606 OID 16850)
-- Name: coursefaq coursefaq_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursefaq
    ADD CONSTRAINT coursefaq_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3663 (class 2606 OID 16875)
-- Name: coursereview coursereview_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3664 (class 2606 OID 16880)
-- Name: coursereview coursereview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3665 (class 2606 OID 17010)
-- Name: lead lead_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3666 (class 2606 OID 17015)
-- Name: lead lead_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3647 (class 2606 OID 16564)
-- Name: specialization specialization_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.specialization
    ADD CONSTRAINT specialization_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.individualcourse(id);


--
-- TOC entry 3650 (class 2606 OID 16604)
-- Name: subject subject_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_courseid_fkey FOREIGN KEY (course) REFERENCES public.individualcourse(id);


--
-- TOC entry 3651 (class 2606 OID 16609)
-- Name: subject subject_specialization_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_specialization_fkey FOREIGN KEY (specialization) REFERENCES public.specialization(id);


--
-- TOC entry 3667 (class 2606 OID 17130)
-- Name: universityactivity universityactivity_superuserid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityactivity
    ADD CONSTRAINT universityactivity_superuserid_fkey FOREIGN KEY (superuserid) REFERENCES public.superuser(id);


--
-- TOC entry 3668 (class 2606 OID 17146)
-- Name: universitycomment universitycomment_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3669 (class 2606 OID 17151)
-- Name: universitycomment universitycomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3670 (class 2606 OID 17166)
-- Name: universityfaq universityfaq_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityfaq
    ADD CONSTRAINT universityfaq_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3671 (class 2606 OID 17181)
-- Name: universityreview universityreview_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3672 (class 2606 OID 17186)
-- Name: universityreview universityreview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3654 (class 2606 OID 16709)
-- Name: users users_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: imtsac
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3916 (class 0 OID 0)
-- Dependencies: 305
-- Name: TABLE aboutpage; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.aboutpage TO PUBLIC;
GRANT ALL ON TABLE public.aboutpage TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.aboutpage TO imtsac_educationdunia;


--
-- TOC entry 3918 (class 0 OID 0)
-- Dependencies: 304
-- Name: SEQUENCE aboutpage_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.aboutpage_id_seq TO imtsac_ibrahimmemon;
GRANT ALL ON SEQUENCE public.aboutpage_id_seq TO imtsac_educationdunia;


--
-- TOC entry 3919 (class 0 OID 0)
-- Dependencies: 197
-- Name: SEQUENCE acdemicspecialization_id; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.acdemicspecialization_id TO imtsac_ibrahimmemon;


--
-- TOC entry 3920 (class 0 OID 0)
-- Dependencies: 252
-- Name: TABLE acdemicspecialization; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.acdemicspecialization TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.acdemicspecialization TO imtsac_educationdunia;


--
-- TOC entry 3921 (class 0 OID 0)
-- Dependencies: 198
-- Name: SEQUENCE alumni_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.alumni_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3922 (class 0 OID 0)
-- Dependencies: 256
-- Name: TABLE alumni; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.alumni TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.alumni TO imtsac_educationdunia;


--
-- TOC entry 3923 (class 0 OID 0)
-- Dependencies: 199
-- Name: SEQUENCE approved_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.approved_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3924 (class 0 OID 0)
-- Dependencies: 257
-- Name: TABLE approved; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.approved TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.approved TO imtsac_educationdunia;


--
-- TOC entry 3925 (class 0 OID 0)
-- Dependencies: 200
-- Name: SEQUENCE backup_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.backup_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3926 (class 0 OID 0)
-- Dependencies: 258
-- Name: TABLE backup; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.backup TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.backup TO imtsac_educationdunia;


--
-- TOC entry 3927 (class 0 OID 0)
-- Dependencies: 259
-- Name: TABLE banner; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.banner TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.banner TO imtsac_educationdunia;


--
-- TOC entry 3928 (class 0 OID 0)
-- Dependencies: 201
-- Name: SEQUENCE blog_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.blog_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3929 (class 0 OID 0)
-- Dependencies: 255
-- Name: TABLE blog; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.blog TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.blog TO imtsac_educationdunia;


--
-- TOC entry 3930 (class 0 OID 0)
-- Dependencies: 202
-- Name: SEQUENCE blogcomment_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.blogcomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3931 (class 0 OID 0)
-- Dependencies: 261
-- Name: TABLE blogcomment; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.blogcomment TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.blogcomment TO imtsac_educationdunia;


--
-- TOC entry 3932 (class 0 OID 0)
-- Dependencies: 203
-- Name: SEQUENCE blogfaq_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.blogfaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3933 (class 0 OID 0)
-- Dependencies: 262
-- Name: TABLE blogfaq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.blogfaq TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.blogfaq TO imtsac_educationdunia;


--
-- TOC entry 3934 (class 0 OID 0)
-- Dependencies: 204
-- Name: SEQUENCE blogreview_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.blogreview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3935 (class 0 OID 0)
-- Dependencies: 263
-- Name: TABLE blogreview; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.blogreview TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.blogreview TO imtsac_educationdunia;


--
-- TOC entry 3936 (class 0 OID 0)
-- Dependencies: 205
-- Name: SEQUENCE book_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.book_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3937 (class 0 OID 0)
-- Dependencies: 254
-- Name: TABLE book; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.book TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.book TO imtsac_educationdunia;


--
-- TOC entry 3938 (class 0 OID 0)
-- Dependencies: 206
-- Name: SEQUENCE city_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.city_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3939 (class 0 OID 0)
-- Dependencies: 264
-- Name: TABLE city; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.city TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.city TO imtsac_educationdunia;


--
-- TOC entry 3940 (class 0 OID 0)
-- Dependencies: 207
-- Name: SEQUENCE collegetype_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.collegetype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3941 (class 0 OID 0)
-- Dependencies: 265
-- Name: TABLE collegetype; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.collegetype TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.collegetype TO imtsac_educationdunia;


--
-- TOC entry 3942 (class 0 OID 0)
-- Dependencies: 307
-- Name: TABLE contactus; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.contactus TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.contactus TO imtsac_educationdunia;


--
-- TOC entry 3944 (class 0 OID 0)
-- Dependencies: 306
-- Name: SEQUENCE contactus_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.contactus_id_seq TO imtsac_ibrahimmemon;
GRANT ALL ON SEQUENCE public.contactus_id_seq TO imtsac_educationdunia;


--
-- TOC entry 3945 (class 0 OID 0)
-- Dependencies: 208
-- Name: SEQUENCE country_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.country_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3946 (class 0 OID 0)
-- Dependencies: 266
-- Name: TABLE country; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.country TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.country TO imtsac_educationdunia;


--
-- TOC entry 3947 (class 0 OID 0)
-- Dependencies: 209
-- Name: SEQUENCE course_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.course_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3948 (class 0 OID 0)
-- Dependencies: 249
-- Name: TABLE course; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.course TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.course TO imtsac_educationdunia;


--
-- TOC entry 3949 (class 0 OID 0)
-- Dependencies: 210
-- Name: SEQUENCE courseactivity_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.courseactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3950 (class 0 OID 0)
-- Dependencies: 267
-- Name: TABLE courseactivity; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.courseactivity TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.courseactivity TO imtsac_educationdunia;


--
-- TOC entry 3951 (class 0 OID 0)
-- Dependencies: 211
-- Name: SEQUENCE coursecomment_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.coursecomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3952 (class 0 OID 0)
-- Dependencies: 268
-- Name: TABLE coursecomment; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.coursecomment TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.coursecomment TO imtsac_educationdunia;


--
-- TOC entry 3953 (class 0 OID 0)
-- Dependencies: 212
-- Name: SEQUENCE courseduration_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.courseduration_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3954 (class 0 OID 0)
-- Dependencies: 269
-- Name: TABLE courseduration; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.courseduration TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.courseduration TO imtsac_educationdunia;


--
-- TOC entry 3955 (class 0 OID 0)
-- Dependencies: 213
-- Name: SEQUENCE coursefaq_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.coursefaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3956 (class 0 OID 0)
-- Dependencies: 270
-- Name: TABLE coursefaq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.coursefaq TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.coursefaq TO imtsac_educationdunia;


--
-- TOC entry 3957 (class 0 OID 0)
-- Dependencies: 214
-- Name: SEQUENCE coursemode_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.coursemode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3958 (class 0 OID 0)
-- Dependencies: 271
-- Name: TABLE coursemode; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.coursemode TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.coursemode TO imtsac_educationdunia;


--
-- TOC entry 3959 (class 0 OID 0)
-- Dependencies: 215
-- Name: SEQUENCE coursereview_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.coursereview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3960 (class 0 OID 0)
-- Dependencies: 272
-- Name: TABLE coursereview; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.coursereview TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.coursereview TO imtsac_educationdunia;


--
-- TOC entry 3961 (class 0 OID 0)
-- Dependencies: 216
-- Name: SEQUENCE coursetype_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.coursetype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3962 (class 0 OID 0)
-- Dependencies: 273
-- Name: TABLE coursetype; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.coursetype TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.coursetype TO imtsac_educationdunia;


--
-- TOC entry 3963 (class 0 OID 0)
-- Dependencies: 274
-- Name: SEQUENCE cta_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.cta_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3964 (class 0 OID 0)
-- Dependencies: 275
-- Name: TABLE cta; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.cta TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.cta TO imtsac_educationdunia;


--
-- TOC entry 3965 (class 0 OID 0)
-- Dependencies: 217
-- Name: SEQUENCE cta_id_seq_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.cta_id_seq_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3966 (class 0 OID 0)
-- Dependencies: 303
-- Name: TABLE expertpage; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.expertpage TO PUBLIC;
GRANT ALL ON TABLE public.expertpage TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.expertpage TO imtsac_educationdunia;


--
-- TOC entry 3968 (class 0 OID 0)
-- Dependencies: 302
-- Name: SEQUENCE expertpage_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.expertpage_id_seq TO PUBLIC;
GRANT ALL ON SEQUENCE public.expertpage_id_seq TO imtsac_ibrahimmemon;
GRANT ALL ON SEQUENCE public.expertpage_id_seq TO imtsac_educationdunia;


--
-- TOC entry 3969 (class 0 OID 0)
-- Dependencies: 218
-- Name: SEQUENCE faq_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.faq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3970 (class 0 OID 0)
-- Dependencies: 276
-- Name: TABLE faq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.faq TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.faq TO imtsac_educationdunia;


--
-- TOC entry 3971 (class 0 OID 0)
-- Dependencies: 219
-- Name: SEQUENCE footer_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.footer_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3972 (class 0 OID 0)
-- Dependencies: 277
-- Name: TABLE footer; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.footer TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.footer TO imtsac_educationdunia;


--
-- TOC entry 3973 (class 0 OID 0)
-- Dependencies: 220
-- Name: SEQUENCE header_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.header_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3974 (class 0 OID 0)
-- Dependencies: 278
-- Name: TABLE header; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.header TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.header TO imtsac_educationdunia;


--
-- TOC entry 3975 (class 0 OID 0)
-- Dependencies: 221
-- Name: SEQUENCE individualcourse_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.individualcourse_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3976 (class 0 OID 0)
-- Dependencies: 250
-- Name: TABLE individualcourse; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.individualcourse TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.individualcourse TO imtsac_educationdunia;


--
-- TOC entry 3977 (class 0 OID 0)
-- Dependencies: 222
-- Name: SEQUENCE individualcoursefaq_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.individualcoursefaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3978 (class 0 OID 0)
-- Dependencies: 279
-- Name: TABLE individualcoursefaq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.individualcoursefaq TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.individualcoursefaq TO imtsac_educationdunia;


--
-- TOC entry 3979 (class 0 OID 0)
-- Dependencies: 223
-- Name: SEQUENCE job_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.job_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3980 (class 0 OID 0)
-- Dependencies: 280
-- Name: TABLE job; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.job TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.job TO imtsac_educationdunia;


--
-- TOC entry 3981 (class 0 OID 0)
-- Dependencies: 224
-- Name: SEQUENCE jobmode_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.jobmode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3982 (class 0 OID 0)
-- Dependencies: 281
-- Name: TABLE jobmode; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.jobmode TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.jobmode TO imtsac_educationdunia;


--
-- TOC entry 3983 (class 0 OID 0)
-- Dependencies: 225
-- Name: SEQUENCE jobreference_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.jobreference_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3984 (class 0 OID 0)
-- Dependencies: 282
-- Name: TABLE jobreference; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.jobreference TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.jobreference TO imtsac_educationdunia;


--
-- TOC entry 3985 (class 0 OID 0)
-- Dependencies: 226
-- Name: SEQUENCE jobresponse_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.jobresponse_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3986 (class 0 OID 0)
-- Dependencies: 283
-- Name: TABLE jobresponse; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.jobresponse TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.jobresponse TO imtsac_educationdunia;


--
-- TOC entry 3987 (class 0 OID 0)
-- Dependencies: 227
-- Name: SEQUENCE jobtype_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.jobtype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3988 (class 0 OID 0)
-- Dependencies: 284
-- Name: TABLE jobtype; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.jobtype TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.jobtype TO imtsac_educationdunia;


--
-- TOC entry 3989 (class 0 OID 0)
-- Dependencies: 228
-- Name: SEQUENCE lead_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.lead_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3990 (class 0 OID 0)
-- Dependencies: 285
-- Name: TABLE lead; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.lead TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.lead TO imtsac_educationdunia;


--
-- TOC entry 3991 (class 0 OID 0)
-- Dependencies: 229
-- Name: SEQUENCE media_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.media_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3992 (class 0 OID 0)
-- Dependencies: 286
-- Name: TABLE media; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.media TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.media TO imtsac_educationdunia;


--
-- TOC entry 3993 (class 0 OID 0)
-- Dependencies: 230
-- Name: SEQUENCE moreresource_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.moreresource_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3994 (class 0 OID 0)
-- Dependencies: 287
-- Name: TABLE moreresource; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.moreresource TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.moreresource TO imtsac_educationdunia;


--
-- TOC entry 3995 (class 0 OID 0)
-- Dependencies: 231
-- Name: SEQUENCE news_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.news_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3996 (class 0 OID 0)
-- Dependencies: 288
-- Name: TABLE news; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.news TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.news TO imtsac_educationdunia;


--
-- TOC entry 3997 (class 0 OID 0)
-- Dependencies: 232
-- Name: SEQUENCE onestep_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.onestep_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 3998 (class 0 OID 0)
-- Dependencies: 289
-- Name: TABLE onestep; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.onestep TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.onestep TO imtsac_educationdunia;


--
-- TOC entry 3999 (class 0 OID 0)
-- Dependencies: 233
-- Name: SEQUENCE specialization_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.specialization_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4000 (class 0 OID 0)
-- Dependencies: 251
-- Name: TABLE specialization; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.specialization TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.specialization TO imtsac_educationdunia;


--
-- TOC entry 4001 (class 0 OID 0)
-- Dependencies: 234
-- Name: SEQUENCE specializationactivity_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.specializationactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4002 (class 0 OID 0)
-- Dependencies: 290
-- Name: TABLE specializationactivity; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.specializationactivity TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.specializationactivity TO imtsac_educationdunia;


--
-- TOC entry 4003 (class 0 OID 0)
-- Dependencies: 235
-- Name: SEQUENCE staff_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.staff_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4004 (class 0 OID 0)
-- Dependencies: 291
-- Name: TABLE staff; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.staff TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.staff TO imtsac_educationdunia;


--
-- TOC entry 4005 (class 0 OID 0)
-- Dependencies: 236
-- Name: SEQUENCE state_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.state_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4006 (class 0 OID 0)
-- Dependencies: 292
-- Name: TABLE state; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.state TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.state TO imtsac_educationdunia;


--
-- TOC entry 4007 (class 0 OID 0)
-- Dependencies: 237
-- Name: SEQUENCE stream_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.stream_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4008 (class 0 OID 0)
-- Dependencies: 293
-- Name: TABLE stream; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.stream TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.stream TO imtsac_educationdunia;


--
-- TOC entry 4009 (class 0 OID 0)
-- Dependencies: 238
-- Name: SEQUENCE studymode_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.studymode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4010 (class 0 OID 0)
-- Dependencies: 294
-- Name: TABLE studymode; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.studymode TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.studymode TO imtsac_educationdunia;


--
-- TOC entry 4011 (class 0 OID 0)
-- Dependencies: 239
-- Name: SEQUENCE subject_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.subject_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4012 (class 0 OID 0)
-- Dependencies: 253
-- Name: TABLE subject; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.subject TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.subject TO imtsac_educationdunia;


--
-- TOC entry 4013 (class 0 OID 0)
-- Dependencies: 240
-- Name: SEQUENCE superuser_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.superuser_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4014 (class 0 OID 0)
-- Dependencies: 295
-- Name: TABLE superuser; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.superuser TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.superuser TO imtsac_educationdunia;


--
-- TOC entry 4015 (class 0 OID 0)
-- Dependencies: 196
-- Name: SEQUENCE university_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.university_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4016 (class 0 OID 0)
-- Dependencies: 248
-- Name: TABLE university; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.university TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.university TO imtsac_educationdunia;


--
-- TOC entry 4017 (class 0 OID 0)
-- Dependencies: 241
-- Name: SEQUENCE universityactivity_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universityactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4018 (class 0 OID 0)
-- Dependencies: 296
-- Name: TABLE universityactivity; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universityactivity TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universityactivity TO imtsac_educationdunia;


--
-- TOC entry 4019 (class 0 OID 0)
-- Dependencies: 242
-- Name: SEQUENCE universitycomment_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universitycomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4020 (class 0 OID 0)
-- Dependencies: 297
-- Name: TABLE universitycomment; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universitycomment TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universitycomment TO imtsac_educationdunia;


--
-- TOC entry 4021 (class 0 OID 0)
-- Dependencies: 243
-- Name: SEQUENCE universityfaq_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universityfaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4022 (class 0 OID 0)
-- Dependencies: 298
-- Name: TABLE universityfaq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universityfaq TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universityfaq TO imtsac_educationdunia;


--
-- TOC entry 4023 (class 0 OID 0)
-- Dependencies: 309
-- Name: TABLE universitylisteningstep; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universitylisteningstep TO PUBLIC;
GRANT ALL ON TABLE public.universitylisteningstep TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universitylisteningstep TO imtsac_educationdunia;


--
-- TOC entry 4025 (class 0 OID 0)
-- Dependencies: 308
-- Name: SEQUENCE universitylisteningstep_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universitylisteningstep_id_seq TO PUBLIC;
GRANT ALL ON SEQUENCE public.universitylisteningstep_id_seq TO imtsac_ibrahimmemon;
GRANT ALL ON SEQUENCE public.universitylisteningstep_id_seq TO imtsac_educationdunia;


--
-- TOC entry 4026 (class 0 OID 0)
-- Dependencies: 244
-- Name: SEQUENCE universityreview_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universityreview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4027 (class 0 OID 0)
-- Dependencies: 299
-- Name: TABLE universityreview; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universityreview TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universityreview TO imtsac_educationdunia;


--
-- TOC entry 4028 (class 0 OID 0)
-- Dependencies: 245
-- Name: SEQUENCE universitytype_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.universitytype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4029 (class 0 OID 0)
-- Dependencies: 300
-- Name: TABLE universitytype; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.universitytype TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.universitytype TO imtsac_educationdunia;


--
-- TOC entry 4030 (class 0 OID 0)
-- Dependencies: 246
-- Name: SEQUENCE users_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.users_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4031 (class 0 OID 0)
-- Dependencies: 260
-- Name: TABLE users; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.users TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.users TO imtsac_educationdunia;


--
-- TOC entry 4032 (class 0 OID 0)
-- Dependencies: 247
-- Name: SEQUENCE zone_id_seq; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON SEQUENCE public.zone_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4033 (class 0 OID 0)
-- Dependencies: 301
-- Name: TABLE zone; Type: ACL; Schema: public; Owner: imtsac
--

GRANT ALL ON TABLE public.zone TO imtsac_ibrahimmemon;
GRANT ALL ON TABLE public.zone TO imtsac_educationdunia;


-- Completed on 2024-08-04 00:00:00 UTC

--
-- PostgreSQL database dump complete
--

