--
-- PostgreSQL database dump
--

-- Dumped from database version 16.3
-- Dumped by pg_dump version 16.3

-- Started on 2024-10-14 00:00:01 UTC

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- TOC entry 232 (class 1259 OID 16464)
-- Name: aboutpage; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.aboutpage (
    id integer NOT NULL,
    heading text,
    description text,
    content text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone,
    moreabout text
);


ALTER TABLE public.aboutpage OWNER TO postgres;

--
-- TOC entry 231 (class 1259 OID 16463)
-- Name: aboutpage_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.aboutpage_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.aboutpage_id_seq OWNER TO postgres;

--
-- TOC entry 4189 (class 0 OID 0)
-- Dependencies: 231
-- Name: aboutpage_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.aboutpage_id_seq OWNED BY public.aboutpage.id;


--
-- TOC entry 234 (class 1259 OID 16477)
-- Name: acdemicspecialization_id; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.acdemicspecialization_id
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.acdemicspecialization_id OWNER TO postgres;

--
-- TOC entry 235 (class 1259 OID 16478)
-- Name: acdemicspecialization; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.acdemicspecialization (
    id integer DEFAULT nextval('public.acdemicspecialization_id'::regclass) NOT NULL,
    universityid integer,
    courseid integer,
    specialization text,
    specializationcode text,
    coursefee text,
    examfee text,
    registrationfee text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.acdemicspecialization OWNER TO postgres;

--
-- TOC entry 233 (class 1259 OID 16473)
-- Name: acdemicspecialization_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.acdemicspecialization_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.acdemicspecialization_id_seq OWNER TO postgres;

--
-- TOC entry 220 (class 1259 OID 16408)
-- Name: alumni_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.alumni_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.alumni_id_seq OWNER TO postgres;

--
-- TOC entry 221 (class 1259 OID 16409)
-- Name: alumni; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.alumni (
    id integer DEFAULT nextval('public.alumni_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.alumni OWNER TO postgres;

--
-- TOC entry 236 (class 1259 OID 16497)
-- Name: approved_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.approved_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.approved_id_seq OWNER TO postgres;

--
-- TOC entry 237 (class 1259 OID 16498)
-- Name: approved; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.approved (
    id integer DEFAULT nextval('public.approved_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.approved OWNER TO postgres;

--
-- TOC entry 238 (class 1259 OID 16507)
-- Name: backup_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.backup_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.backup_id_seq OWNER TO postgres;

--
-- TOC entry 239 (class 1259 OID 16508)
-- Name: backup; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.backup (
    id integer DEFAULT nextval('public.backup_id_seq'::regclass) NOT NULL,
    filepath text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    mode text
);


ALTER TABLE public.backup OWNER TO postgres;

--
-- TOC entry 240 (class 1259 OID 16517)
-- Name: banner_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.banner_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.banner_id_seq OWNER TO postgres;

--
-- TOC entry 241 (class 1259 OID 16518)
-- Name: banner; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.banner (
    id integer DEFAULT nextval('public.banner_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.banner OWNER TO postgres;

--
-- TOC entry 222 (class 1259 OID 16418)
-- Name: blog_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blog_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blog_id_seq OWNER TO postgres;

--
-- TOC entry 223 (class 1259 OID 16419)
-- Name: blog; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.blog (
    id integer DEFAULT nextval('public.blog_id_seq'::regclass) NOT NULL,
    pagename text,
    seotitle text,
    seodescription text,
    tag text,
    status text,
    topic text,
    image text,
    content text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    feature text,
    toc text,
    active text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    layout text
);


ALTER TABLE public.blog OWNER TO postgres;

--
-- TOC entry 341 (class 1259 OID 18364)
-- Name: blog_id_faqs; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blog_id_faqs
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blog_id_faqs OWNER TO postgres;

--
-- TOC entry 352 (class 1259 OID 18543)
-- Name: blogactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blogactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blogactivity_id_seq OWNER TO postgres;

--
-- TOC entry 353 (class 1259 OID 18544)
-- Name: blogactivity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.blogactivity (
    id integer DEFAULT nextval('public.blogactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content text,
    differentcontent text,
    role text,
    blogid text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    previouscontent text,
    previouscontentlength text,
    newcontentlength text
);


ALTER TABLE public.blogactivity OWNER TO postgres;

--
-- TOC entry 242 (class 1259 OID 16527)
-- Name: blogcomment_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blogcomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blogcomment_id_seq OWNER TO postgres;

--
-- TOC entry 245 (class 1259 OID 16557)
-- Name: blogcomment; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.blogcomment (
    id integer DEFAULT nextval('public.blogcomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    blogid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogcomment OWNER TO postgres;

--
-- TOC entry 224 (class 1259 OID 16430)
-- Name: blogfaq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blogfaq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blogfaq OWNER TO postgres;

--
-- TOC entry 246 (class 1259 OID 16576)
-- Name: blogfaq_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blogfaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blogfaq_id_seq OWNER TO postgres;

--
-- TOC entry 342 (class 1259 OID 18365)
-- Name: blogfaqs; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.blogfaqs (
    id integer DEFAULT nextval('public.blogfaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    blogid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogfaqs OWNER TO postgres;

--
-- TOC entry 247 (class 1259 OID 16577)
-- Name: blogreview_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.blogreview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.blogreview_id_seq OWNER TO postgres;

--
-- TOC entry 248 (class 1259 OID 16578)
-- Name: blogreview; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.blogreview (
    id integer DEFAULT nextval('public.blogreview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    userid integer,
    blogid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.blogreview OWNER TO postgres;

--
-- TOC entry 249 (class 1259 OID 16597)
-- Name: book_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.book_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.book_id_seq OWNER TO postgres;

--
-- TOC entry 254 (class 1259 OID 16661)
-- Name: book; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.book (
    id integer DEFAULT nextval('public.book_id_seq'::regclass) NOT NULL,
    specialization integer,
    subject integer,
    title text,
    url text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.book OWNER TO postgres;

--
-- TOC entry 255 (class 1259 OID 16680)
-- Name: city_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.city_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.city_id_seq OWNER TO postgres;

--
-- TOC entry 256 (class 1259 OID 16681)
-- Name: city; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.city (
    id integer DEFAULT nextval('public.city_id_seq'::regclass) NOT NULL,
    name text,
    state text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.city OWNER TO postgres;

--
-- TOC entry 257 (class 1259 OID 16691)
-- Name: collegetype_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.collegetype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.collegetype_id_seq OWNER TO postgres;

--
-- TOC entry 258 (class 1259 OID 16692)
-- Name: collegetype; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.collegetype (
    id integer DEFAULT nextval('public.collegetype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.collegetype OWNER TO postgres;

--
-- TOC entry 260 (class 1259 OID 16702)
-- Name: contactus; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.contactus (
    id integer NOT NULL,
    email text,
    contactnumber text,
    officeaddress text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.contactus OWNER TO postgres;

--
-- TOC entry 259 (class 1259 OID 16701)
-- Name: contactus_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.contactus_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.contactus_id_seq OWNER TO postgres;

--
-- TOC entry 4215 (class 0 OID 0)
-- Dependencies: 259
-- Name: contactus_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.contactus_id_seq OWNED BY public.contactus.id;


--
-- TOC entry 261 (class 1259 OID 16711)
-- Name: country_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.country_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.country_id_seq OWNER TO postgres;

--
-- TOC entry 262 (class 1259 OID 16712)
-- Name: country; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.country (
    id integer DEFAULT nextval('public.country_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.country OWNER TO postgres;

--
-- TOC entry 227 (class 1259 OID 16443)
-- Name: course_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.course_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.course_id_seq OWNER TO postgres;

--
-- TOC entry 228 (class 1259 OID 16444)
-- Name: course; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.course (
    id integer DEFAULT nextval('public.course_id_seq'::regclass) NOT NULL,
    courename text,
    coursedescription text,
    noofyear text,
    noofmonth text,
    fee text,
    title text,
    seodescription text,
    image text,
    mode text,
    feature text,
    categorie text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    detailcoursedescription text,
    whycourse text,
    whopursuecourse text,
    whentodocourse text,
    keyhighcourse text,
    eligibility text,
    skills text,
    other text,
    admission text,
    active text,
    toc text,
    last_modified_user text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    universityid text[],
    toch5 text[]
);


ALTER TABLE public.course OWNER TO postgres;

--
-- TOC entry 263 (class 1259 OID 16721)
-- Name: courseactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.courseactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.courseactivity_id_seq OWNER TO postgres;

--
-- TOC entry 264 (class 1259 OID 16722)
-- Name: courseactivity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.courseactivity (
    id integer DEFAULT nextval('public.courseactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    courseid integer,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text,
    differentcontent text,
    previouscontent text,
    previouscontentlength text,
    newcontentlength text
);


ALTER TABLE public.courseactivity OWNER TO postgres;

--
-- TOC entry 265 (class 1259 OID 16731)
-- Name: coursecomment_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.coursecomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.coursecomment_id_seq OWNER TO postgres;

--
-- TOC entry 266 (class 1259 OID 16732)
-- Name: coursecomment; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.coursecomment (
    id integer DEFAULT nextval('public.coursecomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    courseid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursecomment OWNER TO postgres;

--
-- TOC entry 267 (class 1259 OID 16751)
-- Name: courseduration_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.courseduration_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.courseduration_id_seq OWNER TO postgres;

--
-- TOC entry 268 (class 1259 OID 16752)
-- Name: courseduration; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.courseduration (
    id integer DEFAULT nextval('public.courseduration_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.courseduration OWNER TO postgres;

--
-- TOC entry 269 (class 1259 OID 16761)
-- Name: coursefaq_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.coursefaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.coursefaq_id_seq OWNER TO postgres;

--
-- TOC entry 270 (class 1259 OID 16762)
-- Name: coursefaq; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.coursefaq (
    id integer DEFAULT nextval('public.coursefaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    courseid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursefaq OWNER TO postgres;

--
-- TOC entry 271 (class 1259 OID 16776)
-- Name: coursemode_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.coursemode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.coursemode_id_seq OWNER TO postgres;

--
-- TOC entry 272 (class 1259 OID 16777)
-- Name: coursemode; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.coursemode (
    id integer DEFAULT nextval('public.coursemode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.coursemode OWNER TO postgres;

--
-- TOC entry 273 (class 1259 OID 16786)
-- Name: coursereview_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.coursereview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.coursereview_id_seq OWNER TO postgres;

--
-- TOC entry 274 (class 1259 OID 16787)
-- Name: coursereview; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.coursereview (
    id integer DEFAULT nextval('public.coursereview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    userid integer,
    courseid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.coursereview OWNER TO postgres;

--
-- TOC entry 275 (class 1259 OID 16806)
-- Name: coursetype_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.coursetype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.coursetype_id_seq OWNER TO postgres;

--
-- TOC entry 276 (class 1259 OID 16807)
-- Name: coursetype; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.coursetype (
    id integer DEFAULT nextval('public.coursetype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.coursetype OWNER TO postgres;

--
-- TOC entry 277 (class 1259 OID 16816)
-- Name: cta_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.cta_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.cta_id_seq OWNER TO postgres;

--
-- TOC entry 278 (class 1259 OID 16817)
-- Name: cta; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.cta (
    id integer DEFAULT nextval('public.cta_id_seq'::regclass) NOT NULL,
    title text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text
);


ALTER TABLE public.cta OWNER TO postgres;

--
-- TOC entry 339 (class 1259 OID 17912)
-- Name: cta_id_seq_seq; Type: SEQUENCE; Schema: public; Owner: imtsac_ibrahimmemon
--

CREATE SEQUENCE public.cta_id_seq_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.cta_id_seq_seq OWNER TO imtsac_ibrahimmemon;

--
-- TOC entry 280 (class 1259 OID 16827)
-- Name: designation; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.designation (
    id integer NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.designation OWNER TO postgres;

--
-- TOC entry 279 (class 1259 OID 16826)
-- Name: designation_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.designation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.designation_id_seq OWNER TO postgres;

--
-- TOC entry 4238 (class 0 OID 0)
-- Dependencies: 279
-- Name: designation_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.designation_id_seq OWNED BY public.designation.id;


--
-- TOC entry 344 (class 1259 OID 18459)
-- Name: establish_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.establish_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.establish_id_seq OWNER TO postgres;

--
-- TOC entry 345 (class 1259 OID 18460)
-- Name: establish; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.establish (
    id integer DEFAULT nextval('public.establish_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.establish OWNER TO postgres;

--
-- TOC entry 343 (class 1259 OID 18455)
-- Name: establish_seq_id; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.establish_seq_id
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.establish_seq_id OWNER TO postgres;

--
-- TOC entry 282 (class 1259 OID 16837)
-- Name: expertpage; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.expertpage (
    id integer NOT NULL,
    qualityassurancecell text,
    qualitycellimage text,
    training text,
    trainingimage text,
    qualityassuranceteam text,
    qualityteamimage text,
    aimqualityassurance text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.expertpage OWNER TO postgres;

--
-- TOC entry 281 (class 1259 OID 16836)
-- Name: expertpage_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.expertpage_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.expertpage_id_seq OWNER TO postgres;

--
-- TOC entry 4241 (class 0 OID 0)
-- Dependencies: 281
-- Name: expertpage_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.expertpage_id_seq OWNED BY public.expertpage.id;


--
-- TOC entry 283 (class 1259 OID 16846)
-- Name: faq_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.faq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.faq_id_seq OWNER TO postgres;

--
-- TOC entry 284 (class 1259 OID 16847)
-- Name: faq; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.faq (
    id integer DEFAULT nextval('public.faq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.faq OWNER TO postgres;

--
-- TOC entry 285 (class 1259 OID 16857)
-- Name: footer_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.footer_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.footer_id_seq OWNER TO postgres;

--
-- TOC entry 286 (class 1259 OID 16858)
-- Name: footer; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.footer (
    id integer DEFAULT nextval('public.footer_id_seq'::regclass) NOT NULL,
    work text,
    trust text,
    distancemba text,
    ugcourse text,
    bestcollege text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    aboutwebsite text,
    playstore text,
    appstore text,
    facebook text,
    twitter text,
    instagram text,
    linkedin text,
    youtube text,
    contactus text,
    qr text,
    tagline text,
    tollno text,
    reserved text
);


ALTER TABLE public.footer OWNER TO postgres;

--
-- TOC entry 287 (class 1259 OID 16867)
-- Name: header_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.header_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.header_id_seq OWNER TO postgres;

--
-- TOC entry 288 (class 1259 OID 16868)
-- Name: header; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.header (
    id integer DEFAULT nextval('public.header_id_seq'::regclass) NOT NULL,
    title text,
    logo text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.header OWNER TO postgres;

--
-- TOC entry 229 (class 1259 OID 16453)
-- Name: individualcourse_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.individualcourse_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.individualcourse_id_seq OWNER TO postgres;

--
-- TOC entry 230 (class 1259 OID 16454)
-- Name: individualcourse; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.individualcourse (
    courename text,
    coursedescription text,
    noofyear text,
    noofmonth text,
    fee text,
    title text,
    seodescription text,
    image text,
    mode text,
    feature text,
    categorie text,
    added_by text,
    last_modified timestamp without time zone,
    detailcoursedescription text,
    whycourse text,
    whopursuecourse text,
    whentodocourse text,
    keyhighcourse text,
    eligibility text,
    skills text,
    other text,
    admission text,
    active text,
    toc text,
    last_modified_user text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    id integer DEFAULT nextval('public.individualcourse_id_seq'::regclass) NOT NULL,
    toch5 text[],
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text
);


ALTER TABLE public.individualcourse OWNER TO postgres;

--
-- TOC entry 289 (class 1259 OID 16877)
-- Name: individualcoursefaq_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.individualcoursefaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.individualcoursefaq_id_seq OWNER TO postgres;

--
-- TOC entry 290 (class 1259 OID 16878)
-- Name: individualcoursefaq; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.individualcoursefaq (
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone,
    courseid integer,
    last_modified timestamp without time zone,
    id integer DEFAULT nextval('public.individualcoursefaq_id_seq'::regclass) NOT NULL
);


ALTER TABLE public.individualcoursefaq OWNER TO postgres;

--
-- TOC entry 291 (class 1259 OID 16886)
-- Name: job_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.job_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.job_id_seq OWNER TO postgres;

--
-- TOC entry 292 (class 1259 OID 16887)
-- Name: job; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.job (
    id integer DEFAULT nextval('public.job_id_seq'::regclass) NOT NULL,
    jobtype text,
    jobmode text,
    name text,
    location text,
    responsilibity text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.job OWNER TO postgres;

--
-- TOC entry 293 (class 1259 OID 16896)
-- Name: jobmode_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.jobmode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.jobmode_id_seq OWNER TO postgres;

--
-- TOC entry 294 (class 1259 OID 16897)
-- Name: jobmode; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.jobmode (
    id integer DEFAULT nextval('public.jobmode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobmode OWNER TO postgres;

--
-- TOC entry 295 (class 1259 OID 16906)
-- Name: jobreference_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.jobreference_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.jobreference_id_seq OWNER TO postgres;

--
-- TOC entry 296 (class 1259 OID 16907)
-- Name: jobreference; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.jobreference (
    id integer DEFAULT nextval('public.jobreference_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobreference OWNER TO postgres;

--
-- TOC entry 297 (class 1259 OID 16916)
-- Name: jobresponse_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.jobresponse_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.jobresponse_id_seq OWNER TO postgres;

--
-- TOC entry 298 (class 1259 OID 16917)
-- Name: jobresponse; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.jobresponse (
    id integer DEFAULT nextval('public.jobresponse_id_seq'::regclass) NOT NULL,
    jobtype text,
    name text,
    email text,
    reference text,
    resume text,
    experienceed text,
    isugpg text,
    hqualifuication text,
    ctc text,
    expereience text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modifed_date timestamp without time zone,
    phone text
);


ALTER TABLE public.jobresponse OWNER TO postgres;

--
-- TOC entry 299 (class 1259 OID 16926)
-- Name: jobtype_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.jobtype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.jobtype_id_seq OWNER TO postgres;

--
-- TOC entry 300 (class 1259 OID 16927)
-- Name: jobtype; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.jobtype (
    id integer DEFAULT nextval('public.jobtype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.jobtype OWNER TO postgres;

--
-- TOC entry 301 (class 1259 OID 16936)
-- Name: lead_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.lead_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.lead_id_seq OWNER TO postgres;

--
-- TOC entry 302 (class 1259 OID 16937)
-- Name: lead; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.lead (
    id integer DEFAULT nextval('public.lead_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    phone text,
    courseid integer,
    universityid integer,
    city text,
    message text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.lead OWNER TO postgres;

--
-- TOC entry 348 (class 1259 OID 18507)
-- Name: marquee; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.marquee (
    id integer NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.marquee OWNER TO postgres;

--
-- TOC entry 346 (class 1259 OID 18505)
-- Name: marquee_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.marquee_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.marquee_id_seq OWNER TO postgres;

--
-- TOC entry 347 (class 1259 OID 18506)
-- Name: marquee_id_seq1; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.marquee_id_seq1
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.marquee_id_seq1 OWNER TO postgres;

--
-- TOC entry 4265 (class 0 OID 0)
-- Dependencies: 347
-- Name: marquee_id_seq1; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.marquee_id_seq1 OWNED BY public.marquee.id;


--
-- TOC entry 303 (class 1259 OID 16956)
-- Name: media_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.media_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.media_id_seq OWNER TO postgres;

--
-- TOC entry 304 (class 1259 OID 16957)
-- Name: media; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.media (
    id integer DEFAULT nextval('public.media_id_seq'::regclass) NOT NULL,
    name text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.media OWNER TO postgres;

--
-- TOC entry 305 (class 1259 OID 16966)
-- Name: moreresource_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.moreresource_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.moreresource_id_seq OWNER TO postgres;

--
-- TOC entry 306 (class 1259 OID 16967)
-- Name: moreresource; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.moreresource (
    id integer DEFAULT nextval('public.moreresource_id_seq'::regclass) NOT NULL,
    button1 text,
    button2 text,
    button3 text,
    button4 text,
    button5 text,
    button6 text,
    newstudent text,
    visitus text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.moreresource OWNER TO postgres;

--
-- TOC entry 307 (class 1259 OID 16976)
-- Name: news_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.news_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.news_id_seq OWNER TO postgres;

--
-- TOC entry 308 (class 1259 OID 16977)
-- Name: news; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.news (
    id integer DEFAULT nextval('public.news_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    image text,
    added_by text,
    last_modified date,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.news OWNER TO postgres;

--
-- TOC entry 309 (class 1259 OID 16986)
-- Name: onestep_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.onestep_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.onestep_id_seq OWNER TO postgres;

--
-- TOC entry 310 (class 1259 OID 16987)
-- Name: onestep; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.onestep (
    id integer DEFAULT nextval('public.onestep_id_seq'::regclass) NOT NULL,
    slider text[],
    steps text[],
    icon text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modifid_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.onestep OWNER TO postgres;

--
-- TOC entry 360 (class 1259 OID 23317)
-- Name: prev_userlogs_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.prev_userlogs_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.prev_userlogs_id_seq OWNER TO postgres;

--
-- TOC entry 355 (class 1259 OID 18570)
-- Name: prevewblog; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.prevewblog (
    id integer DEFAULT nextval('public.blog_id_seq'::regclass) NOT NULL,
    pagename text,
    seotitle text,
    seodescription text,
    tag text,
    status text,
    topic text,
    image text,
    content text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    feature text,
    toc text,
    active text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    layout text
);


ALTER TABLE public.prevewblog OWNER TO postgres;

--
-- TOC entry 354 (class 1259 OID 18561)
-- Name: prevewindividualcourse; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.prevewindividualcourse (
    courename text,
    coursedescription text,
    noofyear text,
    noofmonth text,
    fee text,
    title text,
    seodescription text,
    image text,
    mode text,
    feature text,
    categorie text,
    added_by text,
    last_modified timestamp without time zone,
    detailcoursedescription text,
    whycourse text,
    whopursuecourse text,
    whentodocourse text,
    keyhighcourse text,
    eligibility text,
    skills text,
    other text,
    admission text,
    active text,
    toc text,
    last_modified_user text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    id integer DEFAULT nextval('public.individualcourse_id_seq'::regclass) NOT NULL,
    toch5 text[],
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text
);


ALTER TABLE public.prevewindividualcourse OWNER TO postgres;

--
-- TOC entry 357 (class 1259 OID 18626)
-- Name: previewblog; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.previewblog (
    id integer DEFAULT nextval('public.blog_id_seq'::regclass) NOT NULL,
    pagename text,
    seotitle text,
    seodescription text,
    tag text,
    status text,
    topic text,
    image text,
    content text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone,
    feature text,
    toc text,
    active text,
    urlname text,
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    layout text
);


ALTER TABLE public.previewblog OWNER TO postgres;

--
-- TOC entry 225 (class 1259 OID 16433)
-- Name: university_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.university_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.university_id_seq OWNER TO postgres;

--
-- TOC entry 356 (class 1259 OID 18615)
-- Name: previewuniversity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.previewuniversity (
    id integer DEFAULT nextval('public.university_id_seq'::regclass) NOT NULL,
    uname character varying(150),
    established character varying(200),
    officemailid character varying(300),
    approvedby character varying(200),
    coursetype character varying(300),
    stream character varying(500),
    studymode character varying(300),
    universitytype character varying(300),
    websiteurl character varying(200),
    state character varying(340),
    city character varying(400),
    logourl character varying(400),
    imageurl character varying[],
    videourl character varying[],
    fblink character varying(240),
    twitterlink character varying(500),
    linkedin character varying(500),
    instagram character varying(500),
    toc character varying(300),
    smode character varying(400),
    feature character varying(300),
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    nip text,
    about text,
    fact text,
    emi text,
    admission text,
    active text,
    urlname text,
    seotitle text,
    seodescription text,
    toccontent text[],
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    prospectus text,
    last_modified_by text,
    added_by integer,
    zone text
);


ALTER TABLE public.previewuniversity OWNER TO postgres;

--
-- TOC entry 361 (class 1259 OID 23333)
-- Name: prevuserlogs; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.prevuserlogs (
    id integer DEFAULT nextval('public.prev_userlogs_id_seq'::regclass) NOT NULL,
    username text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    status text
);


ALTER TABLE public.prevuserlogs OWNER TO postgres;

--
-- TOC entry 311 (class 1259 OID 16997)
-- Name: qualification_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.qualification_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.qualification_id_seq OWNER TO postgres;

--
-- TOC entry 312 (class 1259 OID 16998)
-- Name: qualification; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.qualification (
    id integer DEFAULT nextval('public.qualification_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.qualification OWNER TO postgres;

--
-- TOC entry 250 (class 1259 OID 16607)
-- Name: specialization_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.specialization_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.specialization_id_seq OWNER TO postgres;

--
-- TOC entry 251 (class 1259 OID 16608)
-- Name: specialization; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.specialization (
    id integer DEFAULT nextval('public.specialization_id_seq'::regclass) NOT NULL,
    universityid integer,
    courseid integer,
    specialization text,
    specializationcode text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    added_by text,
    last_modified timestamp without time zone
);


ALTER TABLE public.specialization OWNER TO postgres;

--
-- TOC entry 313 (class 1259 OID 17007)
-- Name: specializationactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.specializationactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.specializationactivity_id_seq OWNER TO postgres;

--
-- TOC entry 314 (class 1259 OID 17008)
-- Name: specializationactivity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.specializationactivity (
    id integer DEFAULT nextval('public.specializationactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    spid integer,
    role text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP
);


ALTER TABLE public.specializationactivity OWNER TO postgres;

--
-- TOC entry 315 (class 1259 OID 17017)
-- Name: staff_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.staff_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.staff_id_seq OWNER TO postgres;

--
-- TOC entry 316 (class 1259 OID 17018)
-- Name: staff; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.staff (
    id integer DEFAULT nextval('public.staff_id_seq'::regclass) NOT NULL,
    name text,
    expert text,
    experience text,
    image text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    designation text,
    rating text
);


ALTER TABLE public.staff OWNER TO postgres;

--
-- TOC entry 317 (class 1259 OID 17027)
-- Name: state_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.state_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.state_id_seq OWNER TO postgres;

--
-- TOC entry 318 (class 1259 OID 17028)
-- Name: state; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.state (
    id integer DEFAULT nextval('public.state_id_seq'::regclass) NOT NULL,
    name text,
    country text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.state OWNER TO postgres;

--
-- TOC entry 319 (class 1259 OID 17037)
-- Name: stream_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.stream_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.stream_id_seq OWNER TO postgres;

--
-- TOC entry 320 (class 1259 OID 17038)
-- Name: stream; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.stream (
    id integer DEFAULT nextval('public.stream_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    streammenu text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.stream OWNER TO postgres;

--
-- TOC entry 321 (class 1259 OID 17047)
-- Name: studymode_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.studymode_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.studymode_id_seq OWNER TO postgres;

--
-- TOC entry 322 (class 1259 OID 17048)
-- Name: studymode; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.studymode (
    id integer DEFAULT nextval('public.studymode_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.studymode OWNER TO postgres;

--
-- TOC entry 252 (class 1259 OID 16641)
-- Name: subject_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.subject_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.subject_id_seq OWNER TO postgres;

--
-- TOC entry 253 (class 1259 OID 16642)
-- Name: subject; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.subject (
    id integer DEFAULT nextval('public.subject_id_seq'::regclass) NOT NULL,
    course integer,
    specialization integer,
    subject text[],
    subjectcode text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    semsteroryear text,
    noofsemsteroryear text
);


ALTER TABLE public.subject OWNER TO postgres;

--
-- TOC entry 218 (class 1259 OID 16398)
-- Name: superuser_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.superuser_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.superuser_id_seq OWNER TO postgres;

--
-- TOC entry 219 (class 1259 OID 16399)
-- Name: superuser; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.superuser (
    id integer DEFAULT nextval('public.superuser_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    username text,
    password text,
    designation text,
    specialization text,
    about text,
    gender text,
    profile text,
    fb text,
    linkedin text,
    permission text[],
    access text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    modified_by text,
    status text
);


ALTER TABLE public.superuser OWNER TO postgres;

--
-- TOC entry 226 (class 1259 OID 16434)
-- Name: university; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.university (
    id integer DEFAULT nextval('public.university_id_seq'::regclass) NOT NULL,
    uname character varying(150),
    established character varying(200),
    officemailid character varying(300),
    approvedby character varying(200),
    coursetype character varying(300),
    stream character varying(500),
    studymode character varying(300),
    universitytype character varying(300),
    websiteurl character varying(200),
    state character varying(340),
    city character varying(400),
    logourl character varying(400),
    imageurl character varying[],
    videourl character varying[],
    fblink character varying(240),
    twitterlink character varying(500),
    linkedin character varying(500),
    instagram character varying(500),
    toc character varying(300),
    smode character varying(400),
    feature character varying(300),
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone,
    nip text,
    about text,
    fact text,
    emi text,
    admission text,
    active text,
    urlname text,
    seotitle text,
    seodescription text,
    toccontent text[],
    toch1 text[],
    toch2 text[],
    toch3 text[],
    toch4 text[],
    toch5 text[],
    prospectus text,
    last_modified_by text,
    added_by integer,
    zone text
);


ALTER TABLE public.university OWNER TO postgres;

--
-- TOC entry 323 (class 1259 OID 17057)
-- Name: universityactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universityactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universityactivity_id_seq OWNER TO postgres;

--
-- TOC entry 324 (class 1259 OID 17058)
-- Name: universityactivity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universityactivity (
    id integer DEFAULT nextval('public.universityactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content json,
    modified_date timestamp without time zone,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    role text,
    universityid text,
    differentcontent text,
    previouscontent text,
    previouscontentlength text,
    newcontentlength text
);


ALTER TABLE public.universityactivity OWNER TO postgres;

--
-- TOC entry 325 (class 1259 OID 17072)
-- Name: universitycomment_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitycomment_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitycomment_id_seq OWNER TO postgres;

--
-- TOC entry 326 (class 1259 OID 17073)
-- Name: universitycomment; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universitycomment (
    id integer DEFAULT nextval('public.universitycomment_id_seq'::regclass) NOT NULL,
    title text,
    description text,
    universityid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.universitycomment OWNER TO postgres;

--
-- TOC entry 349 (class 1259 OID 18526)
-- Name: universitycourse_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitycourse_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitycourse_id_seq OWNER TO postgres;

--
-- TOC entry 350 (class 1259 OID 18533)
-- Name: universitycourseactivity_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitycourseactivity_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitycourseactivity_id_seq OWNER TO postgres;

--
-- TOC entry 351 (class 1259 OID 18534)
-- Name: universitycourseactivity; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universitycourseactivity (
    id integer DEFAULT nextval('public.universitycourseactivity_id_seq'::regclass) NOT NULL,
    superuserid integer,
    content text,
    differentcontent text,
    role text,
    unicourseid text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    previouscontent text,
    previouscontentlength text,
    newcontentlength text
);


ALTER TABLE public.universitycourseactivity OWNER TO postgres;

--
-- TOC entry 327 (class 1259 OID 17092)
-- Name: universityfaq_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universityfaq_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universityfaq_id_seq OWNER TO postgres;

--
-- TOC entry 328 (class 1259 OID 17093)
-- Name: universityfaq; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universityfaq (
    id integer DEFAULT nextval('public.universityfaq_id_seq'::regclass) NOT NULL,
    question text[],
    answer text[],
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    universityid integer,
    last_modified timestamp without time zone
);


ALTER TABLE public.universityfaq OWNER TO postgres;

--
-- TOC entry 340 (class 1259 OID 17913)
-- Name: universitylistening_benefit_id_seq; Type: SEQUENCE; Schema: public; Owner: imtsac_ibrahimmemon
--

CREATE SEQUENCE public.universitylistening_benefit_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitylistening_benefit_id_seq OWNER TO imtsac_ibrahimmemon;

--
-- TOC entry 329 (class 1259 OID 17107)
-- Name: universitylisteningbenefit_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitylisteningbenefit_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitylisteningbenefit_id_seq OWNER TO postgres;

--
-- TOC entry 330 (class 1259 OID 17108)
-- Name: universitylisteningbenefit; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universitylisteningbenefit (
    id integer DEFAULT nextval('public.universitylisteningbenefit_id_seq'::regclass) NOT NULL,
    step1 text,
    step2 text,
    step3 text,
    step4 text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_date timestamp without time zone,
    last_modified_by text
);


ALTER TABLE public.universitylisteningbenefit OWNER TO postgres;

--
-- TOC entry 332 (class 1259 OID 17118)
-- Name: universitylisteningstep; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universitylisteningstep (
    id integer NOT NULL,
    step1 text,
    step2 text,
    step3 text,
    step4 text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_date timestamp without time zone,
    last_modified_by text
);


ALTER TABLE public.universitylisteningstep OWNER TO postgres;

--
-- TOC entry 331 (class 1259 OID 17117)
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitylisteningstep_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitylisteningstep_id_seq OWNER TO postgres;

--
-- TOC entry 4300 (class 0 OID 0)
-- Dependencies: 331
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.universitylisteningstep_id_seq OWNED BY public.universitylisteningstep.id;


--
-- TOC entry 333 (class 1259 OID 17127)
-- Name: universityreview_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universityreview_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universityreview_id_seq OWNER TO postgres;

--
-- TOC entry 334 (class 1259 OID 17128)
-- Name: universityreview; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universityreview (
    id integer DEFAULT nextval('public.universityreview_id_seq'::regclass) NOT NULL,
    rating text,
    detail text,
    universityid integer,
    userid integer,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified timestamp without time zone
);


ALTER TABLE public.universityreview OWNER TO postgres;

--
-- TOC entry 335 (class 1259 OID 17147)
-- Name: universitytype_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.universitytype_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.universitytype_id_seq OWNER TO postgres;

--
-- TOC entry 336 (class 1259 OID 17148)
-- Name: universitytype; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.universitytype (
    id integer DEFAULT nextval('public.universitytype_id_seq'::regclass) NOT NULL,
    name text,
    status text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone
);


ALTER TABLE public.universitytype OWNER TO postgres;

--
-- TOC entry 217 (class 1259 OID 16397)
-- Name: up; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.up
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.up OWNER TO postgres;

--
-- TOC entry 359 (class 1259 OID 18637)
-- Name: userlogs; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.userlogs (
    id integer NOT NULL,
    username text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    status text
);


ALTER TABLE public.userlogs OWNER TO postgres;

--
-- TOC entry 358 (class 1259 OID 18636)
-- Name: userlogs_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.userlogs_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.userlogs_id_seq OWNER TO postgres;

--
-- TOC entry 4306 (class 0 OID 0)
-- Dependencies: 358
-- Name: userlogs_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.userlogs_id_seq OWNED BY public.userlogs.id;


--
-- TOC entry 243 (class 1259 OID 16542)
-- Name: users_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.users_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.users_id_seq OWNER TO postgres;

--
-- TOC entry 244 (class 1259 OID 16543)
-- Name: users; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.users (
    id integer DEFAULT nextval('public.users_id_seq'::regclass) NOT NULL,
    name text,
    email text,
    phone text,
    city text,
    country text,
    gender text,
    password text,
    added_by text,
    last_modified date,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    courseid integer,
    dob text
);


ALTER TABLE public.users OWNER TO postgres;

--
-- TOC entry 216 (class 1259 OID 16391)
-- Name: uu; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.uu (
    id integer NOT NULL
);


ALTER TABLE public.uu OWNER TO postgres;

--
-- TOC entry 215 (class 1259 OID 16390)
-- Name: uu_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.uu_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.uu_id_seq OWNER TO postgres;

--
-- TOC entry 4309 (class 0 OID 0)
-- Dependencies: 215
-- Name: uu_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE public.uu_id_seq OWNED BY public.uu.id;


--
-- TOC entry 337 (class 1259 OID 17157)
-- Name: zone_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE public.zone_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER SEQUENCE public.zone_id_seq OWNER TO postgres;

--
-- TOC entry 338 (class 1259 OID 17158)
-- Name: zone; Type: TABLE; Schema: public; Owner: postgres
--

CREATE TABLE public.zone (
    id integer DEFAULT nextval('public.zone_id_seq'::regclass) NOT NULL,
    name text,
    added_by text,
    added_date timestamp without time zone DEFAULT CURRENT_TIMESTAMP,
    last_modified_by text,
    last_modified_date timestamp without time zone,
    status text
);


ALTER TABLE public.zone OWNER TO postgres;

--
-- TOC entry 3597 (class 2604 OID 23240)
-- Name: aboutpage id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.aboutpage ALTER COLUMN id SET DEFAULT nextval('public.aboutpage_id_seq'::regclass);


--
-- TOC entry 3623 (class 2604 OID 23241)
-- Name: contactus id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.contactus ALTER COLUMN id SET DEFAULT nextval('public.contactus_id_seq'::regclass);


--
-- TOC entry 3643 (class 2604 OID 23242)
-- Name: designation id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.designation ALTER COLUMN id SET DEFAULT nextval('public.designation_id_seq'::regclass);


--
-- TOC entry 3645 (class 2604 OID 23243)
-- Name: expertpage id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.expertpage ALTER COLUMN id SET DEFAULT nextval('public.expertpage_id_seq'::regclass);


--
-- TOC entry 3706 (class 2604 OID 23244)
-- Name: marquee id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.marquee ALTER COLUMN id SET DEFAULT nextval('public.marquee_id_seq1'::regclass);


--
-- TOC entry 3694 (class 2604 OID 23245)
-- Name: universitylisteningstep id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitylisteningstep ALTER COLUMN id SET DEFAULT nextval('public.universitylisteningstep_id_seq'::regclass);


--
-- TOC entry 3720 (class 2604 OID 23246)
-- Name: userlogs id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.userlogs ALTER COLUMN id SET DEFAULT nextval('public.userlogs_id_seq'::regclass);


--
-- TOC entry 3584 (class 2604 OID 23247)
-- Name: uu id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.uu ALTER COLUMN id SET DEFAULT nextval('public.uu_id_seq'::regclass);


--
-- TOC entry 4053 (class 0 OID 16464)
-- Dependencies: 232
-- Data for Name: aboutpage; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.aboutpage (id, heading, description, content, added_by, added_date, last_modified_by, last_modified_date, moreabout) FROM stdin;
6	About Us		<div class="elementor-element elementor-element-c413a9a elementor-widget elementor-widget-heading" data-id="c413a9a" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box; text-align: center;"><span style="box-sizing: border-box; color: rgb(255, 102, 0);">WHO WE ARE</span></div></div><div class="elementor-element elementor-element-be9b7ae elementor-widget elementor-widget-heading" data-id="be9b7ae" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Offers The Highest Quality Online Learning And Distance Learning Courses.</h2></div></div><div class="elementor-element elementor-element-484fbd7 elementor-widget elementor-widget-text-editor" data-id="484fbd7" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-widget-container" style="box-sizing: border-box;"><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS institute is an educational institute with highly qualified, adept teachers and more than 350 Employee. IMTS Institute aims to provide quality education to all its students, no matter what their location. Primarily geared toward career-oriented students, IMTS Institute strives to make its students reach the pinnacle of their success with its quality education.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS Education is the process of facilitating learning, or the acquisition of knowledge, skills, values, beliefs, and habits. Educational methods include storytelling, discussion, teaching, training, and directed research. Education frequently takes place under the guidance of educators, but learners may also educate themselves.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Core belief of IMTS is that every student should get accurate information and assistance before they choose that would become a stepping-stone towards their bright future.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;"><strong style="box-sizing: border-box; font-weight: 600;">Knowledge and guidance with IMTS institute</strong></p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Career education and leadership play an essential role in the curriculum that supports: student’s interests, strengths, and aspirations. With multiple career options available in the market, it gives students a tough time in selecting the right course for themselves that would help them nurture in the right direction. In the majority of the cases, either student ends up opting for a course that does not align with their plans or take up a job that varies completely from the path they had pursued.</p></div></div>	1	2024-07-30 10:42:58.57088	\N	\N	<section class="elementor-section elementor-top-section elementor-element elementor-element-7319234 elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="7319234" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-top-column elementor-element elementor-element-fb8b4d9" data-id="fb8b4d9" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-afb88c1 elementor-widget elementor-widget-heading" data-id="afb88c1" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-xl" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Institute Assisted 25000+ Students to Achieve their Professional Goals after the Covid-19 Epidemic</h2></div></div></div></div></div></section><section class="elementor-section elementor-top-section elementor-element elementor-element-ff64faa elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="ff64faa" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-top-column elementor-element elementor-element-8f98539" data-id="8f98539" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-d69e989 elementor-widget elementor-widget-text-editor" data-id="d69e989" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h3 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 16px !important;">The New Wave</h3><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">It is critical to recognize the relevance of technology in education, even if you are neither a student nor an educator. While many individuals prefer traditional teaching techniques, the opportunities when technology is introduced into the classroom are limitless. For one thing, education has become much more accessible, with a wider range of learning styles and degree alternatives.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">It can undoubtedly assist educators in tracking individual progress and devising novel instructional plans. Students who learn through technology, on the other hand, can develop a set of skills that will aid them in their future employment. Teachers should evaluate why students want rather than need technology in the classroom to get the most out of these tools.</p><h2 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important;">IMTS to the Rescue</h2><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Due to the unpredictable nature of the Covid-19 pandemic, schools were obliged to halt physical education classes in order to combat the virus. As a result, many students could not obtain the education they desired. IMTS’s contemporary teaching methods proved to be a big success.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">The educational institution aimed to give high-quality education to all of its pupils, regardless of their geographic location, with over 350 career counsellors and highly-skilled, qualified teachers. IMTS Institute, primarily focused on career-oriented students, aims to help them achieve the peak of their accomplishment through superior education.</p><h2 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important;">Online learning</h2><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Learning from home or modern communication paradigms has tremendously facilitated online learning. Individuals can attend lectures via distance education even if the lecturer is on another continent. During the global pandemic of 2020, when schools were compelled to close and fully transition to distance learning, this teaching style became incredibly crucial. Even before that, online courses were popular because they provided knowledge to those who wanted to grow in their careers but didn’t have the time or money to do so.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">When it comes to the formation of critical thinking, the role of technology in education is especially clear. Different educational techniques enable pupils to express themselves in unique ways, resulting in various solutions. They approach information seriously in this process, considering each accessible piece of data to arrive at the intended result.</p><h3 style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 16px !important;">Technology’s Potential in Education</h3><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">As you can see, technology plays a huge role in education, and its influence is rising. However, it is critical to properly incorporate technology in education because many old teaching methods should be preserved. Furthermore, the computer is not appropriate for all situations, nor is studying with it always more efficient. As a result, teachers must balance future-ready education and traditional offline instruction.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">In the uncertain times of Covid-19, IMTS has achieved its objective of educating 25000 students, and it has made it a slogan to ensure that students receive quality education through modern means. They will be up to date on the latest technologies and will be able to ensure that their education is of maximum practical use in the real world.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;"><section class="elementor-section elementor-inner-section elementor-element elementor-element-fbceeba elementor-section-boxed elementor-section-height-default elementor-section-height-default" data-id="fbceeba" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-inner-column elementor-element elementor-element-1fbed1e" data-id="1fbed1e" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-7c9a633 elementor-widget elementor-widget-heading" data-id="7c9a633" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box; text-align: center;"><span class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; color: rgb(255, 102, 0);">TESTIMONIAL</span></div></div><div class="elementor-element elementor-element-0da93ad elementor-widget elementor-widget-heading" data-id="0da93ad" data-element_type="widget" data-widget_type="heading.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><h2 class="elementor-heading-title elementor-size-default" style="box-sizing: border-box; margin-top: 0px; margin-bottom: 0.5rem; font-family: Rajdhani; font-weight: 700; line-height: 1.2; color: rgb(19, 15, 64); font-size: 26px !important; text-align: center;">IMTS Institute Delivers World-Class Education With A 99% Pass Rate: 40% Alumni Working Abroad</h2></div></div></div></div></div></section><section class="elementor-section elementor-inner-section elementor-element elementor-element-c1a2896 elementor-section-full_width elementor-section-height-default elementor-section-height-default" data-id="c1a2896" data-element_type="section" style="box-sizing: border-box; display: block; color: rgb(105, 105, 105); font-family: Rubik; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: left; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: rgb(255, 255, 255); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><div class="elementor-container elementor-column-gap-default" style="box-sizing: border-box;"><div class="elementor-column elementor-col-100 elementor-inner-column elementor-element elementor-element-6789b75" data-id="6789b75" data-element_type="column" style="box-sizing: border-box;"><div class="elementor-widget-wrap elementor-element-populated" style="box-sizing: border-box;"><div class="elementor-element elementor-element-2f0690c elementor-widget elementor-widget-text-editor" data-id="2f0690c" data-element_type="widget" data-widget_type="text-editor.default" style="box-sizing: border-box;"><div class="elementor-widget-container" style="box-sizing: border-box;"><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">For the past 17 years, around 50k students have been satisfied with the assistance and services provided by IMTS. The mentors are highly skilled in their fields and work. They have been leading MNC’s such as IBM, HCL, Google, BSF, Government Indian Army, BSF, CISF, SBI ETC. Jobs and others .For students to improve their professional and personal abilities, IMTS Institute provides the best possible support to students. 99% of students Get their diplomas on schedule.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">The IMTS institution has benefited over 50,000 students. They offer excellent career counseling in which specialists advise students on the breadth of each topic. This allows students to live a stress-free life after passing their Class 12 exams. They can determine which topics are best based on a student’s abilities. It is an ideal environment for those who desire to advance and achieve in their chosen area.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">Strong reputation among Indian students</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">IMTS Institute is a prestigious institute. It has already established a strong reputation among Indian students, and it is now accepting international students as well. It helps students to fly in the sky of boundless knowledge. IMTS provides course after 12th information as well as assistance to students with projects and assignments.</p><p style="box-sizing: border-box; margin-top: 0px; margin-bottom: 1rem;">To avoid any carelessness on the part of the students, IMTS keeps them up to speed on the newest rules, regulations, and announcements issued by the institutions.</p></div></div></div></div></div></section></p></div></div></div></div></div></section>
\.


--
-- TOC entry 4056 (class 0 OID 16478)
-- Dependencies: 235
-- Data for Name: acdemicspecialization; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.acdemicspecialization (id, universityid, courseid, specialization, specializationcode, coursefee, examfee, registrationfee, added_date, added_by, last_modified) FROM stdin;
\.


--
-- TOC entry 4042 (class 0 OID 16409)
-- Dependencies: 221
-- Data for Name: alumni; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.alumni (id, name, image, added_by, added_date) FROM stdin;
18	download.jpeg	download.jpeg	1	2024-07-29 09:48:10.156318
19	images (1).jpeg	images (1).jpeg	1	2024-07-29 09:48:17.05841
20	images (2).jpeg	images (2).jpeg	1	2024-07-29 09:48:26.530984
21	images (3).jpeg	images (3).jpeg	1	2024-07-29 09:48:33.790345
22	images (4).jpeg	images (4).jpeg	1	2024-07-29 09:48:40.913245
23	images (5).jpeg	images (5).jpeg	1	2024-07-29 09:48:47.633629
24	images (6).jpeg	images (6).jpeg	1	2024-07-29 09:48:55.208164
25	images (7).jpeg	images (7).jpeg	1	2024-07-29 09:49:02.522484
26	images (8).jpeg	images (8).jpeg	1	2024-07-29 09:49:10.91477
27	images.jpeg	Medium1.jpg	1	2024-07-29 09:49:18.181863
\.


--
-- TOC entry 4058 (class 0 OID 16498)
-- Dependencies: 237
-- Data for Name: approved; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.approved (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	UGC	Active	1	2024-07-26 05:50:28.22642	\N	\N
\.


--
-- TOC entry 4060 (class 0 OID 16508)
-- Dependencies: 239
-- Data for Name: backup; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.backup (id, filepath, added_date, mode) FROM stdin;
1	imtsonline_vidhya_college-2024-7-19.sql	2024-07-19 00:00:00.814235	Auto
2	imtsac_educationdunia-2024-7-20.sql	2024-07-20 00:00:00.775215	Auto
3	imtsac_educationdunia-2024-7-21.sql	2024-07-21 00:00:00.349357	Auto
4	imtsac_educationdunia-2024-7-22.sql	2024-07-22 00:00:00.276621	Auto
5	imtsac_educationdunia-2024-7-23.sql	2024-07-23 00:00:00.970417	Auto
6	imtsac_educationdunia-2024-7-24.sql	2024-07-24 00:00:00.432669	Auto
7	imtsac_educationdunia-2024-7-25.sql	2024-07-25 00:00:00.311874	Auto
8	imtsac_educationdunia-2024-7-26.sql	2024-07-26 00:00:00.258535	Auto
9	imtsac_educationdunia-2024-7-27.sql	2024-07-27 00:00:00.369742	Auto
10	imtsac_educationdunia-2024-7-28.sql	2024-07-28 00:00:00.190199	Auto
11	imtsac_educationdunia-2024-7-29.sql	2024-07-29 00:00:00.199108	Auto
12	imtsac_educationdunia-2024-7-30.sql	2024-07-30 00:00:00.75426	Auto
13	imtsac_educationdunia-2024-7-31.sql	2024-07-31 00:00:00.243921	Auto
14	imtsac_educationdunia-2024-8-1.sql	2024-08-01 00:00:00.191832	Auto
15	imtsac_educationdunia-2024-8-2.sql	2024-08-02 00:00:00.659873	Auto
16	imtsac_educationdunia-2024-8-3.sql	2024-08-03 00:00:00.466356	Auto
17	imtsac_educationdunia-2024-8-4.sql	2024-08-04 00:00:00.275203	Auto
18	imtsac_educationdunia-2024-8-8.sql	2024-08-08 00:00:00.259693	Auto
19	imtsac_educationdunia-2024-8-9.sql	2024-08-09 00:00:00.583575	Auto
20	imtsac_educationdunia-2024-8-10.sql	2024-08-10 00:00:00.474637	Auto
21	imtsac_educationdunia-2024-8-11.sql	2024-08-11 00:00:01.029	Auto
22	imtsac_educationdunia-2024-8-12.sql	2024-08-12 00:00:00.612205	Auto
23	imtsac_educationdunia-2024-8-13.sql	2024-08-13 00:00:00.183424	Auto
24	imtsac_educationdunia-2024-8-14.sql	2024-08-14 00:00:01.061736	Auto
25	imtsac_educationdunia-2024-8-15.sql	2024-08-15 00:00:01.289659	Auto
26	imtsac_educationdunia-2024-8-16.sql	2024-08-16 00:00:00.950897	Auto
27	imtsac_educationdunia-2024-8-17.sql	2024-08-17 00:00:00.483618	Auto
28	imtsac_educationdunia-2024-8-18.sql	2024-08-18 00:00:01.040796	Auto
29	imtsac_educationdunia-2024-8-19.sql	2024-08-19 00:00:00.933541	Auto
30	imtsac_educationdunia-2024-8-20.sql	2024-08-20 00:00:00.860848	Auto
31	imtsac_educationdunia-2024-8-21.sql	2024-08-21 00:00:00.843477	Auto
32	imtsac_educationdunia-2024-8-22.sql	2024-08-22 00:00:00.863014	Auto
33	imtsac_educationdunia-2024-8-23.sql	2024-08-23 00:00:00.583249	Auto
34	imtsac_educationdunia-2024-8-24.sql	2024-08-24 00:00:00.207588	Auto
35	imtsac_educationdunia-2024-8-25.sql	2024-08-25 00:00:01.07712	Auto
36	imtsac_educationdunia-2024-8-26.sql	2024-08-26 00:00:01.045467	Auto
37	imtsac_educationdunia-2024-8-27.sql	2024-08-27 00:00:00.774553	Auto
38	imtsac_educationdunia-2024-8-28.sql	2024-08-28 00:00:00.985118	Auto
39	imtsac_educationdunia-2024-8-29.sql	2024-08-29 00:00:00.487234	Auto
40	imtsac_educationdunia-2024-8-30.sql	2024-08-30 00:00:00.399828	Auto
41	imtsac_educationdunia-2024-8-31.sql	2024-08-31 00:00:00.661145	Auto
42	imtsac_educationdunia-2024-9-1.sql	2024-09-01 00:00:00.613167	Auto
43	imtsac_educationdunia-2024-9-2.sql	2024-09-02 00:00:00.572261	Auto
44	imtsac_educationdunia-2024-9-3.sql	2024-09-03 00:00:00.782219	Auto
45	imtsac_educationdunia-2024-9-4.sql	2024-09-04 00:00:01.093427	Auto
46	imtsac_educationdunia-2024-9-5.sql	2024-09-05 00:00:00.607565	Auto
47	imtsac_educationdunia-2024-9-6.sql	2024-09-06 00:00:00.768969	Auto
48	imtsac_educationdunia-2024-9-7.sql	2024-09-07 00:00:01.681715	Auto
49	imtsac_educationdunia-2024-9-8.sql	2024-09-08 00:00:01.202105	Auto
50	imtsac_educationdunia-2024-9-9.sql	2024-09-09 00:00:00.482669	Auto
51	imtsac_educationdunia-2024-9-10.sql	2024-09-10 00:00:00.794063	Auto
52	imtsac_educationdunia-2024-9-11.sql	2024-09-11 00:00:00.5218	Auto
53	imtsac_educationdunia-2024-9-12.sql	2024-09-12 00:00:00.874797	Auto
54	imtsac_educationdunia-2024-9-13.sql	2024-09-13 00:00:00.722608	Auto
55	imtsac_educationdunia-2024-9-13.sql	2024-09-13 11:59:21.468795	Auto
56	imtsac_educationdunia-2024-9-14.sql	2024-09-14 00:00:01.247805	Auto
57	imtsac_educationdunia-2024-9-15.sql	2024-09-15 00:00:00.360186	Auto
58	imtsac_educationdunia-2024-9-16.sql	2024-09-16 00:00:01.612915	Auto
59	imtsac_educationdunia-2024-9-16.sql	2024-09-16 10:19:43.646656	Auto
60	imtsac_educationdunia-2024-9-17.sql	2024-09-17 00:00:00.778911	Auto
61	imtsac_educationdunia-2024-9-18.sql	2024-09-18 00:00:00.949474	Auto
62	imtsac_educationdunia-2024-9-19.sql	2024-09-19 00:00:01.365405	Auto
63	imtsac_educationdunia-2024-9-19.sql	2024-09-19 16:13:18.309576	Auto
64	imtsac_educationdunia-2024-9-20.sql	2024-09-20 15:11:51.746447	Mannual
65	imtsac_educationdunia-2024-9-20.sql	2024-09-20 15:12:40.452409	Auto
66	imtsac_educationdunia-2024-9-21.sql	2024-09-21 00:00:00.606121	Auto
68	imtsac_educationdunia-2024-9-22.sql	2024-09-22 00:00:01.246366	Auto
67	imtsac_educationdunia-2024-9-22.sql	2024-09-22 00:00:01.277604	Auto
69	imtsac_educationdunia-2024-9-23.sql	2024-09-23 00:00:00.396743	Auto
70	imtsac_educationdunia-2024-9-23.sql	2024-09-23 00:00:01.200631	Auto
71	imtsac_educationdunia-2024-9-24.sql	2024-09-24 00:00:00.626448	Auto
72	imtsac_educationdunia-2024-9-24.sql	2024-09-24 00:00:03.446138	Auto
73	imtsac_educationdunia-2024-9-25.sql	2024-09-25 00:00:01.039673	Auto
74	imtsac_educationdunia-2024-9-25.sql	2024-09-25 00:00:01.062949	Auto
75	imtsac_educationdunia-2024-9-26.sql	2024-09-26 00:00:00.530595	Auto
76	imtsac_educationdunia-2024-9-27.sql	2024-09-27 00:00:00.666053	Auto
77	imtsac_educationdunia-2024-9-27.sql	2024-09-27 00:00:00.981844	Auto
78	imtsac_educationdunia-2024-9-28.sql	2024-09-28 00:00:00.965623	Auto
79	imtsac_educationdunia-2024-9-28.sql	2024-09-28 00:00:01.169555	Auto
80	imtsac_educationdunia-2024-9-29.sql	2024-09-29 00:00:00.700332	Auto
82	imtsac_educationdunia-2024-9-30.sql	2024-09-30 00:00:00.52631	Auto
81	imtsac_educationdunia-2024-9-30.sql	2024-09-30 00:00:00.539512	Auto
83	imtsac_educationdunia-2024-10-1.sql	2024-10-01 00:00:01.081024	Auto
84	imtsac_educationdunia-2024-10-1.sql	2024-10-01 00:00:01.264181	Auto
85	imtsac_educationdunia-2024-10-2.sql	2024-10-02 00:00:00.423501	Auto
86	imtsac_educationdunia-2024-10-2.sql	2024-10-02 00:00:01.702957	Auto
87	imtsac_educationdunia-2024-10-3.sql	2024-10-03 00:00:00.572027	Auto
88	imtsac_educationdunia-2024-10-3.sql	2024-10-03 00:00:01.442759	Auto
89	imtsac_educationdunia-2024-10-4.sql	2024-10-04 00:00:00.554397	Auto
90	imtsac_educationdunia-2024-10-4.sql	2024-10-04 00:00:01.081481	Auto
91	imtsac_educationdunia-2024-10-5.sql	2024-10-05 00:00:00.724477	Auto
92	imtsac_educationdunia-2024-10-5.sql	2024-10-05 00:00:00.927112	Auto
93	imtsac_educationdunia-2024-10-6.sql	2024-10-06 00:00:01.496047	Auto
94	imtsac_educationdunia-2024-10-7.sql	2024-10-07 00:00:00.66591	Auto
95	imtsac_educationdunia-2024-10-7.sql	2024-10-07 00:00:01.027571	Auto
96	imtsac_educationdunia-2024-10-8.sql	2024-10-08 00:00:00.340103	Auto
97	imtsac_educationdunia-2024-10-8.sql	2024-10-08 00:00:01.859269	Auto
98	imtsac_educationdunia-2024-10-9.sql	2024-10-09 00:00:01.785659	Auto
99	imtsac_educationdunia-2024-10-10.sql	2024-10-10 00:00:00.900177	Auto
100	imtsac_educationdunia-2024-10-11.sql	2024-10-11 00:00:00.615256	Auto
101	imtsac_educationdunia-2024-10-12.sql	2024-10-12 00:00:00.340701	Auto
102	imtsac_educationdunia-2024-10-12.sql	2024-10-12 00:00:01.003408	Auto
103	imtsac_educationdunia-2024-10-12.sql	2024-10-12 00:00:04.084455	Auto
104	imtsac_educationdunia-2024-10-13.sql	2024-10-13 00:00:00.702582	Auto
105	imtsac_educationdunia-2024-10-13.sql	2024-10-13 00:00:01.522202	Auto
106	imtsac_educationdunia-2024-10-13.sql	2024-10-13 00:00:04.899372	Auto
107	imtsac_educationdunia-2024-10-14.sql	2024-10-14 00:00:01.438221	Auto
\.


--
-- TOC entry 4062 (class 0 OID 16518)
-- Dependencies: 241
-- Data for Name: banner; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.banner (id, name, image, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
28	Ibrahim	IMTS 5.png	1	2024-07-29 09:55:53.910817	1	2024-08-06 19:04:31
\.


--
-- TOC entry 4044 (class 0 OID 16419)
-- Dependencies: 223
-- Data for Name: blog; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.blog (id, pagename, seotitle, seodescription, tag, status, topic, image, content, added_date, added_by, last_modified, feature, toc, active, urlname, toch1, toch2, toch3, toch4, toch5, layout) FROM stdin;
2	Best Computer Science Courses After 12th 2025	Top Computer Science Courses After 12th: Launch Your Tech Career	Explore the best computer science courses to pursue after 12th. Discover top universities, career paths, and job opportunities in the tech industry. Make informed decisions for your future.	\N			systems-security-photo.jpg	<p style="text-align: justify;">In today’s digital age, computer science has become a cornerstone of innovation and development. From powering modern businesses to driving cutting-edge research, computer science professionals are in high demand. If you're a student who has just completed the 12th grade and are considering a career in this dynamic field, you have a plethora of course options to choose from. This guide will help you navigate through the best computer science courses available after 12th class, providing you with detailed insights into each option.&nbsp;</p><h3 style="text-align: justify;"><strong>Undergraduate Degree Courses</strong></h3><p style="text-align: justify;"><strong>B.Tech in Computer Science and Engineering</strong></p><p style="text-align: justify;">A B.Tech in Computer Science and Engineering is one of the most prestigious and sought-after courses for aspiring computer professionals. This four-year program combines theoretical knowledge with practical skills in programming, algorithms, software development, and system design.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can pursue careers as software developers, system analysts, network engineers, and more. They can also work in various industries, including IT, finance, healthcare, and education.</li></ul><p style="text-align: justify;"><strong>B.E. in Computer Engineering</strong></p><p style="text-align: justify;">The Bachelor of Engineering (B.E.) in Computer Engineering is similar to B.Tech but may have a slightly different curriculum focus. This four-year program also emphasizes both theoretical and practical aspects of computer science.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as computer engineers, software testers, IT consultants, and in many other roles across different sectors.</li></ul><p style="text-align: justify;"><strong>B.Sc. in Computer Science</strong></p><p style="text-align: justify;">A Bachelor of Science (B.Sc.) in Computer Science is a three-year program that covers the fundamentals of computer science, including programming, data structures, and software engineering.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work in roles such as software developers, web developers, database administrators, and IT support specialists. They can also pursue higher studies like M.Sc. or Ph.D. in Computer Science.</li></ul><p style="text-align: justify;"><strong>BCA (Bachelor of Computer Applications)</strong></p><p style="text-align: justify;">The BCA is a three-year undergraduate program that focuses on computer applications and software development. It is designed for students who want to build a career in IT and software industries.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can become software developers, app developers, system analysts, and IT managers. They can also work in various sectors like banking, education, and e-commerce.</li></ul><p style="text-align: justify;"><strong>Specialized Computer Science Courses</strong></p><p style="text-align: justify;"><strong>B.Tech in Information Technology</strong></p><p style="text-align: justify;">This four-year program specializes in the application of computers and telecommunications to store, retrieve, transmit, and manipulate data. It includes subjects like information security, database management, and web technologies.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as IT consultants, network administrators, database managers, and cybersecurity experts.</li></ul><p style="text-align: justify;"><strong>B.Sc. in Information Technology</strong></p><p style="text-align: justify;">A B.Sc. in IT is a three-year program that focuses on the theoretical and practical aspects of information technology. It includes subjects like programming, web development, and computer networks.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as IT support specialists, network engineers, web developers, and in various other roles within the IT sector.</li></ul><p style="text-align: justify;"><strong>B.Sc. in Data Science</strong></p><p style="text-align: justify;">Data Science is an emerging field that focuses on extracting knowledge and insights from structured and unstructured data. This three-year program covers subjects like machine learning, statistics, and data mining.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as data scientists, data analysts, business analysts, and in roles related to big data and analytics.</li></ul><p style="text-align: justify;"><strong>B.Sc. in Artificial Intelligence and Machine Learning</strong></p><p style="text-align: justify;">This specialized course focuses on the development of intelligent systems and algorithms that can learn and make decisions. The three-year program includes subjects like neural networks, deep learning, and natural language processing.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as AI engineers, machine learning engineers, data scientists, and in research and development roles in AI.</li></ul><p style="text-align: justify;"><strong>Diploma and Associate Degree Courses</strong></p><p style="text-align: justify;"><strong>Diploma in Computer Science Engineering</strong></p><p style="text-align: justify;">A diploma in Computer Science Engineering is typically a three-year program that provides foundational knowledge in computer science and engineering principles. It is a good option for students who want to enter the workforce quickly.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as junior software developers, technical support engineers, and in other entry-level IT roles.</li></ul><p style="text-align: justify;"><strong>Associate Degree in Computer Science</strong></p><p style="text-align: justify;">An associate degree in Computer Science is a two-year program that covers basic and intermediate topics in computer science. It is a good stepping stone for further education or entry-level employment.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work in technical support, software development, and IT services, or continue their education with a bachelor's degree.</li></ul><p style="text-align: justify;"><strong>Online and Certification Courses</strong></p><p style="text-align: justify;"><strong>Google IT Support Professional Certificate</strong></p><p style="text-align: justify;">This online certification program, offered by Google through platforms like Coursera, provides training in IT support and networking. It is designed to be completed in about six months.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Certificate holders can work as IT support specialists, help desk technicians, and network support engineers.</li></ul><p style="text-align: justify;"><strong>IBM Data Science Professional Certificate</strong></p><p style="text-align: justify;">Offered by IBM, this certification program covers data science fundamentals, including Python programming, data visualization, and machine learning. It can be completed online at your own pace.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work as data analysts, data scientists, and in roles related to data analytics and machine learning.</li></ul><p style="text-align: justify;"><strong>Coursera and edX Courses</strong></p><p style="text-align: justify;">Both Coursera and edX offer a wide range of online courses and specializations in computer science from top universities and companies. These courses are flexible and can be tailored to your interests and career goals.</p><ul><li style="text-align: justify;"><strong>Popular Options</strong>: Python for Everybody (Coursera), Introduction to Computer Science (edX), and various specialized courses in AI, data science, and cybersecurity.</li><li style="text-align: justify;"><strong>Benefits of Online Learning</strong>: Flexibility, affordability, and access to high-quality education from renowned institutions.</li></ul><p style="text-align: justify;"><strong>Integrated Courses</strong></p><p style="text-align: justify;"><strong>Integrated B.Tech and M.Tech in Computer Science</strong></p><p style="text-align: justify;">This five-year program combines undergraduate and postgraduate studies in computer science. It is designed for students who want to gain advanced knowledge and skills in a shorter time frame.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can work in research and development, higher education, and advanced technical roles in the IT industry.</li></ul><p style="text-align: justify;"><strong>Integrated B.Sc. and M.Sc. in Computer Science</strong></p><p style="text-align: justify;">An integrated B.Sc. and M.Sc. in Computer Science is a five-year course that offers a seamless transition from undergraduate to postgraduate studies, focusing on both foundational and advanced topics.</p><ul><li style="text-align: justify;"><strong>Career Opportunities</strong>: Graduates can pursue careers in academia, research, and high-level technical positions in various industries.</li></ul><p style="text-align: justify;"><strong>Emerging Fields in Computer Science</strong></p><p style="text-align: justify;"><strong>Cybersecurity</strong></p><p style="text-align: justify;">Cybersecurity is becoming increasingly important as cyber threats grow more sophisticated. Courses in cybersecurity cover topics like ethical hacking, network security, and cryptography.</p><ul><li style="text-align: justify;"><strong>Importance and Growth</strong>: With the rise of cyber attacks, there is a growing demand for cybersecurity professionals.</li><li style="text-align: justify;"><strong>Relevant Courses and Certifications</strong>: Certified Information Systems Security Professional (CISSP), Certified Ethical Hacker (CEH), and various online courses.</li></ul>	2024-08-08 09:57:50.967337	1	2024-09-05 18:48:03	Feature	TOC	Active	Best-Computer-Science-Courses-After-12th-	{}	{}	{"<h3 style=\\"text-align: justify;\\"><strong>Undergraduate Degree Courses</strong></h3>"}	{}	{}	Left
12	Best Engineering Courses After 12th for a Successful Career	Top Engineering Courses After 12th: Launch Your Successful Career	Discover the best engineering courses to pursue after 12th grade. Explore top specializations, job prospects, and career paths. Find your perfect engineering match	\N			17.webp	<p>Engineering is one of the most sought-after career paths for students who have completed their 12th grade, particularly those from the science stream. The decision to pursue engineering is a significant one, as it sets the foundation for a student’s professional journey. With a plethora of engineering disciplines available, making the right choice can be overwhelming. This article aims to guide you through the best engineering courses after the 12th grade, ensuring you choose a path that aligns with your interests, strengths, and career aspirations.</p><h2><strong>What to Consider When Choosing an Engineering Course</strong></h2><p>The first and foremost factor to consider when selecting an engineering course is your personal interest and aptitude. Are you fascinated by computers, intrigued by machinery, or passionate about building structures? Identifying your strengths and interests can help narrow down the options and ensure you are pursuing a course that you will enjoy and excel in.</p><h4><strong>Market Demand and Future Prospects</strong></h4><p>While passion is crucial, it’s also important to consider the job market and future prospects of the engineering field you choose. Some engineering disciplines have higher demand and offer better job opportunities than others. Researching industry trends and understanding which sectors are growing can help you make an informed decision.</p><h4><strong>Course Curriculum and Specialization</strong></h4><p>Each engineering discipline comes with its own set of core subjects and specialized areas of study. It’s essential to understand the curriculum and the kind of projects or research work you will be involved in during the course. Some courses might offer more practical, hands-on experience, while others may focus more on theoretical knowledge.</p><h4><strong>Accreditation and Reputation of Institutions</strong></h4><p>The reputation of the institution where you pursue your engineering degree can have a significant impact on your career. Accredited institutions with strong industry connections and a history of successful alumni are often preferred by employers. It’s advisable to choose a college or university that is recognized for excellence in the specific engineering discipline you wish to pursue.</p><h3><strong>Top Engineering Courses After 12th</strong></h3><p><strong>Computer Science Engineering (CSE)</strong></p><h5><strong>Why Choose CSE?</strong></h5><p>Computer Science Engineering is one of the most popular and rapidly growing fields in engineering. With the advent of the digital age, the demand for skilled computer engineers has skyrocketed, making CSE an attractive option for tech-savvy students.</p><h5><strong>Key Subjects Covered</strong></h5><p>In CSE, you’ll delve into subjects like programming languages, data structures, algorithms, computer networks, and artificial intelligence. The curriculum is designed to equip students with the knowledge and skills required to develop software, manage data, and solve complex computational problems.</p><h5><strong>Career Opportunities in CSE</strong></h5><p>Graduates of CSE have a wide array of career options, including roles like software developer, data scientist, systems analyst, and cybersecurity expert. The IT industry, in particular, offers lucrative job opportunities and the potential for rapid career growth.</p><h4><strong>Mechanical Engineering</strong></h4><p><strong>Why Choose Mechanical Engineering?</strong></p><p>Mechanical Engineering is one of the oldest and broadest engineering disciplines. It is ideal for students who are interested in designing and manufacturing machinery, from small components to large industrial systems.</p><h5><strong>Core Topics and Skills</strong></h5><p>Key subjects in Mechanical Engineering include thermodynamics, fluid mechanics, material science, and robotics. The course emphasizes both theoretical and practical knowledge, with a focus on design, analysis, and the manufacturing process.</p><h5><strong>Career Prospects in Mechanical Engineering</strong></h5><p>Mechanical engineers are in demand across various industries such as automotive, aerospace, energy, and manufacturing. They can work as design engineers, project managers, or even as consultants in their field of expertise.</p><h4><strong>Civil Engineering</strong></h4><p><strong>Why Choose Civil Engineering?</strong></p><p>If you have a passion for designing and building infrastructure, Civil Engineering might be the right choice for you. This field focuses on the construction and maintenance of physical and natural environments, including roads, bridges, buildings, and water supply systems.</p><h5><strong>Subjects and Skills in Civil Engineering</strong></h5><p>Civil Engineering covers topics such as structural engineering, geotechnics, environmental engineering, and transportation engineering. The course is heavily project-based, often involving real-world problem-solving and design challenges.</p><h5><strong>Career Paths in Civil Engineering</strong></h5><p>Civil engineers are essential in both the public and private sectors. They can work as construction managers, structural engineers, or environmental consultants, contributing to the development and maintenance of vital infrastructure.</p><h4><strong>Electrical Engineering</strong></h4><p>Electrical Engineering is perfect for students interested in electrical systems, circuits, and electronics. It is a versatile field that plays a critical role in various industries, from power generation to telecommunications.</p><h5><strong>Important Topics Covered</strong></h5><p>The curriculum includes subjects like circuit analysis, electromagnetism, control systems, and signal processing. Students also gain practical experience through lab work and projects involving the design and testing of electrical systems.</p><h5><strong>Job Opportunities in Electrical Engineering</strong></h5><p>Electrical engineers have diverse career opportunities in sectors such as energy, electronics, telecommunications, and automation. They can work in roles like electrical design engineer, power systems engineer, or instrumentation engineer.</p><h4><strong>Electronics and Communication Engineering (ECE)</strong></h4><p>Electronics and Communication Engineering is a dynamic field that combines electronics with communication technologies. It is particularly appealing to those interested in developing new technologies and improving communication systems.</p><h5><strong>Core Subjects in ECE</strong></h5><p>Key areas of study in ECE include analog and digital communication, microprocessors, signal processing, and embedded systems. The course also emphasizes innovation and the application of electronics in real-world scenarios.</p><h5><strong>Career Opportunities in ECE</strong></h5><p>ECE graduates can pursue careers in various industries, including telecommunications, consumer electronics, and information technology. Common job roles include communication engineer, network analyst, and embedded systems engineer.</p><h4><strong>Chemical Engineering</strong></h4><p>Chemical Engineering is a specialized field that merges the principles of chemistry, physics, and biology with engineering. It is ideal for students who enjoy working on processes that convert raw materials into valuable products.</p><h5><strong>Key Areas of Study</strong></h5><p>The curriculum covers thermodynamics, process engineering, chemical reaction engineering, and materials science. Students are trained to design and optimize chemical processes in industries such as pharmaceuticals, petrochemicals, and food processing.</p><h5><strong>Career Prospects in Chemical Engineering</strong></h5><p>Chemical engineers are in demand in industries that require large-scale production processes. They can work as process engineers, production managers, or research and development scientists.</p><h4><strong>Aerospace Engineering</strong></h4><p>Aerospace Engineering is a challenging and exciting field that involves the design, development, and testing of aircraft and spacecraft. It is suited for students with a strong interest in aerodynamics,</p>	2024-08-13 06:57:51.870884	1	2024-08-15 13:17:33	Feature		Active	Best-Engineering-Courses-After-12th-for-a-Successful-Career-	{}	{"<h2><strong>What to Consider When Choosing an Engineering Courses</strong></h2>"}	{"<h3><strong>Top Engineering Courses After 12th</strong></h3>"}	{"<h4><strong>Market Demand and Future Prospects</strong></h4>","<h4><strong>Course Curriculum and Specialization</strong></h4>","<h4><strong>Accreditation and Reputation of Institutions</strong></h4>","<h4><strong>Mechanical Engineering</strong></h4>","<h4><strong>Civil Engineering</strong></h4>","<h4><strong>Electrical Engineering</strong></h4>","<h4><strong>Electronics and Communication Engineering (ECE)</strong></h4>","<h4><strong>Chemical Engineering</strong></h4>","<h4><strong>Aerospace Engineering</strong></h4>"}	{"<h5><strong>Why Choose CSE?</strong></h5>","<h5><strong>Key Subjects Covered</strong></h5>","<h5><strong>Career Opportunities in CSE</strong></h5>","<h5><strong>Core Topics and Skills</strong></h5>","<h5><strong>Career Prospects in Mechanical Engineering</strong></h5>","<h5><strong>Subjects and Skills in Civil Engineering</strong></h5>","<h5><strong>Career Paths in Civil Engineering</strong></h5>","<h5><strong>Important Topics Covered</strong></h5>","<h5><strong>Job Opportunities in Electrical Engineering</strong></h5>","<h5><strong>Core Subjects in ECE</strong></h5>","<h5><strong>Career Opportunities in ECE</strong></h5>","<h5><strong>Key Areas of Study</strong></h5>","<h5><strong>Career Prospects in Chemical Engineering</strong></h5>"}	Left
1	Top Science Courses After 12th Classes	Top Science Courses After 12th: Launch Your Science Career	Discover the best science courses to pursue after 12th class. Explore top universities, career paths, and job opportunities in various science fields. Make informed decisions for your future.	\N			2_1_3cb521f7b1.webp	<h2><strong>Introduction</strong></h2><p>Choosing the right course after completing the 12th grade is a crucial decision that can significantly impact your future. For students in the science stream, the options are vast and varied, ranging from traditional medical and engineering courses to emerging fields in pure and applied sciences. This guide aims to help you navigate through the top science courses available after the 12th class, providing detailed insights into each option.</p><p><strong>Medical Courses</strong></p><p><strong>MBBS (Bachelor of Medicine, Bachelor of Surgery)</strong></p><p>The MBBS is one of the most sought-after courses for students aspiring to become doctors. It is a comprehensive program that covers various aspects of medicine, surgery, and healthcare. The course duration is typically five and a half years, including a one-year internship.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as doctors in hospitals, start their private practice, or pursue higher studies in specialized fields like cardiology, neurology, etc.</li></ul><p><strong>BDS (Bachelor of Dental Surgery)</strong></p><p>BDS is the premier course for students interested in dentistry. The duration is five years, including an internship, and covers subjects like dental anatomy, oral pathology, and orthodontics.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as dentists in hospitals, clinics, or start their dental practice. They can also specialize further in fields like orthodontics or periodontics.</li></ul><p><strong>BAMS (Bachelor of Ayurvedic Medicine and Surgery)</strong></p><p>For those interested in alternative medicine, BAMS offers an in-depth study of Ayurveda. The course lasts for five and a half years, including an internship, and focuses on Ayurvedic principles, surgery, and modern anatomy.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as Ayurvedic practitioners, start their practice, or work in Ayurvedic hospitals and wellness centers.</li></ul><p><strong>BHMS (Bachelor of Homeopathic Medicine and Surgery)</strong></p><p>BHMS is tailored for students inclined towards homeopathy. This five and a half-year course, including an internship, covers subjects like homeopathic pharmacy, materia medica, and homeopathic therapeutics.</p><ul><li><strong>Career Opportunities</strong>: Graduates can practice as homeopathic doctors, start their practice, or work in homeopathic hospitals and clinics.</li></ul><p><strong>BPT (Bachelor of Physiotherapy)</strong></p><p>BPT is a four and a half-year program, including an internship, that focuses on the physical rehabilitation of patients. Subjects include anatomy, physiology, and therapeutic exercises.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as physiotherapists in hospitals, sports teams, rehabilitation centers, or start their practice.</li></ul><p><strong>Engineering Courses</strong></p><p><strong>B.Tech (Bachelor of Technology)</strong></p><p>B.Tech is a four-year program offering various specializations such as Computer Science, Mechanical, Civil, Electrical, and more. The course combines theoretical knowledge with practical skills.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in various industries, join research and development teams, or pursue higher studies like M.Tech or MBA.</li></ul><p><strong>B.E. (Bachelor of Engineering)</strong></p><p>B.E. is similar to B.Tech but with slight variations in curriculum and focus. It also offers specializations in different engineering fields.</p><ul><li><strong>Differences from B.Tech</strong>: B.E. often has a more theoretical approach compared to the practical focus of B.Tech.</li><li><strong>Career Opportunities</strong>: Similar to B.Tech, graduates can work in diverse engineering roles, research, or further studies.</li></ul><p><strong>Pure Science Courses</strong></p><p><strong>B.Sc. (Bachelor of Science)</strong></p><p>B.Sc. is a three-year undergraduate program with specializations in subjects like Physics, Chemistry, Biology, Mathematics, and more.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in research, education, technical roles, or pursue higher studies like M.Sc. or Ph.D.</li></ul><p><strong>B.Sc. (Hons)</strong></p><p>B.Sc. (Hons) offers a more in-depth study of a particular subject compared to a general B.Sc. It is ideal for students aiming for research or academic careers.</p><ul><li><strong>Differences from General B.Sc.</strong>: B.Sc. (Hons) has a more focused and rigorous curriculum.</li><li><strong>Career Opportunities</strong>: Graduates can pursue research, academic roles, or specialized professional roles in their field of study.</li></ul><p><strong>Applied Science Courses</strong></p><p><strong>B.Sc. in Biotechnology</strong></p><p>Biotechnology combines biology with technology to develop products and processes for various industries. This three-year course covers genetics, biochemistry, and molecular biology.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in pharmaceuticals, healthcare, agriculture, or research labs.</li></ul><p><strong>B.Sc. in Microbiology</strong></p><p>Microbiology focuses on the study of microorganisms and their impact on humans, animals, plants, and the environment. The course duration is three years.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in healthcare, environmental agencies, food and beverage industries, or research institutions.</li></ul><p><strong>B.Sc. in Environmental Science</strong></p><p>This course deals with the study of the environment and solutions to environmental problems. It covers ecology, pollution control, and conservation.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in environmental protection agencies, NGOs, research, or consultancy firms.</li></ul><p><strong>Allied Health Science Courses</strong></p><p><strong>B.Sc. Nursing</strong></p><p>B.Sc. Nursing is a four-year program that prepares students for careers in nursing and healthcare. It includes subjects like anatomy, physiology, and patient care.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as registered nurses in hospitals, clinics, or community health organizations.</li></ul><p><strong>B.Sc. in Radiology</strong></p><p>This course focuses on imaging techniques like X-rays, MRI, and CT scans used in medical diagnosis. The duration is typically three years.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work as radiologists in hospitals, diagnostic centers, or clinics.</li></ul><p><strong>B.Sc. in Medical Laboratory Technology</strong></p><p>This three-year program trains students to perform clinical laboratory tests that aid in the diagnosis, treatment, and prevention of diseases.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in hospitals, diagnostic labs, research centers, or pharmaceutical companies.</li></ul><p><strong>Agricultural Science Courses</strong></p><p><strong>B.Sc. Agriculture</strong></p><p>This four-year course covers various aspects of agriculture, including crop production, soil science, and agribusiness management.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in agricultural research, farm management, agribusiness firms, or government agencies.</li></ul><p><strong>B.Sc. Horticulture</strong></p><p>Horticulture focuses on the cultivation of plants, fruits, vegetables, and flowers. The course duration is typically four years.</p><ul><li><strong>Career Opportunities</strong>: Graduates can work in horticulture farms, landscaping companies, or agricultural research institutions.</li></ul><p><strong>Pharmacy Courses</strong></p><p><strong>B.Pharm (Bachelor of Pharmacy)</strong></p><p>B.Pharm is a four-year program that prepares students for careers in pharmacy. It covers subjects like</p>	2024-08-08 09:51:48.4994	1	2024-08-09 15:56:59	Feature	TOC	Active	Top-Science-Courses-After-12th-Class.-	{}	{<h2><strong>Introduction</strong></h2>}	{}	{}	{}	Left
4	Best Diploma Courses After 12th to Boost Your Career	Best Diploma Courses After 12th: Career-Oriented Options	Discover top diploma courses to kickstart your career after 12th. Explore high-demand fields, job prospects, and skill development. Find the perfect program to achieve your career goals.	\N			diploma-courses-after-12th.webp	<div class="flex max-w-full flex-col flex-grow"><div data-message-author-role="assistant" data-message-id="6a3194de-e426-4300-9198-e867b9cae1dd" dir="auto" class="min-h-[20px] text-message flex w-full flex-col items-end gap-2 break-words [.text-message+&amp;]:mt-5 overflow-x-auto whitespace-normal"><div class="flex w-full flex-col gap-1 empty:hidden first:pt-[3px]"><div class="markdown prose w-full break-words dark:prose-invert light"><p>Choosing the right diploma course after 12th grade can significantly impact your career trajectory. Diplomas are short-term, specialized courses that provide practical knowledge and skills, making them an attractive option for students looking to enter the workforce quickly. Here’s a comprehensive guide to the best diploma courses you can pursue after completing your 12th grade to give your career a strong start.</p><h2>1. <strong>Diploma in Engineering</strong></h2><p><strong>Overview:</strong> This diploma is ideal for students who have completed their 12th grade with a science background. It offers specializations in various branches such as Mechanical, Electrical, Civil, and Computer Engineering.</p><p><strong>Eligibility:</strong> 12th pass with Physics, Chemistry, and Mathematics.</p><p><strong>Duration:</strong> 3 years.</p><p><strong>Career Prospects:</strong> Diploma holders can find employment as junior engineers, technicians, or assistants in various industries. Many students also opt for lateral entry into the second year of B.Tech programs.</p><h4>2. <strong>Diploma in Computer Science</strong></h4><p><strong>Overview:</strong> A diploma in Computer Science equips students with foundational knowledge in programming, database management, web development, and cybersecurity.</p><p><strong>Eligibility:</strong> 12th pass with Mathematics or Computer Science as a subject.</p><p><strong>Duration:</strong> 2-3 years.</p><p><strong>Career Prospects:</strong> Graduates can work as software developers, IT support technicians, web designers, or network administrators. With the growing demand for IT professionals, this diploma offers numerous job opportunities.</p><h4>3. <strong>Diploma in Fashion Designing</strong></h4><p><strong>Overview:</strong> This course is perfect for creative individuals who are passionate about fashion and design. It covers various aspects of fashion, including textile design, garment construction, and fashion marketing.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 1-2 years.</p><p><strong>Career Prospects:</strong> Graduates can work as fashion designers, stylists, merchandisers, or start their own fashion line. The fashion industry offers exciting opportunities for those with the right skills and creativity.</p><h4>4. <strong>Diploma in Digital Marketing</strong></h4><p><strong>Overview:</strong> Digital Marketing is a booming field, and a diploma in this area provides students with the skills to succeed in online marketing, including SEO, social media marketing, content marketing, and email marketing.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 6 months to 1 year.</p><p><strong>Career Prospects:</strong> With the digital landscape constantly evolving, digital marketing professionals are in high demand. Graduates can work as digital marketers, SEO specialists, content creators, or social media managers.</p><h4>5. <strong>Diploma in Hotel Management</strong></h4><p><strong>Overview:</strong> The hospitality industry is one of the largest and fastest-growing sectors globally. A diploma in Hotel Management prepares students for various roles in hotels, resorts, cruise ships, and other hospitality establishments.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 1-2 years.</p><p><strong>Career Prospects:</strong> Graduates can work as hotel managers, front office executives, event managers, or chefs. The hospitality industry offers numerous opportunities for growth and international exposure.</p><h4>6. <strong>Diploma in Graphic Designing</strong></h4><p><strong>Overview:</strong> This course is ideal for students interested in visual communication and design. It covers topics like typography, digital illustration, web design, and multimedia production.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 1-2 years.</p><p><strong>Career Prospects:</strong> Graduates can pursue careers as graphic designers, UI/UX designers, animators, or work in advertising agencies, media houses, or freelance.</p><h4>7. <strong>Diploma in Nursing</strong></h4><p><strong>Overview:</strong> A diploma in Nursing is a gateway to the healthcare industry. It trains students to assist doctors, manage patients, and provide basic medical care.</p><p><strong>Eligibility:</strong> 12th pass with Biology, Chemistry, and Physics.</p><p><strong>Duration:</strong> 3 years.</p><p><strong>Career Prospects:</strong> Nursing graduates are in high demand in hospitals, clinics, and healthcare centers. They can work as staff nurses, healthcare assistants, or pursue further studies in specialized nursing fields.</p><h4>8. <strong>Diploma in Aviation</strong></h4><p><strong>Overview:</strong> The aviation industry offers exciting career opportunities, and a diploma in Aviation covers aspects like airport management, ground handling, and ticketing.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 6 months to 1 year.</p><p><strong>Career Prospects:</strong> Graduates can work as ground staff, cabin crew, or airport managers. The aviation industry is known for offering attractive salaries and benefits.</p><h4>9. <strong>Diploma in Pharmacy</strong></h4><p><strong>Overview:</strong> This diploma provides students with the knowledge required to work as pharmacists, focusing on the preparation and dispensation of medicines.</p><p><strong>Eligibility:</strong> 12th pass with Physics, Chemistry, and Biology/Mathematics.</p><p><strong>Duration:</strong> 2 years.</p><p><strong>Career Prospects:</strong> Graduates can work as pharmacists in hospitals, retail pharmacies, or pharmaceutical companies. They can also open their own pharmacy stores.</p><h4>10. <strong>Diploma in Early Childhood Education</strong></h4><p><strong>Overview:</strong> For those interested in teaching and working with young children, a diploma in Early Childhood Education is an excellent choice. It covers child psychology, teaching methods, and curriculum planning.</p><p><strong>Eligibility:</strong> 12th pass in any stream.</p><p><strong>Duration:</strong> 1-2 years.</p><p><strong>Career Prospects:</strong> Graduates can work as preschool teachers, daycare center coordinators, or start their own childcare centers.</p><h3>Conclusion</h3><p>Diploma courses after 12th provide a quick and efficient way to gain specialized knowledge and skills, leading to various career opportunities. Whether you are interested in engineering, healthcare, design, or hospitality, there is a diploma course tailored to your interests and career goals. With the right choice, a diploma can be the stepping stone to a successful and fulfilling career.</p></div></div></div></div><div class="mt-1 flex gap-3 empty:hidden -ml-2"><div class="items-center justify-start rounded-xl p-1 flex"><div class="flex items-center"><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Read Aloud"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" fill-rule="evenodd" d="M11 4.91a.5.5 0 0 0-.838-.369L6.676 7.737A1 1 0 0 1 6 8H4a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2a1 1 0 0 1 .676.263l3.486 3.196A.5.5 0 0 0 11 19.09zM8.81 3.067C10.415 1.597 13 2.735 13 4.91v14.18c0 2.175-2.586 3.313-4.19 1.843L5.612 18H4a3 3 0 0 1-3-3V9a3 3 0 0 1 3-3h1.611zm11.507 3.29a1 1 0 0 1 1.355.401A10.96 10.96 0 0 1 23 12c0 1.85-.458 3.597-1.268 5.13a1 1 0 1 1-1.768-.934A8.96 8.96 0 0 0 21 12a8.96 8.96 0 0 0-1.085-4.287 1 1 0 0 1 .402-1.356M15.799 7.9a1 1 0 0 1 1.4.2 6.48 6.48 0 0 1 1.3 3.9c0 1.313-.39 2.537-1.06 3.56a1 1 0 0 1-1.673-1.096A4.47 4.47 0 0 0 16.5 12a4.47 4.47 0 0 0-.9-2.7 1 1 0 0 1 .2-1.4" clip-rule="evenodd"></path></svg></span></button></span><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Copy"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" fill-rule="evenodd" d="M7 5a3 3 0 0 1 3-3h9a3 3 0 0 1 3 3v9a3 3 0 0 1-3 3h-2v2a3 3 0 0 1-3 3H5a3 3 0 0 1-3-3v-9a3 3 0 0 1 3-3h2zm2 2h5a3 3 0 0 1 3 3v5h2a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1h-9a1 1 0 0 0-1 1zM5 9a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1h9a1 1 0 0 0 1-1v-9a1 1 0 0 0-1-1z" clip-rule="evenodd"></path></svg></span></button></span><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Regenerate"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" d="M3.07 10.876C3.623 6.436 7.41 3 12 3a9.15 9.15 0 0 1 6.012 2.254V4a1 1 0 1 1 2 0v4a1 1 0 0 1-1 1H15a1 1 0 1 1 0-2h1.957A7.15 7.15 0 0 0 12 5a7 7 0 0 0-6.946 6.124 1 1 0 1 1-1.984-.248m16.992 1.132a1 1 0 0 1 .868 1.116C20.377 17.564 16.59 21 12 21a9.15 9.15 0 0 1-6-2.244V20a1 1 0 1 1-2 0v-4a1 1 0 0 1 1-1h4a1 1 0 1 1 0 2H7.043A7.15 7.15 0 0 0 12 19a7 7 0 0 0 6.946-6.124 1 1 0 0 1 1.116-.868"></path></svg></span></button></span></div></div></div>	2024-08-09 09:22:31.822983	1	2024-08-26 09:18:57	Feature		Active	Top-Government-Jobs-After-12th-Class-You-Can-Apply-For-	{}	{"<h2>1. <strong>Diploma in Engineering</strong></h2>"}	{<h3>Conclusion</h3>}	{"<h4>2. <strong>Diploma in Computer Science</strong></h4>","<h4>3. <strong>Diploma in Fashion Designing</strong></h4>","<h4>4. <strong>Diploma in Digital Marketing</strong></h4>","<h4>5. <strong>Diploma in Hotel Management</strong></h4>","<h4>6. <strong>Diploma in Graphic Designing</strong></h4>","<h4>7. <strong>Diploma in Nursing</strong></h4>","<h4>8. <strong>Diploma in Aviation</strong></h4>","<h4>9. <strong>Diploma in Pharmacy</strong></h4>","<h4>10. <strong>Diploma in Early Childhood Education</strong></h4>"}	{}	Left
13	Top B.A. Courses After 12th Arts You Should Explore	Best BA Courses After 12th Arts: Find Your Perfect Degree	Explore top BA courses after 12th Arts. Discover your passion, career paths, and top colleges. Find the best BA program to shape your future.	\N			Best-Courses-After-12th-for-Arts-Stream-Students1.jpg.webp	<div class="react-scroll-to-bottom--css-lplex-1n7m0yu"><div class="flex flex-col text-sm"><article class="w-full text-token-text-primary focus-visible:outline-2 focus-visible:outline-offset-[-4px] sm:AIPRM__conversation__response" tabindex="0" dir="auto" data-testid="conversation-turn-5" data-scroll-anchor="true"><div class="text-base py-[18px] px-3 md:px-4 m-auto md:px-5 lg:px-1 xl:px-5"><div class="mx-auto flex flex-1 gap-4 text-base md:gap-5 lg:gap-6 md:max-w-3xl lg:max-w-[40rem] xl:max-w-[48rem]"><div class="group/conversation-turn relative flex w-full min-w-0 flex-col agent-turn"><div class="flex-col gap-1 md:gap-3"><div class="flex max-w-full flex-col flex-grow AIPRM__conversation__response"><div data-message-author-role="assistant" data-message-id="36da74f3-debf-4852-9bea-fe5b561adc42" dir="auto" class="min-h-[20px] text-message flex w-full flex-col items-end gap-2 whitespace-pre-wrap break-words [.text-message+&amp;]:mt-5 overflow-x-auto"><div class="flex w-full flex-col gap-1 empty:hidden first:pt-[3px]"><div class="markdown prose w-full break-words dark:prose-invert light"><p>Choosing right Bachelor of Arts (B.A.) course after completing 12th grade can be a pivotal decision that shapes your future career. The Arts stream offers a diverse range of subjects and career opportunities, allowing students to pursue their passion in fields such as literature, history, political science, and more. This guide explores the top B.A. courses you can consider after 12th Arts, helping you make an informed choice that aligns with your interests and career goals.</p><h2><strong>Factors to Consider When Choosing a B.A. Course</strong></h2><p>Your personal interests and passion should be the primary factor when selecting a B.A. course. Are you drawn to literature, fascinated by historical events, or curious about human behavior? Identifying what excites you will help ensure that you enjoy your studies and are motivated to excel.</p><h4><strong>Career Goals and Opportunities</strong></h4><p>It’s important to consider the career prospects associated with each B.A. course. While some fields may offer immediate job opportunities, others might require further studies or specialization. Researching the job market and understanding the potential career paths can help you choose a course that aligns with your long-term goals.</p><h4><strong>Course Curriculum and Specialization</strong></h4><p>Each B.A. course has its own set of core subjects and areas of specialization. Understanding the curriculum and the skills you will acquire during the course is essential. Some courses might offer opportunities for practical experience, internships, or research projects, which can be valuable for your career development.</p><h4><strong>College Reputation and Accreditation</strong></h4><p>The reputation and accreditation of the college or university where you pursue your B.A. degree can significantly impact your education and future job prospects. It’s advisable to choose institutions known for excellence in your chosen field, with a strong faculty and a track record of successful alumni.</p><h3><strong>Top B.A. Courses After 12th Arts</strong></h3><h4><strong>B.A. in English Literature</strong></h4><p>A B.A. in English Literature is ideal for students who love reading and analyzing texts, exploring different genres, and appreciating literary works. This course develops critical thinking, communication skills, and a deep understanding of language and culture.</p><h5><strong>Core Subjects Covered</strong></h5><p>The curriculum typically includes the study of poetry, drama, prose, and literary theory. Students may also explore contemporary literature, world literature, and the works of renowned authors such as Shakespeare, Dickens, and Austen.</p><h5><strong>Career Opportunities in English Literature</strong></h5><p>Graduates can pursue careers in writing, editing, teaching, content creation, and publishing. Additionally, they may work in media, advertising, and public relations, where strong communication skills are highly valued.</p><h4><strong>B.A. in History</strong></h4><p>If you are passionate about understanding the past and its impact on the present, a B.A. in History could be the perfect choice. This course offers insights into various historical periods, events, and movements that have shaped the world.</p><h5><strong>Key Areas of Study</strong></h5><p>The curriculum covers ancient, medieval, and modern history, along with the study of specific regions such as India, Europe, and Asia. Students also learn about historiography, archaeology, and the interpretation of historical sources.</p><h5><strong>Career Paths in History</strong></h5><p>History graduates can work as historians, archivists, museum curators, or educators. They may also find opportunities in research, cultural heritage management, and government services.</p><h4><strong>B.A. in Political Science</strong></h4><p>A B.A. in Political Science is suitable for students interested in politics, governance, and international relations. This course provides a deep understanding of political systems, theories, and institutions.</p><h5><strong>Important Topics Covered</strong></h5><p>Key subjects include political theory, comparative politics, international relations, public administration, and policy analysis. Students may also study political thought, human rights, and global issues.</p><h5><strong>Career Prospects in Political Science</strong></h5><p>Political Science graduates can pursue careers in government, public administration, law, journalism, and international organizations. They may also work as political analysts, policy advisors, or diplomats.</p><h4><strong>B.A. in Psychology</strong></h4><p>For those fascinated by the human mind and behavior, a B.A. in Psychology offers an in-depth study of mental processes, emotions, and social interactions. This course is ideal for students who want to understand and help others through psychological principles.</p><h5><strong>Core Subjects in Psychology</strong></h5><p>The curriculum covers cognitive psychology, developmental psychology, abnormal psychology, social psychology, and research methods. Students also learn about counseling techniques and psychological assessment.</p><h5><strong>Job Opportunities in Psychology</strong></h5><p>Graduates can work as counselors, therapists, human resource professionals, or in research roles. Further specialization can lead to careers in clinical psychology, forensic psychology, or organizational psychology.</p><h4><strong>B.A. in Sociology</strong></h4><p>A B.A. in Sociology is ideal for students interested in understanding social behavior, cultural norms, and societal changes. This course explores the structure and dynamics of societies and social institutions.</p><h5><strong>Key Subjects and Concepts</strong></h5><p>The curriculum includes the study of social theory, social research, cultural studies, gender studies, and urban sociology. Students also examine issues such as inequality, globalization, and social change.</p><h5><strong>Career Options in Sociology</strong></h5><p>Sociology graduates can pursue careers in social research, community development, public policy, and social work. They may also work in education, market research, and human services.</p><h4><strong>B.A. in Economics</strong></h4><p>A B.A. in Economics is perfect for students who are curious about how economies function, how resources are allocated, and how financial systems operate. This course provides a strong foundation in economic theory and quantitative analysis.</p><h5><strong>Core Areas of Study</strong></h5><p>The curriculum covers microeconomics, macroeconomics, econometrics, public finance, and international economics. Students learn to analyze economic data, understand market dynamics, and evaluate economic policies.</p><h5><strong>Career Prospects in Economics</strong></h5><p>Economics graduates have a wide range of career options, including roles in finance, banking, consulting, government, and international organizations.</p></div></div></div></div></div></div></div></div></article></div><div class="AIPRM__invert dark:AIPRM__filter-none AIPRM__sidebar-icon AIPRM__w-12 AIPRM__h-12"><br></div><br></div>	2024-08-13 07:01:52.47534	1	2024-08-09 15:56:59	Feature	TOC	Active	Top-B-A-Courses-After-12th-Arts-You-Should-Explore-	{}	{"<h2><strong>Factors to Consider When Choosing a B.A. Course</strong></h2>"}	{"<h3><strong>Top B.A. Courses After 12th Arts</strong></h3>"}	{"<h4><strong>Career Goals and Opportunities</strong></h4>","<h4><strong>Course Curriculum and Specialization</strong></h4>","<h4><strong>College Reputation and Accreditation</strong></h4>","<h4><strong>B.A. in English Literature</strong></h4>","<h4><strong>B.A. in History</strong></h4>","<h4><strong>B.A. in Political Science</strong></h4>","<h4><strong>B.A. in Psychology</strong></h4>","<h4><strong>B.A. in Sociology</strong></h4>","<h4><strong>B.A. in Economics</strong></h4>"}	{"<h5><strong>Core Subjects Covered</strong></h5>","<h5><strong>Career Opportunities in English Literature</strong></h5>","<h5><strong>Key Areas of Study</strong></h5>","<h5><strong>Career Paths in History</strong></h5>","<h5><strong>Important Topics Covered</strong></h5>","<h5><strong>Career Prospects in Political Science</strong></h5>","<h5><strong>Core Subjects in Psychology</strong></h5>","<h5><strong>Job Opportunities in Psychology</strong></h5>","<h5><strong>Key Subjects and Concepts</strong></h5>","<h5><strong>Career Options in Sociology</strong></h5>","<h5><strong>Core Areas of Study</strong></h5>","<h5><strong>Career Prospects in Economics</strong></h5>"}	Left
29	Anu	rag	hjdsljfja	grsgs			1488259134phpShnPJa.jpeg	<h1><span style="background-color: rgb(255, 0, 0);">bgfdef jdsanfkankjfnenfkjhewrh</span></h1><p><br></p><table data-sourcepos="7:1-11:18"><tbody><tr data-sourcepos="7:1-7:17"><th data-sourcepos="7:1-7:7">Fruit</th><th data-sourcepos="7:9-7:15">Color</th></tr><tr data-sourcepos="9:1-9:15"><td data-sourcepos="9:1-9:7">Apple</td><td data-sourcepos="9:9-9:13" style="text-align: justify;">Red</td></tr><tr data-sourcepos="10:1-10:19"><td data-sourcepos="10:1-10:8">Banana</td><td data-sourcepos="10:10-10:17">Yellow</td></tr><tr data-sourcepos="11:1-11:18"><td data-sourcepos="11:1-11:7">Grape</td><td data-sourcepos="11:9-11:16">Purple</td></tr></tbody></table><p>fnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj This is Ibrahim Memon</p><p><br></p><p>vdvsafefagfvdgerwtrevdvdsgwtre</p><p>gnfdhrsgrdvsdvgfds</p><p>fddsbvdsgsgesrfgs</p><p>mvjfgdnfshtrhsdhfb</p><p>mgntrshf bsrgrsdgvfcv&nbsp; evgdgfvsaf</p><p>grdghrehtrdhd jh jhg jkghk jkjkh jk</p>	2024-09-13 12:04:02.07438	\N	2024-09-12 18:47:03	\N	\N	\N	\N	{"<h1><span style=\\"background-color: rgb(255, 0, 0);\\">bgfdef jdsanfkankjfnenfkjhewrh</span></h1>"}	{}	{}	{}	{}	Left
14	Best B.Com. Courses After 12th Commerce for a Bright Future	Top B.Com. Accounting & Finance Courses After 12th - Secure Your Financial Future!	Unleash your entrepreneurial spirit! Discover B.Com. courses for aspiring entrepreneurs. Learn about program details, skills gained, and college options.	\N			download.jfif	<p>After completing your 12th grade in Commerce, choosing the right Bachelor of Commerce (B.Com.) course is crucial for setting the foundation for a successful career in the business world. B.Com. is a versatile degree that offers a strong grounding in commerce, finance, accounting, and related disciplines, making it one of the most popular choices among students. This guide will explore the best B.Com. courses available after 12th Commerce, helping you make an informed decision that aligns with your career goals. by anurag</p><h2><strong>Why Choose B.Com. After 12th Commerce?</strong></h2><p>A B.Com. degree provides a comprehensive understanding of various aspects of commerce, including accounting, finance, economics, and business law. This strong foundation is essential for anyone looking to build a career in business or finance, as it equips you with the necessary knowledge and skills to excel in these fields.</p><h4><strong>Versatility and Wide Range of Career Options</strong></h4><p>One of the key advantages of pursuing a B.Com. degree is its versatility. Graduates can explore a wide range of career options, including roles in accounting, finance, banking, insurance, and even entrepreneurship. This flexibility makes B.Com. a smart choice for students who want to keep their career options open.</p><h4><strong>Preparation for Professional Courses and Certifications</strong></h4><p>A B.Com. degree also serves as a stepping stone for further professional courses and certifications, such as Chartered Accountancy (CA), Company Secretary (CS), Cost and Management Accountancy (CMA), and Certified Financial Planner (CFP). These certifications can significantly enhance your career prospects and earning potential.</p><h3><strong>Top B.Com. Courses After 12th Commerce</strong></h3><p>B.Com. General is a broad-based course that covers a wide range of subjects related to commerce, including accounting, finance, economics, and business management. It is designed to provide students with a solid understanding of the fundamental concepts of commerce and business.</p><h5><strong>Key Subjects Covered</strong></h5><p>The curriculum typically includes subjects such as financial accounting, business law, economics, corporate finance, marketing, and management principles. This well-rounded approach ensures that students gain a comprehensive understanding of various aspects of commerce.</p><h5><strong>Career Opportunities with B.Com. General</strong></h5><p>Graduates with a B.Com. General degree can pursue careers in accounting, finance, banking, and management. They can also work in roles such as financial analysts, business consultants, or sales and marketing executives. The degree also provides a strong foundation for those looking to start their own businesses.</p><h4><strong>B.Com. (Honours)</strong></h4><p>B.Com. Honours is a more specialized and rigorous version of the B.Com. General course. It allows students to focus on specific areas of interest within commerce, such as accounting, finance, or economics, and often includes a more in-depth study of these subjects.</p><h5><strong>Specialized Subjects and Curriculum</strong></h5><p>The curriculum of B.Com. Honours is more advanced and may include subjects like advanced financial accounting, auditing, corporate law, business taxation, and financial management. This specialized focus makes it an ideal choice for students who have a clear interest in a particular area of commerce.</p><h5><strong>Career Prospects with B.Com. Honours</strong></h5><p>B.Com. Honours graduates are highly sought after by employers, particularly in fields such as accounting, finance, and investment banking. The degree also provides an excellent foundation for pursuing professional certifications like CA, CS, and CFA.</p><h4><strong>B.Com. in Accounting and Finance</strong></h4><p>B.Com. in Accounting and Finance is designed for students who want to build a career in accounting, financial management, and related fields. The course provides an in-depth understanding of financial accounting, auditing, taxation, and financial management.</p><h5><strong>Core Subjects in Accounting and Finance</strong></h5><p>The curriculum includes subjects such as cost accounting, financial reporting, corporate finance, auditing, and income tax. Students also learn about financial analysis, investment management, and risk assessment, which are critical skills in the financial sector.</p><h5><strong>Job Opportunities in Accounting and Finance</strong></h5><p>Graduates can pursue careers as accountants, financial analysts, auditors, tax consultants, and finance managers. The course also prepares students for professional exams such as CA, CPA, and ACCA, which can further enhance their career prospects.</p><h4><strong>B.Com. in Banking and Insurance</strong></h4><p>B.Com. in Banking and Insurance is ideal for students interested in the financial services industry, particularly in banking and insurance. The course provides specialized knowledge in banking operations, insurance practices, risk management, and financial regulations.</p><h5><strong>Important Topics Covered</strong></h5><p>The curriculum includes subjects such as banking law, insurance law, risk management, investment banking, and financial services. Students also learn about the regulatory environment governing banking and insurance sectors.</p><h5><strong>Career Paths in Banking and Insurance</strong></h5><p>Graduates can work in banks, insurance companies, investment firms, and other financial institutions. Common job roles include bank managers, insurance underwriters, risk analysts, and financial advisors. The course also provides a pathway to certifications such as Certified Financial Planner (CFP) and Chartered Financial Analyst (CFA).</p><h4><strong>B.Com. in Financial Markets</strong></h4><p>B.Com. in Financial Markets is focused on the functioning of financial markets, investment analysis, and portfolio management. It is ideal for students who are interested in stock markets, investments, and financial trading.</p><h5><strong>Key Areas of Study</strong></h5><p>The curriculum covers subjects such as financial derivatives, investment analysis, portfolio management, securities market operations, and financial risk management. Students also learn about the regulatory framework governing financial markets.</p><h5><strong>Career Opportunities in Financial Markets</strong></h5><p>Graduates can pursue careers as stockbrokers, investment bankers, portfolio managers, financial analysts, and market researchers. The course also provides the necessary knowledge for pursuing certifications like Chartered Financial Analyst (CFA) and Financial Risk Manager </p>	2024-08-13 07:18:49.877988	1	2024-09-24 12:06:53	Feature		Active	Best-B-Com-Courses-After-12th-Commerce-for-a-Bright-Future	{}	{"<h2><strong>Why Choose B.Com. After 12th Commerce?</strong></h2>"}	{"<h3><strong>Top B.Com. Courses After 12th Commerce</strong></h3>"}	{"<h4><strong>Versatility and Wide Range of Career Options</strong></h4>","<h4><strong>Preparation for Professional Courses and Certifications</strong></h4>","<h4><strong>B.Com. (Honours)</strong></h4>","<h4><strong>B.Com. in Accounting and Finance</strong></h4>","<h4><strong>B.Com. in Banking and Insurance</strong></h4>","<h4><strong>B.Com. in Financial Markets</strong></h4>"}	{"<h5><strong>Key Subjects Covered</strong></h5>","<h5><strong>Career Opportunities with B.Com. General</strong></h5>","<h5><strong>Specialized Subjects and Curriculum</strong></h5>","<h5><strong>Career Prospects with B.Com. Honours</strong></h5>","<h5><strong>Core Subjects in Accounting and Finance</strong></h5>","<h5><strong>Job Opportunities in Accounting and Finance</strong></h5>","<h5><strong>Important Topics Covered</strong></h5>","<h5><strong>Career Paths in Banking and Insurance</strong></h5>","<h5><strong>Key Areas of Study</strong></h5>","<h5><strong>Career Opportunities in Financial Markets</strong></h5>"}	Left
\.


--
-- TOC entry 4174 (class 0 OID 18544)
-- Dependencies: 353
-- Data for Name: blogactivity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.blogactivity (id, superuserid, content, differentcontent, role, blogid, added_date, previouscontent, previouscontentlength, newcontentlength) FROM stdin;
1	1	\N	goals. anuragWhy	Update	14	2024-09-04 10:38:39.583782	\N	\N	\N
2	1	\N	option. Undergraduate	Update	2	2024-09-06 05:23:09.095253	\N	\N	\N
3	2	{}	\N	Add	15	2024-09-06 05:33:16.991573	\N	\N	\N
4	2	\N	This is Ibrahim Memon	Update	15	2024-09-06 10:01:36.121968	\N	\N	\N
5	2	\N	Memonvdvsafefagfvdgerwtrevdvdsgwtregnfdhrsgrdvsdvgfdsfddsbvdsgsgesrfgs	Update	15	2024-09-13 11:59:24.974252	Memon	1	1
6	2	\N	Memonvdvsafefagfvdgerwtrevdvdsgwtregnfdhrsgrdvsdvgfdsfddsbvdsgsgesrfgsmvjfgdnfshtrhsdhfbmgntrshf bsrgrsdgvfcv  evgdgfvsafgrdghrehtrdhd	Update	15	2024-09-13 12:00:50.744896	Memonvdvsafefagfvdgerwtrevdvdsgwtregnfdhrsgrdvsdvgfdsfddsbvdsgsgesrfgs	1	3
7	2	{}	\N	Add	30	2024-09-13 12:06:24.288629	\N	\N	\N
8	2	\N	jh jhg jkghk jkjkh jk	Update	29	2024-09-13 12:07:24.109476		0	5
9	2	{}	\N	Add	38	2024-09-13 12:13:51.028825	\N	\N	\N
10	2	\N	dfg gfh gfh fghfgh fg hfgh hh	Update	43	2024-09-13 12:51:10.355143		0	7
11	1	\N	sdf sdf sdf sdf	Update	43	2024-09-13 12:54:24.022991		0	4
12	1	\N	jdsanfkankjfnenfkjhewrh sddfsdfsdfs sdf sdfsd fFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	Update	44	2024-09-13 12:59:26.223759	jdsanfkankjfnenfkjhewrhFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	1	5
13	1	\N	dfsdf sdfsd sdfsd sdfFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	Update	45	2024-09-13 13:00:16.561763	dfg sdf sdf sdf sdf gfh gfh fghfgh fg hfgh hh bgfdef jdsanfkankjfnenfkjhewrhFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	13	4
14	1	\N	gdfgdfg dfg gdf dfgFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	Update	44	2024-09-13 13:01:33.185838	bgfdef jdsanfkankjfnenfkjhewrh sddfsdfsdfs sdf sdfsd fFruitColorAppleRedBananaYellowGrapePurplefnesfhcfeshnfiuewhhfnjewqfdi8qhkdnoiwqhdkwnbd98csakjbfdioawbfkjbwpfywfj	6	4
15	1	{}	\N	Delete	45	2024-09-19 16:13:03.391966	\N	\N	\N
16	1	{}	\N	Delete	44	2024-09-19 16:13:09.410437	\N	\N	\N
17	1	{}	\N	Delete	43	2024-09-19 16:13:12.178962	\N	\N	\N
18	1	{}	\N	Delete	30	2024-09-21 16:00:37.475575	\N	\N	\N
19	1	\N	<p>Enter Content Heregdfgdfg</p>	Add	46	2024-09-22 08:50:34.203096	\N	\N	\N
20	1	{}	\N	Delete	46	2024-09-24 05:21:40.573725	\N	\N	\N
21	1	{}	\N	Delete	38	2024-09-24 05:21:43.221528	\N	\N	\N
22	1	{}	\N	Delete	28	2024-09-24 05:21:50.384662	\N	\N	\N
23	1	{}	\N	Delete	27	2024-09-24 05:22:10.539139	\N	\N	\N
24	1	{}	\N	Delete	15	2024-09-24 05:22:20.308745	\N	\N	\N
25	1	\N	goals.Why	Update	26	2024-09-24 09:03:55.799018	goals. anuragWhy	2	1
26	1	\N	<p>Test by Kishor&nbsp;Test by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by Kishor\\</p><p><br></p><h2>Test by Kishor</h2><p><br></p><p>Test by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by Kishor</p><p><br></p><h3>Test by Kishor</h3><p><br></p><p>xttruyguyf7fyy yvffffffffTest by Kishorygiuhi&nbsp;Test by KishorTest by Kishorv</p>	Add	47	2024-09-24 09:14:49.024187	\N	\N	\N
27	1	{}	\N	Delete	47	2024-09-24 09:15:51.535385	\N	\N	\N
28	1	{}	\N	Delete	26	2024-09-24 09:16:42.702352	\N	\N	\N
29	3	\N	<h2>ttrxgvh</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	Add	49	2024-09-24 09:25:19.479663	\N	\N	\N
30	3	\N	<h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	Add	51	2024-09-24 09:26:24.660623	\N	\N	\N
31	3	\N	<p>tyyuukkkkkkkkkkkkk</p><h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	Add	53	2024-09-24 09:27:28.96155	\N	\N	\N
32	1	{}	\N	Delete	53	2024-09-24 09:29:30.327002	\N	\N	\N
33	1	{}	\N	Delete	51	2024-09-24 09:29:43.356073	\N	\N	\N
34	1	{}	\N	Delete	49	2024-09-24 09:29:49.536459	\N	\N	\N
35	1	\N		Update	51	2024-09-24 09:42:15.921739		0	0
36	1	\N		Update	14	2024-09-24 11:26:29.445616		0	0
37	1	\N		Update	13	2024-09-24 11:26:51.139818		0	0
38	1	\N		Update	1	2024-09-24 11:30:03.398725		0	0
39	1	\N		Update	1	2024-09-24 11:32:11.718		0	0
40	1	\N		Update	1	2024-09-24 11:37:19.770917		0	0
41	1	\N		Update	1	2024-09-24 11:45:19.543141		0	0
42	1	\N		Update	1	2024-09-24 11:49:53.144852		0	0
43	1	\N		Update	14	2024-09-24 11:52:41.796337		0	0
44	1	\N		Update	14	2024-09-24 11:57:10.607245		0	0
45	1	\N		Update	14	2024-09-24 12:00:23.9999		0	0
46	1	\N		Update	14	2024-09-24 12:04:07.59333		0	0
47	1	\N		Update	14	2024-09-24 12:06:08.158434		0	0
48	1	\N		Update	14	2024-09-24 12:07:17.081617		0	0
\.


--
-- TOC entry 4066 (class 0 OID 16557)
-- Dependencies: 245
-- Data for Name: blogcomment; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.blogcomment (id, title, description, blogid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4163 (class 0 OID 18365)
-- Dependencies: 342
-- Data for Name: blogfaqs; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.blogfaqs (id, question, answer, added_by, added_date, blogid, last_modified) FROM stdin;
2	{}	{}	1	2024-08-13 06:57:51.889162	12	2024-08-15 13:17:33
3	{}	{}	1	2024-08-13 07:01:52.487129	13	2024-09-24 11:25:26
4	{}	{}	1	2024-08-13 07:18:49.888809	14	2024-09-24 12:06:53
\.


--
-- TOC entry 4069 (class 0 OID 16578)
-- Dependencies: 248
-- Data for Name: blogreview; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.blogreview (id, rating, detail, userid, blogid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4075 (class 0 OID 16661)
-- Dependencies: 254
-- Data for Name: book; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.book (id, specialization, subject, title, url, added_date, added_by, last_modified) FROM stdin;
\.


--
-- TOC entry 4077 (class 0 OID 16681)
-- Dependencies: 256
-- Data for Name: city; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.city (id, name, state, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Jhansi	1	1	2024-07-26 05:48:16.382408	\N	\N
\.


--
-- TOC entry 4079 (class 0 OID 16692)
-- Dependencies: 258
-- Data for Name: collegetype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.collegetype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Reguler	Active	1	2024-07-26 05:53:32.442195	\N	\N
\.


--
-- TOC entry 4081 (class 0 OID 16702)
-- Dependencies: 260
-- Data for Name: contactus; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.contactus (id, email, contactnumber, officeaddress, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
2	mail@imtsinstitute.com	 092109 89898	G 38, 2nd Floor, Block G, Noida Sector 3, Noida, Uttar Pradesh 201301	1	2024-07-28 18:46:37.413456	1	2024-08-06 19:04:31
\.


--
-- TOC entry 4083 (class 0 OID 16712)
-- Dependencies: 262
-- Data for Name: country; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.country (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Ibrahim Memon	Active	1	2024-07-18 11:44:05.268494	\N	\N
2	India	Active	1	2024-07-26 05:46:25.814245	\N	\N
\.


--
-- TOC entry 4049 (class 0 OID 16444)
-- Dependencies: 228
-- Data for Name: course; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.course (id, courename, coursedescription, noofyear, noofmonth, fee, title, seodescription, image, mode, feature, categorie, added_date, added_by, last_modified, detailcoursedescription, whycourse, whopursuecourse, whentodocourse, keyhighcourse, eligibility, skills, other, admission, active, toc, last_modified_user, urlname, toch1, toch2, toch3, toch4, universityid, toch5) FROM stdin;
\.


--
-- TOC entry 4085 (class 0 OID 16722)
-- Dependencies: 264
-- Data for Name: courseactivity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.courseactivity (id, superuserid, content, courseid, added_date, role, differentcontent, previouscontent, previouscontentlength, newcontentlength) FROM stdin;
1	1	{}	1	2024-07-26 05:59:44.155483	Add	\N	\N	\N	\N
2	1	{}	1	2024-07-26 06:31:02.266679	Delete	\N	\N	\N	\N
3	1	{}	1	2024-07-26 06:31:24.172555	Delete	\N	\N	\N	\N
4	1	{}	1	2024-07-26 09:30:48.792657	Delete	\N	\N	\N	\N
5	1	{}	1	2024-07-26 09:31:10.293753	Delete	\N	\N	\N	\N
6	1	{}	1	2024-07-26 09:31:11.123597	Delete	\N	\N	\N	\N
7	1	{}	1	2024-07-26 09:31:11.642682	Delete	\N	\N	\N	\N
8	1	{}	1	2024-07-26 09:31:12.702408	Delete	\N	\N	\N	\N
9	1	{}	1	2024-07-26 09:31:48.817554	Delete	\N	\N	\N	\N
10	1	{}	1	2024-07-26 09:32:10.307856	Delete	\N	\N	\N	\N
11	1	{}	1	2024-07-26 11:15:53.510967	Delete	\N	\N	\N	\N
12	1	{}	1	2024-07-26 11:16:07.599959	Delete	\N	\N	\N	\N
13	1	{}	1	2024-07-26 11:16:28.730142	Delete	\N	\N	\N	\N
14	1	{}	1	2024-07-26 11:16:28.949457	Delete	\N	\N	\N	\N
15	1	{}	1	2024-07-26 11:43:47.308038	Delete	\N	\N	\N	\N
16	1	{}	1	2024-07-26 11:44:09.185356	Delete	\N	\N	\N	\N
17	1	{}	1	2024-07-26 11:44:47.324106	Delete	\N	\N	\N	\N
18	1	{}	1	2024-07-26 11:45:09.19547	Delete	\N	\N	\N	\N
19	1	{}	1	2024-07-26 11:52:49.507211	Delete	\N	\N	\N	\N
20	1	{}	1	2024-07-26 11:53:49.526686	Delete	\N	\N	\N	\N
21	1	{}	1	2024-07-26 12:04:09.322744	Delete	\N	\N	\N	\N
22	1	{}	1	2024-07-26 12:05:09.321823	Delete	\N	\N	\N	\N
23	1	{}	1	2024-07-26 12:07:03.454063	Delete	\N	\N	\N	\N
24	1	{}	1	2024-07-26 12:09:48.245329	Delete	\N	\N	\N	\N
26	1	{}	2	2024-07-26 12:37:27.64592	Add	\N	\N	\N	\N
27	1	{}	3	2024-08-13 12:28:50.489542	Add	\N	\N	\N	\N
28	1	{"image":"trust.png","previousimage":"IMTS.png","universityid":"{}","previousuniversityid":["3"]}	3	2024-08-15 10:56:04.148042	Update	\N	\N	\N	\N
29	1	{}	4	2024-08-15 13:35:30.8887	Add	\N	\N	\N	\N
30	1	{}	5	2024-08-20 10:15:11.708802	Add	\N	\N	\N	\N
31	1	{}	3	2024-08-21 07:14:19.802079	Delete	\N	\N	\N	\N
32	1	{}	5	2024-08-21 07:14:26.463849	Delete	\N	\N	\N	\N
33	1	{}	4	2024-08-21 07:14:40.899202	Delete	\N	\N	\N	\N
34	1	{}	5	2024-08-21 07:14:50.371258	Delete	\N	\N	\N	\N
35	1	{}	2	2024-08-21 07:14:54.049795	Delete	\N	\N	\N	\N
36	1	{}	1	2024-08-21 07:14:56.178321	Delete	\N	\N	\N	\N
37	1	{}	5	2024-08-21 07:15:26.482119	Delete	\N	\N	\N	\N
38	1	{}	6	2024-09-02 12:51:09.606223	Add	\N	\N	\N	\N
39	1	\N	46	2024-09-04 10:15:58.971012	Update	12 34	\N	\N	\N
40	1	\N	32	2024-09-05 18:49:03.764366	Update	Master 	\N	\N	\N
41	1	{}	68	2024-09-07 10:15:04.984507	Add	\N	\N	\N	\N
42	1	{}	69	2024-09-07 12:53:41.913543	Add	\N	\N	\N	\N
43	1	{}	70	2024-09-07 13:21:58.53469	Add	\N	\N	\N	\N
44	1	{}	71	2024-09-07 13:22:37.147556	Add	\N	\N	\N	\N
45	1	{}	79	2024-09-07 13:40:06.404075	Add	\N	\N	\N	\N
46	1	{}	79	2024-09-07 13:40:57.031026	Delete	\N	\N	\N	\N
47	\N	{}	82	2024-09-07 14:34:48.73707	Add	\N	\N	\N	\N
48	1	{}	112	2024-09-07 16:28:42.684561	Add	\N	\N	\N	\N
49	1	{}	127	2024-09-07 17:05:25.944108	Add	\N	\N	\N	\N
50	1	{}	127	2024-09-07 17:06:24.151277	Delete	\N	\N	\N	\N
51	1	{}	82	2024-09-07 17:06:31.386645	Delete	\N	\N	\N	\N
52	1	{}	139	2024-09-07 17:11:58.293659	Add	\N	\N	\N	\N
53	1	{}	139	2024-09-07 17:31:37.711217	Delete	\N	\N	\N	\N
54	1	{}	67	2024-09-07 17:31:57.813305	Delete	\N	\N	\N	\N
55	1	{}	154	2024-09-07 17:34:29.412259	Add	\N	\N	\N	\N
56	1	{}	154	2024-09-07 17:36:16.507735	Delete	\N	\N	\N	\N
57	1	{}	159	2024-09-07 17:36:57.976736	Add	\N	\N	\N	\N
58	1	{}	159	2024-09-07 17:37:24.635888	Delete	\N	\N	\N	\N
59	1	{}	68	2024-09-23 09:56:23.780189	Delete	\N	\N	\N	\N
60	1	{}	112	2024-09-24 09:05:03.57116	Delete	\N	\N	\N	\N
\.


--
-- TOC entry 4087 (class 0 OID 16732)
-- Dependencies: 266
-- Data for Name: coursecomment; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.coursecomment (id, title, description, courseid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4089 (class 0 OID 16752)
-- Dependencies: 268
-- Data for Name: courseduration; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.courseduration (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	@ Year	Active	1	2024-07-26 05:51:34.627007	\N	\N
7	2 Years	Active	1	2024-08-13 10:51:30.419045	\N	\N
5	4 Years	Active	1	2024-08-08 10:12:26.639254	1	2024-08-22 10:00:26
6	5 Years	Active	1	2024-08-08 10:12:30.169093	1	2024-08-22 10:00:26
3	2 Years	Active	1	2024-08-08 10:12:18.599507	1	2024-08-22 10:00:26
2	1 Year	Active	1	2024-08-08 10:12:13.844577	1	2024-08-22 10:50:21
4	3 Years	Active	1	2024-08-08 10:12:22.782635	1	2024-08-22 10:50:21
\.


--
-- TOC entry 4091 (class 0 OID 16762)
-- Dependencies: 270
-- Data for Name: coursefaq; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.coursefaq (id, question, answer, added_by, added_date, courseid, last_modified) FROM stdin;
\.


--
-- TOC entry 4093 (class 0 OID 16777)
-- Dependencies: 272
-- Data for Name: coursemode; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.coursemode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 4095 (class 0 OID 16787)
-- Dependencies: 274
-- Data for Name: coursereview; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.coursereview (id, rating, detail, userid, courseid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4097 (class 0 OID 16807)
-- Dependencies: 276
-- Data for Name: coursetype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.coursetype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	MCA	Active	1	2024-07-26 05:50:44.968336	1	2024-07-25 16:31:19
\.


--
-- TOC entry 4099 (class 0 OID 16817)
-- Dependencies: 278
-- Data for Name: cta; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.cta (id, title, added_date, added_by) FROM stdin;
9	Consult Now	2024-08-09 10:39:34.035361	1
\.


--
-- TOC entry 4101 (class 0 OID 16827)
-- Dependencies: 280
-- Data for Name: designation; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.designation (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
4	Education Counsellor	Active	1	2024-08-09 06:48:17.211971	\N	\N
5	Sr Education Counselor 	Active	1	2024-08-09 06:48:26.069119	\N	\N
6	Manager	Active	1	2024-09-16 13:33:25.656161	\N	\N
7	Team Leader	Active	1	2024-09-16 13:33:31.266283	\N	\N
\.


--
-- TOC entry 4166 (class 0 OID 18460)
-- Dependencies: 345
-- Data for Name: establish; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.establish (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	1999	Active	1	2024-08-21 11:38:40.529272	\N	\N
\.


--
-- TOC entry 4103 (class 0 OID 16837)
-- Dependencies: 282
-- Data for Name: expertpage; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.expertpage (id, qualityassurancecell, qualitycellimage, training, trainingimage, qualityassuranceteam, qualityteamimage, aimqualityassurance, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
3	<p><strong style="font-size: 24px;">Empowering Futures, One Student at a Time</strong></p><p><span style="font-size: 16px;">At IMTS Institute, we specialize in providing comprehensive admission consulting services for students seeking higher education. Our mission is to guide you through the intricate admissions process, helping you make informed decisions that align with your academic and career aspirations.</span><br></p>	career.webp	<p><strong style="font-size: 24px;">Why Choose IMTS Institute?</strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">1. Expertise and Experience</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">With years of experience in the education sector, our team of seasoned consultants possesses in-depth knowledge of admission requirements, application processes, and educational systems worldwide. We stay abreast of the latest trends and changes in the education landscape to offer you the most accurate and up-to-date advice.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">2. Personalized Guidance</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We understand that each student has unique goals and aspirations. Our personalized consulting services are tailored to meet your individual needs. Whether you aim for undergraduate, postgraduate, or professional courses, we provide customized strategies to enhance your application and increase your chances of acceptance.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">3. Comprehensive Services</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">From selecting the right course and university to preparing compelling application essays, IMTS Institute offers a wide range of services, including:</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Course and University Selection</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Based on your interests, academic background, and career goals, we help you choose the best-fit courses and institutions.</span></strong></p></li><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Application Assistance</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Our experts assist you in crafting standout applications, including personal statements, letters of recommendation, and resumes.</span></strong></p></li></ul><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">4. Proven Success</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our track record speaks for itself. IMTS Institute has successfully guided numerous students to prestigious institutions worldwide. We take pride in our students' achievements and are committed to helping you reach their full potential.</span></strong></p><br>	Medium.jpg	<p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;">Our Process</span></strong></p><p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;"><strong style="font-weight:normal;" id="docs-internal-guid-4f0e739b-7fff-d7be-48bb-24a796dba9c5"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 1: Initial Consultation</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We start with an in-depth consultation to understand your academic background, interests, and career goals. This helps us tailor our services to your specific needs.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 2: Strategic Planning</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Based on our initial consultation, we developed a personalized admission strategy. This includes a list of recommended courses and universities, as well as a timeline for completing your application.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 3: Application Development</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our consultants work closely with you to develop a compelling application. We provide feedback on your essays, resumes, and other application materials to ensure they reflect your strengths and aspirations.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 4: Review and Submission</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We conduct a thorough review of your application before submission, ensuring all components are polished and error-free. We also help you navigate the submission process to meet all deadlines.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 5: Post-Application Support</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">After submitting your applications, we continue to support you through interview preparation and provide guidance on accepting offers and preparing for your educational journey.</span></p><br></strong></span></strong></p>		<p>&nbsp;<br></p>	1	2024-07-30 09:46:51.670604	\N	\N
4	<p><strong style="font-size: 24px;">Empowering Futures, One Student at a Time</strong></p><p><span style="font-size: 16px;">At IMTS Institute, we specialize in providing comprehensive admission consulting services for students seeking higher education. Our mission is to guide you through the intricate admissions process, helping you make informed decisions that align with your academic and career aspirations.</span><br></p>	career.webp	<p><strong style="font-size: 24px;">Why Choose IMTS Institute?</strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">1. Expertise and Experience</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">With years of experience in the education sector, our team of seasoned consultants possesses in-depth knowledge of admission requirements, application processes, and educational systems worldwide. We stay abreast of the latest trends and changes in the education landscape to offer you the most accurate and up-to-date advice.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">2. Personalized Guidance</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We understand that each student has unique goals and aspirations. Our personalized consulting services are tailored to meet your individual needs. Whether you aim for undergraduate, postgraduate, or professional courses, we provide customized strategies to enhance your application and increase your chances of acceptance.</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">3. Comprehensive Services</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">From selecting the right course and university to preparing compelling application essays, IMTS Institute offers a wide range of services, including:</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Course and University Selection</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Based on your interests, academic background, and career goals, we help you choose the best-fit courses and institutions.</span></strong></p></li><li dir="ltr" style="list-style-type:disc;font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;" aria-level="1"><p dir="ltr" style="line-height:1.38;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Application Assistance</span><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">: Our experts assist you in crafting standout applications, including personal statements, letters of recommendation, and resumes.</span></strong></p></li></ul><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">4. Proven Success</span></strong></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-50e7176a-7fff-bedb-d198-d3b3772b25a0"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our track record speaks for itself. IMTS Institute has successfully guided numerous students to prestigious institutions worldwide. We take pride in our students' achievements and are committed to helping you reach their full potential.</span></strong></p><br>	Medium.jpg	<p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;">Our Process</span></strong></p><p><strong style="font-weight:normal;" id="docs-internal-guid-d17586e4-7fff-748d-4d90-c151432273fd"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 24px;"><strong style="font-weight:normal;" id="docs-internal-guid-4f0e739b-7fff-d7be-48bb-24a796dba9c5"><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 1: Initial Consultation</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We start with an in-depth consultation to understand your academic background, interests, and career goals. This helps us tailor our services to your specific needs.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 2: Strategic Planning</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Based on our initial consultation, we developed a personalized admission strategy. This includes a list of recommended courses and universities, as well as a timeline for completing your application.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 3: Application Development</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Our consultants work closely with you to develop a compelling application. We provide feedback on your essays, resumes, and other application materials to ensure they reflect your strengths and aspirations.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 4: Review and Submission</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">We conduct a thorough review of your application before submission, ensuring all components are polished and error-free. We also help you navigate the submission process to meet all deadlines.</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:700;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">Step 5: Post-Application Support</span></p><p dir="ltr" style="line-height:1.38;margin-top:12pt;margin-bottom:12pt;"><span style="font-size:11pt;font-family:Arial,sans-serif;color:#000000;background-color:transparent;font-weight:400;font-style:normal;font-variant:normal;text-decoration:none;vertical-align:baseline;white-space:pre;white-space:pre-wrap;">After submitting your applications, we continue to support you through interview preparation and provide guidance on accepting offers and preparing for your educational journey.</span></p><br></strong></span></strong></p>	download (1).jpeg	<p>&nbsp;<br></p>	1	2024-07-30 09:47:58.218784	\N	\N
\.


--
-- TOC entry 4105 (class 0 OID 16847)
-- Dependencies: 284
-- Data for Name: faq; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.faq (id, question, answer, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	{"Q1: What is the admission process at IMTS Institute","What are the eligibility criteria for undergraduate programs","Can I apply for multiple courses simultaneously","What documents are required for the admission process","What types of courses does IMTS Institute offer","Are the courses offered by IMTS Institute recognized","Does IMTS Institute offer online courses"}	{"The admission process at IMTS Institute involves filling out the online application form","submitting the required documents","and paying the application fee. For specific courses","there might be entrance exams or interviews","For undergraduate programs","candidates must have completed their 10+2 education from a recognized board with the required percentage as specified by the course",Yes,"you can apply for multiple courses","but you need to fill out separate application forms and pay the application fee for each course","Required documents include educational certificates","identity proof","passport-sized photographs","and any other documents specified by the course requirements.\nCourses and Programs","IMTS Institute offers a variety of courses","including undergraduate",postgraduate,diploma,"and certificate programs in fields such as management",engineering,"computer applications","and more.",Yes,"all courses offered by IMTS Institute are recognized by relevant educational authorities and are designed to meet industry standards",Yes,"IMTS Institute offers several online courses that provide flexibility and convenience for students who cannot attend on-campus classes"}	1	2024-07-23 12:11:22.349281	\N	\N
\.


--
-- TOC entry 4107 (class 0 OID 16858)
-- Dependencies: 286
-- Data for Name: footer; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.footer (id, work, trust, distancemba, ugcourse, bestcollege, added_by, added_date, aboutwebsite, playstore, appstore, facebook, twitter, instagram, linkedin, youtube, contactus, qr, tagline, tollno, reserved) FROM stdin;
2			<h2 class="widget-title">Distance Courses</h2><div class="textwidget"><p><a href="https://dde.imtsinstitute.com/ba-distance-education/">BA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/bsc-distance-education/">BSC Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/b-com-distance-education-admission/">BCOM Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/bba-management-distance-education/">BBA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/ma-distance-education/">MA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/msc-distance-education/">MSC Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mcom-distance-education/">MCOM Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-distance-education/">MBA Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-it-distance-education/" target="_blank" rel="noopener">MBA IT Distance education</a></p><p><a href="https://dde.imtsinstitute.com/mba-human-resource-management-distance-education/">MBA HR Distance Education</a></p><p><a href="https://dde.imtsinstitute.com/mba-hospital-management-distance-education/">MBA Hospital Management</a></p><p><a href="https://dde.imtsinstitute.com/m-sc-in-information-technology-dde/">MSC IT Distance education</a></p></div>	<h2 class="widget-title">Courses</h2><div class="textwidget"><p><a href="https://imtsinstitute.com/ba/">BA Course</a></p><p><a href="https://imtsinstitute.com/bcom/">BCOM Course</a></p><p><a href="https://imtsinstitute.com/bsc/">BSC Course</a></p><p><a href="https://imtsinstitute.com/bba/">BBA Course</a></p><p><a href="https://imtsinstitute.com/bbm/">BBM Course</a></p><p><a href="https://imtsinstitute.com/bca/">BCA Course</a></p><p><a href="https://imtsinstitute.com/mba/">MBA Course</a></p><p><a href="https://imtsinstitute.com/mca/">MCA Course</a></p><p><a href="https://imtsinstitute.com/mcom/">MCom Course</a></p><p><a href="https://imtsinstitute.com/msc/">MSC Course</a></p><p><a href="https://imtsinstitute.com/btech/">BTech Course</a></p><p><a href="https://imtsinstitute.com/bed/">BEd Course</a></p></div>	<h2 class="widget-title">Courses After 12th</h2><div class="textwidget"><p><a href="https://blog.imtsinstitute.com/courses-after-12th/">Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/courses-after-12th-science/">Science Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/diploma-courses-after-10th/">Diploma Courses After 10th</a></p><p><a href="https://blog.imtsinstitute.com/yoga-course-after-12th/">Yoga Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/diploma-courses-after-12th/">Diploma Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/it-course-after-12th/">IT Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/commerce-courses-after-12th/">Commerce Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/career-after-12th/">Career Options After 12th</a></p><p><a href="https://blog.imtsinstitute.com/professional-courses-after-12th/">Professional Courses After 12th</a></p><p><a href="https://blog.imtsinstitute.com/dual-degree-course-after-12th/">Dual Degree Courses After 12th</a></p></div>	1	2024-07-23 12:29:02.204925					https://twitter.com/imtsinstitute	https://www.instagram.com/imts_institute/	https://in.linkedin.com/school/imts-institute/	https://www.youtube.com/channel/UC1gyzoIz5byFm4jPkwsFY5A/videos				092109 89898	
\.


--
-- TOC entry 4109 (class 0 OID 16868)
-- Dependencies: 288
-- Data for Name: header; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.header (id, title, logo, added_date, added_by, last_modified_by, last_modified_date) FROM stdin;
8	IMTS	IMTS.png	2024-08-03 15:55:13.612947	1	\N	\N
\.


--
-- TOC entry 4051 (class 0 OID 16454)
-- Dependencies: 230
-- Data for Name: individualcourse; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.individualcourse (courename, coursedescription, noofyear, noofmonth, fee, title, seodescription, image, mode, feature, categorie, added_by, last_modified, detailcoursedescription, whycourse, whopursuecourse, whentodocourse, keyhighcourse, eligibility, skills, other, admission, active, toc, last_modified_user, urlname, toch1, toch2, toch3, toch4, id, toch5, added_date, role) FROM stdin;
MBA (Master of Business Administration)4234234	4234234		4 Years	5435345	dfgdfg	dfgdfgdg	academic.png	Full Time 	Feature	ugCourses	1	\N	<p>Enter Content Heredsfsdfsdf</p>									Active	TOC	\N	gdfgdfgdfg	{}	{}	{}	{}	69	{}	2024-09-07 12:53:41.887925	Watch
MPT	MPT stands for Master of Physiotherapy. It is a postgraduate degree program designed to advance the knowledge and skills of physiotherapy professionals.		2 Years	5633	Master of Physiotherapy (MPT): Advance Your Physiotherapy Career	Enhance your physiotherapy expertise with an MPT. Explore specializations, career paths, top colleges, and how to excel in the field. Advance your career in healthcare.	Logo_of_MPT.svg.png	Full Time 	Feature	pgCourses	1	2024-09-05 18:48:04	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>			ASdasdasd						Active	TOC	Ibrahim	MPT-	{}	{<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	32	{}	2024-08-13 11:41:02.401187	Add
PGDCA	PGDCA (Post Graduate Diploma in Computer Applications) is a diploma program that provides advanced knowledge and skills in computer applications. It is often pursued by individuals with a background in computer science or related fields, or those looking to enhance their computer skills for career advancement.		1 Year	76467	PGDCA-	Learn about the Post Graduate Diploma in Computer Applications (PGDCA) program, including its course structure, eligibility criteria, fee details, and career opportunities for advanced skills in computer applications.	educational-services-pgdca-course-250x250.webp	Full Time 	Feature	advancedDiploma	1	2024-08-22 10:50:21	<p style="text-align: justify;">The Post Graduate Diploma in Computer Applications (PGDCA) is a one-year postgraduate program designed to provide students with advanced knowledge and practical skills in computer applications. This program is ideal for individuals seeking to enhance their expertise in IT and computer science, preparing them for various roles in the technology sector.</p><h2 style="text-align: justify;"><strong>Course Duration and Structure</strong></h2><p style="text-align: justify;">The PGDCA program typically lasts for one year and is divided into two semesters. The curriculum includes both theoretical and practical components, covering a range of topics in computer applications:</p><ul><li style="text-align: justify;"><strong>Core Subjects:</strong> Includes foundational subjects such as Programming Languages (C, C++, Java), Database Management Systems (DBMS), Software Engineering, and Web Technologies.</li><li style="text-align: justify;"><strong>Electives:</strong> Specialized courses in areas like Networking, Data Analytics, or Advanced Programming.</li><li style="text-align: justify;"><strong>Practical Training:</strong> Hands-on experience through lab sessions, project work, and case studies.</li><li style="text-align: justify;"><strong>Project Work:</strong> A final project that involves solving real-world problems using the skills acquired during the course.</li></ul><h4 style="text-align: justify;"><strong>Eligibility Criteria</strong></h4><p style="text-align: justify;">To enroll in a PGDCA program, candidates generally need to meet the following requirements:</p><ul><li style="text-align: justify;"><strong>Educational Qualification:</strong> A bachelor’s degree in any discipline from a recognized institution. Some institutions may prefer candidates with a background in science or computer science.</li><li style="text-align: justify;"><strong>Minimum Marks:</strong> A minimum percentage of marks in the undergraduate degree, typically around 50%.</li><li style="text-align: justify;"><strong>Entrance Examinations:</strong> Some institutions may require candidates to pass an entrance exam or interview.</li></ul><h4 style="text-align: justify;"><strong>Fee Structure</strong></h4><p style="text-align: justify;">The fee structure for a PGDCA program can vary depending on the institution and location. On average, the fees range from INR 20,000 to INR 1,00,000 for the entire course. Many institutions offer financial aid, scholarships, and installment payment options to support students.</p><h4 style="text-align: justify;"><strong>Specializations in PGDCA</strong></h4><p style="text-align: justify;">While PGDCA programs generally cover a broad range of topics, students may have the option to specialize in specific areas, such as:</p><ul><li style="text-align: justify;"><strong>Software Development</strong></li><li style="text-align: justify;"><strong>Web Development</strong></li><li style="text-align: justify;"><strong>Database Management</strong></li><li style="text-align: justify;"><strong>Networking</strong></li><li style="text-align: justify;"><strong>Cyber Security</strong></li></ul><h4 style="text-align: justify;"><strong>Career Prospects After PGDCA</strong></h4><p style="text-align: justify;">Graduates of the PGDCA program have a variety of career opportunities in the IT and technology sectors. Some potential roles include:</p><ul><li style="text-align: justify;"><strong>Software Developer:</strong> Design, develop, and maintain software applications.</li><li style="text-align: justify;"><strong>Web Developer:</strong> Create and manage websites and web applications.</li><li style="text-align: justify;"><strong>Database Administrator:</strong> Manage and organize data using database management systems.</li><li style="text-align: justify;"><strong>System Analyst:</strong> Analyze and design IT solutions to meet business needs.</li><li style="text-align: justify;"><strong>IT Consultant:</strong> Provide expert advice on technology solutions and implementations.</li><li style="text-align: justify;"><strong>Network Administrator:</strong> Oversee and manage network infrastructure and security.</li><li style="text-align: justify;"><strong>Technical Support Specialist:</strong> Offer support and troubleshooting for IT-related issues.</li></ul><h4 style="text-align: justify;"><strong>Higher Education and Further Studies</strong></h4><p style="text-align: justify;">After completing a PGDCA, graduates may pursue further studies or certifications to enhance their skills and career prospects, such as:</p><ul><li style="text-align: justify;"><strong>Master of Computer Applications (MCA):</strong> A more advanced degree in computer applications.</li><li style="text-align: justify;"><strong>Specialized Certifications:</strong> Certifications in specific technologies or tools, such as cloud computing, data science, or cyber security.</li></ul><h4 style="text-align: justify;"><strong>Conclusion</strong></h4><p style="text-align: justify;">The Post Graduate Diploma in Computer Applications (PGDCA) is a comprehensive program designed to equip students with advanced skills in computer applications and IT. With its focus on practical training and theoretical knowledge, the PGDCA prepares graduates for a range of careers in the technology sector, offering opportunities for professional growth and advancement.</p>			ASdasdasd						Active	TOC	Ibrahim	Post-Graduate-Diploma-in-Computer-Applications-(PGDCA):-Course-Overview,-Eligibility,-Fees,-and-Career-Opportunities	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Fee Structure</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Specializations in PGDCA</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Career Prospects After PGDCA</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Higher Education and Further Studies</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h4>"}	59	{}	2024-08-21 07:07:20.541739	Add
BPT	BPT is a professional undergraduate degree program that prepares individuals for a career in physiotherapy. It focuses on the assessment, diagnosis, and treatment of physical impairments and disabilities.		3 Years	65431	 BPT: A Rewarding Career in Physiotherapy	Discover the BPT program, a gateway to a fulfilling career in physiotherapy. Learn about course curriculum, career opportunities, and top universities. Gain the skills to help patients regain mobility and function.	IMG_20230828_105111-scaled.jpg	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<p data-sourcepos="3:1-3:7"><strong>BPT</strong><span> stands for </span><strong>Bachelor of Physiotherapy</strong><span>.</span><span> It's an undergraduate degree program designed to equip students with the knowledge and skills required to become qualified physiotherapists.</span><span> Physiotherapists play a crucial role in helping individuals recover from injuries,</span><span> illnesses,</span><span> or disabilities.</span></p><h2 data-sourcepos="5:1-5:21" class="">Why Choose a BPT?</h2><ul data-sourcepos="7:1-7:109"><li data-sourcepos="7:1-7:109"><strong>Growing Demand:</strong><span> There is a rising demand for physiotherapists due to an aging population and increasing awareness of the benefits of rehabilitation.</span></li><li data-sourcepos="8:1-8:129"><strong>Helping Others:</strong><span> Physiotherapists have the opportunity to make a significant difference in people's lives by improving their mobility and quality of life.</span></li><li data-sourcepos="9:1-9:143"><strong>Diverse Career Paths:</strong><span> A BPT degree opens doors to various career opportunities in hospitals,</span><span> clinics,</span><span> sports teams,</span><span> and private practice.</span></li><li data-sourcepos="10:1-11:0"><strong>Hands-On Experience:</strong><span> BPT programs often include practical training and clinical placements,</span><span> providing valuable hands-on experience.</span></li></ul><h3 data-sourcepos="12:1-12:34" class="">Core Subjects in a BPT Program</h3><ul data-sourcepos="14:1-17:45"><li data-sourcepos="14:1-14:66"><strong>Human Anatomy:</strong><span> The structure and function of the human body.</span></li><li data-sourcepos="15:1-15:71"><strong>Physiology:</strong><span> The functions of the human body's organs and systems.</span></li><li data-sourcepos="16:1-16:78"><strong>Biomechanics:</strong><span> The study of human movement and forces acting on the body.</span></li><li data-sourcepos="17:1-17:45"><strong>Pathology:</strong><span> The study of disease and its effects on the body.</span></li><li data-sourcepos="18:1-18:57"><strong>Pharmacology:</strong><span> The study of drugs and their effects.</span></li><li data-sourcepos="19:1-19:90"><strong>Physiotherapy Techniques:</strong><span> Therapeutic exercises,</span><span> manual therapy,</span><span> and electrotherapy.</span></li><li data-sourcepos="20:1-20:88"><strong>Rehabilitation:</strong><span> Principles and practices of rehabilitation for various conditions.</span></li><li data-sourcepos="21:1-22:0"><strong>Clinical Practice:</strong><span> Clinical placements in hospitals,</span><span> clinics,</span><span> and community settings.</span></li></ul><h3 data-sourcepos="23:1-23:26" class="">Specializations in BPT</h3><ul data-sourcepos="25:1-27:100"><li data-sourcepos="25:1-25:103"><strong>Orthopedic Physiotherapy:</strong><span> Treating injuries and conditions related to the musculoskeletal system.</span></li><li data-sourcepos="26:1-26:123"><strong>Neurological Physiotherapy:</strong><span> Treating conditions affecting the nervous system,</span><span> such as stroke or spinal cord injuries.</span></li><li data-sourcepos="27:1-27:100"><strong>Cardiovascular Physiotherapy:</strong><span> Treating conditions related to the heart and circulatory system.</span></li><li data-sourcepos="28:1-28:73"><strong>Sports Physiotherapy:</strong><span> Treating injuries and conditions in athletes.</span></li><li data-sourcepos="29:1-29:67"><strong>Geriatric Physiotherapy:</strong><span> Treating conditions in older adults.</span></li><li data-sourcepos="30:1-31:0"><strong>Pediatric Physiotherapy:</strong><span> Treating conditions in children.</span></li></ul><h3 data-sourcepos="32:1-32:35" class="">Career Opportunities with a BPT</h3><ul data-sourcepos="34:1-39:0"><li data-sourcepos="34:1-34:89"><strong>Physiotherapist:</strong><span> Working in hospitals,</span><span> clinics,</span><span> private practices,</span><span> or sports teams.</span></li><li data-sourcepos="35:1-35:67"><strong>Sports Trainer:</strong><span> Providing physiotherapy services to athletes.</span></li><li data-sourcepos="36:1-36:84"><strong>Rehabilitation Specialist:</strong><span> Working in rehabilitation centers or nursing homes.</span></li><li data-sourcepos="37:1-37:95"><strong>Research Physiotherapist:</strong><span> Conducting research on physiotherapy techniques and treatments.</span></li><li data-sourcepos="38:1-39:0"><strong>Educational Physiotherapist:</strong><span> Teaching physiotherapy students or working in physiotherapy education.</span></li></ul><p data-sourcepos="40:1-40:31"><strong>In conclusion,</strong><span> a BPT degree provides a solid foundation for a rewarding career in physiotherapy.</span><span> It equips students with the necessary knowledge and skills to help individuals improve their mobility,</span><span> function,</span><span> and overall quality of life.</span></p>			ASdasdasd						Active	TOC	Ibrahim	BPT-	{}	{"<h2 data-sourcepos=\\"5:1-5:21\\" class=\\"\\">Why Choose a BPT?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:34\\" class=\\"\\">Core Subjects in a BPT Program</h3>","<h3 data-sourcepos=\\"23:1-23:26\\" class=\\"\\">Specializations in BPT</h3>","<h3 data-sourcepos=\\"32:1-32:35\\" class=\\"\\">Career Opportunities with a BPT</h3>"}	{}	47	{}	2024-08-20 09:58:05.810353	Add
MBA PGDM	Acquire in-depth business knowledge and practical skills through our MBA/PGDM program. Prepare for leadership positions across industries. Advance your career and achieve your professional goals.	2	2 Years	65430	MBA/PGDM Program: Gain Essential Business Skills for Success	A diploma program offered by autonomous institutions, regulated by AICTE (All India Council for Technical Education).	70188159.webp	Full Time 	Feature	pgCourses	1	\N	<h2>Introduction</h2><p>The Post Graduate Diploma in Management (PGDM) is a graduate-level program aimed at providing advanced business and management education. While it shares many similarities with an MBA (Master of Business Administration), the PGDM is often offered by autonomous business schools and can have a more flexible curriculum. The program is designed to equip students with comprehensive management skills and prepare them for leadership roles across various industries.</p><h3>Course Structure</h3><p>The PGDM program typically spans two years, divided into four semesters. The curriculum is designed to offer both foundational business knowledge and specialized management skills. Core subjects generally include:</p><ul><li><strong>Management Principles</strong>: Fundamental concepts and practices in business management.</li><li><strong>Financial Management</strong>: Techniques for managing financial resources, budgeting, and investment analysis.</li><li><strong>Marketing Management</strong>: Strategies for market analysis, consumer behavior, and brand management.</li><li><strong>Human Resource Management</strong>: Managing workforce, recruitment, training, and organizational behavior.</li><li><strong>Operations Management</strong>: Principles of production, operations, and supply chain management.</li><li><strong>Strategic Management</strong>: Developing and implementing business strategies to achieve organizational goals.</li><li><strong>Business Ethics and Corporate Governance</strong>: Examination of ethical issues and governance practices in business.</li><li><strong>Entrepreneurship</strong>: Skills and strategies for starting and managing new business ventures.</li><li><strong>International Business</strong>: Understanding global business practices and international market dynamics.</li><li><strong>Business Research Methods</strong>: Techniques for conducting research and analyzing business data.</li></ul><h3>Eligibility Criteria</h3><p>To enroll in a PGDM program, candidates generally need:</p><ul><li><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution.</li><li><strong>Work Experience</strong>: Some programs prefer candidates with work experience, though this is not always a strict requirement.</li><li><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, CAT, or equivalent exams.</li><li><strong>Interview and Personal Statement</strong>: Many programs require an interview or personal statement as part of the admission process.</li></ul><h3>Fee Structure</h3><p>The fee for a PGDM program can vary widely depending on the institution and its location. On average, the annual fee ranges from INR 3,00,000 to INR 20,00,000 in India. Fees can be higher in private institutions compared to government-funded colleges.</p><h3>Career Prospects</h3><p>An PGDM offers a range of career opportunities in various sectors. Graduates can pursue roles such as:</p><ul><li><strong>Business Manager</strong>: Overseeing operations, managing teams, and driving business growth.</li><li><strong>Financial Analyst</strong>: Analyzing financial data, preparing reports, and making investment recommendations.</li><li><strong>Marketing Manager</strong>: Developing and implementing marketing strategies to promote products and services.</li><li><strong>HR Manager</strong>: Managing human resources functions, including recruitment, training, and employee relations.</li><li><strong>Operations Manager</strong>: Managing production processes, supply chains, and operational efficiency.</li><li><strong>Consultant</strong>: Providing advisory services to organizations on management strategies and business improvements.</li><li><strong>Entrepreneur</strong>: Starting and managing new business ventures.</li><li><strong>Product Manager</strong>: Overseeing the development and management of products and services.</li><li><strong>Project Manager</strong>: Leading and managing projects, ensuring timely completion and alignment with business objectives.</li></ul><h3>Specializations</h3><p>PGDM programs often offer various specializations, allowing students to tailor their education according to their career interests. Some common specializations include:</p><ul><li><strong>Marketing Management</strong>: Advanced study of marketing strategies, consumer behavior, and brand management.</li><li><strong>Finance Management</strong>: Focus on financial planning, investment analysis, and corporate finance.</li><li><strong>Human Resource Management</strong>: Specialization in managing human resources, organizational behavior, and employee development.</li><li><strong>Operations Management</strong>: Emphasis on optimizing production processes, supply chains, and operational efficiency.</li><li><strong>Entrepreneurship</strong>: Skills and strategies for starting and managing new business ventures.</li><li><strong>International Business</strong>: Understanding global business practices, international market dynamics, and cross-cultural management.</li><li><strong>Supply Chain Management</strong>: Managing logistics, procurement, and supply chain operations.</li><li><strong>Digital Marketing</strong>: Utilization of digital platforms and analytics for marketing strategies.</li></ul><h3>Differences Between MBA and PGDM</h3><p>While both MBA and PGDM programs aim to provide management education, there are some key differences:</p><ul><li><strong>Certification</strong>: An MBA is typically awarded by universities and is a degree, whereas a PGDM is a diploma awarded by autonomous institutions.</li><li><strong>Curriculum Flexibility</strong>: PGDM programs often have more flexibility in their curriculum and can adapt to industry trends more rapidly.</li><li><strong>Accreditation</strong>: MBA programs are usually accredited by university bodies, whereas PGDM programs may have different accreditation standards depending on the institution.</li><li><strong>Duration and Structure</strong>: The structure and duration can vary, with some PGDM programs offering more specialized or intensive modules.</li></ul>									Active	TOC	\N	MBA-PGDM-	{}	{<h2>Introduction</h2>}	{"<h3>Course Structure</h3>","<h3>Eligibility Criteria</h3>","<h3>Fee Structure</h3>","<h3>Career Prospects</h3>",<h3>Specializations</h3>,"<h3>Differences Between MBA and PGDM</h3>"}	{}	15	{}	2024-08-13 11:41:02.401187	Add
MBA	Our MBA program is designed to develop well-rounded business leaders with a strong foundation in core management disciplines. The curriculum focuses on developing strategic thinking, analytical skills, and a global perspective. Through a blend of theoretical knowledge and practical application, students gain the expertise to excel in diverse business roles.	2	2 Years	65352	MBA Program: Gain Essential Business Skills for Success	Invest in your future with an MBA. Our program offers rigorous coursework, experienced faculty, and valuable networking opportunities. Become a confident and strategic business leader.	1640255976123.png	Full Time 	Feature	pgCourses	1	2024-08-20 10:24:34	<h2 style="text-align: justify; line-height: 1.1;">Introduction</h2><p style="text-align: justify;">The Master of Business Administration (MBA) is a highly sought-after graduate degree that provides a comprehensive education in business management and administration. MBA programs are designed to equip students with leadership, strategic thinking, and managerial skills necessary to excel in various business environments. The program typically covers core business areas and offers specialized tracks to cater to specific career interests.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">An MBA program usually spans two years, divided into four semesters, though some programs offer accelerated one-year formats. The curriculum generally includes:</p><ul><li style="text-align: justify;"><strong>Core Modules</strong>: Subjects common to all MBA programs, such as Financial Accounting, Marketing Management, Organizational Behavior, Operations Management, Strategic Management, and Human Resource Management.</li><li style="text-align: justify;"><strong>Elective Specializations</strong>: Advanced courses in specific areas of interest, allowing students to tailor their education according to career goals.</li><li style="text-align: justify;"><strong>Capstone Projects and Internships</strong>: Practical experience through real-world projects and internships to apply theoretical knowledge.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA program, candidates typically need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Many programs prefer candidates with work experience, though this varies by program.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs require interviews or personal statements.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA program varies widely depending on the institution and location. On average, the annual fee ranges from INR 2,00,000 to INR 30,00,000 in India and can be higher for international programs.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA opens up diverse career opportunities across various sectors. Graduates can pursue roles in:</p><ul><li style="text-align: justify;"><strong>Management Consulting</strong>: Advising organizations on business strategies and operations.</li><li style="text-align: justify;"><strong>Finance</strong>: Positions in investment banking, financial planning, and analysis.</li><li style="text-align: justify;"><strong>Marketing</strong>: Roles in brand management, digital marketing, and market research.</li><li style="text-align: justify;"><strong>Operations</strong>: Careers in supply chain management, logistics, and operations management.</li><li style="text-align: justify;"><strong>Human Resources</strong>: Roles in talent management, organizational development, and HR strategy.</li><li style="text-align: justify;"><strong>Entrepreneurship</strong>: Starting and managing new business ventures.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Now, let's dive into specific MBA specializations:</p><p style="text-align: justify;"><strong>1. MBA PGDM (Post Graduate Diploma in Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: An alternative to traditional MBA programs, offering similar management training but with a different certification.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores may be required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Similar to MBA graduates, including management roles, consulting, and entrepreneurship.</li></ul><p style="text-align: justify;">2. <strong>Executive MBA</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Designed for working professionals with significant work experience, focusing on advanced management and leadership skills.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Several years of work experience; often requires a bachelor’s degree.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Leadership roles, senior management, and executive positions.</li></ul><p style="text-align: justify;">3. <strong>MBA Dual Specialization</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Allows students to specialize in two areas of business, providing a broader skill set.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Versatile roles in management, consulting, and specialized business fields.</li></ul><p style="text-align: justify;">4. <strong>MBA IT (Information Technology)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on integrating IT with business management, covering topics like IT strategy, management, and systems.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree in any discipline; IT background may be preferred.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: IT management, systems analysis, and technology consulting.</li></ul><p style="text-align: justify;">5. <strong>MBA Safety Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in safety protocols, risk management, and compliance in various industries.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in safety or related fields can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Safety manager, risk consultant, and compliance officer.</li></ul><p style="text-align: justify;">6. <strong>MBA Finance</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on financial management, investment analysis, and corporate finance.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Financial analyst, investment banker, and finance manager.</li></ul><p style="text-align: justify;">7. <strong>MBA Operations</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes managing and optimizing business operations and supply chains.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Operations manager, supply chain analyst, and logistics coordinator.</li></ul><p style="text-align: justify;">8. <strong>MBA HRM (Human Resource Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing human resources, including recruitment, training, and organizational development.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: HR manager, recruitment consultant, and organizational development specialist.</li></ul><p style="text-align: justify;">9. <strong>MBA Event Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on planning, organizing, and managing events and conferences.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Event manager, conference organizer, and corporate event planner.</li></ul><p style="text-align: justify;">10. <strong>MBA Entrepreneurship</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Aims to develop skills for starting and managing new ventures.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrepreneurial background or interest is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Entrepreneur, startup manager, and business consultant.</li></ul><p style="text-align: justify;">11. <strong>MBA Airline and Airport Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in the management of airline operations and airport facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in aviation can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Airline manager, airport operations manager, and aviation consultant.</li></ul><p style="text-align: justify;">12. <strong>MBA IB (International Business)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on global business practices, international trade, and cross-cultural management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: International business manager, export manager, and global marketing consultant.</li></ul><p style="text-align: justify;">13. <strong>MBA Logistics</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes supply chain management, logistics operations, and distribution strategies.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Logistics manager, supply chain analyst, and operations coordinator.</li></ul><p style="text-align: justify;">14. <strong>MBA Marketing</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on marketing strategies, consumer behavior, and brand management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Marketing manager, brand strategist, and market researcher.</li></ul><p style="text-align: justify;">15. <strong>MBA Advertising and Sales Promotion</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in advertising strategies and sales promotion techniques.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Advertising manager, sales promotion specialist, and media planner.</li></ul><p style="text-align: justify;">16. <strong>MBA Digital Marketing</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on online marketing strategies, social media, and digital analytics.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Digital marketing manager, SEO specialist, and social media manager.</li></ul><p style="text-align: justify;">17. <strong>MBA Project Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing projects, including planning, execution, and evaluation.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Project manager, program manager, and project coordinator.</li></ul><p style="text-align: justify;">18. <strong>MBA Hospital Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing healthcare facilities and services.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Hospital administrator, healthcare manager, and medical services manager.</li></ul><p style="text-align: justify;">19. <strong>MBA Shipping and Port Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing shipping operations and port facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in logistics or maritime studies is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Shipping manager, port operations manager, and maritime consultant.</li></ul><p style="text-align: justify;">20. <strong>MBA CRM (Customer Relationship Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing customer relationships and enhancing customer satisfaction.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: CRM manager, customer service director, and client relationship manager.</li></ul><p style="text-align: justify;">21. <strong>MBA Clinical Research</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in research methodologies and clinical trials in the healthcare sector.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in life sciences or healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Clinical research manager, research coordinator, and clinical trial analyst.</li></ul><p style="text-align: justify;">22. <strong>MBA Disaster Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing disaster response and recovery efforts.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in emergency management is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Disaster response manager, emergency management specialist, and risk assessment analyst.</li></ul><p style="text-align: justify;">23. <strong>MBA Pharmaceutical Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing pharmaceutical operations and understanding drug regulations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in pharmacy or life sciences is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Pharmaceutical manager, drug regulatory affairs specialist, and healthcare consultant.</li></ul><p style="text-align: justify;">24. <strong>MBA Technology Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing technology resources and innovation within organizations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in technology or engineering can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>:</li></ul>			ASdasdasd						Active	TOC	Ibrahim	MBA-(Master-of-Business-Administration)-	{}	{"<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>"}	{}	13	{}	2024-08-13 11:41:02.401187	Add
BPP	BPP offers a range of professional courses, including those in law, finance, accountancy, and business. Their programs are designed to equip students with the practical skills and knowledge needed to succeed in their chosen careers. BPP courses often include hands-on experience, industry-relevant content, and opportunities for networking with professionals.		3 Years	87877	Bachelor Preparatory Programme (BPP): Overview, Eligibility, Fees, and Benefits	Learn about the Bachelor Preparatory Programme (BPP), including its overview, eligibility requirements, fee structure, and the benefits it offers to students aiming for higher education.	images (20).jfif	Full Time 	Feature	ugCourses	\N	2024-08-22 10:50:21	<p style="text-align: justify;">The <strong>Bachelor Preparatory Programme</strong> (BPP) is a foundational course designed to prepare students for undergraduate studies, especially for those who may not meet the direct entry requirements for a bachelor's degree program. This program aims to bridge the gap between high school education and higher education by providing essential skills and knowledge required for successful academic performance in a bachelor's degree course.</p><h2 style="text-align: justify;"><strong>Course Duration and Structure</strong></h2><p style="text-align: justify;">The BPP typically lasts for 6 months to 1 year, depending on the institution and the student’s pace. The program includes a variety of subjects and modules that focus on developing key academic skills, such as:</p><ul><li style="text-align: justify;"><strong>Study Skills:</strong> Techniques for effective learning, time management, and research skills.</li><li style="text-align: justify;"><strong>Mathematics:</strong> Basic to intermediate mathematical concepts necessary for various undergraduate programs.</li><li style="text-align: justify;"><strong>English Language:</strong> Improvement in writing, reading, and communication skills.</li><li style="text-align: justify;"><strong>Critical Thinking:</strong> Developing analytical and problem-solving skills.</li><li style="text-align: justify;"><strong>Subject-Specific Modules:</strong> Introductory courses in subjects relevant to the student's intended degree program.</li></ul><h4 style="text-align: justify;"><strong>Eligibility Criteria</strong></h4><p style="text-align: justify;">To enroll in a BPP, candidates generally need to meet the following criteria:</p><ul><li style="text-align: justify;"><strong>Educational Qualification:</strong> Students should have completed their 10+2 or equivalent. Some institutions may accept students with less formal qualifications based on their potential and readiness for higher education.</li><li style="text-align: justify;"><strong>Age Limit:</strong> There is usually no specific age limit, making the BPP accessible to a wide range of students, including those who have been out of education for some time.</li></ul><h4 style="text-align: justify;"><strong>Fee Structure</strong></h4><p style="text-align: justify;">The fee structure for a BPP varies depending on the institution and location. On average, the fees can range from INR 10,000 to INR 50,000 for the entire program. Scholarships and financial aid may be available for eligible students to help cover the costs.</p><h4 style="text-align: justify;"><strong>Benefits of BPP</strong></h4><p style="text-align: justify;">Enrolling in a Bachelor Preparatory Programme offers several benefits, including:</p><ul><li style="text-align: justify;"><strong>Academic Preparation:</strong> Provides a solid foundation in essential academic skills and knowledge required for undergraduate studies.</li><li style="text-align: justify;"><strong>Confidence Building:</strong> Helps students gain confidence in their ability to succeed in a bachelor's degree program.</li><li style="text-align: justify;"><strong>Improved Admission Chances:</strong> Enhances the chances of gaining admission to a bachelor's degree program by fulfilling preparatory requirements.</li><li style="text-align: justify;"><strong>Personalized Support:</strong> Offers personalized support and guidance from educators to address individual learning needs and challenges.</li></ul><h4 style="text-align: justify;"><strong>Career Prospects After BPP</strong></h4><p style="text-align: justify;">While the BPP itself does not directly lead to employment, it serves as a stepping stone to pursuing a bachelor’s degree in various fields. Successful completion of the BPP can open doors to various undergraduate programs and subsequently lead to diverse career opportunities based on the chosen field of study. Some potential career paths include:</p><ul><li style="text-align: justify;"><strong>Professional Roles:</strong> Depending on the undergraduate degree pursued, students can enter fields such as business, engineering, healthcare, arts, or sciences.</li><li style="text-align: justify;"><strong>Further Education:</strong> Graduates can pursue advanced degrees and specialized qualifications in their area of interest.</li></ul><h4 style="text-align: justify;"><strong>Conclusion</strong></h4><p style="text-align: justify;">The Bachelor Preparatory Programme (BPP) is an excellent option for students who need additional preparation before embarking on undergraduate studies. By providing essential academic skills and knowledge, the BPP helps students bridge the gap between high school and higher education, ensuring a smoother transition to their chosen bachelor’s degree program and future career opportunities.</p>			ASdasdasd						Active		Ibrahim	BPP-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Fee Structure</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Benefits of BPP</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Career Prospects After BPP</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h4>"}	54	{}	2024-08-21 06:37:51.623732	Add
BHM	 Bachelor of Hotel Management (BHM) is an undergraduate degree program that focuses on the management and operations of hotels, restaurants, and other hospitality businesses. It provides students with a comprehensive understanding of the various aspects of the hospitality industry, from front-of-house operations to back-of-house functions.		3 Years	756543	BHM: Launch Your Hospitality Career	Discover the BHM program, a gateway to a rewarding career in hospitality. Learn about course curriculum, career opportunities, and top universities. Gain the skills to excel in the hotel and tourism industry.	waqas_image.webp	Full Time 	Feature	ugCourses	\N	2024-08-22 10:50:21	<p data-sourcepos="3:1-3:21"><strong>BHM</strong><span> stands for </span><strong>Bachelor of Hotel Management</strong><span>.</span><span> It's an undergraduate degree program specifically designed to equip students with the knowledge and skills required to excel in the hospitality industry.</span><span> This field encompasses hotels,</span><span> restaurants,</span><span> resorts,</span><span> and other related businesses.</span></p><h2 data-sourcepos="5:1-5:21" class="">Why Choose a BHM?</h2><ul data-sourcepos="7:1-9:103"><li data-sourcepos="7:1-7:112"><strong>Growing Industry:</strong><span> The hospitality industry is a thriving sector with numerous job opportunities worldwide.</span></li><li data-sourcepos="8:1-8:139"><strong>Diverse Career Paths:</strong><span> A BHM degree opens doors to a wide range of careers,</span><span> from hotel management to event planning and culinary arts.</span></li><li data-sourcepos="9:1-9:103"><strong>Global Opportunities:</strong><span> The hospitality industry is international in nature,</span><span> offering opportunities to work in different countries and cultures.</span></li><li data-sourcepos="10:1-11:0"><strong>Customer-Centric Focus:</strong><span> BHM programs emphasize providing excellent customer service,</span><span> a fundamental aspect of the hospitality industry.</span></li></ul><h3 data-sourcepos="12:1-12:34" class="">Core Subjects in a BHM Program</h3><ul data-sourcepos="14:1-18:86"><li data-sourcepos="14:1-14:88"><strong>Hospitality Management:</strong><span> Principles of hotel management,</span><span> operations,</span><span> and marketing.</span></li><li data-sourcepos="15:1-15:85"><strong>Food and Beverage Management:</strong><span> Food safety,</span><span> menu planning,</span><span> and beverage service.</span></li><li data-sourcepos="16:1-16:95"><strong>Front Office Operations:</strong><span> Guest services,</span><span> reservations,</span><span> and check-in/check-out procedures.</span></li><li data-sourcepos="17:1-17:84"><strong>Housekeeping:</strong><span> Room management,</span><span> laundry operations,</span><span> and housekeeping standards.</span></li><li data-sourcepos="18:1-18:86"><strong>Event Management:</strong><span> Planning and organizing events,</span><span> such as conferences,</span><span> weddings,</span><span> and banquets.</span></li><li data-sourcepos="19:1-20:0"><strong>Culinary Arts:</strong><span> Basic cooking techniques,</span><span> food preparation,</span><span> and food presentation.</span></li></ul><h3 data-sourcepos="21:1-21:26" class="">Specializations in BHM</h3><ul data-sourcepos="23:1-27:0"><li data-sourcepos="23:1-23:126"><strong>Hotel Management:</strong><span> Managing all aspects of hotel operations,</span><span> including front office,</span><span> housekeeping,</span><span> and food and beverage.</span></li><li data-sourcepos="24:1-24:132"><strong>Food and Beverage Management:</strong><span> Focusing on food and beverage operations,</span><span> including menu development,</span><span> cost control,</span><span> and service.</span></li><li data-sourcepos="25:1-25:125"><strong>Event Management:</strong><span> Specializing in planning and executing events,</span><span> such as conferences,</span><span> weddings,</span><span> and corporate meetings.</span></li><li data-sourcepos="26:1-27:0"><strong>Tourism Management:</strong><span> Understanding the tourism industry,</span><span> destination marketing,</span><span> and tour operations.</span></li></ul><h3 data-sourcepos="28:1-28:35" class="">Career Opportunities with a BHM</h3><ul data-sourcepos="30:1-36:0"><li data-sourcepos="30:1-30:62"><strong>Hotel Manager:</strong><span> Managing all aspects of hotel operations.</span></li><li data-sourcepos="31:1-31:119"><strong>Restaurant Manager:</strong><span> Overseeing restaurant operations,</span><span> including menu development,</span><span> staffing,</span><span> and customer service.</span></li><li data-sourcepos="32:1-32:123"><strong>Event Planner:</strong><span> Planning and executing various types of events,</span><span> such as conferences,</span><span> weddings,</span><span> and corporate meetings.</span></li><li data-sourcepos="33:1-33:97"><strong>Food and Beverage Director:</strong><span> Managing all food and beverage operations in a hotel or resort.</span></li><li data-sourcepos="34:1-34:90"><strong>Tourism Manager:</strong><span> Promoting tourism destinations and organizing tours and activities.</span></li><li data-sourcepos="35:1-36:0"><strong>Hospitality Consultant:</strong><span> Providing expert advice and guidance to hospitality businesses.</span></li></ul><p data-sourcepos="37:1-37:266"><strong>In conclusion,</strong><span> a BHM degree provides a solid foundation for a successful career in the hospitality industry.</span><span> It equips students with the necessary knowledge and skills to excel in various roles and contribute to the growth and development of this dynamic sector.</span></p>			ASdasdasd						Active	TOC	Ibrahim	BHM-	{}	{"<h2 data-sourcepos=\\"5:1-5:21\\" class=\\"\\">Why Choose a BHM?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:34\\" class=\\"\\">Core Subjects in a BHM Program</h3>","<h3 data-sourcepos=\\"21:1-21:26\\" class=\\"\\">Specializations in BHM</h3>","<h3 data-sourcepos=\\"28:1-28:35\\" class=\\"\\">Career Opportunities with a BHM</h3>"}	{}	49	{}	2024-08-20 10:25:01.627758	Add
M.Sc.	A Master of Science (M.Sc.) degree is a postgraduate program designed to provide students with in-depth knowledge and advanced research skills in a specific scientific field. It builds upon the foundation of a Bachelor of Science (B.Sc.) degree and equips graduates for various career paths		2 Years	64365	A Crucial Element for Website Success	Elevate your career with a Master of Science (M.Sc.) degree. Explore a vast range of specializations, from biology to computer science. Gain advanced research skills and prepare for leadership roles.	master-of-science-m.sc_.jpg	Full Time 	Feature	pgCourses	1	2024-08-26 09:18:56	<p data-sourcepos="1:1-1:19" class="first-token"><span>A Master of Science (M.</span><span>Sc.</span><span>),</span><span> also sometimes abbreviated as MS,</span><span> M.</span><span>S.,</span><span> MSc,</span><span> M.</span><span>Sc.,</span><span> SM,</span><span> S.</span><span>M.,</span><span> ScM or Sc.</span><span> M.,</span><span> is a postgraduate degree program typically awarded for studies in science,</span><span> engineering,</span><span> and medicine.</span><span> It's a higher level of academic qualification compared to a Bachelor's degree (B.</span><span>Sc.</span><span> or BS).</span></p><h2 data-sourcepos="5:1-5:12"><strong>Purpose:</strong></h2><ul data-sourcepos="7:1-7:1"><li data-sourcepos="7:1-7:1"><span>Deepens knowledge and understanding in a specific scientific field.</span></li><li data-sourcepos="8:1-8:61"><span>Develops advanced research skills and analytical abilities.</span></li><li data-sourcepos="9:1-9:45"><span>Prepares graduates for careers in research,</span><span> academia,</span><span> or specialized professional roles in industry.</span></li></ul><p data-sourcepos="11:1-11:13"><strong>Duration:</strong></p><ul data-sourcepos="13:1-14:0"><li data-sourcepos="13:1-14:0"><span>Typically takes 1-2 years of full-time study after completing a Bachelor's degree.</span></li></ul><p data-sourcepos="15:1-15:15"><strong>Coursework:</strong></p><ul data-sourcepos="17:1-19:0"><li data-sourcepos="17:1-17:105"><span>May involve advanced coursework,</span><span> seminars,</span><span> research projects,</span><span> and potentially a thesis or dissertation.</span></li><li data-sourcepos="18:1-19:0"><span>Specific coursework varies depending on the chosen field of study within science or engineering.</span></li></ul><p data-sourcepos="20:1-20:26"><strong>Who Pursues an M.Sc.?:</strong></p><ul data-sourcepos="22:1-25:0"><li data-sourcepos="22:1-22:67"><span>Individuals seeking advanced knowledge and skills in their field.</span></li><li data-sourcepos="23:1-23:60"><span>Those aiming for research careers in academia or industry.</span></li><li data-sourcepos="24:1-25:0"><span>Professionals seeking career advancement by specializing in a specific scientific area.</span></li></ul><p data-sourcepos="26:1-26:19"><strong>Benefits of an M.Sc. Degree:</strong></p><ul data-sourcepos="28:1-32:0"><li data-sourcepos="28:1-28:52"><span>Increased job opportunities and earning potential.</span></li><li data-sourcepos="29:1-29:63"><span>Enhanced expertise and qualifications for research positions.</span></li><li data-sourcepos="30:1-30:74"><span>Greater ability to contribute to scientific advancements and innovation.</span></li><li data-sourcepos="31:1-32:0"><span>Improved critical thinking,</span><span> problem-solving,</span><span> and communication skills.</span></li></ul>			ASdasdasd						Active	TOC	Ibrahim	MSc	{}	{"<h2 data-sourcepos=\\"5:1-5:12\\"><strong>Purpose:</strong></h2>"}	{}	{}	50	{}	2024-08-20 10:36:46.874093	Add
MHM	Our Master of Healthcare Management (MHM) program is designed to equip you with the skills and knowledge needed to become a successful leader in the healthcare industry. Through a rigorous curriculum, you'll delve into the complexities of healthcare administration, strategic planning, financial management, and quality improvement.		2 Years	666665	MHM: Master of Healthcare Management - Your Path to Healthcare Leadership	Advance your healthcare career with our MHM program. Gain the essential skills and knowledge to manage healthcare organizations effectively, including strategic planning, financial management, and quality improvement.	images (9).png	0	Feature	pgCourses	1	2024-08-22 10:50:21	<p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">MHM typically stands for Master of Hospitality Management, a graduate degree focused on the hospitality industry. Here are some key points about MHM programs:</span><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">What is an MHM?</h2><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">The Master of Hospitality Management (MHM) is a specialized master's degree that prepares students for leadership roles in the hospitality industry.</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">It provides advanced education in areas such as hotel management, food and beverage operations, event planning, and tourism management.</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">MHM programs are designed for students who have an undergraduate degree in hospitality management or a related field and want to further their education and career prospects.</span></li></ul><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">Curriculum and Specializations</h2><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">MHM curricula cover topics such as hospitality operations, marketing, finance, human resources, and strategic management.</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Many programs offer specializations or concentrations in areas like:</span><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;"><ul class="list-disc" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0.75em 0px; padding: 0px; padding-inline-start: 1.625em;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Hotel management</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Restaurant management</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Event management</span></li><li index="3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Sustainable hospitality</span></li><li index="4" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Luxury hospitality</span></li></ul></span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Students typically complete a capstone project or thesis as part of their degree.</span></li></ul><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">Career Prospects</h2><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Graduates of MHM programs are prepared for management positions in various hospitality settings, including:</span><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;"><ul class="list-disc" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0.75em 0px; padding: 0px; padding-inline-start: 1.625em;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Hotels and resorts</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Restaurants and food service operations</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Event venues</span></li><li index="3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Tourism organizations</span></li><li index="4" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Hospitality consulting firms</span></li></ul></span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">The degree can lead to roles such as hotel general manager, food and beverage director, event planner, and hospitality consultant.</span></li></ul><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">Program Length and Format</h2><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">MHM programs typically take 1-2 years to complete, depending on whether students attend full-time or part-time.</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Many schools offer flexible options like evening, weekend, or online classes to accommodate working professionals.</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Some programs include an internship or industry experience component to provide practical, hands-on learning.</span></li></ul><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-bottom: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-size: 16px; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;">In summary, the Master of Hospitality Management is a specialized graduate degree that equips students with the advanced knowledge and skills needed to excel in leadership roles within the dynamic hospitality industry. Its curriculum and career prospects are tailored to the unique needs and opportunities of this fast-paced field.</span></p>			ASdasdasd						Active	TOC	Ibrahim	MHM-	{}	{"<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;\\">What is an MHM?</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;\\">Curriculum and Specializations</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;\\">Career Prospects</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-size: 1.125rem; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial;\\">Program Length and Format</h2>"}	{}	{}	51	{}	2024-08-20 13:02:16.336801	Add
This is Online Course46546 45 34 345345	This is Online Course BS in English		2 Years	534534	ghgfh	fghfghfgh	bright.png	Full Time 	Feature	ugCourses	\N	\N	<p>Enter Content Herehghgfhfgh fgdfg dfgdfgdfgghjhgjghjghjghjgfhgfh</p>									Active	TOC	\N	34234-4236546546	{}	{}	{}	{}	75	{}	2024-09-07 13:34:34.256316	Watch
BBA	The Bachelor of Business Administration (BBA) is a comprehensive undergraduate program designed to equip students with the knowledge and skills necessary for success in the business world.		3 Years	431212	BBA: Launch Your Business Career	Discover the BBA program, a stepping stone to a successful business career. Learn about course curriculum, career opportunities, and top universities. Gain the essential skills to excel in the corporate world.	download (4).jfif	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<p data-sourcepos="3:1-3:257" style="text-align: justify;"><strong>BBA</strong> stands for <strong>Bachelor of Business Administration</strong>. It's an undergraduate degree program <span class="citation-0 citation-end-0">designed to equip students with the fundamental knowledge and skills required to excel in various fields of business management and administration.<inline-footnote _nghost-ng-c3252873451="" ng-version="0.0.0-PLACEHOLDER"><!----><!----></inline-footnote></span><recitation-inline _nghost-ng-c1957539982="" ng-version="0.0.0-PLACEHOLDER"><sources-carousel-inline _ngcontent-ng-c1957539982="" _nghost-ng-c1662421645=""><span _ngcontent-ng-c1662421645="" class="button-container ng-star-inserted"> &nbsp; </span></sources-carousel-inline></recitation-inline></p><h2 data-sourcepos="5:1-5:21" style="text-align: justify;">Why Choose a BBA?</h2><ul data-sourcepos="7:1-11:0" style="text-align: justify;">\n<li data-sourcepos="7:1-7:154" style=""><strong>Versatile Career Paths:</strong> A BBA degree opens doors to a wide range of career opportunities in business, finance, marketing, human resources, and more.</li>\n<li data-sourcepos="8:1-8:132" style=""><strong>Strong Job Market:</strong> Businesses across industries constantly seek individuals with strong business acumen and management skills.</li>\n<li data-sourcepos="9:1-9:139" style=""><strong>Practical Skills:</strong> BBA programs emphasize practical application of theoretical concepts, preparing students for real-world challenges.</li>\n<li data-sourcepos="10:1-11:0" style=""><strong>Global Perspective:</strong> Many BBA programs include international business courses, fostering a global mindset.</li>\n</ul><h3 data-sourcepos="12:1-12:34" style="text-align: justify;">Core Subjects in a BBA Program</h3><ul data-sourcepos="14:1-19:0" style="text-align: justify;">\n<li data-sourcepos="14:1-14:105" style=""><strong>Business Administration:</strong> Principles of management, organizational behavior, and strategic planning.</li>\n<li data-sourcepos="15:1-15:65" style=""><strong>Finance:</strong> Accounting, financial management, and investments.</li>\n<li data-sourcepos="16:1-16:76" style=""><strong>Marketing:</strong> Market research, consumer behavior, and marketing strategy.</li>\n<li data-sourcepos="17:1-17:89" style=""><strong>Human Resource Management:</strong> Recruitment, employee relations, and talent development.</li>\n<li data-sourcepos="18:1-19:0" style=""><strong>Economics:</strong> Microeconomics and macroeconomics.</li>\n</ul><h3 data-sourcepos="20:1-20:26" style="text-align: justify;">Specializations in BBA</h3><ul data-sourcepos="22:1-27:0" style="text-align: justify;">\n<li data-sourcepos="22:1-22:58" style=""><strong>Marketing:</strong> Advertising, brand management, and sales.</li>\n<li data-sourcepos="23:1-23:77" style=""><strong>Finance:</strong> Corporate finance, financial analysis, and investment banking.</li>\n<li data-sourcepos="24:1-24:94" style=""><strong>Human Resources:</strong> Employee relations, talent acquisition, and organizational development.</li>\n<li data-sourcepos="25:1-25:83" style=""><strong>Entrepreneurship:</strong> Business planning, startup operations, and venture capital.</li>\n<li data-sourcepos="26:1-27:0" style=""><strong>International Business:</strong> Global markets, cross-cultural management, and international trade.</li>\n</ul><h3 data-sourcepos="28:1-28:35" style="text-align: justify;">Career Opportunities with a BBA</h3><ul data-sourcepos="30:1-35:0" style="text-align: justify;">\n<li data-sourcepos="30:1-30:103" style=""><strong>Management Positions:</strong> Business analyst, project manager, operations manager, and general manager.</li>\n<li data-sourcepos="31:1-31:89" style=""><strong>Finance Roles:</strong> Financial analyst, accountant, investment advisor, and risk manager.</li>\n<li data-sourcepos="32:1-32:102" style=""><strong>Marketing Careers:</strong> Marketing analyst, brand manager, sales manager, and market research analyst.</li>\n<li data-sourcepos="33:1-33:101" style=""><strong>Human Resources Roles:</strong> Recruiter, HR generalist, HR manager, and talent acquisition specialist.</li>\n<li data-sourcepos="34:1-35:0" style=""><strong>Entrepreneurship:</strong> Business owner, entrepreneur, and startup founder.</li>\n</ul><p data-sourcepos="36:1-36:231" style="text-align: justify;"><strong>In conclusion,</strong> a BBA degree provides a solid foundation for a successful career in the business world. It equips students with the necessary knowledge, skills, and practical experience to thrive in various roles and industries.</p>			ASdasdasd						Active	TOC	Ibrahim	BBA-	{}	{"<h2 data-sourcepos=\\"5:1-5:21\\" style=\\"text-align: justify;\\">Why Choose a BBA?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:34\\" style=\\"text-align: justify;\\">Core Subjects in a BBA Program</h3>","<h3 data-sourcepos=\\"20:1-20:26\\" style=\\"text-align: justify;\\">Specializations in BBA</h3>","<h3 data-sourcepos=\\"28:1-28:35\\" style=\\"text-align: justify;\\">Career Opportunities with a BBA</h3>"}	{}	45	{}	2024-08-20 09:52:09.306579	Add
M.Com	Master of Commerce (M.Com): Take your Commerce knowledge to the next level with an M.Com degree. Designed for graduates with a Bachelor's in Commerce (B.Com) or a related field, this program equips you with advanced skills and theoretical knowledge for a successful career in finance, accounting, and business management.		2 Years	56543	Boost Your Business Career: Master of Commerce (M.Com) Explained	Explore the M.Com program, a postgraduate degree for Commerce graduates. Learn about specializations, career prospects, top colleges, and how to excel in this in-demand field.	mcom.png	Full Time 	Feature	pgCourses	1	\N	<h2 style="text-align: justify;"><strong>Introduction</strong></h2><p style="text-align: justify;">A Bachelor of Science (BSc) degree is one of the most respected and versatile undergraduate programs available. It offers students the opportunity to delve deep into scientific and technical subjects, providing a strong foundation for various career paths. This article will provide a comprehensive overview of the BSc degree, covering everything from eligibility criteria to career opportunities, to help you make an informed decision about pursuing this degree.</p><p style="text-align: justify;"><strong>What is a BSc Degree?</strong></p><p style="text-align: justify;">A BSc, or Bachelor of Science, is an undergraduate degree that typically spans three to four years. It is designed to provide students with a rigorous education in various scientific disciplines, emphasizing both theoretical knowledge and practical skills. Unlike more general degrees, a BSc offers specialized coursework in fields such as physics, chemistry, biology, and computer science, preparing students for technical and research-oriented careers.</p><p style="text-align: justify;"><strong>Eligibility Criteria</strong></p><p style="text-align: justify;">To be eligible for a BSc program, candidates generally need to have completed their 12th grade or equivalent education with a focus on science subjects like physics, chemistry, and mathematics. The admission process may vary between institutions but usually involves submission of academic transcripts, meeting minimum grade requirements, and sometimes entrance exams, particularly for prestigious colleges and universities.</p><p style="text-align: justify;"><strong>Course Structure and Curriculum</strong></p><p style="text-align: justify;">The BSc program is structured over six to eight semesters, depending on the country and institution. The curriculum typically includes:</p><ul><li style="text-align: justify;"><strong>Core Subjects</strong>: Foundational courses in the chosen major (e.g., Physics, Chemistry, Biology).</li><li style="text-align: justify;"><strong>Electives</strong>: Courses from various disciplines that allow students to explore other areas of interest.</li><li style="text-align: justify;"><strong>Practical Labs and Research Projects</strong>: Hands-on experience through lab sessions, fieldwork, or research projects is often a significant component of the program.</li></ul><p style="text-align: justify;"><strong>Popular Specializations in BSc</strong></p><p style="text-align: justify;"><strong>BSc in Physics</strong></p><p style="text-align: justify;">Focuses on the fundamental principles of physics, covering topics such as mechanics, electromagnetism, thermodynamics, and quantum mechanics. It develops strong analytical and problem-solving skills.</p><p style="text-align: justify;"><strong>BSc in Chemistry</strong></p><p style="text-align: justify;">Covers the study of chemical reactions, molecular structure, and properties of substances. It includes organic, inorganic, physical, and analytical chemistry.</p><p style="text-align: justify;"><strong>BSc in Biology</strong></p><p style="text-align: justify;">Examines the study of living organisms, including botany, zoology, microbiology, and genetics. It provides a solid foundation for careers in healthcare, research, and environmental science.</p><p style="text-align: justify;"><strong>BSc in Mathematics</strong></p><p style="text-align: justify;">Focuses on mathematical theories, computational techniques, and their applications. It includes algebra, calculus, statistics, and applied mathematics.</p><p style="text-align: justify;"><strong>BSc in Computer Science</strong></p><p style="text-align: justify;">Emphasizes programming, algorithms, data structures, and software engineering. It prepares students for careers in software development, IT, and data science.</p><p style="text-align: justify;"><strong>BSc in Environmental Science</strong></p><p style="text-align: justify;">Studies the environment and solutions to environmental problems. It includes ecology, environmental policy, and sustainability.</p><p style="text-align: justify;"><strong>BSc in Biotechnology</strong></p><p style="text-align: justify;">Combines biology and technology to develop new products and processes. It covers genetics, molecular biology, and biochemistry.</p><p style="text-align: justify;"><strong>BSc in Microbiology</strong></p><p style="text-align: justify;">Focuses on microorganisms and their impact on humans, animals, plants, and the environment. It includes virology, bacteriology, and immunology.</p><p style="text-align: justify;"><strong>BSc in Nursing</strong></p><p style="text-align: justify;">Prepares students for careers in healthcare, focusing on patient care, medical procedures, and healthcare management.</p><p style="text-align: justify;"><strong>BSc in Agriculture</strong></p><p style="text-align: justify;">Covers the study of agricultural practices, crop production, and soil science. It prepares students for careers in agribusiness, research, and farm management.</p><p style="text-align: justify;"><strong>Top Colleges and Universities for BSc</strong></p><p style="text-align: justify;">Several prestigious institutions offer BSc programs known for their academic excellence and comprehensive curricula. Some top colleges include:</p><ul><li style="text-align: justify;">Indian Institute of Science (IISc)</li><li style="text-align: justify;">St. Stephen's College, Delhi</li><li style="text-align: justify;">University of Delhi</li><li style="text-align: justify;">University of Cambridge</li><li style="text-align: justify;">Harvard University</li><li style="text-align: justify;">Massachusetts Institute of Technology (MIT)</li></ul><p style="text-align: justify;">These institutions are renowned for their strong faculty, research opportunities, and vibrant campus life.</p><p style="text-align: justify;"><strong>Career Opportunities after BSc</strong></p><p style="text-align: justify;">Graduates with a BSc degree have a wide range of career opportunities across various fields. Some prominent roles include:</p><p style="text-align: justify;"><strong>Research Scientist</strong></p><p style="text-align: justify;">Conducting experiments and research in laboratories to advance scientific knowledge.</p><p style="text-align: justify;"><strong>Lab Technician</strong></p><p style="text-align: justify;">Assisting in laboratory research, performing tests, and maintaining lab equipment.</p><p style="text-align: justify;"><strong>Healthcare Professional</strong></p><p style="text-align: justify;">Working in healthcare settings as nurses, medical technologists, or other specialized roles.</p><p style="text-align: justify;"><strong>Environmental Consultant</strong></p><p style="text-align: justify;">Advising organizations on environmental practices and sustainability.</p><p style="text-align: justify;"><strong>Biotechnologist</strong></p><p style="text-align: justify;">Developing new products and technologies in pharmaceuticals, agriculture, and food industries.</p><p style="text-align: justify;"><strong>Data Analyst</strong></p><p style="text-align: justify;">Analyzing data to help businesses make informed decisions.</p><p style="text-align: justify;"><strong>Software Developer</strong></p><p style="text-align: justify;">Designing and developing software applications.</p><p style="text-align: justify;"><strong>Agricultural Scientist</strong></p><p style="text-align: justify;">Researching and developing agricultural practices to improve crop yield and sustainability.</p><p style="text-align: justify;"><strong>Salary Expectations</strong></p><p style="text-align: justify;">The average salary for BSc graduates varies based on factors such as specialization, location, and experience. Fresh graduates can expect to earn between INR 3-6 lakhs per annum. With experience and advanced skills, professionals can command higher salaries, especially in specialized fields like biotechnology and data science.</p><p style="text-align: justify;"><strong>Further Studies and Certifications</strong></p><p style="text-align: justify;">For those looking to further enhance their qualifications, pursuing a Master of Science (MSc) can open up advanced career opportunities. Additionally, professional certifications in related fields, such as data science, biotechnology, or environmental science, can add significant value to a BSc degree.</p><p style="text-align: justify;"><strong>Benefits of Pursuing a BSc Degree</strong></p><p style="text-align: justify;">Pursuing a BSc offers several benefits:</p><ul><li style="text-align: justify;"><strong>In-Depth Knowledge in Chosen Field</strong>: A BSc provides a comprehensive understanding of specific scientific disciplines.</li><li style="text-align: justify;"><strong>Development of Analytical and Research Skills</strong>: The program emphasizes critical thinking, problem-solving, and research methodologies.</li><li style="text-align: justify;"><strong>Wide Range of Career Options</strong>: Graduates can explore diverse career paths in research, healthcare, IT, and more.</li></ul>									Active	TOC	\N	M.Com-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Introduction</strong></h2>"}	{}	{}	27	{}	2024-08-13 11:41:02.401187	Add
DRM	A Diploma in Retail Management is a vocational qualification that provides students with a solid foundation in the principles and practices of retail operations. This program is designed to equip individuals with the necessary skills to manage various aspects of retail businesses, from store operations to customer service.		2 Years	65764	 Diploma in Retail Management: Your Gateway to a Thriving Career in Retail	Explore the Diploma in Retail Management program, a comprehensive course designed to equip you with the skills and knowledge needed to succeed in the retail industry. Learn about the curriculum, career opportunities, and admission requirements.	diploma-programs-retail-management.webp	Full Time 	Feature	Diploma	1	2024-09-02 17:22:39	<div class="flex max-w-full flex-col flex-grow"><div data-message-author-role="assistant" data-message-id="cf96fc84-3ebf-40c1-8b83-a8d3e2a05f36" dir="auto" class="min-h-[20px] text-message flex w-full flex-col items-end gap-2 break-words [.text-message+&amp;]:mt-5 overflow-x-auto whitespace-pre-wrap"><div class="flex w-full flex-col gap-1 empty:hidden first:pt-[3px]"><div class="markdown prose w-full break-words dark:prose-invert light"><p>The <strong>Diploma in Retail Management</strong> is a specialized program aimed at providing students with the essential knowledge and skills required to succeed in the dynamic and fast-paced retail industry. This course covers various aspects of retail operations, including store management, sales techniques, customer service, merchandising, and supply chain management.</p><h2><strong>Course Overview</strong></h2><p>The Diploma in Retail Management typically spans 1 to 2 years, depending on the institution and the mode of study (full-time or part-time). The program is designed to offer a blend of theoretical understanding and practical application, preparing students to manage retail businesses effectively.</p><h3><strong>Core Subjects</strong></h3><ol><li><p><strong>Introduction to Retail Management</strong></p><ul><li>Overview of the retail industry</li><li>Types of retail formats and their functions</li></ul></li><li><p><strong>Retail Operations and Store Management</strong></p><ul><li>Day-to-day management of retail stores</li><li>Inventory management, pricing, and store layout</li></ul></li><li><p><strong>Sales and Marketing Techniques</strong></p><ul><li>Strategies for increasing sales and customer engagement</li><li>Retail marketing campaigns, promotions, and branding</li></ul></li><li><p><strong>Customer Relationship Management (CRM)</strong></p><ul><li>Techniques for building and maintaining customer loyalty</li><li>Handling customer complaints and improving service quality</li></ul></li><li><p><strong>Merchandising and Visual Display</strong></p><ul><li>Principles of merchandising and product placement</li><li>Creating effective visual displays to attract customers</li></ul></li><li><p><strong>Supply Chain Management</strong></p><ul><li>Understanding the retail supply chain</li><li>Inventory control, logistics, and supplier relations</li></ul></li><li><p><strong>Retail Technology and E-Commerce</strong></p><ul><li>Role of technology in modern retail, including POS systems and online retailing</li><li>Managing e-commerce platforms and digital sales channels</li></ul></li><li><p><strong>Financial Management in Retail</strong></p><ul><li>Budgeting, financial analysis, and cost control in retail operations</li><li>Pricing strategies and profit maximization</li></ul></li><li><p><strong>Human Resource Management in Retail</strong></p><ul><li>Recruitment, training, and management of retail staff</li><li>Leadership skills and team management</li></ul></li></ol><h3><strong>Eligibility Criteria</strong></h3><p>To enroll in a Diploma in Retail Management program, candidates typically need:</p><ul><li>A high school diploma or equivalent (10+2) from a recognized board.</li><li>Some institutions may require a minimum percentage in the qualifying examination.</li></ul><h3><strong>Career Prospects</strong></h3><p>Graduates of the Diploma in Retail Management program can pursue various roles in the retail industry, including:</p><ul><li><strong>Store Manager:</strong> Overseeing the daily operations of a retail store, managing staff, and ensuring customer satisfaction.</li><li><strong>Retail Sales Executive:</strong> Driving sales, assisting customers, and managing product displays.</li><li><strong>Merchandiser:</strong> Planning and implementing merchandising strategies to optimize product placement and sales.</li><li><strong>Inventory Manager:</strong> Managing stock levels, ordering products, and coordinating with suppliers.</li><li><strong>Customer Service Manager:</strong> Ensuring high standards of customer service and handling customer inquiries and complaints.</li><li><strong>E-Commerce Manager:</strong> Managing online retail platforms, digital marketing, and online sales.</li></ul><h3><strong>Job Sectors</strong></h3><ul><li><strong>Retail Chains:</strong> Working in supermarkets, department stores, and specialty stores.</li><li><strong>E-Commerce Companies:</strong> Managing online retail operations and digital marketing strategies.</li><li><strong>Fashion Retail:</strong> Working in clothing stores, boutiques, and fashion chains.</li><li><strong>Consumer Goods:</strong> Managing sales and distribution of consumer products in retail outlets.</li><li><strong>Luxury Retail:</strong> Managing high-end retail stores and providing personalized customer service.</li></ul><h3><strong>Skills Acquired</strong></h3><ul><li><strong>Sales and Marketing:</strong> Understanding and applying sales strategies and marketing techniques to drive business growth.</li><li><strong>Customer Service:</strong> Enhancing the shopping experience and building strong customer relationships.</li><li><strong>Merchandising:</strong> Creating effective product displays and managing inventory to maximize sales.</li><li><strong>Retail Technology:</strong> Utilizing retail management systems, e-commerce platforms, and other digital tools.</li><li><strong>Leadership and Management:</strong> Leading teams, managing store operations, and making strategic decisions.</li></ul><h3><strong>Conclusion</strong></h3><p>A Diploma in Retail Management provides students with the knowledge and practical skills needed to excel in the retail industry. With the growing importance of customer experience and the expansion of e-commerce, this diploma offers a wide range of career opportunities in various sectors of retail. Graduates are well-equipped to take on leadership roles and contribute to the success of retail businesses.</p></div></div></div></div><div class="mt-1 flex gap-3 empty:hidden -ml-2"><div class="items-center justify-start rounded-xl p-1 flex"><div class="flex items-center"><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Read Aloud"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" fill-rule="evenodd" d="M11 4.91a.5.5 0 0 0-.838-.369L6.676 7.737A1 1 0 0 1 6 8H4a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2a1 1 0 0 1 .676.263l3.486 3.196A.5.5 0 0 0 11 19.09zM8.81 3.067C10.415 1.597 13 2.735 13 4.91v14.18c0 2.175-2.586 3.313-4.19 1.843L5.612 18H4a3 3 0 0 1-3-3V9a3 3 0 0 1 3-3h1.611zm11.507 3.29a1 1 0 0 1 1.355.401A10.96 10.96 0 0 1 23 12c0 1.85-.458 3.597-1.268 5.13a1 1 0 1 1-1.768-.934A8.96 8.96 0 0 0 21 12a8.96 8.96 0 0 0-1.085-4.287 1 1 0 0 1 .402-1.356M15.799 7.9a1 1 0 0 1 1.4.2 6.48 6.48 0 0 1 1.3 3.9c0 1.313-.39 2.537-1.06 3.56a1 1 0 0 1-1.673-1.096A4.47 4.47 0 0 0 16.5 12a4.47 4.47 0 0 0-.9-2.7 1 1 0 0 1 .2-1.4" clip-rule="evenodd"></path></svg></span></button></span><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Copy"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" fill-rule="evenodd" d="M7 5a3 3 0 0 1 3-3h9a3 3 0 0 1 3 3v9a3 3 0 0 1-3 3h-2v2a3 3 0 0 1-3 3H5a3 3 0 0 1-3-3v-9a3 3 0 0 1 3-3h2zm2 2h5a3 3 0 0 1 3 3v5h2a1 1 0 0 0 1-1V5a1 1 0 0 0-1-1h-9a1 1 0 0 0-1 1zM5 9a1 1 0 0 0-1 1v9a1 1 0 0 0 1 1h9a1 1 0 0 0 1-1v-9a1 1 0 0 0-1-1z" clip-rule="evenodd"></path></svg></span></button></span><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Regenerate"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" d="M3.07 10.876C3.623 6.436 7.41 3 12 3a9.15 9.15 0 0 1 6.012 2.254V4a1 1 0 1 1 2 0v4a1 1 0 0 1-1 1H15a1 1 0 1 1 0-2h1.957A7.15 7.15 0 0 0 12 5a7 7 0 0 0-6.946 6.124 1 1 0 1 1-1.984-.248m16.992 1.132a1 1 0 0 1 .868 1.116C20.377 17.564 16.59 21 12 21a9.15 9.15 0 0 1-6-2.244V20a1 1 0 1 1-2 0v-4a1 1 0 0 1 1-1h4a1 1 0 1 1 0 2H7.043A7.15 7.15 0 0 0 12 19a7 7 0 0 0 6.946-6.124 1 1 0 0 1 1.116-.868"></path></svg></span></button></span><div class="flex"><span class="" data-state="closed"><button class="rounded-lg text-token-text-secondary hover:bg-token-main-surface-secondary" aria-label="Bad response"><span class="flex h-[30px] w-[30px] items-center justify-center"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24" class="icon-md-heavy"><path fill="currentColor" fill-rule="evenodd" d="M11.873 21.496a1 1 0 0 1-.992.496l-.454-.056A4 4 0 0 1 7.1 16.79L7.65 15h-.718c-2.637 0-4.553-2.508-3.859-5.052l1.364-5A4 4 0 0 1 8.296 2h9.709a3 3 0 0 1 3 3v7a3 3 0 0 1-3 3h-2c-.26 0-.5.14-.628.364zM14.005 4h-5.71a2 2 0 0 0-1.929 1.474l-1.363 5A2 2 0 0 0 6.933 13h2.072a1 1 0 0 1 .955 1.294l-.949 3.084a2 2 0 0 0 1.462 2.537l3.167-5.543a2.72 2.72 0 0 1 1.364-1.182V5a1 1 0 0 0-1-1m3 9V5c0-.35-.06-.687-.171-1h1.17a1 1 0 0 1 1 1v7a1 1 0 0 1-1 1z" clip-rule="evenodd"></path></svg></span></button></span></div><span class="" data-state="closed"><button type="button" id="radix-:rk8:" aria-haspopup="menu" aria-expanded="false" data-state="closed" class="cursor-pointer h-[30px] rounded-md px-1 text-token-text-secondary hover:bg-token-main-surface-secondary"><div class="flex items-center pb-0"><div class="[&amp;_svg]:h-full [&amp;_svg]:w-full icon-md h-4 w-4"><svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" fill="none" viewBox="0 0 24 24"><path fill="currentColor" d="M19.898.855a.4.4 0 0 0-.795 0c-.123 1.064-.44 1.802-.943 2.305-.503.503-1.241.82-2.306.943a.4.4 0 0 0 .001.794c1.047.119 1.801.436 2.317.942.512.504.836 1.241.93 2.296a.4.4 0 0 0 .796 0c.09-1.038.413-1.792.93-2.308.515-.516 1.269-.839 2.306-.928a.4.4 0 0 0 .001-.797c-1.055-.094-1.792-.418-2.296-.93-.506-.516-.823-1.27-.941-2.317Z"></path><path fill="currentColor" d="M12.001 1.5a1 1 0 0 1 .993.887c.313 2.77 1.153 4.775 2.5 6.146 1.34 1.366 3.3 2.223 6.095 2.47a1 1 0 0 1-.003 1.993c-2.747.238-4.75 1.094-6.123 2.467-1.373 1.374-2.229 3.376-2.467 6.123a1 1 0 0 1-1.992.003c-.248-2.795-1.105-4.754-2.47-6.095-1.372-1.347-3.376-2.187-6.147-2.5a1 1 0 0 1-.002-1.987c2.818-.325 4.779-1.165 6.118-2.504 1.339-1.34 2.179-3.3 2.504-6.118A1 1 0 0 1 12 1.5ZM6.725 11.998c1.234.503 2.309 1.184 3.21 2.069.877.861 1.56 1.888 2.063 3.076.5-1.187 1.18-2.223 2.051-3.094.871-.87 1.907-1.55 3.094-2.05-1.188-.503-2.215-1.187-3.076-2.064-.885-.901-1.566-1.976-2.069-3.21-.505 1.235-1.19 2.3-2.081 3.192-.891.89-1.957 1.576-3.192 2.082Z"></path></svg></div></div></button></span></div></div></div>			ASdasdasd						Active		Ibrahim	DIPLOMA-IN-RETAIL-MANAGEMENT-	{}	{"<h2><strong>Course Overview</strong></h2>"}	{"<h3><strong>Core Subjects</strong></h3>","<h3><strong>Eligibility Criteria</strong></h3>","<h3><strong>Career Prospects</strong></h3>","<h3><strong>Job Sectors</strong></h3>","<h3><strong>Skills Acquired</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	64	{}	2024-08-23 09:43:12.470179	Add
MBA (Master of Business Administration)868678 54654 54654 6	67 75567 567567		4 Years	654654	456546	546546	academic.png	Full Time 	Feature	ugCourses	1	\N	<p>Enter Content Hereghfgh</p>									Active	TOC	\N	546456	{}	{}	{}	{}	78	{}	2024-09-07 13:39:58.679932	Watch
B.Tech	The B.Tech program equips students with the fundamental knowledge and practical skills necessary to excel in various engineering disciplines.		4 Years	532412	Unveiling the World of Innovation: A Comprehensive Guide to B.Tech	Demystify the B.Tech degree! Explore everything you need to know about this sought-after engineering program. Dive into specializations, career paths, and unlock your potential to become a future innovator.	BTech_Full_Form (1).webp	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<p><br><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">B.Tech is a four-year undergraduate program that equips students with the fundamental knowledge and practical skills necessary to excel in various engineering disciplines. The curriculum emphasizes a blend of theoretical concepts, hands-on learning, and problem-solving techniques. Throughout the program, students delve into areas like:&nbsp;&nbsp;</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Mathematics and Science:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Calculus, physics, chemistry – these form the bedrock of engineering</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Engineering Fundamentals:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Mechanics, thermodynamics, fluid mechanics – building blocks of engineering principles</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Discipline-Specific Courses:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Each specialization delves deeper into its core areas – e.g., electrical circuits in Electronics and Communication Engineering (ECE), data structures in Computer Science Engineering (CSE)</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Software Applications:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Learning industry-standard software programs like MATLAB, AutoCAD, SolidWorks – crucial for designing and simulating engineering solutions</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Communication and Technical Writing:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Effectively conveying technical concepts is essential for successful engineers&nbsp;&nbsp;</span></strong></p></li></ul><h2 dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Embracing Diversity: A World of Specializations</span></strong></h2><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">The beauty of B.Tech lies in its vast array of specializations, catering to diverse interests and career aspirations. Here's a glimpse into some popular B.Tech specializations:&nbsp;&nbsp;</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Computer Science Engineering (CSE):</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> This specialization focuses on the design, development, and implementation of software systems. From building websites and mobile apps to delving into artificial intelligence and machine learning, CSE graduates are at the forefront of the digital revolution.&nbsp;&nbsp;</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Electronics and Communication Engineering (ECE):</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> ECE deals with the design, development, and operation of electronic circuits, communication systems, and devices. This specialization opens doors to exciting fields like robotics, telecommunications, and embedded systems.&nbsp;&nbsp;</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Mechanical Engineering (ME):</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> The workhorse of engineering disciplines, ME focuses on the design, analysis, and manufacturing of mechanical systems – from automobiles and aircraft to robots and prosthetics.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Civil Engineering (CE):</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> CE is all about creating sustainable infrastructure solutions – buildings, bridges, roads, and dams. This specialization equips students with the knowledge to design, construct, and maintain the physical environment around us.</span></strong></p></li></ul><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">This is just the tip of the iceberg. B.Tech programs also offer specializations in areas like Chemical Engineering, Electrical Engineering, Biomedical Engineering, and many more.</span></strong></p><h3 dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Building a Stellar Career: Opportunities Abound</span></strong></h3><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">With a B.Tech degree, graduates are equipped to pursue a wide range of exciting and lucrative career paths. Some possibilities include:&nbsp;</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Core Engineering Roles:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Design and development engineers, project managers, quality control engineers, research and development professionals.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">IT and Software Industry:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Software developers, data analysts, cybersecurity specialists, systems engineers.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Government and Public Sector:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Urban planners, infrastructure development professionals, environmental engineers.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Higher Education and Research:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Pursue postgraduate studies and contribute to the advancement of engineering knowledge.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Entrepreneurship:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Utilize your technical expertise to develop innovative solutions and launch your own venture.</span></strong></p></li></ul><h3 dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">The Path to Success: Eligibility and Admissions</span></strong></h3><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">To pursue a B.Tech degree, students typically require a strong foundation in science and mathematics. They must have completed their Class 12 (Higher Secondary Education) with Physics, Chemistry, and Mathematics as core subjects. Additionally, many institutions require entrance exams specific to engineering programs, such as JEE Main, JEE Advanced, or state-level engineering entrance exams.&nbsp;&nbsp;</span></strong></p><h3 dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Beyond Academics: Embracing Holistic Development</span></strong></h3><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">While academic excellence forms the core of B.Tech, many institutions also encourage holistic development through various co-curricular activities. These may include:</span></strong></p><ul style="margin-top:0;margin-bottom:0;padding-inline-start:48px;"><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Technical Fests:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Participating in robot-building competitions, coding challenges, and design showcases helps students apply theoretical knowledge and develop practical skills.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:0pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Industry Internships:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Gaining real-world experience through internships allows students to understand industry practices and refine their skills.</span></strong></p></li><li dir="ltr" style="list-style-type: disc; font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre; font-size: 11pt;" aria-level="1"><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:0pt;margin-bottom:12pt;" role="presentation"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Clubs and Societies:</span><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;"> Participating in student-run engineering clubs or professional societies fosters teamwork, communication skills, and a sense of community.</span></strong></p></li></ul><h3 dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">Embrace the Challenge: A Rewarding Journey Awaits</span></strong></h3><p dir="ltr" style="line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;"><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><span style="font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 400; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;">The B.Tech program isn't for the faint of heart. It demands dedication, hard work, and a passion for innovation. However, for those who are up for the challenge, the rewards are immense. Graduates gain not only technical expertise but also critical thinking, problem-solving, and leadership skills that are valuable across numerous industries. They become the driving force behind technological advancements and contribute to shaping a better future.</span></strong></p><p><strong style="font-weight:normal;" id="docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395"><br></strong></p><p><br></p>			ASdasdasd						Active	TOC	Ibrahim	B.Tech-	{}	{"<h2 dir=\\"ltr\\" style=\\"line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;\\"><strong style=\\"font-weight:normal;\\" id=\\"docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395\\"><span style=\\"font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;\\">Embracing Diversity: A World of Specializations</span></strong></h2>"}	{"<h3 dir=\\"ltr\\" style=\\"line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;\\"><strong style=\\"font-weight:normal;\\" id=\\"docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395\\"><span style=\\"font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;\\">Building a Stellar Career: Opportunities Abound</span></strong></h3>","<h3 dir=\\"ltr\\" style=\\"line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;\\"><strong style=\\"font-weight:normal;\\" id=\\"docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395\\"><span style=\\"font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;\\">The Path to Success: Eligibility and Admissions</span></strong></h3>","<h3 dir=\\"ltr\\" style=\\"line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;\\"><strong style=\\"font-weight:normal;\\" id=\\"docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395\\"><span style=\\"font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;\\">Beyond Academics: Embracing Holistic Development</span></strong></h3>","<h3 dir=\\"ltr\\" style=\\"line-height:1.38;text-align: justify;margin-top:12pt;margin-bottom:12pt;\\"><strong style=\\"font-weight:normal;\\" id=\\"docs-internal-guid-c0668f4d-7fff-3b72-8e50-3de097fd0395\\"><span style=\\"font-family: Arial, sans-serif; color: rgb(0, 0, 0); background-color: transparent; font-weight: 700; font-style: normal; font-variant: normal; text-decoration: none; vertical-align: baseline; white-space: pre-wrap; font-size: 11pt;\\">Embrace the Challenge: A Rewarding Journey Awaits</span></strong></h3>"}	{}	43	{}	2024-08-20 06:25:25.475591	Add
BLibSc	After completing the B.Lib.Sc. program, graduates can pursue higher education such as a Master of Library Science (M.Lib.Sc.) or specialized courses in information science, digital librarianship, or archival studies. Advanced degrees and certifications can lead to higher positions and more specialized roles in the field.		2 Years	53241	Bachelor of Library Science (B.Lib.Sc.): Course Overview, Eligibility, Fees, and Career Opportunities	Explore the Bachelor of Library Science (B.Lib.Sc.) course, including its overview, eligibility criteria, fee structure, and the diverse career opportunities available in the field of library and information science.	b-lib-info-science-course-from-distance-education-in-delhi-500x500.webp	Full Time 	Feature	ugCourses	1	2024-08-22 10:00:26	<p>The Bachelor of Library Science (B.Lib.Sc.) is a one-year undergraduate program that prepares students for careers in library and information science. This course provides essential knowledge and skills required to manage library resources, organize information, and offer various library services. It is ideal for those who are passionate about books, information management, and helping others access knowledge.</p><h2><strong>Course Duration and Structure</strong></h2><p>The B.Lib.Sc. program typically lasts for one year, divided into two semesters. The curriculum covers a range of topics, including library management, cataloging and classification, information technology, reference services, and digital libraries. The course is designed to equip students with both theoretical knowledge and practical experience through projects and internships.</p><h4><strong>Eligibility Criteria</strong></h4><p>To enroll in a B.Lib.Sc. program, candidates must meet the following eligibility criteria:</p><ul><li><strong>Educational Qualification:</strong> Candidates should have completed their bachelor’s degree in any discipline from a recognized university with a minimum percentage, generally around 50%. Some institutions may have specific requirements or preferences for candidates with a background in humanities or social sciences.</li><li><strong>Entrance Examinations:</strong> While some universities offer direct admission based on merit, others may require candidates to pass entrance exams or interviews.</li></ul><h4><strong>Fee Structure</strong></h4><p>The fee structure for a B.Lib.Sc. program varies depending on the institution and location. On average, the fees can range from INR 10,000 to INR 50,000 for the entire course. Scholarships and financial aid may be available for eligible students.</p><h4><strong>Core Subjects in B.Lib.Sc.</strong></h4><p>The B.Lib.Sc. curriculum typically includes the following core subjects:</p><ul><li><strong>Library Management:</strong> Principles and practices of managing a library effectively.</li><li><strong>Cataloging and Classification:</strong> Techniques for organizing and classifying library materials.</li><li><strong>Information Technology:</strong> Use of digital tools and technologies in library science.</li><li><strong>Reference Services:</strong> Providing assistance to library users in finding information.</li><li><strong>Library Automation:</strong> Implementing automated systems in libraries.</li><li><strong>Digital Libraries:</strong> Managing and maintaining digital collections.</li></ul><h4><strong>Career Prospects after B.Lib.Sc.</strong></h4><p>Graduates of the B.Lib.Sc. program can pursue a variety of career paths in the field of library and information science. Some of the prominent roles include:</p><ul><li><strong>Librarian:</strong> Manage library resources, assist users, and oversee library operations in schools, colleges, public libraries, or research institutions.</li><li><strong>Information Analyst:</strong> Work in organizations to manage and analyze information resources.</li><li><strong>Archivist:</strong> Preserve and manage historical documents and records in archives or museums.</li><li><strong>Digital Librarian:</strong> Manage digital resources and collections in libraries or online platforms.</li><li><strong>Cataloger:</strong> Specialize in organizing and classifying library materials.</li><li><strong>Library Assistant:</strong> Support librarians in daily operations and user services.</li><li><strong>Knowledge Manager:</strong> Work in corporate or government sectors to manage information systems and databases.</li></ul><h4><strong>Higher Education and Further Studies</strong></h4><p>After completing the B.Lib.Sc. program, graduates can pursue higher education such as a Master of Library Science (M.Lib.Sc.) or specialized courses in information science, digital librarianship, or archival studies. Advanced degrees and certifications can lead to higher positions and more specialized roles in the field.</p><h4><strong>Conclusion</strong></h4><p>The Bachelor of Library Science (B.Lib.Sc.) is a gateway to a fulfilling career in the management and dissemination of information. With the growing importance of information in the digital age, professionals in this field are in demand across various sectors. The course provides a strong foundation for those who wish to contribute to the knowledge society and support lifelong learning.</p>			ASdasdasd						Active	TOC	Ibrahim	BACHELOR--OF-LIBRARY-SCIENCE-	{}	{"<h2><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4><strong>Eligibility Criteria</strong></h4>","<h4><strong>Fee Structure</strong></h4>","<h4><strong>Core Subjects in B.Lib.Sc.</strong></h4>","<h4><strong>Career Prospects after B.Lib.Sc.</strong></h4>","<h4><strong>Higher Education and Further Studies</strong></h4>",<h4><strong>Conclusion</strong></h4>}	53	{}	2024-08-21 06:16:56.020801	Add
B.Ed	The Bachelor of Education (B.Ed) is a professional degree designed to equip individuals with the skills and knowledge necessary to become effective teachers. The program combines theoretical studies in education with practical teaching experience. B.Ed graduates are qualified to teach in schools at various levels, from primary to secondary education.		2 Years		Master the Art of Teaching	Discover the B.Ed program, a gateway to a rewarding teaching career. Learn about course curriculum, eligibility, and career prospects. Gain the skills to inspire and educate future generations.	b-ed-500x500.webp	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<div _ngcontent-ng-c3577293974="" class="presented-response-container ng-tns-c3577293974-422"><div _ngcontent-ng-c3577293974="" selection="" class="response-container-content ng-tns-c3577293974-422 tunable-selection-with-avatar"><div _ngcontent-ng-c681339337="" class="response-content ng-tns-c3577293974-422"><message-content _ngcontent-ng-c681339337="" class="model-response-text ng-star-inserted" _nghost-ng-c3972157843="" id="message-content-id-r_e916cb0976f9e76c" style="height: auto;"><div _ngcontent-ng-c3972157843="" class="markdown markdown-main-panel" dir="ltr" style="--animation-duration: 600ms; --fade-animation-function: linear; --first-token-animation-duration: 600ms;"><p data-sourcepos="3:1-3:6"><strong>B.Ed</strong><span> stands for Bachelor of Education.</span><span> It is a professional degree program designed to equip individuals with the necessary skills and knowledge to become effective teachers.</span><span> This degree is essential for those aspiring to teach in schools,</span><span> colleges,</span><span> or universities.</span></p><h2 data-sourcepos="5:1-5:22" class="">Why Pursue a B.Ed?</h2><ul data-sourcepos="7:1-7:120"><li data-sourcepos="7:1-7:120"><strong>Career Opportunities:</strong><span> A B.</span><span>Ed degree opens doors to various teaching positions across different educational levels.</span></li><li data-sourcepos="8:1-8:133"><strong>Job Satisfaction:</strong><span> Teaching is a rewarding profession,</span><span> and a B.</span><span>Ed degree can help you make a positive impact on students' lives.</span></li><li data-sourcepos="9:1-9:26"><strong>Intellectual Growth:</strong><span> This program fosters critical thinking,</span><span> problem-solving,</span><span> and communication skills.</span></li><li data-sourcepos="10:1-11:0"><strong>Continuous Learning:</strong><span> Teachers are lifelong learners,</span><span> and a B.</span><span>Ed degree provides a strong foundation for professional development.</span></li></ul><h3 data-sourcepos="12:1-12:34" class="">Core Subjects in B.Ed Programs</h3><ul data-sourcepos="14:1-19:0"><li data-sourcepos="14:1-14:94"><strong>Educational Psychology:</strong><span> Understanding student behavior,</span><span> learning styles,</span><span> and motivation.</span></li><li data-sourcepos="15:1-15:82"><strong>Teaching Methodology:</strong><span> Learning effective teaching techniques and strategies.</span></li><li data-sourcepos="16:1-16:95"><strong>Curriculum Development:</strong><span> Designing and implementing relevant lesson plans and assessments.</span></li><li data-sourcepos="17:1-17:78"><strong>Educational Research:</strong><span> Conducting research to improve teaching practices.</span></li><li data-sourcepos="18:1-19:0"><strong>Subject-Specific Pedagogy:</strong><span> In-depth knowledge of specific subjects to teach effectively.</span></li></ul><h3 data-sourcepos="20:1-20:33" class="">Eligibility Criteria for B.Ed</h3><ul data-sourcepos="22:1-25:0"><li data-sourcepos="22:1-22:87"><strong>Academic Qualifications:</strong><span> Typically,</span><span> a Bachelor's degree in any field is required.</span></li><li data-sourcepos="23:1-23:84"><strong>Entrance Exams:</strong><span> Some institutions conduct entrance exams to select candidates.</span></li><li data-sourcepos="24:1-25:0"><strong>Minimum Marks:</strong><span> A minimum percentage of marks is usually specified.</span></li></ul><h3 data-sourcepos="26:1-26:27" class="">Specializations in B.Ed</h3><ul data-sourcepos="28:1-32:0"><li data-sourcepos="28:1-28:62"><strong>Primary Education:</strong><span> Focuses on teaching younger students.</span></li><li data-sourcepos="29:1-29:62"><strong>Secondary Education:</strong><span> Focuses on teaching older students.</span></li><li data-sourcepos="30:1-30:61"><strong>Special Education:</strong><span> Teaches students with special needs.</span></li><li data-sourcepos="31:1-32:0"><strong>Early Childhood Education:</strong><span> Teaches preschool and kindergarten students.</span></li></ul><h3 data-sourcepos="33:1-33:28" class="">Career Paths with a B.Ed</h3><ul data-sourcepos="35:1-35:63"><li data-sourcepos="35:1-35:63"><strong>School Teacher:</strong><span> Teaching in government or private schools.</span></li><li data-sourcepos="36:1-36:63"><strong>College Professor:</strong><span> Teaching at universities and colleges.</span></li><li data-sourcepos="37:1-37:72"><strong>Educational Administrator:</strong><span> Working in school administration roles.</span></li><li data-sourcepos="38:1-38:60"><strong>Private Tutor:</strong><span> Providing one-on-one tutoring services.</span></li><li data-sourcepos="39:1-40:0"><strong>Educational Researcher:</strong><span> Conducting research on education-related topics.</span></li></ul><p data-sourcepos="41:1-41:231"><strong>In conclusion,</strong><span> a B.</span><span>Ed degree is a valuable asset for individuals who want to pursue a career in education.</span><span> It provides the necessary skills and knowledge to become effective teachers and make a positive contribution to society.<tunable-selection-menu _ngcontent-ng-c3577293974="" data-test-id="tunable-selection-menu" class="tunable-selection-menu ng-tns-c3577293974-422 ng-star-inserted" _nghost-ng-c1667547723="" style="opacity: 1; left: 454.25px; top: 1464px;"></tunable-selection-menu></span></p></div></message-content></div></div></div>			ASdasdasd						Active	TOC	Ibrahim	B.Ed-	{}	{"<h2 data-sourcepos=\\"5:1-5:22\\" class=\\"\\">Why Pursue a B.Ed?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:34\\" class=\\"\\">Core Subjects in B.Ed Programs</h3>","<h3 data-sourcepos=\\"20:1-20:33\\" class=\\"\\">Eligibility Criteria for B.Ed</h3>","<h3 data-sourcepos=\\"26:1-26:27\\" class=\\"\\">Specializations in B.Ed</h3>","<h3 data-sourcepos=\\"33:1-33:28\\" class=\\"\\">Career Paths with a B.Ed</h3>"}	{}	44	{}	2024-08-20 09:48:24.421105	Add
BCA	The Bachelor of Computer Applications (BCA) is an undergraduate degree program specifically designed for students interested in computer applications and information technology. It provides a strong foundation in computer programming, software development, and database management.		2 Years	645631	BCA: A Stepping Stone to IT Careers	Discover the BCA program, a gateway to a successful career in information technology. Learn about course curriculum, career opportunities, and top universities. Gain the technical skills to excel in the IT industry.	bca-course-details.webp	Full Time 	Feature	ugCourses	1	2024-09-04 10:15:42	<p data-sourcepos="3:1-3:29"><strong>BCA</strong><span> stands for </span><strong>Bachelor of Computer Applications</strong><span>.</span><span> It's an undergraduate degree program specifically designed to provide students with a strong foundation in computer science and its applications.</span><span> This degree is ideal for those interested in pursuing careers in the information technology (IT) industry.</span></p><h2 data-sourcepos="5:1-5:21" class="">Why Choose a BCA?</h2><ul data-sourcepos="7:1-8:52"><li data-sourcepos="7:1-7:112"><strong>Growing Demand:</strong><span> The IT industry is constantly expanding,</span><span> creating a high demand for skilled professionals.</span></li><li data-sourcepos="8:1-8:52"><strong>Diverse Career Paths:</strong><span> A BCA degree opens doors to a wide range of IT careers,</span><span> from software development to network administration.</span></li><li data-sourcepos="9:1-9:111"><strong>Practical Skills:</strong><span> BCA programs emphasize practical skills and hands-on experience,</span><span> preparing students for real-world challenges.</span></li><li data-sourcepos="10:1-11:0"><strong>Continuous Learning:</strong><span> The IT industry is rapidly evolving,</span><span> and a BCA degree provides a solid foundation for lifelong learning.</span></li></ul><h3 data-sourcepos="12:1-12:34" class="">Core Subjects in a BCA Program</h3><ul data-sourcepos="14:1-20:27"><li data-sourcepos="14:1-14:79"><strong>Programming Languages:</strong><span> C,</span><span> C++,</span><span> Java,</span><span> Python,</span><span> and other popular languages.</span></li><li data-sourcepos="15:1-15:66"><strong>Computer Hardware:</strong><span> Components,</span><span> architecture,</span><span> and networking.</span></li><li data-sourcepos="16:1-16:51"><strong>Operating Systems:</strong><span> Windows,</span><span> Linux,</span><span> and macOS.</span></li><li data-sourcepos="17:1-17:51"><strong>Database Management:</strong><span> SQL and database design.</span></li><li data-sourcepos="18:1-18:78"><strong>Software Engineering:</strong><span> Software development methodologies and principles.</span></li><li data-sourcepos="19:1-19:58"><strong>Computer Graphics:</strong><span> Principles of 2D and 3D graphics.</span></li><li data-sourcepos="20:1-20:27"><strong>Web Development:</strong><span> HTML,</span><span> CSS,</span><span> and JavaScript.</span></li></ul><h3 data-sourcepos="22:1-22:26" class="">Specializations in BCA</h3><ul data-sourcepos="24:1-29:0"><li data-sourcepos="24:1-24:70"><strong>Software Development:</strong><span> Programming,</span><span> software design,</span><span> and testing.</span></li><li data-sourcepos="25:1-25:88"><strong>Database Administration:</strong><span> Database management,</span><span> data analysis,</span><span> and data warehousing.</span></li><li data-sourcepos="26:1-26:63"><strong>Networking:</strong><span> Network design,</span><span> administration,</span><span> and security.</span></li><li data-sourcepos="27:1-27:68"><strong>Web Development:</strong><span> Website design,</span><span> development,</span><span> and maintenance.</span></li><li data-sourcepos="28:1-29:0"><strong>Cybersecurity:</strong><span> Network security,</span><span> data protection,</span><span> and ethical hacking.</span></li></ul><h3 data-sourcepos="30:1-30:35" class="">Career Opportunities with a BCA</h3><ul data-sourcepos="32:1-34:65"><li data-sourcepos="32:1-32:83"><strong>Software Developer:</strong><span> Designing,</span><span> developing,</span><span> and testing software applications.</span></li><li data-sourcepos="33:1-33:76"><strong>Web Developer:</strong><span> Creating and maintaining websites and web applications.</span></li><li data-sourcepos="34:1-34:65"><strong>Database Administrator:</strong><span> Managing and maintaining databases.</span></li><li data-sourcepos="35:1-35:74"><strong>Network Administrator:</strong><span> Overseeing and maintaining computer networks.</span></li><li data-sourcepos="36:1-36:82"><strong>Systems Analyst:</strong><span> Analyzing business requirements and designing IT solutions.</span></li><li data-sourcepos="37:1-37:74"><strong>IT Consultant:</strong><span> Providing expert advice on IT systems and strategies.</span></li><li data-sourcepos="38:1-39:0"><strong>Cybersecurity Analyst:</strong><span> Protecting computer systems and networks from cyber threats.</span></li></ul><p data-sourcepos="40:1-40:221"><strong>In conclusion,</strong><span> a BCA degree offers a solid foundation for a successful career in the IT industry.</span><span> It equips students with the necessary technical skills and knowledge to thrive in this dynamic and ever-evolving field. 12 34</span></p>			ASdasdasd						Active	TOC	Ibrahim	BCA-	{}	{"<h2 data-sourcepos=\\"5:1-5:21\\" class=\\"\\">Why Choose a BCA?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:34\\" class=\\"\\">Core Subjects in a BCA Program</h3>","<h3 data-sourcepos=\\"22:1-22:26\\" class=\\"\\">Specializations in BCA</h3>","<h3 data-sourcepos=\\"30:1-30:35\\" class=\\"\\">Career Opportunities with a BCA</h3>"}	{}	46	{}	2024-08-20 09:55:32.715001	Add
B.Des	The Bachelor of Education (B.Ed) is a professional degree designed to equip individuals with the skills and knowledge necessary to become effective teachers. The program combines theoretical studies in education with practical teaching experience. B.Ed graduates are qualified to teach in schools at various levels, from primary to secondary education.		3 Years	45366	B.Des: Unleash Your Creative Potential	Discover the B.Ed program, a gateway to a rewarding teaching career. Learn about course curriculum, eligibility, and career prospects. Gain the skills to inspire and educate future generations.	bdes-fashion-design.webp	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<p data-sourcepos="3:1-3:9" style="text-align: justify;"><strong>B.Des</strong><span> stands for </span><strong>Bachelor of Design</strong><span>.</span><span> It's an undergraduate degree program that provides students with a comprehensive education in design principles,</span><span> techniques,</span><span> and methodologies.</span><span> This degree is ideal for individuals with a passion for creativity and a desire to pursue careers in various design fields.</span></p><h2 data-sourcepos="5:1-5:23" class="" style="text-align: justify;">Why Choose a B.Des?</h2><ul data-sourcepos="7:1-7:111"><li data-sourcepos="7:1-7:111" style="text-align: justify;"><strong>Creative Expression:</strong><span> A B.</span><span>Des degree allows you to explore your creativity and develop your design skills.</span></li><li data-sourcepos="8:1-8:148" style="text-align: justify;"><strong>Diverse Career Paths:</strong><span> The design field offers a wide range of career opportunities,</span><span> from graphic design to interior design and fashion design.</span></li><li data-sourcepos="9:1-9:23" style="text-align: justify;"><strong>In-Demand Skills:</strong><span> Design skills are highly sought after in various industries,</span><span> making B.</span><span>Des graduates valuable assets to organizations.</span></li><li data-sourcepos="10:1-11:0" style="text-align: justify;"><strong>Hands-On Experience:</strong><span> B.</span><span>Des programs often emphasize practical skills and hands-on projects,</span><span> preparing students for real-world design challenges.</span></li></ul><h3 data-sourcepos="12:1-12:36" class="" style="text-align: justify;">Core Subjects in a B.Des Program</h3><ul data-sourcepos="14:1-17:89"><li data-sourcepos="14:1-14:75" style="text-align: justify;"><strong>Design Principles:</strong><span> Elements of design,</span><span> composition,</span><span> and color theory.</span></li><li data-sourcepos="15:1-15:92" style="text-align: justify;"><strong>Drawing and Sketching:</strong><span> Technical drawing,</span><span> perspective drawing,</span><span> and freehand sketching.</span></li><li data-sourcepos="16:1-16:88" style="text-align: justify;"><strong>Computer-Aided Design (CAD):</strong><span> Software tools for creating and manipulating designs.</span></li><li data-sourcepos="17:1-17:89" style="text-align: justify;"><strong>Materials and Techniques:</strong><span> Understanding of various materials and design techniques.</span></li><li data-sourcepos="18:1-18:89" style="text-align: justify;"><strong>Design History and Theory:</strong><span> Historical context and theoretical frameworks of design.</span></li><li data-sourcepos="19:1-20:0" style="text-align: justify;"><strong>Project-Based Learning:</strong><span> Working on design projects to apply theoretical knowledge and develop practical skills.</span></li></ul><h3 data-sourcepos="21:1-21:28" class="" style="text-align: justify;">Specializations in B.Des</h3><ul data-sourcepos="23:1-28:23"><li data-sourcepos="23:1-23:96" style="text-align: justify;"><strong>Graphic Design:</strong><span> Designing visual communications,</span><span> such as logos,</span><span> branding,</span><span> and advertising.</span></li><li data-sourcepos="24:1-24:111" style="text-align: justify;"><strong>Interior Design:</strong><span> Designing the interior spaces of buildings,</span><span> including residential and commercial spaces.</span></li><li data-sourcepos="25:1-25:56" style="text-align: justify;"><strong>Fashion Design:</strong><span> Creating clothing and accessories.</span></li><li data-sourcepos="26:1-26:101" style="text-align: justify;"><strong>Product Design:</strong><span> Designing physical products,</span><span> such as furniture,</span><span> appliances,</span><span> and consumer goods.</span></li><li data-sourcepos="27:1-27:68" style="text-align: justify;"><strong>Animation:</strong><span> Creating animated films,</span><span> games,</span><span> and visual effects.</span></li><li data-sourcepos="28:1-28:23" style="text-align: justify;"><strong>User Experience (UX) Design:</strong><span> Designing digital interfaces that are easy to use and visually appealing.</span></li></ul><h3 data-sourcepos="30:1-30:37" class="" style="text-align: justify;">Career Opportunities with a B.Des</h3><ul data-sourcepos="32:1-40:0"><li data-sourcepos="32:1-32:83" style="text-align: justify;"><strong>Graphic Designer:</strong><span> Creating visual communications for print and digital media.</span></li><li data-sourcepos="33:1-33:68" style="text-align: justify;"><strong>Interior Designer:</strong><span> Designing the interior spaces of buildings.</span></li><li data-sourcepos="34:1-34:59" style="text-align: justify;"><strong>Fashion Designer:</strong><span> Designing clothing and accessories.</span></li><li data-sourcepos="35:1-35:52" style="text-align: justify;"><strong>Product Designer:</strong><span> Designing physical products.</span></li><li data-sourcepos="36:1-36:67" style="text-align: justify;"><strong>Animator:</strong><span> Creating animated films,</span><span> games,</span><span> and visual effects.</span></li><li data-sourcepos="37:1-37:66" style="text-align: justify;"><strong>User Experience (UX) Designer:</strong><span> Designing digital interfaces.</span></li><li data-sourcepos="38:1-38:71" style="text-align: justify;"><strong>Art Director:</strong><span> Overseeing the visual aspects of creative projects.</span></li><li data-sourcepos="39:1-40:0" style="text-align: justify;"><strong>Freelance Designer:</strong><span> Working as an independent designer for various clients.</span></li></ul><p data-sourcepos="41:1-41:267" style="text-align: justify;"><strong>In conclusion,</strong><span> a B.</span><span>Des degree provides a solid foundation for a creative and fulfilling career in the design field.</span><span> It equips students with the necessary skills and knowledge to excel in various design roles and make a significant impact on the world around them.</span></p>			ASdasdasd						Active	TOC	Ibrahim	B.Des	{}	{"<h2 data-sourcepos=\\"5:1-5:23\\" class=\\"\\" style=\\"text-align: justify;\\">Why Choose a B.Des?</h2>"}	{"<h3 data-sourcepos=\\"12:1-12:36\\" class=\\"\\" style=\\"text-align: justify;\\">Core Subjects in a B.Des Program</h3>","<h3 data-sourcepos=\\"21:1-21:28\\" class=\\"\\" style=\\"text-align: justify;\\">Specializations in B.Des</h3>","<h3 data-sourcepos=\\"30:1-30:37\\" class=\\"\\" style=\\"text-align: justify;\\">Career Opportunities with a B.Des</h3>"}	{}	48	{}	2024-08-20 10:11:07.458298	Add
MLibSc	The Master of Library and Information Science (MLibSc) program is a specialized postgraduate degree designed to equip professionals with the expertise to manage, organize, and disseminate information in various settings.		2 Years	43242	Master of Library and Information Science (MLibSc) Program	Discover the MLibSc program, designed to equip you with advanced knowledge and skills in library science, information management, and technology. Learn about the curriculum, career opportunities, and admission requirements.	images (25).jfif	Full Time 	Feature	pgCourses	1	\N	<div class="flex max-w-full flex-col flex-grow"><div data-message-author-role="assistant" data-message-id="62729a67-8133-4798-879d-9cfe3b5a0ffd" dir="auto" class="min-h-[20px] text-message flex w-full flex-col items-end gap-2 break-words [.text-message+&amp;]:mt-5 overflow-x-auto whitespace-pre-wrap"><div class="flex w-full flex-col gap-1 empty:hidden first:pt-[3px]"><div class="markdown prose w-full break-words dark:prose-invert light"><p>The <strong>Master of Library Science (MLibSc)</strong> is a postgraduate degree focused on advanced studies in library science and information management. This program is designed for individuals who aspire to pursue careers in libraries, information centers, or similar environments where managing and organizing information is key. Here’s an overview of the MLibSc program:</p><h2><strong>Course Overview</strong></h2><p>The MLibSc program typically spans 1 to 2 years, depending on the institution and mode of study (full-time or part-time). It covers a wide range of topics related to library and information science, including cataloging, classification, digital libraries, information retrieval, and library management. The course aims to equip students with the skills required to efficiently manage and organize information resources in various formats.</p><h3><strong>Core Subjects</strong></h3><ol><li><p><strong>Information Organization and Processing</strong></p><ul><li>Advanced cataloging and classification techniques</li><li>Metadata standards and practices</li></ul></li><li><p><strong>Information Retrieval Systems</strong></p><ul><li>Techniques for effective information search and retrieval</li><li>Use of digital tools and databases</li></ul></li><li><p><strong>Digital Libraries and E-Resources</strong></p><ul><li>Management of digital collections</li><li>Preservation of electronic resources</li></ul></li><li><p><strong>Library Management and Administration</strong></p><ul><li>Strategic planning and management in libraries</li><li>Human resources management and leadership in library settings</li></ul></li><li><p><strong>Research Methodology</strong></p><ul><li>Techniques for conducting research in library and information science</li><li>Data analysis and interpretation</li></ul></li><li><p><strong>Knowledge Management</strong></p><ul><li>Principles and practices of managing knowledge in organizations</li><li>Use of technology in knowledge dissemination</li></ul></li></ol><h3><strong>Specializations</strong></h3><p>Some institutions offer specializations within the MLibSc program, allowing students to focus on areas like:</p><ul><li><strong>Digital Libraries</strong></li><li><strong>Academic Libraries</strong></li><li><strong>Archival Studies</strong></li><li><strong>Information Technology in Libraries</strong></li></ul><h3><strong>Eligibility Criteria</strong></h3><p>To enroll in an MLibSc program, candidates typically need:</p><ul><li>A bachelor’s degree in Library Science (B.Lib.Sc or equivalent) from a recognized university.</li><li>Some institutions may also require a minimum percentage in the undergraduate degree and/or relevant work experience.</li></ul><h3><strong>Career Prospects</strong></h3><p>Graduates of the MLibSc program can pursue various roles, including:</p><ul><li><strong>Librarian:</strong> Working in academic, public, or special libraries, managing collections, and assisting patrons.</li><li><strong>Digital Archivist:</strong> Managing and preserving digital collections.</li><li><strong>Information Manager:</strong> Overseeing information systems and resources in corporate or governmental organizations.</li><li><strong>Academic Researcher:</strong> Conducting research in library and information science.</li><li><strong>Knowledge Manager:</strong> Developing and implementing knowledge management strategies in organizations.</li></ul><h3><strong>Job Sectors</strong></h3><ul><li><strong>Academic Institutions:</strong> Universities, colleges, and schools.</li><li><strong>Public Libraries:</strong> Serving the community with access to information resources.</li><li><strong>Corporate Libraries:</strong> Supporting research and information needs in business settings.</li><li><strong>Government Agencies:</strong> Managing information in public sector organizations.</li><li><strong>Non-Profit Organizations:</strong> Overseeing information resources for various causes.</li></ul><h3><strong>Conclusion</strong></h3><p>The Master of Library Science (MLibSc) is a valuable degree for those looking to advance their careers in library and information science. With the growing importance of digital information management, this program equips graduates with the skills needed to meet the evolving demands of the field, making them valuable assets in any information-centric organization.</p></div></div></div></div>									Active		\N	MLibSc-	{}	{"<h2><strong>Course Overview</strong></h2>"}	{"<h3><strong>Core Subjects</strong></h3>",<h3><strong>Specializations</strong></h3>,"<h3><strong>Eligibility Criteria</strong></h3>","<h3><strong>Career Prospects</strong></h3>","<h3><strong>Job Sectors</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	60	{}	2024-08-23 09:21:55.974685	Add
EXECUTIVE M.B.A	An Executive MBA (EMBA) is a specialized Master of Business Administration program designed for working professionals with significant experience in their respective fields. It offers a rigorous curriculum that combines theoretical knowledge with practical applications, equipping executives with the skills and insights needed to excel in leadership roles.		2 Years	45325	Executive MBA (EMBA): Course Overview, Eligibility, Fees, and Career Benefits	Discover the Executive MBA (EMBA) program, including its overview, eligibility requirements, fee structure, and the career benefits it offers for experienced professionals seeking advanced business management skills.	1643884234700.jfif	Full Time 	Feature	executiveEducation	1	2024-08-22 10:50:21	<p style="text-align: justify;">The Executive Master of Business Administration (EMBA) is a specialized MBA program designed for experienced professionals and executives seeking to advance their careers and leadership skills. The EMBA program focuses on providing high-level business management and strategic skills, tailored to the needs of working professionals who want to enhance their expertise without interrupting their careers.</p><h2 style="text-align: justify;"><strong>Course Duration and Structure</strong></h2><p style="text-align: justify;">The EMBA program typically spans 1 to 2 years, depending on the institution and format. The course structure is designed to accommodate the busy schedules of working professionals and usually includes:</p><ul><li style="text-align: justify;"><strong>Core Modules:</strong> Advanced business subjects such as Strategic Management, Financial Analysis, Marketing Management, Operations Management, and Leadership.</li><li style="text-align: justify;"><strong>Electives:</strong> Specialized courses in areas such as International Business, Innovation Management, or Entrepreneurship, allowing students to tailor their learning experience.</li><li style="text-align: justify;"><strong>Capstone Project:</strong> A practical project that involves solving real-world business problems or developing strategic plans, often in collaboration with companies.</li></ul><h4 style="text-align: justify;"><strong>Eligibility Criteria</strong></h4><p style="text-align: justify;">To be eligible for an EMBA program, candidates typically need to meet the following requirements:</p><ul><li style="text-align: justify;"><strong>Work Experience:</strong> A minimum of 5 to 10 years of professional experience, including managerial or supervisory roles.</li><li style="text-align: justify;"><strong>Educational Qualification:</strong> A bachelor’s degree or equivalent from a recognized institution.</li><li style="text-align: justify;"><strong>GMAT/GRE Scores:</strong> Some programs may require GMAT or GRE scores, though many EMBA programs waive this requirement for experienced professionals.</li><li style="text-align: justify;"><strong>Professional Achievements:</strong> Demonstrated career achievements, leadership experience, and potential for further career advancement.</li></ul><h4 style="text-align: justify;"><strong>Fee Structure</strong></h4><p style="text-align: justify;">The fee structure for an EMBA program varies widely depending on the institution, location, and program format. On average, the fees can range from INR 5,00,000 to INR 25,00,000 for the entire course. Many institutions offer payment plans, scholarships, and financial aid options to assist students.</p><h4 style="text-align: justify;"><strong>Program Format</strong></h4><p style="text-align: justify;">EMBA programs are designed to fit the schedules of working professionals and typically offer flexible formats such as:</p><ul><li style="text-align: justify;"><strong>Weekend Classes:</strong> Classes held on weekends to minimize disruption to work schedules.</li><li style="text-align: justify;"><strong>Evening Classes:</strong> Classes scheduled during evenings for professionals who work during the day.</li><li style="text-align: justify;"><strong>Modular Format:</strong> Intensive modules or residencies that require periodic attendance, allowing for greater flexibility.</li></ul><h4 style="text-align: justify;"><strong>Career Benefits and Opportunities</strong></h4><p style="text-align: justify;">An EMBA provides numerous benefits for career advancement, including:</p><ul><li style="text-align: justify;"><strong>Enhanced Leadership Skills:</strong> Develop advanced leadership and management skills necessary for executive roles.</li><li style="text-align: justify;"><strong>Strategic Thinking:</strong> Gain expertise in strategic planning and decision-making.</li><li style="text-align: justify;"><strong>Networking Opportunities:</strong> Connect with a diverse group of peers, faculty, and industry leaders, expanding your professional network.</li><li style="text-align: justify;"><strong>Career Advancement:</strong> Increase your potential for promotions, executive positions, or career changes.</li><li style="text-align: justify;"><strong>Global Perspective:</strong> Acquire a global business perspective, beneficial for international business roles.</li></ul><h4 style="text-align: justify;"><strong>Conclusion</strong></h4><p style="text-align: justify;">The Executive MBA (EMBA) is an excellent choice for experienced professionals seeking to elevate their careers and gain advanced business skills. With a focus on strategic management and leadership, the EMBA equips professionals with the tools needed to excel in high-level roles and drive organizational success. The flexible format and comprehensive curriculum make it a valuable investment for career growth and development.</p>			ASdasdasd						Active		Ibrahim	EXECUTIVE-M.B.A-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Fee Structure</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Program Format</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Career Benefits and Opportunities</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h4>"}	56	{}	2024-08-21 06:53:01.658777	Add
BA	This course will provide you with a comprehensive overview of the most sought-after science courses available after completing your 12th grade. We will delve into a variety of science disciplines, including:		4 Years	43214	BA Courses After 12th: Explore Your Passion in Arts and Humanities	Discover the best science courses to pursue after 12th class. Explore top universities, career paths, and job opportunities in various science fields. Make informed decisions for your future.	ba-1 (1).webp	Full Time 	Feature	ugCourses	1	\N	<h2 style="text-align: justify;"><strong>Introduction</strong></h2><p style="text-align: justify;">A Bachelor of Arts (BA) degree is one of the most popular and versatile undergraduate programs available. It offers students the opportunity to study a wide range of subjects in the humanities, social sciences, and liberal arts. This article will provide a comprehensive overview of the BA degree, covering everything from eligibility criteria to career opportunities, to help you make an informed decision about pursuing this degree.</p><p style="text-align: justify;"><strong>What is a BA Degree?</strong></p><p style="text-align: justify;">A BA, or Bachelor of Arts, is an undergraduate degree that typically spans three to four years. It is designed to provide students with a broad education in various disciplines, emphasizing critical thinking, communication skills, and cultural awareness. Unlike more specialized degrees, a BA offers flexibility and a wide range of elective courses, allowing students to tailor their education to their interests and career goals.</p><p style="text-align: justify;"><strong>Eligibility Criteria</strong></p><p style="text-align: justify;">To be eligible for a BA program, candidates generally need to have completed their 12th grade or equivalent education from a recognized board. The admission process may vary between institutions but usually involves submission of academic transcripts, meeting minimum grade requirements, and sometimes entrance exams or interviews, particularly for prestigious colleges and universities.</p><p style="text-align: justify;"><strong>Course Structure and Curriculum</strong></p><p style="text-align: justify;">The BA program is structured over six to eight semesters, depending on the country and institution. The curriculum typically includes:</p><ul><li style="text-align: justify;"><strong>Core Subjects</strong>: Foundational courses in the chosen major (e.g., English, History, Psychology).</li><li style="text-align: justify;"><strong>Electives</strong>: Courses from various disciplines that allow students to explore other areas of interest.</li><li style="text-align: justify;"><strong>Internships and Projects</strong>: Practical experience through internships, fieldwork, or research projects is often encouraged or required.</li></ul><p style="text-align: justify;"><strong>Popular Specializations in BA</strong></p><p style="text-align: justify;"><strong>English Literature</strong></p><p style="text-align: justify;">Focuses on the study of literature, literary theory, and criticism. Students explore various genres, periods, and authors, developing strong analytical and writing skills.</p><p style="text-align: justify;"><strong>History</strong></p><p style="text-align: justify;">Covers the study of historical events, periods, and figures. It helps students understand the past's impact on the present and future.</p><p style="text-align: justify;"><strong>Psychology</strong></p><p style="text-align: justify;">Examines human behavior, mental processes, and emotional responses. It includes topics like cognitive psychology, developmental psychology, and abnormal psychology.</p><p style="text-align: justify;"><strong>Political Science</strong></p><p style="text-align: justify;">Studies the theory and practice of politics, government systems, and political behavior. It includes topics like international relations, political theory, and public administration.</p><p style="text-align: justify;"><strong>Economics</strong></p><p style="text-align: justify;">Focuses on the study of economic systems, theories, and policies. It includes microeconomics, macroeconomics, and econometrics.</p><p style="text-align: justify;"><strong>Sociology</strong></p><p style="text-align: justify;">Explores the structure and dynamics of societies, social institutions, and social relationships. It includes topics like social theory, research methods, and social stratification.</p><p style="text-align: justify;"><strong>Philosophy</strong></p><p style="text-align: justify;">Investigates fundamental questions about existence, knowledge, values, and reason. It includes areas like ethics, metaphysics, and logic.</p><p style="text-align: justify;"><strong>Fine Arts</strong></p><p style="text-align: justify;">Covers the study of visual arts, including painting, sculpture, and photography. It often includes practical studio work and art history.</p><p style="text-align: justify;"><strong>Journalism and Mass Communication</strong></p><p style="text-align: justify;">Focuses on media studies, journalism practices, and communication theories. It includes topics like reporting, editing, media ethics, and digital media.</p><p style="text-align: justify;"><strong>Top Colleges and Universities for BA</strong></p><p style="text-align: justify;">Several prestigious institutions offer BA programs known for their academic excellence and comprehensive curricula. Some top colleges include:</p><ul><li style="text-align: justify;">University of Delhi</li><li style="text-align: justify;">Jawaharlal Nehru University (JNU)</li><li style="text-align: justify;">University of Mumbai</li><li style="text-align: justify;">University of California, Berkeley</li><li style="text-align: justify;">Harvard University</li><li style="text-align: justify;">University of Oxford</li></ul><p style="text-align: justify;">These institutions are renowned for their strong faculty, research opportunities, and vibrant campus life.</p><p style="text-align: justify;"><strong>Career Opportunities after BA</strong></p><p style="text-align: justify;">Graduates with a BA degree have a wide range of career opportunities across various fields. Some prominent roles include:</p><p style="text-align: justify;"><strong>Content Writer</strong></p><p style="text-align: justify;">Creating engaging and informative content for websites, blogs, and social media.</p><p style="text-align: justify;"><strong>Journalist</strong></p><p style="text-align: justify;">Reporting news, conducting interviews, and writing articles for newspapers, magazines, or online media.</p><p style="text-align: justify;"><strong>Teacher</strong></p><p style="text-align: justify;">Teaching subjects related to their specialization in schools, colleges, or universities.</p><p style="text-align: justify;"><strong>Psychologist</strong></p><p style="text-align: justify;">Working in clinical, counseling, or research settings to help individuals with mental health issues.</p><p style="text-align: justify;"><strong>Social Worker</strong></p><p style="text-align: justify;">Providing support and services to individuals and communities in need.</p><p style="text-align: justify;"><strong>Public Relations Specialist</strong></p><p style="text-align: justify;">Managing the public image and communications for organizations or individuals.</p><p style="text-align: justify;"><strong>Human Resources Specialist</strong></p><p style="text-align: justify;">Handling recruitment, employee relations, and organizational development.</p><p style="text-align: justify;"><strong>Civil Services</strong></p><p style="text-align: justify;">Working in various administrative roles within government agencies.</p><p style="text-align: justify;"><strong>Salary Expectations</strong></p><p style="text-align: justify;">The average salary for BA graduates varies based on factors such as specialization, location, and experience. Fresh graduates can expect to earn between INR 2-5 lakhs per annum. With experience and advanced skills, professionals can command higher salaries, especially in fields like journalism, public relations, and human resources.</p><p style="text-align: justify;"><strong>Further Studies and Certifications</strong></p><p style="text-align: justify;">For those looking to further enhance their qualifications, pursuing a Master of Arts (MA) can open up advanced career opportunities. Additionally, professional certifications in related fields, such as digital marketing, public relations, or human resources, can add significant value to a BA degree.</p><p style="text-align: justify;"><strong>Benefits of Pursuing a BA Degree</strong></p><p style="text-align: justify;">Pursuing a BA offers several benefits:</p><ul><li style="text-align: justify;"><strong>Broad Knowledge Base</strong>: A BA provides a comprehensive understanding of various subjects, fostering intellectual curiosity and versatility.</li><li style="text-align: justify;"><strong>Development of Critical Thinking and Communication Skills</strong>: The program emphasizes analytical thinking, problem-solving, and effective communication.</li><li style="text-align: justify;"><strong>Flexibility in Career Choices</strong>: Graduates can explore diverse career paths and industries.</li></ul><p style="text-align: justify;"><strong>Challenges in Pursuing a BA Degree</strong></p><p style="text-align: justify;">While a BA degree offers numerous advantages, it also comes with challenges:</p><ul><li style="text-align: justify;"><strong>Perception of Limited Career Options</strong>: Some may perceive a BA as less specialized, potentially affecting initial job prospects.</li><li style="text-align: justify;"><strong>Need for Additional Qualifications for Certain Careers</strong>: Certain career paths may require further education or specialized certifications.</li></ul><p style="text-align: justify;"><strong>Tips for Success in BA</strong></p><p style="text-align: justify;">To succeed in a BA program, consider the following tips:</p><ul><li style="text-align: justify;"><strong>Effective Study Habits</strong>: Develop a consistent study schedule and utilize available resources, such as libraries and online databases.</li><li style="text-align: justify;"><strong>Importance of Internships and Practical Experience</strong>: Gain hands-on experience through internships and volunteer work.</li><li style="text-align: justify;"><strong>Networking and Professional Development</strong>: Join student organizations, attend seminars, and connect with professionals in your field of interest.</li></ul><p style="text-align: justify;"><strong>Conclusion</strong></p><p style="text-align: justify;">The BA degree is a valuable investment for those seeking a broad education and versatile career options. With a wide range of specializations and career opportunities, BA graduates are well-equipped to meet the demands of various industries. By choosing the right program and staying committed to continuous learning, you can achieve significant success in this dynamic field.</p>									Active	TOC	\N	BA-	{}	{<h2><strong>Introduction</strong></h2>}	{}	{}	25	{}	2024-08-13 11:41:02.401187	Add
BSC 	A BSc degree provides a strong foundation in scientific principles and prepares you for a variety of career paths. With a wide range of specializations available, there's a BSc course to match your interests.		4 Years	3525	BSc Courses After 12th: Explore Your Science Passion	Discover the best BSc courses to pursue after 12th. Explore diverse fields like science, agriculture, IT, and healthcare. Find top colleges, career paths, and job opportunities.	b-sc-500x500.webp	Full Time 	Feature	ugCourses	1	\N	<h2>Introducation&nbsp;</h2><p>A Bachelor of Science (BSc) degree is one of the most respected and versatile undergraduate programs available. It offers students the opportunity to delve deep into scientific and technical subjects, providing a strong foundation for various career paths. This article will provide a comprehensive overview of the BSc degree, covering everything from eligibility criteria to career opportunities, to help you make an informed decision about pursuing this degree.</p><p><strong>What is a BSc Degree?</strong></p><p>A BSc, or Bachelor of Science, is an undergraduate degree that typically spans three to four years. It is designed to provide students with a rigorous education in various scientific disciplines, emphasizing both theoretical knowledge and practical skills. Unlike more general degrees, a BSc offers specialized coursework in fields such as physics, chemistry, biology, and computer science, preparing students for technical and research-oriented careers.</p><p><strong>Eligibility Criteria</strong></p><p>To be eligible for a BSc program, candidates generally need to have completed their 12th grade or equivalent education with a focus on science subjects like physics, chemistry, and mathematics. The admission process may vary between institutions but usually involves submission of academic transcripts, meeting minimum grade requirements, and sometimes entrance exams, particularly for prestigious colleges and universities.</p><p><strong>Course Structure and Curriculum</strong></p><p>The BSc program is structured over six to eight semesters, depending on the country and institution. The curriculum typically includes:</p><ul><li><strong>Core Subjects</strong>: Foundational courses in the chosen major (e.g., Physics, Chemistry, Biology).</li><li><strong>Electives</strong>: Courses from various disciplines that allow students to explore other areas of interest.</li><li><strong>Practical Labs and Research Projects</strong>: Hands-on experience through lab sessions, fieldwork, or research projects is often a significant component of the program.</li></ul><p><strong>Popular Specializations in BSc</strong></p><p><strong>BSc in Physics</strong></p><p>Focuses on the fundamental principles of physics, covering topics such as mechanics, electromagnetism, thermodynamics, and quantum mechanics. It develops strong analytical and problem-solving skills.</p><p><strong>BSc in Chemistry</strong></p><p>Covers the study of chemical reactions, molecular structure, and properties of substances. It includes organic, inorganic, physical, and analytical chemistry.</p><p><strong>BSc in Biology</strong></p><p>Examines the study of living organisms, including botany, zoology, microbiology, and genetics. It provides a solid foundation for careers in healthcare, research, and environmental science.</p><p><strong>BSc in Mathematics</strong></p><p>Focuses on mathematical theories, computational techniques, and their applications. It includes algebra, calculus, statistics, and applied mathematics.</p><p><strong>BSc in Computer Science</strong></p><p>Emphasizes programming, algorithms, data structures, and software engineering. It prepares students for careers in software development, IT, and data science.</p><p><strong>BSc in Environmental Science</strong></p><p>Studies the environment and solutions to environmental problems. It includes ecology, environmental policy, and sustainability.</p><p><strong>BSc in Biotechnology</strong></p><p>Combines biology and technology to develop new products and processes. It covers genetics, molecular biology, and biochemistry.</p><p><strong>BSc in Microbiology</strong></p><p>Focuses on microorganisms and their impact on humans, animals, plants, and the environment. It includes virology, bacteriology, and immunology.</p><p><strong>BSc in Nursing</strong></p><p>Prepares students for careers in healthcare, focusing on patient care, medical procedures, and healthcare management.</p><p><strong>BSc in Agriculture</strong></p><p>Covers the study of agricultural practices, crop production, and soil science. It prepares students for careers in agribusiness, research, and farm management.</p><p><strong>Top Colleges and Universities for BSc</strong></p><p>Several prestigious institutions offer BSc programs known for their academic excellence and comprehensive curricula. Some top colleges include:</p><ul><li>Indian Institute of Science (IISc)</li><li>St. Stephen's College, Delhi</li><li>University of Delhi</li><li>University of Cambridge</li><li>Harvard University</li><li>Massachusetts Institute of Technology (MIT)</li></ul><p>These institutions are renowned for their strong faculty, research opportunities, and vibrant campus life.</p><p><strong>Career Opportunities after BSc</strong></p><p>Graduates with a BSc degree have a wide range of career opportunities across various fields. Some prominent roles include:</p><p><strong>Research Scientist</strong></p><p>Conducting experiments and research in laboratories to advance scientific knowledge.</p><p><strong>Lab Technician</strong></p><p>Assisting in laboratory research, performing tests, and maintaining lab equipment.</p><p><strong>Healthcare Professional</strong></p><p>Working in healthcare settings as nurses, medical technologists, or other specialized roles.</p><p><strong>Environmental Consultant</strong></p><p>Advising organizations on environmental practices and sustainability.</p><p><strong>Biotechnologist</strong></p><p>Developing new products and technologies in pharmaceuticals, agriculture, and food industries.</p><p><strong>Data Analyst</strong></p><p>Analyzing data to help businesses make informed decisions.</p><p><strong>Software Developer</strong></p><p>Designing and developing software applications.</p><p><strong>Agricultural Scientist</strong></p><p>Researching and developing agricultural practices to improve crop yield and sustainability.</p><p><strong>Salary Expectations</strong></p><p>The average salary for BSc graduates varies based on factors such as specialization, location, and experience. Fresh graduates can expect to earn between INR 3-6 lakhs per annum. With experience and advanced skills, professionals can command higher salaries, especially in specialized fields like biotechnology and data science.</p><p><strong>Further Studies and Certifications</strong></p><p>For those looking to further enhance their qualifications, pursuing a Master of Science (MSc) can open up advanced career opportunities. Additionally, professional certifications in related fields, such as data science, biotechnology, or environmental science, can add significant value to a BSc degree.</p><p><strong>Benefits of Pursuing a BSc Degree</strong></p><p>Pursuing a BSc offers several benefits:</p><ul><li><strong>In-Depth Knowledge in Chosen Field</strong>: A BSc provides a comprehensive understanding of specific scientific disciplines.</li><li><strong>Development of Analytical and Research Skills</strong>: The program emphasizes critical thinking, problem-solving, and research methodologies.</li><li><strong>Wide Range of Career Options</strong>: Graduates can explore diverse career paths in research, healthcare, IT, and more.</li></ul><p><strong>Challenges in Pursuing a BSc Degree</strong></p><p>While a BSc degree offers numerous advantages, it also comes with challenges:</p><ul><li><strong>Intense Coursework and Study Load</strong>: The program is rigorous and requires a strong commitment to succeed.</li><li><strong>Staying Updated with Scientific Advancements</strong>: The field of science is constantly evolving, necessitating continuous learning and adaptation.</li></ul>									Active	TOC	\N	BSC--	{}	{}	{}	{}	26	{}	2024-08-13 11:41:02.401187	Add
DYT	A Diploma in Yoga Teacher Training is a vocational qualification that provides students with a strong foundation in yoga philosophy, asanas (poses), pranayama (breathing techniques), and meditation. This program is designed to develop individuals' teaching abilities and prepare them to lead yoga classes effectively.		2 Years	45361	Diploma in Yoga Teacher Training: Ignite Your Passion for Yoga	Discover the Diploma in Yoga Teacher Training program, a comprehensive course that equips you with the skills and knowledge to become a certified yoga instructor. Learn about the curriculum, career opportunities, and admission requirements.	shutter-stock-1-1-e1630580051421.jpg	Full Time 	Feature	Diploma	1	2024-09-02 17:22:39	<p>The <strong>Diploma in Yoga Teacher Training</strong> is a specialized program designed to prepare individuals to become certified yoga instructors. This program provides in-depth knowledge of yoga practices, philosophies, and teaching methodologies, enabling students to guide others in the practice of yoga for physical, mental, and spiritual well-being.</p><h2><strong>Course Overview</strong></h2><p>The Diploma in Yoga Teacher Training typically spans 6 months to 1 year, depending on the institution and the course structure. The program combines theoretical lessons with extensive practical training, ensuring that students are well-equipped to teach yoga to a diverse range of individuals.</p><h3><strong>Core Subjects</strong></h3><ol><li><p><strong>Introduction to Yoga</strong></p><ul><li>History and philosophy of yoga</li><li>Overview of different styles and traditions of yoga (Hatha, Ashtanga, Vinyasa, etc.)</li></ul></li><li><p><strong>Asanas (Postures)</strong></p><ul><li>Detailed study and practice of various yoga postures</li><li>Alignment, benefits, and contraindications of each asana</li></ul></li><li><p><strong>Pranayama (Breathing Techniques)</strong></p><ul><li>Techniques for controlling and regulating the breath</li><li>Benefits of pranayama for physical and mental health</li></ul></li><li><p><strong>Meditation and Relaxation Techniques</strong></p><ul><li>Various forms of meditation, including mindfulness and guided meditation</li><li>Techniques for deep relaxation and stress management</li></ul></li><li><p><strong>Anatomy and Physiology</strong></p><ul><li>Understanding the human body in relation to yoga practice</li><li>Study of the musculoskeletal system, respiratory system, and nervous system</li></ul></li><li><p><strong>Yoga Philosophy and Ethics</strong></p><ul><li>Study of key texts such as the Yoga Sutras of Patanjali, Bhagavad Gita, and Hatha Yoga Pradipika</li><li>Ethical guidelines for yoga teachers</li></ul></li><li><p><strong>Teaching Methodology</strong></p><ul><li>Techniques for instructing and adjusting students in a yoga class</li><li>Designing yoga sequences for different levels of practice</li><li>Effective communication and classroom management</li></ul></li><li><p><strong>Ayurveda and Yogic Diet</strong></p><ul><li>Introduction to Ayurveda and its connection with yoga</li><li>Principles of a yogic diet and its role in promoting health</li></ul></li><li><p><strong>Yoga for Special Populations</strong></p><ul><li>Adapting yoga practices for children, the elderly, and individuals with special needs</li><li>Therapeutic applications of yoga for specific health conditions</li></ul></li><li><p><strong>Practicum and Teaching Practice</strong></p><ul><li>Hands-on teaching experience under the supervision of experienced instructors</li><li>Feedback and evaluation to improve teaching skills</li></ul></li></ol><h3><strong>Eligibility Criteria</strong></h3><p>To enroll in a Diploma in Yoga Teacher Training program, candidates typically need:</p><ul><li>A high school diploma or equivalent (10+2) from a recognized board.</li><li>Basic knowledge of yoga and a regular practice routine is often preferred, though not always mandatory.</li></ul><h3><strong>Career Prospects</strong></h3><p>Graduates of the Diploma in Yoga Teacher Training program can pursue various roles, including:</p><ul><li><strong>Yoga Instructor:</strong> Teaching yoga classes in yoga studios, fitness centers, or as a private instructor.</li><li><strong>Yoga Therapist:</strong> Providing yoga-based therapeutic practices for individuals with specific health concerns.</li><li><strong>Corporate Yoga Trainer:</strong> Conducting yoga sessions in corporate environments to promote employee wellness.</li><li><strong>Yoga Retreat Leader:</strong> Leading yoga retreats and workshops in various locations.</li><li><strong>Yoga Studio Manager:</strong> Overseeing the operations of a yoga studio, including class scheduling and instructor coordination.</li></ul><h3><strong>Job Sectors</strong></h3><ul><li><strong>Yoga Studios and Centers:</strong> Teaching yoga classes and leading workshops.</li><li><strong>Fitness and Wellness Centers:</strong> Incorporating yoga into broader fitness programs.</li><li><strong>Schools and Universities:</strong> Offering yoga classes as part of physical education or extracurricular activities.</li><li><strong>Retreat Centers:</strong> Leading yoga sessions in wellness retreats and spiritual centers.</li><li><strong>Corporate Wellness Programs:</strong> Providing yoga instruction to employees as part of workplace wellness initiatives.</li></ul><h3><strong>Skills Acquired</strong></h3><ul><li><strong>In-depth Knowledge of Yoga:</strong> Comprehensive understanding of yoga practices, postures, and philosophies.</li><li><strong>Teaching and Communication:</strong> Ability to instruct and guide individuals in yoga practices effectively.</li><li><strong>Physical and Mental Awareness:</strong> Enhanced awareness of body mechanics, breath control, and mental focus.</li><li><strong>Adaptability:</strong> Skills to modify yoga practices for different populations and individual needs.</li><li><strong>Leadership and Motivation:</strong> Ability to inspire and motivate students to pursue a consistent yoga practice.</li></ul><h3><strong>Conclusion</strong></h3><p>A Diploma in Yoga Teacher Training provides a strong foundation for a career as a yoga instructor. It equips students with the necessary skills to teach yoga safely and effectively, while also deepening their own practice. With the growing interest in holistic health and wellness, this diploma opens up numerous opportunities to share the benefits of yoga with others and contribute to the well-being of communities.</p>			ASdasdasd						Active		Ibrahim	DIPLOMA-IN-YOGA-TEACHER	{}	{"<h2><strong>Course Overview</strong></h2>"}	{"<h3><strong>Core Subjects</strong></h3>","<h3><strong>Eligibility Criteria</strong></h3>","<h3><strong>Career Prospects</strong></h3>","<h3><strong>Job Sectors</strong></h3>","<h3><strong>Skills Acquired</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	65	{}	2024-08-23 09:49:20.326544	Add
MFA	A Master of Fine Arts (MFA) is a graduate degree specifically designed for individuals seeking to advance their artistic practice and pursue a career in the arts. It offers a rigorous curriculum that combines theoretical knowledge with practical experience, allowing students to refine their skills and develop a unique artistic voice.		2 Years	43543	Master of Fine Arts (MFA): Course Overview, Eligibility, Fees, and Career Opportunities	Explore the Master of Fine Arts (MFA) program, including its overview, eligibility criteria, fee structure, and career benefits for advanced studies in the visual and performing arts.	FINE_ARTS.jpg	Full Time 	Feature	pgCourses	1	2024-08-22 10:50:21	<p style="text-align: justify;">The Master of Fine Arts (MFA) is a postgraduate degree program designed for students pursuing advanced studies in the visual and performing arts. This degree is highly regarded in creative fields and provides students with the opportunity to develop their artistic practice, engage in critical research, and refine their technical skills. The MFA is ideal for those seeking to advance their careers as professional artists, educators, or scholars.</p><h2 style="text-align: justify;"><strong>Course Duration and Structure</strong></h2><p style="text-align: justify;">The MFA program typically spans 2 to 3 years and is structured to allow for both intensive artistic development and academic research. The curriculum generally includes:</p><ul><li style="text-align: justify;"><strong>Studio Practice:</strong> Focused sessions in the student’s chosen field, such as painting, sculpture, writing, or performing arts, where they create and critique their work.</li><li style="text-align: justify;"><strong>Theoretical Courses:</strong> Study of art history, theory, and criticism to provide a contextual understanding of contemporary practices.</li><li style="text-align: justify;"><strong>Research Projects:</strong> Independent research and creative projects that contribute to the student’s artistic development and scholarship.</li><li style="text-align: justify;"><strong>Exhibitions and Performances:</strong> Opportunities for students to showcase their work through exhibitions, performances, or public presentations.</li></ul><h4 style="text-align: justify;"><strong>Eligibility Criteria</strong></h4><p style="text-align: justify;">To enroll in an MFA program, candidates typically need to meet the following requirements:</p><ul><li style="text-align: justify;"><strong>Educational Qualification:</strong> A bachelor’s degree in Fine Arts or a related field is usually required. Some programs may accept candidates with a strong portfolio of work even if their undergraduate degree is in a different discipline.</li><li style="text-align: justify;"><strong>Portfolio:</strong> A comprehensive portfolio demonstrating the applicant’s artistic ability and potential is often required for admission.</li><li style="text-align: justify;"><strong>Experience:</strong> Some programs may require professional experience or a strong record of artistic achievement.</li></ul><h4 style="text-align: justify;"><strong>Fee Structure</strong></h4><p style="text-align: justify;">The fee structure for an MFA program varies depending on the institution, location, and specialization. On average, the fees can range from INR 1,00,000 to INR 5,00,000 per year. Many institutions offer scholarships, grants, and assistantships to support students financially.</p><h4 style="text-align: justify;"><strong>Specializations in MFA</strong></h4><p style="text-align: justify;">Students can choose from a variety of specializations based on their interests and career goals. Common specializations include:</p><ul><li style="text-align: justify;"><strong>Visual Arts:</strong> Painting, Sculpture, Printmaking, Photography, and Digital Media.</li><li style="text-align: justify;"><strong>Performing Arts:</strong> Theatre, Dance, and Music.</li><li style="text-align: justify;"><strong>Creative Writing:</strong> Fiction, Poetry, Non-Fiction, and Playwriting.</li><li style="text-align: justify;"><strong>Design:</strong> Graphic Design, Fashion Design, and Interior Design.</li></ul><h4 style="text-align: justify;"><strong>Career Prospects After MFA</strong></h4><p style="text-align: justify;">Graduates of an MFA program can pursue various career paths in the arts and creative industries, including:</p><ul><li style="text-align: justify;"><strong>Professional Artist:</strong> Create and exhibit artworks, participate in art fairs, and engage in public art projects.</li><li style="text-align: justify;"><strong>Art Educator:</strong> Teach art at schools, colleges, or universities, or offer private art classes and workshops.</li><li style="text-align: justify;"><strong>Curator:</strong> Manage and organize exhibitions in galleries, museums, or cultural institutions.</li><li style="text-align: justify;"><strong>Art Director:</strong> Oversee visual aspects of creative projects in advertising, media, or entertainment.</li><li style="text-align: justify;"><strong>Writer/Author:</strong> Publish books, scripts, or articles and work as a freelance writer or editor.</li><li style="text-align: justify;"><strong>Performing Artist:</strong> Pursue careers in theatre, dance, music, or other performing arts fields.</li></ul><h4 style="text-align: justify;"><strong>Higher Education and Further Studies</strong></h4><p style="text-align: justify;">After completing an MFA, graduates may pursue further academic research or specialized studies, such as a Doctor of Fine Arts (DFA) or additional certifications in their field. Further studies can enhance expertise and open opportunities for higher-level academic and artistic roles.</p><h4 style="text-align: justify;"><strong>Conclusion</strong></h4><p style="text-align: justify;">The Master of Fine Arts (MFA) provides an in-depth exploration of artistic practice and theory, preparing students for advanced careers in the arts. With its focus on creative development, critical analysis, and professional practice, the MFA is a valuable qualification for those aiming to make significant contributions to the art world and achieve personal and professional growth in their artistic careers.</p>			ASdasdasd						Active	TOC	Ibrahim	MASTER-OF-FINE-ARTS-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Fee Structure</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Specializations in MFA</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Career Prospects After MFA</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Higher Education and Further Studies</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h4>"}	57	{}	2024-08-21 06:57:40.115264	Add
MCA	The Master of Computer Applications (MCA) is a postgraduate degree designed to equip students with advanced knowledge and skills in computer applications. It's a popular choice for those aiming for a successful career in the IT industry.		2 Years		Master of Computer Applications (MCA): Your Path to a Tech Career	Discover the MCA program, a postgraduate degree focused on computer applications. Learn about eligibility, top colleges, career prospects, and how to excel in this in-demand field.	IPEM-blog-banners-5 (1).jpg	Full Time 	Feature	pgCourses	1	\N	<h2><strong>Introduction</strong></h2><p>In today's rapidly evolving technological landscape, pursuing advanced education in computer science can significantly enhance your career prospects. One such popular postgraduate course is the Master of Computer Applications (MCA). This article delves into the various aspects of MCA, from eligibility criteria to career opportunities, to help you make an informed decision about pursuing this degree.</p><p><strong>What is MCA?</strong></p><p>MCA, or Master of Computer Applications, is a postgraduate degree focused on equipping students with comprehensive knowledge and skills in computer science and applications. It typically spans three years and covers a wide range of topics including software development, systems management, and data analysis. Unlike other computer science degrees, MCA emphasizes both theoretical concepts and practical applications, making graduates highly proficient in various technical domains.</p><p><strong>Eligibility Criteria</strong></p><p>To be eligible for an MCA program, candidates must have completed a bachelor's degree, typically in a field related to computer science, information technology, or mathematics. Additionally, many institutions require candidates to have studied mathematics at the 10+2 level. Admission to MCA programs often involves entrance exams such as NIMCET, TANCET, or state-specific tests, followed by a selection process that may include interviews and group discussions.</p><p><strong>Course Structure and Curriculum</strong></p><p>The MCA program is structured over six semesters, encompassing a mix of core subjects, electives, and practical training. Core subjects typically include:</p><ul><li>Programming Languages (Java, C++)</li><li>Data Structures and Algorithms</li><li>Database Management Systems</li><li>Computer Networks</li><li>Software Engineering</li><li>Operating Systems</li></ul><p>In addition to core subjects, students can choose electives based on their interests and career goals. The curriculum also includes practical training through lab sessions, projects, and internships to provide hands-on experience in real-world applications.</p><p><strong>Specializations in MCA</strong></p><p>MCA students have the option to specialize in various areas, allowing them to tailor their education to specific career paths. Some popular specializations include:</p><ul><li><strong>Software Development</strong>: Focuses on designing, coding, and testing software applications.</li><li><strong>Systems Management</strong>: Involves managing and maintaining IT systems and infrastructure.</li><li><strong>Networking</strong>: Covers network design, implementation, and security.</li><li><strong>Database Management</strong>: Emphasizes on database design, development, and administration.</li><li><strong>Cybersecurity</strong>: Focuses on protecting systems and data from cyber threats.</li><li><strong>Artificial Intelligence and Machine Learning</strong>: Involves developing intelligent systems and algorithms.</li></ul><p><strong>Top Colleges and Universities for MCA</strong></p><p>Several prestigious institutions in India and around the world offer MCA programs. Some top colleges include:</p><ul><li>Indian Institute of Technology (IIT)</li><li>National Institute of Technology (NIT)</li><li>University of Delhi</li><li>Banaras Hindu University (BHU)</li><li>Jawaharlal Nehru University (JNU)</li></ul><p>These institutions are known for their rigorous curriculum, experienced faculty, and excellent placement records.</p><p><strong>Career Opportunities after MCA</strong></p><p>Graduates with an MCA degree have a wide array of career opportunities in various sectors. Some prominent roles include:</p><ul><li><strong>Software Developer</strong>: Designing and developing software applications.</li><li><strong>Systems Analyst</strong>: Analyzing and improving IT systems.</li><li><strong>Network Administrator</strong>: Managing and maintaining computer networks.</li><li><strong>Database Administrator</strong>: Overseeing database systems and ensuring data security.</li><li><strong>IT Consultant</strong>: Providing expert advice on IT strategies and solutions.</li><li><strong>Project Manager</strong>: Leading and managing IT projects.</li></ul><p><strong>Salary Expectations</strong></p><p>The average salary for MCA graduates can vary based on factors such as experience, location, and specialization. On average, fresh graduates can expect to earn between INR 4-8 lakhs per annum. With experience and advanced skills, professionals can command significantly higher salaries, especially in specialized fields like cybersecurity and AI.</p><p><strong>Further Studies and Certifications</strong></p><p>For those looking to further enhance their qualifications, pursuing a Ph.D. in Computer Science can open up opportunities in academia and research. Additionally, professional certifications such as Project Management Professional (PMP), Amazon Web Services (AWS) certifications, and Certified Information Systems Security Professional (CISSP) can add significant value to an MCA degree.</p><p><strong>Benefits of Pursuing MCA</strong></p><p>Pursuing an MCA offers several benefits:</p><ul><li><strong>Enhanced Career Prospects</strong>: An MCA degree can open doors to advanced technical roles and leadership positions.</li><li><strong>Advanced Technical Knowledge</strong>: The program equips students with in-depth knowledge of computer applications and emerging technologies.</li><li><strong>Opportunities for Growth and Specialization</strong>: MCA graduates can specialize in fields like AI, cybersecurity, and software development, which are in high demand.</li></ul><p><strong>Challenges in Pursuing MCA</strong></p><p>While an MCA degree offers numerous advantages, it also comes with challenges:</p><ul><li><strong>Intense Coursework and Study Load</strong>: The program is rigorous and requires a strong commitment to succeed.</li><li><strong>Staying Updated with Technological Advancements</strong>: The field of computer science is constantly evolving, necessitating continuous learning and adaptation.</li></ul>									Active	TOC	\N	MCA-	{}	{<h2><strong>Introduction</strong></h2>}	{}	{}	24	{}	2024-08-13 11:41:02.401187	Add
BFA	Graduates of BFA programs can pursue higher education, such as a Master of Fine Arts (MFA), to further specialize in their chosen field. MFA programs offer advanced training and research opportunities, allowing students to deepen their expertise and expand their career options.		3 Years	4324	Bachelor of Fine Arts (BFA) Course: Overview, Eligibility, Fees, and Career Prospects	Discover the Bachelor of Fine Arts (BFA) course, including its overview, eligibility criteria, fee structure, top specializations, and promising career opportunities in the world of art and design.	images (19).jfif	Full Time 	Feature	ugCourses	1	2024-08-22 10:50:21	<p>The Bachelor of Fine Arts (BFA) is an undergraduate degree program designed for students passionate about visual and performing arts. This course provides comprehensive training in various artistic disciplines, enabling students to hone their creative skills and pursue careers in fields such as painting, sculpture, music, dance, theatre, photography, and more.</p><h2><strong>Course Duration and Structure</strong></h2><p>The BFA program typically spans 3 to 4 years, depending on the country and institution. The curriculum is a blend of theoretical knowledge and practical experience, with students engaging in studio work, workshops, and exhibitions. The course structure is usually divided into core subjects, electives, and specialization courses, allowing students to focus on their area of interest.</p><h4><strong>Eligibility Criteria</strong></h4><p>To enroll in a BFA program, candidates must meet the following eligibility criteria:</p><ul><li><strong>Educational Qualification:</strong> Candidates should have completed their 10+2 (or equivalent) from a recognized board with a minimum percentage, typically around 50%. Some institutions may require students to have a background in arts, but this is not always mandatory.</li><li><strong>Entrance Examinations:</strong> Many universities and colleges conduct entrance exams to assess a candidate's artistic abilities. These may include practical tests, portfolio assessments, and interviews.</li></ul><h4><strong>Fee Structure</strong></h4><p>The fee structure for a BFA program varies widely depending on the institution, location, and specialization. On average, the fees can range from INR 30,000 to INR 2,00,000 per year. Scholarships and financial aid options are also available for eligible students.</p><h4><strong>Specializations in BFA</strong></h4><p>BFA students can choose from various specializations based on their interests and career goals. Some popular BFA specializations include:</p><ul><li><strong>Painting</strong></li><li><strong>Sculpture</strong></li><li><strong>Applied Arts</strong></li><li><strong>Photography</strong></li><li><strong>Animation</strong></li><li><strong>Graphic Design</strong></li><li><strong>Theatre Arts</strong></li><li><strong>Music and Dance</strong></li></ul><h4><strong>Career Prospects after BFA</strong></h4><p>A BFA degree opens up numerous career opportunities in the creative industry. Graduates can pursue roles such as:</p><ul><li><strong>Fine Artist:</strong> Create original works of art in various mediums.</li><li><strong>Graphic Designer:</strong> Work in advertising, publishing, or digital media to create visual content.</li><li><strong>Art Director:</strong> Lead creative projects in advertising agencies, magazines, or film production houses.</li><li><strong>Animator:</strong> Develop animated content for films, television, and online platforms.</li><li><strong>Photographer:</strong> Specialize in fashion, commercial, or portrait photography.</li><li><strong>Curator:</strong> Manage collections in art galleries, museums, and cultural institutions.</li><li><strong>Theatre Artist:</strong> Act, direct, or produce theatrical performances.</li><li><strong>Music/Dance Instructor:</strong> Teach in schools, colleges, or private institutions.</li></ul><h4><strong>Higher Education and Further Studies</strong></h4><p>Graduates of BFA programs can pursue higher education, such as a Master of Fine Arts (MFA), to further specialize in their chosen field. MFA programs offer advanced training and research opportunities, allowing students to deepen their expertise and expand their career options.</p>			ASdasdasd						Active	TOC	Ibrahim	BACHELOR--OF-FINE-ARTS-	{}	{"<h2><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4><strong>Eligibility Criteria</strong></h4>","<h4><strong>Fee Structure</strong></h4>","<h4><strong>Specializations in BFA</strong></h4>","<h4><strong>Career Prospects after BFA</strong></h4>","<h4><strong>Higher Education and Further Studies</strong></h4>"}	52	{}	2024-08-21 06:10:48.099974	Add
MA	Deepen your love for literature with an MA in English Literature. Explore career paths, top universities, and online programs. Enhance your writing and critical thinking skills.		2 Years	4321	Master of Arts (MA) Degrees: Advance Your Career & Knowledge	Explore a wide range of MA programs. Discover top universities, career paths, and online options. Enhance your expertise with a Master of Arts degree.	master-of-arts.jpg	Full Time 	Feature	pgCourses	1	2024-08-20 10:24:34	<p style="text-align: justify;">The&nbsp;Master of Arts (MA)&nbsp;is a prestigious postgraduate degree awarded by universities worldwide, primarily in the fields of humanities and social sciences. This degree is designed to provide advanced knowledge and skills in various disciplines, including history, literature, languages, political science, and communication studies, among others.</p><p style="text-align: justify;"><h2 class="mb-2 mt-6 text-lg first:mt-3">Degree Overview</h2>The Master of Arts degree traces its origins to the&nbsp;Licentia docendi, a teaching license from the University of Paris, which aimed to produce qualified educators. The term "master" historically indicated a high level of expertise, akin to a "doctor" in other academic faculties. In many universities, the progression of degrees typically follows the sequence of Bachelor of Arts (BA), Master of Arts (MA), and then Doctor of Philosophy (PhD) or Doctor of Letters (D.Litt)&nbsp;.<br><br><h3 class="mb-2 mt-6 text-lg first:mt-3">Structure and Duration</h3>The MA program usually takes between one to three years to complete, depending on the institution and the specific program structure. Students may choose between thesis-based and non-thesis options. The non-thesis route typically requires one to two years of full-time study, while the thesis option may extend the duration, particularly if the thesis involves extensive research&nbsp;.<br><br><h3 class="mb-2 mt-6 text-lg first:mt-3">Admission Requirements</h3>Admission to a Master of Arts program generally requires a bachelor's degree. Some universities offer combined bachelor's and master's programs that can be completed in about five years. The curriculum usually includes advanced coursework, seminars, and may culminate in a thesis or capstone project, demonstrating the student's ability to conduct independent research&nbsp;.</p><p style="text-align: justify;"><h3 class="mb-2 mt-6 text-lg first:mt-3">Fields of Study</h3>The Master of Arts degree encompasses a wide range of disciplines. Common fields include:<ul class="list-disc pl-8"><li index="0">Art History</li><li index="1">Journalism and Mass Communication</li><li index="2">Languages&nbsp;(e.g., Spanish, French, German)</li><li index="3">English Literature</li><li index="4">Political Science</li><li index="5">Sociology</li><li index="6">Philosophy</li><li index="7">International Affairs</li><li index="8">Comparative Literature</li></ul>These programs not only enhance subject-specific knowledge but also develop critical thinking, research, and communication skills, making graduates versatile in the job market&nbsp;.</p><p style="text-align: justify;"><h3 class="mb-2 mt-6 text-lg first:mt-3">Career Opportunities</h3>Earning a Master of Arts can significantly enhance career prospects. Graduates often pursue careers in education, human services, journalism, and various roles in the arts. The degree is increasingly valued by employers, with many preferring candidates with advanced education for senior positions. The skills acquired during an MA program, such as analytical thinking and effective communication, are applicable in numerous fields, including translation, international relations, and public administration&nbsp;.In summary, the Master of Arts degree is a valuable qualification that offers deep insights into the humanities and social sciences while equipping students with essential skills for diverse career paths.</p>			ASdasdasd						Active	TOC	Ibrahim	Master-of-Arts-	{}	{"<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\">Degree Overview</h2>"}	{"<h3 class=\\"mb-2 mt-6 text-lg first:mt-3\\">Structure and Duration</h3>","<h3 class=\\"mb-2 mt-6 text-lg first:mt-3\\">Admission Requirements</h3>","<h3 class=\\"mb-2 mt-6 text-lg first:mt-3\\">Fields of Study</h3>","<h3 class=\\"mb-2 mt-6 text-lg first:mt-3\\">Career Opportunities</h3>"}	{}	35	{}	2024-08-13 11:41:02.401187	Add
B.Com\t	B.Com (Bachelor of Commerce): Launch your journey in the dynamic world of commerce with a B.Com degree. This three-year undergraduate program equips you with a comprehensive understanding of business principles, accounting practices, and economic theories.		4 Years	876483	Explore B.Com Courses After 12th & Launch Your Commerce Career	Build a strong foundation in business and commerce with a B.Com degree. Discover top courses, specializations, career paths, and top colleges to kickstart your journey.	download (2).jfif	Full Time 	Feature	ugCourses	1	\N	<h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 0.75rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">B.Com: A Comprehensive Guide</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">The Bachelor of Commerce (B.Com) is a popular undergraduate degree program that provides students with a strong foundation in various aspects of commerce, including accounting, finance, economics, and management. This program is designed to prepare students for careers in the business world or further academic pursuits in the field of commerce.</span></p><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">Program Structure and Duration</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">A B.Com degree typically spans a duration of three years, divided into six semesters. The curriculum is designed to provide students with a well-rounded education, covering core subjects such as financial accounting, corporate accounting, cost accounting, business law, and taxation.</span></p><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">Career Opportunities</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">Graduates of a B.Com program have a wide range of career opportunities available to them. They can pursue careers in fields such as:</span></p><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Accounting and finance</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Banking and insurance</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Marketing and sales</span></li><li index="3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Human resource management</span></li><li index="4" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Entrepreneurship</span></li></ul><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">Many students also opt for further studies, such as a Master of Commerce (M.Com) or a Master of Business Administration (MBA), to enhance their career prospects.</span></p><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">Admission Requirements</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">The admission requirements for a B.Com program vary depending on the institution. Generally, students must have completed their 10+2 or equivalent examination from a recognized board with a minimum percentage of marks, as specified by the institution.</span></p><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">Skills Developed</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">Throughout the B.Com program, students develop a range of skills that are essential for success in the business world. These skills include:</span></p><ul class="list-disc pl-8" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; list-style: disc; margin: 0px; padding: 0px 0px 0px 2rem; padding-inline-start: 1.625em; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;"><li index="0" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Critical thinking and problem-solving</span></li><li index="1" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Financial analysis and decision-making</span></li><li index="2" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Communication and interpersonal skills</span></li><li index="3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Teamwork and leadership abilities</span></li><li index="4" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0.5em; margin-bottom: 0.5em; padding-inline-start: 0.375em;"><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ;">Adaptability and flexibility</span></li></ul><h2 class="mb-2 mt-6 text-lg first:mt-3" style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;">Conclusion</h2><p><span style="box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; margin-top: 0px; margin-bottom: 0px; color: oklch(0.304 0.04 213.681); font-family: __fkGroteskNeue_598ab8, __fkGroteskNeue_Fallback_598ab8, ui-sans-serif, system-ui, -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, Roboto, &quot;Helvetica Neue&quot;, Arial, &quot;Noto Sans&quot;, sans-serif, &quot;Apple Color Emoji&quot;, &quot;Segoe UI Emoji&quot;, &quot;Segoe UI Symbol&quot;, &quot;Noto Color Emoji&quot;; font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; font-weight: 400; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 16px;">The Bachelor of Commerce (B.Com) is a versatile degree program that provides students with the knowledge and skills necessary to succeed in the dynamic world of business. With a wide range of career opportunities and the potential for further academic pursuits, a B.Com degree is an excellent choice for those interested in the field of commerce.</span></p>									Active	TOC	\N	B.Com	{}	{"<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;\\">Program Structure and Duration</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;\\">Career Opportunities</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;\\">Admission Requirements</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;\\">Skills Developed</h2>","<h2 class=\\"mb-2 mt-6 text-lg first:mt-3\\" style=\\"box-sizing: border-box; border: 0px solid rgb(229, 231, 235); scrollbar-color: auto; scrollbar-width: auto; --tw-border-spacing-x: 0; --tw-border-spacing-y: 0; --tw-translate-x: 0; --tw-translate-y: 0; --tw-rotate: 0; --tw-skew-x: 0; --tw-skew-y: 0; --tw-scale-x: 1; --tw-scale-y: 1; --tw-pan-x: ; --tw-pan-y: ; --tw-pinch-zoom: ; --tw-scroll-snap-strictness: proximity; --tw-gradient-from-position: ; --tw-gradient-via-position: ; --tw-gradient-to-position: ; --tw-ordinal: ; --tw-slashed-zero: ; --tw-numeric-figure: ; --tw-numeric-spacing: ; --tw-numeric-fraction: ; --tw-ring-inset: ; --tw-ring-offset-width: 0px; --tw-ring-offset-color: #fff; --tw-ring-color: rgba(59,130,246,.5); --tw-ring-offset-shadow: 0 0 #0000; --tw-ring-shadow: 0 0 #0000; --tw-shadow: 0 0 #0000; --tw-shadow-colored: 0 0 #0000; --tw-blur: ; --tw-brightness: ; --tw-contrast: ; --tw-grayscale: ; --tw-hue-rotate: ; --tw-invert: ; --tw-saturate: ; --tw-sepia: ; --tw-drop-shadow: ; --tw-backdrop-blur: ; --tw-backdrop-brightness: ; --tw-backdrop-contrast: ; --tw-backdrop-grayscale: ; --tw-backdrop-hue-rotate: ; --tw-backdrop-invert: ; --tw-backdrop-opacity: ; --tw-backdrop-saturate: ; --tw-backdrop-sepia: ; --tw-contain-size: ; --tw-contain-layout: ; --tw-contain-paint: ; --tw-contain-style: ; font-weight: 500; margin: 1.5rem 0px 0.5rem; color: oklch(0.304 0.04 213.681); line-height: 1.75rem; font-family: var(--font-fk-grotesk); font-style: normal; font-variant-ligatures: normal; font-variant-caps: normal; letter-spacing: normal; orphans: 2; text-align: start; text-indent: 0px; text-transform: none; widows: 2; word-spacing: 0px; -webkit-text-stroke-width: 0px; white-space: normal; background-color: oklch(0.99 0.004 106.471); text-decoration-thickness: initial; text-decoration-style: initial; text-decoration-color: initial; font-size: 1.125rem;\\">Conclusion</h2>"}	{}	{}	34	{}	2024-08-13 11:41:02.401187	Add
MTech	Master of Technology (MTech) is a postgraduate degree program designed for engineers who want to specialize in a particular field of engineering. It offers a rigorous curriculum that combines theoretical knowledge with practical applications, equipping students with advanced skills and expertise.		2 Years	54324	Master of Technology (M.Tech): Course Overview, Eligibility, Fees, and Career Opportunities	Discover the Master of Technology (M.Tech) program, including its overview, eligibility requirements, fee structure, and career benefits for advanced studies in various engineering and technology fields.	9cfbe2fe-05fe-4746-b8c2-6856f34e1ddf.jfif	Full Time 	Feature	pgCourses	1	2024-08-22 10:50:21	<p>The Master of Technology (M.Tech) is a postgraduate degree designed for students seeking advanced knowledge and expertise in various engineering and technology disciplines. This program focuses on providing specialized technical education, research skills, and practical experience to prepare graduates for high-level roles in the industry, academia, or research.</p><h2><strong>Course Duration and Structure</strong></h2><p>The M.Tech program typically spans 2 years and is structured into four semesters. The course includes both coursework and research components, including:</p><ul><li><strong>Core Subjects:</strong> Advanced topics in the chosen engineering or technology field, such as Computer Science, Electrical Engineering, Mechanical Engineering, or Civil Engineering.</li><li><strong>Electives:</strong> Specialized courses that allow students to focus on specific areas of interest within their field.</li><li><strong>Research Project:</strong> A significant research project or thesis that involves solving real-world problems, conducting experiments, or developing new technologies.</li><li><strong>Industrial Training:</strong> Some programs include internships or industrial training to provide practical experience.</li></ul><h4><strong>Eligibility Criteria</strong></h4><p>To enroll in an M.Tech program, candidates generally need to meet the following criteria:</p><ul><li><strong>Educational Qualification:</strong> A Bachelor’s degree in Engineering (B.E./B.Tech) or a related field from a recognized institution with a minimum percentage, typically around 50% to 60%.</li><li><strong>Entrance Examinations:</strong> Many institutions require candidates to pass entrance exams such as GATE (Graduate Aptitude Test in Engineering) or institution-specific tests.</li><li><strong>Work Experience:</strong> While not always mandatory, some programs prefer candidates with relevant work experience in their field.</li></ul><h4><strong>Fee Structure</strong></h4><p>The fee structure for an M.Tech program varies depending on the institution, location, and specialization. On average, the fees can range from INR 50,000 to INR 2,00,000 per year. Many institutions offer scholarships, research assistantships, and financial aid options to support students.</p><h4><strong>Specializations in M.Tech</strong></h4><p>Students can choose from a variety of specializations based on their career goals and interests. Common specializations include:</p><ul><li><strong>Computer Science and Engineering</strong></li><li><strong>Information Technology</strong></li><li><strong>Electrical Engineering</strong></li><li><strong>Mechanical Engineering</strong></li><li><strong>Civil Engineering</strong></li><li><strong>Structural Engineering</strong></li><li><strong>VLSI Design</strong></li><li><strong>Power Systems</strong></li><li><strong>Data Science and Engineering</strong></li></ul><h4><strong>Career Prospects After M.Tech</strong></h4><p>Graduates of an M.Tech program can pursue various career opportunities in their specialized field, including:</p><ul><li><strong>Engineering Manager:</strong> Oversee engineering projects, manage teams, and ensure project success.</li><li><strong>Research Scientist:</strong> Conduct research and development in academic, industrial, or government research institutions.</li><li><strong>Software Engineer:</strong> Develop and maintain software applications, systems, and solutions.</li><li><strong>Consultant:</strong> Provide expert advice and solutions to engineering problems or technology challenges.</li><li><strong>Professor/Lecturer:</strong> Teach engineering courses at universities or technical institutes.</li><li><strong>Project Engineer:</strong> Manage engineering projects, including planning, execution, and quality control.</li></ul><h4><strong>Higher Education and Further Studies</strong></h4><p>After completing an M.Tech, graduates may pursue further academic research or advanced studies, such as:</p><ul><li><strong>Doctor of Philosophy (Ph.D.):</strong> Engage in advanced research and contribute to academic and technological advancements.</li><li><strong>Postgraduate Diplomas:</strong> Specialized diplomas or certifications in emerging technologies or management fields.</li></ul><h4><strong>Conclusion</strong></h4><p>The Master of Technology (M.Tech) program offers advanced technical education and research opportunities for students seeking to enhance their expertise in engineering and technology. With its focus on specialized knowledge, practical skills, and research, the M.Tech degree prepares graduates for leadership roles, research positions, and advanced career opportunities in their chosen field.</p>			ASdasdasd						Active	TOC	Ibrahim	MASTER-OF-TECHNOLOGY-	{}	{"<h2><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4><strong>Eligibility Criteria</strong></h4>","<h4><strong>Fee Structure</strong></h4>","<h4><strong>Specializations in M.Tech</strong></h4>","<h4><strong>Career Prospects After M.Tech</strong></h4>","<h4><strong>Higher Education and Further Studies</strong></h4>",<h4><strong>Conclusion</strong></h4>}	58	{}	2024-08-21 07:01:25.474685	Add
M.Ed	Master of Education (M.Ed): Elevate your teaching career with an M.Ed degree. Designed for educators seeking advanced knowledge and skills, this postgraduate program offers specialization in various educational areas.		2 Years	67655	M.Ed: Advance Your Teaching Career with a Master's in Education	Discover the M.Ed program and how it can enhance your teaching career. Learn about specializations, career paths, top colleges, and the benefits of advanced education in education.	course2.jpg	Full Time 	Feature	pgCourses	1	\N	<h2>Introduction</h2><h4>What is M.Ed in English?</h4><p>The Master of Education (M.Ed) in English is a postgraduate degree designed to enhance the skills of educators specializing in English literature, language, and teaching methodologies. This degree equips educators with advanced knowledge and research skills necessary for effective teaching and curriculum development.</p><h4>Relevance and Importance</h4><p>In a world where English is a global lingua franca, the demand for qualified English educators is on the rise. An M.Ed in English not only improves teaching skills but also prepares educators for leadership roles, curriculum design, and educational research.</p><h3>Types and Categories</h3><h4>Full-Time vs. Part-Time Programs</h4><ul><li><strong>Full-Time Programs</strong>: Typically completed in two years, ideal for those who can dedicate themselves entirely to their studies.</li><li><strong>Part-Time Programs</strong>: Designed for working professionals, allowing flexibility in scheduling and coursework.</li></ul><h4>Online vs. On-Campus Programs</h4><ul><li><strong>Online Programs</strong>: Offer convenience and accessibility for those unable to attend physical classes.</li><li><strong>On-Campus Programs</strong>: Provide a traditional classroom experience and more direct interaction with faculty and peers</li></ul><h4>Biological and Psychological Factors</h4><ul><li><strong>Cognitive Load</strong>: The mental effort required to grasp complex educational theories and methodologies.</li><li><strong>Stress and Anxiety</strong>: Common among graduate students due to the high demands of the program.</li></ul><h4>Environmental and Lifestyle Factors</h4><ul><li><strong>Work-Life Balance</strong>: Juggling professional responsibilities with academic requirements.</li><li><strong>Support Systems</strong>: Lack of a strong support system can impact performance and well-being.</li></ul>									Active	TOC	\N	M.Ed-	{}	{<h2>Introduction</h2>}	{"<h3>Types and Categories</h3>"}	{"<h4>What is M.Ed in English?</h4>","<h4>Relevance and Importance</h4>","<h4>Full-Time vs. Part-Time Programs</h4>","<h4>Online vs. On-Campus Programs</h4>","<h4>Biological and Psychological Factors</h4>","<h4>Environmental and Lifestyle Factors</h4>"}	28	{}	2024-08-13 11:41:02.401187	Add
M.Pharm	Deepen your knowledge and skills in the pharmaceutical industry with an M.Pharm degree. This postgraduate program provides specialized training in various pharmaceutical domains.		2 Years	53324	M.Pharm: Advance Your Pharmacy Career with a Master's Degree	Discover the M.Pharm program and how it can enhance your pharmacy career. Learn about specializations, career paths, top colleges, and the benefits of advanced education in pharmacy.	master-of-pharmacy-mpharm.jpg	Full Time 	Feature	pgCourses	1	\N	<h2>Overview</h2><p>The Master of Pharmacy (M.Pharm) is a postgraduate degree designed for individuals seeking advanced knowledge and expertise in the field of pharmacy. This program offers in-depth understanding of pharmaceutical sciences, including drug development, clinical trials, and pharmaceutical management. It prepares students for a variety of roles in the pharmaceutical industry, research institutions, and healthcare settings.</p><p>The M.Pharm program typically spans two years and includes both theoretical and practical components. Students engage in coursework that covers advanced topics in pharmacology, pharmaceutical chemistry, and pharmaceutics. Additionally, they may participate in research projects and internships to gain hands-on experience.</p><h4>Eligibility</h4><p>To pursue an M.Pharm, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Pharmacy (B.Pharm) degree from a recognized university or institution is required. Some programs may accept candidates with a B.Sc. degree in a related field if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test such as the Graduate Pharmacy Admission Test (GPAT).</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an M.Pharm program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $2,000 to $10,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, research materials, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an M.Pharm degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Pharmaceutical Industry</strong>: Graduates can work as drug development scientists, clinical research associates, regulatory affairs specialists, or quality control managers.</p></li><li><p><strong>Healthcare Settings</strong>: Opportunities in hospitals and clinics as clinical pharmacists, where they play a critical role in medication management and patient care.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on pharmaceutical research, drug discovery, and formulation development.</p></li><li><p><strong>Teaching and Academia</strong>: Graduates may choose to pursue careers in teaching at universities or colleges, contributing to the education of future pharmacy professionals.</p></li><li><p><strong>Regulatory Agencies</strong>: Roles in government and regulatory agencies overseeing drug approval processes and ensuring compliance with pharmaceutical regulations.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own ventures or consultancy firms in the pharmaceutical sector.</p></li></ol><h4>Specializations</h4><p>The M.Pharm program often offers various specializations, allowing students to focus on specific areas of interest within pharmacy. Common specializations include:</p><ol><li><p><strong>Pharmacology</strong>: Study of drug action and interaction within biological systems.</p></li><li><p><strong>Pharmaceutical Chemistry</strong>: Focus on the design, synthesis, and analysis of pharmaceutical compounds.</p></li><li><p><strong>Pharmaceutics</strong>: Development of drug delivery systems and dosage forms.</p></li><li><p><strong>Pharmacognosy</strong>: Study of medicinal plants and natural products used in pharmaceuticals.</p></li><li><p><strong>Clinical Pharmacy</strong>: Emphasis on patient care, medication therapy management, and clinical decision-making.</p></li><li><p><strong>Industrial Pharmacy</strong>: Focus on the manufacturing processes and quality control in the pharmaceutical industry.</p></li><li><p><strong>Hospital Pharmacy</strong>: Specialized knowledge in the management of medications within hospital settings.</p></li></ol><h4>Conclusion</h4><p>The Master of Pharmacy (M.Pharm) is a comprehensive program that equips students with advanced knowledge and skills in the field of pharmacy. With a variety of specializations and a broad range of career opportunities, the M.Pharm degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	M.Pharm-	{}	{<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusion</h4>}	29	{}	2024-08-13 11:41:02.401187	Add
M.Phil	An M.Phil is a research-focused postgraduate degree designed to bridge the gap between a Master's degree and a PhD. It provides students with advanced research skills and the opportunity to delve deep into a specific research area.		2 Years	53251	M.Phil: Master of Philosophy - Your Path to Research Excellence	Discover the M.Phil program, a research-oriented postgraduate degree. Learn about eligibility, specializations, career options, and how to excel in research.	images (13).jfif	Full Time 	Feature	pgCourses	1	\N	<h2 style="text-align: justify;">Overview</h2><p style="text-align: justify;">The Master of Philosophy (M.Phil) is a postgraduate research degree that focuses on advanced research and academic scholarship in various disciplines. This program is designed for students who wish to deepen their understanding of a specific subject area and contribute original research to their field. An M.Phil typically serves as a precursor to a Doctor of Philosophy (Ph.D.) degree, although it can also be pursued as a standalone qualification.</p><p style="text-align: justify;">The M.Phil program usually spans one to two years and involves rigorous coursework, independent research, and the completion of a thesis or dissertation. The program emphasizes critical thinking, research methodologies, and the development of specialized knowledge.</p><h4 style="text-align: justify;">Eligibility</h4><p style="text-align: justify;">To pursue an M.Phil, candidates generally need to meet the following eligibility criteria:</p><ol><li><p style="text-align: justify;"><strong>Educational Qualification</strong>: A Master's degree in a relevant field from a recognized university or institution is required. In some cases, exceptional candidates with a Bachelor's degree may be considered if they have significant research experience.</p></li><li><p style="text-align: justify;"><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the Master's degree, typically around 55-60%, though this may vary by institution.</p></li><li><p style="text-align: justify;"><strong>Research Proposal</strong>: Applicants are often required to submit a research proposal outlining their intended area of study and research objectives.</p></li><li><p style="text-align: justify;"><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test, such as the National Eligibility Test (NET) in India.</p></li><li><p style="text-align: justify;"><strong>Other Requirements</strong>: Letters of recommendation, a statement of purpose, and relevant work or research experience may also be required by some institutions.</p></li></ol><h4 style="text-align: justify;">Fees</h4><p style="text-align: justify;">The fees for an M.Phil program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p style="text-align: justify;"><strong>Tuition Fees</strong>: This can range from $1,000 to $10,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p style="text-align: justify;"><strong>Additional Costs</strong>: Students may also incur costs for research materials, library access, and other resources. These costs can vary based on the requirements of the research project.</p></li><li><p style="text-align: justify;"><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4 style="text-align: justify;">Career Prospects</h4><p style="text-align: justify;">Graduates with an M.Phil degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p style="text-align: justify;"><strong>Academic Positions</strong>: Teaching and research positions in universities and colleges, where they can contribute to academic scholarship and mentor students.</p></li><li><p style="text-align: justify;"><strong>Research Institutions</strong>: Roles in research organizations, think tanks, and government agencies, conducting specialized research and contributing to policy development.</p></li><li><p style="text-align: justify;"><strong>Publishing and Writing</strong>: Opportunities in academic publishing, editing, and writing, contributing to scholarly publications and journals.</p></li><li><p style="text-align: justify;"><strong>Consultancy</strong>: Offering expert advice and consultancy services in their field of specialization, working with businesses, NGOs, and other organizations.</p></li><li><p style="text-align: justify;"><strong>Public and Private Sector Roles</strong>: Positions in government, non-profits, and private companies that require advanced research skills and subject-matter expertise.</p></li><li><p style="text-align: justify;"><strong>Further Studies</strong>: Pursuing a Ph.D. for advanced research opportunities and academic career progression.</p></li></ol><h4 style="text-align: justify;">Specializations</h4><p style="text-align: justify;">The M.Phil program often offers various specializations, allowing students to focus on specific areas of interest within their chosen field. Common specializations include:</p><ol><li><p style="text-align: justify;"><strong>Humanities and Social Sciences</strong>: Specializations in subjects such as history, literature, sociology, psychology, and political science.</p></li><li><p style="text-align: justify;"><strong>Sciences</strong>: Specializations in disciplines such as biology, chemistry, physics, and environmental science.</p></li><li><p style="text-align: justify;"><strong>Engineering and Technology</strong>: Focus on advanced research in engineering fields such as civil, mechanical, electrical, and computer engineering.</p></li><li><p style="text-align: justify;"><strong>Business and Management</strong>: Specializations in areas such as finance, marketing, organizational behavior, and strategic management.</p></li><li><p style="text-align: justify;"><strong>Education</strong>: Focus on research in educational theory, policy, and practice, contributing to advancements in the field of education.</p></li><li><p style="text-align: justify;"><strong>Law</strong>: Specializations in legal research, constitutional law, international law, and other areas of legal studies.</p></li><li><p style="text-align: justify;"><strong>Medical and Health Sciences</strong>: Focus on advanced research in medical fields, public health, and healthcare management.</p></li></ol><h4 style="text-align: justify;">Conclusion</h4><p style="text-align: justify;">The Master of Philosophy (M.Phil) is a comprehensive program that equips students with advanced research skills and specialized knowledge in their chosen field. With a variety of specializations and a broad range of career opportunities, the M.Phil degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	M.Phil-	{}	{"<h2 style=\\"text-align: justify;\\">Overview</h2>"}	{}	{"<h4 style=\\"text-align: justify;\\">Eligibility</h4>","<h4 style=\\"text-align: justify;\\">Fees</h4>","<h4 style=\\"text-align: justify;\\">Career Prospects</h4>","<h4 style=\\"text-align: justify;\\">Specializations</h4>","<h4 style=\\"text-align: justify;\\">Conclusion</h4>"}	31	{}	2024-08-13 11:41:02.401187	Add
MJMC	The MA in Journalism & Mass Communication equips students with skills in media production, reporting, and analysis. It combines theory with practical experience, preparing graduates for careers in journalism, advertising, public relations, and media management.		2 Years	76576	Master of Journalism & Mass Communication-	Become a skilled media professional with our Master of Journalism & Mass Communication program. Learn to report, write, and produce compelling content across various media platforms. Gain hands-on experience and prepare for a successful career in journalism and media industries.	journalism(1).jpg	Full Time 	Feature	pgCourses	1	2024-08-20 10:24:34	<p>The Master of Journalism and Mass Communication (MJMC) is a postgraduate degree designed to equip students with the skills and knowledge required to excel in the dynamic fields of journalism and mass communication. This program offers a blend of theoretical insights and practical experiences, preparing graduates for diverse roles within the media industry.</p><h2>Program Overview</h2><p><br>The MJMC program typically spans two years and includes a mix of core courses and electives. The curriculum addresses crucial topics such as:</p><ul><li>Communication Theory and Practice</li><li>History of Indian Media</li><li>Global Media and Inter-Cultural Communication</li><li>Print Journalism and Media Writing</li><li>Media Management</li><li>Research Methodology for Communication and Media Studies</li></ul><p>Students engage in practical assignments, such as portfolio development, short films, and research projects, to enhance their media communication skills and prepare for real-world challenges in the media sector.</p><h3><strong>Admission Requirements</strong></h3><p><br>Eligibility for the MJMC program usually requires a bachelor’s degree in any discipline with a minimum percentage (typically around 50%). Some institutions may also require an entrance exam or proof of English language proficiency.</p><h3><strong>Specializations</strong></h3><p><br>Many MJMC programs offer specializations in areas such as:</p><ul><li>Print Media</li><li>Electronic Media</li><li>New Media</li><li>Advertising and Public Relations</li><li>Film Studies</li></ul><p>These specializations enable students to focus their education according to their career goals and interests within the media industry.</p><h3><strong>Career Opportunities</strong></h3><p><br>Graduates of the MJMC program can explore various career paths, including:</p><ul><li><strong>Journalist:</strong> Reporting news for diverse media platforms.</li><li><strong>Content Writer:</strong> Crafting engaging content for websites and publications.</li><li><strong>Editor:</strong> Overseeing content quality and accuracy in publications.</li><li><strong>Photojournalist:</strong> Capturing stories through photography.</li><li><strong>Media Manager:</strong> Managing media projects and teams.</li></ul><p>Salaries for these positions can vary. For example, journalists and correspondents may earn around ₹3,46,511 annually, while content writers can expect to earn approximately ₹2,38,392.</p><h3><strong>Conclusion</strong></h3><p><br>The Master of Journalism and Mass Communication is a thorough program designed to prepare students for the evolving media landscape. With its focus on both practical skills and theoretical knowledge, graduates are well-prepared to embark on various roles in journalism, mass communication, and related fields.</p>			ASdasdasd						Active		Ibrahim	Master-of-Journalism-&-Mass-Communication--	{}	{"<h2>Program Overview</h2>"}	{"<h3><strong>Admission Requirements</strong></h3>",<h3><strong>Specializations</strong></h3>,"<h3><strong>Career Opportunities</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	37	{}	2024-08-13 11:41:02.401187	Add
MSW	A Master of Social Work (MSW) is a professional degree that prepares graduates to work with individuals, families, groups, and communities to address social problems. The program focuses on developing critical thinking, problem-solving, and interpersonal skills, as well as a deep understanding of social systems and policies.		2 Years	7676	Master of Social Work (MSW): Empowering Lives, Shaping Communities	Discover the MSW program, a professional degree that equips you with the skills and knowledge to address social issues and improve the lives of individuals and communities. Learn about the curriculum, career opportunities, and admission requirements.	MSW.jpg	Full Time 	Feature	pgCourses	1	2024-08-26 09:18:56	<p>The <strong>Master of Social Work (MSW)</strong> is a postgraduate degree designed to prepare individuals for advanced practice in the field of social work. This program focuses on developing the knowledge, skills, and competencies required to address various social issues and support individuals, families, and communities in need.</p><h2><strong>Course Overview</strong></h2><p>The MSW program typically spans 2 years, though some institutions may offer accelerated or part-time options. The curriculum integrates theoretical learning with practical fieldwork, ensuring that students gain both academic knowledge and hands-on experience.</p><h3><strong>Core Subjects</strong></h3><ol><li><p><strong>Introduction to Social Work</strong></p><ul><li>Overview of social work as a profession</li><li>Historical development and core values of social work practice</li></ul></li><li><p><strong>Human Behavior and the Social Environment</strong></p><ul><li>Theories of human development and behavior</li><li>Impact of social, economic, and environmental factors on individuals and communities</li></ul></li><li><p><strong>Social Work Practice with Individuals and Families</strong></p><ul><li>Techniques and interventions for working with individuals and families</li><li>Case management and counseling strategies</li></ul></li><li><p><strong>Social Work Practice with Groups and Communities</strong></p><ul><li>Group dynamics, facilitation, and community organizing</li><li>Approaches to working with diverse and marginalized groups</li></ul></li><li><p><strong>Research Methods in Social Work</strong></p><ul><li>Research design, data collection, and analysis methods</li><li>Application of research findings to practice and policy development</li></ul></li><li><p><strong>Social Welfare Policy and Services</strong></p><ul><li>Analysis of social welfare policies and their impact on practice</li><li>Advocacy for policy change and improvement in social services</li></ul></li><li><p><strong>Ethics and Professionalism in Social Work</strong></p><ul><li>Ethical principles and decision-making in social work practice</li><li>Professional standards and self-care strategies</li></ul></li><li><p><strong>Field Practicum</strong></p><ul><li>Supervised fieldwork in social service agencies or community organizations</li><li>Application of theoretical knowledge to real-world practice</li></ul></li><li><p><strong>Specializations (Optional)</strong></p><ul><li>Child and Family Social Work</li><li>Clinical Social Work</li><li>School Social Work</li><li>Community Development</li><li>Healthcare Social Work</li></ul></li></ol><h3><strong>Eligibility Criteria</strong></h3><p>To enroll in an MSW program, candidates typically need:</p><ul><li>A bachelor’s degree in social work (BSW) or a related field (some programs accept candidates from other disciplines).</li><li>A minimum GPA as specified by the institution.</li><li>Some programs may require relevant work or volunteer experience in social services.</li></ul><h3><strong>Career Prospects</strong></h3><p>Graduates of the MSW program can pursue a variety of roles in social work, including:</p><ul><li><strong>Clinical Social Worker:</strong> Providing therapy and counseling to individuals, families, and groups.</li><li><strong>School Social Worker:</strong> Supporting students and families within educational settings and addressing issues such as bullying and learning disabilities.</li><li><strong>Healthcare Social Worker:</strong> Assisting patients and their families in healthcare settings, including hospitals and clinics.</li><li><strong>Community Organizer:</strong> Working to mobilize communities and advocate for social change and development.</li><li><strong>Social Service Manager:</strong> Overseeing social service programs and managing staff and resources in agencies or non-profits.</li><li><strong>Policy Analyst:</strong> Researching and analyzing social policies and advocating for policy changes.</li></ul><h3><strong>Job Sectors</strong></h3><ul><li><strong>Healthcare Facilities:</strong> Hospitals, clinics, and mental health centers.</li><li><strong>Educational Institutions:</strong> Schools, colleges, and universities.</li><li><strong>Non-Profit Organizations:</strong> Agencies focused on social services, advocacy, and community development.</li><li><strong>Government Agencies:</strong> Departments responsible for social services, child welfare, and community programs.</li><li><strong>Community Organizations:</strong> Local groups and initiatives focused on social justice, environmental issues, and community support.</li></ul><h3><strong>Skills Acquired</strong></h3><ul><li><strong>Counseling and Therapy:</strong> Techniques for providing mental health support and guidance.</li><li><strong>Crisis Intervention:</strong> Skills for handling emergencies and providing immediate assistance.</li><li><strong>Advocacy:</strong> Ability to advocate for individuals and communities, influencing policy and service delivery.</li><li><strong>Research and Evaluation:</strong> Competence in conducting research and evaluating social programs and services.</li><li><strong>Cultural Competence:</strong> Understanding and respecting diverse backgrounds and working effectively with various populations.</li></ul><h3><strong>Conclusion</strong></h3><p>The Master of Social Work (MSW) degree provides a comprehensive foundation for a career in social work, preparing graduates to tackle complex social issues and provide critical support to individuals and communities. With its focus on both theoretical knowledge and practical application, the MSW program equips students with the skills needed to make a meaningful impact in the field of social work.</p>			ASdasdasd						Active		Ibrahim	MSW-	{}	{"<h2><strong>Course Overview</strong></h2>"}	{"<h3><strong>Core Subjects</strong></h3>","<h3><strong>Eligibility Criteria</strong></h3>","<h3><strong>Career Prospects</strong></h3>","<h3><strong>Job Sectors</strong></h3>","<h3><strong>Skills Acquired</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	66	{}	2024-08-23 10:27:32.760644	Add
DLIS	A Diploma in Library Science is a vocational qualification that provides students with a solid foundation in the principles and practices of library management and information organization. This program is designed to equip individuals with the necessary skills to work in various library settings, including public libraries, academic libraries, and special libraries.		2 Years	53452	Diploma in Library Science: Your Gateway to a Career in Information Management	Explore the Diploma in Library Science program, a comprehensive course designed to equip you with the skills and knowledge needed to manage and organize information resources effectively. Learn about the curriculum, career opportunities, and admission requirements.	images (27).jfif	Full Time 	Feature	Diploma	1	2024-09-02 17:22:39	<p style="text-align: justify;">The <strong>Diploma in Library Science</strong> is a program designed to provide students with foundational knowledge and skills in managing libraries and information centers. This course focuses on the principles of library organization, cataloging, information retrieval, and the effective use of technology in managing library resources.</p><h2 style="text-align: justify;"><strong>Course Overview</strong></h2><p style="text-align: justify;">The Diploma in Library Science typically lasts 1 to 2 years, depending on the institution and whether it is pursued on a full-time or part-time basis. The program combines theoretical instruction with practical training, preparing students for various roles within libraries, archives, and information centers.</p><h3 style="text-align: justify;"><strong>Core Subjects</strong></h3><ol><li><p style="text-align: justify;"><strong>Introduction to Library Science</strong></p><ul><li>Overview of the library profession</li><li>Types of libraries and their functions</li></ul></li><li><p style="text-align: justify;"><strong>Library Classification and Cataloging</strong></p><ul><li>Principles of organizing and classifying library materials</li><li>Dewey Decimal Classification (DDC) and Library of Congress Classification (LCC)</li><li>Creating and maintaining library catalogs</li></ul></li><li><p style="text-align: justify;"><strong>Information Retrieval Systems</strong></p><ul><li>Techniques for efficient information search and retrieval</li><li>Use of online databases and digital libraries</li></ul></li><li><p style="text-align: justify;"><strong>Library Management</strong></p><ul><li>Administrative aspects of running a library</li><li>Budgeting, staffing, and resource management</li></ul></li><li><p style="text-align: justify;"><strong>Reference Services</strong></p><ul><li>Providing reference and information services to library users</li><li>Techniques for answering queries and guiding research</li></ul></li><li><p style="text-align: justify;"><strong>Library Automation and Digital Libraries</strong></p><ul><li>Introduction to library automation software and systems</li><li>Managing digital collections and e-resources</li></ul></li><li><p style="text-align: justify;"><strong>Preservation and Conservation of Library Materials</strong></p><ul><li>Techniques for preserving books, manuscripts, and digital media</li><li>Strategies for maintaining the longevity of library collections</li></ul></li><li><p style="text-align: justify;"><strong>Research Methodology</strong></p><ul><li>Basics of research methods in library science</li><li>Data collection, analysis, and reporting</li></ul></li><li><p style="text-align: justify;"><strong>User Education and Library Marketing</strong></p><ul><li>Teaching users how to effectively use library resources</li><li>Promoting library services to the community</li></ul></li></ol><h3 style="text-align: justify;"><strong>Eligibility Criteria</strong></h3><p style="text-align: justify;">To enroll in a Diploma in Library Science program, candidates typically need:</p><ul><li style="text-align: justify;">A high school diploma or equivalent (10+2) from a recognized board.</li><li style="text-align: justify;">Some institutions may require a minimum percentage in the qualifying examination.</li></ul><h3 style="text-align: justify;"><strong>Career Prospects</strong></h3><p style="text-align: justify;">Graduates of the Diploma in Library Science program can pursue various roles, including:</p><ul><li style="text-align: justify;"><strong>Library Assistant:</strong> Assisting in the daily operations of a library, including cataloging, shelving, and helping patrons.</li><li style="text-align: justify;"><strong>Cataloger:</strong> Organizing and classifying books, journals, and other library materials.</li><li style="text-align: justify;"><strong>Reference Librarian:</strong> Providing research assistance and reference services to library users.</li><li style="text-align: justify;"><strong>Library Technician:</strong> Managing technical aspects of library operations, such as automation and digital cataloging.</li><li style="text-align: justify;"><strong>Archivist Assistant:</strong> Helping in the preservation and organization of historical documents and records.</li></ul><h3 style="text-align: justify;"><strong>Job Sectors</strong></h3><ul><li style="text-align: justify;"><strong>Public Libraries:</strong> Serving the community by managing collections and assisting patrons.</li><li style="text-align: justify;"><strong>Academic Libraries:</strong> Supporting students and faculty in universities, colleges, and schools.</li><li style="text-align: justify;"><strong>Special Libraries:</strong> Working in libraries within corporations, law firms, medical institutions, or government agencies.</li><li style="text-align: justify;"><strong>Archives:</strong> Managing historical documents and records in museums, cultural institutions, and government repositories.</li><li style="text-align: justify;"><strong>Digital Libraries:</strong> Organizing and managing digital collections and online resources.</li></ul><h3 style="text-align: justify;"><strong>Skills Acquired</strong></h3><ul><li style="text-align: justify;"><strong>Information Organization:</strong> Proficiency in cataloging, classification, and information retrieval systems.</li><li style="text-align: justify;"><strong>Customer Service:</strong> Helping library users find information and use resources effectively.</li><li style="text-align: justify;"><strong>Technical Skills:</strong> Familiarity with library automation software, databases, and digital tools.</li><li style="text-align: justify;"><strong>Preservation Techniques:</strong> Knowledge of preserving physical and digital materials.</li><li style="text-align: justify;"><strong>Research Skills:</strong> Ability to assist in academic and professional research projects.</li></ul><h3 style="text-align: justify;"><strong>Conclusion</strong></h3><p style="text-align: justify;">A Diploma in Library Science provides a solid foundation for a career in the library and information sector. It prepares students to handle the technical, administrative, and service-oriented aspects of library work. With the increasing demand for skilled professionals in both traditional and digital libraries, this diploma offers numerous opportunities for growth in the field of library science.</p>			ASdasdasd						Active		Ibrahim	DIPLOMA-IN-LIBRARY-SCIENCE-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Overview</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>Core Subjects</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Career Prospects</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Job Sectors</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Skills Acquired</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h3>"}	{}	63	{}	2024-08-23 09:38:43.393911	Add
DAE	A Diploma in Engineering\n\n is a vocational qualification designed to provide students with the practical skills and knowledge required for entry-level positions in various engineering fields. It's a shorter program compared to a Bachelor's degree, making it a popular choice for those who want to quickly enter the workforce or explore a specific engineering specialization.		3 Years	87621	Diploma in Engineering: Course Overview, Eligibility, Fees, and Career Opportunities	Explore the Diploma in Engineering course, including its overview, eligibility criteria, fee structure, and career opportunities available in various engineering fields.	MG_0201.jpg	Full Time 	Feature	advancedDiploma	1	2024-09-02 17:22:39	<p style="text-align: justify;">The Diploma in Engineering is a technical education program designed to provide students with a solid foundation in engineering principles and practical skills. This course is aimed at individuals who wish to start a career in engineering or enhance their technical expertise for various engineering fields. It typically covers core subjects in engineering and prepares students for entry-level positions in the industry or further studies.</p><h2 style="text-align: justify;"><strong>Course Duration and Structure</strong></h2><p style="text-align: justify;">The Diploma in Engineering program usually lasts for 3 years and is divided into six semesters. The curriculum includes both theoretical and practical components, focusing on fundamental engineering concepts and hands-on training. Key components of the program include:</p><ul><li style="text-align: justify;"><strong>Core Engineering Subjects:</strong> Mathematics, Physics, Chemistry, Engineering Mechanics, Thermodynamics, and Electrical Engineering.</li><li style="text-align: justify;"><strong>Specialization Modules:</strong> Depending on the chosen field, students may study subjects related to Mechanical, Civil, Electrical, Electronics, Computer Science, or Chemical Engineering.</li><li style="text-align: justify;"><strong>Practical Training:</strong> Laboratory work, workshops, and industry internships to provide practical experience.</li></ul><h4 style="text-align: justify;"><strong>Eligibility Criteria</strong></h4><p style="text-align: justify;">To enroll in a Diploma in Engineering program, candidates typically need to meet the following criteria:</p><ul><li style="text-align: justify;"><strong>Educational Qualification:</strong> Completion of 10th grade (Class X) or equivalent from a recognized board with a minimum percentage, usually around 50%. Some institutions may require specific marks in Mathematics and Science subjects.</li><li style="text-align: justify;"><strong>Age Limit:</strong> There is generally no specific age limit, allowing students of various ages to pursue the diploma.</li></ul><h4 style="text-align: justify;"><strong>Fee Structure</strong></h4><p style="text-align: justify;">The fee structure for a Diploma in Engineering program can vary depending on the institution and location. On average, the fees range from INR 30,000 to INR 1,00,000 per year. Scholarships and financial aid options may be available for eligible students to support their education.</p><h4 style="text-align: justify;"><strong>Specializations in Diploma in Engineering</strong></h4><p style="text-align: justify;">Students can choose from various specializations based on their interests and career goals. Common specializations include:</p><ul><li style="text-align: justify;"><strong>Mechanical Engineering</strong></li><li style="text-align: justify;"><strong>Civil Engineering</strong></li><li style="text-align: justify;"><strong>Electrical Engineering</strong></li><li style="text-align: justify;"><strong>Electronics Engineering</strong></li><li style="text-align: justify;"><strong>Computer Science Engineering</strong></li><li style="text-align: justify;"><strong>Chemical Engineering</strong></li></ul><h4 style="text-align: justify;"><strong>Career Prospects After Diploma in Engineering</strong></h4><p style="text-align: justify;">Graduates of a Diploma in Engineering program have various career opportunities available to them. Some of the potential roles include:</p><ul><li style="text-align: justify;"><strong>Engineering Technician:</strong> Assist engineers in designing, testing, and implementing engineering solutions.</li><li style="text-align: justify;"><strong>Project Coordinator:</strong> Manage and coordinate engineering projects and ensure they meet specified requirements.</li><li style="text-align: justify;"><strong>Technical Support Engineer:</strong> Provide technical support and troubleshooting for engineering products and systems.</li><li style="text-align: justify;"><strong>Quality Control Inspector:</strong> Ensure that engineering products and processes meet quality standards.</li><li style="text-align: justify;"><strong>Design Engineer:</strong> Work on designing and developing engineering solutions in various fields.</li></ul><h4 style="text-align: justify;"><strong>Higher Education and Further Studies</strong></h4><p style="text-align: justify;">After completing the Diploma in Engineering, students can opt for further education, such as:</p><ul><li style="text-align: justify;"><strong>Bachelor’s Degree:</strong> Lateral entry into a Bachelor of Engineering (B.E.) or Bachelor of Technology (B.Tech.) program to complete an engineering degree.</li><li style="text-align: justify;"><strong>Specialized Courses:</strong> Pursue advanced certifications or diplomas in specialized engineering areas or management.</li></ul><h4 style="text-align: justify;"><strong>Conclusion</strong></h4><p style="text-align: justify;">The Diploma in Engineering offers a robust foundation in technical and engineering skills, preparing students for diverse career opportunities in the engineering industry. It provides practical knowledge and hands-on experience that are essential for success in various engineering fields. Whether entering the workforce directly or pursuing further education, a Diploma in Engineering is a valuable step towards a successful engineering career.</p>			ASdasdasd						Active	TOC	Ibrahim	DIPLOMA-IN-ENGINEERING-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Duration and Structure</strong></h2>"}	{}	{"<h4 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Fee Structure</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Specializations in Diploma in Engineering</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Career Prospects After Diploma in Engineering</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Higher Education and Further Studies</strong></h4>","<h4 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h4>"}	55	{}	2024-08-21 06:46:10.955482	Add
HMCT	A Diploma in Hotel Management is a vocational qualification that provides students with a solid foundation in the principles and practices of the hotel and hospitality industry. This program is designed to equip individuals with the necessary skills to manage various aspects of hotel operations, from front office and housekeeping to food and beverage services.		2 Years	32414	Diploma in Hotel Management: Your Gateway to a Thriving Career	Explore the Diploma in Hotel Management program, a comprehensive course designed to equip you with the skills and knowledge needed to excel in the hospitality industry. Learn about the curriculum, career opportunities, and admission requirements.	gallery-10.jpg	Full Time 	Feature	Diploma	1	2024-09-02 17:22:39	<p style="text-align: justify;">The <strong>Diploma in Hotel Management</strong> is a specialized program designed to equip students with the essential skills and knowledge required to pursue a career in the hospitality and hotel industry. This program focuses on various aspects of hotel operations, including front office management, housekeeping, food and beverage services, and customer relations.</p><h2 style="text-align: justify;"><strong>Course Overview</strong></h2><p style="text-align: justify;">The Diploma in Hotel Management typically spans 1 to 2 years, depending on the institution and whether it’s offered as a full-time or part-time course. The curriculum is designed to provide both theoretical knowledge and practical experience, preparing students to handle the dynamic and fast-paced environment of the hospitality industry.</p><h3 style="text-align: justify;"><strong>Core Subjects</strong></h3><ol><li><p style="text-align: justify;"><strong>Introduction to Hospitality Management</strong></p><ul><li>Overview of the hospitality industry</li><li>Understanding the structure and functions of different departments in a hotel</li></ul></li><li><p style="text-align: justify;"><strong>Front Office Operations</strong></p><ul><li>Reservation systems, check-in and check-out procedures</li><li>Guest relations and customer service</li></ul></li><li><p style="text-align: justify;"><strong>Housekeeping Management</strong></p><ul><li>Room maintenance, cleaning procedures, and standards</li><li>Inventory management and housekeeping operations</li></ul></li><li><p style="text-align: justify;"><strong>Food and Beverage Management</strong></p><ul><li>Restaurant and bar operations</li><li>Menu planning, food service, and beverage management</li></ul></li><li><p style="text-align: justify;"><strong>Culinary Arts</strong></p><ul><li>Basic cooking techniques, kitchen safety, and hygiene</li><li>Food presentation and culinary trends</li></ul></li><li><p style="text-align: justify;"><strong>Hospitality Marketing and Sales</strong></p><ul><li>Marketing strategies for hotels and resorts</li><li>Sales techniques and customer relationship management</li></ul></li><li><p style="text-align: justify;"><strong>Hotel Accounting and Financial Management</strong></p><ul><li>Basic accounting principles for the hospitality industry</li><li>Budgeting, cost control, and financial analysis</li></ul></li><li><p style="text-align: justify;"><strong>Event Management</strong></p><ul><li>Planning and organizing events such as conferences, weddings, and banquets</li><li>Coordination and management of event logistics</li></ul></li></ol><h3 style="text-align: justify;"><strong>Eligibility Criteria</strong></h3><p style="text-align: justify;">To enroll in a Diploma in Hotel Management program, candidates typically need:</p><ul><li style="text-align: justify;">A high school diploma or equivalent (10+2) from a recognized board.</li><li style="text-align: justify;">Some institutions may require a minimum percentage in the qualifying examination.</li></ul><h3 style="text-align: justify;"><strong>Career Prospects</strong></h3><p style="text-align: justify;">Graduates of the Diploma in Hotel Management program can pursue various roles in the hospitality industry, including:</p><ul><li style="text-align: justify;"><strong>Front Office Manager:</strong> Overseeing the front desk operations, managing staff, and ensuring a positive guest experience.</li><li style="text-align: justify;"><strong>Housekeeping Supervisor:</strong> Managing the housekeeping team, ensuring cleanliness and maintenance of guest rooms and public areas.</li><li style="text-align: justify;"><strong>Food and Beverage Manager:</strong> Supervising restaurant and bar operations, managing staff, and ensuring quality service.</li><li style="text-align: justify;"><strong>Catering Manager:</strong> Overseeing catering services, planning menus, and coordinating food service for events.</li><li style="text-align: justify;"><strong>Event Coordinator:</strong> Planning and organizing events, ensuring smooth execution, and managing event logistics.</li><li style="text-align: justify;"><strong>Hotel Sales Executive:</strong> Promoting the hotel’s services, managing customer relationships, and driving sales.</li></ul><h3 style="text-align: justify;"><strong>Job Sectors</strong></h3><ul><li style="text-align: justify;"><strong>Hotels and Resorts:</strong> Working in various departments such as front office, housekeeping, or food and beverage services.</li><li style="text-align: justify;"><strong>Restaurants:</strong> Managing operations, customer service, and food quality in dining establishments.</li><li style="text-align: justify;"><strong>Cruise Lines:</strong> Providing hospitality services on luxury cruise ships.</li><li style="text-align: justify;"><strong>Event Management Companies:</strong> Planning and executing events, conferences, and banquets.</li><li style="text-align: justify;"><strong>Airlines:</strong> Working in customer service or in-flight management roles.</li><li style="text-align: justify;"><strong>Tourism Boards:</strong> Promoting destinations and managing tourist facilities.</li></ul><h3 style="text-align: justify;"><strong>Skills Acquired</strong></h3><ul><li style="text-align: justify;"><strong>Customer Service:</strong> Enhancing guest experiences and managing customer interactions.</li><li style="text-align: justify;"><strong>Team Management:</strong> Leading teams in various hotel departments.</li><li style="text-align: justify;"><strong>Problem-Solving:</strong> Addressing and resolving issues efficiently in a fast-paced environment.</li><li style="text-align: justify;"><strong>Communication:</strong> Effectively communicating with guests, staff, and management.</li><li style="text-align: justify;"><strong>Organizational Skills:</strong> Managing multiple tasks and ensuring smooth operations.</li></ul><h3 style="text-align: justify;"><strong>Conclusion</strong></h3><p style="text-align: justify;">A Diploma in Hotel Management provides a solid foundation for a career in the hospitality industry. It equips students with the necessary skills to work in various roles within hotels, resorts, restaurants, and other hospitality-related businesses. With the growing global demand for hospitality services, this diploma opens up numerous opportunities for career advancement in the dynamic and ever-evolving hospitality sector.</p>			ASdasdasd						Active	TOC	Ibrahim	DIPLOMA-IN-HOTEL-MANAGEMENT-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>Course Overview</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>Core Subjects</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Eligibility Criteria</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Career Prospects</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Job Sectors</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Skills Acquired</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Conclusion</strong></h3>"}	{}	61	{}	2024-08-23 09:32:31.075864	Add
D.ID	A Diploma in Interior Design is a vocational qualification that provides students with a strong foundation in the principles and practices of interior design. This program is designed to develop individuals' creative abilities and technical skills, enabling them to design and decorate spaces that are both aesthetically pleasing and functional.		2 Years	21235	Diploma in Interior Design: Transform Spaces, Shape Careers	Discover the Diploma in Interior Design program, a comprehensive course that equips you with the skills to create stunning and functional interiors. Learn about the curriculum, career opportunities, and admission requirements.	images (26).jfif	Full Time 	Feature	Diploma	1	2024-09-02 17:22:39	<p>The <strong>Diploma in Interior Design</strong> is a specialized program aimed at equipping students with the fundamental skills and knowledge required to pursue a career in interior design. This program focuses on the principles of design, space planning, color theory, materials, and the technical aspects of creating aesthetically pleasing and functional interior spaces.</p><h2><strong>Course Overview</strong></h2><p>The Diploma in Interior Design typically spans 1 to 2 years, depending on the institution and whether it’s offered as a full-time or part-time course. The curriculum is designed to provide a balance of theoretical knowledge and practical application, preparing students to meet the demands of the interior design industry.</p><h3><strong>Core Subjects</strong></h3><ol><li><p><strong>Introduction to Interior Design</strong></p><ul><li>Overview of interior design as a profession</li><li>Historical perspectives and evolution of interior design</li></ul></li><li><p><strong>Design Principles and Elements</strong></p><ul><li>Fundamentals of design, including balance, harmony, contrast, and rhythm</li><li>Application of design elements such as line, shape, texture, and color</li></ul></li><li><p><strong>Space Planning</strong></p><ul><li>Techniques for efficient space utilization</li><li>Creating layouts that maximize functionality and aesthetics</li></ul></li><li><p><strong>Color Theory and Application</strong></p><ul><li>Understanding color psychology and its impact on interior spaces</li><li>Application of color schemes in residential and commercial design</li></ul></li><li><p><strong>Materials and Finishes</strong></p><ul><li>Knowledge of various materials used in interior design (wood, metal, glass, fabrics)</li><li>Selection of finishes and their application in different spaces</li></ul></li><li><p><strong>Furniture Design and Layout</strong></p><ul><li>Design and selection of furniture for different environments</li><li>Creating functional and aesthetically pleasing furniture layouts</li></ul></li><li><p><strong>Lighting Design</strong></p><ul><li>Importance of lighting in interior design</li><li>Techniques for effective lighting in residential and commercial spaces</li></ul></li><li><p><strong>AutoCAD and 3D Modeling</strong></p><ul><li>Introduction to computer-aided design (CAD) software</li><li>Creating 2D and 3D models for interior design projects</li></ul></li><li><p><strong>Sustainable Design</strong></p><ul><li>Principles of sustainable and eco-friendly design</li><li>Use of sustainable materials and practices in interior design</li></ul></li><li><p><strong>Project Management</strong></p><ul><li>Managing interior design projects from concept to completion</li><li>Budgeting, scheduling, and client communication</li></ul></li></ol><h3><strong>Eligibility Criteria</strong></h3><p>To enroll in a Diploma in Interior Design program, candidates typically need:</p><ul><li>A high school diploma or equivalent (10+2) from a recognized board.</li><li>Some institutions may also require a portfolio of creative work or an entrance exam.</li></ul><h3><strong>Career Prospects</strong></h3><p>Graduates of the Diploma in Interior Design program can pursue various roles in the design industry, including:</p><ul><li><strong>Interior Designer:</strong> Designing residential, commercial, or industrial spaces to meet client needs.</li><li><strong>Space Planner:</strong> Focusing on optimizing the layout and functionality of interior spaces.</li><li><strong>Furniture Designer:</strong> Creating custom furniture pieces that complement interior design projects.</li><li><strong>Lighting Designer:</strong> Specializing in the design and implementation of lighting solutions for interior spaces.</li><li><strong>Color Consultant:</strong> Advising clients on color schemes and combinations for their spaces.</li><li><strong>CAD Specialist:</strong> Creating detailed 2D and 3D models for interior design projects using software like AutoCAD.</li></ul><h3><strong>Job Sectors</strong></h3><ul><li><strong>Interior Design Firms:</strong> Working on a variety of design projects for residential and commercial clients.</li><li><strong>Architectural Firms:</strong> Collaborating with architects to design interiors that align with architectural plans.</li><li><strong>Furniture Companies:</strong> Designing and selecting furniture pieces that complement interior spaces.</li><li><strong>Real Estate Developers:</strong> Designing model homes and interiors for residential and commercial properties.</li><li><strong>Retail Stores:</strong> Creating attractive and functional store layouts to enhance customer experience.</li></ul><h3><strong>Skills Acquired</strong></h3><ul><li><strong>Creative Design:</strong> Developing innovative design concepts that meet client needs and preferences.</li><li><strong>Technical Proficiency:</strong> Mastery of design software like AutoCAD, SketchUp, and 3D modeling tools.</li><li><strong>Project Management:</strong> Overseeing design projects, managing timelines, and working within budgets.</li><li><strong>Client Communication:</strong> Effectively communicating design ideas and plans to clients.</li><li><strong>Attention to Detail:</strong> Ensuring precision in all aspects of design, from material selection to final execution.</li></ul><h3><strong>Conclusion</strong></h3><p>A Diploma in Interior Design provides a strong foundation for a career in the interior design industry. It equips students with the creative and technical skills necessary to transform spaces into functional and aesthetically pleasing environments. With the growing demand for innovative and sustainable interior solutions, this diploma offers numerous opportunities for professional growth and specialization in the dynamic field of interior design.</p>			ASdasdasd						Active		Ibrahim	DIPLOMA-IN-INTERIOR-DESIGNER-	{}	{"<h2><strong>Course Overview</strong></h2>"}	{"<h3><strong>Core Subjects</strong></h3>","<h3><strong>Eligibility Criteria</strong></h3>","<h3><strong>Career Prospects</strong></h3>","<h3><strong>Job Sectors</strong></h3>","<h3><strong>Skills Acquired</strong></h3>",<h3><strong>Conclusion</strong></h3>}	{}	62	{}	2024-08-23 09:34:50.13483	Add
\.


--
-- TOC entry 4111 (class 0 OID 16878)
-- Dependencies: 290
-- Data for Name: individualcoursefaq; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.individualcoursefaq (question, answer, added_by, added_date, courseid, last_modified, id) FROM stdin;
{}	{}	1	\N	1	\N	1
{}	{}	Ibrahim	\N	2	2024-07-23 10:57:43	2
{}	{}	1	\N	3	\N	3
{}	{}	1	\N	4	\N	4
{}	{}	1	\N	5	\N	5
{}	{}	1	\N	6	\N	6
{}	{}	1	\N	7	\N	7
{}	{}	1	\N	8	\N	8
{}	{}	1	\N	9	\N	9
{}	{}	1	\N	10	\N	10
{}	{}	1	\N	11	\N	11
{}	{}	1	\N	12	\N	12
{}	{}	1	\N	14	\N	14
{}	{}	1	\N	15	\N	15
{}	{}	1	\N	16	\N	16
{}	{}	1	\N	17	\N	17
{}	{}	1	\N	18	\N	18
{}	{}	1	\N	19	\N	19
{}	{}	undefined	\N	20	\N	20
{}	{}	undefined	\N	21	\N	21
{}	{}	1	\N	22	\N	22
{}	{}	undefined	\N	23	\N	23
{}	{}	1	\N	24	\N	24
{}	{}	1	\N	25	\N	25
{}	{}	1	\N	26	\N	26
{}	{}	1	\N	27	\N	27
{}	{}	1	\N	28	\N	28
{}	{}	undefined	\N	29	\N	29
{}	{}	1	\N	30	\N	30
{}	{}	1	\N	31	\N	31
{}	{}	undefined	\N	33	\N	33
{}	{}	1	\N	34	\N	34
{}	{}	1	\N	36	\N	36
{}	{}	Ibrahim	\N	38	2024-08-09 15:56:59	38
{}	{}	1	\N	39	\N	39
{}	{}	1	\N	40	\N	40
{}	{}	1	\N	41	\N	41
{}	{}	1	\N	42	\N	42
{}	{}	1	\N	154	\N	84
{}	{}	Ibrahim	\N	44	2024-08-22 10:50:21	44
{}	{}	1	\N	159	\N	85
{}	{}	Ibrahim	\N	51	2024-08-22 10:50:21	51
{}	{}	Ibrahim	\N	57	2024-08-22 10:50:21	57
{}	{}	Ibrahim	\N	45	2024-08-22 10:50:21	45
{}	{}	Ibrahim	\N	58	2024-08-22 10:50:21	58
{}	{}	Ibrahim	\N	52	2024-08-22 10:50:21	52
{}	{}	1	\N	60	\N	60
{}	{}	Ibrahim	\N	13	2024-08-20 10:24:34	13
{}	{}	Ibrahim	\N	37	2024-08-20 10:24:34	37
{}	{}	Ibrahim	\N	66	2024-08-26 09:18:56	66
{}	{}	Ibrahim	\N	35	2024-08-20 10:24:34	35
{}	{}	Ibrahim	\N	53	2024-08-22 10:00:26	53
{}	{}	Ibrahim	\N	59	2024-08-22 10:50:21	59
{}	{}	Ibrahim	\N	47	2024-08-22 10:50:21	47
{}	{}	Ibrahim	\N	54	2024-08-22 10:50:21	54
{}	{}	Ibrahim	\N	48	2024-08-22 10:50:21	48
{}	{}	Ibrahim	\N	49	2024-08-22 10:50:21	49
{}	{}	Ibrahim	\N	56	2024-08-22 10:50:21	56
{}	{}	Ibrahim	\N	43	2024-08-22 10:50:21	43
{}	{}	Ibrahim	\N	50	2024-08-26 09:18:56	50
{}	{}	Ibrahim	\N	67	2024-08-26 09:18:56	67
{}	{}	Ibrahim	\N	63	2024-09-02 17:22:39	63
{}	{}	Ibrahim	\N	55	2024-09-02 17:22:39	55
{}	{}	Ibrahim	\N	61	2024-09-02 17:22:39	61
{}	{}	Ibrahim	\N	64	2024-09-02 17:22:39	64
{}	{}	Ibrahim	\N	62	2024-09-02 17:22:39	62
{}	{}	Ibrahim	\N	65	2024-09-02 17:22:39	65
{}	{}	Ibrahim	\N	46	2024-09-04 10:15:42	46
{}	{}	Ibrahim	\N	32	2024-09-05 18:48:03	32
{}	{}	1	\N	68	\N	68
{}	{}	1	\N	69	\N	69
{}	{}	1	\N	70	\N	70
{}	{}	1	\N	71	\N	71
{}	{}	undefined	\N	72	\N	72
{}	{}	undefined	\N	73	\N	73
{}	{}	undefined	\N	74	\N	74
{}	{}	undefined	\N	75	\N	75
{}	{}	1	\N	76	\N	76
{}	{}	1	\N	77	\N	77
{}	{}	1	\N	78	\N	78
{}	{}	1	\N	79	\N	79
{}	{}	undefined	\N	82	\N	80
{}	{}	1	\N	112	\N	81
{}	{}	1	\N	127	\N	82
{}	{}	1	\N	139	\N	83
\.


--
-- TOC entry 4113 (class 0 OID 16887)
-- Dependencies: 292
-- Data for Name: job; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.job (id, jobtype, jobmode, name, location, responsilibity, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
4	3	5	Full Stack Web Developer	remote	<p>Enter Contentsdfsdf</p>	1	2024-09-26 11:33:51.342192	\N	\N
\.


--
-- TOC entry 4115 (class 0 OID 16897)
-- Dependencies: 294
-- Data for Name: jobmode; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.jobmode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Work From Office	Active	\N	2024-08-21 07:21:30.91835	\N	\N
2	 work from home	Active	\N	2024-08-21 07:21:51.925884	\N	\N
5	 work from home	Active	1	2024-08-21 07:25:58.66436	\N	\N
6	 work from Office	Active	1	2024-08-21 07:26:10.721586	\N	\N
\.


--
-- TOC entry 4117 (class 0 OID 16907)
-- Dependencies: 296
-- Data for Name: jobreference; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.jobreference (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Facebook	Active	1	2024-09-26 10:36:15.042906	\N	\N
\.


--
-- TOC entry 4119 (class 0 OID 16917)
-- Dependencies: 298
-- Data for Name: jobresponse; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.jobresponse (id, jobtype, name, email, reference, resume, experienceed, isugpg, hqualifuication, ctc, expereience, added_by, added_date, last_modified_by, last_modifed_date, phone) FROM stdin;
1	Part Time 	Ibrahim Memon	anurag.k@imtsinsitute.com	1	http://imts.ac.in/images/IbrahimResume.pdf	sadasd	Yes	asdasd	dsdfsdf	sdfsdfsdf	1	2024-09-26 10:39:19.454339	\N	\N	915345345345
2	Full Time	Ibrahim Memon	ibrahimmemon1709@gmail.com	1	http://imts.ac.in/backend/images/IbrahimResume.pdf	dfsdf	Yes	dsfsdf	sdfsdf	sdfsdf	1	2024-09-26 11:34:26.249919	\N	\N	913423423423
\.


--
-- TOC entry 4121 (class 0 OID 16927)
-- Dependencies: 300
-- Data for Name: jobtype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.jobtype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
2	Part Time 	Active	1	2024-08-21 07:20:50.343008	\N	\N
3	Full Time	Active	1	2024-08-21 07:24:31.807628	\N	\N
4	IT	Active	1	2024-08-23 11:30:01.681255	\N	\N
\.


--
-- TOC entry 4123 (class 0 OID 16937)
-- Dependencies: 302
-- Data for Name: lead; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.lead (id, name, email, phone, courseid, universityid, city, message, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4169 (class 0 OID 18507)
-- Dependencies: 348
-- Data for Name: marquee; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.marquee (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 4125 (class 0 OID 16957)
-- Dependencies: 304
-- Data for Name: media; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.media (id, name, image, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
15	AAJ TAK	Blue-Bold-Breaking-News-Facebook-Post-1.jpg	1	2024-08-23 05:57:59.589648	\N	\N
16	NEWS18	Red-Black-Breaking-News-Instagram-Post-6-1024x1024.png	1	2024-08-23 05:58:36.536874	\N	\N
17	FORBES	imts-forbes-1024x1024.png	1	2024-08-23 05:58:58.835938	\N	\N
18	ANI	Red-Black-Breaking-News-Instagram-Post-3-1024x1024.png	1	2024-08-23 05:59:20.756137	\N	\N
19	TOI	Untitled-design-2-1.png	1	2024-08-23 05:59:42.217219	\N	\N
\.


--
-- TOC entry 4127 (class 0 OID 16967)
-- Dependencies: 306
-- Data for Name: moreresource; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.moreresource (id, button1, button2, button3, button4, button5, button6, newstudent, visitus, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
\.


--
-- TOC entry 4129 (class 0 OID 16977)
-- Dependencies: 308
-- Data for Name: news; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.news (id, title, description, image, added_by, last_modified, added_date) FROM stdin;
\.


--
-- TOC entry 4131 (class 0 OID 16987)
-- Dependencies: 310
-- Data for Name: onestep; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.onestep (id, slider, steps, icon, added_by, added_date, last_modifid_by, last_modified_date) FROM stdin;
17	{Educational-Counselling-1.jpg}	{"<p><span><strong>Educational Counseling</strong>: Offers personalized guidance for students in selecting the right courses and institutions.</span></p>"}	{}	1	2024-08-21 07:49:40.240005	1	\N
16	{images.jpeg}	{"<p><span><strong>Student Support Services</strong>: Offers ongoing support and resources for students throughout their educational journey.</span></p>"}	{}	1	2024-07-24 07:39:33.960002	1	\N
10	{An-academic-counselor-guiding-a-student-with-empathy.-As-a-matter-of-fact-it-is-one-of-the-most-important-skills-that-a-counselor-must-have..jpg}	{"<p><span><strong>Educational Counseling</strong>: Offers personalized guidance for students in selecting the right courses and institutions.</span></p>"}	{}	1	2024-07-24 07:37:28.448823	1	\N
14	{career-counseling.jpg}	{"<p><span><strong>Career Guidance</strong>: Provides advice on career planning and development.</span></p>"}	{}	1	2024-07-24 07:38:57.408522	1	\N
12	{channels4_profile.jpg}	{"<p><span><strong>Admission Support</strong>: Assists with the application and admission process for various educational programs.</span></p>"}	{}	1	2024-07-24 07:37:57.499186	1	\N
13	{services3.png}	{"<p><span><strong>Course Selection</strong>: Helps students choose suitable courses based on their interests and career goals.</span></p>"}	{}	1	2024-07-24 07:38:37.579235	1	\N
15	{istockphoto-1181567551-612x612.jpg}	{"<p><span><strong>Information Resources</strong>: Supplies up-to-date information about different educational opportunities and institutions.</span></p>"}	{}	1	2024-07-24 07:39:18.263445	1	\N
\.


--
-- TOC entry 4176 (class 0 OID 18570)
-- Dependencies: 355
-- Data for Name: prevewblog; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.prevewblog (id, pagename, seotitle, seodescription, tag, status, topic, image, content, added_date, added_by, last_modified, feature, toc, active, urlname, toch1, toch2, toch3, toch4, toch5, layout) FROM stdin;
\.


--
-- TOC entry 4175 (class 0 OID 18561)
-- Dependencies: 354
-- Data for Name: prevewindividualcourse; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.prevewindividualcourse (courename, coursedescription, noofyear, noofmonth, fee, title, seodescription, image, mode, feature, categorie, added_by, last_modified, detailcoursedescription, whycourse, whopursuecourse, whentodocourse, keyhighcourse, eligibility, skills, other, admission, active, toc, last_modified_user, urlname, toch1, toch2, toch3, toch4, id, toch5, added_date, role) FROM stdin;
MBA (Master of Business Administration)654654	66546		4 Years	456546	dfgdfg	dfgdfgdfg	faq.png	Full Time 	Feature	ugCourses	1	\N	Enter Content Here									Active	TOC	\N	dfgdfgdfg	{}	{}	{}	{}	148	{}	2024-09-07 17:16:35.300524	Watch
MBA (Master of Business Administration)werwer	erwerwerwer		2 Years	756757	hghfgh	fghfgh	academic.png	Full Time 	Feature	ugCourses	1	\N	<h1>Enter Content Heregfhfgh</h1><p>fghfghfghfgh ghghfghfgh gdfgdfg gdfgdfg</p>									Active	TOC	\N	gfhgfhfg	{"<h1>Enter Content Heregfhfgh</h1>"}	{}	{}	{}	151	{}	2024-09-07 17:29:47.665287	Watch
MBA (Master of Business Administration)asdasd	asdasd		2 Years	34234	sdfsdf	sdfsdfsdf	academic.png	Full Time 	Feature	pgCourses	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	sdfsdfsdf	{}	{<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	158	{}	2024-09-07 17:35:24.091604	Watch
MBA (Master of Business Administration)0809	kjhk		4 Years	08	kjhjk	jhjjk	dashboard.png	Full Time 	Feature	pgCourses	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	sdfsdf78998	{}	{<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	160	{}	2024-09-07 17:37:00.327191	Watch
MBA (Master of Business Administration)	dsfsdf		2 Years	4234	sdfsdf	dsfsdf	dashboard.png	Full Time 	Feature	ugCourses	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	dsfsdf	{}	{<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	163	{}	2024-09-07 17:43:27.024303	Watch
MBA (Master of Business Administration)ferwe	rewr		5 Years	324234	rwerwe	rwerwer	as.png	Full Time 	Feature	ugCourses	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibilityr</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualificati324234234on</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	ewrwerwe	{}	{<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibilityr</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibilityr</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibilityr</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibilityr</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	169	{}	2024-09-07 17:50:53.751365	Watch
MBA (Master of Business Administration)7567	567567567		4 Years	7567567	7567567	567567	academic.png	Full Time 	Feature	executiveEducation	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility12</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	65756756	{}	{<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibility12</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility12</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility12</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility12</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	175	{}	2024-09-07 18:05:17.953928	Watch
ghfghgfh 0809890	ghgfhfgh 89789		2 Years	767567	jghjghj	hjghjghj	CTA.png	Full Time 	Feature	executiveEducation	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	hjghjgh	{}	{<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	180	{}	2024-09-07 18:13:55.913955	Watch
			0				\N	0			1	\N	Enter Content Here											\N		{}	{}	{}	{}	183	{}	2024-09-08 16:35:57.152037	Watch
MBA (Master of Business Administration)56345	345345345		2 Years	435345	34534	5345345	expert.png	Full Time 	Feature	executiveEducation	\N	\N	<h2>dfgdfgdfg<br></h2><p>Enter Content Here</p>									Active	TOC	\N	345345	{}	{<h2>dfgdfgdfg<br></h2>,<h2>dfgdfgdfg<br></h2>,<h2>dfgdfgdfg<br></h2>}	{}	{}	192	{}	2024-09-08 17:17:22.256106	Watch
MCA	gtdtc		2 Years	6566	ygdcresrsxdx	uhftdsxg	Vivekananda College.jpg	Full Time 	Feature	pgCourses	1	\N	<h2>hftdcsxdxsxcxgfxsrs</h2><p>hbhjv</p>									Active		\N	mca-	{}	{<h2>hftdcsxdxsxcxgfxsrs</h2>}	{}	{}	194	{}	2024-09-10 09:23:12.582572	Watch
MPT	MPT stands for Master of Physiotherapy. It is a postgraduate degree program designed to advance the knowledge and skills of physiotherapy professionals.		2 Years	5633	Master of Physiotherapy (MPT): Advance Your Physiotherapy Career	Enhance your physiotherapy expertise with an MPT. Explore specializations, career paths, top colleges, and how to excel in the field. Advance your career in healthcare.	\N	Full Time 	Feature	pgCourses	1	\N	<h2>Overview</h2><p>The Master&nbsp; of a Physiotherapy (MPT) is a postgraduate degree designed for individuals seeking advanced knowledge and skills in the field of physiotherapy. This program focuses on the assessment, diagnosis, and treatment of physical disabilities and conditions through various therapeutic techniques. The MPT program aims to prepare students to become expert physiotherapists who can work in diverse healthcare settings, conduct research, and contribute to the development of the physiotherapy profession.</p><p>The MPT program typically spans two years and includes both theoretical and practical components. Students engage in coursework covering advanced topics in physiotherapy, clinical practice, research methodology, and specialized areas of treatment.</p><h4>Eligibility</h4><p>To pursue an MPT, candidates generally need to meet the following eligibility criteria:</p><ol><li><p><strong>Educational Qualification</strong>: A Bachelor of Physiotherapy (BPT) degree from a recognized university or institution is required. Some programs may accept candidates with a related healthcare degree if they meet additional requirements.</p></li><li><p><strong>Minimum Marks</strong>: Most institutions require a minimum aggregate percentage in the undergraduate degree. This is typically around 50-60%, though it may vary by institution.</p></li><li><p><strong>Entrance Exams</strong>: Some universities and colleges require candidates to pass an entrance exam or qualify for a national-level test specific to physiotherapy.</p></li><li><p><strong>Other Requirements</strong>: In some cases, candidates might need to have relevant work experience or meet specific criteria set by individual institutions.</p></li></ol><h4>Fees</h4><p>The fees for an MPT program can vary widely depending on the institution and country. On average, the fee structure includes:</p><ol><li><p><strong>Tuition Fees</strong>: This can range from $3,000 to $15,000 per year. Prestigious institutions or private colleges may charge higher fees.</p></li><li><p><strong>Additional Costs</strong>: Students may also incur costs for textbooks, laboratory equipment, clinical placements, and other resources. These costs can vary based on the specialization and the requirements of the program.</p></li><li><p><strong>Scholarships and Financial Aid</strong>: Many institutions offer scholarships, grants, or financial aid options to help offset the costs of the program. Students should explore these opportunities to ease the financial burden.</p></li></ol><h4>Career Prospects</h4><p>Graduates with an MPT degree have a wide range of career opportunities available to them. Some of the potential career paths include:</p><ol><li><p><strong>Clinical Practice</strong>: Working as physiotherapists in hospitals, rehabilitation centers, private clinics, and sports facilities, treating patients with various physical conditions.</p></li><li><p><strong>Research and Development</strong>: Positions in research institutions or academia, focusing on physiotherapy research, clinical trials, and the development of new therapeutic techniques.</p></li><li><p><strong>Teaching and Academia</strong>: Careers in teaching at universities or colleges, contributing to the education of future physiotherapy professionals.</p></li><li><p><strong>Specialized Rehabilitation</strong>: Working in specialized areas such as pediatric physiotherapy, geriatric physiotherapy, orthopedic physiotherapy, and neurological physiotherapy.</p></li><li><p><strong>Sports Physiotherapy</strong>: Providing physiotherapy services to athletes and sports teams, focusing on injury prevention, rehabilitation, and performance enhancement.</p></li><li><p><strong>Consultancy</strong>: Offering consultancy services to healthcare organizations, corporate wellness programs, and fitness centers.</p></li><li><p><strong>Entrepreneurship</strong>: Opportunities to start their own physiotherapy clinics or rehabilitation centers.</p></li></ol><h4>Specializations</h4><p>The MPT program often offers various specializations, allowing students to focus on specific areas of interest within physiotherapy. Common specializations include:</p><ol><li><p><strong>Orthopedic Physiotherapy</strong>: Focus on the treatment of musculoskeletal conditions, including injuries, fractures, and post-surgical rehabilitation.</p></li><li><p><strong>Neurological Physiotherapy</strong>: Emphasis on the treatment of neurological disorders such as stroke, multiple sclerosis, and spinal cord injuries.</p></li><li><p><strong>Pediatric Physiotherapy</strong>: Specialization in the treatment of infants, children, and adolescents with physical disabilities or developmental conditions.</p></li><li><p><strong>Sports Physiotherapy</strong>: Concentration on the prevention and treatment of sports-related injuries and the enhancement of athletic performance.</p></li><li><p><strong>Cardiopulmonary Physiotherapy</strong>: Focus on the rehabilitation of patients with cardiac and respiratory conditions, including post-operative care and chronic disease management.</p></li><li><p><strong>Geriatric Physiotherapy</strong>: Specialization in the treatment and management of physical conditions affecting elderly patients, promoting mobility and quality of life.</p></li></ol><h4>Conclusions</h4><p>The Master of Physiotherapy (MPT) is a comprehensive program that equips students with advanced knowledge and skills in the field of physiotherapy. With a variety of specializations and a broad range of career opportunities, the MPT degree opens doors to numerous professional paths. Prospective students should carefully consider their interests, eligibility, and financial options when choosing a program that best aligns with their career goals.</p>									Active	TOC	\N	mpt-	{}	{<h2>Overview</h2>,<h2>Overview</h2>}	{}	{<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>,<h4>Eligibility</h4>,<h4>Fees</h4>,"<h4>Career Prospects</h4>",<h4>Specializations</h4>,<h4>Conclusions</h4>}	206	{}	2024-09-10 11:53:19.083943	Watch
MBA	Our MBA program is designed to develop well-rounded business leaders with a strong foundation in core management disciplines. The curriculum focuses on developing strategic thinking, analytical skills, and a global perspective. Through a blend of theoretical knowledge and practical application, students gain the expertise to excel in diverse business roles.	2	2 Years	65352	MBA Program: Gain Essential Business Skills for Success	Invest in your future with an MBA. Our program offers rigorous coursework, experienced faculty, and valuable networking opportunities. Become a confident and strategic business leader.	\N	Full Time 	Feature	pgCourses	1	\N	<h2 style="text-align: justify; line-height: 1.1;">Introduction</h2><p style="text-align: justify;">The Master of Business Administration (MBA) is a highly sought-after graduate degree that provides a comprehensive education in business management and administration. MBA programs are designed to equip students with leadership, strategic thinking, and managerial skills necessary to excel in various business environments. The program typically covers core business areas and offers specialized tracks to cater to specific career interests.</p><h3 style="text-align: justify;">Course Structure</h3><p style="text-align: justify;">An MBA program usually spans two years, divided into four semesters, though some programs offer accelerated one-year formats. The curriculum generally includes:</p><ul><li style="text-align: justify;"><strong>Core Modules</strong>: Subjects common to all MBA programs, such as Financial Accounting, Marketing Management, Organizational Behavior, Operations Management, Strategic Management, and Human Resource Management.</li><li style="text-align: justify;"><strong>Elective Specializations</strong>: Advanced courses in specific areas of interest, allowing students to tailor their education according to career goals.</li><li style="text-align: justify;"><strong>Capstone Projects and Internships</strong>: Practical experience through real-world projects and internships to apply theoretical knowledge.</li></ul><h3 style="text-align: justify;">Eligibility Criteria</h3><p style="text-align: justify;">To enroll in an MBA program, candidates typically need:</p><ul><li style="text-align: justify;"><strong>Educational Qualification</strong>: A bachelor’s degree from a recognized institution.</li><li style="text-align: justify;"><strong>Work Experience</strong>: Many programs prefer candidates with work experience, though this varies by program.</li><li style="text-align: justify;"><strong>Entrance Exams</strong>: Scores from standardized tests such as GMAT, GRE, or equivalent exams.</li><li style="text-align: justify;"><strong>Interview and Personal Statement</strong>: Some programs require interviews or personal statements.</li></ul><h3 style="text-align: justify;">Fee Structure</h3><p style="text-align: justify;">The fee for an MBA program varies widely depending on the institution and location. On average, the annual fee ranges from INR 2,00,000 to INR 30,00,000 in India and can be higher for international programs.</p><h3 style="text-align: justify;">Career Prospects</h3><p style="text-align: justify;">An MBA opens up diverse career opportunities across various sectors. Graduates can pursue roles in:</p><ul><li style="text-align: justify;"><strong>Management Consulting</strong>: Advising organizations on business strategies and operations.</li><li style="text-align: justify;"><strong>Finance</strong>: Positions in investment banking, financial planning, and analysis.</li><li style="text-align: justify;"><strong>Marketing</strong>: Roles in brand management, digital marketing, and market research.</li><li style="text-align: justify;"><strong>Operations</strong>: Careers in supply chain management, logistics, and operations management.</li><li style="text-align: justify;"><strong>Human Resources</strong>: Roles in talent management, organizational development, and HR strategy.</li><li style="text-align: justify;"><strong>Entrepreneurship</strong>: Starting and managing new business ventures.</li></ul><h3 style="text-align: justify;">Specializations</h3><p style="text-align: justify;">Now, let's dive into specific MBA specializations:</p><p style="text-align: justify;"><strong>1. MBA PGDM (Post Graduate Diploma in Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: An alternative to traditional MBA programs, offering similar management training but with a different certification.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores may be required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Similar to MBA graduates, including management roles, consulting, and entrepreneurship.</li></ul><p style="text-align: justify;">2. <strong>Executive MBA</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Designed for working professionals with significant work experience, focusing on advanced management and leadership skills.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Several years of work experience; often requires a bachelor’s degree.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Leadership roles, senior management, and executive positions.</li></ul><p style="text-align: justify;">3. <strong>MBA Dual Specialization</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Allows students to specialize in two areas of business, providing a broader skill set.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Versatile roles in management, consulting, and specialized business fields.</li></ul><p style="text-align: justify;">4. <strong>MBA IT (Information Technology)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on integrating IT with business management, covering topics like IT strategy, management, and systems.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree in any discipline; IT background may be preferred.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: IT management, systems analysis, and technology consulting.</li></ul><p style="text-align: justify;">5. <strong>MBA Safety Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in safety protocols, risk management, and compliance in various industries.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in safety or related fields can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Safety manager, risk consultant, and compliance officer.</li></ul><p style="text-align: justify;">6. <strong>MBA Finance</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on financial management, investment analysis, and corporate finance.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Financial analyst, investment banker, and finance manager.</li></ul><p style="text-align: justify;">7. <strong>MBA Operations</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes managing and optimizing business operations and supply chains.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Operations manager, supply chain analyst, and logistics coordinator.</li></ul><p style="text-align: justify;">8. <strong>MBA HRM (Human Resource Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing human resources, including recruitment, training, and organizational development.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: HR manager, recruitment consultant, and organizational development specialist.</li></ul><p style="text-align: justify;">9. <strong>MBA Event Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on planning, organizing, and managing events and conferences.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Event manager, conference organizer, and corporate event planner.</li></ul><p style="text-align: justify;">10. <strong>MBA Entrepreneurship</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Aims to develop skills for starting and managing new ventures.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrepreneurial background or interest is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Entrepreneur, startup manager, and business consultant.</li></ul><p style="text-align: justify;">11. <strong>MBA Airline and Airport Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in the management of airline operations and airport facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in aviation can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Airline manager, airport operations manager, and aviation consultant.</li></ul><p style="text-align: justify;">12. <strong>MBA IB (International Business)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on global business practices, international trade, and cross-cultural management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: International business manager, export manager, and global marketing consultant.</li></ul><p style="text-align: justify;">13. <strong>MBA Logistics</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Emphasizes supply chain management, logistics operations, and distribution strategies.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Logistics manager, supply chain analyst, and operations coordinator.</li></ul><p style="text-align: justify;">14. <strong>MBA Marketing</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on marketing strategies, consumer behavior, and brand management.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Marketing manager, brand strategist, and market researcher.</li></ul><p style="text-align: justify;">15. <strong>MBA Advertising and Sales Promotion</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in advertising strategies and sales promotion techniques.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Advertising manager, sales promotion specialist, and media planner.</li></ul><p style="text-align: justify;">16. <strong>MBA Digital Marketing</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on online marketing strategies, social media, and digital analytics.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Digital marketing manager, SEO specialist, and social media manager.</li></ul><p style="text-align: justify;">17. <strong>MBA Project Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing projects, including planning, execution, and evaluation.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Project manager, program manager, and project coordinator.</li></ul><p style="text-align: justify;">18. <strong>MBA Hospital Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing healthcare facilities and services.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Hospital administrator, healthcare manager, and medical services manager.</li></ul><p style="text-align: justify;">19. <strong>MBA Shipping and Port Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing shipping operations and port facilities.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in logistics or maritime studies is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Shipping manager, port operations manager, and maritime consultant.</li></ul><p style="text-align: justify;">20. <strong>MBA CRM (Customer Relationship Management)</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing customer relationships and enhancing customer satisfaction.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; entrance exam scores required.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: CRM manager, customer service director, and client relationship manager.</li></ul><p style="text-align: justify;">21. <strong>MBA Clinical Research</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in research methodologies and clinical trials in the healthcare sector.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in life sciences or healthcare is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Clinical research manager, research coordinator, and clinical trial analyst.</li></ul><p style="text-align: justify;">22. <strong>MBA Disaster Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing disaster response and recovery efforts.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in emergency management is advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Disaster response manager, emergency management specialist, and risk assessment analyst.</li></ul><p style="text-align: justify;">23. <strong>MBA Pharmaceutical Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Specializes in managing pharmaceutical operations and understanding drug regulations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in pharmacy or life sciences is beneficial.</li><li style="text-align: justify;"><strong>Career Prospects</strong>: Pharmaceutical manager, drug regulatory affairs specialist, and healthcare consultant.</li></ul><p style="text-align: justify;">24. <strong>MBA Technology Management</strong></p><ul><li style="text-align: justify;"><strong>Overview</strong>: Focuses on managing technology resources and innovation within organizations.</li><li style="text-align: justify;"><strong>Eligibility</strong>: Bachelor’s degree; background in technology or engineering can be advantageous.</li><li style="text-align: justify;"><strong>Career Prospects</strong>:</li></ul>									Active	TOC	\N	mba-(master-of-business-administration)-	{}	{"<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>","<h2 style=\\"text-align: justify; line-height: 1.1;\\">Introduction</h2>"}	{"<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>","<h3 style=\\"text-align: justify;\\">Course Structure</h3>","<h3 style=\\"text-align: justify;\\">Eligibility Criteria</h3>","<h3 style=\\"text-align: justify;\\">Fee Structure</h3>","<h3 style=\\"text-align: justify;\\">Career Prospects</h3>","<h3 style=\\"text-align: justify;\\">Specializations</h3>"}	{}	204	{}	2024-09-10 10:08:47.196532	Watch
\.


--
-- TOC entry 4178 (class 0 OID 18626)
-- Dependencies: 357
-- Data for Name: previewblog; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.previewblog (id, pagename, seotitle, seodescription, tag, status, topic, image, content, added_date, added_by, last_modified, feature, toc, active, urlname, toch1, toch2, toch3, toch4, toch5, layout) FROM stdin;
25	The NEET 2024 Exam: A Scandal of Fraud and Scam123123sdnbnf	sdfsdf	sdfsdf	\N		sdfsdf	24-hours.png	<p>Enter Content Heresdfsdfdfgdf</p>	2024-09-10 16:47:58.328546	1	\N	Feature	TOC	Active	sdfsdfsdfvbnvbndfgdfg	{}	{}	{}	{}	{}	Right
31	hjbgu	cgfdfdc	ygyfygfu	\N				<p>aszdfghjkl;'</p><p>sdvgjb/\\</p><p>dxchvj'./</p><p>\\ewadxfcvghbnj\\'</p><p>fcc ghjkl'</p><p>76ygbbnhhggknihyhnjihiv</p><p>vtcjvu</p>	2024-09-13 12:06:53.553	2	\N	Feature		Active	hjbgu-	{}	{}	{}	{}	{}	Left
32	hjbgu	cgfdfdc	ygyfygfu	\N				<p>aszdfghjkl;'</p><p>sdvgjb/\\</p><p>dxchvj'./</p><p>\\ewadxfcvghbnj\\'</p><p>fcc ghjkl'</p><p>76ygbbnhhggknihyhnjihiv</p><p>vtcjvu</p>	2024-09-13 12:07:58.121717	2	\N	Feature		Active	hjbgu-	{}	{}	{}	{}	{}	Left
33	hjbgu	cgfdfdc	ygyfygfu	\N				<p>aszdfghjkl;'</p><p>sdvgjb/\\</p><p>dxchvj'./</p><p>\\ewadxfcvghbnj\\'</p><p>fcc ghjkl'</p><p>76ygbbnhhggknihyhnjihiv</p><p>vtcjvu</p>	2024-09-13 12:09:36.288867	2	\N	Feature		Active	hjbgu-	{}	{}	{}	{}	{}	Left
34	hjbgu	cgfdfdc	ygyfygfu	\N				<p>aszdfghjkl;'</p><p>sdvgjb/\\</p><p>dxchvj'./</p><p>\\ewadxfcvghbnj\\'</p><p>fcc ghjkl'</p><p>76ygbbnhhggknihyhnjihiv</p><p>vtcjvu</p>	2024-09-13 12:11:52.314239	2	\N	Feature		Active	hjbgu-	{}	{}	{}	{}	{}	Left
35	hvhgcg	hgfg		\N				Enter Content Here	2024-09-13 12:12:18.697685	2	\N				hvhgcg	{}	{}	{}	{}	{}	
36	hvhgcg	hgfg		\N				<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:13:15.284943	2	\N					{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	
37	hvhgcg	hgfg		\N				<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:13:17.114139	2	\N					{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	
39	NIT Delhi Cutoff 2024: Check JEE Main Round Wise Cutoff Ranks	A	dgdsvdas	\N			Apply Now (12).jpg	<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:13:53.960804	2	\N	Feature	TOC	Active	nit-delhi-cutoff-2024-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	Left
40	NIT Delhi Cutoff 2024: Check JEE Main Round Wise Cutoff Ranks	A	dgdsvdas	\N			Apply Now (12).jpg	<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:16:26.001308	2	\N	Feature	TOC	Active	nit-delhi-cutoff-2024-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	Left
41	NIT Delhi Cutoff 2024: Check JEE Main Round Wise Cutoff Ranks	A	dgdsvdas	\N			Apply Now (12).jpg	<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:17:25.606557	2	\N	Feature	TOC	Active	nit-delhi-cutoff-2024-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	Left
42	NIT Delhi Cutoff 2024: Check JEE Main Round Wise Cutoff Ranks	A	dgdsvdas	\N			Apply Now (12).jpg	<p style="text-align: justify;">National Institute of Technology (NIT) Delhi is one of India’s premier engineering institutes, known for its academic excellence and research-oriented environment. Every year, thousands of students aspire to secure admission at NIT Delhi through the JEE Main exam. The <strong>NIT Delhi Cutoff 2024</strong> will determine the minimum rank and marks required for admission to various B.Tech programs at the institute. The cutoff is released after each round of the <a href="https://josaa.nic.in/">Joint Seat Allocation Authority</a> (JoSAA) counseling and is based on several factors like seat availability, category, and the number of applicants.</p><h2 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2><p style="text-align: justify;">The <strong>NIT Delhi Cutoff for 2024</strong> is expected to be released soon after the <a href="https://jeemain.nta.ac.in/">JEE Main</a> 2024 results are declared. The cutoff will vary for different categories such as General, OBC, SC, ST, and EWS. It will also differ for each B.Tech specialization offered at the institute. Students should keep a regular check on the official JoSAA website and NIT Delhi’s official website for updates on counseling rounds and cutoff ranks.</p><p style="text-align: center;"><img class="aligncenter size-full wp-image-2016" src="https://college.imts.ac.in/wp-content/uploads/2024/09/Apply-Now-12.jpg" alt="" width="600" height="350"></p><h3 style="text-align: justify;"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3><table><thead><tr><th>Feature</th><th>Details</th></tr></thead><tbody><tr><td><strong>Institute Name</strong></td><td>NIT Delhi</td></tr><tr><td><strong>Admission Test</strong></td><td>JEE Main</td></tr><tr><td><strong>Programs Offered</strong></td><td>B.Tech in CSE, ECE, EEE</td></tr><tr><td><strong>Cutoff Release Date</strong></td><td>After JEE Main 2024 Results</td></tr><tr><td><strong>Mode of Cutoff Release</strong></td><td>Online</td></tr><tr><td><strong>Official Website</strong></td><td><a href="http://www.nitdelhi.ac.in" target="_new" rel="noopener">www.nitdelhi.ac.in</a></td></tr></tbody></table><p style="text-align: justify;"><strong>Expected Cutoff for NIT Delhi B.Tech Admission 2024</strong></p><p style="text-align: justify;">The cutoff for admission to NIT Delhi varies each year depending on several factors. Below are the expected cutoff ranges for various B.Tech programs in 2024 based on previous years' trends:</p><table><thead><tr><th><strong>Branch</strong></th><th><strong>Expected Closing Rank (General)</strong></th></tr></thead><tbody><tr><td><strong>Computer Science and Engineering (CSE)</strong></td><td>5000 - 7000</td></tr><tr><td><strong>Electronics and Communication Engineering (ECE)</strong></td><td>9000 - 13000</td></tr><tr><td><strong>Electrical and Electronics Engineering (EEE)</strong></td><td>12000 - 17000</td></tr></tbody></table><h3 style="text-align: justify;"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3><p style="text-align: justify;">The cutoff for NIT Delhi is influenced by several factors, including:</p><ol style="text-align: justify;"><li><strong>Number of Applicants:</strong> A higher number of applicants can lead to a higher cutoff.</li><li><strong>Seat Availability:</strong> The number of seats available for each course plays a significant role in determining the cutoff.</li><li><strong>Difficulty Level of JEE Main Exam:</strong> If the exam is tougher, the cutoff may be lower, and vice versa.</li><li><strong>Category of the Candidate:</strong> Different categories such as General, OBC, SC, ST, and EWS have different cutoffs.</li></ol><p style="text-align: justify;"><strong>Admission Process: How to Apply</strong></p><p style="text-align: justify;">Admission to NIT Delhi is conducted through the JoSAA counseling process. Follow these steps to apply:</p><ol style="text-align: justify;"><li><strong>Appear for JEE Main:</strong><br>Candidates must appear for the JEE Main exam and secure a valid score to be eligible for NIT Delhi.</li><li><strong>Register for JoSAA Counseling:</strong><br>After the declaration of JEE Main results, register for the JoSAA counseling process.</li><li><strong>Select NIT Delhi:</strong><br>During counseling, choose NIT Delhi and the desired B.Tech specialization as your preferred option.</li><li><strong>Check the Cutoff and Rank:</strong><br>Based on your JEE Main rank and category, check if you meet the required cutoff for your preferred course.</li><li><strong>Seat Allotment and Admission:</strong><br>If you meet the cutoff, you will be allotted a seat in one of the rounds of counseling. Complete the admission formalities by paying the required fees and submitting documents.</li></ol><p style="text-align: justify;"><strong>Documents Required for Admission</strong></p><ul style="text-align: justify;"><li>JEE Main Rank Card</li><li>Class 10th and 12th Mark Sheets</li><li>Proof of Identity (Aadhaar Card, Passport)</li><li>Category Certificate (if applicable)</li><li>Passport-sized Photographs</li><li>Seat Allotment Letter from JoSAA</li><li>Payment Receipt of Counseling Fees</li></ul><p style="text-align: justify;"><strong>FAQs</strong></p><ol><li style="text-align: justify;"><strong>When will the NIT Delhi Cutoff 2024 be released?</strong><ul><li>The cutoff will be released after the JEE Main 2024 results, during the JoSAA counseling process.</li></ul></li><li style="text-align: justify;"><strong>How can I check the NIT Delhi cutoff?</strong><ul><li>The cutoff will be available on the official JoSAA website and NIT Delhi’s official portal.</li></ul></li><li style="text-align: justify;"><strong>What factors influence the cutoff for NIT Delhi?</strong><ul><li>The cutoff is influenced by factors such as the number of applicants, seat availability, exam difficulty, and category of the candidate.</li></ul></li><li style="text-align: justify;"><strong>What is the expected closing rank for CSE at NIT Delhi in 2024?</strong><ul><li>The expected closing rank for Computer Science and Engineering (CSE) is between 5000 and 7000 (General category).</li></ul></li><li><p style="text-align: justify;"><strong>Is there a separate cutoff for different categories?</strong></p><ul><li style="text-align: justify;">Yes, NIT Delhi has separate cutoffs for categories like General, OBC, SC, ST, and EWS.</li></ul></li></ol>	2024-09-13 12:18:30.154879	2	\N	Feature	TOC	Active	nit-delhi-cutoff-2024-	{}	{"<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>","<h2 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 Latest Update</strong></h2>"}	{"<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>NIT Delhi Cutoff 2024 </strong><strong>Highlight Table</strong></h3>","<h3 style=\\"text-align: justify;\\"><strong>Factors Determining NIT Delhi Cutoff 2024</strong></h3>"}	{}	{}	Left
48	Test by Kishor	Test by Kishor	test	\N		Test by Kishor 5	Stand-Up India Scheme.webp	<p>Test by Kishor&nbsp;Test by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by Kishor\\</p><p><br></p><h2>Test by Kishor</h2><p><br></p><p>Test by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by KishorTest by Kishor</p><p><br></p><h3>Test by Kishor</h3><p><br></p><p>xttruyguyf7fyy yvffffffffTest by Kishorygiuhi&nbsp;Test by KishorTest by Kishorv</p>	2024-09-24 09:15:13.304493	1	\N			Active	yyyyu-uiib-uyyyy-k	{}	{"<h2>Test by Kishor</h2>","<h2>Test by Kishor</h2>"}	{"<h3>Test by Kishor</h3>","<h3>Test by Kishor</h3>"}	{}	{}	
50	Test 2	123456789	2345678	\N		topic	kcc.webp	<h2>ttrxgvh</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	2024-09-24 09:25:31.856228	3	\N			Active	test	{}	{<h2>ttrxgvh</h2>,<h2>sedrfghjk</h2>,<h2>ttrxgvh</h2>,<h2>sedrfghjk</h2>}	{}	{}	{}	
52	Test 2	123456789	2345678	\N		topic	kcc.webp	<h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	2024-09-24 09:26:28.054046	3	\N			Active	test	{}	{"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>}	{}	{}	{}	
54	Test 2	123456789	2345678	\N		topic	kcc.webp	<p>tyyuukkkkkkkkkkkkk</p><h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	2024-09-24 09:27:30.635686	3	\N			Active	test	{}	{"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>}	{}	{}	{}	
55	Test 2	123456789	2345678	\N		topic	kcc.webp	<p>tyyuukkkkkkkkkkkkk</p><h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	2024-09-24 09:28:37.930176	3	\N			Active	test	{}	{"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>}	{}	{}	{}	
56	Test 2	123456789	2345678	\N		topic	kcc.webp	<p>tyyuukkkkkkkkkkkkk</p><h2>Heading Test</h2><p><br></p><p>hgygyuyuu</p><p>uiggug</p><p><br></p><p><br></p><p><br></p><p><br></p><p>hyyyuyu</p><p>jhhhhjj</p><p><br></p><p><br></p><h2>sedrfghjk</h2>	2024-09-24 09:35:30.855437	3	\N			Active	test	{}	{"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>,"<h2>Heading Test</h2>",<h2>sedrfghjk</h2>}	{}	{}	{}	
57				\N				Enter Content Here	2024-09-24 09:39:37.398918	1	\N					{}	{}	{}	{}	{}	Left
58				\N				Enter Content Here	2024-09-24 12:12:04.485549	\N	\N					{}	{}	{}	{}	{}	Left
59				\N				Enter Content Here	2024-09-24 12:12:08.059655	\N	\N					{}	{}	{}	{}	{}	
\.


--
-- TOC entry 4177 (class 0 OID 18615)
-- Dependencies: 356
-- Data for Name: previewuniversity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.previewuniversity (id, uname, established, officemailid, approvedby, coursetype, stream, studymode, universitytype, websiteurl, state, city, logourl, imageurl, videourl, fblink, twitterlink, linkedin, instagram, toc, smode, feature, added_date, last_modified, nip, about, fact, emi, admission, active, urlname, seotitle, seodescription, toccontent, toch1, toch2, toch3, toch4, toch5, prospectus, last_modified_by, added_by, zone) FROM stdin;
46	Ibrahim Memon1	1999	AKTU123@gmail.com	1	1	1	1	1	F-10 4th Floor Haji Shah Center Bori Bazar Saddar Hyderabad	1	1	aabb.PNG	{"null"}	{}	dfsdf	dsfsdf	dfgdfg	fsdfsdf	TOC		Feature	2024-09-10 14:52:01.045619	2024-09-10 14:52:01.044	5	<p>jkhkfsdfsdfsdf</p>				Active	34234-423	hfgh	gjghgjkh	\N	{}	{}	{}	{}	{}	\N	\N	1	\N
54	Chandigarh university	1999	anurag.k@imtsinsitute.com	1	1	1	1	1	dasdasd	1	1	favicon.ico	{1679235462260.jpeg}	{}	thisis_anurag_	dasd	asdasd	asdas	false		false	2024-09-26 11:38:38.170076	\N	sdasd	<p>asdasd</p>				false				{1,2}	{}	{}	{}	{}	{}		\N	1	\N
\.


--
-- TOC entry 4182 (class 0 OID 23333)
-- Dependencies: 361
-- Data for Name: prevuserlogs; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.prevuserlogs (id, username, added_date, status) FROM stdin;
22	1	2024-10-07 18:24:41.245671	Logout
23	1	2024-10-08 11:05:04.031371	Logout
24	1	2024-10-08 19:02:34.356753	Logout
25	1	2024-10-09 20:32:10.336409	Logout
26	1	2024-10-10 09:46:51.369903	Logout
27	1	2024-10-10 09:49:40.348668	Logout
28	1	2024-10-10 11:12:32.213326	Logout
29	1	2024-10-10 11:12:44.5701	Logout
30	1	2024-10-11 09:16:44.68446	Logout
31	1	2024-10-11 09:39:12.808825	Logout
32	1	2024-10-11 11:25:41.096668	Online
\.


--
-- TOC entry 4133 (class 0 OID 16998)
-- Dependencies: 312
-- Data for Name: qualification; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.qualification (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Undergraduate	Active	1	2024-08-09 06:47:17.968027	\N	\N
2	Postgraduate	Active	1	2024-08-09 06:47:42.122526	\N	\N
\.


--
-- TOC entry 4072 (class 0 OID 16608)
-- Dependencies: 251
-- Data for Name: specialization; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.specialization (id, universityid, courseid, specialization, specializationcode, added_date, added_by, last_modified) FROM stdin;
6	\N	15	Human Resources	5	2024-08-08 10:01:33.075147	1	\N
7	\N	15	Operations management	5	2024-08-08 10:01:43.41694	1	\N
8	\N	15	Finance	6	2024-08-08 10:01:54.241601	1	\N
9	\N	15	Supply chain management	7	2024-08-08 10:02:07.570456	1	\N
10	\N	15	Strategic management	7	2024-08-08 10:02:16.152132	1	\N
11	\N	15	Asset management	7	2024-08-08 10:02:25.964533	1	\N
12	\N	15	Finance Analyst	7	2024-08-08 10:02:53.741702	1	\N
13	\N	15	Hospitality Management	7	2024-08-08 10:03:03.846808	1	\N
14	\N	13	Marketing	6	2024-08-08 10:04:59.169334	1	\N
15	\N	13	Business Analytics.	7	2024-08-08 10:05:09.091675	1	\N
16	\N	13	Information Technology	7	2024-08-08 10:05:18.187105	1	\N
18	\N	13	Textile Management	8	2024-08-08 10:05:52.000974	1	\N
19	\N	13	Energy Management	8	2024-08-08 10:05:59.372016	1	\N
20	\N	13	Tourism management	8	2024-08-08 10:06:16.229231	1	\N
21	\N	13	International business	9	2024-08-08 10:06:32.130745	1	\N
22	\N	24	Cybersecurity	01	2024-08-08 10:30:05.70791	\N	\N
23	\N	24	Artificial Intelligence (AI) and Machine Learning (ML)	01	2024-08-08 10:30:14.308567	\N	\N
24	\N	24	Data Science	01	2024-08-08 10:30:22.833472	\N	\N
25	\N	24	 Web Technology	01	2024-08-08 10:30:31.405101	\N	\N
26	\N	24	Mobile Application development	01	2024-08-08 10:30:40.964731	\N	\N
27	\N	24	Software development	01	2024-08-08 10:30:52.743984	\N	\N
28	\N	24	Data Analytics	01	2024-08-08 10:31:42.494483	\N	\N
29	\N	24	System Management 	01	2024-08-08 10:31:58.154372	\N	\N
30	\N	25	English	66	2024-08-08 10:37:36.465206	1	\N
31	\N	25	Sociology	66	2024-08-08 10:37:48.868453	1	\N
32	\N	25	Journalism and Mass Communication	60	2024-08-08 10:38:09.833125	1	\N
33	\N	25	Philosophy	60	2024-08-08 10:38:21.020769	1	\N
34	\N	25	Psychology	60	2024-08-08 10:38:56.987554	1	\N
35	\N	25	History	60	2024-08-08 10:39:06.601702	1	\N
36	\N	25	Political Science	61	2024-08-08 10:39:19.57485	1	\N
37	\N	25	Education/Physical Education	61	2024-08-08 10:39:29.667135	1	\N
38	\N	26	Physics	6	2024-08-08 10:51:33.582068	1	\N
39	\N	26	Chemistry	6	2024-08-08 10:51:43.787937	1	\N
40	\N	26	Biology	6	2024-08-08 10:51:52.840445	1	\N
41	\N	26	Mathematics	6	2024-08-08 10:52:04.057318	1	\N
42	\N	26	 IT (Information Technology)	6	2024-08-08 10:52:12.298165	1	\N
43	\N	26	Computer Science	7	2024-08-08 10:52:23.63235	1	\N
44	\N	26	Microbiology	7	2024-08-08 10:52:33.311647	1	\N
45	\N	26	 Biotechnology	7	2024-08-08 10:53:14.572984	1	\N
46	\N	32	Orthopedics	1	2024-08-08 12:03:04.951113	1	\N
47	\N	32	Neurology	2	2024-08-08 12:03:15.787468	1	\N
48	\N	32	Cardiopulmonary	2	2024-08-08 12:03:28.694133	1	\N
49	\N	32	Sports	2	2024-08-08 12:03:35.174589	1	\N
50	\N	31	Psychology	2	2024-08-08 12:03:48.874117	1	\N
51	\N	31	English Literature	2	2024-08-08 12:03:55.818451	1	\N
52	\N	31	History	2	2024-08-08 12:04:11.347018	1	\N
53	\N	31	Sociology	2	2024-08-08 12:04:18.868868	1	\N
54	\N	28	Curriculum Development	2	2024-08-08 12:04:31.132907	1	\N
55	\N	28	Educational Technology	2	2024-08-08 12:04:38.345264	1	\N
56	\N	28	Special Education	2	2024-08-08 12:04:44.410193	1	\N
57	\N	27	Accounting	2	2024-08-08 12:04:55.832719	1	\N
58	\N	27	Finance	2	2024-08-08 12:05:04.973298	1	\N
59	\N	27	Taxation	2	2024-08-08 12:05:12.328401	1	\N
60	\N	27	Business Studies	2	2024-08-08 12:05:19.654955	1	\N
64	\N	29	Pharmaceutics	2	2024-08-08 12:06:18.485878	1	\N
65	\N	29	Pharmacology	2	2024-08-08 12:06:21.680694	1	\N
66	\N	29	Pharmaceutical Chemistry	2	2024-08-08 12:06:28.678042	1	\N
67	\N	35	English	6	2024-08-13 07:51:37.496655	1	\N
68	\N	35	History	6	2024-08-13 07:51:47.394645	1	\N
69	\N	35	Political Science	6	2024-08-13 07:52:01.213776	1	\N
70	\N	35	Sociology	6	2024-08-13 07:52:12.571754	1	\N
71	\N	35	Economics	6	2024-08-13 07:52:21.090603	1	\N
76	\N	37	Print Journalism	9	2024-08-13 07:53:37.365149	1	\N
77	\N	37	Electronic Media	9	2024-08-13 07:53:52.636328	1	\N
78	\N	37	Public Relations	9	2024-08-13 07:54:03.417095	1	\N
79	\N	37	 Advertising	9	2024-08-13 07:54:14.017271	1	\N
5	\N	13	HUMAN RESOURCE MANAGEMENT	12345	2024-08-03 15:55:49.289203	1	2024-08-13 12:47:28
80	\N	46	Software Development	3	2024-08-20 09:58:51.458877	1	\N
81	\N	46	Web Development	3	2024-08-20 09:59:13.792997	1	\N
82	\N	46	Data Analytics	3	2024-08-20 09:59:20.898374	1	\N
83	\N	44	Special Education	4	2024-08-20 09:59:35.550505	1	\N
84	\N	44	Elementary Education	4	2024-08-20 09:59:42.267004	1	\N
85	\N	44	Educational Technology	4	2024-08-20 09:59:49.124354	1	\N
86	\N	47	Orthopedic Physiotherapy	5	2024-08-20 10:00:10.162206	1	\N
87	\N	47	Neurological Physiotherapy	5	2024-08-20 10:00:17.083659	1	\N
88	\N	47	Sports Physiotherapy	5	2024-08-20 10:00:23.95976	1	\N
89	\N	45	Human Resource Management	6	2024-08-20 10:00:45.412393	1	\N
90	\N	45	International Business	6	2024-08-20 10:00:52.991971	1	\N
91	\N	45	Entrepreneurship	6	2024-08-20 10:00:59.371651	1	\N
92	\N	43	Computer Science	6	2024-08-20 10:01:18.065133	1	\N
93	\N	43	Civil Engineering	7	2024-08-20 10:01:27.401357	1	\N
94	\N	43	 Electronics Engineering	7	2024-08-20 10:03:15.670775	1	\N
95	\N	43	Agricultural Engineering	7	2024-08-20 10:03:29.367811	1	\N
96	\N	43	Petroleum Engineering	7	2024-08-20 10:03:39.965274	1	\N
97	\N	43	Biomedical Engineering	7	2024-08-20 10:03:48.496058	1	\N
98	\N	34	Accounting	8	2024-08-20 10:04:31.552526	1	\N
99	\N	34	Finance	8	2024-08-20 10:04:37.272852	1	\N
100	\N	34	Marketing	8	2024-08-20 10:04:44.977177	1	\N
101	\N	34	Business Administration	8	2024-08-20 10:04:51.908771	1	\N
102	\N	48	 Industrial Design	9	2024-08-20 10:11:47.243905	1	\N
103	\N	48	 Animation and Multimedia	9	2024-08-20 10:11:56.666267	1	\N
104	\N	48	Communication design	9	2024-08-20 10:12:29.310819	1	\N
105	\N	48	Interior design	9	2024-08-20 10:12:37.75827	1	\N
106	\N	48	UI/UX	9	2024-08-20 10:12:50.492292	1	\N
107	\N	49	Hospitality and Tourism Management	12	2024-08-20 10:32:12.963225	1	\N
108	\N	49	Bachelor of Tourism and Travel Management	12	2024-08-20 10:32:20.996023	1	\N
109	\N	49	Food & Beverage Service	12	2024-08-20 10:33:01.016094	1	\N
110	\N	50	 Physics	14	2024-08-20 10:37:23.918753	1	\N
111	\N	50	 Chemistry	14	2024-08-20 10:37:34.409675	1	\N
112	\N	50	Biology	14	2024-08-20 10:37:42.237608	1	\N
113	\N	50	Mathematics	14	2024-08-20 10:38:21.110838	1	\N
114	\N	32	Dance	56	2024-08-20 12:59:26.018122	1	\N
115	\N	32	Music	56	2024-08-20 12:59:33.091777	1	\N
116	\N	51	Hospitality and Tourism Management	67	2024-08-20 13:03:10.123594	1	\N
117	\N	51	Food and Beverage Management	67	2024-08-20 13:03:16.572802	1	\N
118	\N	51	Hotel Operations	67	2024-08-20 13:03:24.167663	1	\N
119	\N	52	HEPS	45	2024-08-21 06:12:56.52661	1	\N
120	\N	52	ART PAINTING	45	2024-08-21 06:13:11.317489	1	\N
121	\N	53	LIBRARY SCIENCE	65	2024-08-21 06:20:12.670122	1	\N
122	\N	26	BIOCHEMISTRY	34	2024-08-21 06:24:06.707364	1	\N
123	\N	26	BOTANY	34	2024-08-21 06:24:36.477095	1	\N
124	\N	26	ENVIRONMENTAL SCIENCE	34	2024-08-21 06:24:51.765346	1	\N
125	\N	26	MICROBIOLOGY	34	2024-08-21 06:25:11.073367	1	\N
126	\N	26	Hotel MANAGEMENT	36	2024-08-21 06:26:09.94731	1	\N
127	\N	26	Fire & SAFETYMANAGEMENT	36	2024-08-21 06:26:26.546498	1	\N
128	\N	26	GRAPHICS & ANIMATION	37	2024-08-21 06:27:01.385464	1	\N
129	\N	26	AGRICULTURE	37	2024-08-21 06:27:11.706162	1	\N
130	\N	43	ELECTRICAL & ELECTRONICS	37	2024-08-21 06:27:57.536483	1	\N
131	\N	43	INSTRUMENTATION AND CONTROL	37	2024-08-21 06:28:09.377808	1	\N
132	\N	43	PETROCHEMICAL	37	2024-08-21 06:28:22.366386	1	\N
133	\N	43	AGRICULTURE	37	2024-08-21 06:28:38.045648	1	\N
134	\N	43	AUTOMOBILE ENGINEERING	37	2024-08-21 06:29:13.098255	1	\N
135	\N	43	INSTRUMENTATION AND CONTROL	37	2024-08-21 06:30:02.007929	1	\N
136	\N	45	BUSINESS ADMINISTRATION	37	2024-08-21 06:31:02.236402	1	\N
137	\N	45	HOSPITALITY AND TOURISM	38	2024-08-21 06:31:38.000079	1	\N
138	\N	54	REGULAR	88	2024-08-21 06:38:34.989211	1	\N
139	\N	56	MARKETING MANAGEMENT	54	2024-08-23 10:30:24.804939	1	\N
140	\N	56	H.R.M	54	2024-08-23 10:30:32.869143	1	\N
141	\N	56	FINANCE	54	2024-08-23 10:30:44.800322	1	\N
142	\N	60	LIBRARY SCIENCE	54	2024-08-23 10:31:09.456313	1	\N
143	\N	55	CIVIL ENGINEERING	54	2024-08-23 10:34:41.620216	1	\N
144	\N	55	CHEMICAL ENGINEERING	54	2024-08-23 10:34:53.379741	1	\N
145	\N	55	ELECTRICAL ENGINEERING	54	2024-08-23 10:35:02.377927	1	\N
146	\N	55	MECHANICAL ENGINEERING	54	2024-08-23 10:35:12.528425	1	\N
147	\N	55	INSTRUMENTATION AND CONTROL	54	2024-08-23 10:35:20.99217	1	\N
148	\N	55	PETROCHEMICAL	54	2024-08-23 10:35:36.826179	1	\N
149	\N	55	AUTOMOBILE ENGINEERING	54	2024-08-23 10:35:47.461655	1	\N
150	\N	55	COMPUTER SCIENCE	54	2024-08-23 10:35:57.567614	1	\N
151	\N	55	ELECTRONICS & COMMUNICATION	54	2024-08-23 10:36:10.371082	1	\N
152	\N	55	INFORMATION TECHNOLOGY	54	2024-08-23 10:36:25.590193	1	\N
153	\N	61	HOTEL MANAGEMENT	54	2024-08-23 10:36:50.88297	1	\N
154	\N	62	INTERIOR DESIGNER	54	2024-08-23 10:37:03.728117	1	\N
155	\N	64	RETAIL MANAGEMENT	54	2024-08-23 10:37:32.312248	1	\N
156	\N	65	GENERAL	54	2024-08-23 10:37:45.980583	1	\N
157	\N	57	PAINTING	54	2024-08-23 10:40:38.459449	1	\N
158	\N	66	SOCIAL WORK	54	2024-08-23 10:41:03.387594	1	\N
159	\N	59	PHD	54	2024-08-23 10:41:33.689445	1	\N
160	\N	63	LIBRARY SCIENCE		2024-08-23 11:18:12.331981	1	\N
161	\N	59	D.B.A	60	2024-09-22 16:13:27.523669	\N	2024-09-24 12:06:54
\.


--
-- TOC entry 4135 (class 0 OID 17008)
-- Dependencies: 314
-- Data for Name: specializationactivity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.specializationactivity (id, superuserid, content, spid, role, added_date) FROM stdin;
1	1	{}	2	Delete	2024-07-26 06:03:01.151361
2	1	{}	2	Delete	2024-07-26 06:03:08.521373
3	1	{}	2	Delete	2024-07-26 06:03:21.21335
4	1	{}	2	Delete	2024-07-26 06:03:47.242055
5	1	{}	1	Add	2024-07-26 06:07:20.442171
6	1	{}	1	Delete	2024-07-26 11:14:42.823625
7	\N	{}	2	Add	2024-08-03 14:55:53.40213
8	1	{}	2	Delete	2024-08-03 14:56:38.866087
9	1	{}	3	Add	2024-08-03 14:56:58.47403
10	1	{}	3	Delete	2024-08-03 15:37:13.026473
11	1	{}	4	Add	2024-08-03 15:40:41.353215
12	1	{}	5	Add	2024-08-03 15:55:49.291821
13	1	{}	6	Add	2024-08-08 10:01:33.086654
14	1	{}	7	Add	2024-08-08 10:01:43.423791
15	1	{}	8	Add	2024-08-08 10:01:54.249603
16	1	{}	9	Add	2024-08-08 10:02:07.577208
17	1	{}	10	Add	2024-08-08 10:02:16.160723
18	1	{}	11	Add	2024-08-08 10:02:25.969968
19	1	{}	12	Add	2024-08-08 10:02:53.74626
20	1	{}	13	Add	2024-08-08 10:03:03.854871
21	1	{}	14	Add	2024-08-08 10:04:59.176477
22	1	{}	15	Add	2024-08-08 10:05:09.117132
23	1	{}	16	Add	2024-08-08 10:05:18.191463
24	1	{}	17	Add	2024-08-08 10:05:32.581472
25	1	{}	18	Add	2024-08-08 10:05:52.007384
26	1	{}	19	Add	2024-08-08 10:05:59.377044
27	1	{}	20	Add	2024-08-08 10:06:16.237247
28	1	{}	21	Add	2024-08-08 10:06:32.138435
29	1	{}	17	Delete	2024-08-08 10:07:33.224587
30	\N	{}	22	Add	2024-08-08 10:30:05.72565
31	\N	{}	23	Add	2024-08-08 10:30:14.360415
32	\N	{}	24	Add	2024-08-08 10:30:22.83697
33	\N	{}	25	Add	2024-08-08 10:30:31.408105
34	\N	{}	26	Add	2024-08-08 10:30:40.969314
35	\N	{}	27	Add	2024-08-08 10:30:52.753321
36	\N	{}	28	Add	2024-08-08 10:31:42.501352
37	\N	{}	29	Add	2024-08-08 10:31:58.161842
38	1	{}	30	Add	2024-08-08 10:37:36.47264
39	1	{}	31	Add	2024-08-08 10:37:48.877041
40	1	{}	32	Add	2024-08-08 10:38:09.842486
41	1	{}	33	Add	2024-08-08 10:38:21.026629
42	1	{}	34	Add	2024-08-08 10:38:56.994554
43	1	{}	35	Add	2024-08-08 10:39:06.626711
44	1	{}	36	Add	2024-08-08 10:39:19.580994
45	1	{}	37	Add	2024-08-08 10:39:29.6741
46	1	{}	38	Add	2024-08-08 10:51:33.593473
47	1	{}	39	Add	2024-08-08 10:51:43.800071
48	1	{}	40	Add	2024-08-08 10:51:52.845119
49	1	{}	41	Add	2024-08-08 10:52:04.064677
50	1	{}	42	Add	2024-08-08 10:52:12.301619
51	1	{}	43	Add	2024-08-08 10:52:23.640408
52	1	{}	44	Add	2024-08-08 10:52:33.315812
53	1	{}	45	Add	2024-08-08 10:53:14.582848
54	1	{}	46	Add	2024-08-08 12:03:04.963011
55	1	{}	47	Add	2024-08-08 12:03:15.794364
56	1	{}	48	Add	2024-08-08 12:03:28.701429
57	1	{}	49	Add	2024-08-08 12:03:35.177863
58	1	{}	50	Add	2024-08-08 12:03:48.884394
59	1	{}	51	Add	2024-08-08 12:03:55.82203
60	1	{}	52	Add	2024-08-08 12:04:11.353486
61	1	{}	53	Add	2024-08-08 12:04:18.874031
62	1	{}	54	Add	2024-08-08 12:04:31.141651
63	1	{}	55	Add	2024-08-08 12:04:38.350634
64	1	{}	56	Add	2024-08-08 12:04:44.413311
65	1	{}	57	Add	2024-08-08 12:04:55.838045
66	1	{}	58	Add	2024-08-08 12:05:04.976959
67	1	{}	59	Add	2024-08-08 12:05:12.337434
68	1	{}	60	Add	2024-08-08 12:05:19.693252
69	1	{}	61	Add	2024-08-08 12:05:38.125897
70	1	{}	62	Add	2024-08-08 12:05:46.859611
71	1	{}	63	Add	2024-08-08 12:05:54.048605
72	1	{}	64	Add	2024-08-08 12:06:18.494907
73	1	{}	65	Add	2024-08-08 12:06:21.683083
74	1	{}	66	Add	2024-08-08 12:06:28.68129
75	1	{}	67	Add	2024-08-13 07:51:37.509535
76	1	{}	68	Add	2024-08-13 07:51:47.40083
77	1	{}	69	Add	2024-08-13 07:52:01.221872
78	1	{}	70	Add	2024-08-13 07:52:12.578628
79	1	{}	71	Add	2024-08-13 07:52:21.096179
80	1	{}	72	Add	2024-08-13 07:52:46.295806
81	1	{}	73	Add	2024-08-13 07:52:56.626119
82	1	{}	74	Add	2024-08-13 07:53:05.40947
83	1	{}	75	Add	2024-08-13 07:53:16.739873
84	1	{}	76	Add	2024-08-13 07:53:37.376521
85	1	{}	77	Add	2024-08-13 07:53:52.647545
86	1	{}	78	Add	2024-08-13 07:54:03.425331
87	1	{}	79	Add	2024-08-13 07:54:14.037823
88	1	{"specializationcode":"12345","previousspecializationcode":"1234"}	5	Update	2024-08-15 10:57:19.054792
89	1	{}	80	Add	2024-08-20 09:58:51.471071
90	1	{}	81	Add	2024-08-20 09:59:13.802972
91	1	{}	82	Add	2024-08-20 09:59:20.901884
92	1	{}	83	Add	2024-08-20 09:59:35.560427
93	1	{}	84	Add	2024-08-20 09:59:42.275797
94	1	{}	85	Add	2024-08-20 09:59:49.128236
95	1	{}	86	Add	2024-08-20 10:00:10.216129
96	1	{}	87	Add	2024-08-20 10:00:17.101904
97	1	{}	88	Add	2024-08-20 10:00:23.975412
98	1	{}	89	Add	2024-08-20 10:00:45.424306
99	1	{}	90	Add	2024-08-20 10:00:53.004586
100	1	{}	91	Add	2024-08-20 10:00:59.37834
101	1	{}	92	Add	2024-08-20 10:01:18.073041
102	1	{}	93	Add	2024-08-20 10:01:27.406143
103	1	{}	94	Add	2024-08-20 10:03:15.682759
104	1	{}	95	Add	2024-08-20 10:03:29.374012
105	1	{}	96	Add	2024-08-20 10:03:39.969339
106	1	{}	97	Add	2024-08-20 10:03:48.501177
107	1	{}	98	Add	2024-08-20 10:04:31.562195
108	1	{}	99	Add	2024-08-20 10:04:37.307309
109	1	{}	100	Add	2024-08-20 10:04:44.981868
110	1	{}	101	Add	2024-08-20 10:04:51.912033
111	1	{}	102	Add	2024-08-20 10:11:47.250485
112	1	{}	103	Add	2024-08-20 10:11:56.671004
113	1	{}	104	Add	2024-08-20 10:12:29.320122
114	1	{}	105	Add	2024-08-20 10:12:37.764349
115	1	{}	106	Add	2024-08-20 10:12:50.503428
116	1	{}	107	Add	2024-08-20 10:32:12.977073
117	1	{}	108	Add	2024-08-20 10:32:20.999869
118	1	{}	109	Add	2024-08-20 10:33:01.035965
119	1	{}	110	Add	2024-08-20 10:37:23.938687
120	1	{}	111	Add	2024-08-20 10:37:34.413325
121	1	{}	112	Add	2024-08-20 10:37:42.241609
122	1	{}	113	Add	2024-08-20 10:38:21.121199
123	1	{}	114	Add	2024-08-20 12:59:26.025355
124	1	{}	115	Add	2024-08-20 12:59:33.096059
125	1	{}	116	Add	2024-08-20 13:03:10.13228
126	1	{}	117	Add	2024-08-20 13:03:16.577971
127	1	{}	118	Add	2024-08-20 13:03:24.172884
128	1	{}	119	Add	2024-08-21 06:12:56.541808
129	1	{}	120	Add	2024-08-21 06:13:11.333703
130	1	{}	121	Add	2024-08-21 06:20:12.694596
131	1	{}	122	Add	2024-08-21 06:24:06.724414
132	1	{}	123	Add	2024-08-21 06:24:36.488401
133	1	{}	124	Add	2024-08-21 06:24:51.785177
134	1	{}	125	Add	2024-08-21 06:25:11.094437
135	1	{}	126	Add	2024-08-21 06:26:09.959449
136	1	{}	127	Add	2024-08-21 06:26:26.55654
137	1	{}	128	Add	2024-08-21 06:27:01.404137
138	1	{}	129	Add	2024-08-21 06:27:11.715875
139	1	{}	130	Add	2024-08-21 06:27:57.543622
140	1	{}	131	Add	2024-08-21 06:28:09.384095
141	1	{}	132	Add	2024-08-21 06:28:22.37491
142	1	{}	133	Add	2024-08-21 06:28:38.055483
143	1	{}	134	Add	2024-08-21 06:29:13.106155
144	1	{}	135	Add	2024-08-21 06:30:02.070552
145	1	{}	136	Add	2024-08-21 06:31:02.241628
146	1	{}	137	Add	2024-08-21 06:31:38.006234
147	1	{}	138	Add	2024-08-21 06:38:34.99459
148	1	{}	139	Add	2024-08-23 10:30:24.835726
149	1	{}	140	Add	2024-08-23 10:30:32.875285
150	1	{}	141	Add	2024-08-23 10:30:44.805376
151	1	{}	142	Add	2024-08-23 10:31:09.463824
152	1	{}	143	Add	2024-08-23 10:34:41.628961
153	1	{}	144	Add	2024-08-23 10:34:53.386691
154	1	{}	145	Add	2024-08-23 10:35:02.391307
155	1	{}	146	Add	2024-08-23 10:35:12.5435
156	1	{}	147	Add	2024-08-23 10:35:20.999256
157	1	{}	148	Add	2024-08-23 10:35:36.829686
158	1	{}	149	Add	2024-08-23 10:35:47.464533
159	1	{}	150	Add	2024-08-23 10:35:57.573739
160	1	{}	151	Add	2024-08-23 10:36:10.375968
161	1	{}	152	Add	2024-08-23 10:36:25.608847
162	1	{}	153	Add	2024-08-23 10:36:50.887467
163	1	{}	154	Add	2024-08-23 10:37:03.734181
164	1	{}	155	Add	2024-08-23 10:37:32.319135
165	1	{}	156	Add	2024-08-23 10:37:45.986871
166	1	{}	157	Add	2024-08-23 10:40:38.47524
167	1	{}	158	Add	2024-08-23 10:41:03.397154
168	1	{}	159	Add	2024-08-23 10:41:33.700439
169	1	{}	160	Add	2024-08-23 11:18:12.347974
170	\N	{}	161	Add	2024-09-22 16:13:27.542328
171	1	{"specializationcode":"60","previousspecializationcode":"dfsfsdf"}	161	Update	2024-09-24 12:22:06.722385
\.


--
-- TOC entry 4137 (class 0 OID 17018)
-- Dependencies: 316
-- Data for Name: staff; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.staff (id, name, expert, experience, image, added_by, added_date, last_modified, designation, rating) FROM stdin;
11	Amit Singh Rajpoot	Undergraduate	1-Year	amit.jpeg	1	2024-08-09 06:49:54.022949	2024-08-26 09:18:56	Education Counsellor	4.1
20	Shubham 	1-Year	Undergraduate	Shubham.jpg	1	2024-08-26 10:24:12.785664	\N	Education Counsellor	4.2
19	Issac Samarth Nelson	Undergraduate	1-Year	issac.jpeg	1	2024-08-10 08:06:56.791184	2024-08-29 13:56:39	Education Counsellor	4.1
26	Rishabh chaudhary	Postgraduate	3-Year	Rishabh.jpeg	1	2024-08-31 07:25:39.39472	2024-09-02 17:22:39	Education Counsellor	4.9
18	Ashish Yadav	4-Year	Postgraduate	Ashish Yaadav.jpeg	1	2024-08-09 06:56:00.902487	2024-09-02 17:22:39	Education Counsellor	4.7
23	Rahul kumar	Undergraduate	1-Year	Rahul Kumar (2).jpeg	1	2024-08-26 10:25:30.116595	2024-09-02 17:22:39	Education Counsellor	4.3
27	Rohan	3-Year	Postgraduate	rohan.jpeg	\N	2024-09-03 12:24:59.883196	\N	Education Counsellor	4.2
28	VIDEETI	2-Year	Postgraduate	vidheeti.jpeg	\N	2024-09-03 12:25:28.869215	\N	Education Counsellor	4.3
29	PRIYA	2-Year	Postgraduate	priya.jpeg	\N	2024-09-03 12:25:55.634436	\N	Education Counsellor	4.4
30	Hurriya Moin	2-Year	Undergraduate	hurriya.jpeg	\N	2024-09-03 12:26:29.032101	\N	Education Counsellor	4.4
31	Heena Khatoon 	2-Year	Undergraduate	Heena Khatoon.jpg	\N	2024-09-03 12:27:34.980799	\N	Education Counsellor	4.5
32	MANSI	1-Year	Undergraduate	mansi.jpeg	1	2024-09-03 12:32:43.906343	\N	Education Counsellor	3.9
33	Kamran	1-Year	Undergraduate	kamran.jpeg	1	2024-09-03 12:33:38.69749	\N	Education Counsellor	4.1
37	Dheeraj soni	4-Year	Postgraduate	DHEERAJ.png	1	2024-09-04 07:34:34.172294	\N	Sr Education Counselor 	4.7
38	Arfeen	5-Year	Postgraduate	ARFEEN.png	1	2024-09-04 07:35:03.229767	\N	Sr Education Counselor 	4.7
39	Vikas Tomar	3-Year	Postgraduate	VIKAS.jpeg	1	2024-09-04 07:35:51.935415	\N	Education Counsellor	4.7
\.


--
-- TOC entry 4139 (class 0 OID 17028)
-- Dependencies: 318
-- Data for Name: state; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.state (id, name, country, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Delhi	2	1	2024-07-26 05:47:48.133137	\N	\N
\.


--
-- TOC entry 4141 (class 0 OID 17038)
-- Dependencies: 320
-- Data for Name: stream; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.stream (id, name, status, streammenu, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Computer Application	Active	Active	1	2024-07-26 05:50:09.976773	\N	\N
\.


--
-- TOC entry 4143 (class 0 OID 17048)
-- Dependencies: 322
-- Data for Name: studymode; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.studymode (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Online	Active	1	2024-07-26 05:52:36.804952	\N	\N
\.


--
-- TOC entry 4074 (class 0 OID 16642)
-- Dependencies: 253
-- Data for Name: subject; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.subject (id, course, specialization, subject, subjectcode, added_by, added_date, last_modified, semsteroryear, noofsemsteroryear) FROM stdin;
\.


--
-- TOC entry 4040 (class 0 OID 16399)
-- Dependencies: 219
-- Data for Name: superuser; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.superuser (id, name, email, username, password, designation, specialization, about, gender, profile, fb, linkedin, permission, access, added_by, added_date, last_modified, modified_by, status) FROM stdin;
1	Ibrahim	ibrahimmemon1709@gmail.com	ibrahimmemon1709@gmail.com	123456789	7	Node js PHP Laravel		male	1679235462260.jpeg	https://www.facebook.com/	\N	{All,University,Course,Blog,Specialization,Users,Student,Subject,Books,Leads,Reviews,Comments,FAQ,Staff,Alumni,Footer,Header,CTA,"Individual Course",Menu,"Academic Specialization","Auto Backup","University Request","Social Media","Home Faq",Job,"Job Response","One Step","User Activity",Banner}	{All,Add,View,Edit,Delete}	1	2024-07-18 11:32:14.298349	2024-09-16 10:22:04	1	true
2	Anurag	anurag.k@imtsinsitute.com	anurag.k@imtsinsitute.com	1234567890	6	MBA		\N	Image_20240713_130412.jpeg	\N	\N	{University,Course,Specialization,Staff}	{Export,All,Add,View,Edit,Delete}	1	2024-09-06 05:24:48.85544	2024-09-16 10:22:04	1	true
\.


--
-- TOC entry 4047 (class 0 OID 16434)
-- Dependencies: 226
-- Data for Name: university; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.university (id, uname, established, officemailid, approvedby, coursetype, stream, studymode, universitytype, websiteurl, state, city, logourl, imageurl, videourl, fblink, twitterlink, linkedin, instagram, toc, smode, feature, added_date, last_modified, nip, about, fact, emi, admission, active, urlname, seotitle, seodescription, toccontent, toch1, toch2, toch3, toch4, toch5, prospectus, last_modified_by, added_by, zone) FROM stdin;
\.


--
-- TOC entry 4145 (class 0 OID 17058)
-- Dependencies: 324
-- Data for Name: universityactivity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universityactivity (id, superuserid, content, modified_date, added_date, role, universityid, differentcontent, previouscontent, previouscontentlength, newcontentlength) FROM stdin;
1	1	{}	\N	2024-07-26 05:57:49.336239	Add	1	\N	\N	\N	\N
2	1	{}	\N	2024-07-26 06:30:17.341605	Delete	1	\N	\N	\N	\N
3	1	{}	\N	2024-07-26 06:30:41.736721	Delete	1	\N	\N	\N	\N
4	1	{}	\N	2024-07-26 06:30:48.162994	Delete	1	\N	\N	\N	\N
5	1	{}	\N	2024-07-26 06:30:49.83669	Delete	1	\N	\N	\N	\N
6	1	{}	\N	2024-07-26 06:30:50.198812	Delete	1	\N	\N	\N	\N
7	1	{}	\N	2024-07-26 06:31:03.455868	Delete	1	\N	\N	\N	\N
8	1	{}	\N	2024-07-26 06:31:05.235123	Delete	1	\N	\N	\N	\N
9	1	{}	\N	2024-07-26 06:31:14.822974	Delete	1	\N	\N	\N	\N
10	1	{}	\N	2024-07-26 06:31:15.520029	Delete	1	\N	\N	\N	\N
11	1	{}	\N	2024-07-26 06:31:15.675063	Delete	1	\N	\N	\N	\N
12	1	{}	\N	2024-07-26 06:31:17.331117	Delete	1	\N	\N	\N	\N
13	1	{}	\N	2024-07-26 09:30:35.412315	Delete	1	\N	\N	\N	\N
14	1	{}	\N	2024-07-26 09:30:57.499808	Delete	1	\N	\N	\N	\N
15	1	{}	\N	2024-07-26 09:30:59.216741	Delete	1	\N	\N	\N	\N
16	1	{}	\N	2024-07-26 09:30:59.381851	Delete	1	\N	\N	\N	\N
17	1	{}	\N	2024-07-26 09:31:35.444098	Delete	1	\N	\N	\N	\N
18	1	{}	\N	2024-07-26 11:13:57.728891	Delete	1	\N	\N	\N	\N
19	1	{}	\N	2024-07-26 11:14:57.728906	Delete	1	\N	\N	\N	\N
20	1	{}	\N	2024-07-26 12:27:54.902079	Delete	1	\N	\N	\N	\N
21	1	{}	\N	2024-07-26 12:37:07.773538	Add	2	\N	\N	\N	\N
22	1	{}	\N	2024-07-26 12:39:28.271609	Delete	2	\N	\N	\N	\N
23	1	{}	\N	2024-08-13 12:27:51.792081	Add	3	\N	\N	\N	\N
24	1	{}	\N	2024-08-14 10:59:58.314015	Delete	3	\N	\N	\N	\N
25	1	{}	\N	2024-08-15 13:34:10.700594	Add	4	\N	\N	\N	\N
26	1	{}	\N	2024-08-15 13:36:26.092487	Delete	4	\N	\N	\N	\N
27	1	{}	\N	2024-08-20 10:14:25.754058	Add	5	\N	\N	\N	\N
28	1	{}	\N	2024-08-20 11:46:56.656972	Delete	5	\N	\N	\N	\N
29	1	{}	\N	2024-09-02 12:50:23.701059	Add	6	\N	\N	\N	\N
30	1	{}	\N	2024-09-02 13:51:15.386973	Delete	6	\N	\N	\N	\N
31	1	{}	\N	2024-09-02 14:47:42.881307	Delete	7	\N	\N	\N	\N
32	1	{}	\N	2024-09-02 14:53:30.105362	Add	8	\N	\N	\N	\N
33	1	\N	\N	2024-09-02 17:22:58.224318	Update	8	11 22	\N	\N	\N
34	1	\N	\N	2024-09-04 10:12:28.963257	Update	8	33 44 55	\N	\N	\N
35	1	\N	\N	2024-09-04 10:20:34.751424	Update	8	3423 234534 34 546546 546546	\N	\N	\N
36	1	\N	\N	2024-09-04 10:20:59.483771	Update	8	8678 7868 786 78 8786 8	\N	\N	\N
37	1	\N	\N	2024-09-05 16:55:22.860497	Update	8	Ibrahim Memon	\N	\N	\N
38	1	{}	\N	2024-09-07 14:39:55.976612	Add	9	\N	\N	\N	\N
39	1	{}	\N	2024-09-10 13:33:00.564111	Add	45	\N	\N	\N	\N
40	1	\N	\N	2024-09-10 13:33:57.703254	Update	45		\N	\N	\N
41	1	\N	\N	2024-09-10 13:46:56.667072	Update	45		\N	\N	\N
42	1	\N	\N	2024-09-10 13:47:06.959459	Update	45		\N	\N	\N
43	1	\N	\N	2024-09-10 13:50:41.158859	Update	45		\N	\N	\N
44	1	\N	\N	2024-09-10 13:52:46.494045	Update	45		\N	\N	\N
45	1	\N	\N	2024-09-10 13:53:54.149939	Update	45		\N	\N	\N
46	1	\N	\N	2024-09-12 18:39:01.570128	Update	45	zxczxc zxczxzxczxc zxczxc	jkhk	1	3
47	1	\N	\N	2024-09-13 12:38:38.739705	Add	47	<h1>dsfgsdf<br></h1><p>dfgdfg dfg dfgdfgdfg dfgdfg</p>	\N	\N	\N
48	1	{}	\N	2024-09-21 15:30:45.833518	Delete	47	\N	\N	\N	\N
49	\N	\N	\N	2024-09-22 16:14:32.883806	Add	48	<p>,jlljlkjl</p>	\N	\N	\N
50	\N	\N	\N	2024-09-22 16:19:11.925855	Add	49	<p>sdfsdf</p>	\N	\N	\N
51	\N	\N	\N	2024-09-22 16:23:18.299234	Add	50	<p>sdfsdf</p>	\N	\N	\N
52	\N	\N	\N	2024-09-22 16:26:00.309559	Add	51	<p>asd</p>	\N	\N	\N
53	1	\N	\N	2024-09-22 16:28:52.156042	Add	52	<p>fghfgh</p>	\N	\N	\N
54	1	{}	\N	2024-09-24 05:12:43.310126	Delete	45	\N	\N	\N	\N
55	1	{}	\N	2024-09-24 05:12:48.356858	Delete	52	\N	\N	\N	\N
56	1	{}	\N	2024-09-24 05:13:13.393786	Delete	52	\N	\N	\N	\N
57	1	\N	\N	2024-09-26 10:32:54.435521	Add	53	<p>dsfsdf</p>	\N	\N	\N
58	1	\N	\N	2024-09-26 10:33:06.994147	Update	53			0	0
59	1	{}	\N	2024-09-26 10:33:14.19889	Delete	53	\N	\N	\N	\N
60	1	\N	\N	2024-09-26 11:51:10.11486	Add	55	<p>m.l.kjl;k;</p>	\N	\N	\N
61	1	{}	\N	2024-09-26 11:51:31.936502	Delete	55	\N	\N	\N	\N
62	1	\N	\N	2024-09-26 14:28:53.918693	Add	56	<p>fgh</p>	\N	\N	\N
63	1	{}	\N	2024-09-26 14:51:31.686124	Delete	56	\N	\N	\N	\N
64	1	\N	\N	2024-10-09 20:33:02.248191	Add	57	<p>fghfgh</p>	\N	\N	\N
65	1	{}	\N	2024-10-09 20:47:55.474294	Delete	57	\N	\N	\N	\N
66	\N	\N	\N	2024-10-10 09:46:22.674822	Add	58		\N	\N	\N
\.


--
-- TOC entry 4147 (class 0 OID 17073)
-- Dependencies: 326
-- Data for Name: universitycomment; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universitycomment (id, title, description, universityid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4172 (class 0 OID 18534)
-- Dependencies: 351
-- Data for Name: universitycourseactivity; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universitycourseactivity (id, superuserid, content, differentcontent, role, unicourseid, added_date, previouscontent, previouscontentlength, newcontentlength) FROM stdin;
1	1	\N	12312 234234	Update	6	2024-09-04 10:12:52.155133	\N	\N	\N
2	1	\N	786  897 898 789 89	Update	6	2024-09-04 10:21:29.957608	\N	\N	\N
3	1	<p>Enter Content Heresdfsdf</p>	\N	Add	7	2024-09-21 14:42:43.284299	\N	\N	\N
4	1	{}	\N	Delete	7	2024-09-21 14:46:11.414505	\N	\N	\N
5	1	{}	\N	Delete	7	2024-09-21 14:49:59.295053	\N	\N	\N
6	1	{}	\N	Delete	6	2024-09-21 14:50:03.675816	\N	\N	\N
7	1	<p>Enter Content Heresdfsdf</p>	\N	Add	8	2024-09-21 14:50:42.676375	\N	\N	\N
8	1	{}	\N	Delete	8	2024-09-24 12:15:45.758636	\N	\N	\N
9	1	<p>Enter Content Heredfgdfg</p>	\N	Add	9	2024-09-26 14:29:21.268861	\N	\N	\N
10	1	{}	\N	Delete	9	2024-10-11 09:18:08.555972	\N	\N	\N
\.


--
-- TOC entry 4149 (class 0 OID 17093)
-- Dependencies: 328
-- Data for Name: universityfaq; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universityfaq (id, question, answer, added_by, added_date, universityid, last_modified) FROM stdin;
\.


--
-- TOC entry 4151 (class 0 OID 17108)
-- Dependencies: 330
-- Data for Name: universitylisteningbenefit; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universitylisteningbenefit (id, step1, step2, step3, step4, added_by, added_date, last_modified_date, last_modified_by) FROM stdin;
1	Universities love listing on IMTS because it boosts their global reach, connecting them with a vast audience of prospective students from various regions. The platform’s extensive network allows universities to present their unique programs, faculty expertise, and campus facilities, attracting a diverse and qualified applicant pool.	Additionally, being listed on IMTS enhances a university’s credibility and reputation by associating them with a trusted platform known for its educational resources. This association helps universities build trust with potential students, making them more likely to consider enrolling.	Finally, listing on IMTS offers universities a competitive edge, helping them stand out in a crowded educational market. With the platform’s support, universities can effectively highlight their strengths, making it easier for students to choose them over others.	IMTS listing elevates universities' global visibility, credibility, and reputation. It connects them with a diverse, qualified student pool, offering a competitive edge in a crowded market. Universities can effectively showcase their strengths, making them a top choice for prospective students.	1	2024-08-20 10:37:18.990966	2024-08-21 11:33:36	1
\.


--
-- TOC entry 4153 (class 0 OID 17118)
-- Dependencies: 332
-- Data for Name: universitylisteningstep; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universitylisteningstep (id, step1, step2, step3, step4, added_by, added_date, last_modified_date, last_modified_by) FROM stdin;
12	Start by visiting the IMTS platform and creating an account. Fill in the required details, including your university or college name, contact information, and relevant credentials. Ensure all information is accurate for a smooth registration process.	Once registered, complete your institution’s profile by adding essential details like programs offered, faculty information, and campus facilities. Include high-quality images and descriptions to make your listing appealing. A well-detailed profile attracts more prospective students	Upload necessary documents such as accreditation certificates faculty qualifications and program outlines.Ensure all documents are up-to-date and clearly presented. This step is crucial as it verifies your institution's legitimacy and enhances credibility on the platform	Review all the information entered and make any necessary edits. Once everything is accurate and complete, submit your profile for approval. After approval, your university or college will be live on IMTS, accessible to a global audience of prospective students	1	2024-08-22 11:29:53.993577	\N	\N
\.


--
-- TOC entry 4155 (class 0 OID 17128)
-- Dependencies: 334
-- Data for Name: universityreview; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universityreview (id, rating, detail, universityid, userid, added_by, added_date, last_modified) FROM stdin;
\.


--
-- TOC entry 4157 (class 0 OID 17148)
-- Dependencies: 336
-- Data for Name: universitytype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.universitytype (id, name, status, added_by, added_date, last_modified_by, last_modified_date) FROM stdin;
1	Goverment	Active	1	2024-07-26 05:53:10.464118	\N	\N
\.


--
-- TOC entry 4180 (class 0 OID 18637)
-- Dependencies: 359
-- Data for Name: userlogs; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.userlogs (id, username, added_date, status) FROM stdin;
301	1	2024-09-25 14:47:23.887198	Online
302	1	2024-09-25 14:47:23.902714	Online
303	1	2024-09-25 14:50:01.130927	Logout
304	1	2024-09-25 14:50:09.588983	Online
305	1	2024-09-25 14:51:28.277792	Online
306	1	2024-09-25 14:52:40.039676	Logout
307	\N	2024-09-25 14:52:46.723684	Logout
308	1	2024-09-25 14:53:05.459815	Online
309	2	2024-09-25 14:53:18.921599	Online
310	1	2024-09-25 14:53:29.689163	Logout
311	2	2024-09-25 14:54:11.444838	Logout
312	1	2024-09-25 17:57:16.815664	Online
313	2	2024-09-25 17:57:37.382391	Online
314	2	2024-09-25 17:57:48.617618	Logout
315	1	2024-09-26 10:22:58.268626	Online
316	1	2024-09-26 10:23:42.350987	Logout
317	1	2024-09-26 10:24:06.261842	Online
318	1	2024-09-26 10:25:07.791494	Online
319	1	2024-09-26 10:32:05.347367	Online
320	1	2024-09-26 11:12:55.312381	Online
321	1	2024-09-26 11:19:40.721918	Logout
322	1	2024-09-26 11:26:29.235346	Online
323	1	2024-09-26 11:28:47.906964	Logout
324	1	2024-09-26 11:28:54.594921	Online
325	\N	2024-09-26 13:46:48.509757	Logout
326	1	2024-09-26 13:51:45.693396	Online
327	1	2024-09-26 13:51:52.056996	Logout
328	1	2024-09-26 14:04:31.899733	Online
329	1	2024-09-26 14:48:36.036316	Online
330	1	2024-09-26 14:55:34.455602	Logout
331	1	2024-09-28 11:09:34.742775	Online
332	1	2024-09-29 11:12:06.178496	Online
333	1	2024-09-29 11:13:05.025392	Logout
334	\N	2024-09-29 11:13:09.793261	Logout
335	1	2024-09-29 11:16:46.47654	Online
336	1	2024-09-29 11:16:59.656266	Logout
337	1	2024-09-29 12:20:42.832206	Online
338	1	2024-09-29 12:21:24.420655	Logout
339	1	2024-09-29 14:41:40.305074	Online
340	1	2024-10-01 10:52:26.338653	Online
341	1	2024-10-01 10:53:15.75642	Logout
342	\N	2024-10-01 10:53:19.525953	Logout
343	\N	2024-10-01 10:53:21.597841	Logout
344	\N	2024-10-01 10:53:28.201937	Logout
345	1	2024-10-07 18:24:41.229192	Online
346	1	2024-10-07 18:25:49.661607	Logout
347	1	2024-10-08 11:05:03.886128	Online
348	1	2024-10-08 19:02:34.338366	Online
349	1	2024-10-08 19:02:39.016552	Logout
350	1	2024-10-09 20:32:10.321664	Online
351	1	2024-10-10 09:46:51.364197	Online
352	1	2024-10-10 09:49:34.201049	Logout
353	1	2024-10-10 09:49:40.332691	Online
354	1	2024-10-10 09:49:44.532321	Logout
355	1	2024-10-10 11:12:32.200115	Online
356	1	2024-10-10 11:12:38.967531	Logout
357	1	2024-10-10 11:12:44.563946	Online
358	1	2024-10-10 11:13:07.742408	Logout
359	1	2024-10-11 09:16:44.671416	Online
360	1	2024-10-11 09:39:12.789198	Online
361	1	2024-10-11 09:39:31.65566	Logout
362	1	2024-10-11 11:25:41.083371	Online
\.


--
-- TOC entry 4065 (class 0 OID 16543)
-- Dependencies: 244
-- Data for Name: users; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.users (id, name, email, phone, city, country, gender, password, added_by, last_modified, added_date, courseid, dob) FROM stdin;
\.


--
-- TOC entry 4037 (class 0 OID 16391)
-- Dependencies: 216
-- Data for Name: uu; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.uu (id) FROM stdin;
\.


--
-- TOC entry 4159 (class 0 OID 17158)
-- Dependencies: 338
-- Data for Name: zone; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY public.zone (id, name, added_by, added_date, last_modified_by, last_modified_date, status) FROM stdin;
1	fdjshj	1	2024-07-26 05:49:04.699371	\N	\N	Active
\.


--
-- TOC entry 4312 (class 0 OID 0)
-- Dependencies: 231
-- Name: aboutpage_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.aboutpage_id_seq', 6, true);


--
-- TOC entry 4313 (class 0 OID 0)
-- Dependencies: 234
-- Name: acdemicspecialization_id; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.acdemicspecialization_id', 2, true);


--
-- TOC entry 4314 (class 0 OID 0)
-- Dependencies: 233
-- Name: acdemicspecialization_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.acdemicspecialization_id_seq', 1, false);


--
-- TOC entry 4315 (class 0 OID 0)
-- Dependencies: 220
-- Name: alumni_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.alumni_id_seq', 28, true);


--
-- TOC entry 4316 (class 0 OID 0)
-- Dependencies: 236
-- Name: approved_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.approved_id_seq', 1, true);


--
-- TOC entry 4317 (class 0 OID 0)
-- Dependencies: 238
-- Name: backup_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.backup_id_seq', 109, true);


--
-- TOC entry 4318 (class 0 OID 0)
-- Dependencies: 240
-- Name: banner_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.banner_id_seq', 1, false);


--
-- TOC entry 4319 (class 0 OID 0)
-- Dependencies: 341
-- Name: blog_id_faqs; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blog_id_faqs', 1, false);


--
-- TOC entry 4320 (class 0 OID 0)
-- Dependencies: 222
-- Name: blog_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blog_id_seq', 59, true);


--
-- TOC entry 4321 (class 0 OID 0)
-- Dependencies: 352
-- Name: blogactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blogactivity_id_seq', 48, true);


--
-- TOC entry 4322 (class 0 OID 0)
-- Dependencies: 242
-- Name: blogcomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blogcomment_id_seq', 1, false);


--
-- TOC entry 4323 (class 0 OID 0)
-- Dependencies: 224
-- Name: blogfaq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blogfaq', 1, false);


--
-- TOC entry 4324 (class 0 OID 0)
-- Dependencies: 246
-- Name: blogfaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blogfaq_id_seq', 12, true);


--
-- TOC entry 4325 (class 0 OID 0)
-- Dependencies: 247
-- Name: blogreview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.blogreview_id_seq', 1, false);


--
-- TOC entry 4326 (class 0 OID 0)
-- Dependencies: 249
-- Name: book_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.book_id_seq', 1, false);


--
-- TOC entry 4327 (class 0 OID 0)
-- Dependencies: 255
-- Name: city_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.city_id_seq', 1, true);


--
-- TOC entry 4328 (class 0 OID 0)
-- Dependencies: 257
-- Name: collegetype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.collegetype_id_seq', 1, true);


--
-- TOC entry 4329 (class 0 OID 0)
-- Dependencies: 259
-- Name: contactus_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.contactus_id_seq', 2, true);


--
-- TOC entry 4330 (class 0 OID 0)
-- Dependencies: 261
-- Name: country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.country_id_seq', 2, true);


--
-- TOC entry 4331 (class 0 OID 0)
-- Dependencies: 227
-- Name: course_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.course_id_seq', 9, true);


--
-- TOC entry 4332 (class 0 OID 0)
-- Dependencies: 263
-- Name: courseactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.courseactivity_id_seq', 60, true);


--
-- TOC entry 4333 (class 0 OID 0)
-- Dependencies: 265
-- Name: coursecomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.coursecomment_id_seq', 1, false);


--
-- TOC entry 4334 (class 0 OID 0)
-- Dependencies: 267
-- Name: courseduration_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.courseduration_id_seq', 7, true);


--
-- TOC entry 4335 (class 0 OID 0)
-- Dependencies: 269
-- Name: coursefaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.coursefaq_id_seq', 9, true);


--
-- TOC entry 4336 (class 0 OID 0)
-- Dependencies: 271
-- Name: coursemode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.coursemode_id_seq', 1, false);


--
-- TOC entry 4337 (class 0 OID 0)
-- Dependencies: 273
-- Name: coursereview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.coursereview_id_seq', 1, false);


--
-- TOC entry 4338 (class 0 OID 0)
-- Dependencies: 275
-- Name: coursetype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.coursetype_id_seq', 1, true);


--
-- TOC entry 4339 (class 0 OID 0)
-- Dependencies: 277
-- Name: cta_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.cta_id_seq', 9, true);


--
-- TOC entry 4340 (class 0 OID 0)
-- Dependencies: 339
-- Name: cta_id_seq_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac_ibrahimmemon
--

SELECT pg_catalog.setval('public.cta_id_seq_seq', 1, false);


--
-- TOC entry 4341 (class 0 OID 0)
-- Dependencies: 279
-- Name: designation_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.designation_id_seq', 7, true);


--
-- TOC entry 4342 (class 0 OID 0)
-- Dependencies: 344
-- Name: establish_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.establish_id_seq', 1, true);


--
-- TOC entry 4343 (class 0 OID 0)
-- Dependencies: 343
-- Name: establish_seq_id; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.establish_seq_id', 1, false);


--
-- TOC entry 4344 (class 0 OID 0)
-- Dependencies: 281
-- Name: expertpage_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.expertpage_id_seq', 4, true);


--
-- TOC entry 4345 (class 0 OID 0)
-- Dependencies: 283
-- Name: faq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.faq_id_seq', 1, true);


--
-- TOC entry 4346 (class 0 OID 0)
-- Dependencies: 285
-- Name: footer_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.footer_id_seq', 2, true);


--
-- TOC entry 4347 (class 0 OID 0)
-- Dependencies: 287
-- Name: header_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.header_id_seq', 8, true);


--
-- TOC entry 4348 (class 0 OID 0)
-- Dependencies: 229
-- Name: individualcourse_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.individualcourse_id_seq', 206, true);


--
-- TOC entry 4349 (class 0 OID 0)
-- Dependencies: 289
-- Name: individualcoursefaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.individualcoursefaq_id_seq', 85, true);


--
-- TOC entry 4350 (class 0 OID 0)
-- Dependencies: 291
-- Name: job_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.job_id_seq', 4, true);


--
-- TOC entry 4351 (class 0 OID 0)
-- Dependencies: 293
-- Name: jobmode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.jobmode_id_seq', 6, true);


--
-- TOC entry 4352 (class 0 OID 0)
-- Dependencies: 295
-- Name: jobreference_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.jobreference_id_seq', 2, true);


--
-- TOC entry 4353 (class 0 OID 0)
-- Dependencies: 297
-- Name: jobresponse_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.jobresponse_id_seq', 2, true);


--
-- TOC entry 4354 (class 0 OID 0)
-- Dependencies: 299
-- Name: jobtype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.jobtype_id_seq', 4, true);


--
-- TOC entry 4355 (class 0 OID 0)
-- Dependencies: 301
-- Name: lead_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.lead_id_seq', 34, true);


--
-- TOC entry 4356 (class 0 OID 0)
-- Dependencies: 346
-- Name: marquee_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.marquee_id_seq', 1, false);


--
-- TOC entry 4357 (class 0 OID 0)
-- Dependencies: 347
-- Name: marquee_id_seq1; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.marquee_id_seq1', 1, true);


--
-- TOC entry 4358 (class 0 OID 0)
-- Dependencies: 303
-- Name: media_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.media_id_seq', 19, true);


--
-- TOC entry 4359 (class 0 OID 0)
-- Dependencies: 305
-- Name: moreresource_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.moreresource_id_seq', 1, false);


--
-- TOC entry 4360 (class 0 OID 0)
-- Dependencies: 307
-- Name: news_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.news_id_seq', 1, false);


--
-- TOC entry 4361 (class 0 OID 0)
-- Dependencies: 309
-- Name: onestep_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.onestep_id_seq', 18, true);


--
-- TOC entry 4362 (class 0 OID 0)
-- Dependencies: 360
-- Name: prev_userlogs_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.prev_userlogs_id_seq', 32, true);


--
-- TOC entry 4363 (class 0 OID 0)
-- Dependencies: 311
-- Name: qualification_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.qualification_id_seq', 2, true);


--
-- TOC entry 4364 (class 0 OID 0)
-- Dependencies: 250
-- Name: specialization_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.specialization_id_seq', 161, true);


--
-- TOC entry 4365 (class 0 OID 0)
-- Dependencies: 313
-- Name: specializationactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.specializationactivity_id_seq', 171, true);


--
-- TOC entry 4366 (class 0 OID 0)
-- Dependencies: 315
-- Name: staff_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.staff_id_seq', 39, true);


--
-- TOC entry 4367 (class 0 OID 0)
-- Dependencies: 317
-- Name: state_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.state_id_seq', 1, true);


--
-- TOC entry 4368 (class 0 OID 0)
-- Dependencies: 319
-- Name: stream_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.stream_id_seq', 1, true);


--
-- TOC entry 4369 (class 0 OID 0)
-- Dependencies: 321
-- Name: studymode_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.studymode_id_seq', 1, true);


--
-- TOC entry 4370 (class 0 OID 0)
-- Dependencies: 252
-- Name: subject_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.subject_id_seq', 1, true);


--
-- TOC entry 4371 (class 0 OID 0)
-- Dependencies: 218
-- Name: superuser_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.superuser_id_seq', 3, true);


--
-- TOC entry 4372 (class 0 OID 0)
-- Dependencies: 225
-- Name: university_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.university_id_seq', 58, true);


--
-- TOC entry 4373 (class 0 OID 0)
-- Dependencies: 323
-- Name: universityactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universityactivity_id_seq', 66, true);


--
-- TOC entry 4374 (class 0 OID 0)
-- Dependencies: 325
-- Name: universitycomment_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitycomment_id_seq', 1, false);


--
-- TOC entry 4375 (class 0 OID 0)
-- Dependencies: 349
-- Name: universitycourse_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitycourse_id_seq', 1, false);


--
-- TOC entry 4376 (class 0 OID 0)
-- Dependencies: 350
-- Name: universitycourseactivity_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitycourseactivity_id_seq', 10, true);


--
-- TOC entry 4377 (class 0 OID 0)
-- Dependencies: 327
-- Name: universityfaq_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universityfaq_id_seq', 20, true);


--
-- TOC entry 4378 (class 0 OID 0)
-- Dependencies: 340
-- Name: universitylistening_benefit_id_seq; Type: SEQUENCE SET; Schema: public; Owner: imtsac_ibrahimmemon
--

SELECT pg_catalog.setval('public.universitylistening_benefit_id_seq', 1, true);


--
-- TOC entry 4379 (class 0 OID 0)
-- Dependencies: 329
-- Name: universitylisteningbenefit_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitylisteningbenefit_id_seq', 2, true);


--
-- TOC entry 4380 (class 0 OID 0)
-- Dependencies: 331
-- Name: universitylisteningstep_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitylisteningstep_id_seq', 12, true);


--
-- TOC entry 4381 (class 0 OID 0)
-- Dependencies: 333
-- Name: universityreview_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universityreview_id_seq', 1, false);


--
-- TOC entry 4382 (class 0 OID 0)
-- Dependencies: 335
-- Name: universitytype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.universitytype_id_seq', 1, true);


--
-- TOC entry 4383 (class 0 OID 0)
-- Dependencies: 217
-- Name: up; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.up', 1, false);


--
-- TOC entry 4384 (class 0 OID 0)
-- Dependencies: 358
-- Name: userlogs_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.userlogs_id_seq', 362, true);


--
-- TOC entry 4385 (class 0 OID 0)
-- Dependencies: 243
-- Name: users_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.users_id_seq', 1, false);


--
-- TOC entry 4386 (class 0 OID 0)
-- Dependencies: 215
-- Name: uu_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.uu_id_seq', 1, false);


--
-- TOC entry 4387 (class 0 OID 0)
-- Dependencies: 337
-- Name: zone_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('public.zone_id_seq', 1, true);


--
-- TOC entry 3739 (class 2606 OID 16472)
-- Name: aboutpage aboutpage_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.aboutpage
    ADD CONSTRAINT aboutpage_pkey PRIMARY KEY (id);


--
-- TOC entry 3741 (class 2606 OID 16486)
-- Name: acdemicspecialization acdemicspecialization_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_pkey PRIMARY KEY (id);


--
-- TOC entry 3729 (class 2606 OID 16417)
-- Name: alumni alumni_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.alumni
    ADD CONSTRAINT alumni_pkey PRIMARY KEY (id);


--
-- TOC entry 3743 (class 2606 OID 16506)
-- Name: approved approved_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.approved
    ADD CONSTRAINT approved_pkey PRIMARY KEY (id);


--
-- TOC entry 3745 (class 2606 OID 16516)
-- Name: backup backup_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.backup
    ADD CONSTRAINT backup_pkey PRIMARY KEY (id);


--
-- TOC entry 3747 (class 2606 OID 16526)
-- Name: banner banner_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.banner
    ADD CONSTRAINT banner_pkey PRIMARY KEY (id);


--
-- TOC entry 3731 (class 2606 OID 16427)
-- Name: blog blog_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blog
    ADD CONSTRAINT blog_pkey PRIMARY KEY (id);


--
-- TOC entry 3853 (class 2606 OID 18552)
-- Name: blogactivity blogactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogactivity
    ADD CONSTRAINT blogactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3751 (class 2606 OID 16565)
-- Name: blogcomment blogcomment_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3845 (class 2606 OID 18373)
-- Name: blogfaqs blogfaq_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogfaqs
    ADD CONSTRAINT blogfaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3753 (class 2606 OID 16586)
-- Name: blogreview blogreview_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_pkey PRIMARY KEY (id);


--
-- TOC entry 3759 (class 2606 OID 16669)
-- Name: book book_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_pkey PRIMARY KEY (id);


--
-- TOC entry 3761 (class 2606 OID 16689)
-- Name: city city_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.city
    ADD CONSTRAINT city_pkey PRIMARY KEY (id);


--
-- TOC entry 3763 (class 2606 OID 16700)
-- Name: collegetype collegetype_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.collegetype
    ADD CONSTRAINT collegetype_pkey PRIMARY KEY (id);


--
-- TOC entry 3765 (class 2606 OID 16710)
-- Name: contactus contactus_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.contactus
    ADD CONSTRAINT contactus_pkey PRIMARY KEY (id);


--
-- TOC entry 3767 (class 2606 OID 16720)
-- Name: country country_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.country
    ADD CONSTRAINT country_pkey PRIMARY KEY (id);


--
-- TOC entry 3735 (class 2606 OID 16452)
-- Name: course course_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.course
    ADD CONSTRAINT course_pkey PRIMARY KEY (id);


--
-- TOC entry 3769 (class 2606 OID 16730)
-- Name: courseactivity courseactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.courseactivity
    ADD CONSTRAINT courseactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3771 (class 2606 OID 16740)
-- Name: coursecomment coursecomment_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3773 (class 2606 OID 16760)
-- Name: courseduration courseduration_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.courseduration
    ADD CONSTRAINT courseduration_pkey PRIMARY KEY (id);


--
-- TOC entry 3775 (class 2606 OID 16770)
-- Name: coursefaq coursefaq_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursefaq
    ADD CONSTRAINT coursefaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3777 (class 2606 OID 16785)
-- Name: coursemode coursemode_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursemode
    ADD CONSTRAINT coursemode_pkey PRIMARY KEY (id);


--
-- TOC entry 3779 (class 2606 OID 16795)
-- Name: coursereview coursereview_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_pkey PRIMARY KEY (id);


--
-- TOC entry 3781 (class 2606 OID 16815)
-- Name: coursetype coursetype_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursetype
    ADD CONSTRAINT coursetype_pkey PRIMARY KEY (id);


--
-- TOC entry 3783 (class 2606 OID 16825)
-- Name: cta cta_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.cta
    ADD CONSTRAINT cta_pkey PRIMARY KEY (id);


--
-- TOC entry 3785 (class 2606 OID 16835)
-- Name: designation designation_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.designation
    ADD CONSTRAINT designation_pkey PRIMARY KEY (id);


--
-- TOC entry 3847 (class 2606 OID 18468)
-- Name: establish establish_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.establish
    ADD CONSTRAINT establish_pkey PRIMARY KEY (id);


--
-- TOC entry 3787 (class 2606 OID 16845)
-- Name: expertpage expertpage_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.expertpage
    ADD CONSTRAINT expertpage_pkey PRIMARY KEY (id);


--
-- TOC entry 3789 (class 2606 OID 16855)
-- Name: faq faq_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.faq
    ADD CONSTRAINT faq_pkey PRIMARY KEY (id);


--
-- TOC entry 3791 (class 2606 OID 16866)
-- Name: footer footer_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.footer
    ADD CONSTRAINT footer_pkey PRIMARY KEY (id);


--
-- TOC entry 3793 (class 2606 OID 16876)
-- Name: header header_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.header
    ADD CONSTRAINT header_pkey PRIMARY KEY (id);


--
-- TOC entry 3737 (class 2606 OID 16461)
-- Name: individualcourse individualcourse_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.individualcourse
    ADD CONSTRAINT individualcourse_pkey PRIMARY KEY (id);


--
-- TOC entry 3795 (class 2606 OID 16885)
-- Name: individualcoursefaq individualcoursefaq_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.individualcoursefaq
    ADD CONSTRAINT individualcoursefaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3797 (class 2606 OID 16895)
-- Name: job job_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.job
    ADD CONSTRAINT job_pkey PRIMARY KEY (id);


--
-- TOC entry 3799 (class 2606 OID 16905)
-- Name: jobmode jobmode_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.jobmode
    ADD CONSTRAINT jobmode_pkey PRIMARY KEY (id);


--
-- TOC entry 3801 (class 2606 OID 16915)
-- Name: jobreference jobreference_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.jobreference
    ADD CONSTRAINT jobreference_pkey PRIMARY KEY (id);


--
-- TOC entry 3803 (class 2606 OID 16925)
-- Name: jobresponse jobresponse_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.jobresponse
    ADD CONSTRAINT jobresponse_pkey PRIMARY KEY (id);


--
-- TOC entry 3805 (class 2606 OID 16935)
-- Name: jobtype jobtype_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.jobtype
    ADD CONSTRAINT jobtype_pkey PRIMARY KEY (id);


--
-- TOC entry 3807 (class 2606 OID 16945)
-- Name: lead lead_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_pkey PRIMARY KEY (id);


--
-- TOC entry 3849 (class 2606 OID 18515)
-- Name: marquee marquee_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.marquee
    ADD CONSTRAINT marquee_pkey PRIMARY KEY (id);


--
-- TOC entry 3809 (class 2606 OID 16965)
-- Name: media media_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.media
    ADD CONSTRAINT media_pkey PRIMARY KEY (id);


--
-- TOC entry 3811 (class 2606 OID 16975)
-- Name: moreresource moreresource_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.moreresource
    ADD CONSTRAINT moreresource_pkey PRIMARY KEY (id);


--
-- TOC entry 3813 (class 2606 OID 16985)
-- Name: news news_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.news
    ADD CONSTRAINT news_pkey PRIMARY KEY (id);


--
-- TOC entry 3815 (class 2606 OID 16995)
-- Name: onestep onestep_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.onestep
    ADD CONSTRAINT onestep_pkey PRIMARY KEY (id);


--
-- TOC entry 3865 (class 2606 OID 23341)
-- Name: prevuserlogs prev_userlogs_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.prevuserlogs
    ADD CONSTRAINT prev_userlogs_pkey PRIMARY KEY (id);


--
-- TOC entry 3857 (class 2606 OID 18578)
-- Name: prevewblog prevewblog_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.prevewblog
    ADD CONSTRAINT prevewblog_pkey PRIMARY KEY (id);


--
-- TOC entry 3855 (class 2606 OID 18569)
-- Name: prevewindividualcourse prevewindividualcourse_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.prevewindividualcourse
    ADD CONSTRAINT prevewindividualcourse_pkey PRIMARY KEY (id);


--
-- TOC entry 3861 (class 2606 OID 18634)
-- Name: previewblog previewblog_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.previewblog
    ADD CONSTRAINT previewblog_pkey PRIMARY KEY (id);


--
-- TOC entry 3859 (class 2606 OID 18623)
-- Name: previewuniversity previewuniversity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.previewuniversity
    ADD CONSTRAINT previewuniversity_pkey PRIMARY KEY (id);


--
-- TOC entry 3817 (class 2606 OID 17006)
-- Name: qualification qualification_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.qualification
    ADD CONSTRAINT qualification_pkey PRIMARY KEY (id);


--
-- TOC entry 3755 (class 2606 OID 16616)
-- Name: specialization specialization_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.specialization
    ADD CONSTRAINT specialization_pkey PRIMARY KEY (id);


--
-- TOC entry 3819 (class 2606 OID 17016)
-- Name: specializationactivity specializationactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.specializationactivity
    ADD CONSTRAINT specializationactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3821 (class 2606 OID 17026)
-- Name: staff staff_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.staff
    ADD CONSTRAINT staff_pkey PRIMARY KEY (id);


--
-- TOC entry 3823 (class 2606 OID 17036)
-- Name: state state_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.state
    ADD CONSTRAINT state_pkey PRIMARY KEY (id);


--
-- TOC entry 3825 (class 2606 OID 17046)
-- Name: stream stream_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.stream
    ADD CONSTRAINT stream_pkey PRIMARY KEY (id);


--
-- TOC entry 3827 (class 2606 OID 17056)
-- Name: studymode studymode_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.studymode
    ADD CONSTRAINT studymode_pkey PRIMARY KEY (id);


--
-- TOC entry 3757 (class 2606 OID 16650)
-- Name: subject subject_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_pkey PRIMARY KEY (id);


--
-- TOC entry 3727 (class 2606 OID 16407)
-- Name: superuser superuser_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.superuser
    ADD CONSTRAINT superuser_pkey PRIMARY KEY (id);


--
-- TOC entry 3733 (class 2606 OID 16442)
-- Name: university university_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.university
    ADD CONSTRAINT university_pkey PRIMARY KEY (id);


--
-- TOC entry 3829 (class 2606 OID 17066)
-- Name: universityactivity universityactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityactivity
    ADD CONSTRAINT universityactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3831 (class 2606 OID 17081)
-- Name: universitycomment universitycomment_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_pkey PRIMARY KEY (id);


--
-- TOC entry 3851 (class 2606 OID 18542)
-- Name: universitycourseactivity universitycourseactivity_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitycourseactivity
    ADD CONSTRAINT universitycourseactivity_pkey PRIMARY KEY (id);


--
-- TOC entry 3833 (class 2606 OID 17101)
-- Name: universityfaq universityfaq_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityfaq
    ADD CONSTRAINT universityfaq_pkey PRIMARY KEY (id);


--
-- TOC entry 3835 (class 2606 OID 17116)
-- Name: universitylisteningbenefit universitylisteningbenefit_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitylisteningbenefit
    ADD CONSTRAINT universitylisteningbenefit_pkey PRIMARY KEY (id);


--
-- TOC entry 3837 (class 2606 OID 17126)
-- Name: universitylisteningstep universitylisteningstep_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitylisteningstep
    ADD CONSTRAINT universitylisteningstep_pkey PRIMARY KEY (id);


--
-- TOC entry 3839 (class 2606 OID 17136)
-- Name: universityreview universityreview_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_pkey PRIMARY KEY (id);


--
-- TOC entry 3841 (class 2606 OID 17156)
-- Name: universitytype universitytype_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitytype
    ADD CONSTRAINT universitytype_pkey PRIMARY KEY (id);


--
-- TOC entry 3863 (class 2606 OID 18645)
-- Name: userlogs userlogs_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.userlogs
    ADD CONSTRAINT userlogs_pkey PRIMARY KEY (id);


--
-- TOC entry 3749 (class 2606 OID 16551)
-- Name: users users_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_pkey PRIMARY KEY (id);


--
-- TOC entry 3725 (class 2606 OID 16396)
-- Name: uu uu_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.uu
    ADD CONSTRAINT uu_pkey PRIMARY KEY (id);


--
-- TOC entry 3843 (class 2606 OID 17166)
-- Name: zone zone_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.zone
    ADD CONSTRAINT zone_pkey PRIMARY KEY (id);


--
-- TOC entry 3866 (class 2606 OID 16487)
-- Name: acdemicspecialization acdemicspecialization_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3867 (class 2606 OID 16492)
-- Name: acdemicspecialization acdemicspecialization_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.acdemicspecialization
    ADD CONSTRAINT acdemicspecialization_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3869 (class 2606 OID 16566)
-- Name: blogcomment blogcomment_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3870 (class 2606 OID 16571)
-- Name: blogcomment blogcomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogcomment
    ADD CONSTRAINT blogcomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3892 (class 2606 OID 18374)
-- Name: blogfaqs blogfaq_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogfaqs
    ADD CONSTRAINT blogfaq_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3871 (class 2606 OID 16587)
-- Name: blogreview blogreview_blogid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_blogid_fkey FOREIGN KEY (blogid) REFERENCES public.blog(id);


--
-- TOC entry 3872 (class 2606 OID 16592)
-- Name: blogreview blogreview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.blogreview
    ADD CONSTRAINT blogreview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3877 (class 2606 OID 16670)
-- Name: book book_specialization_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_specialization_fkey FOREIGN KEY (specialization) REFERENCES public.specialization(id);


--
-- TOC entry 3878 (class 2606 OID 16675)
-- Name: book book_subject_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.book
    ADD CONSTRAINT book_subject_fkey FOREIGN KEY (subject) REFERENCES public.subject(id);


--
-- TOC entry 3879 (class 2606 OID 16741)
-- Name: coursecomment coursecomment_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3880 (class 2606 OID 16746)
-- Name: coursecomment coursecomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursecomment
    ADD CONSTRAINT coursecomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3881 (class 2606 OID 16771)
-- Name: coursefaq coursefaq_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursefaq
    ADD CONSTRAINT coursefaq_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3882 (class 2606 OID 16796)
-- Name: coursereview coursereview_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3883 (class 2606 OID 16801)
-- Name: coursereview coursereview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.coursereview
    ADD CONSTRAINT coursereview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3884 (class 2606 OID 16946)
-- Name: lead lead_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 3885 (class 2606 OID 16951)
-- Name: lead lead_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.lead
    ADD CONSTRAINT lead_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3873 (class 2606 OID 16617)
-- Name: specialization specialization_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.specialization
    ADD CONSTRAINT specialization_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.individualcourse(id);


--
-- TOC entry 3874 (class 2606 OID 16622)
-- Name: specialization specialization_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.specialization
    ADD CONSTRAINT specialization_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3875 (class 2606 OID 16651)
-- Name: subject subject_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_courseid_fkey FOREIGN KEY (course) REFERENCES public.individualcourse(id);


--
-- TOC entry 3876 (class 2606 OID 16656)
-- Name: subject subject_specialization_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.subject
    ADD CONSTRAINT subject_specialization_fkey FOREIGN KEY (specialization) REFERENCES public.specialization(id);


--
-- TOC entry 3886 (class 2606 OID 17067)
-- Name: universityactivity universityactivity_superuserid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityactivity
    ADD CONSTRAINT universityactivity_superuserid_fkey FOREIGN KEY (superuserid) REFERENCES public.superuser(id);


--
-- TOC entry 3887 (class 2606 OID 17082)
-- Name: universitycomment universitycomment_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3888 (class 2606 OID 17087)
-- Name: universitycomment universitycomment_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universitycomment
    ADD CONSTRAINT universitycomment_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3889 (class 2606 OID 17102)
-- Name: universityfaq universityfaq_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityfaq
    ADD CONSTRAINT universityfaq_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3890 (class 2606 OID 17137)
-- Name: universityreview universityreview_universityid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_universityid_fkey FOREIGN KEY (universityid) REFERENCES public.university(id);


--
-- TOC entry 3891 (class 2606 OID 17142)
-- Name: universityreview universityreview_userid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.universityreview
    ADD CONSTRAINT universityreview_userid_fkey FOREIGN KEY (userid) REFERENCES public.users(id);


--
-- TOC entry 3868 (class 2606 OID 16552)
-- Name: users users_courseid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: postgres
--

ALTER TABLE ONLY public.users
    ADD CONSTRAINT users_courseid_fkey FOREIGN KEY (courseid) REFERENCES public.course(id);


--
-- TOC entry 4188 (class 0 OID 0)
-- Dependencies: 232
-- Name: TABLE aboutpage; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.aboutpage TO PUBLIC;
GRANT ALL ON TABLE public.aboutpage TO imtsac_ibrahimmemon;


--
-- TOC entry 4190 (class 0 OID 0)
-- Dependencies: 231
-- Name: SEQUENCE aboutpage_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.aboutpage_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4191 (class 0 OID 0)
-- Dependencies: 234
-- Name: SEQUENCE acdemicspecialization_id; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.acdemicspecialization_id TO imtsac_ibrahimmemon;


--
-- TOC entry 4192 (class 0 OID 0)
-- Dependencies: 235
-- Name: TABLE acdemicspecialization; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.acdemicspecialization TO imtsac_ibrahimmemon;


--
-- TOC entry 4193 (class 0 OID 0)
-- Dependencies: 220
-- Name: SEQUENCE alumni_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.alumni_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4194 (class 0 OID 0)
-- Dependencies: 221
-- Name: TABLE alumni; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.alumni TO imtsac_ibrahimmemon;


--
-- TOC entry 4195 (class 0 OID 0)
-- Dependencies: 236
-- Name: SEQUENCE approved_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.approved_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4196 (class 0 OID 0)
-- Dependencies: 237
-- Name: TABLE approved; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.approved TO imtsac_ibrahimmemon;


--
-- TOC entry 4197 (class 0 OID 0)
-- Dependencies: 238
-- Name: SEQUENCE backup_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.backup_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4198 (class 0 OID 0)
-- Dependencies: 239
-- Name: TABLE backup; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.backup TO imtsac_ibrahimmemon;


--
-- TOC entry 4199 (class 0 OID 0)
-- Dependencies: 241
-- Name: TABLE banner; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.banner TO imtsac_ibrahimmemon;


--
-- TOC entry 4200 (class 0 OID 0)
-- Dependencies: 222
-- Name: SEQUENCE blog_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.blog_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4201 (class 0 OID 0)
-- Dependencies: 223
-- Name: TABLE blog; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.blog TO imtsac_ibrahimmemon;


--
-- TOC entry 4202 (class 0 OID 0)
-- Dependencies: 242
-- Name: SEQUENCE blogcomment_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.blogcomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4203 (class 0 OID 0)
-- Dependencies: 245
-- Name: TABLE blogcomment; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.blogcomment TO imtsac_ibrahimmemon;


--
-- TOC entry 4204 (class 0 OID 0)
-- Dependencies: 224
-- Name: SEQUENCE blogfaq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.blogfaq TO imtsac_ibrahimmemon;


--
-- TOC entry 4205 (class 0 OID 0)
-- Dependencies: 246
-- Name: SEQUENCE blogfaq_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.blogfaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4206 (class 0 OID 0)
-- Dependencies: 247
-- Name: SEQUENCE blogreview_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.blogreview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4207 (class 0 OID 0)
-- Dependencies: 248
-- Name: TABLE blogreview; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.blogreview TO imtsac_ibrahimmemon;


--
-- TOC entry 4208 (class 0 OID 0)
-- Dependencies: 249
-- Name: SEQUENCE book_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.book_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4209 (class 0 OID 0)
-- Dependencies: 254
-- Name: TABLE book; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.book TO imtsac_ibrahimmemon;


--
-- TOC entry 4210 (class 0 OID 0)
-- Dependencies: 255
-- Name: SEQUENCE city_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.city_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4211 (class 0 OID 0)
-- Dependencies: 256
-- Name: TABLE city; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.city TO imtsac_ibrahimmemon;


--
-- TOC entry 4212 (class 0 OID 0)
-- Dependencies: 257
-- Name: SEQUENCE collegetype_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.collegetype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4213 (class 0 OID 0)
-- Dependencies: 258
-- Name: TABLE collegetype; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.collegetype TO imtsac_ibrahimmemon;


--
-- TOC entry 4214 (class 0 OID 0)
-- Dependencies: 260
-- Name: TABLE contactus; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.contactus TO imtsac_ibrahimmemon;


--
-- TOC entry 4216 (class 0 OID 0)
-- Dependencies: 259
-- Name: SEQUENCE contactus_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.contactus_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4217 (class 0 OID 0)
-- Dependencies: 261
-- Name: SEQUENCE country_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.country_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4218 (class 0 OID 0)
-- Dependencies: 262
-- Name: TABLE country; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.country TO imtsac_ibrahimmemon;


--
-- TOC entry 4219 (class 0 OID 0)
-- Dependencies: 227
-- Name: SEQUENCE course_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.course_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4220 (class 0 OID 0)
-- Dependencies: 228
-- Name: TABLE course; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.course TO imtsac_ibrahimmemon;


--
-- TOC entry 4221 (class 0 OID 0)
-- Dependencies: 263
-- Name: SEQUENCE courseactivity_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.courseactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4222 (class 0 OID 0)
-- Dependencies: 264
-- Name: TABLE courseactivity; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.courseactivity TO imtsac_ibrahimmemon;


--
-- TOC entry 4223 (class 0 OID 0)
-- Dependencies: 265
-- Name: SEQUENCE coursecomment_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.coursecomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4224 (class 0 OID 0)
-- Dependencies: 266
-- Name: TABLE coursecomment; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.coursecomment TO imtsac_ibrahimmemon;


--
-- TOC entry 4225 (class 0 OID 0)
-- Dependencies: 267
-- Name: SEQUENCE courseduration_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.courseduration_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4226 (class 0 OID 0)
-- Dependencies: 268
-- Name: TABLE courseduration; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.courseduration TO imtsac_ibrahimmemon;


--
-- TOC entry 4227 (class 0 OID 0)
-- Dependencies: 269
-- Name: SEQUENCE coursefaq_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.coursefaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4228 (class 0 OID 0)
-- Dependencies: 270
-- Name: TABLE coursefaq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.coursefaq TO imtsac_ibrahimmemon;


--
-- TOC entry 4229 (class 0 OID 0)
-- Dependencies: 271
-- Name: SEQUENCE coursemode_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.coursemode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4230 (class 0 OID 0)
-- Dependencies: 272
-- Name: TABLE coursemode; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.coursemode TO imtsac_ibrahimmemon;


--
-- TOC entry 4231 (class 0 OID 0)
-- Dependencies: 273
-- Name: SEQUENCE coursereview_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.coursereview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4232 (class 0 OID 0)
-- Dependencies: 274
-- Name: TABLE coursereview; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.coursereview TO imtsac_ibrahimmemon;


--
-- TOC entry 4233 (class 0 OID 0)
-- Dependencies: 275
-- Name: SEQUENCE coursetype_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.coursetype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4234 (class 0 OID 0)
-- Dependencies: 276
-- Name: TABLE coursetype; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.coursetype TO imtsac_ibrahimmemon;


--
-- TOC entry 4235 (class 0 OID 0)
-- Dependencies: 277
-- Name: SEQUENCE cta_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.cta_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4236 (class 0 OID 0)
-- Dependencies: 278
-- Name: TABLE cta; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.cta TO imtsac_ibrahimmemon;


--
-- TOC entry 4237 (class 0 OID 0)
-- Dependencies: 280
-- Name: TABLE designation; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.designation TO imtsac_ibrahimmemon;


--
-- TOC entry 4239 (class 0 OID 0)
-- Dependencies: 279
-- Name: SEQUENCE designation_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.designation_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4240 (class 0 OID 0)
-- Dependencies: 282
-- Name: TABLE expertpage; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.expertpage TO PUBLIC;
GRANT ALL ON TABLE public.expertpage TO imtsac_ibrahimmemon;


--
-- TOC entry 4242 (class 0 OID 0)
-- Dependencies: 281
-- Name: SEQUENCE expertpage_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.expertpage_id_seq TO PUBLIC;
GRANT ALL ON SEQUENCE public.expertpage_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4243 (class 0 OID 0)
-- Dependencies: 283
-- Name: SEQUENCE faq_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.faq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4244 (class 0 OID 0)
-- Dependencies: 284
-- Name: TABLE faq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.faq TO imtsac_ibrahimmemon;


--
-- TOC entry 4245 (class 0 OID 0)
-- Dependencies: 285
-- Name: SEQUENCE footer_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.footer_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4246 (class 0 OID 0)
-- Dependencies: 286
-- Name: TABLE footer; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.footer TO imtsac_ibrahimmemon;


--
-- TOC entry 4247 (class 0 OID 0)
-- Dependencies: 287
-- Name: SEQUENCE header_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.header_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4248 (class 0 OID 0)
-- Dependencies: 288
-- Name: TABLE header; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.header TO imtsac_ibrahimmemon;


--
-- TOC entry 4249 (class 0 OID 0)
-- Dependencies: 229
-- Name: SEQUENCE individualcourse_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.individualcourse_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4250 (class 0 OID 0)
-- Dependencies: 230
-- Name: TABLE individualcourse; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.individualcourse TO imtsac_ibrahimmemon;


--
-- TOC entry 4251 (class 0 OID 0)
-- Dependencies: 289
-- Name: SEQUENCE individualcoursefaq_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.individualcoursefaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4252 (class 0 OID 0)
-- Dependencies: 290
-- Name: TABLE individualcoursefaq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.individualcoursefaq TO imtsac_ibrahimmemon;


--
-- TOC entry 4253 (class 0 OID 0)
-- Dependencies: 291
-- Name: SEQUENCE job_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.job_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4254 (class 0 OID 0)
-- Dependencies: 292
-- Name: TABLE job; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.job TO imtsac_ibrahimmemon;


--
-- TOC entry 4255 (class 0 OID 0)
-- Dependencies: 293
-- Name: SEQUENCE jobmode_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.jobmode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4256 (class 0 OID 0)
-- Dependencies: 294
-- Name: TABLE jobmode; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.jobmode TO imtsac_ibrahimmemon;


--
-- TOC entry 4257 (class 0 OID 0)
-- Dependencies: 295
-- Name: SEQUENCE jobreference_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.jobreference_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4258 (class 0 OID 0)
-- Dependencies: 296
-- Name: TABLE jobreference; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.jobreference TO imtsac_ibrahimmemon;


--
-- TOC entry 4259 (class 0 OID 0)
-- Dependencies: 297
-- Name: SEQUENCE jobresponse_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.jobresponse_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4260 (class 0 OID 0)
-- Dependencies: 298
-- Name: TABLE jobresponse; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.jobresponse TO imtsac_ibrahimmemon;


--
-- TOC entry 4261 (class 0 OID 0)
-- Dependencies: 299
-- Name: SEQUENCE jobtype_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.jobtype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4262 (class 0 OID 0)
-- Dependencies: 300
-- Name: TABLE jobtype; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.jobtype TO imtsac_ibrahimmemon;


--
-- TOC entry 4263 (class 0 OID 0)
-- Dependencies: 301
-- Name: SEQUENCE lead_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.lead_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4264 (class 0 OID 0)
-- Dependencies: 302
-- Name: TABLE lead; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.lead TO imtsac_ibrahimmemon;


--
-- TOC entry 4266 (class 0 OID 0)
-- Dependencies: 303
-- Name: SEQUENCE media_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.media_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4267 (class 0 OID 0)
-- Dependencies: 304
-- Name: TABLE media; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.media TO imtsac_ibrahimmemon;


--
-- TOC entry 4268 (class 0 OID 0)
-- Dependencies: 305
-- Name: SEQUENCE moreresource_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.moreresource_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4269 (class 0 OID 0)
-- Dependencies: 306
-- Name: TABLE moreresource; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.moreresource TO imtsac_ibrahimmemon;


--
-- TOC entry 4270 (class 0 OID 0)
-- Dependencies: 307
-- Name: SEQUENCE news_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.news_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4271 (class 0 OID 0)
-- Dependencies: 308
-- Name: TABLE news; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.news TO imtsac_ibrahimmemon;


--
-- TOC entry 4272 (class 0 OID 0)
-- Dependencies: 309
-- Name: SEQUENCE onestep_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.onestep_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4273 (class 0 OID 0)
-- Dependencies: 310
-- Name: TABLE onestep; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.onestep TO imtsac_ibrahimmemon;


--
-- TOC entry 4274 (class 0 OID 0)
-- Dependencies: 225
-- Name: SEQUENCE university_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.university_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4275 (class 0 OID 0)
-- Dependencies: 250
-- Name: SEQUENCE specialization_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.specialization_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4276 (class 0 OID 0)
-- Dependencies: 251
-- Name: TABLE specialization; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.specialization TO imtsac_ibrahimmemon;


--
-- TOC entry 4277 (class 0 OID 0)
-- Dependencies: 313
-- Name: SEQUENCE specializationactivity_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.specializationactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4278 (class 0 OID 0)
-- Dependencies: 314
-- Name: TABLE specializationactivity; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.specializationactivity TO imtsac_ibrahimmemon;


--
-- TOC entry 4279 (class 0 OID 0)
-- Dependencies: 315
-- Name: SEQUENCE staff_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.staff_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4280 (class 0 OID 0)
-- Dependencies: 316
-- Name: TABLE staff; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.staff TO imtsac_ibrahimmemon;


--
-- TOC entry 4281 (class 0 OID 0)
-- Dependencies: 317
-- Name: SEQUENCE state_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.state_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4282 (class 0 OID 0)
-- Dependencies: 318
-- Name: TABLE state; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.state TO imtsac_ibrahimmemon;


--
-- TOC entry 4283 (class 0 OID 0)
-- Dependencies: 319
-- Name: SEQUENCE stream_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.stream_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4284 (class 0 OID 0)
-- Dependencies: 320
-- Name: TABLE stream; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.stream TO imtsac_ibrahimmemon;


--
-- TOC entry 4285 (class 0 OID 0)
-- Dependencies: 321
-- Name: SEQUENCE studymode_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.studymode_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4286 (class 0 OID 0)
-- Dependencies: 322
-- Name: TABLE studymode; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.studymode TO imtsac_ibrahimmemon;


--
-- TOC entry 4287 (class 0 OID 0)
-- Dependencies: 252
-- Name: SEQUENCE subject_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.subject_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4288 (class 0 OID 0)
-- Dependencies: 253
-- Name: TABLE subject; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.subject TO imtsac_ibrahimmemon;


--
-- TOC entry 4289 (class 0 OID 0)
-- Dependencies: 218
-- Name: SEQUENCE superuser_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.superuser_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4290 (class 0 OID 0)
-- Dependencies: 219
-- Name: TABLE superuser; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.superuser TO imtsac_ibrahimmemon;


--
-- TOC entry 4291 (class 0 OID 0)
-- Dependencies: 226
-- Name: TABLE university; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.university TO imtsac_ibrahimmemon;


--
-- TOC entry 4292 (class 0 OID 0)
-- Dependencies: 323
-- Name: SEQUENCE universityactivity_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universityactivity_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4293 (class 0 OID 0)
-- Dependencies: 324
-- Name: TABLE universityactivity; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universityactivity TO imtsac_ibrahimmemon;


--
-- TOC entry 4294 (class 0 OID 0)
-- Dependencies: 325
-- Name: SEQUENCE universitycomment_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universitycomment_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4295 (class 0 OID 0)
-- Dependencies: 326
-- Name: TABLE universitycomment; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universitycomment TO imtsac_ibrahimmemon;


--
-- TOC entry 4296 (class 0 OID 0)
-- Dependencies: 327
-- Name: SEQUENCE universityfaq_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universityfaq_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4297 (class 0 OID 0)
-- Dependencies: 328
-- Name: TABLE universityfaq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universityfaq TO imtsac_ibrahimmemon;


--
-- TOC entry 4298 (class 0 OID 0)
-- Dependencies: 330
-- Name: TABLE universitylisteningbenefit; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universitylisteningbenefit TO imtsac_ibrahimmemon;


--
-- TOC entry 4299 (class 0 OID 0)
-- Dependencies: 332
-- Name: TABLE universitylisteningstep; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universitylisteningstep TO PUBLIC;
GRANT ALL ON TABLE public.universitylisteningstep TO imtsac_ibrahimmemon;


--
-- TOC entry 4301 (class 0 OID 0)
-- Dependencies: 331
-- Name: SEQUENCE universitylisteningstep_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universitylisteningstep_id_seq TO PUBLIC;
GRANT ALL ON SEQUENCE public.universitylisteningstep_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4302 (class 0 OID 0)
-- Dependencies: 333
-- Name: SEQUENCE universityreview_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universityreview_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4303 (class 0 OID 0)
-- Dependencies: 334
-- Name: TABLE universityreview; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universityreview TO imtsac_ibrahimmemon;


--
-- TOC entry 4304 (class 0 OID 0)
-- Dependencies: 335
-- Name: SEQUENCE universitytype_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.universitytype_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4305 (class 0 OID 0)
-- Dependencies: 336
-- Name: TABLE universitytype; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.universitytype TO imtsac_ibrahimmemon;


--
-- TOC entry 4307 (class 0 OID 0)
-- Dependencies: 243
-- Name: SEQUENCE users_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.users_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4308 (class 0 OID 0)
-- Dependencies: 244
-- Name: TABLE users; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.users TO imtsac_ibrahimmemon;


--
-- TOC entry 4310 (class 0 OID 0)
-- Dependencies: 337
-- Name: SEQUENCE zone_id_seq; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON SEQUENCE public.zone_id_seq TO imtsac_ibrahimmemon;


--
-- TOC entry 4311 (class 0 OID 0)
-- Dependencies: 338
-- Name: TABLE zone; Type: ACL; Schema: public; Owner: postgres
--

GRANT ALL ON TABLE public.zone TO imtsac_ibrahimmemon;


-- Completed on 2024-10-14 00:00:09 UTC

--
-- PostgreSQL database dump complete
--

